# Graphs.jl

[![Documentation stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliagraphs.org/Graphs.jl/stable/)
[![Documentation dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://juliagraphs.org/Graphs.jl/dev/)
[![Build status](https://github.com/JuliaGraphs/Graphs.jl/actions/workflows/ci.yml/badge.svg?branch=master)](https://github.com/JuliaGraphs/Graphs.jl/actions/workflows/ci.yml?query=branch%3Amaster)
[![Code coverage](https://codecov.io/github/JuliaGraphs/Graphs.jl/coverage.svg?branch=master)](https://codecov.io/github/JuliaGraphs/Graphs.jl?branch=master)
[![Code style: Blue](https://img.shields.io/badge/code%20style-blue-4495d1.svg)](https://github.com/invenia/BlueStyle)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

## Overview

The goal of _Graphs.jl_ is to offer a performant platform for network and graph analysis in Julia, following the example of libraries such as [NetworkX](http://networkx.github.io) in Python. To this end, _Graphs.jl_ offers:

- a set of simple, concrete graph implementations -- `SimpleGraph` (for undirected graphs) and `SimpleDiGraph` (for directed graphs)
- an API for the development of more sophisticated graph implementations under the `AbstractGraph` type
- a large collection of graph algorithms with the same requirements as this API.

## Installation

Installation is straightforward. First, enter Pkg mode by hitting `]`, and then run the following command:

```julia-repl
pkg> add Graphs
```

## Basic use

_Graphs.jl_ includes numerous convenience functions for generating graphs, such as `path_graph`, which builds a simple undirected [path graph](https://en.wikipedia.org/wiki/Path_graph) of a given length. Once created, these graphs can be easily interrogated and modified.

```julia-repl
julia> g = path_graph(6)
{6, 5} undirected simple Int64 graph

# Number of vertices
julia> nv(g)
6

# Number of edges
julia> ne(g)
5

# Add an edge to make the path a loop
julia> add_edge!(g, 1, 6);
```

## Documentation

The full documentation is available at [GitHub Pages](https://juliagraphs.org/Graphs.jl/dev/). Documentation for methods is also available via the Julia REPL help system.
Additional tutorials can be found at [JuliaGraphsTutorials](https://github.com/JuliaGraphs/JuliaGraphsTutorials).

## Citing

We encourage you to cite our work if you have used our libraries, tools or datasets. Starring the _Graphs.jl_ repository on GitHub is also appreciated.

The latest citation information may be found in the [CITATION.bib](https://raw.githubusercontent.com/JuliaGraphs/Graphs.jl/master/CITATION.bib) file within the repository.

## Contributing

We welcome contributions and bug reports!
Please see [CONTRIBUTING.md](https://github.com/JuliaGraphs/Graphs.jl/blob/master/CONTRIBUTING.md) for guidance on development and bug reporting.

JuliaGraphs development subscribes to the [Julia Community Standards](https://julialang.org/community/standards/).

## Related packages

It is an explicit design decision that any data not required for graph manipulation (attributes and other information, for example) is expected to be stored outside of the graph structure itself.

Additional functionality like advanced IO and file formats, weighted graphs, property graphs, and optimization-related functions can be found in the packages of the [JuliaGraphs organization](https://juliagraphs.org/).

## Project history

_Graphs.jl_ is the successor to _LightGraphs.jl_ (archived October 2021); see the [CHANGELOG](CHANGELOG.md) for the full transition history.

# Parts of this code were taken / derived from Graphs.jl. See LICENSE for
# licensing details.

#################################################
#
#  Minimum Cut
#
#################################################

"""
    mincut(g, distmx=weights(g))

Return a tuple `(parity, bestcut)`, where `parity` is a vector of integer
values that determines the partition in `g` (1 or 2) and `bestcut` is the
weight of the cut that makes this partition. An optional `distmx` matrix
of non-negative weights may be specified; if omitted, edge distances are
assumed to be 1.
"""
@traitfn function mincut(
    g::::(!IsDirected), distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number}
    nvg = nv(g)
    U = eltype(g)

    # make sure we have at least two vertices, otherwise, there's nothing to cut,
    # in which case we'll return immediately.
    (nvg > one(U)) || return (Vector{Int8}([1]), zero(T))

    # to avoid reallocating lists in fadjlist, we have some already merged vertices
    # still appearing in fadjlist. When iterating neighbors, is_merged makes sure we
    # don't consider them
    is_merged = falses(nvg)
    merged_vertices = IntDisjointSets(U(nvg))
    graph_size = nvg
    # We need to mutate the weight matrix,
    # and we need it clean (0 for non edges)
    w = zeros(T, nvg, nvg)
    size(distmx) != (nvg, nvg) && throw(
        ArgumentError(
            "Adjacency / distance matrix size should match the number of vertices"
        ),
    )
    @inbounds for e in edges(g)
        d = distmx[src(e), dst(e)]
        (d < 0) && throw(DomainError(w, "weigths should be non-negative"))
        w[src(e), dst(e)] = d
        (d != distmx[dst(e), src(e)]) &&
            throw(ArgumentError("Adjacency / distance matrix must be symmetric"))
        w[dst(e), src(e)] = d
    end
    # we also need to mutate neighbors when merging vertices
    fadjlist = [collect(outneighbors(g, v)) for v in vertices(g)]
    parities = falses(nvg)
    bestweight = typemax(T)
    pq = PriorityQueue{U,T}(Base.Order.Reverse)
    u = last_vertex = one(U)

    is_processed = falses(nvg)
    @inbounds while graph_size > 1
        is_processed .= false
        is_processed[u] = true
        # initialize pq
        for v in vertices(g)
            is_merged[v] && continue
            v == u && continue
            pq[v] = zero(T)
        end
        for v in fadjlist[u]
            (is_merged[v] || v == u) && continue
            pq[v] = w[u, v]
        end
        # Minimum cut phase
        local cutweight
        while true
            last_vertex = u
            u, cutweight = dequeue_pair!(pq)
            isempty(pq) && break
            for v in fadjlist[u]
                (is_processed[v] || is_merged[v] || u == v) && continue
                pq[v] += w[u, v]
            end
            is_processed[u] = true
            # cutweight is a lower bound on the cut separating the two last vertices
            # encountered, so if cutweight >= bestweight, we can already merge these
            # vertices to save one phase.
            if cutweight >= bestweight
                u = _merge_vertex!(merged_vertices, fadjlist, is_merged, w, u, last_vertex)
                graph_size -= 1
            end
        end

        # check if we improved the mincut
        if cutweight < bestweight
            bestweight = cutweight
            for v in vertices(g)
                parities[v] = (find_root!(merged_vertices, v) == u)
            end
        end

        # merge u and last_vertex
        u = _merge_vertex!(merged_vertices, fadjlist, is_merged, w, u, last_vertex)
        graph_size -= 1
    end
    return (convert(Vector{Int8}, parities) .+ one(Int8), bestweight)
end

function _merge_vertex!(merged_vertices, fadjlist, is_merged, w, u, v)
    # root is kept, non-root is discarded
    root = union!(merged_vertices, u, v)
    non_root = (root == u) ? v : u
    is_merged[non_root] = true
    # update weights
    for v2 in fadjlist[non_root]
        w[root, v2] += w[non_root, v2]
        w[v2, root] = w[root, v2]
    end
    # update neighbors
    union!(fadjlist[root], fadjlist[non_root])
    for v in fadjlist[non_root]
        if root ∉ fadjlist[v]
            push!(fadjlist[v], root)
        end
    end
    return root
end

"""
    maximum_adjacency_visit(g[, distmx][, log][, io][, s])
    maximum_adjacency_visit(g[, s])

Return the vertices in `g` traversed by maximum adjacency search, optionally
starting from vertex `s` (default `1`). An optional `distmx` matrix may be
specified; if omitted, edge distances are assumed to be 1. If `log` (default
`false`) is `true`, visitor events will be printed to `io`, which defaults to
`STDOUT`; otherwise, no event information will be displayed.
"""
function maximum_adjacency_visit(
    g::AbstractGraph{U},
    distmx::AbstractMatrix{T},
    log::Bool=false,
    io::IO=stdout,
    s::U=one(U),
) where {U,T<:Number}
    pq = PriorityQueue{U,T}(Base.Order.Reverse)
    vertices_order = Vector{U}()
    has_key = ones(Bool, nv(g))
    sizehint!(vertices_order, nv(g))
    # if the graph only has one vertex, we return the vertex by itself.
    nv(g) > one(U) || return collect(vertices(g))

    # Setting intial count to 0
    for v in vertices(g)
        pq[v] = zero(T)
    end

    # Give start vertex maximum priority
    pq[s] = one(T)

    # start traversing the graph
    while !isempty(pq)
        u = dequeue!(pq)
        has_key[u] = false
        push!(vertices_order, u)
        log && println(io, "discover vertex: $u")
        for v in outneighbors(g, u)
            log && println(io, " -- examine neighbor from $u to $v")
            if has_key[v] && (u != v)
                ed = distmx[u, v]
                pq[v] += ed
            end
        end
        log && println(io, "close vertex: $u")
    end
    return vertices_order
end

function maximum_adjacency_visit(g::AbstractGraph{U}, s::U=one(U)) where {U}
    return maximum_adjacency_visit(g, weights(g), false, stdout, s)
end

"""
    Biconnections

A state type for depth-first search that finds the biconnected components.
"""
mutable struct Biconnections{E<:AbstractEdge}
    low::Vector{Int}
    depth::Vector{Int}
    stack::Vector{E}
    biconnected_comps::Vector{Vector{E}}
    id::Int
end

# TODO it might be more reasonable to return the components a s collections of vertices
# instead of edges.
@traitfn function Biconnections(g::::(!IsDirected))
    n = nv(g)
    E = Edge{eltype(g)}
    return Biconnections(zeros(Int, n), zeros(Int, n), Vector{E}(), Vector{Vector{E}}(), 0)
end

"""
    visit!(g, state, u, v)

Perform a DFS visit storing the depth and low-points of each vertex.
"""
function visit!(g::AbstractGraph, state::Biconnections{E}, u::Integer, v::Integer) where {E}
    # E === Edge{eltype(g)}

    children = 0
    state.id += 1
    state.depth[v] = state.id
    state.low[v] = state.depth[v]

    for w in outneighbors(g, v)
        if state.depth[w] == 0
            children += 1
            push!(state.stack, E(min(v, w), max(v, w)))
            visit!(g, state, v, w)
            state.low[v] = min(state.low[v], state.low[w])

            # Checking the root, and then the non-roots if they are articulation points
            if (u == v && children > 1) || (u != v && state.low[w] >= state.depth[v])
                e = E(0, 0) # Invalid Edge, used for comparison only
                st = Vector{E}()
                while e != E(min(v, w), max(v, w))
                    e = pop!(state.stack)
                    push!(st, e)
                end
                push!(state.biconnected_comps, st)
            end

        elseif w != u
            if state.depth[v] > state.depth[w]
                push!(state.stack, E(min(v, w), max(v, w)))
            end
            if state.low[v] > state.depth[w]
                state.low[v] = state.depth[w]
            end
        end
    end
end

"""
    biconnected_components(g) -> Vector{Vector{Edge{eltype(g)}}}

Compute the [biconnected components](https://en.wikipedia.org/wiki/Biconnected_component)
of an undirected graph `g`and return a vector of vectors containing each
biconnected component.

Performance:
Time complexity is ``\\mathcal{O}(|V|)``.

# Examples
```jldoctest
julia> using Graphs

julia> biconnected_components(star_graph(5))
4-element Vector{Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}}:
 [Edge 1 => 3]
 [Edge 1 => 4]
 [Edge 1 => 5]
 [Edge 1 => 2]

julia> biconnected_components(cycle_graph(5))
1-element Vector{Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}}:
 [Edge 1 => 5, Edge 4 => 5, Edge 3 => 4, Edge 2 => 3, Edge 1 => 2]
```
"""
function biconnected_components end
@traitfn function biconnected_components(g::::(!IsDirected))
    state = Biconnections(g)
    for u in vertices(g)
        if state.depth[u] == 0
            visit!(g, state, u, u)
        end

        if !isempty(state.stack)
            push!(state.biconnected_comps, reverse(state.stack))
            empty!(state.stack)
        end
    end
    return state.biconnected_comps
end

@testset "Parallel.BFS" begin
    @testset "Thread Queue" begin
        next = @inferred(Parallel.ThreadQueue(Int, 5)) # Initialize threadqueue
        @test isempty(next) == true
        push!(next, 1)
        @test next[1][] == 1
        @threads for i in 2:5
            push!(next, i)
        end
        @test Set([i[] for i in next[1:5]]) == Set([1, 2, 3, 4, 5])
        first = popfirst!(next)
        @test first == 1
    end

    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)
    g6 = smallgraph(:house)

    for g in testdigraphs(g5)
        T = eltype(g)
        z = @inferred(Parallel.bfs_tree(g, T(1)))
        next = Parallel.ThreadQueue(T, nv(g)) # Initialize threadqueue
        parents = [Atomic{T}(0) for i in 1:nv(g)] # Create parents array
        Parallel.bfs_tree!(next, g, T(1), parents)
        t = [i[] for i in parents]
        @test t == [T(1), T(1), T(1), T(3)]
        @test nv(z) == T(4) && ne(z) == T(3) && !has_edge(z, 2, 3)
    end

    function istree(parents::Vector{Atomic{T}}, maxdepth, n::T) where {T<:Integer}
        flag = true
        for i in one(T):n
            s = i
            depth = 0
            while parents[s][] > 0 && parents[s][] != s
                s = parents[s][]
                depth += 1
                if depth > maxdepth
                    return false
                end
            end
        end
        return flag
    end

    for g in testgraphs(g6)
        n = nv(g)
        T = eltype(g)
        next = Parallel.ThreadQueue(eltype(g), nv(g)) # Initialize threadqueue
        parents = [Atomic{T}(0) for i in 1:nv(g)] # Create parents array
        @test length(next.data) == n
        @inferred(Parallel.bfs_tree!(next, g, T(1), parents))
        @test istree(parents, n, n)
        p = [i[] for i in parents]
        t = Graphs.tree(p)
        @test is_directed(t)
        @test typeof(t) <: AbstractGraph
        @test ne(t) < nv(t)
    end
end

@testset "Stress" begin
    rng = StableRNG(1)
    gint = loadgraph(joinpath(testdir, "testdata", "graph-50-500.jgz"), "graph-50-500")

    c = vec(readdlm(joinpath(testdir, "testdata", "graph-50-500-sc.txt"), ','))
    for g in test_generic_graphs(gint)
        z = @inferred(stress_centrality(g))
        @test z == c

        x = @inferred(stress_centrality(g, 3, rng=rng))
        x2 = @inferred(stress_centrality(g, collect(1:20)))
        @test length(x) == 50
        @test length(x2) == 50
    end

    g1 = cycle_graph(4)
    add_vertex!(g1)
    add_edge!(g1, 4, 5)
    for g in test_generic_graphs(g1)
        z = @inferred(stress_centrality(g))
        @test z == [4, 2, 4, 10, 0]
    end
end

# used in shortest path calculations

function eccentricity(
    g::AbstractGraph,
    vs=vertices(g),
    distmx::AbstractMatrix{T}=weights(g);
    parallel::Symbol=:threads,
) where {T<:Number}
    return if parallel === :threads
        threaded_eccentricity(g, vs, distmx)
    elseif parallel === :distributed
        distr_eccentricity(g, vs, distmx)
    else
        throw(
            ArgumentError(
                "Unsupported parallel argument '$(repr(parallel))' (supported: ':threads' or ':distributed')",
            ),
        )
    end
end

function distr_eccentricity(args...; kwargs...)
    return error(
        "`parallel = :distributed` requested, but SharedArrays or Distributed is not loaded"
    )
end

function threaded_eccentricity(
    g::AbstractGraph, vs=vertices(g), distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number}
    vlen = length(vs)
    eccs = Vector{T}(undef, vlen)
    Base.Threads.@threads for i in 1:vlen
        d = Graphs.dijkstra_shortest_paths(g, vs[i], distmx)
        eccs[i] = maximum(d.dists)
    end
    maximum(eccs) == typemax(T) && @warn("Infinite path length detected")
    return eccs
end

function eccentricity(g::AbstractGraph, distmx::AbstractMatrix; parallel::Symbol=:threads)
    return eccentricity(g, vertices(g), distmx; parallel)
end

function diameter(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return maximum(eccentricity(g, distmx))
end

function periphery(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return Graphs.periphery(eccentricity(g, distmx))
end

function radius(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return minimum(eccentricity(g, distmx))
end

function center(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return Graphs.center(eccentricity(g, distmx))
end

@testset "Graph Views" begin
    @testset "ReverseView" begin
        gx = DiGraph([
            Edge(1, 1),
            Edge(1, 2),
            Edge(1, 4),
            Edge(2, 1),
            Edge(2, 2),
            Edge(2, 4),
            Edge(3, 1),
            Edge(4, 3),
        ])

        gr = erdos_renyi(20, 0.1; is_directed=true)

        for g in hcat(test_generic_graphs(gx), test_generic_graphs(gr))
            rg = ReverseView(g)
            allocated_rg = DiGraph(nv(g))
            for e in edges(g)
                add_edge!(allocated_rg, Edge(dst(e), src(e)))
            end

            @test wrapped_graph(rg) == g
            @test is_directed(rg) == true
            @test eltype(rg) == eltype(g)
            @test edgetype(rg) == edgetype(g)
            @test has_vertex(rg, 4) == has_vertex(g, 4)
            @test nv(rg) == nv(g) == nv(allocated_rg)
            @test ne(rg) == ne(g) == ne(allocated_rg)
            @test all(adjacency_matrix(rg) .== adjacency_matrix(allocated_rg))
            @test sort(collect(inneighbors(rg, 2))) ==
                sort(collect(inneighbors(allocated_rg, 2)))
            @test sort(collect(outneighbors(rg, 2))) ==
                sort(collect(outneighbors(allocated_rg, 2)))
            @test indegree(rg, 3) == indegree(allocated_rg, 3)
            @test degree(rg, 1) == degree(allocated_rg, 1)
            @test has_edge(rg, 1, 3) == has_edge(allocated_rg, 1, 3)
            @test has_edge(rg, 1, 4) == has_edge(allocated_rg, 1, 4)

            rg_res = @inferred(floyd_warshall_shortest_paths(rg))
            allocated_rg_res = floyd_warshall_shortest_paths(allocated_rg)
            @test rg_res.dists == allocated_rg_res.dists # parents may not be the same

            rg_res = @inferred(strongly_connected_components(rg))
            allocated_rg_res = strongly_connected_components(allocated_rg)
            @test length(rg_res) == length(allocated_rg_res)
            @test sort(length.(rg_res)) == sort(length.(allocated_rg_res))
        end

        @test_throws ArgumentError ReverseView(path_graph(5))
    end

    @testset "UndirectedView" begin
        gx = DiGraph([
            Edge(1, 1),
            Edge(1, 2),
            Edge(1, 4),
            Edge(2, 1),
            Edge(2, 2),
            Edge(2, 4),
            Edge(3, 1),
            Edge(4, 3),
        ])

        gr = erdos_renyi(20, 0.05; is_directed=true)

        for g in test_generic_graphs(gx)
            ug = UndirectedView(g)
            @test ne(ug) == 7 # one less edge since there was two edges in reverse directions
        end

        for g in hcat(test_generic_graphs(gx), test_generic_graphs(gr))
            ug = UndirectedView(g)
            allocated_ug = Graph(g)

            @test wrapped_graph(ug) == g
            @test is_directed(ug) == false
            @test eltype(ug) == eltype(g)
            @test edgetype(ug) == edgetype(g)
            @test has_vertex(ug, 4) == has_vertex(g, 4)
            @test nv(ug) == nv(g) == nv(allocated_ug)
            @test ne(ug) == ne(allocated_ug)
            @test all(adjacency_matrix(ug) .== adjacency_matrix(allocated_ug))
            @test sort(collect(inneighbors(ug, 2))) ==
                sort(collect(inneighbors(allocated_ug, 2)))
            @test sort(collect(outneighbors(ug, 2))) ==
                sort(collect(outneighbors(allocated_ug, 2)))
            @test indegree(ug, 3) == indegree(allocated_ug, 3)
            @test degree(ug, 1) == degree(allocated_ug, 1)
            @test has_edge(ug, 1, 3) == has_edge(allocated_ug, 1, 3)
            @test has_edge(ug, 1, 4) == has_edge(allocated_ug, 1, 4)

            ug_res = @inferred(floyd_warshall_shortest_paths(ug))
            allocated_ug_res = floyd_warshall_shortest_paths(allocated_ug)
            @test ug_res.dists == allocated_ug_res.dists # parents may not be the same

            ug_res = @inferred(biconnected_components(ug))
            allocated_ug_res = biconnected_components(allocated_ug)
            @test length(ug_res) == length(allocated_ug_res)
            @test sort(length.(ug_res)) == sort(length.(allocated_ug_res))
        end

        @test_throws ArgumentError UndirectedView(path_graph(5))
    end
end

# TODO this algorithm does not work with abitrary AbstractGraph yet,
# as it relies on rem_edge! and deepcopy

"""
    struct YenState{T, U}

Designed for yen k-shortest-paths calculations.

# Fields

- `dists::Vector{T}`: `dists[k]` is the length of the `k`-th shortest path from the source to the target
- `paths::Vector{Vector{U}}`: `paths[k]` is the description of the `k`-th shortest path (as a sequence of vertices) from the source to the target 
"""
struct YenState{T,U<:Integer} <: AbstractPathState
    dists::Vector{T}
    paths::Vector{Vector{U}}
end

"""
    yen_k_shortest_paths(g, source, target, distmx=weights(g), K=1; maxdist=typemax(T));

Perform [Yen's algorithm](http://en.wikipedia.org/wiki/Yen%27s_algorithm)
on a graph, computing k-shortest distances between `source` and `target` other vertices.
Return a [`YenState`](@ref) that contains distances and paths.
"""
function yen_k_shortest_paths(
    g::AbstractGraph,
    source::U,
    target::U,
    distmx::AbstractMatrix{T}=weights(g),
    K::Int=1;
    maxdist=typemax(T),
) where {T<:Number} where {U<:Integer}
    source == target && return YenState{T,U}([U(0)], [[source]])

    dj = dijkstra_shortest_paths(g, source, distmx; maxdist)
    path = enumerate_paths(dj)[target]
    isempty(path) && return YenState{T,U}(Vector{T}(), Vector{Vector{U}}())

    dists = Array{T,1}()
    push!(dists, dj.dists[target])
    A = [path]
    B = PriorityQueue()
    gcopy = deepcopy(g)

    for k in 1:(K - 1)
        for j in 1:length(A[k])
            # Spur node is retrieved from the previous k-shortest path, k − 1
            spurnode = A[k][j]
            #  The sequence of nodes from the source to the spur node of the previous k-shortest path
            rootpath = A[k][1:j]

            # Store the removed edges
            edgesremoved = Array{Tuple{Int,Int},1}()
            # Remove the links of the previous shortest paths which share the same root path
            for ppath in A
                if length(ppath) > j && rootpath == ppath[1:j]
                    u = ppath[j]
                    v = ppath[j + 1]
                    if has_edge(gcopy, u, v)
                        rem_edge!(gcopy, u, v)
                        push!(edgesremoved, (u, v))
                    end
                end
            end

            # Remove node of root path and calculate dist of it
            distrootpath = zero(T)
            for n in 1:(length(rootpath) - 1)
                u = rootpath[n]
                nei = copy(neighbors(gcopy, u))
                for v in nei
                    rem_edge!(gcopy, u, v)
                    push!(edgesremoved, (u, v))
                end

                # Evaluate distance of root path
                v = rootpath[n + 1]
                distrootpath += distmx[u, v]
            end

            # Calculate the spur path from the spur node to the sink
            djspur = dijkstra_shortest_paths(gcopy, spurnode, distmx)
            spurpath = enumerate_paths(djspur)[target]
            if !isempty(spurpath)
                # Entire path is made up of the root path and spur path
                pathtotal = [rootpath[1:(end - 1)]; spurpath]
                distpath = distrootpath + djspur.dists[target]
                # Add the potential k-shortest path to the heap
                if !haskey(B, pathtotal)
                    enqueue!(B, pathtotal, distpath)
                end
            end

            for (u, v) in edgesremoved
                add_edge!(gcopy, u, v)
            end
        end

        # No more paths in B
        isempty(B) && break
        mindistB = peek(B)[2]
        # The path with minimum distance in B is higher than maxdist
        mindistB > maxdist && break
        push!(dists, peek(B)[2])
        push!(A, dequeue!(B))
    end

    return YenState{T,U}(dists, A)
end

"""
    core_number(g)

Return the core number for each vertex in graph `g`.

A k-core is a maximal subgraph that contains vertices of degree `k` or more.
The core number of a vertex is the largest value `k` of a k-core containing
that vertex.

### Implementation Notes
Not implemented for graphs with self loops.

### References
* An O(m) Algorithm for Cores Decomposition of Networks,
    Vladimir Batagelj and Matjaz Zaversnik, 2003.
    http://arxiv.org/abs/cs.DS/0310049

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(5);

julia> add_vertex!(g);

julia> add_edge!(g, 5, 2);

julia> core_number(g)
6-element Vector{Int64}:
 1
 2
 2
 2
 2
 0
```
"""
function core_number(g::AbstractGraph{T}) where {T}
    has_self_loops(g) && throw(ArgumentError("graph must not have self-loops"))
    n = nv(g)
    deg = T.(degree(g)) # this will contain core number for each vertex of graph
    maxdeg = maximum(deg) # maximum degree of a vertex in graph
    bin = zeros(T, maxdeg + 1) # used for bin-sort and storing starting positions of bins
    vert = zeros(T, n) # contains the set of vertices, sorted by their degrees
    pos = zeros(T, n) # contains positions of vertices in array vert

    # count number of vertices will be in each bin
    for v in 1:n
        bin[deg[v] + 1] += one(T)
    end
    # from bin sizes determine starting positions of bins in array vert
    start = one(T)
    for d in zero(T):maxdeg
        num = bin[d + 1]
        bin[d + 1] = start
        start += num
    end
    # sort the vertices in increasing order of their degrees and store in array vert
    for v in vertices(g)
        pos[v] = bin[deg[v] + 1]
        vert[pos[v]] = v
        bin[deg[v] + 1] += one(T)
    end

    # recover starting positions of the bins
    for d in maxdeg:-1:one(T)
        bin[d + 1] = bin[d]
    end
    bin[1] = one(T)

    # cores decomposition
    for i in 1:n
        v = vert[i]
        # for each neighbor u of vertex v with higher degree we have to decrease its degree and move it for one bin to the left
        for u in outneighbors(g, v)
            if deg[u] > deg[v]
                du = deg[u]
                pu = pos[u]
                pw = bin[du + 1]
                w = vert[pw]
                if u != w
                    pos[u] = pw
                    vert[pu] = w
                    pos[w] = pu
                    vert[pw] = u
                end
                bin[du + 1] += one(T)
                deg[u] -= one(T)
            end
        end
        if is_directed(g)
            for u in inneighbors(g, v)
                if deg[u] > deg[v]
                    du = deg[u]
                    pu = pos[u]
                    pw = bin[du + 1]
                    w = vert[pw]
                    if u != w
                        pos[u] = pw
                        vert[pu] = w
                        pos[w] = pu
                        vert[pw] = u
                    end
                    bin[du + 1] += one(T)
                    deg[u] -= one(T)
                end
            end
        end
    end

    return deg
end

"""
    k_core(g[, k]; corenum=core_number(g))

Return a vector of vertices in the k-core of graph `g`.
If `k` is not specified, return the core with the largest degree.

A k-core is a maximal subgraph that contains vertices of degree `k` or more.

### Implementation Notes
Not implemented for graphs with self loops.

### References
- An O(m) Algorithm for Cores Decomposition of Networks,
    Vladimir Batagelj and Matjaz Zaversnik, 2003.
    http://arxiv.org/abs/cs.DS/0310049

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(5);

julia> add_vertex!(g);

julia> add_edge!(g, 5, 2);

julia> k_core(g, 1)
5-element Vector{Int64}:
 1
 2
 3
 4
 5

julia> k_core(g, 2)
4-element Vector{Int64}:
 2
 3
 4
 5
```
"""
function k_core(g::AbstractGraph, k=-1; corenum=core_number(g))
    if (k == -1)
        # type assertion for inference (performance of captured variables julia#15726)
        k::Int = maximum(corenum) # max core
    end

    return findall(x -> x >= k, corenum)
end

"""
    k_shell(g[, k]; corenum=core_number(g))

Return a vector of vertices in the k-shell of `g`.
If `k` is not specified, return the shell of the core
with the largest degree.

The k-shell is the subgraph of vertices in the `k`-core but not in
the (`k+1`)-core. This is similar to `k_corona` but in that case
only neighbors in the k-core are considered.


### Implementation Notes
Not implemented for graphs with parallel edges or self loops.

### References
- A model of Internet topology using k-shell decomposition
   Shai Carmi, Shlomo Havlin, Scott Kirkpatrick, Yuval Shavitt,
   and Eran Shir, PNAS  July 3, 2007   vol. 104  no. 27  11150-11154
   http://www.pnas.org/content/104/27/11150.full

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(5);

julia> add_vertex!(g);

julia> add_edge!(g, 5, 2);

julia> k_shell(g, 0)
1-element Vector{Int64}:
 6

julia> k_shell(g, 1)
1-element Vector{Int64}:
 1

julia> k_shell(g, 2)
4-element Vector{Int64}:
 2
 3
 4
 5
```
"""
function k_shell(g::AbstractGraph, k=-1; corenum=core_number(g))
    if k == -1
        # type assertion for inference (performance of captured variables julia#15726)
        k::Int = maximum(corenum)
    end
    return findall(x -> x == k, corenum)
end

"""
    k_crust(g[, k]; corenum=core_number(g))

Return a vector of vertices in the k-crust of `g`.
If `k` is not specified, return the crust of the core with
the largest degree.

The k-crust is the graph `g` with the [`k-core`](@ref k_core) removed.

### Implementation Notes
This definition of k-crust is different than the definition in References.
The k-crust in References is equivalent to the `k+1` crust of this algorithm.

Not implemented for graphs with self loops.

### References
- A model of Internet topology using k-shell decomposition
   Shai Carmi, Shlomo Havlin, Scott Kirkpatrick, Yuval Shavitt,
   and Eran Shir, PNAS  July 3, 2007   vol. 104  no. 27  11150-11154
   http://www.pnas.org/content/104/27/11150.full

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(5);

julia> add_vertex!(g);

julia> add_edge!(g, 5, 2);

julia> k_crust(g, 0)
1-element Vector{Int64}:
 6

julia> k_crust(g, 1)
2-element Vector{Int64}:
 1
 6

julia> k_crust(g, 2)
6-element Vector{Int64}:
 1
 2
 3
 4
 5
 6
```
"""
function k_crust(g, k=-1; corenum=core_number(g))
    if k == -1
        # type assertion for inference (performance of captured variables julia#15726)
        k::Int = maximum(corenum) - 1
    end
    return findall(x -> x <= k, corenum)
end

"""
    k_corona(g, k; corenum=core_number(g))

Return a vector of vertices in the k-corona of `g`.

The k-corona is the subgraph of vertices in the [`k-core`](@ref k_core) which
have exactly `k` neighbors in the k-core.

### Implementation Notes
Not implemented for graphs with parallel edges or self loops.

### References

- k-core (bootstrap) percolation on complex networks:
   Critical phenomena and nonlocal effects,
   A. V. Goltsev, S. N. Dorogovtsev, and J. F. F. Mendes,
   Phys. Rev. E 73, 056101 (2006)
   http://link.aps.org/doi/10.1103/PhysRevE.73.056101

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(5);

julia> add_vertex!(g);

julia> add_edge!(g, 5, 2);

julia> k_corona(g, 0)
1-element Vector{Int64}:
 6

julia> k_corona(g, 1)
1-element Vector{Int64}:
 1

julia> k_corona(g, 2)
4-element Vector{Int64}:
 2
 3
 4
 5

julia> k_corona(g, 3)
Int64[]
```
"""
function k_corona(g::AbstractGraph, k; corenum=core_number(g))

    # TODO k_corona does not correctly work for all AbstractGraph as
    # it relies on induced_subgraph, which does not work on any AbstractGraph

    kcore = k_core(g, k)
    kcoreg = g[kcore]
    kcoredeg = degree(kcoreg)

    return kcore[findall(x -> x == k, kcoredeg)]
end

"""
    assortativity(g)

Return the [assortativity coefficient](https://en.wikipedia.org/wiki/Assortativity)
of graph `g`, defined as the Pearson correlation of excess degree between
the end vertices of all the edges of the graph.

The excess degree is equal to the degree of linked vertices minus one,
i.e. discounting the edge that links the pair.
In directed graphs, the paired values are the out-degree of source vertices
and the in-degree of destination vertices.

# Examples
```jldoctest
julia> using Graphs

julia> assortativity(star_graph(4))
-1.0
```
"""
function assortativity(g::AbstractGraph{T}) where {T}
    P = promote_type(Int64, T) # at least Int64 to reduce risk of overflow
    nue = ne(g)
    sjk = sj = sk = sjs = sks = zero(P)
    for d in edges(g)
        j = P(outdegree(g, src(d)) - 1)
        k = P(indegree(g, dst(d)) - 1)
        sjk += j * k
        sj += j
        sk += k
        sjs += j^2
        sks += k^2
    end
    return assortativity_coefficient(g, sjk, sj, sk, sjs, sks, nue)
end

#=
assortativity coefficient for directed graphs: 
see equation (21) in M. E. J. Newman: Mixing patterns in networks, Phys. Rev. E 67, 026126 (2003), 
http://arxiv.org/abs/cond-mat/0209450
=#
@traitfn function assortativity_coefficient(g::::IsDirected, sjk, sj, sk, sjs, sks, nue)
    return (sjk - sj * sk / nue) / sqrt((sjs - sj^2 / nue) * (sks - sk^2 / nue))
end

#=
assortativity coefficient for undirected graphs: 
see equation (4) in M. E. J. Newman: Assortative mixing in networks, Phys. Rev. Lett. 89, 208701 (2002), 
http://arxiv.org/abs/cond-mat/0205405/
=#
@traitfn function assortativity_coefficient(g::::(!IsDirected), sjk, sj, sk, sjs, sks, nue)
    return (sjk / nue - ((sj + sk) / (2 * nue))^2) /
           ((sjs + sks) / (2 * nue) - ((sj + sk) / (2 * nue))^2)
end

@testset "Radiality" begin
    gint = loadgraph(joinpath(testdir, "testdata", "graph-50-500.jgz"), "graph-50-500")

    c = vec(readdlm(joinpath(testdir, "testdata", "graph-50-500-rc.txt"), ','))
    for g in test_generic_graphs(gint)
        z = @inferred(radiality_centrality(g))
        @test z == c
    end

    g1 = cycle_graph(4)
    add_vertex!(g1)
    add_edge!(g1, 4, 5)
    for g in test_generic_graphs(g1)
        z = @inferred(radiality_centrality(g))
        @test z ≈ [5//6, 3//4, 5//6, 11//12, 2//3]
    end
end

function bellman_ford_shortest_paths(
    g::AbstractGraph{U},
    sources::AbstractVector{<:Integer},
    distmx::AbstractMatrix{T}=weights(g),
) where {T<:Number} where {U<:Integer}
    nvg = nv(g)
    active = Set{U}()
    sizehint!(active, nv(g))
    for s in sources
        union!(active, outneighbors(g, s))
    end
    dists = fill(typemax(T), nvg)
    parents = zeros(U, nvg)
    dists[sources] .= 0

    for i in one(U):nvg
        _loop_body!(g, distmx, dists, parents, active)

        isempty(active) && break
    end

    isempty(active) || throw(Graphs.NegativeCycleError())
    return BellmanFordState(parents, dists)
end

# Helper function used due to performance bug in @threads.
function _loop_body!(
    g::AbstractGraph{U},
    distmx::AbstractMatrix{T},
    dists::Vector{T},
    parents::Vector{U},
    active::Set{U},
) where {T<:Number} where {U<:Integer}
    prev_dists = deepcopy(dists)

    tmp_active = collect(active)
    @threads for v in tmp_active
        prev_dist_vertex = prev_dists[v]
        for u in inneighbors(g, v)
            relax_dist = (
                prev_dists[u] == typemax(T) ? typemax(T) : prev_dists[u] + distmx[u, v]
            )
            if prev_dist_vertex > relax_dist
                prev_dist_vertex = relax_dist
                parents[v] = u
            end
        end
        dists[v] = prev_dist_vertex
    end

    empty!(active)
    for v in vertices(g)
        if dists[v] < prev_dists[v]
            union!(active, outneighbors(g, v))
        end
    end
end

function has_negative_edge_cycle(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}
) where {T<:Number} where {U<:Integer}
    try
        Parallel.bellman_ford_shortest_paths(g, vertices(g), distmx)
    catch e
        isa(e, Graphs.NegativeCycleError) && return true
    end
    return false
end

"""
    DFSIterator

`DFSIterator` is used to iterate through graph vertices using a depth-first search. 
A source node(s) is optionally supplied as an `Int` or an array-like type that can be 
indexed if supplying multiple sources.
    
# Examples
```julia-repl
julia> g = smallgraph(:house)
{5, 6} undirected simple Int64 graph

julia> for node in DFSIterator(g, 3)
           display(node)
       end
1
2
4
3
5
```
"""
struct DFSIterator{S,G<:AbstractGraph}
    graph::G
    source::S
    function DFSIterator(graph::G, source::S) where {S,G}
        if any(node -> !has_vertex(graph, node), source)
            error("Some source nodes for the iterator are not in the graph")
        end
        return new{S,G}(graph, source)
    end
end

"""
    DFSVertexIteratorState

`DFSVertexIteratorState` is a struct to hold the current state of iteration
in DFS which is needed for the `Base.iterate()` function. A queue is used to
keep track of the vertices which will be visited during DFS. Since the queue
can contains repetitions of already visited nodes, we also keep track of that
in a `BitVector` so that to skip those nodes.
"""
mutable struct DFSVertexIteratorState
    visited::BitVector
    queue::Vector{Int}
end

Base.IteratorSize(::DFSIterator) = Base.SizeUnknown()
Base.eltype(::Type{DFSIterator{S,G}}) where {S,G} = eltype(G)

"""
    Base.iterate(t::DFSIterator)

First iteration to visit vertices in a graph using depth-first search.
"""
function Base.iterate(t::DFSIterator{<:Integer})
    visited = falses(nv(t.graph))
    visited[t.source] = true
    return (t.source, DFSVertexIteratorState(visited, [t.source]))
end

function Base.iterate(t::DFSIterator{<:AbstractArray})
    visited = falses(nv(t.graph))
    source_rev = reverse(t.source)
    visited[last(source_rev)] = true
    state = DFSVertexIteratorState(visited, source_rev)
    return (last(source_rev), state)
end

"""
    Base.iterate(t::DFSIterator, state::VertexIteratorState)

Iterator to visit vertices in a graph using depth-first search.
"""
function Base.iterate(t::DFSIterator, state::DFSVertexIteratorState)
    graph, visited, queue = t.graph, state.visited, state.queue
    while !isempty(queue)
        # we take the last node in the queue
        node_start = last(queue)
        # we first return it
        if !visited[node_start]
            visited[node_start] = true
            return (node_start, state)
        end
        # and then we visit a neighbor and push it at the
        # end of the queue
        for node in outneighbors(graph, node_start)
            if !visited[node]
                push!(queue, node)
                visited[node] = true
                return (node, state)
            end
        end
        # we pop the last node in the queue
        # when it and all its neighbors were visited
        pop!(queue)
    end
end

@testset "Karp Minimum Cycle Mean" begin
    w = [
        0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0
        0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0
        0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.1 0.0 0.0 0.0
        0.0 1.2 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0
        0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.3 0.0 0.0 0.0
        0.0 1.2 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0
        0.0 1.0 0.0 0.0 0.0 0.0 0.0 0.0 1.3 0.0 0.0 0.0
        0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0
        0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.4 0.0
        0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0
        0.0 0.0 0.0 0.0 0.0 0.0 1.0 0.0 0.0 0.0 0.0 0.0
        0.0 0.0 0.0 0.0 0.0 0.0 0.0 0.0 1.2 0.0 0.0 0.0
    ]

    w2 = [
        Inf Inf Inf Inf Inf Inf -0.09 Inf Inf Inf Inf Inf
        Inf Inf Inf Inf Inf Inf -0.06 Inf Inf Inf Inf Inf
        Inf Inf Inf Inf Inf Inf Inf Inf -0.01 Inf Inf Inf
        Inf -0.19 Inf Inf Inf Inf -0.09 Inf Inf Inf Inf Inf
        Inf -0.02 Inf Inf Inf Inf Inf Inf -0.03 Inf Inf Inf
        Inf -0.19 Inf Inf Inf Inf -0.09 Inf Inf Inf Inf Inf
        Inf -0.02 Inf Inf Inf Inf Inf Inf -0.03 Inf Inf Inf
        Inf Inf Inf Inf Inf Inf Inf Inf Inf Inf Inf Inf
        Inf Inf Inf Inf Inf Inf Inf Inf Inf Inf 0.39 Inf
        Inf Inf Inf Inf Inf Inf -0.09 Inf Inf Inf Inf Inf
        Inf Inf Inf Inf Inf Inf -0.06 Inf Inf Inf Inf Inf
        Inf Inf Inf Inf Inf Inf Inf Inf -0.01 Inf Inf Inf
    ]

    g1 = SimpleDiGraph(12)
    add_edge!(g1, 1, 7)
    add_edge!(g1, 2, 7)
    add_edge!(g1, 3, 9)
    add_edge!(g1, 4, 2)
    add_edge!(g1, 4, 7)
    add_edge!(g1, 5, 2)
    add_edge!(g1, 5, 9)
    add_edge!(g1, 6, 2)
    add_edge!(g1, 6, 7)
    add_edge!(g1, 7, 2)
    add_edge!(g1, 7, 9)
    add_edge!(g1, 9, 11)
    add_edge!(g1, 10, 7)
    add_edge!(g1, 11, 7)
    add_edge!(g1, 12, 9)

    @testset "simple digraphs" for g in test_generic_graphs(g1)
        c, λ = karp_minimum_cycle_mean(g, w)
        @test c == [9, 11, 7]
        @test λ == 0.9

        c2, λ2 = karp_minimum_cycle_mean(g, w2)
        @test λ2 == -0.04
        @test c2 == [2, 7]
    end

    # Tricky test case
    # Backward walk from 3 is good:
    # 1 - 2 - 3 - 4 - 3
    # Only the first of the two backward walk from 4 is good:
    # 1 - 3 - 4 - 3 - 4
    # 1 - 2 - 2 - 3 - 4
    # We will do the backward walk from 3 in the test since 0 = F_4(3) < F_4(4) = 1
    tricky = SimpleDiGraph(4)
    add_edge!(tricky, 1, 3)
    add_edge!(tricky, 1, 2)
    add_edge!(tricky, 3, 4)
    add_edge!(tricky, 4, 1) # Make it strongly connected
    add_edge!(tricky, 4, 3)
    add_edge!(tricky, 2, 3)
    add_edge!(tricky, 2, 2)
    distmx = [
        Inf 0.0 1.0 Inf
        Inf 1.0 0.0 Inf
        Inf Inf Inf 0.0
        1.0 Inf 0.0 Inf
    ]

    @testset "tricky case" for g in test_generic_graphs(tricky)
        c, λ = karp_minimum_cycle_mean(g, distmx)
        @test λ == 0.0
        @test sort(c) == [3, 4]

        c, λ = karp_minimum_cycle_mean(g, distmx .- 2)
        @test λ == -2.0
        @test sort(c) == [3, 4]
    end

    # Multiple strongly connected components and one component with one node and no edge
    multi = SimpleDiGraph(3)
    add_edge!(multi, 1, 1)
    add_edge!(multi, 2, 2)
    distmx = [
        0.0 Inf
        Inf -1
    ]

    @testset "multiple SCCs" for g in test_generic_graphs(multi)
        c, λ = karp_minimum_cycle_mean(g, distmx)
        @test λ == -1.0
        @test c == [2]
    end
end

"""
    squash(g::Union{SimpleGraph, SimpleDiGraph}; alwayscopy=true)

Specialised version of `Graphs.squash` for `SimpleGraph` and `SimpleDiGraph`.
If `alwayscopy` is `true`, the resulting graph will always be a copy, otherwise
it can also be the original graph.
"""
function Graphs.squash(g::Union{SimpleGraph,SimpleDiGraph}; alwayscopy::Bool=true)
    G = is_directed(g) ? SimpleDiGraph : SimpleGraph
    T = eltype(g)

    (!alwayscopy && T <: Union{Int8,UInt8}) && return g
    nv(g) < typemax(Int8) && return G{Int8}(g)
    nv(g) < typemax(UInt8) && return G{UInt8}(g)
    (!alwayscopy && T <: Union{Int16,UInt16}) && return g
    nv(g) < typemax(Int16) && return G{Int16}(g)
    nv(g) < typemax(UInt16) && return G{UInt16}(g)
    (!alwayscopy && T <: Union{Int32,UInt32}) && return g
    nv(g) < typemax(Int32) && return G{Int32}(g)
    nv(g) < typemax(UInt32) && return G{UInt32}(g)
    (!alwayscopy && T <: Union{Int64,UInt64}) && return g
    nv(g) < typemax(Int64) && return G{Int64}(g)
    nv(g) < typemax(UInt64) && return G{UInt64}(g)

    return alwayscopy ? copy(g) : g
end

"""
    FrozenVector(v::Vector) <: AbstractVector

A data structure that wraps a `Vector` but does not allow modifications.
"""
struct FrozenVector{T} <: AbstractVector{T}
    wrapped::Vector{T}
end

Base.size(v::FrozenVector) = Base.size(v.wrapped)

Base.@propagate_inbounds Base.getindex(v::FrozenVector, i::Int) = Base.getindex(
    v.wrapped, i
)

Base.IndexStyle(v::Type{FrozenVector{T}}) where {T} = Base.IndexStyle(Vector{T})

Base.iterate(v::FrozenVector) = Base.iterate(v.wrapped)
Base.iterate(v::FrozenVector, state) = Base.iterate(v.wrapped, state)

Base.similar(v::FrozenVector) = Base.similar(v.wrapped)
Base.similar(v::FrozenVector, T::Type) = Base.similar(v.wrapped, T)
Base.similar(v::FrozenVector, T::Type, dims::Base.Dims) = Base.similar(v.wrapped, T, dims)

Base.copy(v::FrozenVector) = Base.copy(v.wrapped)

@testset "Static graphs" begin
    @testset "DiGraphs" begin
        g = @inferred(complete_digraph(5))
        @test nv(g) == 5 && ne(g) == 20
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = complete_digraph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = complete_digraph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = complete_digraph(2)
        @test nv(g) == 2 && ne(g) == 2
        g = @inferred complete_digraph(Int8(127))
        @test nv(g) == 127 && ne(g) == 127 * (127 - 1)
        @test eltype(g) == Int8
    end

    @testset "Graphs" begin
        g = @inferred(complete_graph(5))
        @test nv(g) == 5 && ne(g) == 10
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = complete_graph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = complete_graph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = complete_graph(2)
        @test nv(g) == 2 && ne(g) == 1
        g = @inferred complete_graph(Int8(127))
        @test nv(g) == 127 && ne(g) == 127 * (127 - 1) ÷ 2
        @test eltype(g) == Int8
    end

    @testset "Bipartite Graphs" begin
        g = @inferred(complete_bipartite_graph(5, 8))
        @test nv(g) == 13 && ne(g) == 40
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = complete_bipartite_graph(0, 0)
        @test nv(g) == 0 && ne(g) == 0
        g = complete_bipartite_graph(5, 0)
        @test nv(g) == 5 && ne(g) == 0
        g = complete_bipartite_graph(0, 5)
        @test nv(g) == 5 && ne(g) == 0
        g = @inferred complete_bipartite_graph(Int8(100), Int8(27))
        @test nv(g) == 127 && ne(g) == 100 * 27
        @test eltype(g) == Int8
        g = complete_bipartite_graph(Int8(127), Int8(0))
        @test nv(g) == 127 && ne(g) == 0
        g = complete_bipartite_graph(Int8(0), Int8(127))
        @test nv(g) == 127 && ne(g) == 0
    end

    function iscompletemultipartite(g, partitions)
        sum(partitions) != nv(g) && return false
        n = nv(g)

        edges = 0
        for p in partitions
            edges += p * (Int(n) - p)
        end
        edges = div(edges, 2)

        edges != ne(g) && return false

        cur = 1
        for p in partitions
            currange = cur:(cur + p - 1)
            lowerrange = 1:(cur - 1)
            upperrange = (cur + p):n
            for u in currange
                for v in currange # check that no vertices are connected to vertices in the same partition
                    has_edge(g, u, v) && return false
                end

                for v in lowerrange # check all lower partition vertices
                    !has_edge(g, u, v) && return false
                end

                for v in upperrange # check all higher partition vertices
                    !has_edge(g, u, v) && return false
                end
            end
            cur += p
        end
        return true
    end

    @testset "Multipartite Graphs" begin
        g = @inferred(complete_multipartite_graph([5, 8, 3]))
        @test nv(g) == 16 && ne(g) == 79
        @test isvalid_simplegraph(g)
        @test iscompletemultipartite(g, [5, 8, 3])
        # tests for extreme values
        g = complete_multipartite_graph([0, 0, 0])
        @test nv(g) == 0 && ne(g) == 0
        g = complete_multipartite_graph(Int[])
        @test nv(g) == 0 && ne(g) == 0
        g = complete_multipartite_graph([5, 0, 3])
        @test nv(g) == 8 && ne(g) == 15
        @test iscompletemultipartite(g, [5, 0, 3])
        g = complete_multipartite_graph(Int8[100, 25, 2])
        @test nv(g) == 127 && ne(g) == 2750
        @test eltype(g) == Int8
        @test iscompletemultipartite(g, [100, 25, 2])
        g = complete_multipartite_graph([0, 10, 0, 2, 0, 3, 0, 0, 6, 0])
        @test nv(g) == 21 && ne(g) == 146
        @test iscompletemultipartite(g, [0, 10, 0, 2, 0, 3, 0, 0, 6, 0])
        g = complete_multipartite_graph([5, 3, -1])
        @test nv(g) == 0 && ne(g) == 0
        g = complete_multipartite_graph([-5, 0, -11])
        @test nv(g) == 0 && ne(g) == 0
        g = complete_multipartite_graph([5, 3])
        h = complete_multipartite_graph([5, 0, 3])
        j = complete_multipartite_graph([0, 5, 0, 3, 0, 0])
        @test g == h == j
        @test_throws InexactError complete_multipartite_graph(Int8[100, 20, 20])
    end

    function retrievepartitions(n, r)
        partitions = partitions = Vector{Int}(undef, r)
        c = cld(n, r)
        f = fld(n, r)
        for i in 1:(n % r)
            partitions[i] = c
        end
        for i in ((n % r) + 1):r
            partitions[i] = f
        end
        return partitions
    end

    @testset "Turan Graphs" begin
        g = @inferred(turan_graph(13, 4))
        @test nv(g) == 13 && ne(g) == 63
        @test isvalid_simplegraph(g)
        @test iscompletemultipartite(g, retrievepartitions(13, 4))
        # testing smaller int types
        g = turan_graph(Int8(11), Int8(6))
        @test nv(g) == 11 && ne(g) == 50
        @test iscompletemultipartite(g, retrievepartitions(11, 6))
        g = turan_graph(Int16(35), Int16(17))
        @test nv(g) == 35 && ne(g) == 576
        @test iscompletemultipartite(g, retrievepartitions(35, 17))
        # tests for extreme values
        g = turan_graph(15, 15)
        @test nv(g) == 15 && ne(g) == 105
        @test iscompletemultipartite(g, retrievepartitions(15, 15))
        g = turan_graph(10, 1)
        @test nv(g) == 10 && ne(g) == 0
        @test iscompletemultipartite(g, retrievepartitions(10, 1))
        @test_throws DomainError turan_graph(3, 0)
        @test_throws DomainError turan_graph(0, 4)
        @test_throws DomainError turan_graph(3, 4)
        @test_throws DomainError turan_graph(-1, 5)
        @test_throws DomainError turan_graph(3, -6)
    end

    @testset "Star Graphs" begin
        g = @inferred(star_graph(5))
        @test nv(g) == 5 && ne(g) == 4
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = star_graph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = star_graph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = star_graph(2)
        @test nv(g) == 2 && ne(g) == 1
        g = @inferred star_graph(Int8(127))
        @test nv(g) == 127 && ne(g) == 127 - 1
        @test eltype(g) == Int8
    end

    @testset "Star DiGraphs" begin
        g = @inferred(star_digraph(5))
        @test nv(g) == 5 && ne(g) == 4
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = star_digraph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = star_digraph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = star_digraph(2)
        @test nv(g) == 2 && ne(g) == 1
        @test first(edges(g)) == Edge(1, 2) # edges should point outwards from vertex 1
        g = @inferred star_digraph(Int8(127))
        @test nv(g) == 127 && ne(g) == 127 - 1
        @test eltype(g) == Int8
    end

    @testset "Path DiGraphs" begin
        g = @inferred(path_digraph(5))
        @test nv(g) == 5 && ne(g) == 4
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = path_digraph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = path_digraph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = @inferred path_digraph(Int8(127))
        @test nv(g) == 127 && ne(g) == 126
        @test eltype(g) == Int8
    end

    @testset "Path Graphs" begin
        g = @inferred(path_graph(5))
        @test nv(g) == 5 && ne(g) == 4
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = path_graph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = path_graph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = @inferred path_graph(Int8(127))
        @test nv(g) == 127 && ne(g) == 126
        @test eltype(g) == Int8
    end

    @testset "Cycle DiGraphs" begin
        g = @inferred(cycle_digraph(5))
        @test nv(g) == 5 && ne(g) == 5
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = cycle_digraph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = cycle_digraph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = cycle_digraph(2)
        @test nv(g) == 2 && ne(g) == 2
        g = @inferred cycle_digraph(Int8(127))
        @test nv(g) == 127 && ne(g) == 127
        @test eltype(g) == Int8
    end

    @testset "Cycle Graphs" begin
        g = @inferred(cycle_graph(5))
        @test nv(g) == 5 && ne(g) == 5
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = cycle_graph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = cycle_graph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = cycle_graph(2)
        @test nv(g) == 2 && ne(g) == 1
        g = @inferred cycle_graph(Int8(127))
        @test nv(g) == 127 && ne(g) == 127
        @test eltype(g) == Int8
    end

    @testset "Wheel DiGraphs" begin
        g = @inferred(wheel_digraph(5))
        @test nv(g) == 5 && ne(g) == 8
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = wheel_digraph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = wheel_digraph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = wheel_digraph(2)
        @test nv(g) == 2 && ne(g) == 1
        g = wheel_digraph(3)
        @test nv(g) == 3 && ne(g) == 4
        g = @inferred wheel_digraph(Int8(127))
        @test nv(g) == 127 && ne(g) == 2 * 126
        @test eltype(g) == Int8
    end

    @testset "Wheel Graphs" begin
        g = @inferred(wheel_graph(5))
        @test nv(g) == 5 && ne(g) == 8
        @test isvalid_simplegraph(g)
        # tests for extreme values
        g = wheel_graph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = wheel_graph(1)
        @test nv(g) == 1 && ne(g) == 0
        g = wheel_graph(2)
        @test nv(g) == 2 && ne(g) == 1
        g = wheel_graph(3)
        @test nv(g) == 3 && ne(g) == 3
        g = @inferred wheel_graph(Int8(127))
        @test nv(g) == 127 && ne(g) == 2 * 126
        @test eltype(g) == Int8
    end

    @testset "grids" begin
        g = @inferred(grid([3, 3, 4]))
        @test nv(g) == 3 * 3 * 4
        @test ne(g) == 75
        @test Δ(g) == 6
        @test δ(g) == 3
        @test isvalid_simplegraph(g)

        g2 = @inferred(grid((3, 3, 4)))
        @test g2 == g

        g = @inferred(grid([3, 3, 4], periodic=true))
        @test nv(g) == 3 * 3 * 4
        @test ne(g) == 108
        @test Δ(g) == 6
        @test δ(g) == 6
        @test isvalid_simplegraph(g)

        g2 = @inferred(grid((3, 3, 4), periodic=true))
        @test g2 == g
    end

    @testset "Clique Graphs" begin
        g = @inferred(clique_graph(3, 5))
        @test nv(g) == 15 && ne(g) == 20
        @test g[1:3] == complete_graph(3)
        @test isvalid_simplegraph(g)
    end

    @testset "Binary Trees" begin
        g = @inferred(crosspath(3, binary_tree(2)))
        # f = Vector{Vector{Int}}[[2 3 4];
        # [1 5];
        # [1 6];
        # [1 5 6 7];
        # [2 4 8];
        # [3 4 9];
        # [4 8 9];
        # [5 7];
        # [6 7]
        # ]
        I = [1, 1, 1, 2, 2, 3, 3, 4, 4, 4, 4, 5, 5, 5, 6, 6, 6, 7, 7, 7, 8, 8, 9, 9]
        J = [2, 3, 4, 1, 5, 1, 6, 1, 5, 6, 7, 2, 4, 8, 3, 4, 9, 4, 8, 9, 5, 7, 6, 7]
        V = ones(Int, length(I))
        Adj = sparse(I, J, V)
        @test Adj == sparse(g)
        @test isvalid_simplegraph(g)
        @test_throws DomainError binary_tree(Int8(8))

        g = @inferred(double_binary_tree(3))
        # [[3, 2, 8]
        # [4, 1, 5]
        # [1, 6, 7]
        # [2]
        # [2]
        # [3]
        # [3]
        # [10, 9, 1]
        # [11, 8, 12]
        # [8, 13, 14]
        # [9]
        # [9]
        # [10]
        # [10]]
        I = [
            1,
            1,
            1,
            2,
            2,
            2,
            3,
            3,
            3,
            4,
            5,
            6,
            7,
            8,
            8,
            8,
            9,
            9,
            9,
            10,
            10,
            10,
            11,
            12,
            13,
            14,
        ]
        J = [
            3,
            2,
            8,
            4,
            1,
            5,
            1,
            6,
            7,
            2,
            2,
            3,
            3,
            10,
            9,
            1,
            11,
            8,
            12,
            8,
            13,
            14,
            9,
            9,
            10,
            10,
        ]
        V = ones(Int, length(I))
        Adj = sparse(I, J, V)
        @test Adj == sparse(g)
        @test isvalid_simplegraph(g)
    end

    @testset "Regular Trees" begin
        g = @inferred(regular_tree(3, 3))
        I = [1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 4, 4, 4, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13]
        J = [2, 3, 4, 1, 5, 6, 7, 8, 1, 9, 10, 1, 11, 12, 13, 2, 2, 2, 3, 3, 3, 4, 4, 4]
        V = ones(Int, length(I))
        Adj = sparse(I, J, V)
        @test Adj == sparse(g)
        @test isvalid_simplegraph(g)
        @test_throws InexactError regular_tree(Int8, 4, 5)
        g = @inferred(regular_tree(Int16, 4, 5))
        @test isvalid_simplegraph(g)
        # test that z = 1 recovers a path graph
        @test all(regular_tree(k, 1) == path_graph(k) for k in 0:10)
        # test that z = 2 recovers a binary tree
        @test all(regular_tree(k, 2) == binary_tree(k) for k in 0:10)
    end

    @testset "Roach Graphs" begin
        rg3 = @inferred(roach_graph(3))
        # [3]
        # [4]
        # [1, 5]
        # [2, 6]
        # [3, 7]
        # [4, 8]
        # [9, 8, 5]
        # [10, 7, 6]
        # [11, 10, 7]
        # [8, 9, 12]
        # [9, 12]
        # [10, 11]
        I = [
            1,
            2,
            3,
            3,
            4,
            4,
            5,
            5,
            6,
            6,
            7,
            7,
            7,
            8,
            8,
            8,
            9,
            9,
            9,
            10,
            10,
            10,
            11,
            11,
            12,
            12,
        ]
        J = [
            3,
            4,
            1,
            5,
            2,
            6,
            3,
            7,
            4,
            8,
            9,
            8,
            5,
            10,
            7,
            6,
            11,
            10,
            7,
            8,
            9,
            12,
            9,
            12,
            10,
            11,
        ]
        V = ones(Int, length(I))
        Adj = sparse(I, J, V)
        @test Adj == sparse(rg3)
        @test isvalid_simplegraph(rg3)
    end

    function isladdergraph(g)
        n = nv(g) ÷ 2
        !(degree(g, 1) == degree(g, n) == degree(g, n + 1) == degree(g, 2 * n) == 2) &&
            return false
        !(has_edge(g, 1, n + 1) && has_edge(g, n, 2 * n)) && return false
        !(
            has_edge(g, 1, 2) &&
            has_edge(g, n, n - 1) &&
            has_edge(g, n + 1, n + 2) &&
            has_edge(g, 2 * n, 2 * n - 1)
        ) && return false
        for i in 2:(n - 1)
            !(degree(g, i) == 3 && degree(g, n + i) == 3) && return false
            !(has_edge(g, i, i % n + 1) && has_edge(g, i, i + n)) && return false
            !(has_edge(g, n + i, n + (i % n + 1)) && has_edge(g, n + i, i)) && return false
        end
        return true
    end

    @testset "Ladder Graphs" begin
        g = @inferred(ladder_graph(5))
        @test nv(g) == 10 && ne(g) == 13
        @test isvalid_simplegraph(g)
        @test isladdergraph(g)
        # tests for extreme values
        g = ladder_graph(0)
        @test nv(g) == 0 && ne(g) == 0
        g = ladder_graph(1)
        @test nv(g) == 2 && ne(g) == 1
        g = @inferred ladder_graph(-1)
        @test nv(g) == 0 && ne(g) == 0
        g = ladder_graph(Int8(63))
        @test nv(g) == 126 && ne(g) == 187
        @test eltype(g) == Int8
        @test isladdergraph(g)
        # tests for errors
        @test_throws InexactError ladder_graph(Int8(64))
    end

    function iscircularladdergraph(g)
        n = nv(g) ÷ 2
        for i in 1:n
            !(degree(g, i) == 3 && degree(g, n + i) == 3) && return false
            !(has_edge(g, i, i % n + 1) && has_edge(g, i, i + n)) && return false
            !(has_edge(g, n + i, n + (i % n + 1)) && has_edge(g, n + i, i)) && return false
        end
        return true
    end

    @testset "Circular Ladder Graphs" begin
        g = @inferred(circular_ladder_graph(5))
        @test nv(g) == 10 && ne(g) == 15
        @test isvalid_simplegraph(g)
        @test iscircularladdergraph(g)
        # tests for extreme values
        g = circular_ladder_graph(3)
        @test nv(g) == 6 && ne(g) == 9
        @test iscircularladdergraph(g)
        g = circular_ladder_graph(Int8(63))
        @test nv(g) == 126 && ne(g) == 189
        @test eltype(g) == Int8
        @test iscircularladdergraph(g)
        # tests for errors
        @test_throws InexactError circular_ladder_graph(Int8(64))
        @test_throws DomainError circular_ladder_graph(-1)
        @test_throws DomainError circular_ladder_graph(0)
        @test_throws DomainError circular_ladder_graph(1)
        @test_throws DomainError circular_ladder_graph(2)
    end

    # checking that the nodes are organized correctly
    # see the docstring implementation notes for lollipop_graph
    function isbarbellgraph(g, n1, n2)
        nv(g) != n1 + n2 && return false
        ne(g) != n1 * (n1 - 1) ÷ 2 + n2 * (n2 - 1) ÷ 2 + 1 && return false
        for i in 1:n1
            for j in (i + 1):n1
                !has_edge(g, i, j) && return false
            end
        end

        for i in (n1 .+ 1):n2
            for j in (i + 1):(n1 + n2)
                !has_edge(g, i, j) && return false
            end
        end

        !has_edge(g, n1, n1 + 1) && return false
        return true
    end

    @testset "Barbell Graphs" begin
        g = @inferred(barbell_graph(5, 6))
        @test nv(g) == 11 && ne(g) == 26
        @test isvalid_simplegraph(g)
        @test isbarbellgraph(g, 5, 6)
        g = barbell_graph(Int8(5), Int8(6))
        @test nv(g) == 11 && ne(g) == 26
        @test isvalid_simplegraph(g)
        @test isbarbellgraph(g, 5, 6)
        # extreme values
        g = barbell_graph(1, 5)
        @test nv(g) == 6 && ne(g) == 11
        @test isbarbellgraph(g, 1, 5)
        g = barbell_graph(5, 1)
        @test nv(g) == 6 && ne(g) == 11
        @test isbarbellgraph(g, 5, 1)
        g = barbell_graph(1, 1)
        @test nv(g) == 2 && ne(g) == 1
        @test isbarbellgraph(g, 1, 1)
        @test_throws OverflowError barbell_graph(Int8(100), Int8(50))
        @test_throws DomainError barbell_graph(1, 0)
        @test_throws DomainError barbell_graph(0, 1)
        @test_throws DomainError barbell_graph(-1, -1)
    end

    # checking that the nodes are organized correctly
    # see the docstring implementation notes for lollipop_graph
    function islollipopgraph(g, n1, n2)
        nv(g) != n1 + n2 && return false
        ne(g) != n1 * (n1 - 1) ÷ 2 + n2 && return false
        for i in 1:n1
            for j in (i + 1):n1
                !has_edge(g, i, j) && return false
            end
        end

        for i in (n1 .+ 1):(n2 - 1)
            !has_edge(g, i, i + 1) && return false
        end

        !has_edge(g, n1, n1 + 1) && return false

        return true
    end

    @testset "Lollipop Graphs" begin
        g = @inferred(lollipop_graph(3, 5))
        @test nv(g) == 8 && ne(g) == 8
        @test isvalid_simplegraph(g)
        @test islollipopgraph(g, 3, 5)
        g = lollipop_graph(Int8(7), Int8(6))
        @test nv(g) == 13 && ne(g) == 27
        @test isvalid_simplegraph(g)
        @test islollipopgraph(g, 7, 6)
        # extreme values
        g = lollipop_graph(1, 3)
        @test nv(g) == 4 && ne(g) == 3
        @test islollipopgraph(g, 1, 3)
        g = lollipop_graph(3, 1)
        @test nv(g) == 4 && ne(g) == 4
        @test islollipopgraph(g, 3, 1)
        g = lollipop_graph(1, 1)
        @test nv(g) == 2 && ne(g) == 1
        @test islollipopgraph(g, 1, 1)
        @test_throws OverflowError lollipop_graph(Int8(100), Int8(50))
        @test_throws DomainError lollipop_graph(1, 0)
        @test_throws DomainError lollipop_graph(0, 1)
        @test_throws DomainError lollipop_graph(-1, -1)
    end
end

# TODO most functions here do not work for general abstract graphs yet
# as most of them relay on induced_subgraph, which expects the graph type
# to be modifiable.

abstract type Visitor{T<:Integer} end

"""
    ncycles_n_i(n::Integer, i::Integer)

Compute the theoretical maximum number of cycles of size `i` in a directed graph of `n`
 vertices.
"""
function ncycles_n_i(n::Integer, i::Integer)
    return binomial(big(n), big(n - i + 1)) * factorial(big(n - i))
end

"""
    maxsimplecycles(n::Integer)

Compute the theoretical maximum number of cycles in a directed graph of `n` vertices,
assuming there are no self-loops.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007).
"""
maxsimplecycles(n::Integer) = sum(x -> ncycles_n_i(n, x), 1:(n - 1))

"""
    maxsimplecycles(dg::::IsDirected, byscc::Bool = true)

Compute the theoretical maximum number of cycles in the directed graph `dg`.

The computation can be performed assuming the graph is complete or taking into account the
decomposition in strongly connected components (`byscc` parameter).

### Performance
A more efficient version is possible.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007)
"""
function maxsimplecycles end
@traitfn function maxsimplecycles(dg::::IsDirected, byscc::Bool=true)
    c::BigInt = zero(BigInt)
    n = nv(dg)
    if !byscc
        c = maxsimplecycles(n)
    else
        for scc in strongly_connected_components(dg)
            if length(scc) > 1
                c += maxsimplecycles(length(scc))
            end
        end
    end
    return c
end

"""
```
type JohnsonVisitor{T<:Integer} <: Visitor{T}
    stack::Vector{T}
    blocked::BitVector
    blockedmap::Vector{Set{T}}
end

JohnsonVisitor(dg::::IsDirected)

```

Composite type that regroups the information needed for Johnson's algorithm.

`stack` is the stack of visited vertices. `blocked` is a boolean for each
vertex that tells whether it is blocked or not. `blockedmap` tells which
vertices to unblock if the key vertex is unblocked.

`JohnsonVisitor` may also be constructed directly from the directed graph.
"""
struct JohnsonVisitor{T<:Integer} <: Visitor{T}
    stack::Vector{T}
    blocked::BitVector
    blockedmap::Vector{Set{T}}
end

function JohnsonVisitor(dg)
    # dg should be a directed graph, we had some problems with type instability and @traitfn
    # so we removed the type check for this (Julia v1.1.0), this might change in the future.
    T = eltype(dg)
    return JohnsonVisitor(Vector{T}(), falses(nv(dg)), [Set{T}() for i in vertices(dg)])
end

"""
    unblock!{T<:Integer}(v::T, blocked::BitVector, B::Vector{Set{T}})

Unblock the vertices recursively.

`v` is the vertex to unblock, `blocked` tells whether a vertex is blocked or
not and `B` is the map that tells if the unblocking of one vertex should
unblock other vertices.
"""
function unblock!(v::T, blocked::BitVector, B::Vector{Set{T}}) where {T<:Integer}
    blocked[v] = false
    for w in B[v]
        delete!(B[v], w)
        if blocked[w]
            unblock!(w, blocked, B)
        end
    end
end

"""
    circuit{T<:Integer}(v::T, dg::::IsDirected, vis::JohnsonVisitor{T},
    allcycles::Vector{Vector{T}}, vmap::Vector{T}, startnode::T = v)

Return one step of the recursive version of simple cycle detection,
using a DFS algorithm.


* `v`: the vertex considered in this iteration of the DFS
* `dg`: the digraph from which cycles are computed
* `visitor`: Informations needed for the cycle computation, contains:
    * `stack`: the stack of parent vertices
    * `blocked`: tells whether a vertex has already been explored or not
    * `blockedmap`: mapping of the blocking / unblocking consequences
* `allcycles`: output containing the cycles already detected
* `vmap`: vector map containing the link from the old to the new nodes of the directed graph
* `startnode = v`: optional argument giving the starting node. In the first iteration,
 the same as v, otherwise it should be passed.

### Implementation Notes
Implements Johnson's CIRCUIT function. This is a recursive version.
Modifies the vector of cycles, when needed.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007)
"""
function circuit end
@traitfn function circuit(
    v::T,
    dg::::IsDirected,
    vis::JohnsonVisitor{T},
    allcycles::Vector{Vector{T}},
    vmap::Vector{T},
    startnode::T=v,
) where {T<:Integer}
    done = false
    push!(vis.stack, v)
    vis.blocked[v] = true
    for w in outneighbors(dg, v)
        if w == startnode
            push!(allcycles, vmap[vis.stack])
            done = true
        elseif !vis.blocked[w]
            circuit(w, dg, vis, allcycles, vmap, startnode) && (done = true) # This is different from done = circuit(...). It keeps the previous value of done in the for loop
        end
    end
    if done
        unblock!(v, vis.blocked, vis.blockedmap)
    else
        for w in outneighbors(dg, v)
            if !in(vis.blockedmap[w], v)
                push!(vis.blockedmap[w], v)
            end
        end
    end
    pop!(vis.stack)
    return done
end

"""
    simplecycles(dg::::IsDirected)

Compute and return all cycles of the given directed graph using Johnson's algorithm.

### Performance
The number of cycles grows more than exponentially with the number of vertices,
you might want to use the algorithm with a ceiling -- [`simplecycles_iter`](@ref) -- on large directed graphs
(slightly slower). If you want to have an idea of the possible number of cycles,
look at function `maxsimplecycles(dg::DiGraph, byscc::Bool = true)`. If you only need
short cycles of a limited length, [`simplecycles_limited_length`](@ref) can be more efficient.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007)

# Examples
```jldoctest
julia> using Graphs

julia> simplecycles(complete_digraph(3))
5-element Vector{Vector{Int64}}:
 [1, 2]
 [1, 2, 3]
 [1, 3]
 [1, 3, 2]
 [2, 3]
```
"""
function simplecycles end
@traitfn function simplecycles(dg::::IsDirected)
    T = eltype(dg)
    sccs = strongly_connected_components(dg)
    cycles = Vector{Vector{T}}()
    for scc in sccs
        for i in 1:length(scc)
            wdg, vmap = induced_subgraph(dg, scc[i:end])
            visitor = JohnsonVisitor(wdg)
            circuit(T(1), wdg, visitor, cycles, vmap) # 1 is the startnode.
        end
    end
    return cycles
end

##########################################################
#### Iterative version, using Tasks, of the previous algorithms.
"""
    circuit_iter{T<:Integer}(v::T, dg::::IsDirected, vis::JohnsonVisitor{T},
    vmap::Vector{T}, cycle::Channel, startnode::T = v)

Execute one step of the recursive version of simple cycle detection, using a DFS algorithm.
Return `true` if a circuit has been found in the current exploration.

# Arguments
* v: the vertex considered in this iteration of the DFS
* dg: the digraph from which cycles are computed
* visitor: information needed for the cycle computation, contains:
    * stack: the stack of parent vertices
    * blocked: tells whether a vertex has already been explored or not
    * blockedmap: mapping of the blocking / unblocking consequences
* `vmap`: vector map containing the link from the old to the new nodes of the directed graph
* `cycle`: storage of the channel
* startnode = v: optional argument giving the starting node. In the first iteration,
the same as v, otherwise it should be passed.

### Implementation Notes
Implements the CIRCUIT function from Johnson's algorithm, recursive and iterative version.
Produces a cycle when needed. Can be used only inside a `Channel`.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007)
"""
function circuit_iter end
@traitfn function circuit_iter(
    v::T,
    dg::::IsDirected,
    vis::JohnsonVisitor{T},
    vmap::Vector{T},
    cycle::Channel{Vector{T}},
    startnode::T=v,
) where {T<:Integer}
    done = false
    push!(vis.stack, v)
    vis.blocked[v] = true
    for w in outneighbors(dg, v)
        if w == startnode
            put!(cycle, vmap[vis.stack])
            done = true
        elseif !vis.blocked[w]
            circuit_iter(w, dg, vis, vmap, cycle, startnode) && (done = true) # This is different from done = circuit(...). It keeps the previous value of done in the for loop
        end
    end
    if done
        unblock!(v, vis.blocked, vis.blockedmap)
    else
        for w in outneighbors(dg, v)
            if !in(vis.blockedmap[w], v)
                push!(vis.blockedmap[w], v)
            end
        end
    end
    pop!(vis.stack)
    return done
end

"""
    itercycles(dg::::IsDirected, cycle::Channel)

Compute all cycles of the given directed graph, using Johnson's algorithm.

### Implementation Notes
Iterative version of the algorithm, using `Channel`s to stop the exploration
after a given number of cycles.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007)
"""
function itercycles end
@traitfn function itercycles(
    dg::AG::IsDirected, cycle::Channel{Vector{T}}
) where {T,AG<:AbstractGraph{T}}
    sccs = strongly_connected_components(dg)
    for scc in sccs
        while length(scc) >= 1
            wdg, vmap = induced_subgraph(dg, scc)
            popfirst!(scc)
            visitor = JohnsonVisitor(wdg)
            circuit_iter(T(1), wdg, visitor, vmap, cycle)
        end
    end
end

"""
    simplecyclescount(dg::DiGraph, ceiling = 10^6)

Count the number of cycles in a directed graph, using Johnson's algorithm.
Return the minimum of the ceiling and the number of cycles.

### Implementation Notes
The `ceiling` is here to avoid memory overload if there are a lot of cycles in the graph.
Default value is 10^6, but it can be higher or lower. You can use the function
`maxsimplecycles(dg::DiGraph, byscc::Bool = true)` to get an idea of the
theoretical maximum number or cycles.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007)

# Examples
```jldoctest
julia> using Graphs

julia> simplecyclescount(complete_digraph(6))
409
```
"""
function simplecyclescount end
@traitfn function simplecyclescount(
    dg::AG::IsDirected, ceiling=10^6
) where {T,AG<:AbstractGraph{T}}
    len = 0
    for cycle in Iterators.take(
        Channel(c -> itercycles(dg, c); ctype=Vector{T})::Channel{Vector{T}}, ceiling
    )
        len += 1
    end
    return len
end

"""
    simplecycles_iter(dg::DiGraph, ceiling = 10^6)

Search all cycles of the given directed graph, using Johnson's algorithm,
up to the ceiling (to avoid memory overload).

### Implementation Notes
If the graph is small, the ceiling will not be reached and
`simplecycles(dg::DiGraph)` is more efficient. It avoids the overhead of the
counting and testing if the ceiling is reached. It returns all the cycles of the
directed graph if the `ceiling` is not reached, a subset of them otherwise.

To get an idea of the possible number of cycles, use function
`maxsimplecycles(dg::DiGraph, byscc::Bool = true) on the directed graph.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007)
"""
function simplecycles_iter end
@traitfn function simplecycles_iter(
    dg::AG::IsDirected, ceiling=10^6
) where {T,AG<:AbstractGraph{T}}
    return collect(
        Iterators.take(Channel(c -> itercycles(dg, c); ctype=Vector{T}), ceiling)
    )::Vector{Vector{T}}
end

"""
    simplecycleslength(dg::DiGraph, ceiling = 10^6)

Search all cycles of the given directed graph, using Johnson's algorithm,
and return a tuple representing the cycle length and the number of cycles.

### Implementation Notes
To get an idea of the possible number of cycles, using function
`maxsimplecycles(dg::DiGraph, byscc::Bool = true)` on the directed graph.

If the `ceiling` is reached (`ncycles = ceiling`), the output is only
a subset of the cycles lengths.

### References
- [Johnson](http://epubs.siam.org/doi/abs/10.1137/0204007)

# Examples
```jldoctest
julia> using Graphs

julia> simplecycleslength(complete_digraph(16))
([0, 1, 1, 1, 1, 1, 2, 10, 73, 511, 3066, 15329, 61313, 183939, 367876, 367876], 1000000)

julia> simplecycleslength(wheel_digraph(16))
([0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0], 1)
```
"""
function simplecycleslength end
@traitfn function simplecycleslength(
    dg::AG::IsDirected, ceiling=10^6
) where {T,AG<:AbstractGraph{T}}
    ncycles = 0
    cyclelength = zeros(Int, nv(dg))
    for cycle in Iterators.take(
        Channel(c -> itercycles(dg, c); ctype=Vector{T})::Channel{Vector{T}}, ceiling
    )
        cyclelength[length(cycle)] += 1
        ncycles += 1
    end
    return cyclelength, ncycles
end

@testset "squash" begin
    @testset "$g_in, kwargs=$kwargs" for kwargs in
                                         [(), (alwayscopy=false,), (alwayscopy=true,)],
        (g_in, g_expected) in [
            (SimpleGraph{Int64}(), SimpleGraph{Int8}()),
            (
                SimpleDiGraph{UInt8}(),
                if kwargs == (alwayscopy=false,)
                    SimpleDiGraph{UInt8}()
                else
                    SimpleDiGraph{Int8}()
                end,
            ),
            (path_graph(Int16(126)), path_graph(Int8(126))),
            (path_digraph(Int16(127)), path_digraph(UInt8(127))),
            (path_graph(Int16(254)), path_graph(UInt8(254))),
            (path_digraph(Int16(255)), path_digraph(Int16(255))),
            (
                path_graph(UInt16(255)),
                if kwargs == (alwayscopy=false,)
                    path_graph(UInt16(255))
                else
                    path_graph(Int16(255))
                end,
            ),
            (star_graph(Int16(32766)), star_graph(Int16(32766))),
            (star_digraph(Int32(32767)), star_digraph(UInt16(32767))),
            (cycle_graph(Int128(123)), cycle_graph(Int8(123))),
        ]

        g_actual = squash(g_in; kwargs...)
        @test typeof(g_actual) === typeof(g_expected)
        @test g_actual == g_expected
        if kwargs == (alwayscopy=false,) && typeof(g_in) === typeof(g_actual)
            @test g_in === g_actual
        end
    end
end

# Karp, R. M.
# A characterization of the minimum cycle mean in a digraph
# Discrete Mathematics, 1978, 23, 309 - 311
function _karp_minimum_cycle_mean(
    g::AbstractGraph, distmx::AbstractMatrix{T}, component::Vector{U}
) where {T<:Number} where {U<:Integer}
    v2j = Dict{U,Int}()
    for (j, v) in enumerate(component)
        v2j[v] = j
    end
    n = length(component)
    F = fill(Inf, n + 1, n)
    F[1, 1] = 0.0
    for i in 2:(n + 1)
        for (j, v) in enumerate(component)
            for u in inneighbors(g, v)
                k = get(v2j, u, 0)
                if !iszero(k)
                    F[i, j] = min(F[i, j], F[i - 1, k] + distmx[u, v])
                end
            end
        end
    end

    # Extracting the cycle of minimal mean is not explained in Karp's paper.
    # Let
    # V* = argmin_v max_k (F_n(v) - F_k(v)) / (n - k)
    # Intuitively, one would think that it can be found by walking backward
    # using the F matrix starting from a vertex v ∈ V*.
    # However, it may not work as shown by the example in the tests.
    #
    # Fortunately, one can show that it works if we pick the v ∈ argmin_{v ∈ V*} F_n(v)
    # Indeed, suppose we walk backward and find v_0, ..., v_n=v.
    # Since there are n+1 nodes, there must be a cycle.
    # If the cycle is not of minimum cycle mean, then if we remove this cycle
    # and appends nodes of one of the cycle of minimum cycle mean containing v such that
    # the length is again n+1, we get a new walk of length n+1 ending at a node v' of the cycle.
    # Moreover, we know that v' ∈ V* and F_n(v') < F_n(v). Therefore if v minimizes F_n(v) among the nodes of V*, this cannot happen.

    # Find jbest ∈ V*
    λmin = Inf
    jbest = 0

    for j in 1:n
        λ = maximum(map(i -> (F[n + 1, j] - F[i, j]) / (n + 1 - i), 1:n))
        if λ < λmin || (isfinite(λ) && λ ≈ λmin && F[n + 1, j] < F[n + 1, jbest])
            λmin = λ
            jbest = j
        end
    end

    iszero(jbest) && return U[], Inf

    # Backward walk from jbest
    walk = zeros(Int, n + 1)
    walk[n + 1] = jbest
    for i in n:-1:1
        v = component[walk[i + 1]]
        dmin = Inf
        for u in inneighbors(g, v)
            j = get(v2j, u, 0)
            if !iszero(j)
                dcur = F[i, j] + distmx[u, v]
                if dcur < dmin
                    walk[i] = j
                    dmin = dcur
                end
            end
        end
    end

    # Extract cycle in the walk
    invmap = zeros(Int, n)
    I = 1:0
    for i in (n + 1):-1:1
        if iszero(invmap[walk[i]])
            invmap[walk[i]] = i
        else
            I = (i + 1):invmap[walk[i]]
            break
        end
    end
    return component[walk[I]], λmin
end

"""
    karp_minimum_cycle_mean(g[, distmx])

Return minimum cycle mean of the directed graph `g` with optional edge weights contained in `distmx`.

### References
- [Karp](http://dx.doi.org/10.1016/0012-365X(78)90011-0).
"""
function karp_minimum_cycle_mean end
@traitfn function karp_minimum_cycle_mean(
    g::::IsDirected, distmx::AbstractMatrix=weights(g)
)
    cycle = Int[]
    λmin = Inf
    for component in strongly_connected_components(g)
        c, λ = _karp_minimum_cycle_mean(g, distmx, component)
        if λ < λmin
            cycle = c
            λmin = λ
        end
    end
    return cycle, λmin
end

"""
    is_tree(g)

Returns true if g is a tree: that is, a simple, connected undirected graph, with nv-1 edges (nv = number of vertices). Trees are the minimal connected graphs; equivalently they have no cycles.  

This function does not apply to directed graphs. Directed trees are sometimes called [polytrees](https://en.wikipedia.org/wiki/Polytree)). 

"""
function is_tree end

@traitfn function is_tree(g::::(!IsDirected))
    return ne(g) == nv(g) - 1 && is_connected(g)
end

function _is_prufer(c::AbstractVector{T}) where {T<:Integer}
    return isempty(c) || (minimum(c) >= 1 && maximum(c) <= length(c) + 2)
end

function _degree_from_prufer(c::Vector{T})::Vector{T} where {T<:Integer}
    """
    Degree sequence from Prüfer code.
    Returns d such that d[i] = 1 + number of occurences of i in c
    """
    n = length(c) + 2
    d = ones(T, n)
    for value in c
        d[value] += 1
    end
    return d
end

"""
    prufer_decode(code)

Returns the unique tree associated with the given (Prüfer) code. 
Each tree of size n is associated with a Prüfer sequence (a[1], ..., a[n-2]) with 1 ⩽ a[i] ⩽ n. The sequence is constructed recursively by the leaf removal algoritm. At step k, the leaf with smallest index is removed and its unique neighbor is added to the Prüfer sequence, giving a[k]. The decoding algorithm goes backward.  The tree associated with the empty sequence is the 2-vertices tree with one edge.
Ref: [Prüfer sequence on Wikipedia](https://en.wikipedia.org/wiki/Pr%C3%BCfer_sequence)

"""
function prufer_decode(code::AbstractVector{T})::SimpleGraph{T} where {T<:Integer}
    !_is_prufer(code) && throw(
        ArgumentError("The code must have one dimension and must be a Prüfer sequence. "),
    )
    isempty(code) && return path_graph(T(2)) # the empty Prüfer sequence codes for the one-edge tree

    n = length(code) + 2
    d = _degree_from_prufer(code)
    L = BinaryMinHeap{T}(findall(==(1), d))
    g = Graph{T}(n, 0)

    for i in 1:(n - 2)
        l = pop!(L) # extract leaf with priority rule (max)
        d[l] -= 1 # update degree sequence
        add_edge!(g, l, code[i]) # add edge
        d[code[i]] -= 1 # update degree sequence
        d[code[i]] == 1 && push!(L, code[i]) # add new leaf if any
    end

    add_edge!(g, pop!(L), pop!(L)) # add last leaf

    return g
end

"""
    prufer_encode(g::SimpleGraph)

Given a tree (a connected minimal undirected graph) of size n⩾3, returns the unique Prüfer sequence associated with this tree. 

Each tree of size n ⩾ 2 is associated with a Prüfer sequence (a[1], ..., a[n-2]) with 1 ⩽ a[i] ⩽ n. The sequence is constructed recursively by the leaf removal algoritm. At step k, the leaf with smallest index is removed and its unique neighbor is added to the Prüfer sequence, giving a[k]. The Prüfer sequence of the tree with only one edge is the empty sequence. 

Ref: [Prüfer sequence on Wikipedia](https://en.wikipedia.org/wiki/Pr%C3%BCfer_sequence)

"""
function prufer_encode(G::SimpleGraph{T})::Vector{T} where {T<:Integer}
    (nv(G) < 2 || !is_tree(G)) &&
        throw(ArgumentError("The graph must be a tree with n ⩾ 2 vertices. "))

    n = nv(G)
    n == 2 && return Vector{T}() # empty Prüfer sequence 
    g = copy(G)
    code = zeros(T, n - 2)
    d = degree(g)
    L = BinaryMinHeap(findall(==(1), d))

    for i in 1:(n - 2)
        u = pop!(L)
        v = neighbors(g, u)[1]
        rem_edge!(g, u, v)
        d[u] -= 1
        d[v] -= 1
        d[v] == 1 && push!(L, v)
        code[i] = v
    end

    return code
end

@testset "Maximal Independent Set" begin
    rng = StableRNG(1)

    g0 = SimpleGraph(0)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g0)
            z = @inferred(
                Parallel.independent_set(
                    g, 4, MaximalIndependentSet(); parallel=parallel, rng=rng
                )
            )
            @test isempty(z)
        end
    end

    g1 = SimpleGraph(1)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g1)
            z = @inferred(
                Parallel.independent_set(
                    g, 4, MaximalIndependentSet(); parallel=parallel, rng=rng
                )
            )
            @test (z == [1])
        end
    end

    add_edge!(g1, 1, 1)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g1)
            z = @inferred(
                Parallel.independent_set(
                    g, 4, MaximalIndependentSet(); parallel=parallel, rng=rng
                )
            )
            isempty(z)
        end
    end

    g3 = star_graph(5)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g3)
            z = @inferred(
                Parallel.independent_set(
                    g, 4, MaximalIndependentSet(); parallel=parallel, rng=rng
                )
            )
            @test (length(z) == 1 || length(z) == 4)
        end
    end

    g4 = complete_graph(5)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g4)
            z = @inferred(
                Parallel.independent_set(
                    g, 4, MaximalIndependentSet(); parallel=parallel, rng=rng
                )
            )
            @test length(z) == 1 # Exactly one vertex
        end
    end

    g5 = path_graph(5)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g5)
            z = @inferred(
                Parallel.independent_set(
                    g, 4, MaximalIndependentSet(); parallel=parallel, rng=rng
                )
            )
            sort!(z)
            @test (z == [2, 4] || z == [2, 5] || z == [1, 3, 5] || z == [1, 4])
        end
    end

    add_edge!(g5, 2, 2)
    add_edge!(g5, 3, 3)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g5)
            z = @inferred(
                Parallel.independent_set(
                    g, 4, MaximalIndependentSet(); parallel=parallel, rng=rng
                )
            )
            sort!(z)
            @test (z == [4] || z == [5] || z == [1, 5] || z == [1, 4])
        end
    end
end

@testset "Degree Vertex Cover" begin
    g3 = star_graph(5)
    for g in testgraphs(g3)
        c = @inferred(vertex_cover(g, DegreeVertexCover()))
        @test c == [1]
    end

    g4 = complete_graph(5)
    for g in testgraphs(g4)
        c = @inferred(vertex_cover(g, DegreeVertexCover()))
        @test length(c) == 4 #All except one vertex
    end

    # path_graph(5) with additional edge 2-5
    g5 = Graph([0 1 0 0 0; 1 0 1 0 1; 0 1 0 1 0; 0 0 1 0 1; 0 1 0 1 0])
    for g in testgraphs(g5)
        c = @inferred(vertex_cover(g, DegreeVertexCover()))
        @test sort(c) == [2, 4]
    end
end

function betweenness_centrality(
    g::AbstractGraph,
    vs=vertices(g),
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    endpoints=false,
    parallel=:threads,
)
    return if parallel == :distributed
        distr_betweenness_centrality(
            g, vs, distmx; normalize=normalize, endpoints=endpoints
        )
    else
        threaded_betweenness_centrality(
            g, vs, distmx; normalize=normalize, endpoints=endpoints
        )
    end
end

function betweenness_centrality(
    g::AbstractGraph,
    k::Integer,
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    endpoints=false,
    parallel=:threads,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    samples = sample(vertices(g), k; rng=rng, seed=seed)
    return if parallel == :distributed
        distr_betweenness_centrality(
            g, samples, distmx; normalize=normalize, endpoints=endpoints
        )
    else
        threaded_betweenness_centrality(
            g, samples, distmx; normalize=normalize, endpoints=endpoints
        )
    end
end

function distr_betweenness_centrality(args...; kwargs...)
    return error(
        "`parallel = :distributed` requested, but SharedArrays or Distributed is not loaded"
    )
end

function distr_betweenness_centrality(
    g::AbstractGraph,
    k::Integer,
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    endpoints=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    samples = sample(vertices(g), k; rng=rng, seed=seed)
    return distr_betweenness_centrality(
        g, samples, distmx; normalize=normalize, endpoints=endpoints
    )
end

function threaded_betweenness_centrality(
    g::AbstractGraph,
    vs=vertices(g),
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    endpoints=false,
)::Vector{Float64}
    n_v = nv(g)
    k = length(vs)
    isdir = is_directed(g)

    vs_active = findall((x) -> degree(g, x) > 0, vs) # 0 might be 1?
    k_active = length(vs_active)
    d, r = divrem(k_active, Threads.nthreads())
    ntasks = d == 0 ? r : Threads.nthreads()
    local_betweenness = [zeros(n_v) for _ in 1:ntasks]
    task_size = cld(k_active, ntasks)

    @sync for (t, task_range) in enumerate(Iterators.partition(1:k_active, task_size))
        Threads.@spawn for s in @view(vs_active[task_range])
            state = Graphs.dijkstra_shortest_paths(
                g, s, distmx; allpaths=true, trackvertices=true
            )
            if endpoints
                Graphs._accumulate_endpoints!(local_betweenness[t], state, g, s)
            else
                Graphs._accumulate_basic!(local_betweenness[t], state, g, s)
            end
        end
    end
    betweenness = reduce(+, local_betweenness)
    Graphs._rescale!(betweenness, n_v, normalize, isdir, k)

    return betweenness
end

function threaded_betweenness_centrality(
    g::AbstractGraph,
    k::Integer,
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    endpoints=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    samples = sample(vertices(g), k; rng=rng, seed=seed)
    return threaded_betweenness_centrality(
        g, samples, distmx; normalize=normalize, endpoints=endpoints
    )
end

"""
    ReverseView{T<:Integer,G<:AbstractGraph} <: AbstractGraph{T}

A graph view that wraps a directed graph and reverse the direction of every edge.

!!! warning
    Some properties of the view (e.g. the number of edges) are forwarded from the
    underlying graph and are not recomputed. Modifying the underlying graph after
    constructing the view may lead to incorrect results.

# Examples
```jldoctest; filter = r"0-element Graphs\\.FrozenVector\\{Int64\\}|Int64\\[\\]"
julia> using Graphs

julia> g = SimpleDiGraph(2);

julia> add_edge!(g, 1, 2);

julia> rg = ReverseView(g);

julia> neighbors(rg, 1)
0-element Graphs.FrozenVector{Int64}

julia> neighbors(rg, 2)
1-element Graphs.FrozenVector{Int64}:
 1
```
"""
struct ReverseView{T<:Integer,G<:AbstractGraph} <: AbstractGraph{T}
    g::G

    @traitfn ReverseView{T,G}(g::::(IsDirected)) where {T<:Integer,G<:AbstractGraph{T}} = new(
        g
    )
    @traitfn ReverseView{T,G}(g::::(!IsDirected)) where {T<:Integer,G<:AbstractGraph{T}} = throw(
        ArgumentError("Your graph needs to be directed")
    )
end

ReverseView(g::G) where {T<:Integer,G<:AbstractGraph{T}} = ReverseView{T,G}(g)

wrapped_graph(g::ReverseView) = g.g

Graphs.is_directed(::ReverseView{T,G}) where {T,G} = true
Graphs.is_directed(::Type{<:ReverseView{T,G}}) where {T,G} = true

Graphs.edgetype(g::ReverseView) = Graphs.edgetype(g.g)
Graphs.has_vertex(g::ReverseView, v) = Graphs.has_vertex(g.g, v)
Graphs.ne(g::ReverseView) = Graphs.ne(g.g)
Graphs.nv(g::ReverseView) = Graphs.nv(g.g)
Graphs.vertices(g::ReverseView) = Graphs.vertices(g.g)
Graphs.edges(g::ReverseView) = (reverse(e) for e in Graphs.edges(g.g))
Graphs.has_edge(g::ReverseView, s, d) = Graphs.has_edge(g.g, d, s)
Graphs.inneighbors(g::ReverseView, v) = Graphs.outneighbors(g.g, v)
Graphs.outneighbors(g::ReverseView, v) = Graphs.inneighbors(g.g, v)

"""
    UndirectedView{T<:Integer,G<:AbstractGraph} <: AbstractGraph{T}

A graph view that wraps a directed graph and consider every edge as undirected.

!!! warning
    Some properties of the view, such as the number of edges, are cached at
    construction time. Modifying the underlying graph after constructing the view
    will lead to incorrect results.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph(2);

julia> add_edge!(g, 1, 2);

julia> ug = UndirectedView(g);

julia> neighbors(ug, 1)
1-element Vector{Int64}:
 2

julia> neighbors(ug, 2)
1-element Vector{Int64}:
 1
```
"""
struct UndirectedView{T<:Integer,G<:AbstractGraph} <: AbstractGraph{T}
    g::G
    ne::Int
    @traitfn function UndirectedView{T,G}(
        g::::(IsDirected)
    ) where {T<:Integer,G<:AbstractGraph{T}}
        ne = count(e -> src(e) <= dst(e) || !has_edge(g, dst(e), src(e)), Graphs.edges(g))
        return new(g, ne)
    end

    @traitfn UndirectedView{T,G}(g::::(!IsDirected)) where {T<:Integer,G<:AbstractGraph{T}} = throw(
        ArgumentError("Your graph needs to be directed")
    )
end

UndirectedView(g::G) where {T<:Integer,G<:AbstractGraph{T}} = UndirectedView{T,G}(g)

"""
    wrapped_graph(g)

Return the graph wrapped by `g`
"""
function wrapped_graph end

wrapped_graph(g::UndirectedView) = g.g

Graphs.is_directed(::UndirectedView) = false
Graphs.is_directed(::Type{<:UndirectedView}) = false

Graphs.edgetype(g::UndirectedView) = Graphs.edgetype(g.g)
Graphs.has_vertex(g::UndirectedView, v) = Graphs.has_vertex(g.g, v)
Graphs.ne(g::UndirectedView) = g.ne
Graphs.nv(g::UndirectedView) = Graphs.nv(g.g)
Graphs.vertices(g::UndirectedView) = Graphs.vertices(g.g)
function Graphs.has_edge(g::UndirectedView, s, d)
    return Graphs.has_edge(g.g, s, d) || Graphs.has_edge(g.g, d, s)
end
Graphs.inneighbors(g::UndirectedView, v) = Graphs.all_neighbors(g.g, v)
Graphs.outneighbors(g::UndirectedView, v) = Graphs.all_neighbors(g.g, v)
function Graphs.edges(g::UndirectedView)
    return (
        begin
            (u, v) = src(e), dst(e)
            if (v < u)
                (u, v) = (v, u)
            end
            Edge(u, v)
        end for
        e in Graphs.edges(g.g) if (src(e) <= dst(e) || !has_edge(g.g, dst(e), src(e)))
    )
end

function pagerank(g::AbstractGraph{U}, α=0.85, n=100::Integer, ϵ=1.0e-6) where {U<:Integer}

    # indegree(g, v) is estimated run-time to iterate over inneighbors(g, v)
    partitions = Graphs.optimal_contiguous_partition(indegree(g), nthreads(), nv(g))

    α_div_outdegree = Vector{Float64}(undef, nv(g))
    dangling_nodes = Vector{U}()
    @inbounds for v in vertices(g)
        if outdegree(g, v) == 0
            push!(dangling_nodes, v)
        end
        α_div_outdegree[v] = (α / outdegree(g, v))
    end

    nvg = Int(nv(g))
    # solution vector and temporary vector
    x = fill(1.0 / nvg, nvg)
    xlast = copy(x)
    @inbounds for _ in 1:n
        dangling_sum = 0.0
        for v in dangling_nodes
            dangling_sum += x[v]
        end
        # flow from teleprotation
        y = (1 - α + α * dangling_sum) * (1.0 / nvg)
        xlast .= y
        # flow from edges
        let x = x
            @threads for v_set in partitions
                for v in v_set
                    for u in inneighbors(g, v)
                        xlast[v] += (x[u] * α_div_outdegree[u])
                    end
                end
            end
        end

        # l1 change in solution convergence criterion
        err = 0.0
        for v in vertices(g)
            err += abs(xlast[v] - x[v])
            x[v] = xlast[v]
        end
        if (err < nvg * ϵ)
            return x
        end
    end
    return error("Pagerank did not converge after $n iterations.") # TODO 0.7: change to InexactError with appropriate msg.
end

@testset "Connectivity" begin
    g6 = smallgraph(:house)
    gx = path_graph(4)
    add_vertices!(gx, 10)
    add_edge!(gx, 5, 6)
    add_edge!(gx, 6, 7)
    add_edge!(gx, 8, 9)
    add_edge!(gx, 10, 9)

    for g in test_generic_graphs(gx)
        @test @inferred(!is_connected(g))
        cc = @inferred(connected_components(g))
        label = zeros(eltype(g), nv(g))
        @inferred(Graphs.connected_components!(label, g))
        @test label[1:10] == [1, 1, 1, 1, 5, 5, 5, 8, 8, 8]
        import Graphs: components, components_dict
        cclab = @inferred(components_dict(label))
        @test cclab[1] == [1, 2, 3, 4]
        @test cclab[5] == [5, 6, 7]
        @test cclab[8] == [8, 9, 10]
        @test length(cc) >= 3 && sort(cc[3]) == [8, 9, 10]
    end
    for g in test_generic_graphs(g6)
        @test @inferred(is_connected(g))
    end

    g10 = SimpleDiGraph(4)
    add_edge!(g10, 1, 3)
    add_edge!(g10, 2, 4)
    for g in test_generic_graphs(g10)
        @test @inferred(is_bipartite(g))
    end
    add_edge!(g10, 1, 4)
    for g in test_generic_graphs(g10)
        @test @inferred(is_bipartite(g))
    end

    g10 = SimpleDiGraph(20)
    for g in testdigraphs(g10)
        for m in 1:50
            i = rand(1:10)
            j = rand(11:20)
            if rand() < 0.5
                i, j = j, i
            end
            if !has_edge(g, i, j)
                add_edge!(g, i, j)
                @test @inferred(is_bipartite(GenericDiGraph(g)))
            end
        end
    end

    # graph from https://en.wikipedia.org/wiki/Strongly_connected_component
    h = SimpleDiGraph(8)
    add_edge!(h, 1, 2)
    add_edge!(h, 2, 3)
    add_edge!(h, 2, 5)
    add_edge!(h, 2, 6)
    add_edge!(h, 3, 4)
    add_edge!(h, 3, 7)
    add_edge!(h, 4, 3)
    add_edge!(h, 4, 8)
    add_edge!(h, 5, 1)
    add_edge!(h, 5, 6)
    add_edge!(h, 6, 7)
    add_edge!(h, 7, 6)
    add_edge!(h, 8, 4)
    add_edge!(h, 8, 7)
    for g in test_generic_graphs(h)
        @test @inferred(is_weakly_connected(g))
        scc = @inferred(strongly_connected_components(g))
        scc_k = @inferred(strongly_connected_components_kosaraju(g))
        wcc = @inferred(weakly_connected_components(g))

        @test length(scc) == 3 && sort(scc[3]) == [1, 2, 5]
        @test length(scc_k) == 3 && sort(scc_k[1]) == [1, 2, 5]
        @test length(wcc) == 1 && length(wcc[1]) == nv(g)
    end

    function scc_ok(graph::GenericDiGraph)
        # Check that all SCC really are strongly connected

        # TODO it might be better if we did not have to unwrap the GenericDiGraph
        # (and we somehow might prevent this in the future) but currently the methods
        # used in this utility test function do not work with GenericDiGraph yet.
        graph = graph.g

        scc = @inferred(strongly_connected_components(graph))
        scc_as_subgraphs = map(i -> graph[i], scc)
        return all(is_strongly_connected, scc_as_subgraphs)
    end

    function scc_k_ok(graph::GenericDiGraph)
        # Check that all SCC really are strongly connected

        # TODO it might be better if we did not have to unwrap the GenericDiGraph
        # (and we somehow might prevent this in the future) but currently the methods
        # used in this utility test function do not work with GenericDiGraph yet.
        graph = graph.g

        scc_k = @inferred(strongly_connected_components_kosaraju(graph))
        scc_k_as_subgraphs = map(i -> graph[i], scc_k)
        return all(is_strongly_connected, scc_k_as_subgraphs)
    end

    # the two graphs below are isomorphic (exchange 2 <--> 4)
    h = SimpleDiGraph(4)
    add_edge!(h, 1, 4)
    add_edge!(h, 4, 2)
    add_edge!(h, 2, 3)
    add_edge!(h, 1, 3)
    for g in test_generic_graphs(h)
        @test scc_ok(g)
        @test scc_k_ok(g)
    end

    h2 = SimpleDiGraph(4)
    add_edge!(h2, 1, 2)
    add_edge!(h2, 2, 4)
    add_edge!(h2, 4, 3)
    add_edge!(h2, 1, 3)
    for g in test_generic_graphs(h2)
        @test scc_ok(g)
        @test scc_k_ok(g)
    end

    # Test case for empty graph
    h = SimpleDiGraph(0)
    for g in test_generic_graphs(h)
        scc = @inferred(strongly_connected_components(g))
        scc_k = @inferred(strongly_connected_components_kosaraju(g))
        @test length(scc) == 0
        @test length(scc_k) == 0
    end

    # Test case for graph with one vertex
    h = SimpleDiGraph(1)
    for g in test_generic_graphs(h)
        scc = @inferred(strongly_connected_components(g))
        scc_k = @inferred(strongly_connected_components_kosaraju(g))
        @test length(scc) == 1 && scc[1] == [1]
        @test length(scc_k) == 1 && scc[1] == [1]
    end

    # Test case for graph with self loops
    h = SimpleDiGraph(3)
    add_edge!(h, 1, 1)
    add_edge!(h, 2, 2)
    add_edge!(h, 3, 3)
    add_edge!(h, 1, 2)
    add_edge!(h, 2, 3)
    add_edge!(h, 2, 1)

    for g in test_generic_graphs(h)
        scc = @inferred(strongly_connected_components(g))
        scc_k = @inferred(strongly_connected_components_kosaraju(g))
        @test length(scc) == 2
        @test sort(scc[1]) == [3]
        @test sort(scc[2]) == [1, 2]

        @test length(scc_k) == 2
        @test sort(scc_k[1]) == [1, 2]
        @test sort(scc_k[2]) == [3]
    end

    h = SimpleDiGraph(6)
    add_edge!(h, 1, 3)
    add_edge!(h, 3, 4)
    add_edge!(h, 4, 2)
    add_edge!(h, 2, 1)
    add_edge!(h, 3, 5)
    add_edge!(h, 5, 6)
    add_edge!(h, 6, 4)
    for g in test_generic_graphs(h)
        scc = @inferred(strongly_connected_components(g))
        scc_k = @inferred(strongly_connected_components_kosaraju(g))
        @test length(scc) == 1 && sort(scc[1]) == [1:6;]
        @test length(scc_k) == 1 && sort(scc_k[1]) == [1:6;]
    end
    # tests from Graphs.jl
    h = SimpleDiGraph(4)
    add_edge!(h, 1, 2)
    add_edge!(h, 2, 3)
    add_edge!(h, 3, 1)
    add_edge!(h, 4, 1)
    for g in test_generic_graphs(h)
        scc = @inferred(strongly_connected_components(g))
        scc_k = @inferred(strongly_connected_components_kosaraju(g))
        @test length(scc) == 2 && sort(scc[1]) == [1:3;] && sort(scc[2]) == [4]
        @test length(scc_k) == 2 && sort(scc_k[2]) == [1:3;] && sort(scc_k[1]) == [4]
    end

    h = SimpleDiGraph(12)
    add_edge!(h, 1, 2)
    add_edge!(h, 2, 3)
    add_edge!(h, 2, 4)
    add_edge!(h, 2, 5)
    add_edge!(h, 3, 6)
    add_edge!(h, 4, 5)
    add_edge!(h, 4, 7)
    add_edge!(h, 5, 2)
    add_edge!(h, 5, 6)
    add_edge!(h, 5, 7)
    add_edge!(h, 6, 3)
    add_edge!(h, 6, 8)
    add_edge!(h, 7, 8)
    add_edge!(h, 7, 10)
    add_edge!(h, 8, 7)
    add_edge!(h, 9, 7)
    add_edge!(h, 10, 9)
    add_edge!(h, 10, 11)
    add_edge!(h, 11, 12)
    add_edge!(h, 12, 10)

    for g in test_generic_graphs(h)
        scc = @inferred(strongly_connected_components(g))
        scc_k = @inferred(strongly_connected_components_kosaraju(g))
        @test length(scc) == 4
        @test sort(scc[1]) == [7, 8, 9, 10, 11, 12]
        @test sort(scc[2]) == [3, 6]
        @test sort(scc[3]) == [2, 4, 5]
        @test scc[4] == [1]

        @test length(scc_k) == 4
        @test sort(scc_k[1]) == [1]
        @test sort(scc_k[2]) == [2, 4, 5]
        @test sort(scc_k[3]) == [3, 6]
        @test sort(scc_k[4]) == [7, 8, 9, 10, 11, 12]
    end

    # Test examples with self-loops from
    # Graph-Theoretic Analysis of Finite Markov Chains by J.P. Jarvis & D. R. Shier

    # figure 1 example
    fig1 = spzeros(5, 5)
    fig1[[3, 4, 9, 10, 11, 13, 18, 19, 22, 24]] = [
        0.5, 0.4, 0.1, 1.0, 1.0, 0.2, 0.3, 0.2, 1.0, 0.3
    ]
    fig1 = GenericDiGraph(SimpleDiGraph(fig1))
    scc_fig1 = Vector[[2, 5], [1, 3, 4]]

    # figure 2 example
    fig2 = spzeros(5, 5)
    fig2[[3, 10, 11, 13, 14, 17, 18, 19, 22]] .= 1
    fig2 = GenericDiGraph(SimpleDiGraph(fig2))

    # figure 3 example
    fig3 = spzeros(8, 8)
    fig3[[
        1, 7, 9, 13, 14, 15, 18, 20, 23, 27, 28, 31, 33, 34, 37, 45, 46, 49, 57, 63, 64
    ]] .= 1
    fig3 = GenericDiGraph(SimpleDiGraph(fig3))
    scc_fig3 = Vector[[3, 4], [2, 5, 6], [8], [1, 7]]
    fig3_cond = SimpleDiGraph(4)
    add_edge!(fig3_cond, 4, 3)
    add_edge!(fig3_cond, 2, 1)
    add_edge!(fig3_cond, 4, 1)
    add_edge!(fig3_cond, 4, 2)
    fig3_cond

    # construct a n-number edge ring graph (period = n)
    n = 10
    n_ring = cycle_digraph(n)
    n_ring_shortcut = copy(n_ring)
    add_edge!(n_ring_shortcut, 1, 4)
    n_ring = GenericDiGraph(n_ring)
    n_ring_shortcut = GenericDiGraph(n_ring_shortcut)

    # figure 8 example
    fig8 = spzeros(6, 6)
    fig8[[2, 10, 13, 21, 24, 27, 35]] .= 1
    fig8 = GenericDiGraph(SimpleDiGraph(fig8))

    @test Set(@inferred(strongly_connected_components(fig1))) == Set(scc_fig1)
    @test Set(@inferred(strongly_connected_components(fig3))) == Set(scc_fig3)

    @test @inferred(period(n_ring)) == n
    @test @inferred(period(n_ring_shortcut)) == 2

    # TODO condensation currently returns a SimpleDiGraph, even if the input graph
    # is a GenericDiGraph, so we compare with a SimpleDiGraph in this test,
    # but one should think, if the condensation should not also be a GenericDiGraph
    @test @inferred(condensation(fig3)) == fig3_cond

    @test @inferred(attracting_components(fig1)) == Vector[[2, 5]]
    @test @inferred(attracting_components(fig3)) == Vector[[3, 4], [8]]

    g10dists = ones(10, 10)
    g10dists[1, 2] = 10.0
    g10 = star_graph(10)
    for g in test_generic_graphs(g10)
        @test @inferred(neighborhood_dists(g, 1, 0)) == [(1, 0)]
        @test length(@inferred(neighborhood(g, 1, 1))) == 10
        @test length(@inferred(neighborhood(g, 1, 1, g10dists))) == 9
        @test length(@inferred(neighborhood(g, 2, 1))) == 2
        @test length(@inferred(neighborhood(g, 1, 2))) == 10
        @test length(@inferred(neighborhood(g, 2, 2))) == 10
        @test length(@inferred(neighborhood(g, 2, -1))) == 0
    end
    g10 = star_digraph(10)
    for g in test_generic_graphs(g10)
        @test @inferred(neighborhood_dists(g, 1, 0, dir=:out)) == [(1, 0)]
        @test length(@inferred(neighborhood(g, 1, 1, dir=:out))) == 10
        @test length(@inferred(neighborhood(g, 1, 1, g10dists, dir=:out))) == 9
        @test length(@inferred(neighborhood(g, 2, 1, dir=:out))) == 1
        @test length(@inferred(neighborhood(g, 1, 2, dir=:out))) == 10
        @test length(@inferred(neighborhood(g, 2, 2, dir=:out))) == 1
        @test @inferred(neighborhood_dists(g, 1, 0, dir=:in)) == [(1, 0)]
        @test length(@inferred(neighborhood(g, 1, 1, dir=:in))) == 1
        @test length(@inferred(neighborhood(g, 2, 1, dir=:in))) == 2
        @test length(@inferred(neighborhood(g, 2, 1, g10dists, dir=:in))) == 2
        @test length(@inferred(neighborhood(g, 1, 2, dir=:in))) == 1
        @test length(@inferred(neighborhood(g, 2, 2, dir=:in))) == 2
    end
    @test @inferred(!isgraphical([1, 1, 1]))
    @test @inferred(isgraphical([2, 2, 2]))
    @test @inferred(isgraphical(fill(3, 10)))
    @test @inferred(isgraphical(Integer[]))
    @test @inferred(!isgraphical([4, 2, 2, 2, 0]))
    ##@test !@inferred(isgraphical([2]))

    # Test simple digraphicality
    sdg = GenericDiGraph(SimpleDiGraph(10, 90))
    @test @inferred(isdigraphical(indegree(sdg), outdegree(sdg)))
    @test !@inferred(isdigraphical([1, 1, 1], [1, 1, 0]))
    @test @inferred(isdigraphical(Integer[], Integer[]))
    #@test !@inferred(isdigraphical([1], [1]))
    # Self loops should be excluded
    @test !@inferred(isdigraphical([1], [1]))
    @test !@inferred(isdigraphical([1, 0], [1, 0]))
    # Multi edges should be excluded
    @test !@inferred(isdigraphical([5], [5]))

    # 1116
    gc = cycle_graph(4)
    for g in test_generic_graphs(gc)
        z = @inferred(neighborhood(g, 3, 3))
        @test (z == [3, 2, 4, 1] || z == [3, 4, 2, 1])
    end

    gd = SimpleDiGraph([0 1 1 0; 0 0 0 1; 0 0 0 1; 0 0 0 0])
    add_edge!(gd, 1, 4)
    for g in test_generic_graphs(gd)
        z = @inferred(neighborhood_dists(g, 1, 4))
        @test (4, 1) ∈ z
        @test (4, 2) ∉ z
    end
end

"""
    randomwalk(g, s, niter; rng=nothing, seed=nothing)

Perform a random walk on graph `g` starting at vertex `s` and continuing for
a maximum of `niter` steps. Return a vector of vertices visited in order.
"""
function randomwalk(
    g::AG,
    s::Integer,
    niter::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {AG<:AbstractGraph{T}} where {T}
    s in vertices(g) || throw(BoundsError())
    rng = rng_from_rng_or_seed(rng, seed)
    visited = Vector{T}()
    sizehint!(visited, niter)
    currs = s
    i = 1
    while i <= niter
        push!(visited, currs)
        i += 1
        nbrs = outneighbors(g, currs)
        length(nbrs) == 0 && break
        currs = rand(rng, nbrs)
    end
    return visited[1:(i - 1)]
end

"""
    non_backtracking_randomwalk(g, s, niter; rng=nothing, seed=nothing)

Perform a non-backtracking random walk on directed graph `g` starting at
vertex `s` and continuing for a maximum of `niter` steps. Return a
vector of vertices visited in order.
"""
function non_backtracking_randomwalk end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function non_backtracking_randomwalk(
    g::AG::(!IsDirected),
    s::Integer,
    niter::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T,AG<:AbstractGraph{T}}
    s in vertices(g) || throw(BoundsError())
    rng = rng_from_rng_or_seed(rng, seed)
    visited = Vector{T}()
    sizehint!(visited, niter)
    currs = s
    prev = -1
    i = 1

    push!(visited, currs)
    i += 1
    nbrs = outneighbors(g, currs)
    length(nbrs) == 0 && return visited[1:(i - 1)]
    prev = currs
    currs = rand(rng, nbrs)

    while i <= niter
        push!(visited, currs)
        i += 1
        nbrs = outneighbors(g, currs)
        length(nbrs) == 1 && break
        idnext = rand(rng, 1:(length(nbrs) - 1))
        next = nbrs[idnext]
        if next == prev
            next = nbrs[end]
        end
        prev = currs
        currs = next
    end
    return visited[1:(i - 1)]
end

# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function non_backtracking_randomwalk(
    g::AG::IsDirected,
    s::Integer,
    niter::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T,AG<:AbstractGraph{T}}
    s in vertices(g) || throw(BoundsError())
    rng = rng_from_rng_or_seed(rng, seed)
    visited = Vector{T}()
    sizehint!(visited, niter)
    currs = s
    prev = -1
    i = 1

    while i <= niter
        push!(visited, currs)
        i += 1
        nbrs = outneighbors(g, currs)
        length(nbrs) == 0 && break
        next = rand(rng, nbrs)
        if next == prev
            length(nbrs) == 1 && break
            idnext = rand(rng, 1:(length(nbrs) - 1))
            next = nbrs[idnext]
            if next == prev
                next = nbrs[end]
            end
        end
        prev = currs
        currs = next
    end
    return visited[1:(i - 1)]
end

"""
    self_avoiding_walk(g, s, niter; rng=nothing, seed=nothing)

Perform a [self-avoiding walk](https://en.wikipedia.org/wiki/Self-avoiding_walk)
on graph `g` starting at vertex `s` and continuing for a maximum of `niter` steps.
Return a vector of vertices visited in order.
"""
function self_avoiding_walk(
    g::AG,
    s::Integer,
    niter::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {AG<:AbstractGraph{T}} where {T}
    s in vertices(g) || throw(BoundsError())
    rng = rng_from_rng_or_seed(rng, seed)
    visited = Vector{T}()
    svisited = Set{T}()
    sizehint!(visited, niter)
    sizehint!(svisited, niter)
    currs = s
    i = 1
    while i <= niter
        push!(visited, currs)
        push!(svisited, currs)
        i += 1
        nbrs = setdiff(Set(outneighbors(g, currs)), svisited)
        length(nbrs) == 0 && break
        currs = rand(rng, collect(nbrs))
    end
    return visited[1:(i - 1)]
end

"""
    struct DijkstraState{T, U}

An [`AbstractPathState`](@ref) designed for Dijkstra shortest-paths calculations.

# Fields

- `parents::Vector{U}`
- `dists::Vector{T}`
- `predecessors::Vector{Vector{U}}`: a vector, indexed by vertex, of all the predecessors discovered during shortest-path calculations. This keeps track of all parents when there are multiple shortest paths available from the source.
- `pathcounts::Vector{Float64}`: a vector, indexed by vertex, of the number of shortest paths from the source to that vertex. The path count of a source vertex is always `1.0`. The path count of an unreached vertex is always `0.0`.
- `closest_vertices::Vector{U}`: a vector of all vertices in the graph ordered from closest to farthest.
"""
struct DijkstraState{T<:Number,U<:Integer} <: AbstractPathState
    parents::Vector{U}
    dists::Vector{T}
    predecessors::Vector{Vector{U}}
    pathcounts::Vector{Float64}
    closest_vertices::Vector{U}
end

"""
    dijkstra_shortest_paths(g, srcs, distmx=weights(g));

Perform [Dijkstra's algorithm](http://en.wikipedia.org/wiki/Dijkstra%27s_algorithm)
on a graph, computing shortest distances between `srcs` and all other vertices.
Return a [`Graphs.DijkstraState`](@ref) that contains various traversal information (try querying `state.parents` or `state.dists`).


### Optional Arguments
* `allpaths=false`: If true, `state.pathcounts` holds a vector, indexed by vertex, of the number of shortest paths from the source to that vertex. The path count of a source vertex is always `1.0`. The path count of an unreached vertex is always `0.0`.
* `trackvertices=false`: If true, `state.closest_vertices` holds a vector of all vertices in the graph ordered from closest to farthest.
* `maxdist` (default: `typemax(T)`) specifies the maximum path distance beyond which all path distances are assumed to be infinite (that is, they do not exist).

### Performance
If using a sparse matrix for `distmx`, you *may* achieve better performance by passing in a transpose of its sparse transpose.
That is, assuming `D` is the sparse distance matrix:
```
D = transpose(sparse(transpose(D)))
```
Be aware that realizing the sparse transpose of `D` incurs a heavy one-time penalty, so this strategy should only be used
when multiple calls to `dijkstra_shortest_paths` with the distance matrix are planned.

# Examples
```jldoctest
julia> using Graphs

julia> ds = dijkstra_shortest_paths(cycle_graph(5), 2);

julia> ds.dists
5-element Vector{Int64}:
 1
 0
 1
 2
 2

julia> ds = dijkstra_shortest_paths(path_graph(5), 2);

julia> ds.dists
5-element Vector{Int64}:
 1
 0
 1
 2
 3
```
"""
function dijkstra_shortest_paths(
    g::AbstractGraph,
    srcs::Vector{U},
    distmx::AbstractMatrix{T}=weights(g);
    allpaths=false,
    trackvertices=false,
    maxdist=typemax(T),
) where {T<:Number} where {U<:Integer}
    nvg = nv(g)
    dists = fill(typemax(T), nvg)
    parents = zeros(U, nvg)
    visited = zeros(Bool, nvg)

    pathcounts = zeros(nvg)
    preds = fill(Vector{U}(), nvg)
    H = PriorityQueue{U,T}()
    # fill creates only one array.

    for src in srcs
        dists[src] = zero(T)
        visited[src] = true
        pathcounts[src] = one(Float64)
        H[src] = zero(T)
    end

    closest_vertices = Vector{U}()  # Maintains vertices in order of distances from source
    sizehint!(closest_vertices, nvg)

    while !isempty(H)
        u = dequeue!(H)

        if trackvertices
            push!(closest_vertices, u)
        end

        d = dists[u] # Cannot be typemax if `u` is in the queue
        for v in outneighbors(g, u)
            alt = d + distmx[u, v]

            alt > maxdist && continue

            if !visited[v]
                visited[v] = true
                dists[v] = alt
                parents[v] = u

                pathcounts[v] += pathcounts[u]
                if allpaths
                    preds[v] = [u;]
                end
                H[v] = alt
            elseif alt < dists[v]
                dists[v] = alt
                parents[v] = u
                #615
                pathcounts[v] = pathcounts[u]
                if allpaths
                    resize!(preds[v], 1)
                    preds[v][1] = u
                end
                H[v] = alt
            elseif alt == dists[v]
                pathcounts[v] += pathcounts[u]
                if allpaths
                    push!(preds[v], u)
                end
            end
        end
    end

    if trackvertices
        for s in vertices(g)
            if !visited[s]
                push!(closest_vertices, s)
            end
        end
    end

    for src in srcs
        pathcounts[src] = one(Float64)
        parents[src] = 0
        empty!(preds[src])
    end

    return DijkstraState{T,U}(parents, dists, preds, pathcounts, closest_vertices)
end

function dijkstra_shortest_paths(
    g::AbstractGraph,
    src::Integer,
    distmx::AbstractMatrix=weights(g);
    allpaths=false,
    trackvertices=false,
    maxdist=typemax(eltype(distmx)),
)
    return dijkstra_shortest_paths(
        g, [src;], distmx; allpaths=allpaths, trackvertices=trackvertices, maxdist=maxdist
    )
end

"""
    articulation(g)

Compute the [articulation points](https://en.wikipedia.org/wiki/Biconnected_component)
of a connected graph `g` and return an array containing all cut vertices.

# Examples
```jldoctest
julia> using Graphs

julia> articulation(star_graph(5))
1-element Vector{Int64}:
 1

julia> articulation(path_graph(5))
3-element Vector{Int64}:
 2
 3
 4
```
"""
function articulation end
@traitfn function articulation(g::AG::(!IsDirected)) where {T,AG<:AbstractGraph{T}}
    s = Vector{Tuple{T,T,T}}()
    is_articulation_pt = falses(nv(g))
    low = zeros(T, nv(g))
    pre = zeros(T, nv(g))

    @inbounds for u in vertices(g)
        pre[u] != 0 && continue
        v = u
        children = 0
        wi::T = zero(T)
        w::T = zero(T)
        cnt::T = one(T)
        first_time = true

        # TODO the algorithm currently relies on the assumption that
        # outneighbors(g, v) is indexable. This assumption might not be true
        # in general, so in case that outneighbors does not produce a vector
        # we collect these vertices. This might lead to a large number of
        # allocations, so we should find a way to handle that case differently,
        # or require inneighbors, outneighbors and neighbors to always
        # return indexable collections.

        while !isempty(s) || first_time
            first_time = false
            if wi < 1
                pre[v] = cnt
                cnt += 1
                low[v] = pre[v]
                v_neighbors = collect_if_not_vector(outneighbors(g, v))
                wi = 1
            else
                wi, u, v = pop!(s)
                v_neighbors = collect_if_not_vector(outneighbors(g, v))
                w = v_neighbors[wi]
                low[v] = min(low[v], low[w])
                if low[w] >= pre[v] && u != v
                    is_articulation_pt[v] = true
                end
                wi += 1
            end
            while wi <= length(v_neighbors)
                w = v_neighbors[wi]
                if pre[w] == 0
                    if u == v
                        children += 1
                    end
                    push!(s, (wi, u, v))
                    wi = 0
                    u = v
                    v = w
                    break
                elseif w != u
                    low[v] = min(low[v], pre[w])
                end
                wi += 1
            end
            wi < 1 && continue
        end

        if children > 1
            is_articulation_pt[u] = true
        end
    end

    articulation_points = Vector{T}()

    for u in findall(is_articulation_pt)
        push!(articulation_points, T(u))
    end

    return articulation_points
end

import Base: Pair, Tuple, show, ==, hash, isless
import Graphs: AbstractEdge, src, dst, reverse

abstract type AbstractSimpleEdge{T<:Integer} <: AbstractEdge{T} end

struct SimpleEdge{T<:Integer} <: AbstractSimpleEdge{T}
    src::T
    dst::T
end

SimpleEdge(t::Tuple) = SimpleEdge(t[1], t[2])
SimpleEdge(p::Pair) = SimpleEdge(p.first, p.second)
SimpleEdge{T}(p::Pair) where {T<:Integer} = SimpleEdge(T(p.first), T(p.second))
SimpleEdge{T}(t::Tuple) where {T<:Integer} = SimpleEdge(T(t[1]), T(t[2]))

eltype(::Type{<:ET}) where {ET<:AbstractSimpleEdge{T}} where {T} = T

# Accessors
src(e::AbstractSimpleEdge) = e.src
dst(e::AbstractSimpleEdge) = e.dst

# I/O
show(io::IO, e::AbstractSimpleEdge) = print(io, "Edge $(e.src) => $(e.dst)")

# Conversions
Pair(e::AbstractSimpleEdge) = Pair(src(e), dst(e))
Tuple(e::AbstractSimpleEdge) = (src(e), dst(e))

SimpleEdge{T}(e::AbstractSimpleEdge) where {T<:Integer} = SimpleEdge{T}(T(e.src), T(e.dst))

# Convenience functions
reverse(e::T) where {T<:AbstractSimpleEdge} = T(dst(e), src(e))
function ==(e1::AbstractSimpleEdge, e2::AbstractSimpleEdge)
    return (src(e1) == src(e2) && dst(e1) == dst(e2))
end
hash(e::AbstractSimpleEdge, h::UInt) = hash(src(e), hash(dst(e), h))
function isless(e1::AbstractSimpleEdge, e2::AbstractSimpleEdge)
    return (src(e1) < src(e2)) || ((src(e1) == src(e2)) && (dst(e1) < dst(e2)))
end

module Traversals

# This module does not export much. The primary reasons are that exporting would increase the
# likelihood of name conflicts, and because the functions here should be used only by developers
# to create new graph algorithms that rely on breadth-first or depth-first search traversals.

using Graphs
using SimpleTraits
"""
    abstract type TraversalAlgorithm

`TraversalAlgorithm` is the abstract type used to specify breadth-first traversal (`BFS`) or
depth-first traversal (`DFS`) for the various traversal functions.
"""
abstract type TraversalAlgorithm end

"""
    abstract type AbstractTraversalState

`AbstractTraversalState` is the abstract type used to hold mutable states
for various traversal algorithms (see [`traverse_graph!`](@ref)).

When creating concrete types, you should override the following functions where relevant. These functions
are listed in order of occurrence in the traversal:
- [`initfn!(<:AbstractTraversalState, u::Integer)`](@ref): runs prior to traversal, used to set initial state.
- [`previsitfn!(<:AbstractTraversalState, u::Integer)`](@ref): runs prior to neighborhood discovery for vertex `u`.
- [`visitfn!(<:AbstractTraversalState, u::Integer, v::Integer)`](@ref): runs for each neighbor `v` (newly-discovered or not) of vertex `u`.
- [`newvisitfn!(<:AbstractTraversalState, u::Integer, v::Integer)`](@ref): runs when a new neighbor `v` of vertex `u` is discovered.
- [`postvisitfn!(<:AbstractTraversalState, u::Integer)`](@ref): runs after neighborhood discovery for vertex `u`.
- [`postlevelfn!(<:AbstractTraversalState)`](@ref): runs after each traversal level.

Each of these functions should return a boolean. If the return value of the function is `false`, the traversal will return the state
immediately. Otherwise, the traversal will continue.

For better performance, use the `@inline` directive and make your functions branch-free.
"""
abstract type AbstractTraversalState end

"""
    initfn!(state, u)

Modify [`AbstractTraversalState`](@ref) `state` on initialization of traversal
with source vertices, and return `true` if successful; `false` otherwise.
`initfn!` will be called once for each vertex passed to [`traverse_graph!`](@ref).
"""
@inline initfn!(::AbstractTraversalState, u) = true

"""
    previsitfn!(state, u)

Modify [`AbstractTraversalState`](@ref) `state` before examining neighbors of vertex `u`,
and return `true` if successful; `false` otherwise.
"""
@inline previsitfn!(::AbstractTraversalState, u) = true

"""
    newvisitfn!(state, u, v)

Modify [`AbstractTraversalState`](@ref) `state` when the first edge between `u` and `v` is encountered,
and return `true` if successful; `false` otherwise.
"""
@inline newvisitfn!(::AbstractTraversalState, u, v) = true

"""
    visitfn!(state, u, v)

Modify [`AbstractTraversalState`](@ref) `state` when the edge between `u` and `v` is encountered,
and return `true` if successful; `false` otherwise. Note: `visitfn!` may be called multiple times
per edge, depending on the traversal algorithm, for a function that operates on the first occurrence
only, use [`newvisitfn!`](@ref).
"""
@inline visitfn!(::AbstractTraversalState, u, v) = true

"""
    postvisitfn!(state, u)

Modify [`AbstractTraversalState`](@ref) `state` after having examined all neighbors of vertex `u`,
and return `true` if successful; `false` otherwise.
"""
@inline postvisitfn!(::AbstractTraversalState, u) = true
"""
    postlevelfn!(state)

Modify [`AbstractTraversalState`](@ref) `state` before moving to the next vertex in the traversal algorithm,
and return `true` if successful; `false` otherwise.
"""
@inline postlevelfn!(::AbstractTraversalState) = true

##############
# functions common to both BFS and DFS
##############
"""
    traverse_graph!(g, s, alg, state, neighborfn=outneighbors)
    traverse_graph!(g, ss, alg, state, neighborfn=outneighbors)

Traverse a graph `g` from source vertex `s` / vertices `ss` keeping track of `state`. Return `true` if
traversal finished normally; `false` if one of the visit functions returned `false` (see )

"""
function traverse_graph!(g::AbstractGraph, s::Integer, alg, state, neighborfn)
    return traverse_graph!(g, [s], alg, state, neighborfn)
end
function traverse_graph!(g::AbstractGraph, s::Integer, alg, state)
    return traverse_graph!(g, [s], alg, state)
end

struct VisitState{T<:Integer} <: AbstractTraversalState
    visited::Vector{T}
end

@inline function initfn!(s::VisitState, u)
    push!(s.visited, u)
    return true
end
@inline function newvisitfn!(s::VisitState, u, v)
    push!(s.visited, v)
    return true
end

"""
    visited_vertices(g, s, alg)
    visited_vertices(g, ss, alg)

Return a vector representing the vertices of `g` visited in order by [`TraversalAlgorithm`](@ref) `alg`
starting at vertex `s` (vertices `ss`).
"""
function visited_vertices(
    g::AbstractGraph{U}, ss::AbstractVector, alg::TraversalAlgorithm
) where {U<:Integer}
    v = Vector{U}()
    sizehint!(v, nv(g))  # actually just the largest connected component, but we'll use this.
    state = VisitState(v)
    traverse_graph!(g, ss, alg, state)

    return state.visited
end

function visited_vertices(g::AbstractGraph, s::Integer, alg::TraversalAlgorithm)
    return visited_vertices(g, [s], alg)
end

mutable struct ParentState{T<:Integer} <: AbstractTraversalState
    parents::Vector{T}
end

@inline function newvisitfn!(s::ParentState, u, v)
    s.parents[v] = u
    return true
end

"""
    parents(g, s, alg, neighborfn=outneighbors)

Return a vector of parent vertices indexed by vertex using [`TraversalAlgorithm`](@ref) `alg` starting with
vertex `s`. If `neighborfn` is specified, use the corresponding neighbor-generation function ([`inneighbors`](@ref)r
and [`outneighbors`](@ref) are valid values).

### Performance
This implementation is designed to perform well on large graphs. There are
implementations which are marginally faster in practice for smaller graphs,
but the performance improvements using this implementation on large graphs
can be significant.
"""
function parents(
    g::AbstractGraph{T}, s::Integer, alg::TraversalAlgorithm, neighborfn=outneighbors
) where {T}
    parents = zeros(T, nv(g))
    state = ParentState(parents)

    traverse_graph!(g, s, alg, state, neighborfn)
    return state.parents
end

include("bfs.jl")
include("dfs.jl")

"""
    tree(p)

Return a directed acyclic graph based on a [`parents`](@ref) vector `p`.
"""
function tree(p::AbstractVector{T}) where {T<:Integer}
    n = T(length(p))
    t = DiGraph{T}(n)
    for (v, u) in enumerate(p)
        if u > zero(T) && u != v
            add_edge!(t, u, v)
        end
    end
    return t
end

"""
    tree(g, s, alg, neighborfn=outneighbors)

Return a directed acyclic graph based on traversal of the graph `g` starting with source vertex `s`
using algorithm `alg` with neighbor function `neighborfn`.
"""
function tree(
    g::AbstractGraph, s::Integer, alg::TraversalAlgorithm, neighborfn::Function=outneighbors
)
    p = parents(g, s, alg, neighborfn)
    return tree(p)
end

export visited_vertices, parents, distances, tree

end  # module

"""
    bipartite_map(g) -> Vector{UInt8}

For a bipartite graph `g`, return a vector `c` of size ``|V|`` containing
the assignment of each vertex to one of the two sets (``c_i == 1`` or ``c_i == 2``).
If `g` is not bipartite, return an empty vector.

### Implementation Notes
Note that an empty vector does not necessarily indicate non-bipartiteness.
An empty graph will return an empty vector but is bipartite.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(3);

julia> bipartite_map(g)
3-element Vector{UInt8}:
 0x01
 0x01
 0x01

julia> add_vertices!(g, 3);

julia> add_edge!(g, 1, 2);

julia> add_edge!(g, 2, 3);

julia> bipartite_map(g)
6-element Vector{UInt8}:
 0x01
 0x02
 0x01
 0x01
 0x01
 0x01
```
"""
function bipartite_map(g::AbstractGraph{T}) where {T}
    nvg = nv(g)
    if !is_directed(g)
        ccs = filter(x -> length(x) >= 2, connected_components(g))
    else
        ccs = filter(x -> length(x) >= 2, weakly_connected_components(g))
    end
    seen = zeros(Bool, nvg)
    colors = zeros(Bool, nvg)
    for cc in ccs
        Q = Vector{T}()
        s = cc[1]
        push!(Q, s)
        bipartitemap = zeros(UInt8, nvg)
        while !isempty(Q)
            u = popfirst!(Q)
            for v in outneighbors(g, u)
                if !seen[v]
                    colors[v] = !colors[u]
                    push!(Q, v)
                    seen[v] = true
                elseif colors[v] == colors[u]
                    return Vector{UInt8}()
                end
            end
        end
    end
    return UInt8.(colors) .+ (one(UInt8))
end

"""
    is_bipartite(g)

Return `true` if graph `g` is [bipartite](https://en.wikipedia.org/wiki/Bipartite_graph).

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(3);

julia> add_edge!(g, 1, 2);

julia> add_edge!(g, 2, 3);

julia> is_bipartite(g)
true

julia> add_edge!(g, 1, 3);

julia> is_bipartite(g)
false
```
"""
is_bipartite(g::AbstractGraph) = length(bipartite_map(g)) == nv(g)

const SparseMatrix{T} = SparseMatrixCSC{T,Int}

"""
    GraphMatrix{T}

An abstract type to allow operations on any type of graph matrix
"""
abstract type GraphMatrix{T} end

"""
    Adjacency{T}

The core Adjacency matrix structure. Keeps the vertex degrees around.
Subtypes are used to represent the different normalizations of the adjacency matrix.
Laplacian and its subtypes are used for the different Laplacian matrices.

Adjacency(lapl::Laplacian) provides a generic function for getting the
adjacency matrix of a Laplacian matrix. If your subtype of Laplacian does not provide
a field A for the Adjacency instance, then attach another method to this function to provide
an Adjacency{T} representation of the Laplacian. The Adjacency matrix here
is the final subtype that corresponds to this type of Laplacian.
"""
abstract type Adjacency{T} <: GraphMatrix{T} end
abstract type Laplacian{T} <: GraphMatrix{T} end

"""
    CombinatorialAdjacency{T,S,V}

The standard adjacency matrix.
"""
struct CombinatorialAdjacency{T,S,V} <: Adjacency{T}
    A::S
    D::V
end

function CombinatorialAdjacency(A::SparseMatrix{T}) where {T}
    D = vec(sum(A; dims=1))
    return CombinatorialAdjacency{T,SparseMatrix{T},typeof(D)}(A, D)
end

"""
    NormalizedAdjacency{T}

The normalized adjacency matrix is ``\\hat{A} = D^{-1/2} A D^{-1/2}``.
If A is symmetric, then the normalized adjacency is also symmetric
with real eigenvalues bounded by [-1, 1].
"""
struct NormalizedAdjacency{T} <: Adjacency{T}
    A::CombinatorialAdjacency{T}
    scalefactor::Vector{T}
end
function NormalizedAdjacency(adjmat::CombinatorialAdjacency)
    sf = adjmat.D .^ (-1 / 2)
    return NormalizedAdjacency(adjmat, sf)
end

"""
    StochasticAdjacency{T}

A transition matrix for the random walk.
"""
struct StochasticAdjacency{T} <: Adjacency{T}
    A::CombinatorialAdjacency{T}
    scalefactor::Vector{T}
end
function StochasticAdjacency(adjmat::CombinatorialAdjacency)
    sf = adjmat.D .^ (-1)
    return StochasticAdjacency(adjmat, sf)
end

"""
    AveragingAdjacency{T}

The matrix whose action is to average over each neighborhood.
"""
struct AveragingAdjacency{T} <: Adjacency{T}
    A::CombinatorialAdjacency{T}
    scalefactor::Vector{T}
end
function AveragingAdjacency(adjmat::CombinatorialAdjacency)
    sf = adjmat.D .^ (-1)
    return AveragingAdjacency(adjmat, sf)
end

perron(adjmat::NormalizedAdjacency) = sqrt.(adjmat.A.D) / norm(sqrt.(adjmat.A.D))

struct PunchedAdjacency{T} <: Adjacency{T}
    A::NormalizedAdjacency{T}
    perron::Vector{T}
end
function PunchedAdjacency(adjmat::CombinatorialAdjacency)
    perron = sqrt.(adjmat.D) / norm(sqrt.(adjmat.D))
    return PunchedAdjacency(NormalizedAdjacency(adjmat), perron)
end

perron(m::PunchedAdjacency) = m.perron

"""
    Noop

A type that represents no action.

### Implementation Notes
- The purpose of `Noop` is to help write more general code for the
different scaled GraphMatrix types.
"""
struct Noop end

Broadcast.broadcasted(::typeof(*), ::Noop, x) = x

Diagonal(::Noop) = Noop()

==(g::GraphMatrix, h::GraphMatrix) = typeof(g) == typeof(h) && (g.A == h.A)

postscalefactor(::Adjacency) = Noop()

postscalefactor(adjmat::NormalizedAdjacency) = adjmat.scalefactor

postscalefactor(adjmat::AveragingAdjacency) = adjmat.scalefactor

prescalefactor(::Adjacency) = Noop()

prescalefactor(adjmat::NormalizedAdjacency) = adjmat.scalefactor

prescalefactor(adjmat::StochasticAdjacency) = adjmat.scalefactor

struct CombinatorialLaplacian{T} <: Laplacian{T}
    A::CombinatorialAdjacency{T}
end

"""
    NormalizedLaplacian{T}

The normalized Laplacian is ``\\hat{L} = I - D^{-1/2} A D^{-1/2}``.
If A is symmetric, then the normalized Laplacian is also symmetric
with positive eigenvalues bounded by 2.
"""
struct NormalizedLaplacian{T} <: Laplacian{T}
    A::NormalizedAdjacency{T}
end

"""
    StochasticLaplacian{T}

Laplacian version of the StochasticAdjacency matrix.
"""
struct StochasticLaplacian{T} <: Laplacian{T}
    A::StochasticAdjacency{T}
end

"""
    AveragingLaplacian{T}

Laplacian version of the AveragingAdjacency matrix.
"""
struct AveragingLaplacian{T} <: Laplacian{T}
    A::AveragingAdjacency{T}
end

arrayfunctions = (:eltype, :length, :ndims, :size, :strides)
for f in arrayfunctions
    @eval $f(a::GraphMatrix) = $f(a.A)
end
issymmetric(a::GraphMatrix) = issymmetric(a.A)
size(a::GraphMatrix, i::Integer) = size(a.A, i)
issymmetric(::StochasticAdjacency) = false
issymmetric(::AveragingAdjacency) = false

"""
    degrees(adjmat)

Return the degrees of a graph represented by the [`CombinatorialAdjacency`](@ref) `adjmat`.
"""
degrees(adjmat::CombinatorialAdjacency) = adjmat.D

"""
    degrees(graphmx)

Return the degrees of a graph represented by the graph matrix `graphmx`.
"""
degrees(mat::GraphMatrix) = degrees(adjacency(mat))

adjacency(lapl::Laplacian) = lapl.A
adjacency(lapl::GraphMatrix) = lapl.A

convert(::Type{CombinatorialAdjacency}, adjmat::Adjacency) = adjmat.A
convert(::Type{CombinatorialAdjacency}, adjmat::CombinatorialAdjacency) = adjmat

function sparse(lapl::M) where {M<:Laplacian}
    adjmat = adjacency(lapl)
    A = sparse(adjmat)
    L = sparse(Diagonal(diag(lapl))) - A
    return L
end

function SparseMatrix(lapl::M) where {M<:GraphMatrix}
    return sparse(lapl)
end

function sparse(adjmat::Adjacency)
    A = sparse(adjmat.A)
    return Diagonal(prescalefactor(adjmat)) * (A * Diagonal(postscalefactor(adjmat)))
end

function convert(::Type{SparseMatrix{T}}, lapl::Laplacian{T}) where {T}
    adjmat = adjacency(lapl)
    A = convert(SparseMatrix{T}, adjmat)
    L = sparse(Diagonal(diag(lapl))) - A
    return L
end

diag(lapl::CombinatorialLaplacian) = lapl.A.D
diag(lapl::Laplacian) = ones(size(lapl)[2])

*(x::AbstractArray, ::Noop) = x
*(::Noop, x) = x
function *(adjmat::Adjacency{T}, x::AbstractVector{T}) where {T<:Number}
    return postscalefactor(adjmat) .* (adjmat.A * (prescalefactor(adjmat) .* x))
end

*(adjmat::CombinatorialAdjacency{T}, x::AbstractVector{T}) where {T<:Number} = adjmat.A * x

function *(lapl::Laplacian{T}, x::AbstractVector{T}) where {T<:Number}
    return (diag(lapl) .* x) - (adjacency(lapl) * x)
end

function *(adjmat::PunchedAdjacency{T}, x::AbstractVector{T}) where {T<:Number}
    y = adjmat.A * x
    return y - dot(adjmat.perron, y) * adjmat.perron
end

function mul!(Y, A::Adjacency, B)
    # we need to do 3 matrix products
    # Y and B can't overlap in any one call to mul!
    # The last call to mul! must be (Y, postscalefactor, tmp)
    # so we need to write to tmp in the second step  must be (tmp, A.A, Y)
    # and the first step (Y, prescalefactor, B)
    tmp1 = Diagonal(prescalefactor(A)) * B
    tmp = similar(Y)
    mul!(tmp, A.A, tmp1)
    return mul!(Y, Diagonal(postscalefactor(A)), tmp)
end

mul!(Y, A::CombinatorialAdjacency, B) = mul!(Y, A.A, B)

# You can compute the StochasticAdjacency product without allocating a similar of Y.
# This is true for all Adjacency where the postscalefactor is a Noop
# at time of writing this is just StochasticAdjacency and CombinatorialAdjacency
function mul!(Y, A::StochasticAdjacency, B)
    tmp = Diagonal(prescalefactor(A)) * B
    mul!(Y, A.A, tmp)
    return Y
end

function mul!(Y, adjmat::PunchedAdjacency, x)
    y = adjmat.A * x
    Y[:] = y - dot(adjmat.perron, y) * adjmat.perron
    return Y
end

function mul!(Y, lapl::Laplacian, B)
    mul!(Y, lapl.A, B)
    z = diag(lapl) .* B
    Y[:] = z - Y[:]
    return Y
end

"""
    symmetrize(A::SparseMatrix, which=:or)

Return a symmetric version of graph (represented by sparse matrix `A`) as a sparse matrix.
`which` may be one of `:triu`, `:tril`, `:sum`, or `:or`. Use `:sum` for weighted graphs.
"""
function symmetrize(A::SparseMatrix, which=:or)
    if which == :or
        M = A + sparse(A')
        M.nzval[M.nzval .== 2] .= 1
        return M
    end
    T = A
    if which == :triu
        T = triu(A)
    elseif which == :tril
        T = tril(A)
    elseif which == :sum
        T = A
    else
        throw(ArgumentError("$which is not a supported method of symmetrizing a matrix"))
    end
    M = T + sparse(T')
    return M
end

"""
    symmetrize(adjmat, which=:or)

Return a symmetric version of graph (represented by [`CombinatorialAdjacency`](@ref) `adjmat`)
as a [`CombinatorialAdjacency`](@ref). `which` may be one of `:triu`, `:tril`, `:sum`, or `:or`.
Use `:sum` for weighted graphs.

### Implementation Notes
Only works on [`Adjacency`](@ref) because the normalizations don't commute with symmetrization.
"""
function symmetrize(adjmat::CombinatorialAdjacency, which=:or)
    return CombinatorialAdjacency(symmetrize(adjmat.A, which))
end

# per #564
# @deprecate mul!(Y, A::Noop, B) nothing
@deprecate convert(::Type{Adjacency}, lapl::Laplacian) nothing
@deprecate convert(::Type{SparseMatrix}, adjmat::GraphMatrix) sparse(adjmat)

"""
    LinAlg

A package for using the type system to check types of graph matrices.
"""
LinAlg

"""
    transitiveclosure!(g, selflooped=false)

Compute the transitive closure of a directed graph, using DFS.
If `selflooped` is true, add self loops to the graph.

### Performance
Time complexity is ``\\mathcal{O}(|E||V|)``.

### Implementation Notes
This version of the function modifies the original graph.
"""
function transitiveclosure! end
@traitfn function transitiveclosure!(g::::IsDirected, selflooped=false)
    scc = strongly_connected_components(g)
    cg = condensation(g, scc)
    tp = reverse(topological_sort_by_dfs(cg))
    sr = [Vector{eltype(cg)}() for _ in vertices(cg)]

    x = selflooped ? 0 : 1
    for comp in scc
        for j in 1:(length(comp) - x)
            for k in (j + x):length(comp)
                add_edge!(g, comp[j], comp[k])
                add_edge!(g, comp[k], comp[j])
            end
        end
    end
    for u in tp
        for v in outneighbors(cg, u)
            union!(sr[u], sr[v], [v])
        end
    end
    for i in vertices(cg)
        for u in scc[i]
            for j in sr[i]
                for v in scc[j]
                    add_edge!(g, u, v)
                end
            end
        end
    end
    return g
end

"""
    transitiveclosure(g, selflooped=false)

Compute the transitive closure of a directed graph, using DFS.
Return a graph representing the transitive closure. If `selflooped`
is `true`, add self loops to the graph.

### Performance
Time complexity is ``\\mathcal{O}(|E||V|)``.

# Examples
```jldoctest
julia> using Graphs

julia> barbell = blockdiag(complete_digraph(3), complete_digraph(3));

julia> add_edge!(barbell, 1, 4);

julia> ne(barbell)
13

julia> ne(transitiveclosure(barbell))
21
```
"""
function transitiveclosure(g::DiGraph, selflooped=false)
    copyg = copy(g)
    return transitiveclosure!(copyg, selflooped)
end

"""
    transitivereduction(g; selflooped=false)

Compute the transitive reduction of  a directed graph. If the graph contains
cycles, each strongly connected component is replaced by a directed cycle and
the transitive reduction is calculated on the condensation graph connecting the
components. If `selflooped` is true, self loops on strongly connected components
of size one will be preserved.

### Performance
Time complexity is ``\\mathcal{O}(|V||E|)``.

# Examples
```jldoctest
julia> using Graphs

julia> barbell = blockdiag(complete_digraph(3), complete_digraph(3));

julia> add_edge!(barbell, 1, 4);

julia> collect(edges(barbell))
13-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3
 Edge 1 => 4
 Edge 2 => 1
 Edge 2 => 3
 Edge 3 => 1
 Edge 3 => 2
 Edge 4 => 5
 Edge 4 => 6
 Edge 5 => 4
 Edge 5 => 6
 Edge 6 => 4
 Edge 6 => 5

julia> collect(edges(transitivereduction(barbell)))
7-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 4
 Edge 2 => 3
 Edge 3 => 1
 Edge 4 => 5
 Edge 5 => 6
 Edge 6 => 4
```
"""
function transitivereduction end
@traitfn function transitivereduction(g::::IsDirected; selflooped::Bool=false)
    scc = strongly_connected_components(g)
    cg = condensation(g, scc)

    reachable = Vector{Bool}(undef, nv(cg))
    visited = Vector{Bool}(undef, nv(cg))
    stack = Vector{eltype(cg)}(undef, nv(cg))
    resultg = SimpleDiGraph{eltype(g)}(nv(g))

    # Calculate the transitive reduction of the acyclic condensation graph.
    @inbounds(
        for u in vertices(cg)
            fill!(reachable, false) # vertices reachable from u on a path of length >= 2
            fill!(visited, false)
            stacksize = 0
            for v in outneighbors(cg, u)
                @simd for w in outneighbors(cg, v)
                    if !visited[w]
                        visited[w] = true
                        stacksize += 1
                        stack[stacksize] = w
                    end
                end
            end
            while stacksize > 0
                v = stack[stacksize]
                stacksize -= 1
                reachable[v] = true
                @simd for w in outneighbors(cg, v)
                    if !visited[w]
                        visited[w] = true
                        stacksize += 1
                        stack[stacksize] = w
                    end
                end
            end
            # Add the edges from the condensation graph to the resulting graph.
            @simd for v in outneighbors(cg, u)
                if !reachable[v]
                    add_edge!(resultg, scc[u][1], scc[v][1])
                end
            end
        end
    )

    # Replace each strongly connected component with a directed cycle.
    @inbounds(
        for component in scc
            nvc = length(component)
            if nvc == 1
                if selflooped && has_edge(g, component[1], component[1])
                    add_edge!(resultg, component[1], component[1])
                end
                continue
            end
            for i in 1:(nvc - 1)
                add_edge!(resultg, component[i], component[i + 1])
            end
            add_edge!(resultg, component[nvc], component[1])
        end
    )

    return resultg
end

"""
	filter_non_term_leaves!(g, term_vert)

Remove edges of `g` so that all non-isolated leaves of `g` are in the set `term_vert`
"""
function filter_non_term_leaves!(
    g::AbstractGraph{T}, term_vert::Vector{<:Integer}
) where {T<:Integer}
    is_term = falses(nv(g))
    is_term[term_vert] .= true
    leaves = [v for v in vertices(g) if degree(g, v) == 1 && !is_term[v]]

    while !isempty(leaves)
        leaf = pop!(leaves)
        for v in neighbors(g, leaf)
            rem_edge!(g, v, leaf)
            if degree(g, v) == 1 && !is_term[v]
                push!(leaves, v)
            end
        end
    end

    return g
end

"""
	steiner_tree(g, term_vert, distmx=weights(g))

Return an approximately minimum steiner tree of connected, undirected graph `g` with positive edge 
weights represented by `distmx` using [Approximate Steiner Tree](https://en.wikipedia.org/wiki/Steiner_tree_problem#Approximating_the_Steiner_tree). 
The minimum steiner tree problem involves finding a subset of edges in `g` of minimum weight such
that all the vertices in `term_vert` are connected.

`t = length(term_vert)`.

### Performance
Runtime: O(t*(t*log(t)+|E|*log(|V| ))
Memory: O(t*|V|)
Approximation Factor: 2-2/t
"""
function steiner_tree end

@traitfn function steiner_tree(
    g::AG::(!IsDirected), term_vert::Vector{<:Integer}, distmx::AbstractMatrix{U}=weights(g)
) where {U<:Real,T,AG<:AbstractGraph{T}}
    nvg = nv(g)
    length(term_vert) == 0 && return SimpleGraph{T}()
    length(term_vert) == 1 && return SimpleGraph{T}(first(term_vert))
    term_to_actual = T.(term_vert)
    unique!(term_to_actual)

    # Compute the graph formed by inducing the metric closure graph of g on term_vert
    nvg_mc = length(term_to_actual)
    distmx_mc = Matrix{U}(undef, nvg_mc, nvg_mc)
    parents = Matrix{T}(undef, nvg, nvg_mc)

    for (i, v) in enumerate(term_to_actual)
        d_s = dijkstra_shortest_paths(g, v, distmx)
        @inbounds parents[:, i] = d_s.parents
        @inbounds distmx_mc[:, i] = @view d_s.dists[term_to_actual]
    end

    # Compute MST of Metric Closure graph
    mst_mc = kruskal_mst(complete_graph(nvg_mc), distmx_mc)
    expanded_mst = Vector{Edge{T}}()
    sizehint!(expanded_mst, nvg)

    # Expand each edge in mst_mc into the path it represents
    for e in mst_mc
        i = src(e)
        s = term_to_actual[i]
        t = term_to_actual[dst(e)]
        while s != t
            t_next = parents[t, i]
            push!(expanded_mst, Edge(min(t_next, t), max(t_next, t)))
            t = t_next
        end
    end

    # Compute the MST of the expanded graph
    mst_mst_mc = kruskal_mst(SimpleGraph(expanded_mst), distmx)

    # Remove non-terminal leaves
    return filter_non_term_leaves!(SimpleGraph(mst_mst_mc), term_to_actual)
end

@testset "Eulerian tours/cycles" begin
    # a cycle (identical start/end)
    g0 = GenericGraph(SimpleGraph([Edge(1, 2), Edge(2, 3), Edge(3, 1)]))
    @test eulerian(g0, 1) == eulerian(g0)
    @test last(eulerian(g0, 1)) == 1 # a cycle

    # a tour (different start/end)
    g1_3 = GenericGraph(SimpleGraph([Edge(1, 2), Edge(2, 3)]))
    @test eulerian(g1_3, 3) == [3, 2, 1]
    g1_4 = GenericGraph(SimpleGraph([Edge(1, 2), Edge(2, 3), Edge(3, 4)]))
    @test eulerian(g1_4, 1) == [1, 2, 3, 4]
    # in a graph with an Eulerian trail but not cycle, you have to start at an odd degree vertex
    @test_throws ErrorException(
        "starting vertex has even degree but there are other vertices with odd degree: a eulerian cycle does not exist",
    ) eulerian(g1_3, 2)
    # too many odd degree vertices; Eulerian cycle does not exist
    # 3-pointed star with vertex 1 at the center
    g_star = GenericGraph(SimpleGraph([Edge(1, 2), Edge(1, 3), Edge(1, 4)]))
    @test_throws ErrorException(
        "starting vertex has odd degree but the total number of vertices of odd degree is not equal to 2: a eulerian trail does not exist",
    ) eulerian(g_star, 1)

    # a cycle with a node (vertex 2) with multiple neighbors
    g2 = GenericGraph(
        SimpleGraph([
            Edge(1, 2),
            Edge(2, 3),
            Edge(3, 4),
            Edge(4, 1),
            Edge(2, 5),
            Edge(5, 6),
            Edge(6, 2),
        ]),
    )
    @test eulerian(g2) == eulerian(g2, 1) == [1, 2, 5, 6, 2, 3, 4, 1]

    # graph with odd-degree vertices
    g3 = GenericGraph(
        SimpleGraph([
            Edge(1, 2), Edge(2, 3), Edge(3, 4), Edge(2, 4), Edge(4, 1), Edge(4, 2)
        ]),
    )
    @test_throws ErrorException(
        "starting vertex has even degree but there are other vertices with odd degree: a eulerian cycle does not exist",
    ) eulerian(g3, 1)

    # start/end point not in graph
    @test_throws ErrorException("starting vertex is not in the graph") eulerian(g3, 5)

    # disconnected components
    g4 = GenericGraph(
        SimpleGraph([
            Edge(1, 2),
            Edge(2, 3),
            Edge(3, 1),  # component 1
            Edge(4, 5),
            Edge(5, 6),
            Edge(6, 4),
        ]),
    ) # component 2
    @test_throws ErrorException(
        "graph is not connected: a eulerian cycle/trail does not exist"
    ) eulerian(g4)

    # zero-degree nodes
    g5′ = SimpleGraph(4)
    add_edge!(g5′, Edge(1, 2))
    add_edge!(g5′, Edge(2, 3))
    add_edge!(g5′, Edge(3, 1))
    g5 = GenericGraph(g5′)
    @test_throws ErrorException(
        "some vertices have degree zero (are isolated) and cannot be reached"
    ) eulerian(g5)

    # not yet implemented for directed graphs
    @test_broken eulerian(GenericDiGraph([Edge(1, 2), Edge(2, 3), Edge(3, 1)]))
end

export DegreeVertexCover

struct DegreeVertexCover end

"""
    vertex_cover(g, DegreeVertexCover())

Obtain a vertex cover using a greedy heuristic.

### Implementation Notes
An edge is said to be covered if it has at least one end-point in the vertex cover.
Initialise the vertex cover to an empty set and iteratively choose the vertex with the most uncovered
edges.

### Performance
Runtime: O((|V|+|E|)*log(|V|))
Memory: O(|V|)

# Examples
```jldoctest
julia> using Graphs

julia> vertex_cover(path_graph(3), DegreeVertexCover())
1-element Vector{Int64}:
 2

julia> vertex_cover(cycle_graph(3), DegreeVertexCover())
2-element Vector{Int64}:
 1
 3
```
"""
function vertex_cover(g::AbstractGraph{T}, alg::DegreeVertexCover) where {T<:Integer}
    nvg = nv(g)
    in_cover = falses(nvg)
    length_cover = 0
    degree_queue = PriorityQueue(Base.Order.Reverse, enumerate(degree(g)))

    while !isempty(degree_queue) && peek(degree_queue)[2] > 0
        v = dequeue!(degree_queue)
        in_cover[v] = true
        length_cover += 1

        @inbounds @simd for u in neighbors(g, v)
            if !in_cover[u]
                degree_queue[u] -= 1
            end
        end
    end
    return Graphs.findall!(in_cover, Vector{T}(undef, length_cover))
end

"""
    SimpleEdgeIter

The function [`edges`](@ref) returns a `SimpleEdgeIter` for `AbstractSimpleGraph`s.
The iterates are in lexicographical order, smallest first. The iterator is valid for
one pass over the edges, and is invalidated by changes to the graph.

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(3);

julia> es = edges(g)
SimpleEdgeIter 2

julia> e_it = iterate(es)
(Edge 1 => 2, (1, 2))

julia> iterate(es, e_it[2])
(Edge 2 => 3, (2, 3))
```
"""
struct SimpleEdgeIter{G} <: AbstractEdgeIter
    g::G
end

eltype(::Type{SimpleEdgeIter{SimpleGraph{T}}}) where {T} = SimpleGraphEdge{T}
eltype(::Type{SimpleEdgeIter{SimpleDiGraph{T}}}) where {T} = SimpleDiGraphEdge{T}

@traitfn @inline function iterate(
    eit::SimpleEdgeIter{G}, state=(one(eltype(eit.g)), 1)
) where {G<:AbstractSimpleGraph;!IsDirected{G}}
    g = eit.g
    T = eltype(g)
    n = T(nv(g))
    u, i = state

    @inbounds while u < n
        list_u = fadj(g, u)
        if i > length(list_u)
            u += one(u)
            i = searchsortedfirst(fadj(g, u), u)
            continue
        end
        e = SimpleEdge(u, list_u[i])
        state = (u, i + 1)
        return e, state
    end

    @inbounds (n == 0 || i > length(fadj(g, n))) && return nothing

    e = SimpleEdge(n, n)
    state = (u, i + 1)
    return e, state
end

@traitfn @inline function iterate(
    eit::SimpleEdgeIter{G}, state=(one(eltype(eit.g)), 1)
) where {G<:AbstractSimpleGraph;IsDirected{G}}
    g = eit.g
    T = eltype(g)
    n = T(nv(g))
    u, i = state

    n == 0 && return nothing

    @inbounds while true
        list_u = fadj(g, u)
        if i > length(list_u)
            u == n && return nothing

            u += one(u)
            list_u = fadj(g, u)
            i = 1
            continue
        end
        e = SimpleEdge(u, list_u[i])
        state = (u, i + 1)
        return e, state
    end

    return nothing
end

length(eit::SimpleEdgeIter) = ne(eit.g)

function _isequal(e1::SimpleEdgeIter, e2)
    k = 0
    for e in e2
        has_edge(e1.g, e) || return false
        k += 1
    end
    return k == ne(e1.g)
end
==(e1::SimpleEdgeIter, e2::AbstractVector{SimpleEdge}) = _isequal(e1, e2)
==(e1::AbstractVector{SimpleEdge}, e2::SimpleEdgeIter) = _isequal(e2, e1)
==(e1::SimpleEdgeIter, e2::Set{SimpleEdge}) = _isequal(e1, e2)
==(e1::Set{SimpleEdge}, e2::SimpleEdgeIter) = _isequal(e2, e1)

function ==(e1::SimpleEdgeIter, e2::SimpleEdgeIter)
    g = e1.g
    h = e2.g
    ne(g) == ne(h) || return false
    m = min(nv(g), nv(h))
    for i in 1:m
        fadj(g, i) == fadj(h, i) || return false
    end
    nv(g) == nv(h) && return true
    for i in (m + 1):nv(g)
        isempty(fadj(g, i)) || return false
    end
    for i in (m + 1):nv(h)
        isempty(fadj(h, i)) || return false
    end
    return true
end

in(e, es::SimpleEdgeIter) = has_edge(es.g, e)

show(io::IO, eit::SimpleEdgeIter) = write(io, "SimpleEdgeIter $(ne(eit.g))")

using Graphs.Experimental, Graphs.Experimental.ShortestPaths
using SparseArrays

using Graphs.Experimental.Traversals: NOOPSort
import Base.==
function ==(a::ShortestPaths.AStarResult, b::ShortestPaths.AStarResult)
    return a.path == b.path && a.dist == b.dist
end
@testset "Shortest Paths" begin
    g1 = path_graph(5)
    g2 = path_digraph(5)
    s1 = shortest_paths(g1, 1) # bfs
    s2 = shortest_paths(g2, 1) # bfs
    @test paths(s1)[2] == paths(s1, 2) == [1, 2]
    @test paths(s2)[2] == paths(s2, 2) == [1, 2]
    @test dists(s1)[2] == dists(s1, 2) == 1
    @test dists(s2)[2] == dists(s2, 2) == 1
    @test !has_negative_weight_cycle(g1)
    @test !has_negative_weight_cycle(g2)

    @testset "AStar" begin
        g3 = path_graph(5)
        g4 = path_digraph(5)

        d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        d2 = sparse(
            float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        )
        for g in testgraphs(g3), dg in testdigraphs(g4)
            y = @inferred(shortest_paths(g, 1, 4, d1, AStar()))
            @test y ==
                @inferred(shortest_paths(dg, 1, 4, d1, AStar())) ==
                @inferred(shortest_paths(g, 1, 4, d2, AStar()))
            @test paths(y) == [y.path]
            @test_throws ArgumentError paths(y, 2)
            @test dists(y) == [[y.dist]]
            @test_throws ArgumentError dists(y, 2)

            z = @inferred(shortest_paths(dg, 4, 1, AStar()))
            @test isempty(z.path)
            @test isempty(paths(z)[1])
            @test dists(z)[1] == [typemax(Int)]
        end

        # test for #1258

        g = complete_graph(4)
        w = float([1 1 1 4; 1 1 1 1; 1 1 1 1; 4 1 1 1])
        @test length(first(paths(shortest_paths(g, 1, 4, w, AStar())))) == 3
    end

    @testset "BellmanFord" begin
        g4 = path_digraph(5)

        d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        d2 = sparse(
            float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        )
        for g in testdigraphs(g4)
            y = @inferred(shortest_paths(g, 2, d1, BellmanFord()))
            z = @inferred(shortest_paths(g, 2, d2, BellmanFord()))
            @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
            @test @inferred(paths(z))[2] == []
            @test @inferred(paths(z))[4] == paths(z, 4) == [2, 3, 4]
            @test @inferred(!has_negative_weight_cycle(g, BellmanFord()))
            @test @inferred(!has_negative_weight_cycle(g, d1, BellmanFord()))

            y = @inferred(shortest_paths(g, 2, d1, BellmanFord()))
            z = @inferred(shortest_paths(g, 2, d2, BellmanFord()))
            @test dists(y) == dists(z) == [Inf, 0, 6, 17, 33]
            @test @inferred(paths(z))[2] == []
            @test @inferred(paths(z))[4] == paths(z, 4) == [2, 3, 4]
            @test @inferred(!has_negative_weight_cycle(g, BellmanFord()))
            z = @inferred(shortest_paths(g, 2, BellmanFord()))
            @test dists(z) == [typemax(Int), 0, 1, 2, 3]
        end

        # Negative Cycle
        gx = complete_graph(3)
        for g in testgraphs(gx)
            d = [1 -3 1; -3 1 1; 1 1 1]
            @test_throws NegativeCycleError shortest_paths(g, 1, d, BellmanFord())
            @test has_negative_weight_cycle(g, d, BellmanFord())

            d = [1 -1 1; -1 1 1; 1 1 1]
            @test_throws NegativeCycleError shortest_paths(g, 1, d, BellmanFord())
            @test has_negative_weight_cycle(g, d, BellmanFord())
            @test has_negative_weight_cycle(g, d)
        end

        # Negative cycle of length 3 in graph of diameter 4
        gx = complete_graph(4)
        d = [1 -1 1 1; 1 1 1 -1; 1 1 1 1; 1 1 1 1]
        for g in testgraphs(gx)
            @test_throws NegativeCycleError shortest_paths(g, 1, d, BellmanFord())
            @test has_negative_weight_cycle(g, d)
        end
    end

    @testset "BFS" begin
        g1 = path_graph(5)
        g2 = path_digraph(5)
        add_edge!(g1, 2, 5)
        add_edge!(g2, 2, 5)
        for g in testgraphs(g1, g2)
            d = shortest_paths(g, 1, Dijkstra())
            b = shortest_paths(g, 1, BFS())
            q = shortest_paths(g, 1, BFS(Base.Sort.QuickSort))
            @test dists(d) == dists(b) && paths(d) == paths(b)
            @test dists(b) == dists(q) && paths(b) == paths(q)
            d2 = shortest_paths(g, [1, 3], Dijkstra())
            b2 = shortest_paths(g, [1, 3], BFS(NOOPSort))
            q2 = shortest_paths(g, [1, 3], BFS(Base.Sort.MergeSort))
            @test dists(d2) == dists(b2) && paths(d2) == paths(b2)
            @test dists(b2) == dists(q2) && paths(b2) == paths(q2)
        end

        @test shortest_paths(g1, 1) isa ShortestPaths.BFSResult
        @test shortest_paths(g2, 1) isa ShortestPaths.BFSResult
        m1 = shortest_paths(g1, [1, 2])
        m2 = shortest_paths(g2, [1, 2])
        @test m1 isa ShortestPaths.BFSResult
        @test m2 isa ShortestPaths.BFSResult
        @test m1.dists == [0, 0, 1, 2, 1]
        @test m2.dists == [0, 0, 1, 2, 1]
    end

    @testset "DEsopoPape" begin
        g4 = path_digraph(5)
        d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        d2 = sparse(
            float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        )
        @testset "generic tests: $g" for g in testdigraphs(g4)
            y = @inferred(shortest_paths(g, 2, d1, DEsopoPape()))
            z = @inferred(shortest_paths(g, 2, d2, DEsopoPape()))
            @test y.parents == z.parents == [0, 0, 2, 3, 4]
            @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
        end

        gx = path_graph(5)
        add_edge!(gx, 2, 4)
        d = ones(Int, 5, 5)
        d[2, 3] = 100
        @testset "cycles: $g" for g in testgraphs(gx)
            z = @inferred(shortest_paths(g, 1, d, DEsopoPape()))
            @test z.dists == [0, 1, 3, 2, 3]
            @test z.parents == [0, 1, 4, 2, 4]
        end

        m = [0 2 2 0 0; 2 0 0 0 3; 2 0 0 1 2; 0 0 1 0 1; 0 3 2 1 0]
        G = SimpleGraph(5)
        add_edge!(G, 1, 2)
        add_edge!(G, 1, 3)
        add_edge!(G, 2, 5)
        add_edge!(G, 3, 5)
        add_edge!(G, 3, 4)
        add_edge!(G, 4, 5)

        @testset "more cycles: $g" for g in testgraphs(G)
            y = @inferred(shortest_paths(g, 1, m, DEsopoPape()))
            @test y.parents == [0, 1, 1, 3, 3]
            @test y.dists == [0, 2, 2, 3, 4]
        end

        G = SimpleGraph(5)
        add_edge!(G, 2, 2)
        add_edge!(G, 1, 2)
        add_edge!(G, 1, 3)
        add_edge!(G, 3, 3)
        add_edge!(G, 1, 5)
        add_edge!(G, 2, 4)
        add_edge!(G, 4, 5)
        m = [0 10 2 0 15; 10 9 0 1 0; 2 0 1 0 0; 0 1 0 0 2; 15 0 0 2 0]
        @testset "self loops: $g" for g in testgraphs(G)
            z = @inferred(shortest_paths(g, 1, m, DEsopoPape()))
            y = @inferred(shortest_paths(g, 1, m, Dijkstra()))
            @test isapprox(z.dists, y.dists)
        end

        G = SimpleGraph(5)
        add_edge!(G, 1, 2)
        add_edge!(G, 1, 3)
        add_edge!(G, 4, 5)
        inf = typemax(eltype(G))
        @testset "disconnected: $g" for g in testgraphs(G)
            z = @inferred(shortest_paths(g, 1, DEsopoPape()))
            @test z.dists == [0, 1, 1, inf, inf]
            @test z.parents == [0, 1, 1, 0, 0]
        end

        G = SimpleGraph(3)
        inf = typemax(eltype(G))
        @testset "empty: $g" for g in testgraphs(G)
            z = @inferred(shortest_paths(g, 1, DEsopoPape()))
            @test z.dists == [0, inf, inf]
            @test z.parents == [0, 0, 0]
        end

        @testset "random simple graphs" begin
            for seed in 1:5
                rng = StableRNG(seed)
                nvg = Int(ceil(250 * rand(rng)))
                neg = Int(floor((nvg * (nvg - 1) / 2) * rand(rng)))
                g = SimpleGraph(nvg, neg; rng=rng)
                z = shortest_paths(g, 1, DEsopoPape())
                y = shortest_paths(g, 1, Dijkstra())
                @test isapprox(z.dists, y.dists)
            end
        end

        @testset "random simple digraphs" begin
            for seed in 1:5
                rng = StableRNG(seed)
                nvg = Int(ceil(250 * rand(rng)))
                neg = Int(floor((nvg * (nvg - 1) / 2) * rand(rng)))
                g = SimpleDiGraph(nvg, neg; rng=rng)
                z = shortest_paths(g, 1, DEsopoPape())
                y = shortest_paths(g, 1, Dijkstra())
                @test isapprox(z.dists, y.dists)
            end
        end

        @testset "misc graphs" begin
            G = complete_graph(9)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)

            G = complete_digraph(9)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)

            G = cycle_graph(9)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)

            G = cycle_digraph(9)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)

            G = star_graph(9)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)

            G = wheel_graph(9)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)

            G = roach_graph(9)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)

            G = clique_graph(5, 19)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)
        end

        @testset "smallgraphs: $s" for s in [
            :bull,
            :chvatal,
            :cubical,
            :desargues,
            :diamond,
            :dodecahedral,
            :frucht,
            :heawood,
            :house,
            :housex,
            :icosahedral,
            :krackhardtkite,
            :moebiuskantor,
            :octahedral,
            :pappus,
            :petersen,
            :sedgewickmaze,
            :tutte,
            :tetrahedral,
            :truncatedcube,
            :truncatedtetrahedron,
            :truncatedtetrahedron_dir,
        ]
            G = smallgraph(s)
            z = shortest_paths(G, 1, DEsopoPape())
            y = shortest_paths(G, 1, Dijkstra())
            @test isapprox(z.dists, y.dists)
        end

        @testset "errors" begin
            g = Graph()
            @test_throws DomainError shortest_paths(g, 1, DEsopoPape())
            g = Graph(5)
            @test_throws DomainError shortest_paths(g, 6, DEsopoPape())
        end
    end

    @testset "Dijkstra" begin
        g4 = path_digraph(5)
        d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        d2 = sparse(
            float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        )

        for g in testdigraphs(g4)
            y = @inferred(shortest_paths(g, 2, d1, Dijkstra()))
            z = @inferred(shortest_paths(g, 2, d2, Dijkstra()))

            @test y.parents == z.parents == [0, 0, 2, 3, 4]
            @test y.dists == z.dists == [Inf, 0, 6, 17, 33]

            y = @inferred(shortest_paths(g, 2, d1, Dijkstra(; all_paths=true)))
            z = @inferred(shortest_paths(g, 2, d2, Dijkstra(; all_paths=true)))
            @test z.predecessors[3] == y.predecessors[3] == [2]

            @test @inferred(paths(z)) == paths(y)
            @test @inferred(paths(z))[4] == paths(z, 4) == paths(y, 4) == [2, 3, 4]

            @test shortest_paths(g, 1, d1) isa ShortestPaths.DijkstraResult
        end

        gx = path_graph(5)
        add_edge!(gx, 2, 4)
        d = ones(Int, 5, 5)
        d[2, 3] = 100
        for g in testgraphs(gx)
            z = @inferred(shortest_paths(g, 1, d, Dijkstra()))
            @test z.dists == [0, 1, 3, 2, 3]
            @test z.parents == [0, 1, 4, 2, 4]
        end

        # small function to reconstruct the shortest path; I copied it from somewhere,
        # can't find the original source to give the credits
        # @Beatzekatze on github
        function spath(target, dijkstraStruct, source)
            return if target == source
                target
            else
                [spath(dijkstraStruct.parents[target], dijkstraStruct, source) target]
            end
        end
        spaths(ds, targets, source) = [spath(i, ds, source) for i in targets]

        G = Graph(4)
        add_edge!(G, 2, 1)
        add_edge!(G, 2, 3)
        add_edge!(G, 1, 4)
        add_edge!(G, 3, 4)
        add_edge!(G, 2, 2)
        w = [
            0.0 3.0 0.0 1.0
            3.0 0.0 2.0 0.0
            0.0 2.0 0.0 3.0
            1.0 0.0 3.0 0.0
        ]

        for g in testgraphs(G)
            ds = @inferred(shortest_paths(g, 2, w, Dijkstra()))
            # this loop reconstructs the shortest path for vertices 1, 3 and 4
            @test spaths(ds, [1, 3, 4], 2) == Array[[2 1], [2 3], [2 1 4]]

            # here a selflink at source is introduced; it should not change the shortest paths
            w[2, 2] = 10.0
            ds = @inferred(shortest_paths(g, 2, w, Dijkstra()))
            # this loop reconstructs the shortest path for vertices 1, 3 and 4
            @test spaths(ds, [1, 3, 4], 2) == Array[[2 1], [2 3], [2 1 4]]
        end

        #615
        m = [0 2 2 0 0; 2 0 0 0 3; 2 0 0 1 2; 0 0 1 0 1; 0 3 2 1 0]
        G = SimpleGraph(5)
        add_edge!(G, 1, 2)
        add_edge!(G, 1, 3)
        add_edge!(G, 2, 5)
        add_edge!(G, 3, 5)
        add_edge!(G, 3, 4)
        add_edge!(G, 4, 5)
        for g in testgraphs(G)
            ds = @inferred(shortest_paths(g, 1, m, Dijkstra(; all_paths=true)))
            @test ds.pathcounts == [1, 1, 1, 1, 2]
            @test ds.predecessors == [[], [1], [1], [3], [3, 4]]
            @test ds.predecessors == [[], [1], [1], [3], [3, 4]]

            dm = @inferred(
                shortest_paths(g, 1, Dijkstra(; all_paths=true, track_vertices=true))
            )
            @test dm.pathcounts == [1, 1, 1, 1, 2]
            @test dm.predecessors == [[], [1], [1], [3], [2, 3]]
            @test dm.closest_vertices == [1, 2, 3, 5, 4]
        end

        G = SimpleGraph(5)
        add_edge!(G, 1, 2)
        add_edge!(G, 1, 3)
        add_edge!(G, 4, 5)
        for g in testgraphs(G)
            dm = @inferred(
                shortest_paths(g, 1, Dijkstra(; all_paths=true, track_vertices=true))
            )
            @test dm.closest_vertices == [1, 2, 3, 4, 5]
        end
    end

    @testset "FloydWarshall" begin
        g3 = path_graph(5)
        d = [0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]
        for g in testgraphs(g3)
            z = @inferred(shortest_paths(g, d, FloydWarshall()))
            @test z.dists[3, :][:] == [7, 6, 0, 11, 27]
            @test z.parents[3, :][:] == [2, 3, 0, 3, 4]

            @test @inferred(paths(z))[2][2] == []
            @test @inferred(paths(z))[2][4] == paths(z, 2)[4] == paths(z, 2, 4) == [2, 3, 4]
        end
        g4 = path_digraph(4)
        d = ones(4, 4)
        for g in testdigraphs(g4)
            z = @inferred(shortest_paths(g, d, FloydWarshall()))
            @test length(paths(z, 4, 3)) == 0
            @test length(paths(z, 4, 1)) == 0
            @test length(paths(z, 2, 3)) == 2
        end

        g5 = DiGraph([1 1 1 0 1; 0 1 0 1 1; 0 1 1 0 0; 1 0 1 1 0; 0 0 0 1 1])
        d = [0 3 8 0 -4; 0 0 0 1 7; 0 4 0 0 0; 2 0 -5 0 0; 0 0 0 6 0]
        for g in testdigraphs(g5)
            z = @inferred(shortest_paths(g, d, FloydWarshall()))
            @test z.dists == [0 1 -3 2 -4; 3 0 -4 1 -1; 7 4 0 5 3; 2 -1 -5 0 -2; 8 5 1 6 0]
        end

        @testset "paths infinite loop bug" begin
            g = SimpleGraph(2)
            add_edge!(g, 1, 2)
            add_edge!(g, 2, 2)
            @test paths(shortest_paths(g, FloydWarshall())) ==
                Vector{Vector{Int}}[[[], [1, 2]], [[2, 1], []]]

            g = SimpleDiGraph(2)
            add_edge!(g, 1, 1)
            add_edge!(g, 1, 2)
            add_edge!(g, 2, 1)
            add_edge!(g, 2, 2)
            @test paths(shortest_paths(g, FloydWarshall())) ==
                Vector{Vector{Int}}[[[], [1, 2]], [[2, 1], []]]
        end
        @testset "default for no source, no alg" begin
            g = path_graph(4)
            w = zeros(4, 4)
            for i in 1:3
                w[i, i + 1] = 1.0
                w[i + 1, i] = 1.0
            end
            @test shortest_paths(g) isa ShortestPaths.FloydWarshallResult
            @test shortest_paths(g, w) isa ShortestPaths.FloydWarshallResult
        end
    end

    @testset "Johnson" begin
        g3 = path_graph(5)
        d = Symmetric([0 1 2 3 4; 1 0 6 7 8; 2 6 0 11 12; 3 7 11 0 16; 4 8 12 16 0])
        for g in testgraphs(g3)
            z = @inferred(shortest_paths(g, d, Johnson()))
            @test z.dists[3, :][:] == [7, 6, 0, 11, 27]
            @test z.parents[3, :][:] == [2, 3, 0, 3, 4]

            @test @inferred(paths(z))[2][2] == []
            @test @inferred(paths(z))[2][4] == paths(z, 2)[4] == paths(z, 2, 4) == [2, 3, 4]
        end

        g4 = path_digraph(4)
        for g in testdigraphs(g4)
            z = @inferred(shortest_paths(g, Johnson()))
            @test length(paths(z, 4, 3)) == 0
            @test length(paths(z, 4, 1)) == 0
            @test length(paths(z, 2, 3)) == 2
        end

        g5 = DiGraph([1 1 1 0 1; 0 1 0 1 1; 0 1 1 0 0; 1 0 1 1 0; 0 0 0 1 1])
        d = [0 3 8 0 -4; 0 0 0 1 7; 0 4 0 0 0; 2 0 -5 0 0; 0 0 0 6 0]
        for g in testdigraphs(g5)
            z = @inferred(shortest_paths(g, d, Johnson()))
            @test z.dists == [0 1 -3 2 -4; 3 0 -4 1 -1; 7 4 0 5 3; 2 -1 -5 0 -2; 8 5 1 6 0]
        end
    end

    @testset "SPFA" begin
        @testset "Generic tests for graphs" begin
            g4 = path_digraph(5)
            d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])

            for g in testdigraphs(g4)
                y = @inferred(shortest_paths(g, 2, d1, SPFA()))
                @test y.dists == [Inf, 0, 6, 17, 33]
            end

            @testset "Graph with cycle" begin
                gx = path_graph(5)
                add_edge!(gx, 2, 4)
                d = ones(Int, 5, 5)
                d[2, 3] = 100
                for g in testgraphs(gx)
                    z = @inferred(shortest_paths(g, 1, d, SPFA()))
                    @test z.dists == [0, 1, 3, 2, 3]
                end
            end

            m = [0 2 2 0 0; 2 0 0 0 3; 2 0 0 1 2; 0 0 1 0 1; 0 3 2 1 0]
            G = SimpleGraph(5)
            add_edge!(G, 1, 2)
            add_edge!(G, 1, 3)
            add_edge!(G, 2, 5)
            add_edge!(G, 3, 5)
            add_edge!(G, 3, 4)
            add_edge!(G, 4, 5)

            for g in testgraphs(G)
                y = @inferred(shortest_paths(g, 1, m, SPFA()))
                @test y.dists == [0, 2, 2, 3, 4]
            end
        end

        @testset "Graph with self loop" begin
            G = SimpleGraph(5)
            add_edge!(G, 2, 2)
            add_edge!(G, 1, 2)
            add_edge!(G, 1, 3)
            add_edge!(G, 3, 3)
            add_edge!(G, 1, 5)
            add_edge!(G, 2, 4)
            add_edge!(G, 4, 5)
            m = [0 10 2 0 15; 10 9 0 1 0; 2 0 1 0 0; 0 1 0 0 2; 15 0 0 2 0]
            for g in testgraphs(G)
                z = @inferred(shortest_paths(g, 1, m, SPFA()))
                y = @inferred(dijkstra_shortest_paths(g, 1, m))
                @test isapprox(z.dists, y.dists)
            end
        end

        @testset "Disconnected graph" begin
            G = SimpleGraph(5)
            add_edge!(G, 1, 2)
            add_edge!(G, 1, 3)
            add_edge!(G, 4, 5)
            inf = typemax(eltype(G))
            for g in testgraphs(G)
                z = @inferred(shortest_paths(g, 1, SPFA()))
                @test z.dists == [0, 1, 1, inf, inf]
            end
        end

        @testset "Empty graph" begin
            G = SimpleGraph(3)
            inf = typemax(eltype(G))
            for g in testgraphs(G)
                z = @inferred(shortest_paths(g, 1, SPFA()))
                @test z.dists == [0, inf, inf]
            end
        end

        @testset "Random Graphs" begin
            @testset "Simple graphs" begin
                for seed in 1:5
                    rng = StableRNG(seed)
                    nvg = Int(ceil(250 * rand(rng)))
                    neg = Int(floor((nvg * (nvg - 1) / 2) * rand(rng)))
                    g = SimpleGraph(nvg, neg; rng=rng)
                    z = shortest_paths(g, 1, SPFA())
                    y = dijkstra_shortest_paths(g, 1)
                    @test isapprox(z.dists, y.dists)
                end
            end

            @testset "Simple DiGraphs" begin
                for seed in 1:5
                    rng = StableRNG(seed)
                    nvg = Int(ceil(250 * rand(rng)))
                    neg = Int(floor((nvg * (nvg - 1) / 2) * rand(rng)))
                    g = SimpleDiGraph(nvg, neg; rng=rng)
                    z = shortest_paths(g, 1, SPFA())
                    y = dijkstra_shortest_paths(g, 1)
                    @test isapprox(z.dists, y.dists)
                end
            end
        end

        @testset "Different types of graph" begin
            G = complete_graph(9)
            z = shortest_paths(G, 1, SPFA())
            y = dijkstra_shortest_paths(G, 1)
            @test isapprox(z.dists, y.dists)

            G = complete_digraph(9)
            z = shortest_paths(G, 1, SPFA())
            y = dijkstra_shortest_paths(G, 1)
            @test isapprox(z.dists, y.dists)

            G = cycle_graph(9)
            z = shortest_paths(G, 1, SPFA())
            y = dijkstra_shortest_paths(G, 1)
            @test isapprox(z.dists, y.dists)

            G = cycle_digraph(9)
            z = shortest_paths(G, 1, SPFA())
            y = dijkstra_shortest_paths(G, 1)
            @test isapprox(z.dists, y.dists)

            G = star_graph(9)
            z = shortest_paths(G, 1, SPFA())
            y = dijkstra_shortest_paths(G, 1)
            @test isapprox(z.dists, y.dists)

            G = wheel_graph(9)
            z = shortest_paths(G, 1, SPFA())
            y = dijkstra_shortest_paths(G, 1)
            @test isapprox(z.dists, y.dists)

            G = roach_graph(9)
            z = shortest_paths(G, 1, SPFA())
            y = dijkstra_shortest_paths(G, 1)
            @test isapprox(z.dists, y.dists)

            G = clique_graph(5, 19)
            z = shortest_paths(G, 1, SPFA())
            y = dijkstra_shortest_paths(G, 1)
            @test isapprox(z.dists, y.dists)

            @testset "Small Graphs" begin
                for s in [
                    :bull,
                    :chvatal,
                    :cubical,
                    :desargues,
                    :diamond,
                    :dodecahedral,
                    :frucht,
                    :heawood,
                    :house,
                    :housex,
                    :icosahedral,
                    :krackhardtkite,
                    :moebiuskantor,
                    :octahedral,
                    :pappus,
                    :petersen,
                    :sedgewickmaze,
                    :tutte,
                    :tetrahedral,
                    :truncatedcube,
                    :truncatedtetrahedron,
                    :truncatedtetrahedron_dir,
                ]
                    G = smallgraph(s)
                    z = shortest_paths(G, 1, SPFA())
                    y = dijkstra_shortest_paths(G, 1)
                    @test isapprox(z.dists, y.dists)
                end
            end
        end

        @testset "Normal graph" begin
            g4 = path_digraph(5)

            d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
            d2 = sparse(
                float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
            )
            for g in testdigraphs(g4)
                y = @inferred(shortest_paths(g, 2, d1, SPFA()))
                z = @inferred(shortest_paths(g, 2, d2, SPFA()))
                @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
                @test @inferred(!has_negative_weight_cycle(g, SPFA()))
                @test @inferred(!has_negative_weight_cycle(g, d1, SPFA()))

                y = @inferred(shortest_paths(g, 2, d1, SPFA()))
                z = @inferred(shortest_paths(g, 2, d2, SPFA()))
                @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
                @test @inferred(!has_negative_weight_cycle(g, SPFA()))
                z = @inferred(shortest_paths(g, 2, SPFA()))
                @test z.dists == [typemax(Int), 0, 1, 2, 3]
            end
        end

        @testset "Negative Cycle" begin
            # Negative Cycle 1
            gx = complete_graph(3)
            for g in testgraphs(gx)
                d = [1 -3 1; -3 1 1; 1 1 1]
                @test_throws ShortestPaths.NegativeCycleError shortest_paths(
                    g, 1, d, SPFA()
                )
                @test has_negative_weight_cycle(g, d, SPFA())

                d = [1 -1 1; -1 1 1; 1 1 1]
                @test_throws ShortestPaths.NegativeCycleError shortest_paths(
                    g, 1, d, SPFA()
                )
                @test has_negative_weight_cycle(g, d, SPFA())
            end

            # Negative cycle of length 3 in graph of diameter 4
            gx = complete_graph(4)
            d = [1 -1 1 1; 1 1 1 -1; 1 1 1 1; 1 1 1 1]
            for g in testgraphs(gx)
                @test_throws ShortestPaths.NegativeCycleError shortest_paths(
                    g, 1, d, SPFA()
                )
                @test has_negative_weight_cycle(g, d, SPFA())
            end
        end
    end
end

@testset "Maximal Independent Set" begin
    g0 = SimpleGraph(0)
    for g in testgraphs(g0)
        z = @inferred(independent_set(g, MaximalIndependentSet(); rng=StableRNG(3)))
        @test isempty(z)
    end

    g1 = SimpleGraph(1)
    for g in testgraphs(g1)
        z = @inferred(independent_set(g, MaximalIndependentSet(); rng=StableRNG(3)))
        @test (z == [1])
    end

    add_edge!(g1, 1, 1)
    for g in testgraphs(g1)
        z = @inferred(independent_set(g, MaximalIndependentSet(); rng=StableRNG(3)))
        isempty(z)
    end

    g3 = star_graph(5)
    for g in testgraphs(g3)
        z = @inferred(independent_set(g, MaximalIndependentSet(); rng=StableRNG(3)))
        @test (length(z) == 1 || length(z) == 4)
    end

    g4 = complete_graph(5)
    for g in testgraphs(g4)
        z = @inferred(independent_set(g, MaximalIndependentSet(); rng=StableRNG(3)))
        @test length(z) == 1 # Exactly one vertex
    end

    g5 = path_graph(5)
    for g in testgraphs(g5)
        z = @inferred(independent_set(g, MaximalIndependentSet(); rng=StableRNG(3)))
        sort!(z)
        @test (z == [2, 4] || z == [2, 5] || z == [1, 3, 5] || z == [1, 4])
    end

    add_edge!(g5, 2, 2)
    add_edge!(g5, 3, 3)
    for g in testgraphs(g5)
        z = @inferred(independent_set(g, MaximalIndependentSet(); rng=StableRNG(3)))
        sort!(z)
        @test (z == [4] || z == [5] || z == [1, 5] || z == [1, 4])
    end
end

function _degree_centrality(g::AbstractGraph, gtype::Integer; normalize=true)
    n_v = nv(g)
    c = zeros(n_v)
    for v in vertices(g)
        if gtype == 0    # count both in and out degree if appropriate
            deg = is_directed(g) ? outdegree(g, v) + indegree(g, v) : outdegree(g, v)
        elseif gtype == 1    # count only in degree
            deg = indegree(g, v)
        else                 # count only out degree
            deg = outdegree(g, v)
        end
        s = normalize ? (1.0 / (n_v - 1.0)) : 1.0
        c[v] = deg * s
    end
    return c
end

"""
    degree_centrality(g)
    indegree_centrality(g)
    outdegree_centrality(g)

Calculate the [degree centrality](https://en.wikipedia.org/wiki/Centrality#Degree_centrality)
of graph `g`. Return a vector representing the centrality calculated for each node in `g`.

### Optional Arguments
- `normalize=true`: If true, normalize each centrality measure by ``\\frac{1}{|V|-1}``.

# Examples
```jldoctest
julia> using Graphs

julia> degree_centrality(star_graph(4))
4-element Vector{Float64}:
 1.0               
 0.3333333333333333
 0.3333333333333333
 0.3333333333333333

julia> degree_centrality(path_graph(3))
3-element Vector{Float64}:
 0.5
 1.0
 0.5
```
"""
degree_centrality(g::AbstractGraph; all...) = _degree_centrality(g, 0; all...)
indegree_centrality(g::AbstractGraph; all...) = _degree_centrality(g, 1; all...)
outdegree_centrality(g::AbstractGraph; all...) = _degree_centrality(g, 2; all...)

using Graphs.SimpleGraphs

import Graphs.SimpleGraphs: fadj, badj, adj
import Graphs.edgetype, Graphs.has_edge
using Statistics: mean

struct DummySimpleGraph <: AbstractSimpleGraph{Int} end
struct DummySimpleEdge <: AbstractSimpleEdge{Int} end
DummySimpleEdge(x...) = DummySimpleEdge()
Graphs.edgetype(g::DummySimpleGraph) = DummySimpleEdge
has_edge(::DummySimpleGraph, ::DummySimpleEdge) = true

# function to check if the invariants for SimpleGraph and SimpleDiGraph holds
function isvalid_simplegraph(g::SimpleGraph{T}) where {T<:Integer}
    nf = length(g.fadjlist)
    n = T(nf)
    # checks it the adjacency lists are sorted, free of duplicates and in the correct range
    for u in one(T):n
        listu = g.fadjlist[u]
        isempty(listu) && continue
        issorted(listu) || return false
        allunique(listu) || return false
        issubset(extrema(listu), one(T):n) || return false
    end
    # checks if the edge count is correct
    edge_count = 0
    for u in one(T):n
        listu = g.fadjlist[u]
        for v in listu
            v > u && break
            edge_count += 1
        end
    end
    g.ne == edge_count || return false
    #  checks for backwards edge
    for u in one(T):n
        listu = g.fadjlist[u]
        for v in listu
            Graphs.insorted(u, g.fadjlist[v]) || return false
        end
    end
    return true
end

function isvalid_simplegraph(g::SimpleDiGraph{T}) where {T<:Integer}
    nf = length(g.fadjlist)
    nb = length(g.badjlist)
    nf == nb || return false
    n = T(nf)

    for u in one(T):n
        for listu in (g.fadjlist[u], g.badjlist[u])
            listu = g.fadjlist[u]
            isempty(listu) && continue
            issorted(listu) || return false
            allunique(listu) || return false
            issubset(extrema(listu), one(T):n) || return false
        end
    end
    # checks if the edge count is correct
    edge_count = 0
    for u in one(T):n
        edge_count += length(g.fadjlist[u])
    end
    g.ne == edge_count || return false
    edge_count = 0
    for u in one(T):n
        edge_count += length(g.badjlist[u])
    end
    g.ne == edge_count || return false
    #  checks for backwards edge
    for u in one(T):n
        listu = g.fadjlist[u]
        for v in listu
            Graphs.insorted(u, g.badjlist[v]) || return false
        end
    end
    return true
end

const simplegraphtestdir = dirname(@__FILE__)

const simple_tests = [
    "simplegraphs",
    "simpleedge",
    "simpleedgeiter",
    "specializations",
    "generators/randgraphs",
    "generators/staticgraphs",
    "generators/smallgraphs",
    "generators/euclideangraphs",
]

@testset "Graphs.SimpleGraphs" begin
    for t in simple_tests
        tp = joinpath(simplegraphtestdir, "$(t).jl")
        include(tp)
    end
end

@testset "Biconnect" begin
    gint = SimpleGraph(12)
    add_edge!(gint, 1, 2)
    add_edge!(gint, 2, 3)
    add_edge!(gint, 2, 4)
    add_edge!(gint, 3, 4)
    add_edge!(gint, 3, 5)
    add_edge!(gint, 4, 5)
    add_edge!(gint, 2, 6)
    add_edge!(gint, 1, 7)
    add_edge!(gint, 6, 7)
    add_edge!(gint, 6, 8)
    add_edge!(gint, 6, 9)
    add_edge!(gint, 8, 9)
    add_edge!(gint, 9, 10)
    add_edge!(gint, 11, 12)

    a = [
        [Edge(3, 5), Edge(4, 5), Edge(2, 4), Edge(3, 4), Edge(2, 3)],
        [Edge(9, 10)],
        [Edge(6, 9), Edge(8, 9), Edge(6, 8)],
        [Edge(1, 7), Edge(6, 7), Edge(2, 6), Edge(1, 2)],
        [Edge(11, 12)],
    ]

    for g in test_generic_graphs(gint)
        bcc = @inferred(biconnected_components(g))
        @test bcc == a
        @test typeof(bcc) === Vector{Vector{Edge{eltype(g)}}}
    end

    g = SimpleGraph(4)
    add_edge!(g, 1, 2)
    add_edge!(g, 2, 3)
    add_edge!(g, 3, 4)
    add_edge!(g, 1, 4)

    h = SimpleGraph(4)
    add_edge!(h, 1, 2)
    add_edge!(h, 2, 3)
    add_edge!(h, 3, 4)
    add_edge!(h, 1, 4)

    gint = blockdiag(g, h)
    add_edge!(gint, 4, 5)

    a = [
        [Edge(5, 8), Edge(7, 8), Edge(6, 7), Edge(5, 6)],
        [Edge(4, 5)],
        [Edge(1, 4), Edge(3, 4), Edge(2, 3), Edge(1, 2)],
    ]

    for g in test_generic_graphs(gint)
        bcc = @inferred(biconnected_components(g))
        @test bcc == a
        @test typeof(bcc) === Vector{Vector{Edge{eltype(g)}}}
    end

    # Non regression test for #13
    g = complete_graph(4)
    a = [[Edge(2, 4), Edge(1, 4), Edge(3, 4), Edge(1, 3), Edge(2, 3), Edge(1, 2)]]
    bcc = @inferred(biconnected_components(GenericGraph(g)))
    @test bcc == a
end

@testset "Eigenvector" begin
    g1 = smallgraph(:house)
    g2 = cycle_digraph(4)

    for g in test_generic_graphs(g1)
        y = @inferred(eigenvector_centrality(g))
        @test round.(y, digits=3) ==
            round.(
            [
                0.3577513877490464,
                0.3577513877490464,
                0.5298987782873977,
                0.5298987782873977,
                0.4271328349194304,
            ],
            digits=3,
        )
    end
    for g in test_generic_graphs(g2)
        y = @inferred(eigenvector_centrality(g))
        @test round.(y, digits=3) == round.([0.5, 0.5, 0.5, 0.5], digits=3)
    end
end

"""
    generate_reduce(g, gen_func, comp, reps; parallel=:threads)

Compute `gen_func(g)` `reps` times and return the instance `best` for which
`comp(best, v)` is true where `v` is all the other instances of `gen_func(g)`.

For example, `comp(x, y) = length(x) < length(y) ? x : y` then instance with the smallest
length will be returned.
"""
function generate_reduce(
    g::AbstractGraph{T}, gen_func::Function, comp::Comp, reps::Integer; parallel=:threads
) where {T<:Integer,Comp}
    return if parallel == :threads
        threaded_generate_reduce(g, gen_func, comp, reps)
    else
        distr_generate_reduce(g, gen_func, comp, reps)
    end
end

"""
    distr_generate_min_set(g, gen_func, comp, reps)

Distributed implementation of [`generate_reduce`](@ref).
"""
function distr_generate_reduce(args...; kwargs...)
    return error(
        "`parallel = :distributed` requested, but SharedArrays or Distributed is not loaded"
    )
end

"""
    threaded_generate_reduce(g, gen_func, comp reps)

Multi-threaded implementation of [`generate_reduce`](@ref).
"""
function threaded_generate_reduce(
    g::AbstractGraph{T}, gen_func::Function, comp::Comp, reps::Integer
) where {T<:Integer,Comp}
    d, r = divrem(reps, Threads.nthreads())
    ntasks = d == 0 ? r : Threads.nthreads()
    min_set = [Vector{T}() for _ in 1:ntasks]
    is_undef = ones(Bool, ntasks)
    task_size = cld(reps, ntasks)

    @sync for (t, task_range) in enumerate(Iterators.partition(1:reps, task_size))
        Threads.@spawn for _ in task_range
            next_set = gen_func(g)
            if is_undef[t] || comp(next_set, min_set[t])
                min_set[t] = next_set
                is_undef[t] = false
            end
        end
    end

    min_ind = 0
    for i in filter((j) -> !is_undef[j], 1:ntasks)
        if min_ind == 0 || comp(min_set[i], min_set[min_ind])
            min_ind = i
        end
    end

    return min_set[min_ind]
end

@testset "DFS" begin
    gnodes_directed = SimpleDiGraph(4)
    gnodes_undirected = SimpleGraph(4)
    gloop_directed = SimpleDiGraph(1)
    add_edge!(gloop_directed, 1, 1)
    gloop_undirected = SimpleGraph(1)
    add_edge!(gloop_undirected, 1, 1)
    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)
    gx = cycle_digraph(3)
    gcyclic = SimpleGraph([0 1 1 0 0; 1 0 1 0 0; 1 1 0 0 0; 0 0 0 0 1; 0 0 0 1 0])
    gtree = SimpleGraph(
        [
            0 1 1 1 0 0 0
            1 0 0 0 0 0 0
            1 0 0 0 0 0 0
            1 0 0 0 1 1 1
            0 0 0 1 0 0 0
            0 0 0 1 0 0 0
            0 0 0 1 0 0 0
        ],
    )
    # non regression test following https://github.com/JuliaGraphs/Graphs.jl/pull/266#issuecomment-1621698039
    g6 = SimpleDiGraph(4)
    add_edge!(g6, 1, 2)
    add_edge!(g6, 2, 3)
    add_edge!(g6, 2, 4)
    add_edge!(g6, 4, 3)
    g7 = copy(g6)
    add_edge!(g7, 3, 4)

    @testset "dfs_tree" begin
        for g in testdigraphs(g5)
            z = @inferred(dfs_tree(GenericDiGraph(g), 1))
            @test ne(z) == 3 && nv(z) == 4
            @test !has_edge(z, 1, 3)
            @test !is_cyclic(g)
        end
    end

    @testset "topological_sort" begin
        for g in testdigraphs(SimpleDiGraph([Edge(2, 1)]))
            @test @inferred(topological_sort(g)) == [2, 1]
        end

        for g in testdigraphs(g5)
            @test @inferred(topological_sort(g)) == [1, 2, 3, 4]
        end

        for g in testdigraphs(gx)
            @test @inferred(is_cyclic(g))
            @test_throws ErrorException topological_sort(g)
        end

        # non regression test following https://github.com/JuliaGraphs/Graphs.jl/pull/266#issuecomment-1621698039
        for g in testdigraphs(g6)
            @test @inferred(topological_sort(g)) == [1, 2, 4, 3]
        end
    end

    @testset "topological_sort_by_dfs" begin
        for g in testdigraphs(g5)
            @test @inferred(topological_sort_by_dfs(GenericDiGraph(g))) == [1, 2, 3, 4]
        end

        for g in testdigraphs(gx)
            @test @inferred(is_cyclic(GenericDiGraph(g)))
            @test_throws ErrorException topological_sort_by_dfs(GenericDiGraph(g))
        end
    end

    @testset "is_cyclic" begin
        for g in testgraphs(path_graph(2))
            @test !@inferred(is_cyclic(GenericGraph(g)))
            @test !@inferred(is_cyclic(GenericGraph(zero(g))))
        end
        for g in testgraphs(gcyclic)
            @test @inferred(is_cyclic(g))
        end
        for g in testgraphs(gtree)
            @test !@inferred(is_cyclic(g))
        end
        for g in testgraphs(g5)
            @test !@inferred(is_cyclic(g))
        end
        for g in testgraphs(gnodes_directed)
            @test !@inferred(is_cyclic(g))
        end
        for g in testgraphs(gnodes_undirected)
            @test !@inferred(is_cyclic(g))
        end
        for g in testgraphs(gloop_directed)
            @test @inferred(is_cyclic(g))
        end
        for g in testgraphs(gloop_undirected)
            @test @inferred(is_cyclic(g))
        end
        # non regression test following https://github.com/JuliaGraphs/Graphs.jl/pull/266#issuecomment-1621698039
        for g in testdigraphs(g7)
            @test @inferred(is_cyclic(g))
        end
    end
end

# TODO most of the operators here do not work with any AbstractGraph yet
# as they require cloning and modifying graphs.

"""
	complement(g)

Return the [graph complement](https://en.wikipedia.org/wiki/Complement_graph)
of a graph

### Implementation Notes
Preserves the `eltype` of the input graph.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> foreach(println, edges(complement(g)))
Edge 1 => 3
Edge 1 => 4
Edge 1 => 5
Edge 2 => 1
Edge 2 => 4
Edge 2 => 5
Edge 3 => 2
Edge 3 => 5
Edge 4 => 1
Edge 4 => 2
Edge 4 => 3
Edge 5 => 1
Edge 5 => 2
Edge 5 => 3
```
"""
function complement(g::Graph)
    gnv = nv(g)
    h = SimpleGraph(gnv)
    for i in 1:gnv
        for j in (i + 1):gnv
            if !has_edge(g, i, j)
                add_edge!(h, i, j)
            end
        end
    end
    return h
end

function complement(g::DiGraph)
    gnv = nv(g)
    h = SimpleDiGraph(gnv)
    for i in vertices(g), j in vertices(g)
        if i != j && !has_edge(g, i, j)
            add_edge!(h, i, j)
        end
    end
    return h
end

"""
	reverse(g)

Return a directed graph where all edges are reversed from the
original directed graph.

### Implementation Notes
Preserves the eltype of the input graph.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> foreach(println, edges(reverse(g)))
Edge 1 => 3
Edge 2 => 1
Edge 3 => 2
Edge 4 => 3
Edge 4 => 5
Edge 5 => 4
```
"""
function reverse end
@traitfn function reverse(g::G::IsDirected) where {G<:AbstractSimpleGraph}
    gnv = nv(g)
    gne = ne(g)
    h = SimpleDiGraph(gnv)
    h.fadjlist = deepcopy_adjlist(g.badjlist)
    h.badjlist = deepcopy_adjlist(g.fadjlist)
    h.ne = gne
    return h
end

"""
	reverse!(g)

In-place reverse of a directed graph (modifies the original graph).
See [`reverse`](@ref) for a non-modifying version.
"""
function reverse! end
@traitfn function reverse!(g::G::IsDirected) where {G<:AbstractSimpleGraph}
    g.fadjlist, g.badjlist = g.badjlist, g.fadjlist
    return g
end

"""
	blockdiag(g, h)

Return a graph with ``|V(g)| + |V(h)|`` vertices and ``|E(g)| + |E(h)|``
edges where the vertices and edges from graph `h` are appended to graph `g`.

### Implementation Notes
Preserves the eltype of the input graph. Will error if the
number of vertices in the generated graph exceeds the `eltype`.

# Examples
```jldoctest
julia> using Graphs

julia> g1 = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> g2 = SimpleDiGraph([0 1 0; 0 0 1; 1 0 0]);

julia> blockdiag(g1, g2)
{8, 9} directed simple Int64 graph

julia> foreach(println, edges(blockdiag(g1, g2)))
Edge 1 => 2
Edge 2 => 3
Edge 3 => 1
Edge 3 => 4
Edge 4 => 5
Edge 5 => 4
Edge 6 => 7
Edge 7 => 8
Edge 8 => 6
```
"""
function blockdiag(g::T, h::T) where {T<:AbstractGraph}
    gnv = nv(g)
    r = T(gnv + nv(h))
    for e in edges(g)
        add_edge!(r, e)
    end
    for e in edges(h)
        add_edge!(r, gnv + src(e), gnv + dst(e))
    end
    return r
end

"""
	intersect(g, h)

Return a graph with edges that are only in both graph `g` and graph `h`.

### Implementation Notes
This function may produce a graph with 0-degree vertices.
Preserves the eltype of the input graph.

# Examples
```jldoctest
julia> using Graphs

julia> g1 = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> g2 = SimpleDiGraph([0 1 0; 0 0 1; 1 0 0]);

julia> foreach(println, edges(intersect(g1, g2)))
Edge 1 => 2
Edge 2 => 3
Edge 3 => 1
```
"""
function intersect(g::T, h::T) where {T<:AbstractGraph}
    gnv = nv(g)
    hnv = nv(h)

    r = T(min(gnv, hnv))
    for e in intersect(edges(g), edges(h))
        add_edge!(r, e)
    end
    return r
end

"""
	difference(g, h)

Return a graph with edges in graph `g` that are not in graph `h`.

### Implementation Notes
Note that this function may produce a graph with 0-degree vertices.
Preserves the `eltype` of the input graph.

# Examples
```jldoctest
julia> using Graphs

julia> g1 = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> g2 = SimpleDiGraph([0 1 0; 0 0 1; 1 0 0]);

julia> foreach(println, edges(difference(g1, g2)))
Edge 3 => 4
Edge 4 => 5
Edge 5 => 4
```
"""
function difference(g::T, h::T) where {T<:AbstractGraph}
    gnv = nv(g)
    hnv = nv(h)

    r = T(gnv)
    for e in edges(g)
        !has_edge(h, e) && add_edge!(r, e)
    end
    return r
end

"""
	symmetric_difference(g, h)

Return a graph with edges from graph `g` that do not exist in graph `h`,
and vice versa.

### Implementation Notes
Note that this function may produce a graph with 0-degree vertices.
Preserves the eltype of the input graph. Will error if the
number of vertices in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(3); h = SimpleGraph(3);

julia> add_edge!(g, 1, 2);

julia> add_edge!(h, 1, 3);

julia> add_edge!(h, 2, 3);

julia> f = symmetric_difference(g, h);

julia> collect(edges(f))
3-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3
 Edge 2 => 3
```
"""
function symmetric_difference(g::T, h::T) where {T<:AbstractGraph}
    gnv = nv(g)
    hnv = nv(h)

    r = T(max(gnv, hnv))
    for e in edges(g)
        !has_edge(h, e) && add_edge!(r, e)
    end
    for e in edges(h)
        !has_edge(g, e) && add_edge!(r, e)
    end
    return r
end

"""
	union(g, h)

Return a graph that combines graphs `g` and `h` by taking the set union
of all vertices and edges.

### Implementation Notes
Preserves the eltype of the input graph. Will error if the
number of vertices in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(3); h = SimpleGraph(5);

julia> add_edge!(g, 1, 2);

julia> add_edge!(g, 1, 3);

julia> add_edge!(h, 3, 4);

julia> add_edge!(h, 3, 5);

julia> add_edge!(h, 4, 5);

julia> f = union(g, h);

julia> collect(edges(f))
5-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3
 Edge 3 => 4
 Edge 3 => 5
 Edge 4 => 5
```
"""
function union(g::T, h::T) where {T<:AbstractSimpleGraph}
    gnv = nv(g)
    hnv = nv(h)

    r = T(max(gnv, hnv))
    r.ne = ne(g)
    for i in vertices(g)
        r.fadjlist[i] = deepcopy(g.fadjlist[i])
        if is_directed(g)
            r.badjlist[i] = deepcopy(g.badjlist[i])
        end
    end
    for e in edges(h)
        add_edge!(r, e)
    end
    return r
end

"""
	join(g, h)

Return a graph that combines graphs `g` and `h` using `blockdiag` and then
adds all the edges between the vertices in `g` and those in `h`.

### Implementation Notes
Preserves the eltype of the input graph. Will error if the number of vertices
in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> g = join(star_graph(3), path_graph(2))
{5, 9} undirected simple Int64 graph

julia> collect(edges(g))
9-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3
 Edge 1 => 4
 Edge 1 => 5
 Edge 2 => 4
 Edge 2 => 5
 Edge 3 => 4
 Edge 3 => 5
 Edge 4 => 5
```
"""
function join(g::T, h::T) where {T<:AbstractGraph}
    r = blockdiag(g, h)
    for i in vertices(g)
        for j in (nv(g) + 1):(nv(g) + nv(h))
            add_edge!(r, i, j)
        end
    end
    return r
end

"""
	crosspath(len::Integer, g::Graph)

Return a graph that duplicates `g` `len` times and connects each vertex
with its copies in a path.

### Implementation Notes
Preserves the eltype of the input graph. Will error if the number of vertices
in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> g = crosspath(3, path_graph(3))
{9, 12} undirected simple Int64 graph

julia> collect(edges(g))
12-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 4
 Edge 2 => 3
 Edge 2 => 5
 Edge 3 => 6
 Edge 4 => 5
 Edge 4 => 7
 Edge 5 => 6
 Edge 5 => 8
 Edge 6 => 9
 Edge 7 => 8
 Edge 8 => 9
```
"""
function crosspath end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function crosspath(
    len::Integer, g::AG::(!IsDirected)
) where {T,AG<:AbstractGraph{T}}
    p = path_graph(len)
    h = SimpleGraph{T}(p)
    return cartesian_product(h, g)
end

# The following operators allow one to use a Graphs.Graph as a matrix in eigensolvers for spectral ranking and partitioning.
# """Provides multiplication of a graph `g` by a vector `v` such that spectral
# graph functions in [GraphMatrices.jl](https://github.com/jpfairbanks/GraphMatrices.jl) can utilize Graphs natively.
# """
function *(g::AbstractGraph, v::Vector{T}) where {T<:Number}
    length(v) == nv(g) || throw(ArgumentError("Vector size must equal number of vertices"))
    y = zeros(T, nv(g))
    for e in edges(g)
        i = src(e)
        j = dst(e)
        y[i] += v[j]
        if !is_directed(g)
            y[j] += v[i]
        end
    end
    return y
end

"""
	sum(g, i)

Return a vector of indegree (`i`=1) or outdegree (`i`=2) values for graph `g`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> sum(g, 2)
5-element Vector{Int64}:
 1
 1
 2
 1
 1

julia> sum(g, 1)
5-element Vector{Int64}:
 1
 1
 1
 2
 1
```
"""
function sum(g::AbstractGraph, dim::Int)
    dim == 1 && return indegree(g, vertices(g))
    dim == 2 && return outdegree(g, vertices(g))
    throw(ArgumentError("dimension must be <= 2"))
end

size(g::AbstractGraph) = (nv(g), nv(g))
"""
	size(g, i)

Return the number of vertices in `g` if `i`=1 or `i`=2, or `1` otherwise.

# Examples
```jldoctest
julia> using Graphs

julia> g = cycle_graph(4);

julia> size(g, 1)
4

julia> size(g, 2)
4

julia> size(g, 3)
1
```
"""
size(g::AbstractGraph, dim::Int) = (dim == 1 || dim == 2) ? nv(g) : 1

"""
	sum(g)

Return the number of edges in `g`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph([0 1 0; 1 0 1; 0 1 0]);

julia> sum(g)
2
```
"""
sum(g::AbstractGraph) = ne(g)

"""
	sparse(g)

Return the default adjacency matrix of `g`.
"""
sparse(g::AbstractGraph) = adjacency_matrix(g)

length(g::AbstractGraph) = widen(nv(g)) * widen(nv(g))
ndims(g::AbstractGraph) = 2

@traitfn function issymmetric(g::AG) where {AG<:AbstractGraph;!IsDirected{AG}}
    return true
end

@traitfn function issymmetric(g::AG) where {AG<:AbstractGraph;IsDirected{AG}}
    for e in edges(g)
        if !has_edge(g, reverse(e))
            return false
        end
    end
    return true
end

"""
	cartesian_product(g, h)

Return the [cartesian product](https://en.wikipedia.org/wiki/Cartesian_product_of_graphs)
of `g` and `h`.

The cartesian product has edges (g₁, h₁) ∼ (g₂, h₂) when
(g₁ = g₂ ∧ h₁ ∼ h₂) ∨ (g₁ ∼ g₂ ∧ h₁ = h₂).

### Implementation Notes
Preserves the eltype of the input graph. Will error if the number of vertices
in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> g = cartesian_product(star_graph(3), path_graph(3))
{9, 12} undirected simple Int64 graph

julia> collect(edges(g))
12-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 4
 Edge 1 => 7
 Edge 2 => 3
 Edge 2 => 5
 Edge 2 => 8
 Edge 3 => 6
 Edge 3 => 9
 Edge 4 => 5
 Edge 5 => 6
 Edge 7 => 8
 Edge 8 => 9
```
"""
function cartesian_product(g::G, h::G) where {G<:AbstractGraph}
    z = G(nv(g) * nv(h))
    id(i, j) = (i - 1) * nv(h) + j
    for e in edges(g)
        i1, i2 = Tuple(e)
        for j in 1:nv(h)
            add_edge!(z, id(i1, j), id(i2, j))
        end
    end

    for e in edges(h)
        j1, j2 = Tuple(e)
        for i in vertices(g)
            add_edge!(z, id(i, j1), id(i, j2))
        end
    end
    return z
end

"""
	tensor_product(g, h)

Return the [tensor product](https://en.wikipedia.org/wiki/Tensor_product_of_graphs)
of `g` and `h`.

The tensor product has edges (g₁, h₁) ∼ (g₂, h₂) when g₁ ∼ g₂ ∧ h₁ ∼ h₂.

### Implementation Notes
Preserves the eltype of the input graph. Will error if the number of vertices
in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> g = tensor_product(star_graph(3), path_graph(3))
{9, 8} undirected simple Int64 graph

julia> collect(edges(g))
8-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 5
 Edge 1 => 8
 Edge 2 => 4
 Edge 2 => 6
 Edge 2 => 7
 Edge 2 => 9
 Edge 3 => 5
 Edge 3 => 8
```
"""
function tensor_product(g::G, h::G) where {G<:AbstractGraph}
    z = G(nv(g) * nv(h))
    id(i, j) = (i - 1) * nv(h) + j
    undirected = !is_directed(g)
    for e1 in edges(g)
        i1, i2 = Tuple(e1)
        for e2 in edges(h)
            j1, j2 = Tuple(e2)
            add_edge!(z, id(i1, j1), id(i2, j2))
            if undirected
                add_edge!(z, id(i1, j2), id(i2, j1))
            end
        end
    end
    return z
end

"""
    strong_product(g, h)

Return the [strong product](https://en.wikipedia.org/wiki/Strong_product_of_graphs)
of `g` and `h`.

The strong product has edges (g₁, h₁) ∼ (g₂, h₂) when
(g₁ = g₂ ∧ h₁ ∼ h₂) ∨ (g₁ ∼ g₂ ∧ h₁ = h₂) ∨ (g₁ ∼ g₂ ∧ h₁ ∼ h₂).

### Implementation Notes
Preserves the eltype of the input graph. Will error if the number of vertices
in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> a = star_graph(3);

julia> b = path_graph(3);

julia> g = strong_product(a, b)
{9, 20} undirected simple Int64 graph

julia> g == union(cartesian_product(a, b), tensor_product(a, b))
true
```
"""
function strong_product(g::G, h::G) where {G<:AbstractSimpleGraph}
    z = G(nv(g) * nv(h))
    id(i, j) = (i - 1) * nv(h) + j
    undirected = !is_directed(g)
    for e1 in edges(g)
        i1, i2 = Tuple(e1)
        for e2 in edges(h)
            j1, j2 = Tuple(e2)
            add_edge!(z, id(i1, j1), id(i2, j2))
            if undirected
                add_edge!(z, id(i1, j2), id(i2, j1))
            end
        end
    end
    for e in edges(g)
        i1, i2 = Tuple(e)
        for j in vertices(h)
            add_edge!(z, id(i1, j), id(i2, j))
        end
    end
    for e in edges(h)
        j1, j2 = Tuple(e)
        for i in vertices(g)
            add_edge!(z, id(i, j1), id(i, j2))
        end
    end
    return z
end

"""
    disjunctive_product(g, h)

Return the [disjunctive product](https://en.wikipedia.org/wiki/Graph_product)
of `g` and `h`.

The disjunctive product has edges (g₁, h₁) ∼ (g₂, h₂) when g₁ ∼ g₂ ∨ h₁ ∼ h₂.

### Implementation Notes
Preserves the eltype of the input graph. Will error if the number of vertices
in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> a = star_graph(3);

julia> b = path_graph(3);

julia> g = disjunctive_product(a, b)
{9, 28} undirected simple Int64 graph

julia> complement(g) == strong_product(complement(a), complement(b))
true
```
"""
function disjunctive_product(g::G, h::G) where {G<:AbstractSimpleGraph}
    z = G(nv(g) * nv(h))
    id(i, j) = (i - 1) * nv(h) + j
    for e in edges(g)
        i1, i2 = Tuple(e)
        for j in vertices(h)
            for k in vertices(h)
                add_edge!(z, id(i1, j), id(i2, k))
            end
        end
    end
    for e in edges(h)
        j1, j2 = Tuple(e)
        for i in vertices(g)
            for k in vertices(g)
                add_edge!(z, id(i, j1), id(k, j2))
            end
        end
    end
    return z
end

"""
    lexicographic_product(g, h)

Return the [lexicographic product](https://en.wikipedia.org/wiki/Lexicographic_product_of_graphs)
of `g` and `h`.

The lexicographic product has edges (g₁, h₁) ∼ (g₂, h₂) when (g₁ ∼ g₂) ∨ (g₁ = g₂ ∧ h₁ ∼ h₂).

### Implementation Notes
Preserves the eltype of the input graph. Will error if the number of vertices
in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> g = lexicographic_product(star_graph(3), path_graph(3))
{9, 24} undirected simple Int64 graph

julia> adjacency_matrix(g)
9×9 SparseArrays.SparseMatrixCSC{Int64, Int64} with 48 stored entries:
 ⋅  1  ⋅  1  1  1  1  1  1
 1  ⋅  1  1  1  1  1  1  1
 ⋅  1  ⋅  1  1  1  1  1  1
 1  1  1  ⋅  1  ⋅  ⋅  ⋅  ⋅
 1  1  1  1  ⋅  1  ⋅  ⋅  ⋅
 1  1  1  ⋅  1  ⋅  ⋅  ⋅  ⋅
 1  1  1  ⋅  ⋅  ⋅  ⋅  1  ⋅
 1  1  1  ⋅  ⋅  ⋅  1  ⋅  1
 1  1  1  ⋅  ⋅  ⋅  ⋅  1  ⋅
```
"""
function lexicographic_product(g::G, h::G) where {G<:AbstractSimpleGraph}
    z = G(nv(g) * nv(h))
    id(i, j) = (i - 1) * nv(h) + j
    for e in edges(g)
        i1, i2 = Tuple(e)
        for j in vertices(h)
            for k in vertices(h)
                add_edge!(z, id(i1, j), id(i2, k))
            end
        end
    end
    for e in edges(h)
        j1, j2 = Tuple(e)
        for i in vertices(g)
            add_edge!(z, id(i, j1), id(i, j2))
        end
    end
    return z
end

"""
    homomorphic_product(g, h)

Return the [homomorphic product](https://en.wikipedia.org/wiki/Graph_product)
of `g` and `h`.

The homomorphic product has edges (g₁, h₁) ∼ (g₂, h₂) when
(g₁ = g₂) ∨ (g₁ ∼ g₂ ∧ h₁ ≁ h₂).

### Implementation Notes
Preserves the eltype of the input graph. Will error if the number of vertices
in the generated graph exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> g = homomorphic_product(star_graph(3), path_graph(3))
{9, 19} undirected simple Int64 graph

julia> adjacency_matrix(g)
9×9 SparseArrays.SparseMatrixCSC{Int64, Int64} with 38 stored entries:
 ⋅  1  1  1  ⋅  1  1  ⋅  1
 1  ⋅  1  ⋅  1  ⋅  ⋅  1  ⋅
 1  1  ⋅  1  ⋅  1  1  ⋅  1
 1  ⋅  1  ⋅  1  1  ⋅  ⋅  ⋅
 ⋅  1  ⋅  1  ⋅  1  ⋅  ⋅  ⋅
 1  ⋅  1  1  1  ⋅  ⋅  ⋅  ⋅
 1  ⋅  1  ⋅  ⋅  ⋅  ⋅  1  1
 ⋅  1  ⋅  ⋅  ⋅  ⋅  1  ⋅  1
 1  ⋅  1  ⋅  ⋅  ⋅  1  1  ⋅
```
"""
function homomorphic_product(g::G, h::G) where {G<:AbstractSimpleGraph}
    z = G(nv(g) * nv(h))
    id(i, j) = (i - 1) * nv(h) + j
    undirected = !is_directed(g)
    for i in vertices(g)
        for j in vertices(h)
            for k in vertices(h)
                if k != j
                    add_edge!(z, id(i, j), id(i, k))
                end
            end
        end
    end
    cmpl_h = complement(h)
    for e in edges(g)
        i1, i2 = Tuple(e)
        for f in edges(cmpl_h)
            j1, j2 = Tuple(f)
            add_edge!(z, id(i1, j1), id(i2, j2))
            if undirected
                add_edge!(z, id(i1, j2), id(i2, j1))
            end
        end
        for j in vertices(h)
            add_edge!(z, id(i1, j), id(i2, j))
        end
    end
    return z
end

## subgraphs ###

"""
	induced_subgraph(g, vlist)
	induced_subgraph(g, elist)

Return the subgraph of `g` induced by the vertices in  `vlist` or edges in `elist`
along with a vector mapping the new vertices to the old ones
(the  vertex `i` in the subgraph corresponds to the vertex `vmap[i]` in `g`.)

The returned graph has `length(vlist)` vertices, with the new vertex `i`
corresponding to the vertex of the original graph in the `i`-th position
of `vlist`.

### Usage Examples
```doctestjl
julia> g = complete_graph(10)

julia> sg, vmap = induced_subgraph(g, 5:8)

julia> @assert g[5:8] == sg

julia> @assert nv(sg) == 4

julia> @assert ne(sg) == 6

julia> @assert vm[4] == 8

julia> sg, vmap = induced_subgraph(g, [2,8,3,4])

julia> @assert sg == g[[2,8,3,4]]

julia> elist = [Edge(1,2), Edge(3,4), Edge(4,8)]

julia> sg, vmap = induced_subgraph(g, elist)

julia> @assert sg == g[elist]
```
"""
function induced_subgraph(
    g::T, vlist::AbstractVector{U}
) where {T<:AbstractGraph} where {U<:Integer}
    allunique(vlist) || throw(ArgumentError("Vertices in subgraph list must be unique"))
    h = T(length(vlist))
    newvid = Dict{U,U}()
    vmap = Vector{U}(undef, length(vlist))
    for (i, v) in enumerate(vlist)
        newvid[v] = U(i)
        vmap[i] = v
    end

    vset = Set(vlist)
    for s in vlist
        for d in outneighbors(g, s)
            # println("s = $s, d = $d")
            if d in vset && has_edge(g, s, d)
                newe = Edge(newvid[s], newvid[d])
                add_edge!(h, newe)
            end
        end
    end
    return h, vmap
end

function induced_subgraph(g::AbstractGraph, vlist::AbstractVector{Bool})
    length(vlist) == length(g) || throw(BoundsError(g, vlist))
    return induced_subgraph(g, findall(vlist))
end

function induced_subgraph(
    g::AG, elist::AbstractVector{U}
) where {AG<:AbstractGraph{T}} where {T} where {U<:AbstractEdge}
    h = zero(g)
    newvid = Dict{T,T}()
    vmap = Vector{T}()

    for e in elist
        u, v = Tuple(e)
        for i in (u, v)
            if !haskey(newvid, i)
                add_vertex!(h)
                newvid[i] = nv(h)
                push!(vmap, i)
            end
        end
        add_edge!(h, newvid[u], newvid[v])
    end
    return h, vmap
end

"""
	g[iter]

Return the subgraph induced by `iter`.
Equivalent to [`induced_subgraph`](@ref)`(g, iter)[1]`.
"""
getindex(g::AbstractGraph, iter) = induced_subgraph(g, iter)[1]

"""
	egonet(g, v, d, distmx=weights(g))

Return the subgraph of `g` induced by the neighbors of `v` up to distance
`d`, using weights (optionally) provided by `distmx`.
This is equivalent to [`induced_subgraph`](@ref)`(g, neighborhood(g, v, d, dir=dir))[1].`

### Optional Arguments
- `dir=:out`: if `g` is directed, this argument specifies the edge direction
with respect to `v` (i.e. `:in` or `:out`).
"""
function egonet(
    g::AbstractGraph{T},
    v::Integer,
    d::Integer,
    distmx::AbstractMatrix{U}=weights(g);
    dir=:out,
) where {T<:Integer} where {U<:Real}
    return g[neighborhood(g, v, d, distmx; dir=dir)]
end

"""
	compute_shifts(n::Int, x::AbstractArray)

Determine how many elements of `x` are less than `i` for all `i` in `1:n`.
"""
function compute_shifts(n::Integer, x::AbstractArray)
    tmp = zeros(eltype(x), n)
    tmp[x] .= 1
    return cumsum!(tmp, tmp)
end

"""
	merge_vertices(g::AbstractGraph, vs)

Create a new graph where all vertices in `vs` have been aliased to the same vertex `minimum(vs)`.

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(5);

julia> collect(edges(g))
4-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 3
 Edge 3 => 4
 Edge 4 => 5

julia> h = merge_vertices(g, [2, 3]);

julia> collect(edges(h))
3-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 3
 Edge 3 => 4
```
"""
function merge_vertices(g::G, vs) where {G<:AbstractSimpleGraph}
    # Use lowest value as new vertex id.
    vs = unique!(sort(vs))
    merged_vertex = popfirst!(vs)

    nvnew = nv(g) - length(vs)
    nvnew <= nv(g) || return g
    merged_vertex > 0 || throw(
        ArgumentError("invalid vertex ID: $merged_vertex in list of vertices to be merged"),
    )
    vs[end] <= nv(g) || throw(ArgumentError("vertex $(vs[end]) not found in graph")) # TODO 0.7: change to DomainError?

    new_vertex_ids = collect(vertices(g)) .- compute_shifts(nv(g), vs)
    new_vertex_ids[vs] .= merged_vertex

    # if v in vs then labels[v] == v0 else labels[v] == v
    newg = G(nvnew)
    for e in edges(g)
        u, w = src(e), dst(e)
        if new_vertex_ids[u] != new_vertex_ids[w] # not a new self loop
            add_edge!(newg, new_vertex_ids[u], new_vertex_ids[w])
        end
    end
    return newg
end

"""
	merge_vertices!(g, vs)

Combine vertices specified in `vs` into single vertex whose
index will be the lowest value in `vs`. All edges connected to vertices in `vs`
connect to the new merged vertex.

Return a vector with new vertex values are indexed by the original vertex indices.

### Implementation Notes
Supports [`SimpleGraph`](@ref) only.

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(5);

julia> collect(edges(g))
4-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 3
 Edge 3 => 4
 Edge 4 => 5

julia> merge_vertices!(g, [2, 3])
5-element Vector{Int64}:
 1
 2
 2
 3
 4

julia> collect(edges(g))
3-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 3
 Edge 3 => 4
```
"""
function merge_vertices!(g::Graph{T}, vs::Vector{U} where {U<:Integer}) where {T}
    vs = unique!(sort(vs))
    (merged_vertex, vm) = extrema(vs)

    merged_vertex > 0 || throw(
        ArgumentError("invalid vertex ID: $merged_vertex in list of vertices to be merged"),
    )
    vm <= nv(g) || throw(ArgumentError("vertex $vm not found in graph")) # TODO 0.7: change to DomainError?

    new_vertex_ids = collect(vertices(g)) .- compute_shifts(nv(g), vs[2:end])
    new_vertex_ids[vs] .= merged_vertex

    for i in vertices(g)
        # Adjust connections to merged vertices
        if new_vertex_ids[i] != merged_vertex
            nbrs_to_rewire = Set{T}()
            for j in outneighbors(g, i)
                push!(nbrs_to_rewire, new_vertex_ids[j])
            end
            g.fadjlist[new_vertex_ids[i]] = sort!(collect(nbrs_to_rewire))

            # Collect connections to new merged vertex
        else
            nbrs_to_merge = Set{T}()
            for j in vs, e in outneighbors(g, j)
                if new_vertex_ids[e] != merged_vertex
                    push!(nbrs_to_merge, new_vertex_ids[e])
                end
            end
            g.fadjlist[i] = sort(collect(nbrs_to_merge))
        end
    end

    # Drop excess vertices
    g.fadjlist = g.fadjlist[firstindex(g.fadjlist):(end - length(vs) + 1)]

    # Correct edge counts
    g.ne = sum(degree(g, i) for i in vertices(g)) / 2

    return new_vertex_ids
end

@testset "Parallel.Betweenness" begin
    rng = StableRNG(1)
    s2 = SimpleDiGraph(3)
    add_edge!(s2, 1, 2)
    add_edge!(s2, 2, 3)
    add_edge!(s2, 3, 3)
    s1 = SimpleGraph(s2)
    g3 = path_graph(5)
    gint = loadgraph(joinpath(testdir, "testdata", "graph-50-500.jgz"), "graph-50-500")
    for g in testdigraphs(gint)
        z = @inferred(Graphs.betweenness_centrality(g))
        zt = @inferred(Parallel.betweenness_centrality(g; parallel=:threads))
        @test all(isapprox.(z, zt))
        zd = @inferred(Parallel.betweenness_centrality(g; parallel=:distributed))
        @test all(isapprox.(z, zd))

        y = Graphs.betweenness_centrality(g; endpoints=true, normalize=false)
        yt = Parallel.betweenness_centrality(
            g; endpoints=true, normalize=false, parallel=:threads
        )
        @test all(isapprox(y, yt))
        yd = Parallel.betweenness_centrality(
            g; endpoints=true, normalize=false, parallel=:distributed
        )
        @test all(isapprox(y, yd))

        xt = @inferred(Parallel.betweenness_centrality(g, 3; parallel=:threads, rng=rng))
        @test length(xt) == 50
        xd = @inferred(
            Parallel.betweenness_centrality(g, 3; parallel=:distributed, rng=rng)
        )
        @test length(xd) == 50

        xt2 = @inferred(
            Parallel.betweenness_centrality(g, collect(1:20); parallel=:threads)
        )
        @test length(xt2) == 50
        xd2 = @inferred(
            Parallel.betweenness_centrality(g, collect(1:20); parallel=:distributed)
        )
        @test length(xd2) == 50
    end
    @test @inferred(Parallel.betweenness_centrality(s1; parallel=:threads)) == [0, 1, 0]
    @test @inferred(Parallel.betweenness_centrality(s1; parallel=:distributed)) == [0, 1, 0]

    @test @inferred(Parallel.betweenness_centrality(s2; parallel=:threads)) == [0, 0.5, 0]
    @test @inferred(Parallel.betweenness_centrality(s2; parallel=:distributed)) ==
        [0, 0.5, 0]

    g = SimpleGraph(2)
    add_edge!(g, 1, 2)
    z = Graphs.betweenness_centrality(g; normalize=true)
    @test z[1] == z[2] == 0.0
    zt = Parallel.betweenness_centrality(g; normalize=true, parallel=:threads)
    @test all(isapprox(z, zt))
    zd = Parallel.betweenness_centrality(g; normalize=true, parallel=:distributed)
    @test all(isapprox(z, zd))

    z2 = Graphs.betweenness_centrality(g, vertices(g))
    zt2 = Parallel.betweenness_centrality(g, vertices(g); parallel=:threads)
    @test all(isapprox(z2, zt2))
    zd2 = Parallel.betweenness_centrality(g, vertices(g); parallel=:distributed)
    @test all(isapprox(z2, zd2))

    z3 = Graphs.betweenness_centrality(g, [vertices(g);])
    zt3 = Parallel.betweenness_centrality(g, [vertices(g);]; parallel=:threads)
    @test all(isapprox(z3, zt3))
    zd3 = Parallel.betweenness_centrality(g, [vertices(g);]; parallel=:distributed)
    @test all(isapprox(z3, zd3))

    @test z == z2 == z3

    z = Graphs.betweenness_centrality(g3; normalize=false)
    zt = Parallel.betweenness_centrality(g3; normalize=false, parallel=:threads)
    @test all(isapprox(z, zt))
    zd = Parallel.betweenness_centrality(g3; normalize=false, parallel=:distributed)
    @test all(isapprox(z, zd))
    @test z[1] == z[5] == 0.0
end

# Parts of this code were taken / derived from Graphs.jl. See LICENSE for
# licensing details.
"""
    struct FloydWarshallState{T, U}

An [`AbstractPathState`](@ref) designed for Floyd-Warshall shortest-paths calculations.

# Fields

- `dists::Matrix{T}`: `dists[u, v]` is the length of the shortest path from `u` to `v` 
- `parents::Matrix{U}`: `parents[u, v]` is the predecessor of vertex `v` on the shortest path from `u` to `v`
"""
struct FloydWarshallState{T,U<:Integer} <: AbstractPathState
    dists::Matrix{T}
    parents::Matrix{U}
end

@doc """
    floyd_warshall_shortest_paths(g, distmx=weights(g))

Use the [Floyd-Warshall algorithm](http://en.wikipedia.org/wiki/Floyd–Warshall_algorithm)
to compute the shortest paths between all pairs of vertices in graph `g` using an
optional distance matrix `distmx`. Return a [`Graphs.FloydWarshallState`](@ref) with relevant traversal information (try querying `state.parents` or `state.dists`).

### Performance
Space complexity is on the order of `O(|V|^2)`.
"""
function floyd_warshall_shortest_paths(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number} where {U<:Integer}
    nvg = nv(g)
    # if we do checkbounds here, we can use @inbounds later
    checkbounds(distmx, Base.OneTo(nvg), Base.OneTo(nvg))

    dists = fill(typemax(T), (Int(nvg), Int(nvg)))
    parents = zeros(U, (Int(nvg), Int(nvg)))

    @inbounds for v in vertices(g)
        dists[v, v] = zero(T)
    end
    undirected = !is_directed(g)
    @inbounds for e in edges(g)
        u = src(e)
        v = dst(e)

        d = distmx[u, v]

        dists[u, v] = min(d, dists[u, v])
        parents[u, v] = u
        if undirected
            dists[v, u] = min(d, dists[v, u])
            parents[v, u] = v
        end
    end

    @inbounds for pivot in vertices(g)
        # Relax dists[u, v] = min(dists[u, v], dists[u, pivot]+dists[pivot, v]) for all u, v
        for v in vertices(g)
            d = dists[pivot, v]
            d == typemax(T) && continue
            p = parents[pivot, v]
            for u in vertices(g)
                ans = (dists[u, pivot] == typemax(T) ? typemax(T) : dists[u, pivot] + d)
                if dists[u, v] > ans
                    dists[u, v] = ans
                    parents[u, v] = p
                end
            end
        end
    end
    fws = FloydWarshallState(dists, parents)
    return fws
end

function enumerate_paths(
    s::FloydWarshallState{T,U}, v::Integer
) where {T} where {U<:Integer}
    pathinfo = s.parents[v, :]
    paths = Vector{Vector{U}}()
    for i in 1:length(pathinfo)
        if (i == v) || (s.dists[v, i] == typemax(T))
            push!(paths, Vector{U}())
        else
            path = Vector{U}()
            currpathindex = U(i)
            while currpathindex != 0
                push!(path, currpathindex)
                if pathinfo[currpathindex] == currpathindex
                    currpathindex = zero(currpathindex)
                else
                    currpathindex = pathinfo[currpathindex]
                end
            end
            push!(paths, reverse(path))
        end
    end
    return paths
end

function enumerate_paths(s::FloydWarshallState)
    return [enumerate_paths(s, v) for v in 1:size(s.parents, 1)]
end
enumerate_paths(st::FloydWarshallState, s::Integer, d::Integer) = enumerate_paths(st, s)[d]

@testset "Bipartiteness" begin
    g6 = smallgraph(:house)
    for g in testgraphs(g6)
        @test @inferred(!is_bipartite(g))
    end

    gx = SimpleGraph(5)
    add_edge!(gx, 1, 2)
    add_edge!(gx, 1, 4)
    add_edge!(gx, 2, 3)
    add_edge!(gx, 2, 5)
    add_edge!(gx, 3, 4)

    for g in testgraphs(gx)
        @test @inferred(is_bipartite(g))
    end

    g10 = complete_graph(10)
    for g in testgraphs(g10)
        @test @inferred(bipartite_map(g)) == Vector{eltype(g)}()
    end

    g10 = complete_bipartite_graph(10, 10)
    for g in testgraphs(g10)
        T = eltype(g)
        @test @inferred(bipartite_map(g)) == Vector{T}([ones(T, 10); 2 * ones(T, 10)])

        h = blockdiag(g, g)
        @test @inferred(bipartite_map(h)) ==
            Vector{T}([ones(T, 10); 2 * ones(T, 10); ones(T, 10); 2 * ones(T, 10)])
    end

    g2 = complete_graph(2)
    for g in testgraphs(g2)
        @test @inferred(bipartite_map(g)) == Vector{eltype(g)}([1, 2])
    end

    g2 = Graph(2)
    for g in testgraphs(g2)
        @test @inferred(bipartite_map(g)) == Vector{eltype(g)}([1, 1])
    end

    g2 = DiGraph(2)
    for g in testdigraphs(g2)
        @test @inferred(bipartite_map(g)) == Vector{eltype(g)}([1, 1])
    end

    g2 = path_digraph(2)
    for g in testdigraphs(g2)
        @test @inferred(bipartite_map(g)) == Vector{eltype(g)}([1, 2])
    end
end

# Currently used to support the ismutable function that is not available in Julia < v1.7
"""
    struct Johnson <: ShortestPathAlgorithm

The structure used to configure and specify that [`shortest_paths`](@ref)
should use the [Johnson algorithm](https://en.wikipedia.org/wiki/Johnson%27s_algorithm).
No additional configuration parameters are specified or required.

### Implementation Notes
`Johnson` supports the following shortest-path functionality:
- non-negative distance matrices / weights
- all-pairs shortest paths

### Performance
Complexity: O(|V|*|E|)
"""
struct Johnson <: ShortestPathAlgorithm end

struct JohnsonResult{T,U<:Integer} <: ShortestPathResult
    parents::Matrix{U}
    dists::Matrix{T}
end

function shortest_paths(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}, ::Johnson
) where {T,U<:Integer}
    nvg = nv(g)
    type_distmx = typeof(distmx)
    # Change when parallel implementation of Bellman Ford available
    wt_transform = Graphs.Experimental.ShortestPaths.dists(
        shortest_paths(g, vertices(g), distmx, BellmanFord())
    )

    if !ismutable(distmx) && type_distmx != Graphs.DefaultDistance
        distmx = sparse(distmx) # Change reference, not value
    end

    # Weight transform not needed if all weights are positive.
    if type_distmx != Graphs.DefaultDistance
        for e in edges(g)
            distmx[src(e), dst(e)] += wt_transform[src(e)] - wt_transform[dst(e)]
        end
    end

    dists = Matrix{T}(undef, nvg, nvg)
    parents = Matrix{U}(undef, nvg, nvg)
    for v in vertices(g)
        dijk_state = dijkstra_shortest_paths(g, v, distmx)
        dists[v, :] = dijk_state.dists
        parents[v, :] = dijk_state.parents
    end

    broadcast!(-, dists, dists, wt_transform)
    for v in vertices(g)
        dists[:, v] .+= wt_transform[v] # Vertical traversal preferred
    end

    if ismutable(distmx)
        for e in edges(g)
            distmx[src(e), dst(e)] += wt_transform[dst(e)] - wt_transform[src(e)]
        end
    end

    return JohnsonResult(parents, dists)
end

shortest_paths(g::AbstractGraph, alg::Johnson) = shortest_paths(g, weights(g), alg)

function paths(s::JohnsonResult{T,U}, v::Integer) where {T,U<:Integer}
    pathinfo = s.parents[v, :]
    paths = Vector{Vector{U}}()
    for i in 1:length(pathinfo)
        if (i == v) || (s.dists[v, i] == typemax(T))
            push!(paths, Vector{U}())
        else
            path = Vector{U}()
            currpathindex = U(i)
            while currpathindex != 0
                push!(path, currpathindex)
                currpathindex = pathinfo[currpathindex]
            end
            push!(paths, reverse(path))
        end
    end
    return paths
end

paths(s::JohnsonResult) = [paths(s, v) for v in 1:size(s.parents, 1)]
paths(st::JohnsonResult, s::Integer, d::Integer) = paths(st, s)[d]

"""
    struct Coloring{T}

Store the number of colors used and mapping from vertex to color
"""
struct Coloring{T<:Integer}
    num_colors::T
    colors::Vector{T}
end

best_color(c1::Coloring, c2::Coloring) = c1.num_colors < c2.num_colors ? c1 : c2

"""
    perm_greedy_color(g, seq)

Color graph `g` according to an order specified by `seq` using a greedy heuristic.
`seq[i] = v` implies that vertex v is the ``i^{th}`` vertex to be colored.
"""
function perm_greedy_color(g::AbstractGraph, seq::Vector{T}) where {T<:Integer}
    nvg::T = nv(g)
    cols = Vector{T}(undef, nvg)
    seen = zeros(Bool, nvg + 1)

    has_self_loops(g) && throw(ArgumentError("graph must not have self loops"))

    colors_used = BitSet()

    for v in seq
        empty!(colors_used)
        for w in neighbors(g, v)
            if seen[w]
                push!(colors_used, cols[w])
            end
        end

        for i in one(T):nvg
            if i ∉ colors_used
                cols[v] = i
                break
            end
        end

        seen[v] = true
    end

    return Coloring{T}(maximum(cols), cols)
end

"""
    degree_greedy_color(g)

Color graph `g` iteratively in the descending order of the degree of the vertices.
"""
function degree_greedy_color(g::AbstractGraph{T}) where {T<:Integer}
    seq = convert(Vector{T}, sortperm(degree(g); rev=true))
    return perm_greedy_color(g, seq)
end

"""
    random_greedy_color(g, reps)

Color the graph `g` iteratively in a random order using a greedy heuristic
and choose the best coloring out of `reps` such random colorings.
"""
function random_greedy_color(g::AbstractGraph{T}, reps::Integer) where {T<:Integer}
    seq = shuffle(vertices(g))
    best = perm_greedy_color(g, seq)

    for i in 2:reps
        shuffle!(seq)
        best = best_color(best, perm_greedy_color(g, seq))
    end
    return best
end

"""
    greedy_color(g; sort_degree=false, reps = 1)

Color graph `g` based on [Greedy Coloring Heuristics](https://en.wikipedia.org/wiki/Greedy_coloring)

The heuristics can be described as choosing a permutation of the vertices and assigning the
lowest color index available iteratively in that order.

If `sort_degree` is true then the permutation is chosen in reverse sorted order of the degree of the vertices.
`parallel` and `reps` are irrelevant in this case.

If `sort_degree` is false then `reps` colorings are obtained based on random permutations and the one using least
colors is chosen.
"""
function greedy_color(
    g::AbstractGraph{U}; sort_degree::Bool=false, reps::Integer=1
) where {U<:Integer}
    return sort_degree ? degree_greedy_color(g) : random_greedy_color(g, reps)
end

"""
    simplecycles_limited_length(g, n, ceiling=10^6)

Compute and return at most `ceiling` cycles of length at most `n` of
the given graph. Both directed and undirected graphs are supported.

### Performance
The number of cycles grows very fast with the number of vertices and
the allowed length of the cycles. This function is intended for
finding short cycles. If you want to find cycles of any length in a
directed graph, [`simplecycles`](@ref) or [`simplecycles_iter`](@ref) may be more
efficient.
"""
function simplecycles_limited_length(
    graph::AbstractGraph{T}, n::Int, ceiling=10^6
) where {T}
    cycles = Vector{Vector{T}}()
    n < 1 && return cycles
    cycle = Vector{T}(undef, n)
    @inbounds for v in vertices(graph)
        cycle[1] = v
        simplecycles_limited_length!(graph, n, ceiling, cycles, cycle, 1)
        length(cycles) >= ceiling && break
    end
    return cycles
end

function simplecycles_limited_length!(graph, n, ceiling, cycles, cycle, i)
    length(cycles) >= ceiling && return nothing
    for v in outneighbors(graph, cycle[i])
        if v == cycle[1]
            push!(cycles, cycle[1:i])
        elseif (i < n && v > cycle[1] && !repeated_vertex(v, cycle, 2, i))
            cycle[i + 1] = v
            simplecycles_limited_length!(graph, n, ceiling, cycles, cycle, i + 1)
        end
    end
end

# Note: Doing the same thing as `@views v in cycle[n1:n2]`, but until
# views are completely allocation free this can be expected to be
# faster.
function repeated_vertex(v, cycle, n1, n2)
    for k in n1:n2
        cycle[k] == v && return true
    end
    return false
end

@testset "Decomposition" begin
    d = loadgraph(joinpath(testdir, "testdata", "graph-decomposition.jgz"))

    @testset "$(typeof(g))" for g in test_generic_graphs(d)
        corenum = @inferred(core_number(g))
        @test corenum == [3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 0]

        @testset "k-core" begin
            @test @inferred(k_core(g)) == k_core(g; corenum=corenum) == [1:8;]
            @test @inferred(k_core(g, 2)) == k_core(g, 2; corenum=corenum) == [1:16;]
            @test length(k_core(g, 4)) == 0
        end

        @testset "k-shell" begin
            @test @inferred(k_shell(g)) == k_shell(g; corenum=corenum) == [1:8;]
            @test @inferred(k_shell(g, 2)) == k_shell(g, 2; corenum=corenum) == [9:16;]
            @test length(k_shell(g, 4)) == 0
        end

        @testset "k-crust" begin
            @test @inferred(k_crust(g)) == k_crust(g; corenum=corenum) == [9:21;]
            @test @inferred(k_crust(g, 2)) == k_crust(g, 2; corenum=corenum) == [9:21;]
            @test @inferred(k_crust(g, 4, corenum=corenum)) == [1:21;]
        end
    end

    # TODO k_corona does not work yet with generic graphs
    @testset "k-corona $(typeof(g))" for g in testgraphs(d)
        corenum = [3, 3, 3, 3, 3, 3, 3, 3, 2, 2, 2, 2, 2, 2, 2, 2, 1, 1, 1, 1, 0]

        @test @inferred(k_corona(g, 1)) == k_corona(g, 1; corenum=corenum) == [17:20;]
        @test @inferred(k_corona(g, 2)) == [10, 12, 13, 14, 15, 16]
    end

    d_loop = copy(d)
    add_edge!(d_loop, 1, 1)
    @testset "errors $(typeof(g))" for g in test_generic_graphs(d_loop)
        @test_throws ArgumentError k_core(g)
        @test_throws ArgumentError k_shell(g)
        @test_throws ArgumentError k_crust(g)
    end

    # TODO k_corona does not work yet with generic graphs
    @testset "k-corona errors $(typeof(g))" for g in testgraphs(d_loop)
        @test_throws ArgumentError k_corona(g, 1)
    end
end

@testset "Parallel.Bellman Ford" begin
    g4 = path_digraph(5)

    d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
    d2 = sparse(float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]))
    for g in testdigraphs(g4)
        y = @inferred(Parallel.bellman_ford_shortest_paths(g, [2], d1))
        z = @inferred(Parallel.bellman_ford_shortest_paths(g, [2], d2))
        @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
        @test @inferred(enumerate_paths(z))[2] == []
        @test @inferred(enumerate_paths(z))[4] == enumerate_paths(z, 4) == [2, 3, 4]
        @test @inferred(!Parallel.has_negative_edge_cycle(g, d1))

        y = @inferred(Parallel.bellman_ford_shortest_paths(g, [2], d1))
        z = @inferred(Parallel.bellman_ford_shortest_paths(g, [2], d2))
        @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
        @test @inferred(enumerate_paths(z))[2] == []
        @test @inferred(enumerate_paths(z))[4] == enumerate_paths(z, 4) == [2, 3, 4]
        z = @inferred(Parallel.bellman_ford_shortest_paths(g, [2]))
        @test z.dists == [typemax(Int), 0, 1, 2, 3]
    end

    # Negative Cycle
    gx = complete_graph(3)
    for g in testgraphs(gx)
        d = [1 -3 1; -3 1 1; 1 1 1]
        @test_throws Graphs.NegativeCycleError Parallel.bellman_ford_shortest_paths(
            g, [1], d
        )
        @test Parallel.has_negative_edge_cycle(g, d)

        d = [1 -1 1; -1 1 1; 1 1 1]
        @test_throws Graphs.NegativeCycleError Parallel.bellman_ford_shortest_paths(
            g, [1], d
        )
        @test Parallel.has_negative_edge_cycle(g, d)
    end

    # Negative cycle of length 3 in graph of diameter 4
    gx = complete_graph(4)
    d = [1 -1 1 1; 1 1 1 -1; 1 1 1 1; 1 1 1 1]
    for g in testgraphs(gx)
        @test_throws Graphs.NegativeCycleError Parallel.bellman_ford_shortest_paths(
            g, [1], d
        )
        @test Parallel.has_negative_edge_cycle(g, d)
    end
end

function radiality_centrality(g::AbstractGraph; parallel=:distributed)
    return if parallel == :distributed
        distr_radiality_centrality(g)
    else
        threaded_radiality_centrality(g)
    end
end

function distr_radiality_centrality(g::AbstractGraph)::Vector{Float64}
    n_v = nv(g)
    vs = vertices(g)
    n = ne(g)
    meandists = SharedVector{Float64}(Int(n_v))
    maxdists = SharedVector{Float64}(Int(n_v))

    @sync @distributed for i in 1:n_v
        d = Graphs.dijkstra_shortest_paths(g, vs[i])
        maxdists[i] = maximum(d.dists)
        meandists[i] = sum(d.dists) / (n_v - 1)
        nothing
    end
    dmtr = maximum(maxdists)
    radialities = collect(meandists)
    return ((dmtr + 1) .- radialities) ./ dmtr
end

function threaded_radiality_centrality(g::AbstractGraph)::Vector{Float64}
    n_v = nv(g)
    vs = vertices(g)
    n = ne(g)
    meandists = Vector{Float64}(undef, n_v)
    maxdists = Vector{Float64}(undef, n_v)

    Base.Threads.@threads for i in vertices(g)
        d = Graphs.dijkstra_shortest_paths(g, vs[i])
        maxdists[i] = maximum(d.dists)
        meandists[i] = sum(d.dists) / (n_v - 1)
    end
    dmtr = maximum(maxdists)
    radialities = collect(meandists)
    return ((dmtr + 1) .- radialities) ./ dmtr
end

@testset "Persistence" begin
    @testset "Errors" begin
        @test_throws Graphs.NotImplementedError Graphs._NI("Not implemented")
    end

    pdict = loadgraphs(joinpath(testdir, "testdata", "tutte-pathdigraph.jgz"))
    p1 = pdict["Tutte"]
    p2 = pdict["pathdigraph"]
    @testset "LGFormat simple load" begin
        @test (ne(p2), nv(p2)) == (9, 10)
    end
    g3 = path_graph(5)

    (f, fio) = mktemp()
    # test :lg
    @testset "LGFormat save single graph" begin
        @test savegraph(f, p1) == 1
        @test_deprecated r"Saving compressed graphs is no longer supported" savegraph(
            f, p1; compress=true
        )
        @test savegraph(f, p1) == 1
        @test_deprecated r"Saving compressed graphs is no longer supported" savegraph(
            f, p1, LGFormat(); compress=true
        )
        @test_logs (:info, r"Note: the `compress` keyword is no longer supported in Graphs") savegraph(
            f, p1; compress=false
        )
        @test savegraph(f, p1, LGFormat()) == 1
        @test savegraph(f, p2) == 1
    end

    g2 = loadgraph(f)
    h2 = loadgraph(f, LGFormat())
    j2 = loadgraph(f, "graph")
    @testset "LGFormat load single graph" begin
        @test g2 == h2 == j2
        @test (ne(g2), nv(g2)) == (9, 10)
    end

    @testset "LGFormat save - content check" begin
        (f, fio) = mktemp()
        @test length(sprint(savegraph, p1, LGFormat())) == 421
        @test length(sprint(savegraph, p2, LGFormat())) == 70
        gs = loadgraph(
            joinpath(testdir, "testdata", "tutte-pathdigraph.jgz"), "pathdigraph"
        )
        @test gs == p2
        @test_throws ArgumentError loadgraph(
            joinpath(testdir, "testdata", "tutte-pathdigraph.jgz"), "badname"
        )
    end

    @testset "LGFormat save multiple graphs" begin
        d = Dict{String,AbstractGraph}("p1" => p1, "p2" => p2)
        @test savegraph(f, d) == 2
    end

    close(fio)
    rm(f)
end

using Documenter
using Graphs
using IGraphs: IGraphs
using NautyGraphs: NautyGraphs

# same for contributing and license
cp(
    normpath(@__FILE__, "../../CONTRIBUTING.md"),
    normpath(@__FILE__, "../src/contributing.md");
    force=true,
)
cp(
    normpath(@__FILE__, "../../LICENSE.md"),
    normpath(@__FILE__, "../src/license.md");
    force=true,
)
cp(
    normpath(@__FILE__, "../../README.md"),
    normpath(@__FILE__, "../src/index.md");
    force=true,
)
cp(
    normpath(@__FILE__, "../../CHANGELOG.md"),
    normpath(@__FILE__, "../src/CHANGELOG.md");
    force=true,
)

function get_title(markdown_file_path::AbstractString)
    first_line = open(markdown_file_path) do io
        readline(io)
    end
    return String(chop(first_line; head=2, tail=0))
end

pages_files = [
    "First steps" => [
        "index.md",
        "first_steps/theory.md",
        "first_steps/construction.md",
        "first_steps/access.md",
        "first_steps/paths_traversal.md",
        "first_steps/plotting.md",
        "first_steps/persistence.md",
    ],
    "Ecosystem" => [
        "ecosystem/graphtypes.md",
        "ecosystem/graphalgorithms.md",
        "ecosystem/interface.md",
    ],
    "Core API" => [
        "core_functions/core.md",
        "core_functions/interface.md",
        "core_functions/module.md",
        "core_functions/operators.md",
        "core_functions/persistence.md",
        "core_functions/simplegraphs_generators.md",
        "core_functions/simplegraphs.md",
        "core_functions/wrappedgraphs.md",
    ],
    "Algorithms API" => [
        "algorithms/biconnectivity.md",
        "algorithms/centrality.md",
        "algorithms/community.md",
        "algorithms/connectivity.md",
        "algorithms/cut.md",
        "algorithms/cycles.md",
        "algorithms/trees.md",
        "algorithms/degeneracy.md",
        "algorithms/digraph.md",
        "algorithms/distance.md",
        "algorithms/dominatingset.md",
        "algorithms/editdist.md",
        "algorithms/independentset.md",
        "algorithms/iterators.md",
        "algorithms/linalg.md",
        "algorithms/shortestpaths.md",
        "algorithms/spanningtrees.md",
        "algorithms/steinertree.md",
        "algorithms/traversals.md",
        "algorithms/utils.md",
        "algorithms/vertexcover.md",
    ],
    "For advanced users" => [
        "advanced/errorhandling.md",
        "advanced/test.md",
        "advanced/experimental.md",
        "advanced/parallel.md",
        "contributing.md",
        "license.md",
    ],
]

pages = [
    section_name => [
        get_title(joinpath(normpath(@__FILE__, ".."), "src", file)) => file for
        file in section_files
    ] for (section_name, section_files) in pages_files
]

makedocs(;
    modules=[Graphs],
    format=Documenter.HTML(;
        prettyurls=get(ENV, "CI", "false") == "true",
        assets=String[],
        collapselevel=1,
        canonical="https://gdalle.github.io/Graphs.jl",
    ),
    sitename="Graphs.jl",
    checkdocs=:public,
    doctest=false,
    expandfirst=[],
    pages=[
        section_name => [
            get_title(joinpath(normpath(@__FILE__, ".."), "src", file)) => file for
            file in section_files
        ] for (section_name, section_files) in pages_files
    ],
)

deploydocs(; repo="github.com/JuliaGraphs/Graphs.jl.git", target="build")

rm(normpath(@__FILE__, "../src/contributing.md"))
rm(normpath(@__FILE__, "../src/license.md"))
rm(normpath(@__FILE__, "../src/index.md"))
rm(normpath(@__FILE__, "../src/CHANGELOG.md"))

##################################################################
#
#   Maximal cliques of undirected graph
#   Derived from Graphs.jl: https://github.com/julialang/Graphs.jl
#
##################################################################

"""
    maximal_cliques(g)

Return a vector of vectors representing the node indices in each of the maximal
cliques found in the undirected graph `g`.

```jldoctest
julia> using Graphs

julia> g = SimpleGraph(3)
{3, 0} undirected simple Int64 graph

julia> add_edge!(g, 1, 2)
true

julia> add_edge!(g, 2, 3)
true

julia> maximal_cliques(g)
2-element Vector{Vector{Int64}}:
 [2, 3]
 [2, 1]
```
"""
function maximal_cliques end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function maximal_cliques(g::AG::(!IsDirected)) where {T,AG<:AbstractGraph{T}}
    # Cache nbrs and find first pivot (highest degree)
    maxconn = -1
    # uncomment this when https://github.com/JuliaLang/julia/issues/23618 is fixed
    # nnbrs = [Set{T}() for n in vertices(g)]
    nnbrs = Vector{Set{T}}()
    for n in vertices(g)
        push!(nnbrs, Set{T}())
    end
    pivotnbrs = Set{T}() # handle empty graph
    pivotdonenbrs = Set{T}()  # initialize

    for n in vertices(g)
        nbrs = Set{T}()
        union!(nbrs, outneighbors(g, n))
        delete!(nbrs, n) # ignore edges between n and itself
        conn = length(nbrs)
        if conn > maxconn
            pivotnbrs = nbrs
            nnbrs[n] = pivotnbrs
            maxconn = conn
        else
            nnbrs[n] = nbrs
        end
    end

    # Initial setup
    cand = Set{T}(vertices(g))
    # union!(cand, keys(nnbrs))
    smallcand = setdiff(cand, pivotnbrs)
    done = Set{T}()
    stack = Vector{Tuple{Set{T},Set{T},Set{T}}}()
    clique_so_far = Vector{T}()
    cliques = Vector{Vector{T}}()

    # Start main loop
    while !isempty(smallcand) || !isempty(stack)
        if !isempty(smallcand) # Any vertices left to check?
            n = pop!(smallcand)
        else
            # back out clique_so_far
            cand, done, smallcand = pop!(stack)
            pop!(clique_so_far)
            continue
        end
        # Add next node to clique
        push!(clique_so_far, n)
        delete!(cand, n)
        push!(done, n)
        nn = nnbrs[n]
        new_cand = intersect(cand, nn)
        new_done = intersect(done, nn)
        # check if we have more to search
        if isempty(new_cand)
            if isempty(new_done)
                # Found a clique!
                push!(cliques, collect(clique_so_far))
            end
            pop!(clique_so_far)
            continue
        end
        # Shortcut--only one node left!
        if isempty(new_done) && length(new_cand) == 1
            push!(cliques, vcat(clique_so_far, collect(new_cand)))
            pop!(clique_so_far)
            continue
        end
        # find pivot node (max connected in cand)
        # look in done vertices first
        numb_cand = length(new_cand)
        maxconndone = -1
        for n in new_done
            cn = intersect(new_cand, nnbrs[n])
            conn = length(cn)
            if conn > maxconndone
                pivotdonenbrs = cn
                maxconndone = conn
                if maxconndone == numb_cand
                    break
                end
            end
        end
        # Shortcut--this part of tree already searched
        if maxconndone == numb_cand
            pop!(clique_so_far)
            continue
        end
        # still finding pivot node
        # look in cand vertices second
        maxconn = -1
        for n in new_cand
            cn = intersect(new_cand, nnbrs[n])
            conn = length(cn)
            if conn > maxconn
                pivotnbrs = cn
                maxconn = conn
                if maxconn == numb_cand - 1
                    break
                end
            end
        end
        # pivot node is max connected in cand from done or cand
        if maxconndone > maxconn
            pivotnbrs = pivotdonenbrs
        end
        # save search status for later backout
        push!(stack, (cand, done, smallcand))
        cand = new_cand
        done = new_done
        smallcand = setdiff(cand, pivotnbrs)
    end
    return cliques
end

@testset "Degree Dominating Set" begin
    g0 = SimpleGraph(0)
    for g in testgraphs(g0)
        d = @inferred(dominating_set(g, DegreeDominatingSet()))
        @test isempty(d)
    end

    g1 = SimpleGraph(1)
    for g in testgraphs(g1)
        d = @inferred(dominating_set(g, DegreeDominatingSet()))
        @test (d == [1])
    end

    add_edge!(g1, 1, 1)
    for g in testgraphs(g1)
        d = @inferred(dominating_set(g, DegreeDominatingSet()))
        @test (d == [1])
    end

    g3 = star_graph(5)
    for g in testgraphs(g1)
        d = @inferred(dominating_set(g, DegreeDominatingSet()))
        @test (d == [1])
    end

    g4 = complete_graph(5)
    for g in testgraphs(g4)
        d = @inferred(dominating_set(g, DegreeDominatingSet()))
        @test length(d) == 1
    end

    # path_graph(5) with additional edge 2-5
    g5 = path_graph(5)
    add_edge!(g5, 2, 5)
    for g in testgraphs(g5)
        d = @inferred(dominating_set(g, DegreeDominatingSet()))
        @test (length(d) == 2 && minimum(d) == 2)
    end

    add_edge!(g5, 2, 2)
    add_edge!(g5, 3, 3)
    for g in testgraphs(g5)
        d = @inferred(dominating_set(g, DegreeDominatingSet()))
        @test (length(d) == 2 && minimum(d) == 2)
    end
end

@testset "Closeness" begin
    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)

    for g in test_generic_graphs(g5)
        y = @inferred(closeness_centrality(g; normalize=false))
        z = @inferred(closeness_centrality(g))
        @test y == [0.75, 0.6666666666666666, 1.0, 0.0]
        @test z == [0.75, 0.4444444444444444, 0.3333333333333333, 0.0]
    end

    adjmx2 = [0 1 0; 1 0 1; 1 1 0] # digraph
    a2 = SimpleDiGraph(adjmx2)
    for g in test_generic_graphs(a2)
        distmx2 = [Inf 2.0 Inf; 3.2 Inf 4.2; 5.5 6.1 Inf]
        c2 = [0.24390243902439027, 0.27027027027027023, 0.1724137931034483]
        y = @inferred(closeness_centrality(g, distmx2; normalize=false))
        z = @inferred(closeness_centrality(g, distmx2))
        @test isapprox(y, c2)
        @test isapprox(z, c2)
    end

    g5 = SimpleGraph(5)
    add_edge!(g5, 1, 2)
    for g in test_generic_graphs(g5)
        z = @inferred(closeness_centrality(g))
        @test z[1] == z[2] == 0.25
        @test z[3] == z[4] == z[5] == 0.0
    end

    adjmx1 = [0 1 0; 1 0 1; 0 1 0] # graph
    a1 = SimpleGraph(adjmx1)
    for g in test_generic_graphs(a1)
        distmx1 = [Inf 2.0 Inf; 2.0 Inf 4.2; Inf 4.2 Inf]
        c1 = [0.24390243902439027, 0.3225806451612903, 0.1923076923076923]
        y = @inferred(closeness_centrality(g, distmx1; normalize=false))
        z = @inferred(closeness_centrality(g, distmx1))
        @test isapprox(y, c1)
        @test isapprox(z, c1)
    end
end

@testset "PMFG tests" begin
    k5 = complete_graph(5)
    k5_am = Matrix{Float64}(adjacency_matrix(k5))

    #random weights
    for i in CartesianIndices(k5_am)
        if k5_am[i] == 1
            k5_am[i] = rand()
        end
    end

    #let's make 1->5 very distant 
    k5_am[1, 5] = 10.0
    k5_am[5, 1] = 10.0

    #correct result of PMFG
    correct_am = [
        0 1 1 1 0
        1 0 1 1 1
        1 1 0 1 1
        1 1 1 0 1
        0 1 1 1 0
    ]

    @test correct_am == adjacency_matrix(planar_maximally_filtered_graph(k5, k5_am))

    #type test 
    N = 10
    g = SimpleGraph{Int16}(N)
    X = rand(N, N)
    C = X' * X
    p = planar_maximally_filtered_graph(g, C)
    @test typeof(p) == SimpleGraph{eltype(g)}

    #Test that MST is a subset of the PMFG 
    N = 50
    X = rand(N, N)
    D = X' * X
    c = complete_graph(N)
    p = planar_maximally_filtered_graph(c, D)
    mst_edges = kruskal_mst(c, D)
    is_subgraph = true
    for mst_edge in mst_edges
        if mst_edge ∉ edges(p)
            is_subgraph = false
        end
    end
    @test is_subgraph
end

import Base: convert

const P = Pair{Int,Int}

convert(::Type{Tuple}, e::Pair) = (e.first, e.second)

function fille(n)
    return [Graphs.Edge(i, i + 1) for i in 1:n]
end

function fillp(n)
    t = Vector{P}(undef, n)
    for i in 1:n
        t[i] = P(i, i + 1)
    end
    return t
end

function tsum(t)
    x = 0
    for item in t
        u, v = Tuple(item)
        x += u
        x += v
    end
    return x
end

let
    n = 10_000

    SUITE["edges"] = BenchmarkGroup([])
    SUITE["edges"]["fille"] = @benchmarkable fille($n)
    SUITE["edges"]["fillp"] = @benchmarkable fille($n)

    a, b = fille(n), fillp(n)

    SUITE["edges"]["tsume"] = @benchmarkable tsum($a)
    SUITE["edges"]["tsump"] = @benchmarkable tsum($b)
end

export DegreeDominatingSet

struct DegreeDominatingSet end

"""
    update_dominated!(degree_queue, v, dominated, in_dom_set)

Check if a vertex is already dominated.
If not, make it dominated and update `degree_queue` by decreasing
the priority of the vertices adjacent to `v` by 1.
"""
function update_dominated!(
    g::AbstractGraph{T},
    degree_queue::PriorityQueue,
    v::Integer,
    dominated::BitArray{1},
    in_dom_set::BitArray{1},
) where {T<:Integer}
    @inbounds if !dominated[v]
        dominated[v] = true
        if !in_dom_set[v]
            degree_queue[v] -= 1
        end
        @inbounds @simd for u in neighbors(g, v)
            if !in_dom_set[u]
                degree_queue[u] -= ifelse(in_dom_set[u], 0, 1)
            end
        end
    end
end

"""
    dominating_set(g, DegreeDominatingSet())

Obtain a [dominating set](https://en.wikipedia.org/wiki/Dominating_set) using a greedy heuristic.

### Implementation Notes
A vertex is said to be dominated if it is in the dominating set or adjacent to a vertex 
in the dominating set.
Initialise the dominating set to an empty set and iteratively choose the vertex that would 
dominate the most undominated vertices.

### Performance
Runtime: ``\\mathcal{O}((|V|+|E|)*log(|V|))``
Memory: ``\\mathcal{O}(|V|)``
Approximation Factor: `ln(maximum(degree(g)))+2`
"""
function dominating_set(g::AbstractGraph{T}, alg::DegreeDominatingSet) where {T<:Integer}
    nvg = nv(g)
    in_dom_set = falses(nvg)
    dominated = falses(nvg)
    degree_queue = PriorityQueue(Base.Order.Reverse, enumerate(degree(g) .+ 1))
    length_ds = 0

    while !isempty(degree_queue) && first(degree_queue)[2] > 0
        v = popfirst!(degree_queue).first
        in_dom_set[v] = true
        length_ds += 1

        update_dominated!(g, degree_queue, v, dominated, in_dom_set)
        for u in neighbors(g, v)
            update_dominated!(g, degree_queue, u, dominated, in_dom_set)
        end
    end

    return Graphs.findall!(in_dom_set, Vector{T}(undef, length_ds))
end

@testset "Path from parents" begin
    using Graphs: path_from_parents
    parents = [3, 0, 2, 5, 5]
    @test path_from_parents(1, parents) == [2, 3, 1]
    @test path_from_parents(2, parents) == [2]
    @test path_from_parents(3, parents) == [2, 3]
    @test path_from_parents(4, parents) == [5, 4]
    @test path_from_parents(5, parents) == [5]
end

"""
    prim_mst(g, distmx=weights(g))

Return a vector of edges representing the minimum spanning tree of a connected, undirected graph `g` with optional
distance matrix `distmx` using [Prim's algorithm](https://en.wikipedia.org/wiki/Prim%27s_algorithm).
Return a vector of edges.
"""
function prim_mst end
@traitfn function prim_mst(
    g::AG::(!IsDirected), distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number,U,AG<:AbstractGraph{U}}
    nvg = nv(g)

    pq = PriorityQueue{U,T}()
    finished = zeros(Bool, nvg)
    wt = fill(typemax(T), nvg) # Faster access time
    parents = zeros(U, nv(g))

    pq[1] = typemin(T)
    wt[1] = typemin(T)

    while !isempty(pq)
        v = dequeue!(pq)
        finished[v] = true

        for u in neighbors(g, v)
            finished[u] && continue

            if wt[u] > distmx[u, v]
                wt[u] = distmx[u, v]
                pq[u] = wt[u]
                parents[u] = v
            end
        end
    end

    return [Edge{U}(parents[v], v) for v in vertices(g) if parents[v] != 0]
end

"""
    label_propagation(g, maxiter=1000; rng=nothing, seed=nothing)

Community detection using the label propagation algorithm.
Return two vectors: the first is the label number assigned to each node, and
the second is the convergence history for each node. Will return after
`maxiter` iterations if convergence has not completed.

### References
- [Raghavan et al.](http://arxiv.org/abs/0709.2938)
"""
function label_propagation(
    g::AbstractGraph{T},
    maxiter=1000;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T}
    rng = rng_from_rng_or_seed(rng, seed)

    n = nv(g)
    n == 0 && return (T[], Int[])

    label = collect(one(T):n)
    active_vs = BitSet(vertices(g))
    c = NeighComm(collect(one(T):n), fill(-1, n), one(T))
    convergence_hist = Vector{Int}()
    random_order = Vector{T}(undef, n)
    i = 0
    while !isempty(active_vs) && i < maxiter
        num_active = length(active_vs)
        push!(convergence_hist, num_active)
        i += 1

        # processing vertices in random order
        for (j, node) in enumerate(active_vs)
            random_order[j] = node
        end
        range_shuffle!(rng, 1:num_active, random_order)
        @inbounds for j in 1:num_active
            u = random_order[j]
            old_comm = label[u]
            label[u] = vote!(rng, g, label, c, u)
            if old_comm != label[u]
                for v in outneighbors(g, u)
                    push!(active_vs, v)
                end
            else
                delete!(active_vs, u)
            end
        end
    end
    fill!(c.neigh_cnt, 0)
    renumber_labels!(label, c.neigh_cnt)
    return label, convergence_hist
end

"""
    NeighComm{T}

Type to record neighbor labels and their counts.
"""
mutable struct NeighComm{T<:Integer}
    neigh_pos::Vector{T}
    neigh_cnt::Vector{Int}
    neigh_last::T
end

"""
    range_shuffle!(rng, r, a)

Fast shuffle Array `a` in UnitRange `r`.
"""
function range_shuffle!(rng::AbstractRNG, r::UnitRange, a::AbstractVector)
    (r.start > 0 && r.stop <= length(a)) ||
        throw(DomainError(r, "range indices are out of bounds"))
    @inbounds for i in length(r):-1:2
        j = rand(rng, 1:i)
        ii = i + r.start - 1
        jj = j + r.start - 1
        a[ii], a[jj] = a[jj], a[ii]
    end
end

"""
    vote!(rng, g, m, c, u)

Return the label with greatest frequency.
"""
function vote!(rng::AbstractRNG, g::AbstractGraph, m::Vector, c::NeighComm, u::Integer)
    @inbounds for i in 1:(c.neigh_last - 1)
        c.neigh_cnt[c.neigh_pos[i]] = -1
    end
    c.neigh_last = 1
    c.neigh_pos[1] = m[u]
    c.neigh_cnt[c.neigh_pos[1]] = 0
    c.neigh_last = 2
    max_cnt = 0
    for neigh in outneighbors(g, u)
        neigh_comm = m[neigh]
        if c.neigh_cnt[neigh_comm] < 0
            c.neigh_cnt[neigh_comm] = 0
            c.neigh_pos[c.neigh_last] = neigh_comm
            c.neigh_last += 1
        end
        c.neigh_cnt[neigh_comm] += 1
        if c.neigh_cnt[neigh_comm] > max_cnt
            max_cnt = c.neigh_cnt[neigh_comm]
        end
    end
    # ties breaking randomly
    range_shuffle!(rng, 1:(c.neigh_last - 1), c.neigh_pos)

    result_lbl = zero(eltype(c.neigh_pos))
    for lbl in c.neigh_pos
        if c.neigh_cnt[lbl] == max_cnt
            result_lbl = lbl
            break
        end
    end

    return result_lbl
end

function renumber_labels!(
    membership::Vector{T}, label_counters::Vector{Int}
) where {T<:Integer}
    N = length(membership)
    (maximum(membership) > N || minimum(membership) < 1) &&
        throw(ArgumentError("Labels must between 1 and |V|")) # TODO 0.7: change to DomainError?
    j = one(T)
    @inbounds for i in 1:length(membership)
        k::T = membership[i]
        if k >= 1
            if label_counters[k] == 0
                # We have seen this label for the first time
                label_counters[k] = j
                k = j
                j += one(j)
            else
                k = label_counters[k]
            end
        end
        membership[i] = k
    end
end

export MinimalDominatingSet

struct MinimalDominatingSet end

"""
    dominating_set(g, MinimalDominatingSet(); rng=nothing, seed=nothing)

Find a set of vertices that constitutes a dominating set (all vertices in `g` are either adjacent to a vertex
in the set or is a vertex in the set) and it is not possible to delete a vertex from the set
without sacrificing the dominating property.

### Implementation Notes
Initially, every vertex is in the dominating set.
In some random order, we check if the removal of a vertex from the set will destroy the
dominating property. If no, the vertex is removed from the dominating set.

### Performance
Runtime: ``\\mathcal{O}(|V|+|E|)``
Memory: ``\\mathcal{O}(|V|)``

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- If `seed >= 0`, a random generator is seeded with this value.
"""
function dominating_set(
    g::AbstractGraph{T},
    alg::MinimalDominatingSet;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    rng = rng_from_rng_or_seed(rng, seed)
    nvg = nv(g)
    in_dom_set = trues(nvg)
    length_ds = Int(nvg)
    dom_degree = degree(g)
    @inbounds @simd for v in vertices(g)
        dom_degree[v] -= (has_edge(g, v, v) ? 1 : 0)
    end

    for v in randperm(rng, nvg)
        (dom_degree[v] == 0) && continue # It is not adjacent to any dominating vertex
        # Check if any vertex is depending on v to be dominated
        dependent = findfirst(u -> !in_dom_set[u] && dom_degree[u] <= 1, neighbors(g, v))

        !isnothing(dependent) && continue
        in_dom_set[v] = false
        length_ds -= 1
        dom_degree[neighbors(g, v)] .-= 1
    end

    return Graphs.findall!(in_dom_set, Vector{T}(undef, length_ds))
end

# Parts of this code were taken / derived from Graphs.jl. See LICENSE for
# licensing details.

# The Bellman Ford algorithm for single-source shortest path

struct NegativeCycleError <: Exception end

"""
    struct BellmanFord <: ShortestPathAlgorithm

The structure used to configure and specify that [`shortest_paths`](@ref)
should use the [Bellman-Ford algorithm](http://en.wikipedia.org/wiki/Bellman–Ford_algorithm).
No fields are specified or required.

### Implementation Notes
`BellmanFord` supports the following shortest-path functionality:
- negative distance matrices / weights
- (optional) multiple sources
- all destinations
"""
struct BellmanFord <: ShortestPathAlgorithm end
struct BellmanFordResult{T,U<:Integer} <: ShortestPathResult
    parents::Vector{U}
    dists::Vector{T}
end

function shortest_paths(
    graph::AbstractGraph{U},
    sources::AbstractVector{<:Integer},
    distmx::AbstractMatrix{T},
    ::BellmanFord,
) where {T,U<:Integer}
    nvg = nv(graph)
    active = falses(nvg)
    active[sources] .= true
    dists = fill(typemax(T), nvg)
    parents = zeros(U, nvg)
    dists[sources] .= 0
    no_changes = false
    new_active = falses(nvg)

    @inbounds for i in vertices(graph)
        no_changes = true
        new_active .= false
        for u in vertices(graph)[active]
            for v in outneighbors(graph, u)
                relax_dist = distmx[u, v] + dists[u]
                if dists[v] > relax_dist
                    dists[v] = relax_dist
                    parents[v] = u
                    no_changes = false
                    new_active[v] = true
                end
            end
        end
        no_changes && break
        active, new_active = new_active, active
    end
    no_changes || throw(NegativeCycleError())
    return BellmanFordResult(parents, dists)
end

function shortest_paths(
    g::AbstractGraph, v::Integer, distmx::AbstractMatrix, alg::BellmanFord
)
    return shortest_paths(g, [v], distmx, alg)
end

has_negative_weight_cycle(g::AbstractGraph, ::BellmanFord) = false

function has_negative_weight_cycle(
    g::AbstractGraph, distmx::AbstractMatrix, alg::BellmanFord
)
    try
        shortest_paths(g, vertices(g), distmx, alg)
    catch e
        isa(e, ShortestPaths.NegativeCycleError) && return true
    end
    return false
end

@testset "SimpleEdge" begin
    e = SimpleEdge(1, 2)
    re = SimpleEdge(2, 1)

    @testset "edgetype: $(typeof(s))" for s in [0x01, UInt16(1), 1]
        T = typeof(s)
        d = s + one(T)
        p = Pair(s, d)

        ep1 = SimpleEdge(p)
        ep2 = SimpleEdge{UInt8}(p)
        ep3 = SimpleEdge{Int16}(p)

        t1 = (s, d)
        t2 = (s, d, "foo")

        @test src(ep1) == src(ep2) == src(ep3) == s
        @test dst(ep1) == dst(ep2) == dst(ep3) == s + one(T)

        @test eltype(ep1) == eltype(SimpleEdge{T}) == T

        @test eltype(p) == typeof(s)
        @test SimpleEdge(p) == e
        @test SimpleEdge(t1) == SimpleEdge(t2) == e
        @test SimpleEdge(t1) == SimpleEdge{UInt8}(t1) == SimpleEdge{Int16}(t1)
        @test SimpleEdge{Int64}(ep1) == e

        @test hash(SimpleEdge(t1)) ==
            hash(SimpleEdge{UInt8}(t1)) ==
            hash(SimpleEdge{UInt16}(t1))
        @test hash(SimpleEdge(1, 2)) != hash(SimpleEdge(2, 1))

        @test Pair(e) == p
        @test Tuple(e) == t1
        @test reverse(ep1) == re
        @test sprint(show, ep1) == "Edge 1 => 2"
    end

    @testset "comparison" begin
        @test SimpleEdge(1, 2) < SimpleEdge(1, 3)
        @test SimpleEdge(1, 2) < SimpleEdge(2, 3)
        @test SimpleEdge(1, 2) < SimpleEdge(2, 1)
        @test SimpleEdge(1, 2) <= SimpleEdge(1, 2)
        @test SimpleEdge(2, 3) > SimpleEdge(1, 2)
    end
end

@testset "Euclidean graphs" begin
    rng = StableRNG(1)
    N = 10
    d = 2
    g, weights, points = @inferred(euclidean_graph(N, d, rng=rng))
    @test nv(g) == N
    @test ne(g) == N * (N - 1) ÷ 2
    @test (d, N) == size(points)
    @test maximum(x -> x[2], weights) <= sqrt(d)
    @test minimum(x -> x[2], weights) >= 0
    @test maximum(points) <= 1
    @test minimum(points) >= 0.0

    g, weights, points = @inferred(euclidean_graph(N, d, bc=:periodic, rng=rng))
    @test maximum(x -> x[2], weights) <= sqrt(d / 2)
    @test minimum(x -> x[2], weights) >= 0.0
    @test maximum(points) <= 1
    @test minimum(points) >= 0.0

    @test_throws DomainError euclidean_graph(points, L=0.01, bc=:periodic)
    @test_throws ArgumentError euclidean_graph(points, bc=:badbc)

    # In our algorithm we ensure, that the resulting graph has the same
    # number of vertices as we have points. For this we have a special case,
    # where we have to insert vertices if the vertices with the highest indices are
    # isolated. This test ensures that this case is covered.
    @testset "Euclidean graph with vertex of highest index isolated" begin
        point1 = [1.0, 0.0, 0.0]
        point2 = [0.0, 1.0, 0.0]
        point3 = [0.0, 0.0, 100.0]
        matrix = hcat(point1, point2, point3)
        g, _ = euclidean_graph(matrix; cutoff=5.0)
        @test has_edge(g, 1, 2) && ne(g) == 1
        @test nv(g) == 3
    end
end

using Graphs
using Graphs.Parallel
using Base.Threads: @threads, Atomic
@test length(description()) > 1

tests = [
    "centrality/betweenness",
    "centrality/closeness",
    "centrality/pagerank",
    "centrality/radiality",
    "centrality/stress",
    "distance",
    "shortestpaths/bellman-ford",
    "shortestpaths/dijkstra",
    "shortestpaths/floyd-warshall",
    "shortestpaths/johnson",
    "traversals/bfs",
    "traversals/greedy_color",
    "dominatingset/minimal_dom_set",
    "independentset/maximal_ind_set",
    "vertexcover/random_vertex_cover",
    "utils",
]

@testset "Graphs.Parallel" begin
    for t in tests
        tp = joinpath(testdir, "parallel", "$(t).jl")
        include(tp)
    end
end

# deprecations should also include a comment stating the version
# for which the deprecation should be removed.

# Deprecated to fix spelling. Can be removed for version 2.0.
@deprecate simplecycles_hadwick_james(g) simplecycles_hawick_james(g)

# Deprecated for more explicit function name. Can be removed for version 2.0.
@deprecate saw self_avoiding_walk

module SimpleGraphs

using SparseArrays
using LinearAlgebra
using Graphs
using SimpleTraits

import Random: AbstractRNG

import Base:
    eltype, show, ==, Pair, Tuple, copy, length, issubset, reverse, zero, in, iterate

import Graphs:
    _NI,
    AbstractGraph,
    AbstractEdge,
    AbstractEdgeIter,
    src,
    dst,
    edgetype,
    nv,
    ne,
    vertices,
    edges,
    is_directed,
    has_vertex,
    has_edge,
    inneighbors,
    outneighbors,
    all_neighbors,
    deepcopy_adjlist,
    indegree,
    outdegree,
    degree,
    has_self_loops,
    num_self_loops,
    insorted,
    squash,
    rng_from_rng_or_seed

export AbstractSimpleGraph,
    AbstractSimpleEdge,
    SimpleEdge,
    SimpleGraph,
    SimpleGraphFromIterator,
    SimpleGraphEdge,
    SimpleDiGraph,
    SimpleDiGraphFromIterator,
    SimpleDiGraphEdge,
    add_vertex!,
    add_edge!,
    rem_vertex!,
    rem_vertices!,
    rem_edge!,
    squash,
    # randgraphs
    erdos_renyi,
    expected_degree_graph,
    watts_strogatz,
    newman_watts_strogatz,
    random_regular_graph,
    random_regular_digraph,
    random_configuration_model,
    uniform_tree,
    random_tournament_digraph,
    StochasticBlockModel,
    make_edgestream,
    nearbipartiteSBM,
    blockcounts,
    blockfractions,
    stochastic_block_model,
    barabasi_albert,
    dorogovtsev_mendes,
    barabasi_albert!,
    static_fitness_model,
    static_scale_free,
    kronecker,
    random_orientation_dag,
    # generators
    complete_graph,
    star_graph,
    path_graph,
    wheel_graph,
    cycle_graph,
    complete_bipartite_graph,
    complete_multipartite_graph,
    turan_graph,
    complete_digraph,
    star_digraph,
    path_digraph,
    grid,
    wheel_digraph,
    cycle_digraph,
    binary_tree,
    double_binary_tree,
    roach_graph,
    clique_graph,
    barbell_graph,
    lollipop_graph,
    ladder_graph,
    circular_ladder_graph,
    # smallgraphs
    smallgraph,
    # Euclidean graphs
    euclidean_graph

"""
    AbstractSimpleGraph

An abstract type representing a simple graph structure.
`AbstractSimpleGraph`s must have the following elements:
  - `vertices::UnitRange{Integer}`
  - `fadjlist::Vector{Vector{Integer}}`
  - `ne::Integer`
"""
abstract type AbstractSimpleGraph{T<:Integer} <: AbstractGraph{T} end

function show(io::IO, ::MIME"text/plain", g::AbstractSimpleGraph{T}) where {T}
    dir = is_directed(g) ? "directed" : "undirected"
    return print(io, "{$(nv(g)), $(ne(g))} $dir simple $T graph")
end

nv(g::AbstractSimpleGraph{T}) where {T} = T(length(fadj(g)))
vertices(g::AbstractSimpleGraph) = Base.OneTo(nv(g))

"""
    throw_if_invalid_eltype(T)

Internal function, throw a `DomainError` if `T` is not a concrete type `Integer`.
Can be used in the constructor of AbstractSimpleGraphs,
as Julia's typesystem does not enforce concrete types, which can lead to
problems. E.g `SimpleGraph{Signed}`.
"""
function throw_if_invalid_eltype(T::Type{<:Integer})
    if !isconcretetype(T)
        throw(DomainError(T, "Eltype for AbstractSimpleGraph must be concrete type."))
    end
end

edges(g::AbstractSimpleGraph) = SimpleEdgeIter(g)

fadj(g::AbstractSimpleGraph) = g.fadjlist
fadj(g::AbstractSimpleGraph, v::Integer) = g.fadjlist[v]

badj(x...) = _NI("badj")

# handles single-argument edge constructors such as pairs and tuples
has_edge(g::AbstractSimpleGraph, x) = has_edge(g, edgetype(g)(x))
add_edge!(g::AbstractSimpleGraph, x) = add_edge!(g, edgetype(g)(x))

# handles two-argument edge constructors like src,dst
has_edge(g::AbstractSimpleGraph, x, y) = has_edge(g, edgetype(g)(x, y))
add_edge!(g::AbstractSimpleGraph, x, y) = add_edge!(g, edgetype(g)(x, y))

inneighbors(g::AbstractSimpleGraph, v::Integer) = badj(g, v)
outneighbors(g::AbstractSimpleGraph, v::Integer) = fadj(g, v)

function issubset(g::T, h::T) where {T<:AbstractSimpleGraph}
    nv(g) <= nv(h) || return false
    for u in vertices(g)
        u_nbrs_g = neighbors(g, u)
        len_u_nbrs_g = length(u_nbrs_g)
        len_u_nbrs_g == 0 && continue
        u_nbrs_h = neighbors(h, u)
        p = 1
        len_u_nbrs_g > length(u_nbrs_h) && return false
        (u_nbrs_g[1] < u_nbrs_h[1] || u_nbrs_g[end] > u_nbrs_h[end]) && return false
        @inbounds for v in u_nbrs_h
            if v == u_nbrs_g[p]
                p == len_u_nbrs_g && break
                p += 1
            end
        end
        p == len_u_nbrs_g || return false
    end
    return true
end

has_vertex(g::AbstractSimpleGraph, v::Integer) = v in vertices(g)

ne(g::AbstractSimpleGraph) = g.ne

function rem_edge!(g::AbstractSimpleGraph{T}, u::Integer, v::Integer) where {T}
    return rem_edge!(g, edgetype(g)(T(u), T(v)))
end

"""
    rem_vertex!(g, v)

Remove the vertex `v` from graph `g`. Return `false` if removal fails
(e.g., if vertex is not in the graph); `true` otherwise.

### Performance
Time complexity is ``\\mathcal{O}(k^2)``, where ``k`` is the max of the degrees
of vertex ``v`` and vertex ``|V|``.

### Implementation Notes
This operation has to be performed carefully if one keeps external
data structures indexed by edges or vertices in the graph, since
internally the removal is performed swapping the vertices `v`  and ``|V|``,
and removing the last vertex ``|V|`` from the graph. After removal the
vertices in `g` will be indexed by ``1:|V|-1``.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(2);

julia> rem_vertex!(g, 2)
true

julia> rem_vertex!(g, 2)
false
```
"""
function rem_vertex!(g::AbstractSimpleGraph, v::Integer)
    v in vertices(g) || return false
    n = nv(g)
    self_loop_n = false  # true if n is self-looped (see #820)

    # remove the in_edges from v
    srcs = copy(inneighbors(g, v))
    @inbounds for s in srcs
        rem_edge!(g, edgetype(g)(s, v))
    end
    # remove the in_edges from the last vertex
    neigs = copy(inneighbors(g, n))
    @inbounds for s in neigs
        rem_edge!(g, edgetype(g)(s, n))
    end
    if v != n
        # add the edges from n back to v
        @inbounds for s in neigs
            if s != n  # don't add an edge to the last vertex - see #820.
                add_edge!(g, edgetype(g)(s, v))
            else
                self_loop_n = true
            end
        end
    end

    if is_directed(g)
        # remove the out_edges from v
        dsts = copy(outneighbors(g, v))
        @inbounds for d in dsts
            rem_edge!(g, edgetype(g)(v, d))
        end
        # remove the out_edges from the last vertex
        neigs = copy(outneighbors(g, n))
        @inbounds for d in neigs
            rem_edge!(g, edgetype(g)(n, d))
        end
        if v != n
            # add the out_edges back to v
            @inbounds for d in neigs
                if d != n
                    add_edge!(g, edgetype(g)(v, d))
                end
            end
        end
    end
    if self_loop_n
        add_edge!(g, edgetype(g)(v, v))
    end
    pop!(g.fadjlist)
    if is_directed(g)
        pop!(g.badjlist)
    end
    return true
end

zero(::Type{G}) where {G<:AbstractSimpleGraph} = G()

include("./simpleedge.jl")
include("./simpledigraph.jl")
include("./simplegraph.jl")
include("./simpleedgeiter.jl")
include("./specializations.jl")
include("./generators/deprecations.jl")
include("./generators/staticgraphs.jl")
include("./generators/randgraphs.jl")
include("./generators/euclideangraphs.jl")
include("./generators/smallgraphs.jl")

end # module

"""
    radiality_centrality(g)

Calculate the [radiality centrality](http://www.cbmc.it/fastcent/doc/Radiality.htm)
of a graph `g` across all vertices. Return a vector representing the centrality
calculated for each node in `g`.

The radiality centrality ``R_u`` of a vertex ``u`` is defined as
``
R_u = \\frac{D_g + 1 - \\frac{\\sum_{v∈V}d_{u,v}}{|V|-1}}{D_g}
``

where ``D_g`` is the diameter of the graph and ``d_{u,v}`` is the 
length of the shortest path from ``u`` to ``v``.

### References
- Brandes, U.: A faster algorithm for betweenness centrality. J Math Sociol 25 (2001) 163-177

# Examples
```jldoctest
julia> using Graphs

julia> radiality_centrality(star_graph(4))
4-element Vector{Float64}:
 1.0               
 0.6666666666666666
 0.6666666666666666
 0.6666666666666666

julia> radiality_centrality(path_graph(3))
3-element Vector{Float64}:
 0.75
 1.0 
 0.75
```
"""
function radiality_centrality(g::AbstractGraph)::Vector{Float64}
    n_v = nv(g)
    vs = vertices(g)

    meandists = zeros(Float64, n_v)
    dmtr = 0.0
    for v in vs
        d = dijkstra_shortest_paths(g, v)
        dmtr = max(dmtr, maximum(d.dists))
        meandists[v] = sum(d.dists) / (n_v - 1) # ignore the source vx
    end
    meandists = (dmtr + 1) .- (meandists)
    return meandists ./ dmtr
end

@testset "Bridge" begin
    rng = StableRNG(1)

    gint = SimpleGraph(13)
    add_edge!(gint, 1, 7)
    add_edge!(gint, 1, 2)
    add_edge!(gint, 1, 3)
    add_edge!(gint, 12, 13)
    add_edge!(gint, 10, 13)
    add_edge!(gint, 10, 12)
    add_edge!(gint, 12, 11)
    add_edge!(gint, 5, 4)
    add_edge!(gint, 6, 4)
    add_edge!(gint, 8, 9)
    add_edge!(gint, 6, 5)
    add_edge!(gint, 1, 6)
    add_edge!(gint, 7, 5)
    add_edge!(gint, 7, 3)
    add_edge!(gint, 7, 8)
    add_edge!(gint, 7, 10)
    add_edge!(gint, 7, 12)

    for g in test_generic_graphs(gint)
        brd = @inferred(bridges(g))
        ans = [Edge(1, 2), Edge(8, 9), Edge(7, 8), Edge(11, 12)]
        @test brd == ans
    end
    for level in 1:6
        btree = Graphs.binary_tree(level)
        for tree in test_generic_graphs(btree; eltypes=[Int, UInt8, Int16])
            brd = @inferred(bridges(tree))
            ans = edges(tree)

            # AbstractEdge currently does not implement any comparison operators
            # so instead we compare tuples of source and target vertices
            @test sort([(src(e), dst(e)) for e in brd]) == sort([(src(e), dst(e)) for e in ans])
        end
    end

    hint = blockdiag(wheel_graph(5), wheel_graph(5))
    add_edge!(hint, 5, 6)
    for h in test_generic_graphs(hint; eltypes=[Int, UInt8, Int16])
        brd = @inferred bridges(h)
        @test length(brd) == 1
        @test src(brd[begin]) == 5
        @test dst(brd[begin]) == 6
    end

    dir = GenericDiGraph(SimpleDiGraph(10, 10; rng=rng))
    @test_throws MethodError bridges(dir)
end

SUITE["connectivity"] = BenchmarkGroup(
    [], "graphs" => BenchmarkGroup([]), "digraphs" => BenchmarkGroup([])
)

SUITE["connectivity"]["digraphs"]["strongly_connected_components"] = @benchmarkable [
    Graphs.strongly_connected_components(g) for (_, g) in $DIGRAPHS
]

SUITE["connectivity"]["graphs"]["connected_components"] = @benchmarkable [
    Graphs.connected_components(g) for (_, g) in $GRAPHS
]

# computes normalized cut cost for partition `cut`
function _normalized_cut_cost(cut, W::AbstractMatrix, D)
    cut_cost = zero(eltype(W))
    for j in axes(W, 2)
        for i in axes(W, 1)
            if cut[i] != cut[j]
                cut_cost += W[i, j]
            end
        end
    end
    half_cut_cost = cut_cost / 2
    return half_cut_cost / sum(D * cut) + half_cut_cost / sum(D * (.~cut))
end

function _normalized_cut_cost(cut, W::SparseMatrixCSC, D)
    cut_cost = zero(eltype(W))
    rows = rowvals(W)
    vals = nonzeros(W)
    n = size(W, 2)
    for i in 1:n
        for j in nzrange(W, i)
            row = rows[j]
            if cut[i] != cut[row]
                cut_cost += vals[j]
            end
        end
    end
    half_cut_cost = cut_cost / 2
    return half_cut_cost / sum(D * cut) + half_cut_cost / sum(D * (.~cut))
end

function _partition_weightmx(cut, W::AbstractMatrix)
    nv = length(cut)
    nv2 = sum(cut)
    nv1 = nv - nv2
    newvid = Vector{Int}(undef, nv)
    vmap1 = Vector{Int}(undef, nv1)
    vmap2 = Vector{Int}(undef, nv2)
    j1 = 1
    j2 = 1
    for i in eachindex(cut)
        if cut[i] == false
            newvid[i] = j1
            vmap1[j1] = i
            j1 += 1
        else
            newvid[i] = j2
            vmap2[j2] = i
            j2 += 1
        end
    end

    W1 = similar(W, (nv1, nv1))
    W2 = similar(W, (nv2, nv2))

    for j in axes(W, 2)
        for i in axes(W, 1)
            if cut[i] == cut[j] == false
                W1[newvid[i], newvid[j]] = W[i, j]
            elseif cut[i] == cut[j] == true
                W2[newvid[i], newvid[j]] = W[i, j]
            end
        end
    end

    return (W1, W2, vmap1, vmap2)
end

function _partition_weightmx(cut, W::SparseMatrixCSC)
    nv = length(cut)
    nv2 = sum(cut)
    nv1 = nv - nv2
    newvid = Vector{Int}(undef, nv)
    vmap1 = Vector{Int}(undef, nv1)
    vmap2 = Vector{Int}(undef, nv2)
    j1 = 1
    j2 = 1
    for i in eachindex(cut)
        if cut[i] == false
            newvid[i] = j1
            vmap1[j1] = i
            j1 += 1
        else
            newvid[i] = j2
            vmap2[j2] = i
            j2 += 1
        end
    end

    rows = rowvals(W)
    vals = nonzeros(W)
    I1 = Vector{Int}()
    I2 = Vector{Int}()
    J1 = Vector{Int}()
    J2 = Vector{Int}()
    V1 = Vector{Float64}()
    V2 = Vector{Float64}()
    for i in 1:nv
        for j in nzrange(W, i)
            row = rows[j]
            if cut[i] == cut[row] == false
                push!(I1, newvid[i])
                push!(J1, newvid[row])
                push!(V1, vals[j])
            elseif cut[i] == cut[row] == true
                push!(I2, newvid[i])
                push!(J2, newvid[row])
                push!(V2, vals[j])
            end
        end
    end
    W1 = sparse(I1, J1, V1)
    W2 = sparse(I2, J2, V2)
    return (W1, W2, vmap1, vmap2)
end

function _recursive_normalized_cut(W, thres, num_cuts)
    m, n = size(W)
    (m <= 1) && return ones(Int, m) # trivial
    D = Diagonal(vec(sum(W; dims=2)))

    # check that the diagonal is not degenerated as otherwise invDroot errors
    dnz = abs.(diag(D)) .>= 1E-16
    if !all(dnz)
        # vertices with incident edges summing to almost zero
        # are not connected to the rest of the subnetwork,
        # put them to separate modules and cut the remaining submatrix
        nzlabels = _recursive_normalized_cut(W[dnz, dnz], thres, num_cuts)
        nzix = 0
        zix = maximum(nzlabels)
        return Int[nz ? nzlabels[nzix += 1] : (zix += 1) for nz in dnz]
    end

    # get eigenvector corresponding to the second smallest generalized eigenvalue:
    # v = eigs(D-W, D, nev=2, which=SR())[2][:,2]
    # At least some versions of ARPACK have a bug, this is a workaround
    invDroot = sqrt.(inv(D)) # equal to Cholesky factorization for diagonal D
    if n > 12
        _, Q = eigs(invDroot' * (D - W) * invDroot; nev=12, which=SR())
        (size(Q, 2) <= 1) && return collect(1:m) # no 2nd eigenvector
        ret = convert(Vector, real(view(Q, :, 2)))
    else
        ret = eigen(Matrix(invDroot' * (D - W) * invDroot)).vectors[:, 2]
    end
    v = real(invDroot * ret)

    # perform n-cuts with different partitions of v and find best one
    min_cost = Inf
    best_thres = -1
    vmin, vmax = extrema(v)
    for t in range(vmin; stop=vmax, length=num_cuts)
        cut = v .> t
        cost = _normalized_cut_cost(cut, W, D)
        if cost < min_cost
            min_cost = cost
            best_thres = t
        end
    end

    if min_cost < thres
        # split graph, compute normalized_cut for each subgraph recursively and merge indices.
        cut = v .> best_thres
        W1, W2, vmap1, vmap2 = _partition_weightmx(cut, W)
        labels1 = _recursive_normalized_cut(W1, thres, num_cuts)
        labels2 = _recursive_normalized_cut(W2, thres, num_cuts)

        labels = Vector{Int}(undef, m)
        offset = maximum(labels1)

        for i in eachindex(labels1)
            labels[vmap1[i]] = labels1[i]
        end
        for i in eachindex(labels2)
            labels[vmap2[i]] = labels2[i] + offset
        end

        return labels
    else
        return ones(Int, m)
    end
end

"""
    normalized_cut(g, thres, distmx=weights(g), [num_cuts=10]);

Perform [recursive two-way normalized graph-cut](https://en.wikipedia.org/wiki/Segmentation-based_object_categorization#Normalized_cuts)
on a graph, partitioning the vertices into disjoint sets.
Return a vector that contains the set index for each vertex.

It is important to identify a good threshold for your application. A bisection search over the range (0,1) will help determine a good value of thres.

### Keyword Arguments
- `thres`: Subgraphs aren't split if best normalized cut is above this threshold
- `num_cuts`: Number of cuts performed to determine optimal cut

### References
"Normalized Cuts and Image Segmentation" - Jianbo Shi and Jitendra Malik
"""
function normalized_cut(
    g::AbstractGraph,
    thres::Real,
    W::AbstractMatrix{T}=adjacency_matrix(g),
    num_cuts::Int=10,
) where {T<:Number}
    return _recursive_normalized_cut(W, thres, num_cuts)
end

@testset "Parallel.Floyd Warshall" begin
    g3 = path_graph(5)
    d = [0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]
    for g in testgraphs(g3)
        z = @inferred(Parallel.floyd_warshall_shortest_paths(g, d))
        @test z.dists[3, :][:] == [7, 6, 0, 11, 27]
        @test z.parents[3, :][:] == [2, 3, 0, 3, 4]

        @test @inferred(enumerate_paths(z))[2][2] == []
        @test @inferred(enumerate_paths(z))[2][4] ==
            enumerate_paths(z, 2)[4] ==
            enumerate_paths(z, 2, 4) ==
            [2, 3, 4]
    end
    g4 = path_digraph(4)
    d = ones(4, 4)
    for g in testdigraphs(g4)
        z = @inferred(Parallel.floyd_warshall_shortest_paths(g, d))
        @test length(enumerate_paths(z, 4, 3)) == 0
        @test length(enumerate_paths(z, 4, 1)) == 0
        @test length(enumerate_paths(z, 2, 3)) == 2
    end

    g5 = DiGraph([1 1 1 0 1; 0 1 0 1 1; 0 1 1 0 0; 1 0 1 1 0; 0 0 0 1 1])
    d = [0 3 8 0 -4; 0 0 0 1 7; 0 4 0 0 0; 2 0 -5 0 0; 0 0 0 6 0]
    for g in testdigraphs(g5)
        z = @inferred(Parallel.floyd_warshall_shortest_paths(g, d))
        @test z.dists == [0 1 -3 2 -4; 3 0 -4 1 -1; 7 4 0 5 3; 2 -1 -5 0 -2; 8 5 1 6 0]
    end
end

# The Shortest Path Faster Algorithm for single-source shortest path

###################################################################
#
# The type that encapsulates the state of Shortest Path Faster Algorithm
#
###################################################################

"""
    spfa_shortest_paths(g, s, distmx=weights(g))

Compute shortest paths between a source `s` and all
other nodes in graph `g` using the [Shortest Path Faster Algorithm]
(https://en.wikipedia.org/wiki/Shortest_Path_Faster_Algorithm).

Return a vector of distances to the source.

# Examples

```jldoctest
julia> using Graphs

julia> g = complete_graph(4);

julia> d = [1 1 -1 1; 1 1 -1 1; 1 1 1 1; 1 1 1 1];

julia> spfa_shortest_paths(g, 1, d)
4-element Vector{Int64}:
  0
  0
 -1
  0
```

```jldoctest
julia> using Graphs

julia> g = complete_graph(3);

julia> d = [1 -3 1; -3 1 1; 1 1 1];

julia> spfa_shortest_paths(g, 1, d)
ERROR: Graphs.NegativeCycleError()
[...]
```
"""
function spfa_shortest_paths(
    graph::AbstractGraph{U}, source::Integer, distmx::AbstractMatrix{T}=weights(graph)
) where {T<:Number} where {U<:Integer}
    nvg = nv(graph)

    (source in 1:nvg) ||
        throw(DomainError(source, "source should be in between 1 and $nvg"))
    dists = fill(typemax(T), nvg)
    dists[source] = 0

    count = zeros(U, nvg)           # Vector to store the count of number of times a vertex goes in the queue.

    queue = Vector{U}()             # Vector used to implement queue
    inqueue = falses(nvg, 1)         # BitArray to mark which vertices are in queue
    push!(queue, source)
    inqueue[source] = true

    @inbounds while !isempty(queue)
        v = popfirst!(queue)
        inqueue[v] = false

        @inbounds for v_neighbor in outneighbors(graph, v)
            d = distmx[v, v_neighbor]
            if dists[v] + d < dists[v_neighbor]      # Relaxing edges
                dists[v_neighbor] = dists[v] + d

                if !inqueue[v_neighbor]
                    push!(queue, v_neighbor)
                    inqueue[v_neighbor] = true                   # Mark the vertex as inside queue.
                    count[v_neighbor] = count[v_neighbor] + 1      # Increment the number of times a vertex enters a queue.

                    if count[v_neighbor] > nvg          # This step is just to check negative edge cycle. If this step is not there,
                        throw(NegativeCycleError())     # the algorithm will run infinitely in case of a negative weight cycle.
                        # If count[i]>nvg for any i belonging to [1,nvg], it means a negative edge
                        # cycle is present.
                    end
                end
            end
        end
    end

    return dists
end

has_negative_edge_cycle_spfa(g::AbstractGraph) = false

"""
Function which returns true if there is any negative weight cycle in the graph.
# Examples

```jldoctest
julia> using Graphs

julia> g = complete_graph(3);

julia> d = [1 -3 1; -3 1 1; 1 1 1];

julia> has_negative_edge_cycle_spfa(g, d)
true

julia> g = complete_graph(4);

julia> d = [1 1 -1 1; 1 1 -1 1; 1 1 1 1; 1 1 1 1];

julia> has_negative_edge_cycle_spfa(g, d)
false
```

"""
function has_negative_edge_cycle_spfa(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}
) where {T<:Number} where {U<:Integer}
    try
        spfa_shortest_paths(g, 1, distmx)
    catch e
        isa(e, NegativeCycleError) && return true
    end

    return false
end

@testset "Longest path" begin
    # empty DAG
    g = DiGraph()
    @test dag_longest_path(g) == Int[]

    # unweighted DAG
    g = SimpleDiGraphFromIterator(Edge.([(1, 2), (2, 3), (2, 4), (3, 5), (5, 6), (3, 7)]))
    @test dag_longest_path(g) == [1, 2, 3, 5, 6]

    # weighted DAG
    n = 6
    g = DiGraph(n)
    A = [(1, 2, -5), (2, 3, 1), (3, 4, 1), (4, 5, 0), (3, 5, 4), (1, 6, 2)]
    distmx = fill(NaN, n, n)
    for (i, j, dist) in A
        add_edge!(g, (i, j))
        distmx[i, j] = dist
    end
    @test dag_longest_path(g, distmx) == [2, 3, 5]
end

@testset "Steiner Tree" begin
    function sum_weight(
        g::AbstractGraph{<:Integer}, distmx::AbstractMatrix{<:Integer}=weights(g)
    )
        sum_wt = zero(eltype(g))
        for e in edges(g)
            sum_wt += distmx[src(e), dst(e)]
        end
        return sum_wt
    end

    approx_factor(t::Integer) = 2 - 2 / t

    g3 = star_graph(5)
    for g in testgraphs(g3)
        g_st = @inferred(steiner_tree(g, [2, 5]))
        @test ne(g_st) == 2 # [Edge(2, 1), Edge(1, 5)]

        g_copy = SimpleGraph(g)
        Graphs.filter_non_term_leaves!(g_copy, [2, 5])
        @test ne(g_copy) == 2 # [Edge(2, 1), Edge(1, 5)]

        # non regression test for #362
        g_st = @inferred(steiner_tree(g, [2]))
        @test ne(g_st) == 0
    end

    g4 = path_graph(11)
    for g in testgraphs(g4)
        g_st = @inferred(steiner_tree(g, [4, 8]))
        @test ne(g_st) == 4

        g_copy = SimpleGraph(g)
        Graphs.filter_non_term_leaves!(g_copy, [4, 8])
        @test ne(g_copy) == 4
    end

    g5 = grid([5, 5])
    for g in testgraphs(g5)
        g_st = @inferred(steiner_tree(g, [3, 11, 15, 23]))
        @test sum_weight(g_st) == 8
    end

    d = [
        0 2 3 4 5
        2 0 60 80 1
        3 60 0 120 150
        4 80 120 0 200
        5 1 150 200 0
    ]

    g6 = complete_graph(5)

    for g in testgraphs(g6)
        g_st = @inferred(steiner_tree(g, [2, 4, 5], d))
        @test sum_weight(g_st, d) <= approx_factor(3) * (1 + 2 + 4)
    end

    d[2, 5] = d[5, 2] = 100

    for g in testgraphs(g6)
        g_st = @inferred(steiner_tree(g, [2, 4, 5], d))
        @test sum_weight(g_st, d) <= approx_factor(3) * (2 + 4 + 5)
    end
end

# Parts of this code were taken / derived from Graphs.jl. See LICENSE for
# licensing details.

# A* shortest-path algorithm

"""
    struct AStar <: ShortestPathAlgorithm

The structure used to configure and specify that [`shortest_paths`](@ref)
should use the [A* search algorithm](http://en.wikipedia.org/wiki/A%2A_search_algorithm).
An optional `heuristic` function may be supplied. If missing, the heuristic is set to
`n -> 0`.

### Implementation Notes
`AStar` supports the following shortest-path functionality:
- non-negative distance matrices / weights
- single destination
"""
struct AStar{F<:Function} <: ShortestPathAlgorithm
    heuristic::F
end

AStar(T::Type=Float64) = AStar(n -> zero(T))

struct AStarResult{T,U<:Integer} <: ShortestPathResult
    path::Vector{U}
    dist::T
end

function reconstruct_path!(
    total_path, # a vector to be filled with the shortest path
    came_from, # a vector holding the parent of each node in the A* exploration
    end_idx, # the end vertex
    g,
) # the graph
    curr_idx = end_idx
    while came_from[curr_idx] != curr_idx
        pushfirst!(total_path, came_from[curr_idx])
        curr_idx = came_from[curr_idx]
    end
    return push!(total_path, end_idx)
end

function a_star_impl!(
    g, # the graph
    goal, # the end vertex
    open_set, # an initialized heap containing the active vertices
    closed_set, # an (initialized) color-map to indicate status of vertices
    g_score, # a vector holding g scores for each node
    f_score, # a vector holding f scores for each node
    came_from, # a vector holding the parent of each node in the A* exploration
    distmx,
    heuristic,
)
    T = eltype(g)
    total_path = Vector{T}()

    @inbounds while !isempty(open_set)
        current = dequeue!(open_set)

        if current == goal
            reconstruct_path!(total_path, came_from, current, g)
            return total_path
        end

        closed_set[current] = true

        for neighbor in outneighbors(g, current)
            closed_set[neighbor] && continue

            tentative_g_score = g_score[current] + distmx[current, neighbor]

            if tentative_g_score < g_score[neighbor]
                g_score[neighbor] = tentative_g_score
                priority = tentative_g_score + heuristic(neighbor)
                open_set[neighbor] = priority
                came_from[neighbor] = current
            end
        end
    end
    return total_path
end

function calc_dist(path, distmx)
    T = eltype(distmx)
    isempty(path) && return typemax(T)
    rest_of_path = copy(path)
    dist = zero(T)
    u = pop!(rest_of_path)
    while !isempty(rest_of_path)
        v = pop!(rest_of_path)
        dist += distmx[u, v]
        u = v
    end
    return dist
end

function shortest_paths(
    g::AbstractGraph, s::Integer, t::Integer, distmx::AbstractMatrix, alg::AStar
)
    T = eltype(distmx)

    # if we do checkbounds here, we can use @inbounds in a_star_impl!
    checkbounds(distmx, Base.OneTo(nv(g)), Base.OneTo(nv(g)))

    open_set = PriorityQueue{Integer,T}()
    enqueue!(open_set, s, 0)

    closed_set = zeros(Bool, nv(g))

    g_score = fill(Inf, nv(g))
    g_score[s] = 0

    f_score = fill(Inf, nv(g))
    f_score[s] = alg.heuristic(s)

    came_from = -ones(Integer, nv(g))
    came_from[s] = s

    path = a_star_impl!(
        g, t, open_set, closed_set, g_score, f_score, came_from, distmx, alg.heuristic
    )
    return AStarResult(path, calc_dist(path, distmx))
end

function shortest_paths(g::AbstractGraph, s::Integer, t::Integer, alg::AStar)
    return shortest_paths(g, s, t, weights(g), alg)
end
paths(s::AStarResult) = [s.path]
paths(s::AStarResult, v::Integer) = throw(ArgumentError("AStar produces at most one path."))
dists(s::AStarResult) = [[s.dist]]
dists(s::AStarResult, v::Integer) = throw(ArgumentError("AStar produces at most one path."))

@testset "All simple paths" begin
    # single path
    g = path_graph(4)
    paths = all_simple_paths(g, 1, 4)
    @test Set(paths) == Set(collect(paths)) == Set([[1, 2, 3, 4]])

    # printing
    @test sprint(show, paths) == "SimplePathIterator{SimpleGraph{Int64}}(1 → 4)"

    # complete graph with cutoff
    g = complete_graph(4)
    @test Set(all_simple_paths(g, 1, 4; cutoff=2)) == Set([[1, 2, 4], [1, 3, 4], [1, 4]])

    # two paths
    g = path_graph(4)
    add_vertex!(g)
    add_edge!(g, 3, 5)
    paths = all_simple_paths(g, 1, [4, 5])
    @test Set(paths) == Set([[1, 2, 3, 4], [1, 2, 3, 5]])
    @test Set(collect(paths)) == Set([[1, 2, 3, 4], [1, 2, 3, 5]]) # check `collect` also

    # two paths, with one beyond a cut-off
    g = path_graph(4)
    add_vertex!(g)
    add_edge!(g, 3, 5)
    add_vertex!(g)
    add_edge!(g, 5, 6)
    paths = all_simple_paths(g, 1, [4, 6])
    @test Set(paths) == Set([[1, 2, 3, 4], [1, 2, 3, 5, 6]])
    paths = all_simple_paths(g, 1, [4, 6]; cutoff=3)
    @test Set(paths) == Set([[1, 2, 3, 4]])

    # two targets in line emits two paths
    g = path_graph(4)
    add_vertex!(g)
    paths = all_simple_paths(g, 1, [3, 4])
    @test Set(paths) == Set([[1, 2, 3], [1, 2, 3, 4]])

    # two paths digraph
    g = SimpleDiGraph(5)
    add_edge!(g, 1, 2)
    add_edge!(g, 2, 3)
    add_edge!(g, 3, 4)
    add_edge!(g, 3, 5)
    paths = all_simple_paths(g, 1, [4, 5])
    @test Set(paths) == Set([[1, 2, 3, 4], [1, 2, 3, 5]])

    # two paths digraph with cutoff
    g = SimpleDiGraph(5)
    add_edge!(g, 1, 2)
    add_edge!(g, 2, 3)
    add_edge!(g, 3, 4)
    add_edge!(g, 3, 5)
    paths = all_simple_paths(g, 1, [4, 5]; cutoff=3)
    @test Set(paths) == Set([[1, 2, 3, 4], [1, 2, 3, 5]])

    # digraph with a cycle
    g = SimpleDiGraph(4)
    add_edge!(g, 1, 2)
    add_edge!(g, 2, 3)
    add_edge!(g, 3, 1)
    add_edge!(g, 2, 4)
    paths = all_simple_paths(g, 1, 4)
    @test Set(paths) == Set([[1, 2, 4]])

    # digraph with a cycle; paths with two targets share a node in the cycle
    g = SimpleDiGraph(4)
    add_edge!(g, 1, 2)
    add_edge!(g, 2, 3)
    add_edge!(g, 3, 1)
    add_edge!(g, 2, 4)
    paths = all_simple_paths(g, 1, [3, 4])
    @test Set(paths) == Set([[1, 2, 3], [1, 2, 4]])

    # another digraph with a cycle; check cycles are excluded, regardless of cutoff
    g = SimpleDiGraph(6)
    add_edge!(g, 1, 2)
    add_edge!(g, 2, 3)
    add_edge!(g, 3, 4)
    add_edge!(g, 4, 5)
    add_edge!(g, 5, 2)
    add_edge!(g, 5, 6)
    paths = all_simple_paths(g, 1, 6)
    paths′ = all_simple_paths(g, 1, 6; cutoff=typemax(Int))
    @test Set(paths) == Set(paths′) == Set([[1, 2, 3, 4, 5, 6]])

    # same source and target vertex
    g = path_graph(4)
    @test Set(all_simple_paths(g, 1, 1)) == Set([[1]])
    @test Set(all_simple_paths(g, 3, 3)) == Set([[3]])
    @test Set(all_simple_paths(g, 1, [1, 1])) == Set([[1]])
    @test Set(all_simple_paths(g, 1, [1, 4])) == Set([[1], [1, 2, 3, 4]])

    # cutoff prunes paths (note: maximum path length below is `nv(g) - 1`)
    g = complete_graph(4)
    paths = all_simple_paths(g, 1, 2; cutoff=1)
    @test Set(paths) == Set([[1, 2]])

    paths = all_simple_paths(g, 1, 2; cutoff=2)
    @test Set(paths) == Set([[1, 2], [1, 3, 2], [1, 4, 2]])

    # nontrivial graph
    g = SimpleDiGraph(6)
    add_edge!(g, 1, 2)
    add_edge!(g, 2, 3)
    add_edge!(g, 3, 4)
    add_edge!(g, 4, 5)

    add_edge!(g, 1, 6)
    add_edge!(g, 2, 6)
    add_edge!(g, 2, 4)
    add_edge!(g, 6, 5)
    add_edge!(g, 5, 3)
    add_edge!(g, 5, 4)

    paths = all_simple_paths(g, 2, [3, 4])
    @test Set(paths) == Set([
        [2, 3], [2, 4, 5, 3], [2, 6, 5, 3], [2, 4], [2, 3, 4], [2, 6, 5, 4], [2, 6, 5, 3, 4]
    ])

    paths = all_simple_paths(g, 2, [3, 4]; cutoff=3)
    @test Set(paths) ==
        Set([[2, 3], [2, 4, 5, 3], [2, 6, 5, 3], [2, 4], [2, 3, 4], [2, 6, 5, 4]])

    paths = all_simple_paths(g, 2, [3, 4]; cutoff=2)
    @test Set(paths) == Set([[2, 3], [2, 4], [2, 3, 4]])
end

"""
    edit_distance(G₁::AbstractGraph, G₂::AbstractGraph)

Compute the edit distance between graphs `G₁` and `G₂`. Return the minimum
edit cost and edit path to transform graph `G₁` into graph `G₂``.
An edit path consists of a sequence of pairs of vertices ``(u,v) ∈ [0,|G₁|] × [0,|G₂|]``
representing vertex operations:

- ``(0,v)``: insertion of vertex ``v ∈ G₂``
- ``(u,0)``: deletion of vertex ``u ∈ G₁``
- ``(u>0,v>0)``: substitution of vertex ``u ∈ G₁`` by vertex ``v ∈ G₂``


### Optional Arguments
- `vertex_insert_cost::Function=v->0.`
- `vertex_delete_cost::Function=u->0.`
- `vertex_subst_cost::Function=(u, v)->0.`
- `edge_insert_cost::Function=e->1.`
- `edge_delete_cost::Function=e->1.`
- `edge_subst_cost::Function=(e1, e2)->0.`

The algorithm will always try to match two edges if it can, so if it is
preferrable to delete two edges rather than match these, it should be
reflected in the `edge_subst_cost` function.

By default, the algorithm uses constant operation costs. The
user can provide classical Minkowski costs computed from vertex
labels μ₁ (for G₁) and μ₂ (for G₂) in order to further guide the
search, for example:

```
edit_distance(G₁, G₂, subst_cost=MinkowskiCost(μ₁, μ₂))
```
- `heuristic::Function=DefaultEditHeuristic`: a custom heuristic provided to the A*
search in case the default heuristic is not satisfactory.

### Performance
- Given two graphs ``|G₁| < |G₂|``, `edit_distance(G₁, G₂)` is faster to
compute than `edit_distance(G₂, G₁)`. Consider swapping the arguments
if involved costs are equivalent.
- The use of a heuristic can improve performance considerably.
- Exploit vertex attributes when designing operation costs.

### References
- RIESEN, K., 2015. Structural Pattern Recognition with Graph Edit Distance: Approximation Algorithms and Applications. (Chapter 2)

### Author
- Júlio Hoffimann Mendes (juliohm@stanford.edu)

# Examples
```jldoctest
julia> using Graphs

julia> g1 = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> g2 = SimpleDiGraph([0 1 0; 0 0 1; 1 0 0]);

julia> edit_distance(g1, g2)
(3.0, Tuple[(1, 3), (2, 1), (3, 2), (4, 0), (5, 0)])
```
"""
function edit_distance(
    G₁::AbstractGraph,
    G₂::AbstractGraph;
    vertex_insert_cost=nothing,
    vertex_delete_cost=nothing,
    vertex_subst_cost=nothing,
    edge_insert_cost=nothing,
    edge_delete_cost=nothing,
    edge_subst_cost=nothing,
    heuristic=nothing,
)
    if isnothing(vertex_insert_cost) &&
        isnothing(vertex_delete_cost) &&
        isnothing(vertex_subst_cost) &&
        isnothing(edge_insert_cost) &&
        isnothing(edge_delete_cost) &&
        isnothing(edge_subst_cost) &&
        isnothing(heuristic)
        heuristic = default_edit_heuristic
    end
    vertex_insert_cost = something(vertex_insert_cost, v -> 0.0)
    vertex_delete_cost = something(vertex_delete_cost, v -> 0.0)
    vertex_subst_cost = something(vertex_subst_cost, (u, v) -> 0.0)
    edge_insert_cost = something(edge_insert_cost, e -> 1.0)
    edge_delete_cost = something(edge_delete_cost, e -> 1.0)
    edge_subst_cost = something(edge_subst_cost, (e1, e2) -> 0.0)
    heuristic = something(heuristic, (λ, G₁, G₂) -> 0.0)
    return _edit_distance(
        G₁::AbstractGraph,
        G₂::AbstractGraph,
        vertex_insert_cost,
        vertex_delete_cost,
        vertex_subst_cost,
        edge_insert_cost,
        edge_delete_cost,
        edge_subst_cost,
        heuristic,
    )
end

function _edit_distance(
    G₁::AbstractGraph{T},
    G₂::AbstractGraph{U},
    vertex_insert_cost::Function,
    vertex_delete_cost::Function,
    vertex_subst_cost::Function,
    edge_insert_cost::Function,
    edge_delete_cost::Function,
    edge_subst_cost::Function,
    heuristic::Function,
) where {T<:Integer,U<:Integer}
    isdirected = is_directed(G₁) || is_directed(G₂)

    # compute the cost on edges due to associate u1 to v1 and u2 to v2
    # u2 and v2 can eventually be 0
    function association_cost(u1, u2, v1, v2)
        cost = 0.0
        if has_edge(G₁, u1, u2)
            if has_edge(G₂, v1, v2)
                cost += edge_subst_cost(Edge(u1, u2), Edge(v1, v2))
            else
                cost += edge_delete_cost(Edge(u1, u2))
            end
        else
            if has_edge(G₂, v1, v2)
                cost += edge_insert_cost(Edge(v1, v2))
            end
        end
        if isdirected && u1 != u2
            if has_edge(G₁, u2, u1)
                if has_edge(G₂, v2, v1)
                    cost += edge_subst_cost(Edge(u2, u1), Edge(v2, v1))
                else
                    cost += edge_delete_cost(Edge(u2, u1))
                end
            else
                if has_edge(G₂, v2, v1)
                    cost += edge_insert_cost(Edge(v2, v1))
                end
            end
        end
        return cost
    end

    # A* search heuristic
    h(λ) = heuristic(λ, G₁, G₂)

    # initialize open set
    OPEN = PriorityQueue{Vector{Tuple},Float64}()
    for v in vertices(G₂)
        push!(OPEN, [(T(1), v)] => vertex_subst_cost(1, v) + h([(T(1), v)]))
    end
    push!(OPEN, [(T(1), U(0))] => vertex_delete_cost(1) + h([(T(1), U(0))]))

    c = 0
    while true
        # minimum (partial) edit path
        λ, cost = first(OPEN)
        c += 1
        popfirst!(OPEN)

        if is_complete_path(λ, G₁, G₂)
            return cost, λ
        else
            u1, _ = λ[end]
            u1 += T(1)
            vs = setdiff(vertices(G₂), [v for (u, v) in λ])

            if u1 <= nv(G₁) # there are still vertices to process in G₁?
                # we try every possible assignment of v1
                for v1 in vs
                    λ⁺ = [λ; (u1, v1)]
                    new_cost = cost + vertex_subst_cost(u1, v1) + h(λ⁺) - h(λ)
                    for (u2, v2) in λ
                        new_cost += association_cost(u1, u2, v1, v2)
                    end
                    new_cost += association_cost(u1, u1, v1, v1) # handle self-loops

                    push!(OPEN, λ⁺ => new_cost)
                end
                # we try deleting v1
                λ⁺ = [λ; (u1, U(0))]
                new_cost = cost + vertex_delete_cost(u1) + h(λ⁺) - h(λ)
                for u2 in outneighbors(G₁, u1)
                    # edges deleted later when assigning v2
                    u2 > u1 && continue
                    new_cost += edge_delete_cost(Edge(u1, u2))
                end
                if isdirected
                    for u2 in inneighbors(G₁, u1)
                        # edges deleted later when assigning v2, and we should not count a self loop twice
                        u2 >= u1 && continue
                        new_cost += edge_delete_cost(Edge(u2, u1))
                    end
                end
                push!(OPEN, λ⁺ => new_cost)
            else
                # add remaining vertices of G₂ to the path by deleting them
                λ⁺ = [λ; [(T(0), v) for v in vs]]
                new_cost = cost + sum(vertex_insert_cost, vs)
                for v1 in vs
                    for v2 in outneighbors(G₂, v1)
                        (v2 > v1 && v2 in vs) && continue # these edges will be deleted later
                        new_cost += edge_insert_cost(Edge(v1, v2))
                    end
                    if isdirected
                        for v2 in inneighbors(G₂, v1)
                            (v2 > v1 && v2 in vs) && continue # these edges will be deleted later
                            v1 == v2 && continue # we should not count a self loop twice
                            new_cost += edge_insert_cost(Edge(v2, v1))
                        end
                    end
                end
                push!(OPEN, λ⁺ => new_cost + h(λ⁺) - h(λ))
            end
        end
    end
end

function is_complete_path(λ, G₁, G₂)
    us = Set()
    vs = Set()
    for (u, v) in λ
        push!(us, u)
        push!(vs, v)
    end
    delete!(us, 0)
    delete!(vs, 0)

    return length(us) == nv(G₁) && length(vs) == nv(G₂)
end

# edit_distance(G₁::AbstractGraph, G₂::AbstractGraph) =
#         edit_distance(G₁, G₂,
#             vertex_insert_cost=v -> 0.,
#             vertex_delete_cost=u -> 0.,
#             vertex_subst_cost=(u, v) -> 0.,
#             edge_insert_cost=e -> 1.,
#             edge_delete_cost=e -> 1.,
#             edge_subst_cost=(e1, e2) -> 0.,
#             heuristic=default_edit_heuristic)

"""
compute an upper bound on the number of edges that can still be affected
"""
function default_edit_heuristic(λ, G₁::AbstractGraph, G₂::AbstractGraph)
    us = setdiff(1:nv(G₁), [u for (u, v) in λ])
    vs = setdiff(1:nv(G₂), [v for (u, v) in λ])
    total_free_edges_g1 = 0
    total_free_edges_g2 = 0
    if !isempty(us)
        total_free_edges_g1 = sum(u -> outdegree(G₁, u), us)
    end
    if !isempty(vs)
        total_free_edges_g2 = sum(v -> outdegree(G₂, v), vs)
    end
    for (u1, v1) in λ
        (u1 == 0 || v1 == 0) && continue
        total_free_edges_g1 += count(u2 -> u2 in us, outneighbors(G₁, u1))
        total_free_edges_g2 += count(v2 -> v2 in vs, outneighbors(G₂, v1))
    end
    if !is_directed(G₁) && !is_directed(G₂)
        total_free_edges_g1 = total_free_edges_g1 / 2
        total_free_edges_g2 = total_free_edges_g2 / 2
    end
    return abs(total_free_edges_g1 - total_free_edges_g2)
end

#-------------------------
# Edit path cost functions
#-------------------------

"""
    MinkowskiCost(μ₁, μ₂; p::Real=1)

For labels μ₁ on the vertices of graph G₁ and labels μ₂ on the vertices
of graph G₂, compute the p-norm cost of substituting vertex u ∈ G₁ by
vertex v ∈ G₂.

### Optional Arguments
`p=1`: the p value for p-norm calculation.
"""
function MinkowskiCost(μ₁::AbstractVector, μ₂::AbstractVector; p::Real=1)
    return (u, v) -> norm(μ₁[u] - μ₂[v], p)
end

"""
    BoundedMinkowskiCost(μ₁, μ₂)

Return value similar to [`MinkowskiCost`](@ref), but ensure costs smaller than 2τ.

### Optional Arguments
`p=1`: the p value for p-norm calculation.
`τ=1`: value specifying half of the upper limit of the Minkowski cost.
"""
function BoundedMinkowskiCost(μ₁::AbstractVector, μ₂::AbstractVector; p::Real=1, τ::Real=1)
    return (u, v) -> 1 / (1 / (2τ) + exp(-norm(μ₁[u] - μ₂[v], p)))
end

@testset "Parallel.Generate Reduce" begin
    function make_vec(g::AbstractGraph{T}) where {T<:Integer}
        return Vector{T}(undef, nv(g))
    end

    function comp_vec(x::Vector, y::Vector)
        return length(x) < length(y)
    end

    g1 = star_graph(5)

    for parallel in [:distributed, :threads]
        for g in testgraphs(g1)
            s = @inferred(
                Graphs.Parallel.generate_reduce(g, make_vec, comp_vec, 5; parallel=parallel)
            )
            @test length(s) == 5
        end
    end
end

##################################################################
#
#   Maximal cliques of undirected graph
#   Derived from Graphs.jl: https://github.com/julialang/Graphs.jl
#
##################################################################

@testset "Cliques" begin
    function setofsets(array_of_arrays)
        return Set(map(Set, array_of_arrays))
    end

    function test_cliques(graph, expected)
        # Make test results insensitive to ordering
        okay_maximal = setofsets(@inferred(maximal_cliques(graph))) == setofsets(expected)
        okay_maximum = Set(@inferred(maximum_clique(graph))) in setofsets(expected)
        okay_maximum2 =
            length(@inferred(maximum_clique(graph))) == maximum(length.(expected))
        okay_number = @inferred(clique_number(graph)) == maximum(length.(expected))
        return okay_maximal && okay_maximum && okay_maximum2 && okay_number
    end

    gx = SimpleGraph(3)
    add_edge!(gx, 1, 2)
    for g in test_generic_graphs(gx)
        @test test_cliques(g, Array[[1, 2], [3]])
    end
    add_edge!(gx, 2, 3)
    for g in test_generic_graphs(gx)
        @test test_cliques(g, Array[[1, 2], [2, 3]])
    end
    # Test for "pivotdonenbrs not defined" bug
    h = SimpleGraph(6)
    add_edge!(h, 1, 2)
    add_edge!(h, 1, 3)
    add_edge!(h, 1, 4)
    add_edge!(h, 2, 5)
    add_edge!(h, 2, 6)
    add_edge!(h, 3, 4)
    add_edge!(h, 3, 6)
    add_edge!(h, 5, 6)

    for g in test_generic_graphs(h)
        @test !isempty(@inferred(maximal_cliques(g)))
    end

    # test for extra cliques bug

    h = SimpleGraph(7)
    add_edge!(h, 1, 3)
    add_edge!(h, 2, 6)
    add_edge!(h, 3, 5)
    add_edge!(h, 3, 6)
    add_edge!(h, 4, 5)
    add_edge!(h, 4, 7)
    add_edge!(h, 5, 7)
    for g in test_generic_graphs(h)
        @test test_cliques(h, Array[[7, 4, 5], [2, 6], [3, 5], [3, 6], [3, 1]])
    end
end

export RandomVertexCover

struct RandomVertexCover end

"""
    vertex_cover(g, RandomVertexCover(); rng=nothing, seed=nothing)

Find a set of vertices such that every edge in `g` has some vertex in the set as 
atleast one of its end point.

### Implementation Notes
Performs [Approximate Minimum Vertex Cover](https://en.wikipedia.org/wiki/Vertex_cover#Approximate_evaluation) once.
Returns a vector of vertices representing the vertices in the Vertex Cover.

### Performance
Runtime: O(|V|+|E|)
Memory: O(|E|)
Approximation Factor: 2

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- If `seed >= 0`, a random generator is seeded with this value.
"""
function vertex_cover(
    g::AbstractGraph{T},
    alg::RandomVertexCover;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    (ne(g) > 0) || return Vector{T}() #Shuffle raises error
    nvg = nv(g)
    in_cover = falses(nvg)
    length_cover = 0

    rng = rng_from_rng_or_seed(rng, seed)
    @inbounds for e in shuffle(rng, collect(edges(g)))
        u = src(e)
        v = dst(e)
        if !(in_cover[u] || in_cover[v])
            in_cover[u] = in_cover[v] = true
            length_cover += (v != u ? 2 : 1)
        end
    end

    return Graphs.findall!(in_cover, Vector{T}(undef, length_cover))
end

const SimpleDiGraphEdge = SimpleEdge

"""
    SimpleDiGraph{T}

A type representing a directed graph.
"""
mutable struct SimpleDiGraph{T<:Integer} <: AbstractSimpleGraph{T}
    ne::Int
    fadjlist::Vector{Vector{T}} # [src]: (dst, dst, dst)
    badjlist::Vector{Vector{T}} # [dst]: (src, src, src)

    function SimpleDiGraph{T}(
        ne::Int, fadjlist::Vector{Vector{T}}, badjlist::Vector{Vector{T}}
    ) where {T}
        throw_if_invalid_eltype(T)
        return new(ne, fadjlist, badjlist)
    end
end

function SimpleDiGraph(
    ne::Int, fadjlist::Vector{Vector{T}}, badjlist::Vector{Vector{T}}
) where {T}
    return SimpleDiGraph{T}(ne, fadjlist, badjlist)
end

# DiGraph{UInt8}(6), DiGraph{Int16}(7), DiGraph{Int8}()
"""
    SimpleDiGraph{T}(n=0)

Construct a `SimpleDiGraph{T}` with `n` vertices and 0 edges.
If not specified, the element type `T` is the type of `n`.

## Examples
```jldoctest
julia> using Graphs

julia> SimpleDiGraph(UInt8(10))
{10, 0} directed simple UInt8 graph
```
"""
function SimpleDiGraph{T}(n::Integer=0) where {T<:Integer}
    fadjlist = [Vector{T}() for _ in 1:n]
    badjlist = [Vector{T}() for _ in 1:n]
    return SimpleDiGraph(0, fadjlist, badjlist)
end

# SimpleDiGraph(6), SimpleDiGraph(0x5)
SimpleDiGraph(n::T) where {T<:Integer} = SimpleDiGraph{T}(n)

# SimpleDiGraph()
SimpleDiGraph() = SimpleDiGraph{Int}()

# SimpleDiGraph(UInt8)
"""
    SimpleDiGraph(::Type{T})

Construct an empty `SimpleDiGraph{T}` with 0 vertices and 0 edges.

## Examples
```jldoctest
julia> using Graphs

julia> SimpleDiGraph(UInt8)
{0, 0} directed simple UInt8 graph
```
"""
SimpleDiGraph(::Type{T}) where {T<:Integer} = SimpleDiGraph{T}(zero(T))

# SimpleDiGraph(adjmx)
"""
    SimpleDiGraph{T}(adjm::AbstractMatrix)

Construct a `SimpleDiGraph{T}` from the adjacency matrix `adjm`.
If `adjm[i][j] != 0`, an edge `(i, j)` is inserted. `adjm` must be a square matrix.
The element type `T` can be omitted.

## Examples
```jldoctest
julia> using Graphs

julia> A1 = [false true; false false]
2×2 Matrix{Bool}:
 0  1
 0  0

julia> SimpleDiGraph(A1)
{2, 1} directed simple Int64 graph

julia> A2 = [2 7; 5 0]
2×2 Matrix{Int64}:
 2  7
 5  0

julia> SimpleDiGraph{Int16}(A2)
{2, 3} directed simple Int16 graph
```
"""
SimpleDiGraph(adjmx::AbstractMatrix) = SimpleDiGraph{Int}(adjmx)

# sparse adjacency matrix constructor: SimpleDiGraph(adjmx)
function SimpleDiGraph{T}(adjmx::SparseMatrixCSC{U}) where {T<:Integer} where {U<:Real}
    dima, dimb = size(adjmx)
    isequal(dima, dimb) ||
        throw(ArgumentError("Adjacency / distance matrices must be square"))

    g = SimpleDiGraph(T(dima))
    maxc = length(adjmx.colptr)
    @inbounds for c in 1:(maxc - 1)
        for rind in adjmx.colptr[c]:(adjmx.colptr[c + 1] - 1)
            isnz = (adjmx.nzval[rind] != zero(U))
            if isnz
                r = adjmx.rowval[rind]
                add_edge!(g, r, c)
            end
        end
    end
    return g
end

# dense adjacency matrix constructor: DiGraph{UInt8}(adjmx)
function SimpleDiGraph{T}(adjmx::AbstractMatrix{U}) where {T<:Integer} where {U<:Real}
    dima, dimb = size(adjmx)
    isequal(dima, dimb) ||
        throw(ArgumentError("Adjacency / distance matrices must be square"))

    g = SimpleDiGraph(T(dima))
    @inbounds for i in findall(adjmx .!= zero(U))
        add_edge!(g, i[1], i[2])
    end
    return g
end

# converts DiGraph{Int} to DiGraph{Int32}
"""
    SimpleDiGraph{T}(g::SimpleDiGraph)

Construct a copy of g.
If the element type `T` is specified, the vertices of `g` are converted to this type.
Otherwise the element type is the same as for `g`.

## Examples
```jldoctest
julia> using Graphs

julia> g = complete_digraph(5)
{5, 20} directed simple Int64 graph

julia> SimpleDiGraph{UInt8}(g)
{5, 20} directed simple UInt8 graph
```
"""
function SimpleDiGraph{T}(g::SimpleDiGraph) where {T<:Integer}
    h_fadj = [Vector{T}(x) for x in fadj(g)]
    h_badj = [Vector{T}(x) for x in badj(g)]
    return SimpleDiGraph(ne(g), h_fadj, h_badj)
end

SimpleDiGraph(g::SimpleDiGraph) = copy(g)

# constructor from abstract graph: SimpleDiGraph(graph)
"""
    SimpleDiGraph(g::AbstractSimpleGraph)

Construct an directed `SimpleDiGraph` from a graph `g`.
The element type is the same as for `g`.

## Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(Int8(5))
{5, 4} undirected simple Int8 graph

julia> SimpleDiGraph(g)
{5, 8} directed simple Int8 graph
```
"""
function SimpleDiGraph(g::AbstractSimpleGraph)
    h = SimpleDiGraph(nv(g))
    h.ne = ne(g) * 2 - num_self_loops(g)
    h.fadjlist = deepcopy_adjlist(fadj(g))
    h.badjlist = deepcopy_adjlist(badj(g))
    return h
end

@inbounds function cleanupedges!(
    fadjlist::Vector{Vector{T}}, badjlist::Vector{Vector{T}}
) where {T<:Integer}
    neg = 0
    for v in 1:length(fadjlist)
        if !issorted(fadjlist[v])
            sort!(fadjlist[v])
        end
        if !issorted(badjlist[v])
            sort!(badjlist[v])
        end
        unique!(fadjlist[v])
        unique!(badjlist[v])
        neg += length(fadjlist[v])
    end
    return neg
end

"""
    SimpleDiGraph(edge_list::Vector)

Construct a `SimpleDiGraph` from a vector of edges.
The element type is taken from the edges in `edge_list`.
The number of vertices is the highest that is used in an edge in `edge_list`.

### Implementation Notes
This constructor works the fastest when `edge_list` is sorted
by the lexical ordering and does not contain any duplicates.

### See also
[`SimpleDiGraphFromIterator`](@ref)

## Examples
```jldoctest
julia> using Graphs

julia> el = Edge.([ (1, 3), (1, 5), (3, 1) ])
3-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 3
 Edge 1 => 5
 Edge 3 => 1
 
julia> SimpleDiGraph(el)
{5, 3} directed simple Int64 graph
```
"""
function SimpleDiGraph(edge_list::Vector{SimpleDiGraphEdge{T}}) where {T<:Integer}
    nvg = zero(T)
    @inbounds(
        for e in edge_list
            nvg = max(nvg, src(e), dst(e))
        end
    )

    list_sizes_out = ones(Int, nvg)
    list_sizes_in = ones(Int, nvg)
    degs_out = zeros(Int, nvg)
    degs_in = zeros(Int, nvg)
    @inbounds(
        for e in edge_list
            s, d = src(e), dst(e)
            (s >= 1 && d >= 1) || continue
            degs_out[s] += 1
            degs_in[d] += 1
        end
    )

    fadjlist = Vector{Vector{T}}(undef, nvg)
    badjlist = Vector{Vector{T}}(undef, nvg)
    @inbounds(
        for v in 1:nvg
            fadjlist[v] = Vector{T}(undef, degs_out[v])
            badjlist[v] = Vector{T}(undef, degs_in[v])
        end
    )

    @inbounds(
        for e in edge_list
            s, d = src(e), dst(e)
            (s >= 1 && d >= 1) || continue
            fadjlist[s][list_sizes_out[s]] = d
            list_sizes_out[s] += 1
            badjlist[d][list_sizes_in[d]] = s
            list_sizes_in[d] += 1
        end
    )

    neg = cleanupedges!(fadjlist, badjlist)
    g = SimpleDiGraph{T}()
    g.fadjlist = fadjlist
    g.badjlist = badjlist
    g.ne = neg

    return g
end

"""
    SimpleDiGraph{T}(g::AbstractGraph)
    SimpleDiGraph(g::AbstractGraph)

Construct a `SimpleDiGraph` from any `AbstractGraph` by enumerating edges.

If `g` is undirected, both directed edges `(u, v)` and `(v, u)` are added if undirected edge `{u, v}` exists.
"""
function SimpleDiGraph{T}(g::AbstractGraph) where {T}
    eds = edges(g)
    srcs = src.(eds)
    dsts = dst.(eds)
    if !is_directed(g)
        append!(srcs, dst.(eds))
        append!(dsts, src.(eds))
    end
    newg = SimpleDiGraph(Edge{T}.(srcs, dsts))
    add_vertices!(newg, nv(g) - nv(newg))
    return newg
end

SimpleDiGraph(g::AbstractGraph{T}) where {T} = SimpleDiGraph{T}(g)

@inbounds function add_to_lists!(
    fadjlist::Vector{Vector{T}}, badjlist::Vector{Vector{T}}, s::T, d::T
) where {T<:Integer}
    nvg = length(fadjlist)
    nvg_new = max(nvg, s, d)
    for v in (nvg + 1):nvg_new
        push!(fadjlist, Vector{T}())
        push!(badjlist, Vector{T}())
    end

    push!(fadjlist[s], d)
    return push!(badjlist[d], s)
end

# Try to get the eltype from the first element
function _SimpleDiGraphFromIterator(iter)::SimpleDiGraph
    next = iterate(iter)
    if (next === nothing)
        return SimpleDiGraph(0)
    end

    e = first(next)
    E = typeof(e)
    if !(E <: SimpleGraphEdge{<:Integer})
        throw(DomainError(iter, "Edges must be of type SimpleEdge{T <: Integer}"))
    end

    T = eltype(e)
    g = SimpleDiGraph{T}()
    fadjlist = Vector{Vector{T}}()
    badjlist = Vector{Vector{T}}()

    while !isnothing(next)
        (e, state) = next

        if !(e isa E)
            throw(DomainError(iter, "Edges must all have the same type."))
        end
        s, d = src(e), dst(e)
        if ((s >= 1) & (d >= 1))
            add_to_lists!(fadjlist, badjlist, s, d)
        end

        next = iterate(iter, state)
    end

    neg = cleanupedges!(fadjlist, badjlist)
    g.fadjlist = fadjlist
    g.badjlist = badjlist
    g.ne = neg

    return g
end

function _SimpleDiGraphFromIterator(iter, ::Type{T}) where {T<:Integer}
    g = SimpleDiGraph{T}()
    fadjlist = Vector{Vector{T}}()
    badjlist = Vector{Vector{T}}()

    @inbounds(
        for e in iter
            s, d = src(e), dst(e)
            (s >= 1 && d >= 1) || continue
            add_to_lists!(fadjlist, badjlist, s, d)
        end
    )

    neg = cleanupedges!(fadjlist, badjlist)
    g.fadjlist = fadjlist
    g.badjlist = badjlist
    g.ne = neg

    return g
end

"""
    SimpleDiGraphFromIterator(iter)

Create a `SimpleDiGraph` from an iterator `iter`. The elements in `iter` must
be of `type <: SimpleEdge`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph(2);

julia> add_edge!(g, 1, 2);

julia> add_edge!(g, 2, 1);

julia> h = SimpleDiGraphFromIterator(edges(g))
{2, 2} directed simple Int64 graph

julia> collect(edges(h))
2-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 1
```
"""
function SimpleDiGraphFromIterator(iter)::SimpleDiGraph
    if Base.IteratorEltype(iter) == Base.HasEltype()
        E = eltype(iter)
        if (E <: SimpleGraphEdge{<:Integer} && isconcretetype(E))
            T = eltype(E)
            if isconcretetype(T)
                return _SimpleDiGraphFromIterator(iter, T)
            end
        end
    end

    return _SimpleDiGraphFromIterator(iter)
end

edgetype(::SimpleDiGraph{T}) where {T<:Integer} = SimpleGraphEdge{T}

badj(g::SimpleDiGraph) = g.badjlist
badj(g::SimpleDiGraph, v::Integer) = badj(g)[v]

function copy(g::SimpleDiGraph{T}) where {T<:Integer}
    return SimpleDiGraph{T}(
        g.ne, deepcopy_adjlist(g.fadjlist), deepcopy_adjlist(g.badjlist)
    )
end

function ==(g::SimpleDiGraph, h::SimpleDiGraph)
    return vertices(g) == vertices(h) &&
           ne(g) == ne(h) &&
           fadj(g) == fadj(h) &&
           badj(g) == badj(h)
end

is_directed(::Type{<:SimpleDiGraph}) = true

function has_edge(g::SimpleDiGraph{T}, s, d) where {T}
    verts = vertices(g)
    (s in verts && d in verts) || return false  # edge out of bounds
    @inbounds list = g.fadjlist[s]
    @inbounds list_backedge = g.badjlist[d]
    if length(list) > length(list_backedge)
        d = s
        list = list_backedge
    end
    return insorted(d, list)
end

function has_edge(g::SimpleDiGraph{T}, e::SimpleDiGraphEdge{T}) where {T}
    s, d = T.(Tuple(e))
    return has_edge(g, s, d)
end

function add_edge!(g::SimpleDiGraph{T}, e::SimpleDiGraphEdge{T}) where {T}
    s, d = T.(Tuple(e))
    verts = vertices(g)
    (s in verts && d in verts) || return false  # edge out of bounds
    @inbounds list = g.fadjlist[s]
    index = searchsortedfirst(list, d)
    @inbounds (index <= length(list) && list[index] == d) && return false  # edge already in graph
    insert!(list, index, d)

    g.ne += 1

    @inbounds list = g.badjlist[d]
    index = searchsortedfirst(list, s)
    insert!(list, index, s)
    return true  # edge successfully added
end

function rem_edge!(g::SimpleDiGraph{T}, e::SimpleDiGraphEdge{T}) where {T}
    s, d = T.(Tuple(e))
    verts = vertices(g)
    (s in verts && d in verts) || return false  # edge out of bounds
    @inbounds list = g.fadjlist[s]
    index = searchsortedfirst(list, d)
    @inbounds (index <= length(list) && list[index] == d) || return false   # edge not in graph
    deleteat!(list, index)

    g.ne -= 1

    @inbounds list = g.badjlist[d]
    index = searchsortedfirst(list, s)
    deleteat!(list, index)
    return true # edge successfully removed
end

function add_vertex!(g::SimpleDiGraph{T}) where {T}
    (nv(g) + one(T) <= nv(g)) && return false       # test for overflow
    push!(g.badjlist, Vector{T}())
    push!(g.fadjlist, Vector{T}())

    return true
end

function rem_vertices!(
    g::SimpleDiGraph{T}, vs::AbstractVector{<:Integer}; keep_order::Bool=false
) where {T<:Integer}
    # check the implementation in simplegraph.jl for more comments

    n = nv(g)
    isempty(vs) && return collect(Base.OneTo(n))

    # Sort and filter the vertices that we want to remove
    remove = sort(vs)
    unique!(remove)
    (1 <= remove[1] && remove[end] <= n) ||
        throw(ArgumentError("Vertices to be removed must be in the range 1:nv(g)."))

    # Create a vmap that maps vertices to their new position
    # vertices that get removed are mapped to 0
    vmap = Vector{T}(undef, n)
    if keep_order
        # traverse the vertex list and shift if a vertex gets removed
        i = 1
        @inbounds for u in vertices(g)
            if i <= length(remove) && u == remove[i]
                vmap[u] = 0
                i += 1
            else
                vmap[u] = u - (i - 1)
            end
        end
    else
        # traverse the vertex list and replace vertices that get removed 
        # with the furthest one to the back that does not get removed
        i = 1
        j = length(remove)
        v = n
        @inbounds for u in vertices(g)
            u > v && break
            if i <= length(remove) && u == remove[i]
                while v == remove[j] && v > u
                    vmap[v] = 0
                    v -= one(T)
                    j -= 1
                end
                # v > remove[j] || u == v
                vmap[v] = u
                vmap[u] = 0
                v -= one(T)
                i += 1
            else
                vmap[u] = u
            end
        end
    end

    fadjlist = g.fadjlist
    badjlist = g.badjlist

    # count the number of edges that will be removed
    num_removed_edges = 0
    @inbounds for u in remove
        for v in fadjlist[u]
            num_removed_edges += 1
        end
        for v in badjlist[u]
            if vmap[v] != 0
                num_removed_edges += 1
            end
        end
    end
    g.ne -= num_removed_edges

    # move the lists in the adjacency list to their new position
    # order of traversing is important!
    @inbounds for u in (keep_order ? (one(T):1:n) : (n:-1:one(T)))
        if vmap[u] != 0
            fadjlist[vmap[u]] = fadjlist[u]
            badjlist[vmap[u]] = badjlist[u]
        end
    end
    resize!(fadjlist, n - length(remove))
    resize!(badjlist, n - length(remove))

    # remove vertices from the lists in fadjlist and badjlist
    @inbounds for list_of_lists in (fadjlist, badjlist)
        for list in list_of_lists
            Δ = 0
            for (i, v) in enumerate(list)
                if vmap[v] == 0
                    Δ += 1
                else
                    list[i - Δ] = vmap[v]
                end
            end
            resize!(list, length(list) - Δ)
            if !keep_order
                sort!(list)
            end
        end
    end

    # we create a reverse vmap, that maps vertices in the result graph
    # to the ones in the original graph. This resembles the output of
    # induced_subgraph
    reverse_vmap = Vector{T}(undef, nv(g))
    @inbounds for (i, u) in enumerate(vmap)
        if u != 0
            reverse_vmap[u] = i
        end
    end

    return reverse_vmap
end

function all_neighbors(g::SimpleDiGraph{T}, u::Integer) where {T}
    i, j = 1, 1
    in_nbrs, out_nbrs = inneighbors(g, u), outneighbors(g, u)
    in_len, out_len = length(in_nbrs), length(out_nbrs)
    union_nbrs = Vector{T}(undef, in_len + out_len)
    indx = 1
    @inbounds while i <= in_len && j <= out_len
        if in_nbrs[i] < out_nbrs[j]
            union_nbrs[indx] = in_nbrs[i]
            i += 1
        elseif in_nbrs[i] > out_nbrs[j]
            union_nbrs[indx] = out_nbrs[j]
            j += 1
        else
            union_nbrs[indx] = out_nbrs[j]
            i += 1
            j += 1
        end
        indx += 1
    end
    @inbounds while i <= in_len
        union_nbrs[indx] = in_nbrs[i]
        i += 1
        indx += 1
    end
    @inbounds while j <= out_len
        union_nbrs[indx] = out_nbrs[j]
        j += 1
        indx += 1
    end
    resize!(union_nbrs, indx - 1)
    return union_nbrs
end

@testset "A star" begin
    g3 = path_graph(5)
    g4 = path_digraph(5)

    d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
    d2 = sparse(float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]))
    @testset "SimpleGraph and SimpleDiGraph" for g in testgraphs(g3), dg in testdigraphs(g4)
        @test @inferred(a_star(g, 1, 4, d1)) ==
            @inferred(a_star(dg, 1, 4, d1)) ==
            @inferred(a_star(g, 1, 4, d2))
        @test isempty(@inferred(a_star(dg, 4, 1)))
    end
    @testset "GenericGraph and GenricDiGraph with SimpleEdge" for g in
                                                                  test_generic_graphs(g3),
        dg in test_generic_graphs(g4)

        zero_heuristic = n -> 0
        Eg = SimpleEdge{eltype(g)}
        Edg = SimpleEdge{eltype(dg)}
        @test @inferred(a_star(g, 1, 4, d1, zero_heuristic, Eg)) ==
            @inferred(a_star(dg, 1, 4, d1, zero_heuristic, Edg)) ==
            @inferred(a_star(g, 1, 4, d2, zero_heuristic, Eg))
        @test isempty(@inferred(a_star(dg, 4, 1, weights(dg), zero_heuristic, Edg)))
    end

    # test for #1258
    g = complete_graph(4)
    w = float([1 1 1 4; 1 1 1 1; 1 1 1 1; 4 1 1 1])
    @test length(a_star(g, 1, 4, w)) == 2

    # test for #120
    struct MyFavoriteEdgeType <: AbstractEdge{Int}
        s::Int
        d::Int
    end
    @test eltype(a_star(GenericGraph(g), 1, 4, w, n -> 0, MyFavoriteEdgeType)) ==
        MyFavoriteEdgeType
end

@testset "Kruskal" begin
    g4 = complete_graph(4)

    distmx = [
        0 1 5 6
        1 0 4 10
        5 4 0 3
        6 10 3 0
    ]

    vec_mst = Vector{Edge}([Edge(1, 2), Edge(3, 4), Edge(2, 3)])
    max_vec_mst = Vector{Edge}([Edge(2, 4), Edge(1, 4), Edge(1, 3)])
    for g in test_generic_graphs(g4)
        # Testing Kruskal's algorithm
        mst = @inferred(kruskal_mst(g, distmx))
        max_mst = @inferred(kruskal_mst(g, distmx, minimize=false))
        # GenericEdge currently does not implement any comparison operators
        # so instead we compare tuples of source and target vertices
        @test sort([(src(e), dst(e)) for e in mst]) == sort([(src(e), dst(e)) for e in vec_mst])
        @test sort([(src(e), dst(e)) for e in max_mst]) == sort([(src(e), dst(e)) for e in max_vec_mst])
    end
    # second test
    distmx_sec = [
        0 0 0.26 0 0.38 0 0.58 0.16
        0 0 0.36 0.29 0 0.32 0 0.19
        0.26 0.36 0 0.17 0 0 0.4 0.34
        0 0.29 0.17 0 0 0 0.52 0
        0.38 0 0 0 0 0.35 0.93 0.37
        0 0.32 0 0 0.35 0 0 0.28
        0.58 0 0.4 0.52 0.93 0 0 0
        0.16 0.19 0.34 0 0.37 0.28 0 0
    ]

    gx = SimpleGraph(distmx_sec)
    vec2 = Vector{Edge}([
        Edge(1, 8), Edge(3, 4), Edge(2, 8), Edge(1, 3), Edge(6, 8), Edge(5, 6), Edge(3, 7)
    ])
    max_vec2 = Vector{Edge}([
        Edge(5, 7), Edge(1, 7), Edge(4, 7), Edge(3, 7), Edge(5, 8), Edge(2, 3), Edge(5, 6)
    ])
    for g in test_generic_graphs(gx)
        mst2 = @inferred(kruskal_mst(g, distmx_sec))
        max_mst2 = @inferred(kruskal_mst(g, distmx_sec, minimize=false))
        @test sort([(src(e), dst(e)) for e in mst2]) == sort([(src(e), dst(e)) for e in vec2])
        @test sort([(src(e), dst(e)) for e in max_mst2]) == sort([(src(e), dst(e)) for e in max_vec2])
    end

    # non regression test for #362
    g = Graph()
    mst = @inferred(kruskal_mst(g))
    @test isempty(mst)

    g = Graph(1)
    mst = @inferred(kruskal_mst(g))
    @test isempty(mst)
end

"""
    simplecycles_hawick_james(g)

Find circuits (including self-loops) in `g` using the algorithm
of Hawick & James.

### References
- Hawick & James, "Enumerating Circuits and Loops in Graphs with Self-Arcs and Multiple-Arcs", 2008
"""
function simplecycles_hawick_james end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function simplecycles_hawick_james(
    g::AG::IsDirected
) where {T,AG<:AbstractGraph{T}}
    nvg = nv(g)
    B = Vector{T}[Vector{T}() for i in vertices(g)]
    blocked = zeros(Bool, nvg)
    stack = Vector{T}()
    cycles = Vector{Vector{T}}()
    for v in vertices(g)
        circuit_recursive!(g, v, v, blocked, B, stack, cycles)
        resetblocked!(blocked)
        resetB!(B)
    end
    return cycles
end

"""
    resetB!(B)

Reset B work structure.
"""
resetB!(B) = map!(empty!, B, B)

"""
    resetblocked!(blocked)

Reset vector of `blocked` vertices.
"""
resetblocked!(blocked) = fill!(blocked, false)

"""
    circuit_recursive!(g, v1, v2, blocked, B, stack, cycles)

Find circuits in `g` recursively starting from v1.
"""
function circuit_recursive! end
@traitfn function circuit_recursive!(
    g::::IsDirected,
    v1::T,
    v2::T,
    blocked::AbstractVector,
    B::Vector{Vector{T}},
    stack::Vector{T},
    cycles::Vector{Vector{T}},
) where {T<:Integer}
    f = false
    push!(stack, v2)
    blocked[v2] = true

    Av = outneighbors(g, v2)
    for w in Av
        (w < v1) && continue
        if w == v1 # Found a circuit
            push!(cycles, copy(stack))
            f = true
        elseif !blocked[w]
            f |= circuit_recursive!(g, v1, w, blocked, B, stack, cycles)
        end
    end
    if f
        unblock!(v2, blocked, B)
    else
        for w in Av
            (w < v1) && continue
            if !(v2 in B[w])
                push!(B[w], v2)
            end
        end
    end
    pop!(stack)
    return f
end

"""
    unblock!(v, blocked, B)

Unblock the value `v` from the `blocked` list and remove from `B`.
"""
function unblock!(v::T, blocked::AbstractVector, B::Vector{Vector{T}}) where {T}
    blocked[v] = false
    wPos = 1
    Bv = B[v]
    while wPos <= length(Bv)
        w = Bv[wPos]
        old_length = length(Bv)
        filter!(v -> v != w, Bv)
        wPos += 1 - (old_length - length(Bv))
        if blocked[w]
            unblock!(w, blocked, B)
        end
    end
    return nothing
end

"""
    modularity(g, c, distmx=weights(g), γ=1.0)

Return a value representing Newman's modularity `Q` for the undirected and 
directed graph `g` given the partitioning vector `c`. This method also supports
weighted graphs if the distance matrix is provided.

Modularity ``Q`` for undirected graph:
```math
Q = \\frac{1}{2m} \\sum_{c} \\left( e_{c} - \\gamma \\frac{K_c^2}{2m} \\right)
```

Modularity ``Q`` for directed graph:
```math
Q = \\frac{1}{m} \\sum_{c} \\left( e_{c} - \\gamma \\frac{K_c^{in} K_c^{out}}{m} \\right)
```

where:
- ``m``: total number of edges in the network 
- ``e_c``: number of edges in community ``c``
- ``K_c``: sum of the degrees of the nodes in community ``c`` or the 
  sum of the weighted degree of the nodes in community ``c`` when the graph is 
  weighted. ``K_c^{in}`` sum of the in-degrees of the nodes in community ``c``.

### Optional Arguments
- `distmx=weights(g)`: distance matrix for weighted graphs
- `γ=1.0`: where `γ > 0` is a resolution parameter. When the modularity is used 
  to find communities structure in networks (i.e with [Louvain's method for 
  community detection](https://en.wikipedia.org/wiki/Louvain_Modularity)), 
  higher resolutions lead to more communities, while lower resolutions lead to 
  fewer communities. Where `γ=1.0` it lead to the traditional definition of 
  the modularity.

### References
- M. E. J. Newman and M. Girvan. "Finding and evaluating community structure in networks". 
  Phys. Rev. E 69, 026113 (2004). [(arXiv)](https://arxiv.org/abs/cond-mat/0308217)
- J. Reichardt and S. Bornholdt. "Statistical mechanics of community detection". 
  Phys. Rev. E 74, 016110 (2006). [(arXiv)](https://arxiv.org/abs/cond-mat/0603718)
- E. A. Leicht and M. E. J. Newman. "Community structure in directed networks". 
  Physical Review Letter, 100:118703, (2008). [(arXiv)](https://arxiv.org/pdf/0709.4500.pdf)

# Examples 
```jldoctest
julia> using Graphs

julia> barbell = blockdiag(complete_graph(3), complete_graph(3));

julia> add_edge!(barbell, 1, 4);

julia> modularity(barbell, [1, 1, 1, 2, 2, 2])
0.35714285714285715

julia> modularity(barbell, [1, 1, 1, 2, 2, 2], γ=0.5)
0.6071428571428571  
```
```jldoctest
julia> using Graphs

julia> triangle = cycle_graph(3);

julia> barbell = blockdiag(triangle, triangle);

julia> add_edge!(barbell, 1, 4);

julia> distmx = Matrix(weights(barbell));

julia> distmx[1, 4] = distmx[4, 1] = 5;  # additional edge has a weight of 5

julia> round(modularity(barbell, [1, 1, 1, 2, 2, 2]; distmx), digits=6)
0.045455
```
"""
function modularity(
    g::AbstractGraph,
    c::AbstractVector{<:Integer};
    distmx::AbstractArray{<:Number}=weights(g),
    γ=1.0,
)
    m = sum([distmx[src(e), dst(e)] for e in edges(g)])
    m = is_directed(g) ? m : 2 * m

    m == 0 && return 0.0
    nc = maximum(c)
    kin = zeros(Float32, nc)
    kout = zeros(Float32, nc)
    Q = 0.0
    for u in vertices(g)
        for v in neighbors(g, u)
            c1 = c[u]
            c2 = c[v]
            if c1 == c2
                Q += distmx[u, v]
            end
            kout[c1] += distmx[u, v]
            kin[c2] += distmx[u, v]
        end
    end
    Q = Q * m
    @inbounds for i in 1:nc
        Q -= γ * kin[i] * kout[i]
    end
    return Q / m^2
end

function stress_centrality(g::AbstractGraph, vs=vertices(g); parallel=:threads)
    return if parallel == :distributed
        distr_stress_centrality(g, vs)
    else
        threaded_stress_centrality(g, vs)
    end
end

function stress_centrality(
    g::AbstractGraph,
    k::Integer;
    parallel=:threads,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    samples = sample(vertices(g), k; rng=rng, seed=seed)
    return if parallel == :distributed
        distr_stress_centrality(g, samples)
    else
        threaded_stress_centrality(g, samples)
    end
end

function distr_stress_centrality(args...; kwargs...)
    return error(
        "`parallel = :distributed` requested, but SharedArrays or Distributed is not loaded"
    )
end

function threaded_stress_centrality(g::AbstractGraph, vs=vertices(g))::Vector{Int64}
    n_v = nv(g)
    k = length(vs)
    isdir = is_directed(g)

    # Parallel reduction
    d, r = divrem(k, Threads.nthreads())
    ntasks = d == 0 ? r : Threads.nthreads()
    local_stress = [zeros(Int, n_v) for _ in 1:ntasks]
    task_size = cld(k, ntasks)

    @sync for (t, task_range) in enumerate(Iterators.partition(1:k, task_size))
        Threads.@spawn for s in @view(vs[task_range])
            if degree(g, s) > 0  # this might be 1?
                state = Graphs.dijkstra_shortest_paths(
                    g, s; allpaths=true, trackvertices=true
                )
                Graphs._stress_accumulate_basic!(local_stress[t], state, g, s)
            end
        end
    end
    return reduce(+, local_stress)
end

"""
    dag_longest_path(g, distmx=weights(g); topological_order=topological_sort_by_dfs(g))

Return a longest path within the directed acyclic graph `g`, with distance matrix `distmx` and using `topological_order` to iterate on vertices.
"""
function dag_longest_path end

@traitfn function dag_longest_path(
    g::::IsDirected,
    distmx::AbstractMatrix=weights(g);
    topological_order=topological_sort_by_dfs(g),
)
    U = eltype(g)
    T = eltype(distmx)

    dists = zeros(T, nv(g))
    parents = zeros(U, nv(g))

    for v in topological_order
        for u in inneighbors(g, v)
            newdist = dists[u] + distmx[u, v]
            if newdist > dists[v]
                dists[v] = newdist
                parents[v] = u
            end
        end
    end

    if isempty(dists)
        return U[]
    else
        v = argmax(dists)
        return path_from_parents(v, parents)
    end
end

# TODO yen_k_shortest_paths does not wort for GenericGraph yet

@testset "Yen" begin
    g4 = path_digraph(5)
    d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
    d2 = sparse(float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]))

    for g in testdigraphs(g4)
        x = @inferred(yen_k_shortest_paths(g, 5, 5))
        @test length(x.dists) == length(x.paths) == 1
        @test x.dists[1] == 0
        @test x.paths[1] == [5]

        y = @inferred(yen_k_shortest_paths(g, 2, 5, d1, 1))
        z = @inferred(yen_k_shortest_paths(g, 2, 5, d2, 1))

        @test length(y.dists) == length(z.dists) == 1
        @test length(y.paths) == length(z.paths) == 1
        @test y.dists == z.dists == [33.0]
        @test z.paths == y.paths == [[2, 3, 4, 5]]

        # Remove edge to test empty paths
        rem_edge!(g, 1, 2)
        x = @inferred(yen_k_shortest_paths(g, 1, 5))
        @test length(x.dists) == length(x.paths) == 0
    end

    gx = path_graph(5)
    add_edge!(gx, 2, 4)
    d = ones(Int, 5, 5)
    d[2, 3] = 100

    for g in testgraphs(gx)
        z = @inferred(yen_k_shortest_paths(g, 1, 5, d, 1))
        @test length(z.dists) == 1
        @test z.dists == [3]
        @test z.paths[1] == [1, 2, 4, 5]
    end

    G = Graphs.Graph()
    add_vertices!(G, 4)
    add_edge!(G, 2, 1)
    add_edge!(G, 2, 3)
    add_edge!(G, 1, 4)
    add_edge!(G, 3, 4)
    add_edge!(G, 2, 2)
    w = [
        0.0 3.0 0.0 1.0
        3.0 0.0 2.0 0.0
        0.0 2.0 0.0 3.0
        1.0 0.0 3.0 0.0
    ]

    w_km = KMf.(w)
    for g in testgraphs(G)
        ds = @inferred(yen_k_shortest_paths(g, 2, 4, w_km))
        @test ds.paths == [[2, 1, 4]]
        ds = @inferred(yen_k_shortest_paths(g, 2, 1, w_km))
        @test ds.paths == [[2, 1]]
        ds = @inferred(yen_k_shortest_paths(g, 2, 3, w_km))
        @test ds.paths == [[2, 3]]

        # Test with multiple paths
        ds = @inferred(yen_k_shortest_paths(g, 2, 4, w_km, 2))
        @test ds.paths == [[2, 1, 4], [2, 3, 4]]
    end

    for g in testgraphs(G)
        ds = @inferred(yen_k_shortest_paths(g, 2, 4, w))
        @test ds.paths == [[2, 1, 4]]
        ds = @inferred(yen_k_shortest_paths(g, 2, 1, w))
        @test ds.paths == [[2, 1]]
        ds = @inferred(yen_k_shortest_paths(g, 2, 3, w))
        @test ds.paths == [[2, 3]]

        # Test with multiple paths
        ds = @inferred(yen_k_shortest_paths(g, 2, 4, w, 2))
        @test ds.paths == [[2, 1, 4], [2, 3, 4]]

        # here a selflink at source is introduced; it should not change the shortest paths
        w[2, 2] = 10.0
        ds = @inferred(yen_k_shortest_paths(g, 2, 4, w))
        @test ds.paths == [[2, 1, 4]]
        ds = @inferred(yen_k_shortest_paths(g, 2, 4, w, 3))
        @test ds.paths == [[2, 1, 4], [2, 3, 4]]

        # Test with new short link
        add_edge!(g, 2, 4)
        w[2, 4] = 1.0
        w[4, 2] = 1.0
        ds = @inferred(yen_k_shortest_paths(g, 2, 4, w, 2))
        @test ds.paths == [[2, 4], [2, 1, 4]]
        ds = @inferred(yen_k_shortest_paths(g, 2, 4, w, 3))
        @test ds.paths == [[2, 4], [2, 1, 4], [2, 3, 4]]
    end

    # Testing with the example in https://en.wikipedia.org/wiki/Yen%27s_algorithm
    G = Graphs.DiGraph()
    add_vertices!(G, 6)
    add_edge!(G, 1, 2)
    add_edge!(G, 1, 3)
    add_edge!(G, 2, 4)
    add_edge!(G, 3, 2)
    add_edge!(G, 3, 4)
    add_edge!(G, 3, 5)
    add_edge!(G, 4, 5)
    add_edge!(G, 4, 6)
    add_edge!(G, 5, 6)
    w = [
        0.0 3.0 2.0 0.0 0.0 0.0
        0.0 0.0 0.0 4.0 0.0 0.0
        0.0 1.0 0.0 2.0 3.0 0.0
        0.0 0.0 0.0 0.0 2.0 1.0
        0.0 0.0 0.0 0.0 0.0 2.0
        0.0 0.0 0.0 0.0 0.0 0.0
    ]

    for g in testdigraphs(G)
        ds = @inferred(yen_k_shortest_paths(g, 1, 6, w, 3))
        @test ds.dists == [5.0, 7.0, 8.0]
        @test ds.paths[1] == [1, 3, 4, 6]
        @test ds.paths[2] == [1, 3, 5, 6]
    end

    # Test all the paths
    add_edge!(G, 1, 4)
    w[1, 4] = 3
    w[4, 1] = 3
    for g in testdigraphs(G)
        ds = @inferred(yen_k_shortest_paths(g, 1, 6, w, 100))
        @test ds.dists == [4.0, 5.0, 7.0, 7.0, 8.0, 8.0, 8.0, 11.0, 11.0]

        ds = @inferred(yen_k_shortest_paths(g, 1, 6, w, 100, maxdist=7.0))
        @test ds.dists == [4.0, 5.0, 7.0, 7.0]
    end

    # Test that no paths are returned if every path is longer than maxdist
    for g in testdigraphs(cycle_digraph(10))
        ds = @inferred(yen_k_shortest_paths(g, 2, 1, weights(g), 2, maxdist=2))
        @test isempty(ds.paths)
    end
end

@testset "Rich club coefficient" begin
    rng = StableRNG(1)
    @testset "Small graphs" for _n in 5:10
        @test @inferred rich_club(GenericGraph(star_graph(_n)), 1) ≈ 2 / _n
        @test @inferred rich_club(GenericDiGraph(DiGraph(star_graph(_n))), 1) ≈ 2 / _n
    end
    @testset "Directed ($seed)" for seed in [1, 2, 3],
        (n, ne) in [(14, 18), (10, 22), (7, 16)]

        g = GenericDiGraph(erdos_renyi(n, ne; is_directed=true, rng=StableRNG(seed)))
        _r = rich_club(g, 1)
        @test @inferred rich_club(g, 1) > 0.0
    end
    @testset "Undirected ($seed)" for seed in [1, 2, 3],
        (n, ne) in [(14, 18), (10, 22), (7, 16)]

        g = GenericGraph(erdos_renyi(n, ne; is_directed=false, rng=StableRNG(seed)))
        _r = rich_club(g, 1)
        @test @inferred rich_club(g, 1) > 0.0
    end
end

@testset "D'Esopo-Pape" begin
    g4 = path_digraph(5)
    d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
    d2 = sparse(float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]))
    @testset "generic tests: $(typeof(g))" for g in test_generic_graphs(g4)
        y = @inferred(desopo_pape_shortest_paths(g, 2, d1))
        z = @inferred(desopo_pape_shortest_paths(g, 2, d2))
        @test y.parents == z.parents == [0, 0, 2, 3, 4]
        @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
    end

    gx = path_graph(5)
    add_edge!(gx, 2, 4)
    d = ones(Int, 5, 5)
    d[2, 3] = 100
    @testset "cycles: $(typeof(g))" for g in test_generic_graphs(gx)
        z = @inferred(desopo_pape_shortest_paths(g, 1, d))
        @test z.dists == [0, 1, 3, 2, 3]
        @test z.parents == [0, 1, 4, 2, 4]
    end

    m = [0 2 2 0 0; 2 0 0 0 3; 2 0 0 1 2; 0 0 1 0 1; 0 3 2 1 0]
    G = SimpleGraph(5)
    add_edge!(G, 1, 2)
    add_edge!(G, 1, 3)
    add_edge!(G, 2, 5)
    add_edge!(G, 3, 5)
    add_edge!(G, 3, 4)
    add_edge!(G, 4, 5)

    @testset "more cycles: $(typeof(g))" for g in test_generic_graphs(G)
        y = @inferred(desopo_pape_shortest_paths(g, 1, m))
        @test y.parents == [0, 1, 1, 3, 3]
        @test y.dists == [0, 2, 2, 3, 4]
    end

    G = SimpleGraph(5)
    add_edge!(G, 2, 2)
    add_edge!(G, 1, 2)
    add_edge!(G, 1, 3)
    add_edge!(G, 3, 3)
    add_edge!(G, 1, 5)
    add_edge!(G, 2, 4)
    add_edge!(G, 4, 5)
    m = [0 10 2 0 15; 10 9 0 1 0; 2 0 1 0 0; 0 1 0 0 2; 15 0 0 2 0]
    @testset "self loops: $(typeof(g))" for g in test_generic_graphs(G)
        z = @inferred(desopo_pape_shortest_paths(g, 1, m))
        y = @inferred(dijkstra_shortest_paths(g, 1, m))
        @test isapprox(z.dists, y.dists)
    end

    G = SimpleGraph(5)
    add_edge!(G, 1, 2)
    add_edge!(G, 1, 3)
    add_edge!(G, 4, 5)
    inf = typemax(eltype(G))
    @testset "disconnected: $(typeof(G))" for g in test_generic_graphs(G)
        z = @inferred(desopo_pape_shortest_paths(g, 1))
        @test z.dists == [0, 1, 1, inf, inf]
        @test z.parents == [0, 1, 1, 0, 0]
    end

    G = SimpleGraph(3)
    inf = typemax(eltype(G))
    @testset "empty: $(typeof(g))" for g in test_generic_graphs(G)
        z = @inferred(desopo_pape_shortest_paths(g, 1))
        @test z.dists == [0, inf, inf]
        @test z.parents == [0, 0, 0]
    end

    @testset "random simple graphs" begin
        for seed in 1:5
            rng = StableRNG(seed)
            nvg = Int(ceil(250 * rand(rng)))
            neg = Int(floor((nvg * (nvg - 1) / 2) * rand(rng)))
            g = GenericGraph(SimpleGraph(nvg, neg; rng=rng))
            z = desopo_pape_shortest_paths(g, 1)
            y = dijkstra_shortest_paths(g, 1)
            @test isapprox(z.dists, y.dists)
        end
    end

    @testset "random simple digraphs" begin
        for seed in 1:5
            rng = StableRNG(seed)
            nvg = Int(ceil(250 * rand(rng)))
            neg = Int(floor((nvg * (nvg - 1) / 2) * rand(rng)))
            g = GenericDiGraph(SimpleDiGraph(nvg, neg; rng=rng))
            z = desopo_pape_shortest_paths(g, 1)
            y = dijkstra_shortest_paths(g, 1)
            @test isapprox(z.dists, y.dists)
        end
    end

    @testset "misc graphs" begin
        G = GenericGraph(complete_graph(9))
        z = desopo_pape_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z.dists, y.dists)

        G = GenericDiGraph(complete_digraph(9))
        z = desopo_pape_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z.dists, y.dists)

        G = GenericGraph(cycle_graph(9))
        z = desopo_pape_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z.dists, y.dists)

        G = GenericDiGraph(cycle_digraph(9))
        z = desopo_pape_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z.dists, y.dists)

        G = GenericGraph(star_graph(9))
        z = desopo_pape_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z.dists, y.dists)

        G = GenericGraph(wheel_graph(9))
        z = desopo_pape_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z.dists, y.dists)

        G = GenericGraph(roach_graph(9))
        z = desopo_pape_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z.dists, y.dists)

        G = GenericGraph(clique_graph(5, 19))
        z = desopo_pape_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z.dists, y.dists)
    end

    @testset "smallgraphs: $s" for s in [
        :bull,
        :chvatal,
        :cubical,
        :desargues,
        :diamond,
        :dodecahedral,
        :frucht,
        :heawood,
        :house,
        :housex,
        :icosahedral,
        :krackhardtkite,
        :moebiuskantor,
        :octahedral,
        :pappus,
        :petersen,
        :sedgewickmaze,
        :tutte,
        :tetrahedral,
        :truncatedcube,
        :truncatedtetrahedron,
        :truncatedtetrahedron_dir,
    ]
        GS = smallgraph(s)
        GG = is_directed(GS) ? GenericDiGraph(GS) : GenericGraph(GS)
        z = desopo_pape_shortest_paths(GG, 1)
        y = dijkstra_shortest_paths(GG, 1)
        @test isapprox(z.dists, y.dists)
    end

    @testset "errors" begin
        g = GenericGraph(Graph())
        @test_throws DomainError desopo_pape_shortest_paths(g, 1)
        g = GenericGraph(Graph(5))
        @test_throws DomainError desopo_pape_shortest_paths(g, 6)
    end
end

mutable struct DummyGraph <: AbstractGraph{Int} end
mutable struct DummyDiGraph <: AbstractGraph{Int} end
mutable struct DummyEdge <: AbstractEdge{Int} end

@testset "Interface" begin
    dummygraph = DummyGraph()
    dummydigraph = DummyDiGraph()
    dummyedge = DummyEdge()

    @test_throws Graphs.NotImplementedError is_directed(DummyGraph)
    @test_throws Graphs.NotImplementedError zero(DummyGraph)

    for edgefun in [src, dst, Pair, Tuple, reverse]
        @test_throws Graphs.NotImplementedError edgefun(dummyedge)
    end

    for edgefun2edges in [==]
        @test_throws Graphs.NotImplementedError edgefun2edges(dummyedge, dummyedge)
    end

    for graphfunbasic in [nv, ne, vertices, edges, is_directed, edgetype]
        @test_throws Graphs.NotImplementedError graphfunbasic(dummygraph)
    end

    for graphfun1int in [has_vertex, inneighbors, outneighbors]
        @test_throws Graphs.NotImplementedError graphfun1int(dummygraph, 1)
    end
    for graphfunedge in [has_edge]
        @test_throws Graphs.NotImplementedError graphfunedge(dummygraph, dummyedge)
        @test_throws Graphs.NotImplementedError graphfunedge(dummygraph, 1, 2)
    end

    # Implementation error
    impl_error = Graphs.NotImplementedError(edges)
    @test impl_error isa Graphs.NotImplementedError{typeof(edges)}
    io = IOBuffer()
    Base.showerror(io, impl_error)
    @test String(take!(io)) == "method $edges not implemented."
end # testset

# Parts of this code were taken / derived from Graphs.jl. See LICENSE for
# licensing details.

# The Bellman Ford algorithm for single-source shortest path

###################################################################
#
#   The type that encapsulates the state of Bellman Ford algorithm
#
###################################################################

struct NegativeCycleError <: Exception end

# AbstractPathState is defined in core
"""
    BellmanFordState{T, U}

An `AbstractPathState` designed for Bellman-Ford shortest-paths calculations.

# Fields

- `parents::Vector{U}`: `parents[v]` is the predecessor of vertex `v` on the shortest path from the source to `v`
- `dists::Vector{T}`: `dists[v]` is the length of the shortest path from the source to `v`
"""
struct BellmanFordState{T<:Number,U<:Integer} <: AbstractPathState
    parents::Vector{U}
    dists::Vector{T}
end

"""
    bellman_ford_shortest_paths(g, s, distmx=weights(g))
    bellman_ford_shortest_paths(g, ss, distmx=weights(g))

Compute shortest paths between a source `s` (or list of sources `ss`) and all
other nodes in graph `g` using the [Bellman-Ford algorithm](http://en.wikipedia.org/wiki/Bellman–Ford_algorithm).

Return a [`Graphs.BellmanFordState`](@ref) with relevant traversal information (try querying `state.parents` or `state.dists`).
"""
function bellman_ford_shortest_paths(
    graph::AbstractGraph{U},
    sources::AbstractVector{<:Integer},
    distmx::AbstractMatrix{T}=weights(graph),
) where {T<:Number} where {U<:Integer}
    nvg = nv(graph)
    active = falses(nvg)
    active[sources] .= true
    dists = fill(typemax(T), nvg)
    parents = zeros(U, nvg)
    dists[sources] .= zero(T)
    no_changes = false
    new_active = falses(nvg)

    for i in vertices(graph)
        no_changes = true
        new_active .= false
        for u in vertices(graph)
            active[u] || continue
            for v in outneighbors(graph, u)
                relax_dist = distmx[u, v] + dists[u]
                if dists[v] > relax_dist
                    dists[v] = relax_dist
                    parents[v] = u
                    no_changes = false
                    new_active[v] = true
                end
            end
        end
        if no_changes
            break
        end
        active, new_active = new_active, active
    end
    no_changes || throw(NegativeCycleError())
    return BellmanFordState(parents, dists)
end

function bellman_ford_shortest_paths(
    graph::AbstractGraph{U}, v::Integer, distmx::AbstractMatrix{T}=weights(graph);
) where {T<:Number} where {U<:Integer}
    return bellman_ford_shortest_paths(graph, [v], distmx)
end

has_negative_edge_cycle(g::AbstractGraph) = false

function has_negative_edge_cycle(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}
) where {T<:Number} where {U<:Integer}
    try
        bellman_ford_shortest_paths(g, collect_if_not_vector(vertices(g)), distmx)
    catch e
        isa(e, NegativeCycleError) && return true
        rethrow()
    end
    return false
end

"""
    enumerate_paths(state[, vs])

Given a path state `state` of type `AbstractPathState`, return a
vector (indexed by vertex) of the paths between the source vertex used to
compute the path state and a single destination vertex, a list of destination
vertices, or the entire graph. For multiple destination vertices, each
path is represented by a vector of vertices on the path between the source and
the destination. Nonexistent paths will be indicated by an empty vector. For
single destinations, the path is represented by a single vector of vertices,
and will be length 0 if the path does not exist.

### Implementation Notes

For Floyd-Warshall path states, please note that the output is a bit different,
since this algorithm calculates all shortest paths for all pairs of vertices:
`enumerate_paths(state)` will return a vector (indexed by source vertex) of
vectors (indexed by destination vertex) of paths. `enumerate_paths(state, v)`
will return a vector (indexed by destination vertex) of paths from source `v`
to all other vertices. In addition, `enumerate_paths(state, v, d)` will return
a vector representing the path from vertex `v` to vertex `d`.
"""
function enumerate_paths(state::AbstractPathState, vs::AbstractVector{<:Integer})
    T = eltype(state.parents)
    all_paths = Vector{T}[Vector{eltype(state.parents)}() for _ in 1:length(vs)]
    return enumerate_paths!(all_paths, state, vs)
end
enumerate_paths(state::AbstractPathState, v::Integer) = enumerate_paths(state, v:v)[1]
function enumerate_paths(state::AbstractPathState)
    return enumerate_paths(state, 1:length(state.parents))
end

"""
    enumerate_paths!(paths::AbstractVector{<:AbstractVector}, state, vs::AbstractVector{Int})

In-place version of [`enumerate_paths`](@ref).

`paths` must be a `Vector{Vectors{eltype(state.parents)}}`, `state` an `AbstractPathState`, 
and `vs`` an AbstractRange or other AbstractVector of `Int`. 

See the `enumerate_paths` documentation for details.

`enumerate_paths!` should be more efficient when used in a loop,
as the same memory can be used for each iteration.
"""
function enumerate_paths!(
    all_paths::AbstractVector{<:AbstractVector},
    state::AbstractPathState,
    vs::AbstractVector{<:Integer},
)
    Base.require_one_based_indexing(all_paths)
    Base.require_one_based_indexing(vs)
    length(all_paths) == length(vs) || throw(
        ArgumentError(
            "length of destination paths $(length(vs)) deos not match length of vs $(length(all_paths))",
        ),
    )

    parents = state.parents
    T = eltype(state.parents)
    num_vs = length(vs)

    for i in 1:num_vs
        empty!(all_paths[i])
        index = T(vs[i])
        if parents[index] != 0 || parents[index] == index
            while parents[index] != 0
                push!(all_paths[i], index)
                index = parents[index]
            end
            push!(all_paths[i], index)
            reverse!(all_paths[i])
        end
    end
    return all_paths
end

@testset "Dijkstra" begin
    g4 = path_digraph(5)
    d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
    d2 = sparse(float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]))

    for g in test_generic_graphs(g4)
        y = @inferred(dijkstra_shortest_paths(g, 2, d1))
        z = @inferred(dijkstra_shortest_paths(g, 2, d2))

        @test y.parents == z.parents == [0, 0, 2, 3, 4]
        @test y.dists == z.dists == [Inf, 0, 6, 17, 33]

        y = @inferred(dijkstra_shortest_paths(g, 2, d1; allpaths=true))
        z = @inferred(dijkstra_shortest_paths(g, 2, d2; allpaths=true))
        @test z.predecessors[3] == y.predecessors[3] == [2]

        @test @inferred(enumerate_paths(z)) == enumerate_paths(y)
        @test @inferred(enumerate_paths(z))[4] ==
            enumerate_paths(z, 4) ==
            # test that we can pass a range into enumerate_paths - previously this caused
            # infinite recursion - see #1552
            enumerate_paths(z, 3:4)[2] ==
            enumerate_paths(y, 4) ==
            [2, 3, 4]
    end

    gx = path_graph(5)
    add_edge!(gx, 2, 4)
    d = ones(Int, 5, 5)
    d[2, 3] = 100
    for g in test_generic_graphs(gx)
        z = @inferred(dijkstra_shortest_paths(g, 1, d))
        @test z.dists == [0, 1, 3, 2, 3]
        @test z.parents == [0, 1, 4, 2, 4]
    end

    # small function to reconstruct the shortest path; I copied it from somewhere, can't find the original source to give the credits
    # @Beatzekatze on github
    function spath(target, dijkstraStruct, source)
        return if target == source
            target
        else
            [spath(dijkstraStruct.parents[target], dijkstraStruct, source) target]
        end
    end
    spaths(ds, targets, source) = [spath(i, ds, source) for i in targets]

    G = Graphs.Graph()
    add_vertices!(G, 4)
    add_edge!(G, 2, 1)
    add_edge!(G, 2, 3)
    add_edge!(G, 1, 4)
    add_edge!(G, 3, 4)
    add_edge!(G, 2, 2)
    w = [
        0.0 3.0 0.0 1.0
        3.0 0.0 2.0 0.0
        0.0 2.0 0.0 3.0
        1.0 0.0 3.0 0.0
    ]

    for g in test_generic_graphs(G)
        ds = @inferred(dijkstra_shortest_paths(g, 2, w))
        # this loop reconstructs the shortest path for vertices 1, 3 and 4
        @test spaths(ds, [1, 3, 4], 2) == Array[[2 1], [2 3], [2 1 4]]

        # here a selflink at source is introduced; it should not change the shortest paths
        w[2, 2] = 10.0
        ds = @inferred(dijkstra_shortest_paths(g, 2, w))
        shortest_paths = []
        # this loop reconstructs the shortest path for vertices 1, 3 and 4
        @test spaths(ds, [1, 3, 4], 2) == Array[[2 1], [2 3], [2 1 4]]
    end

    #615
    m = [0 2 2 0 0; 2 0 0 0 3; 2 0 0 1 2; 0 0 1 0 1; 0 3 2 1 0]
    G = SimpleGraph(5)
    add_edge!(G, 1, 2)
    add_edge!(G, 1, 3)
    add_edge!(G, 2, 5)
    add_edge!(G, 3, 5)
    add_edge!(G, 3, 4)
    add_edge!(G, 4, 5)
    for g in test_generic_graphs(G)
        ds = @inferred(dijkstra_shortest_paths(g, 1, m; allpaths=true))
        @test ds.pathcounts == [1.0, 1.0, 1.0, 1.0, 2.0]
        @test ds.predecessors == [[], [1], [1], [3], [3, 4]]
        @test ds.predecessors == [[], [1], [1], [3], [3, 4]]

        dm = @inferred(dijkstra_shortest_paths(g, 1; allpaths=true, trackvertices=true))
        @test dm.pathcounts == [1.0, 1.0, 1.0, 1.0, 2.0]
        @test dm.predecessors == [[], [1], [1], [3], [2, 3]]
        @test dm.closest_vertices == [1, 2, 3, 5, 4]
    end

    G = SimpleGraph(5)
    add_edge!(G, 1, 2)
    add_edge!(G, 1, 3)
    add_edge!(G, 4, 5)
    for g in test_generic_graphs(G)
        dm = @inferred(dijkstra_shortest_paths(g, 1; allpaths=true, trackvertices=true))
        @test dm.closest_vertices == [1, 2, 3, 4, 5]
    end

    #maximum distance setting limits paths found
    G = cycle_graph(6)
    add_edge!(G, 1, 3)
    m = float(
        [0 2 2 0 0 1; 2 0 1 0 0 0; 2 1 0 4 0 0; 0 0 4 0 1 0; 0 0 0 1 0 1; 1 0 0 0 1 0]
    )

    for g in test_generic_graphs(G)
        ds = @inferred(dijkstra_shortest_paths(g, 3, m; maxdist=3.0))
        @test ds.dists == [2, 1, 0, Inf, Inf, 3]
    end
end

"""
    core_periphery_deg(g)

Compute the degree-based core-periphery for graph `g`. Return the vertex
assignments (`1` for core and `2` for periphery) for each node in `g`.

References:
    [Lip](http://arxiv.org/abs/1102.5511))

# Examples
```jldoctest
julia> using Graphs

julia> core_periphery_deg(star_graph(5))
5-element Vector{Int64}:
 1
 2
 2
 2
 2

julia> core_periphery_deg(path_graph(3))
3-element Vector{Int64}:
 2
 1
 2
```
"""
function core_periphery_deg end
@traitfn function core_periphery_deg(g::::(!IsDirected))
    degs = degree(g)
    p = sortperm(degs; rev=true)
    s = sum(degs) / 2.0
    sbest = +Inf
    kbest = 0
    for k in 1:(nv(g) - 1)
        s = s + k - 1 - degree(g, p[k])
        if s < sbest
            sbest = s
            kbest = k
        end
    end
    c = fill(2, nv(g))
    c[p[1:kbest]] .= 1
    return c
end

# Planarity algorithm for Julia graphs. 
# Algorithm from https://www.uni-konstanz.de/algo/publications/b-lrpt-sub.pdf
# The implementation is heavily influenced by the recursive implementation in Networkx (https://networkx.org/documentation/stable/_modules/networkx/algorithms/planarity.html)

import DataStructures: DefaultDict, Stack
import Base: isempty

"""
    is_planar(g)

Determines whether or not the graph `g` is [planar](https://en.wikipedia.org/wiki/Planar_graph).

Uses the [left-right planarity test](https://en.wikipedia.org/wiki/Left-right_planarity_test).

### References 
- [Brandes 2009](https://www.uni-konstanz.de/algo/publications/b-lrpt-sub.pdf)
"""
function is_planar(g)
    lrp = LRPlanarity(g)
    return lr_planarity!(lrp)
end

#Simple structs to be used in algorithm. Keep private for now. 
function empty_edge(T)
    return Edge{T}(0, 0)
end

function isempty(e::Edge{T}) where {T}
    return src(e) == zero(T) && dst(e) == zero(T)
end

mutable struct Interval{T}
    high::Edge{T}
    low::Edge{T}
end

function empty_interval(T)
    return Interval(empty_edge(T), empty_edge(T))
end

function isempty(interval::Interval)
    return isempty(interval.high) && isempty(interval.low)
end

function conflicting(interval::Interval{T}, b, lrp_state) where {T}
    return !isempty(interval) && (lrp_state.lowpt[interval.high] > lrp_state.lowpt[b])
end

mutable struct ConflictPair{T}
    L::Interval{T}
    R::Interval{T}
end

function empty_pair(T)
    return ConflictPair(empty_interval(T), empty_interval(T))
end

function swap!(self::ConflictPair)
    #Swap left and right intervals
    temp = self.L
    self.L = self.R
    return self.R = temp
end

function root_pair(T)
    #returns the "root pair" of type T 
    e = Edge{T}(0, 0)
    return ConflictPair(Interval(e, e), Interval(e, e))
end

function isempty(p::ConflictPair)
    return isempty(p.L) && isempty(p.R)
end

# ATM (Julia 1.8.4, DataStructures v0.18.13), DefaultDict crashes
# for large order matrices when we attempt to trim the back edges. 
#To fix this we create a manual version of the DefaultDict that seems to be more stable

struct ManualDict{A,B}
    d::Dict{A,B}
    default::B
end

function ManualDict(A, B, default)
    return ManualDict(Dict{A,B}(), default)
end

import Base: getindex

function getindex(md::ManualDict, x)
    d = md.d
    if haskey(d, x)
        d[x]
    else
        d[x] = md.default
        md.default
    end
end

function setindex!(md::ManualDict, X, key)
    return setindex!(md.d, X, key)
end

mutable struct LRPlanarity{T<:Integer}
    #State class for the planarity test 
    #We index by Edge structs throughout as it is easier than switching between
    #Edges and tuples
    #G::SimpleGraph{T} #Copy of the input graph
    V::Int64
    E::Int64
    roots::Vector{T} #Vector of roots for disconnected graphs. Normally size(roots, 1) == 1
    height::DefaultDict{T,Int64} #DefaultDict of heights <: Int, indexed by node. default is -1
    lowpt::Dict{Edge{T},Int64} #Dict of low points, indexed by Edge
    lowpt2::Dict{Edge{T},Int64} #Dict of low points (copy), indexed by Edge 
    nesting_depth::Dict{Edge{T},Int64} #Dict of nesting depths, indexed by Edge
    parent_edge::DefaultDict{T,Edge{T}} #Dict of parent edges, indexed by node
    DG::SimpleDiGraph{T} #Directed graph for the orientation phase
    adjs::Dict{T,Vector{T}} #Dict of neighbors of nodes, indexed by node
    ordered_adjs::Dict{T,Vector{T}} #Dict of neighbors of nodes sorted by nesting depth, indexed by node
    ref::DefaultDict{Edge{T},Edge{T}} #ManualDict of Edges, indexed by Edge
    side::DefaultDict{Edge{T},Int8} #DefaultDict of +/- 1, indexed by edge
    S::Stack{ConflictPair{T}} #Stack of tuples of Edges
    stack_bottom::Dict{Edge{T},ConflictPair{T}} #Dict of Tuples of Edges, indexed by Edge
    lowpt_edge::Dict{Edge{T},Edge{T}} #Dict of Edges, indexed by Edge 
    #left_ref::Dict{T,Edge{T}} #Dict of Edges, indexed by node
    #right_ref::Dict{T,Edge{T}} #Dict of Edges, indexed by node
    # skip embedding for now 
end

#outer constructor for LRPlanarity
function LRPlanarity(g::AG) where {AG<:AbstractGraph}
    V = Int64(nv(g)) #needs promoting
    E = Int64(ne(g)) #JIC
    #record nodetype of g
    T = eltype(g)
    N = nv(g)

    roots = T[]

    # distance from tree root
    height = DefaultDict{T,Int64}(-1)

    lowpt = Dict{Edge{T},Int64}()  # height of lowest return point of an edge
    lowpt2 = Dict{Edge{T},Int64}()  # height of second lowest return point
    nesting_depth = Dict{Edge{T},Int64}()  # for nesting order

    # None == Edge(0, 0)  for our type-stable algo

    parent_edge = DefaultDict{T,Edge{T}}(empty_edge(T))

    # oriented DFS graph
    DG = SimpleDiGraph{T}(N)

    adjs = Dict{T,Vector{T}}()
    # make adjacency lists for dfs
    for v in 1:nv(g) #for all vertices in G,
        adjs[v] = all_neighbors(g, v) ##neighbourhood of v
    end

    ordered_adjs = Dict{T,Vector{T}}()

    ref = DefaultDict{Edge{T},Edge{T}}(empty_edge(T))
    side = DefaultDict{Edge{T},Int8}(one(Int8))

    # stack of conflict pairs
    S = Stack{ConflictPair{T}}()
    stack_bottom = Dict{Edge{T},ConflictPair{T}}()
    lowpt_edge = Dict{Edge{T},Edge{T}}()
    #left_ref = Dict{T,Edge{T}}()
    #right_ref = Dict{T,Edge{T}}()

    #self.embedding = PlanarEmbedding()
    return LRPlanarity(
        #g,
        V,
        E,
        roots,
        height,
        lowpt,
        lowpt2,
        nesting_depth,
        parent_edge,
        DG,
        adjs,
        ordered_adjs,
        ref,
        side,
        S,
        stack_bottom,
        lowpt_edge,
        #left_ref,
        #right_ref,
    )
end

function lrp_type(lrp::LRPlanarity{T}) where {T}
    T
end

function lowest(self::ConflictPair, planarity_state::LRPlanarity)
    #Returns the lowest lowpoint of a conflict pair
    if isempty(self.L)
        return planarity_state.lowpt[self.R.low]
    end

    if isempty(self.R)
        return planarity_state.lowpt[self.L.low]
    end

    return min(planarity_state.lowpt[self.L.low], planarity_state.lowpt[self.R.low])
end

function lr_planarity!(self::LRPlanarity{T}) where {T}
    V = self.V
    E = self.E

    if V > 2 && (E > (3V - 6))
        # graph is not planar
        return false
    end

    # orientation of the graph by depth first search traversal
    for v in 1:V
        if self.height[v] == -one(T) #using -1 rather than nothing for type stability. 
            self.height[v] = zero(T)
            push!(self.roots, v)
            dfs_orientation!(self, v)
        end
    end

    #Testing stage
    #First, sort the ordered_adjs by nesting depth
    for v in 1:V #for all vertices in G,
        #get neighboring nodes
        neighboring_nodes = T[]
        neighboring_nesting_depths = Int64[]
        for (k, value) in self.nesting_depth
            if k.src == v
                push!(neighboring_nodes, k.dst)
                push!(neighboring_nesting_depths, value)
            end
        end
        neighboring_nodes .= neighboring_nodes[sortperm(neighboring_nesting_depths)]
        self.ordered_adjs[v] = neighboring_nodes
    end
    for s in self.roots
        if !dfs_testing!(self, s)
            return false
        end
    end

    #if the algorithm finishes, the graph is planar. Return true
    return true
end

function dfs_orientation!(self::LRPlanarity, v)
    # get the parent edge of v. 
    # if v is a root, the parent_edge dict 
    # will return Edge(0, 0)
    e = self.parent_edge[v] #get the parent edge of v. 
    #orient all edges in graph recursively 
    for w in self.adjs[v]
        # see if vw = Edge(v, w) has already been oriented 
        vw = Edge(v, w)
        wv = Edge(w, v) #Need to consider approach from both direction
        if vw in edges(self.DG) || wv in edges(self.DG)
            continue
        end

        #otherwise, appended to DG
        add_edge!(self.DG, vw)

        #record lowpoints
        self.lowpt[vw] = self.height[v]
        self.lowpt2[vw] = self.height[v]
        #if height == -1, i.e. we are at a tree edge, then 
        # record the height accordingly
        if self.height[w] == -1 ##tree edge
            self.parent_edge[w] = vw
            self.height[w] = self.height[v] + 1
            dfs_orientation!(self, w)
        else
            #at a back edge - no need to 
            #go through a DFS
            self.lowpt[vw] = self.height[w]
        end

        #determine nesting depth with formulae from Brandes
        #note that this will only be carried out 
        #once per edge 
        # if the edge is chordal, use the alternative formula
        self.nesting_depth[vw] = 2 * self.lowpt[vw]
        if self.lowpt2[vw] < self.height[v]
            #chordal 
            self.nesting_depth[vw] += 1
        end

        #update lowpoints of parent 
        if !isempty(e) #if e != root
            if self.lowpt[vw] < self.lowpt[e]
                self.lowpt2[e] = min(self.lowpt[e], self.lowpt2[vw])
                self.lowpt[e] = self.lowpt[vw]
            elseif self.lowpt[vw] > self.lowpt[e]
                self.lowpt2[e] = min(self.lowpt2[e], self.lowpt[vw])
            else
                self.lowpt2[e] = min(self.lowpt2[e], self.lowpt2[vw])
            end
        end
    end
end

function dfs_testing!(self, v)
    T = typeof(v)
    e = self.parent_edge[v]
    for w in self.ordered_adjs[v] #already ordered 
        ei = Edge(v, w)
        if !isempty(self.S) #stack is not empty
            self.stack_bottom[ei] = first(self.S)
        else #stack is empty
            self.stack_bottom[ei] = root_pair(T)
        end

        if ei == self.parent_edge[ei.dst] #tree edge
            if !dfs_testing!(self, ei.dst) #half if testing fails
                return false
            end
        else #back edge
            self.lowpt_edge[ei] = ei
            push!(self.S, ConflictPair(empty_interval(T), Interval(ei, ei)))
        end

        #integrate new return edges 
        if self.lowpt[ei] < self.height[v] #ei has return edge 
            e1 = Edge(v, first(self.ordered_adjs[v]))
            if ei == e1
                self.lowpt_edge[e] = self.lowpt_edge[ei] #in Brandes this is e <- e1. Corrected in Python source?
            else
                #add contraints (algo 4)
                if !edge_constraints!(self, ei, e) #half if fails
                    return false
                end
            end
        end
    end

    #remove back edges returning to parent 
    if !isempty(e)#v is not root
        u = src(e)
        #trim edges ending at parent u, algo 5 
        trim_back_edges!(self, u)
        #side of e is side of highest returning edge 
        if self.lowpt[e] < self.height[u] #e has return edge
            hl = first(self.S).L.high
            hr = first(self.S).R.high
            if !isempty(hl) && (isempty(hr) || (self.lowpt[hl] > self.lowpt[hr]))
                self.ref[e] = hl
            else
                self.ref[e] = hr
            end
        end
    end
    return true
end

function edge_constraints!(self, ei, e)
    T = eltype(ei)
    P = empty_pair(T)
    #merge return edges of ei into P.R
    while first(self.S) != self.stack_bottom[ei]
        Q = pop!(self.S)
        if !isempty(Q.L)
            swap!(Q)
        end
        if !isempty(Q.L) #not planar
            return false
        else
            if self.lowpt[Q.R.low] > self.lowpt[e] #merge intervals
                if isempty(P.R) #topmost interval
                    P.R.high = Q.R.high
                else
                    self.ref[P.R.low] = Q.R.high
                end
                P.R.low = Q.R.low
            else #align
                self.ref[Q.R.low] = self.lowpt_edge[e]
            end
        end
    end

    #merge conflicting return edges of <e...> into P.LRPlanarity
    while conflicting(first(self.S).L, ei, self) || conflicting(first(self.S).R, ei, self)
        Q = pop!(self.S)
        if conflicting(Q.R, ei, self)
            swap!(Q)
        end
        if conflicting(Q.R, ei, self) #not planar
            return false
        else #merge interval below into P.R
            self.ref[P.R.low] = Q.R.high
            if !isempty(Q.R.low)
                P.R.low = Q.R.low
            end
        end
        if isempty(P.L) #topmost interval
            P.L.high = Q.L.high
        else
            self.ref[P.L.low] = Q.L.high
        end
        P.L.low = Q.L.low
    end
    if !isempty(P)
        push!(self.S, P)
    end
    return true
end

function trim_back_edges!(self, u)
    #trim back edges ending at u 
    #drop entire conflict pairs 
    while !isempty(self.S) && (lowest(first(self.S), self) == self.height[u])
        P = pop!(self.S)
        if !isempty(P.L.low)
            self.side[P.L.low] = -1
        end
    end

    if !isempty(self.S) #one more conflict pair to consider 
        P = pop!(self.S)
        #trim left interval 
        while !isempty(P.L.high) && P.L.high.dst == u
            P.L.high = self.ref[P.L.high]
        end

        if isempty(P.L.high) && !isempty(P.L.low) #just emptied
            self.ref[P.L.low] = P.R.low
            self.side[P.L.low] = -1
            T = typeof(u)
            P.L.low = empty_edge(T)
        end

        #trim right interval 
        while !isempty(P.R.high) && P.R.high.dst == u
            P.R.high = self.ref[P.R.high]
        end

        if isempty(P.R.high) && !isempty(P.R.low) #just emptied
            self.ref[P.R.low] = P.L.low
            self.side[P.R.low] = -1
            T = typeof(u)
            P.R.low = empty_edge(T)
        end
        push!(self.S, P)
    end
end

@testset "Minimal Dominating Set" begin
    g0 = SimpleGraph(0)
    for g in testgraphs(g0)
        d = @inferred(dominating_set(g, MinimalDominatingSet(); rng=StableRNG(3)))
        @test isempty(d)
    end

    g1 = SimpleGraph(1)
    for g in testgraphs(g1)
        d = @inferred(dominating_set(g, MinimalDominatingSet(); rng=StableRNG(3)))
        @test (d == [1])
    end

    add_edge!(g1, 1, 1)
    for g in testgraphs(g1)
        d = @inferred(dominating_set(g, MinimalDominatingSet(); rng=StableRNG(3)))
        @test (d == [1])
    end

    g3 = star_graph(5)
    for g in testgraphs(g3)
        d = @inferred(dominating_set(g, MinimalDominatingSet(); rng=StableRNG(3)))
        @test (length(d) == 1 || (length(d) == 4 && minimum(d) > 1))
    end

    g4 = complete_graph(5)
    for g in testgraphs(g4)
        d = @inferred(dominating_set(g, MinimalDominatingSet(); rng=StableRNG(3)))
        @test length(d) == 1 # Exactly one vertex
    end

    g5 = path_graph(4)
    for g in testgraphs(g5)
        d = @inferred(dominating_set(g, MinimalDominatingSet(); rng=StableRNG(3)))
        sort!(d)
        @test (d == [1, 2, 4] || d == [1, 3] || d == [1, 4] || d == [2, 3] || d == [2, 4])
    end

    add_edge!(g5, 2, 2)
    add_edge!(g5, 3, 3)
    for g in testgraphs(g5)
        d = @inferred(dominating_set(g, MinimalDominatingSet(); rng=StableRNG(3)))
        sort!(d)
        @test (d == [1, 2, 4] || d == [1, 3] || d == [1, 4] || d == [2, 3] || d == [2, 4])
    end
end

"""
    BFSIterator(graph, source; depth_limit=nothing, neighbors_type=outneighbors)

`BFSIterator` is used to iterate through graph vertices using a breadth-first search.
A source node(s) must be supplied as an `Int` or an array-like type that can be
indexed if supplying multiple sources. It is also possible to specify a `depth_limit`
which will stop the search once all nodes at that depth are visited and a `neighbors_type`
which specifies what kind of neighbors of a node should be considered when exploring the graph.
    
# Examples
```julia-repl
julia> g = smallgraph(:house)
{5, 6} undirected simple Int64 graph

julia> for node in BFSIterator(g,3)
           display(node)
       end
3
1
4
5
2
```
"""
struct BFSIterator{S,G<:AbstractGraph,F}
    graph::G
    source::S
    depth_limit::Int
    neighbors_type::F
    function BFSIterator(
        graph::G, source::S; depth_limit=typemax(Int64), neighbors_type::F=outneighbors
    ) where {S,G,F}
        if any(node -> !has_vertex(graph, node), source)
            error("Some source nodes for the iterator are not in the graph")
        end
        return new{S,G,F}(graph, source, depth_limit, neighbors_type)
    end
end

"""
    BFSVertexIteratorState

`BFSVertexIteratorState` is a struct to hold the current state of iteration
in BFS which is needed for the `Base.iterate()` function. We use two vectors,
one for the current level nodes and one from the next level nodes to visit 
the graph. Since new levels can contains repetitions of already visited nodes, 
we also keep track of that in a `BitVector` so as to skip those nodes.
"""
mutable struct BFSVertexIteratorState
    visited::BitVector
    curr_level::Vector{Int}
    next_level::Vector{Int}
    node_idx::Int
    n_visited::Int
    n_level::Int
end

Base.IteratorSize(::BFSIterator) = Base.SizeUnknown()
Base.eltype(::Type{BFSIterator{S,G}}) where {S,G} = eltype(G)

"""
    Base.iterate(t::BFSIterator)

First iteration to visit vertices in a graph using breadth-first search.
"""
function Base.iterate(t::BFSIterator{<:Integer})
    visited = falses(nv(t.graph))
    visited[t.source] = true
    state = BFSVertexIteratorState(visited, [t.source], Int[], 0, 0, 0)
    return Base.iterate(t, state)
end

function Base.iterate(t::BFSIterator{<:AbstractArray})
    visited = falses(nv(t.graph))
    curr_level = unique(s for s in t.source)
    sort!(curr_level)
    visited[curr_level] .= true
    state = BFSVertexIteratorState(visited, curr_level, Int[], 0, 0, 0)
    return Base.iterate(t, state)
end

"""
    Base.iterate(t::BFSIterator, state::VertexIteratorState)

Iterator to visit vertices in a graph using breadth-first search.
"""
function Base.iterate(t::BFSIterator, state::BFSVertexIteratorState)
    # we fill nodes in this level
    if state.node_idx == length(state.curr_level)
        state.n_level == t.depth_limit && return nothing
        state.n_level += 1
        state.n_visited += length(state.curr_level)
        state.n_visited == nv(t.graph) && return nothing
        neighbors_type = t.neighbors_type
        @inbounds for node in state.curr_level
            for adj_node in neighbors_type(t.graph, node)
                if !state.visited[adj_node]
                    push!(state.next_level, adj_node)
                    state.visited[adj_node] = true
                end
            end
        end
        length(state.next_level) == 0 && return nothing
        state.curr_level, state.next_level = state.next_level, empty!(state.curr_level)
        sort!(state.curr_level)
        state.node_idx = 0
    end
    # we visit all nodes in this level
    state.node_idx += 1
    @inbounds node = state.curr_level[state.node_idx]
    return (node, state)
end

struct DijkstraResult{T,U<:Integer} <: ShortestPathResult
    parents::Vector{U}
    dists::Vector{T}
    predecessors::Vector{Vector{U}}
    pathcounts::Vector{UInt64}
    closest_vertices::Vector{U}
end

"""
    struct Dijkstra <: ShortestPathAlgorithm

The structure used to configure and specify that [`shortest_paths`](@ref)
should use [Dijkstra's algorithm](http://en.wikipedia.org/wiki/Dijkstra%27s_algorithm)
to compute shortest paths. Optional fields for this structure include
- all_paths::Bool - set to `true` to calculate all (redundant, equivalent) paths to a given destination
- track_vertices::Bool - set to `true` to keep a running list of visited vertices (used for specific
  centrality calculations; generally not needed).

`Dijkstra` is the default algorithm used when a distance matrix is specified.

### Implementation Notes
`Dijkstra` supports the following shortest-path functionality:
- non-negative distance matrices / weights
- (optional) multiple sources
- all destinations
- redundant equivalent path tracking
- vertex tracking

### Performance
If using a sparse matrix for `distmx` in [`shortest_paths`](@ref), you *may* achieve better performance
by passing in a transpose of its sparse transpose. That is, assuming `D` is the sparse distance matrix:
```
D = transpose(sparse(transpose(D)))
```
Be aware that realizing the sparse transpose of `D` incurs a heavy one-time penalty, so this strategy
should only be used when multiple calls to [`shortest_paths`](@ref) with the distance matrix are planned.
"""
struct Dijkstra <: ShortestPathAlgorithm
    all_paths::Bool
    track_vertices::Bool
end

Dijkstra(; all_paths=false, track_vertices=false) = Dijkstra(all_paths, track_vertices)

function shortest_paths(
    g::AbstractGraph, srcs::Vector{U}, distmx::AbstractMatrix{T}, alg::Dijkstra
) where {T,U<:Integer}
    nvg = nv(g)
    dists = fill(typemax(T), nvg)
    parents = zeros(U, nvg)
    visited = zeros(Bool, nvg)

    pathcounts = zeros(UInt64, nvg)
    preds = fill(Vector{U}(), nvg)
    H = PriorityQueue{U,T}()
    # fill creates only one array.

    for src in srcs
        dists[src] = zero(T)
        visited[src] = true
        pathcounts[src] = 1
        H[src] = zero(T)
    end

    closest_vertices = Vector{U}()  # Maintains vertices in order of distances from source
    sizehint!(closest_vertices, nvg)

    while !isempty(H)
        u = popfirst!(H).first

        if alg.track_vertices
            push!(closest_vertices, u)
        end

        d = dists[u] # Cannot be typemax if `u` is in the queue
        for v in outneighbors(g, u)
            alt = d + distmx[u, v]

            if !visited[v]
                visited[v] = true
                dists[v] = alt
                parents[v] = u

                pathcounts[v] += pathcounts[u]
                if alg.all_paths
                    preds[v] = [u;]
                end
                H[v] = alt
            elseif alt < dists[v]
                dists[v] = alt
                parents[v] = u
                #615
                pathcounts[v] = pathcounts[u]
                if alg.all_paths
                    resize!(preds[v], 1)
                    preds[v][1] = u
                end
                H[v] = alt
            elseif alt == dists[v]
                pathcounts[v] += pathcounts[u]
                if alg.all_paths
                    push!(preds[v], u)
                end
            end
        end
    end

    if alg.track_vertices
        for s in vertices(g)
            if !visited[s]
                push!(closest_vertices, s)
            end
        end
    end

    for src in srcs
        pathcounts[src] = 1
        parents[src] = 0
        empty!(preds[src])
    end

    return DijkstraResult{T,U}(parents, dists, preds, pathcounts, closest_vertices)
end

function shortest_paths(g::AbstractGraph, s::Integer, distmx::AbstractMatrix, alg::Dijkstra)
    return shortest_paths(g, [s], distmx, alg)
end
# If we don't specify an algorithm, use dijkstra.
function shortest_paths(g::AbstractGraph, s, distmx::AbstractMatrix)
    return shortest_paths(g, s, distmx, Dijkstra())
end

"""
    karger_min_cut(g)

Perform [Karger Minimum Cut](https://en.wikipedia.org/wiki/Karger%27s_algorithm)
to find the minimum cut of graph `g` with some probability of success.
A cut is a partition of `vertices(g)` into two non-empty sets.
The size of a cut is the number of edges crossing the two non-empty sets. 

### Implementation Notes
The cut is represented by an integer array.
If `cut[v] == 1` then `v` is in the first non-empty set.
If `cut[v] == 2` then `v` is in the second non-empty set.
`cut[1] = 1`.

If |V| < 2 then `cut[v] = 0` for all `v`.

### Performance
Runtime: O(|E|)
Memory: O(|E|)
"""
function karger_min_cut(g::AbstractGraph{T}) where {T<:Integer}
    nvg = nv(g)
    nvg < 2 && return zeros(Int, nvg)
    nvg == 2 && return [1, 2]

    connected_vs = IntDisjointSets(nvg)
    num_components = nvg

    for e in shuffle(collect(edges(g)))
        s = src(e)
        d = dst(e)
        if !in_same_set(connected_vs, s, d)
            union!(connected_vs, s, d)
            num_components -= one(T)
            (num_components <= 2) && break
        end
    end

    return [(in_same_set(connected_vs, one(T), v) ? 1 : 2) for v in vertices(g)]
end

"""
    karger_cut_cost(g, cut)

Find the number of crossing edges in a cut of graph `g` where the cut is represented
by the integer array, `cut`.
"""
function karger_cut_cost(g::AbstractGraph{T}, cut::Vector{<:Integer}) where {T<:Integer}
    return count((e::Edge{T}) -> cut[src(e)] != cut[dst(e)], edges(g))
end

"""
    karger_cut_edges(g, cut)

Find the crossing edges in a cut of graph `g` where the cut is represented
by the integer array, `cut`.
"""
function karger_cut_edges(g::AbstractGraph{T}, cut::Vector{<:Integer}) where {T<:Integer}
    return [e for e in edges(g) if cut[src(e)] != cut[dst(e)]]
end

"""
    bridges(g)

Compute the [bridges](https://en.wikipedia.org/wiki/Bridge_(graph_theory))
of a connected graph `g` and return an array containing all bridges, i.e edges
whose deletion increases the number of connected components of the graph.
# Examples
```jldoctest
julia> using Graphs

julia> bridges(star_graph(5))
4-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3
 Edge 1 => 4
 Edge 1 => 5

julia> bridges(path_graph(5))
4-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 4 => 5
 Edge 3 => 4
 Edge 2 => 3
 Edge 1 => 2
```
"""
function bridges end
@traitfn function bridges(g::AG::(!IsDirected)) where {T,AG<:AbstractGraph{T}}
    s = Vector{Tuple{T,T,T}}()
    low = zeros(T, nv(g)) # keeps track of the earliest accessible time of a vertex in DFS-stack, effect of having back-edges is considered here
    pre = zeros(T, nv(g)) # checks the entry time of a vertex in the DFS-stack, pre[u] = 0 if a vertex isn't visited; non-zero, otherwise
    bridges = Edge{T}[]   # keeps record of the bridge-edges

    # We iterate over all vertices, and if they have already been visited (pre != 0), we don't start a DFS from that vertex.
    # The purpose is to create a DFS forest.
    @inbounds for u in vertices(g)
        pre[u] != 0 && continue
        v = u # currently visiting vertex
        wi::T = zero(T) # index of children of v
        w::T = zero(T) # children of v
        cnt::T = one(T) # keeps record of the time
        first_time = true

        # TODO the algorithm currently relies on the assumption that
        # outneighbors(g, v) is indexable. This assumption might not be true
        # in general, so in case that outneighbors does not produce a vector
        # we collect these vertices. This might lead to a large number of
        # allocations, so we should find a way to handle that case differently,
        # or require inneighbors, outneighbors and neighbors to always
        # return indexable collections.

        # start of DFS
        while !isempty(s) || first_time
            first_time = false
            if wi < 1 # initialisation for vertex v
                pre[v] = cnt
                cnt += 1
                low[v] = pre[v]
                v_neighbors = collect_if_not_vector(outneighbors(g, v))
                wi = 1
            else
                wi, u, v = pop!(s) # the stack states, explained later
                v_neighbors = collect_if_not_vector(outneighbors(g, v))
                w = v_neighbors[wi]
                low[v] = min(low[v], low[w]) # condition check for (v, w) being a tree-edge
                if low[w] > pre[v]
                    edge = v < w ? Edge(v, w) : Edge(w, v)
                    push!(bridges, edge)
                end
                wi += 1
            end

            # here, we're iterating of all the children of vertex v, if unvisited, we start a DFS from that child, else we update the low[v] as the edge is a back-edge.
            while wi <= length(v_neighbors)
                w = v_neighbors[wi]
                # If this is true , this indicates the vertex is still unvisited, then we push this on the stack.
                # Pushing onto the stack is analogous to visiting the vertex and starting DFS from that vertex.
                if pre[w] == 0
                    push!(s, (wi, u, v)) # the stack states are (index of child, currently visiting vertex, parent vertex of the child)
                    # updates the value for stimulating DFS from top of the stack
                    wi = 0
                    u = v
                    v = w
                    break
                elseif w != u # (v, w) is a back-edge
                    low[v] = min(low[v], pre[w]) # condition for back-edges
                end
                wi += 1
            end
            wi < 1 && continue
        end
    end

    return bridges
end

using Random: randperm

# helper function that permutates the vertices of a graph
function shuffle_vertices(g::AbstractGraph, σ)
    G = typeof(g)
    gperm = G(nv(g))
    n = nv(g)
    for e in edges(g)
        add_edge!(gperm, σ[src(e)], σ[dst(e)])
    end
    return gperm
end

# all (up to isomorphism) 3-regular, connected graphs on 8 vertices
# list taken from https://en.wikipedia.org/wiki/Table_of_simple_cubic_graphs#4_vertices
cubic_graphs = [
    SimpleGraph(
        Edge.([
            (1, 2),
            (1, 3),
            (1, 8),
            (2, 3),
            (2, 4),
            (3, 4),
            (4, 5),
            (5, 6),
            (5, 7),
            (6, 7),
            (6, 8),
            (7, 8),
        ]),
    ),
    SimpleGraph(
        Edge.([
            (1, 2),
            (1, 3),
            (1, 8),
            (2, 3),
            (2, 5),
            (3, 4),
            (4, 5),
            (4, 7),
            (5, 6),
            (6, 7),
            (6, 8),
            (7, 8),
        ]),
    ),
    SimpleGraph(
        Edge.([
            (1, 2),
            (1, 3),
            (1, 8),
            (2, 3),
            (2, 6),
            (3, 4),
            (4, 5),
            (4, 7),
            (5, 6),
            (5, 8),
            (6, 7),
            (7, 8),
        ]),
    ),
    grid([2, 2, 2]),
    SimpleGraph(
        Edge.([
            (1, 2),
            (1, 5),
            (1, 8),
            (2, 3),
            (2, 6),
            (3, 4),
            (3, 7),
            (4, 5),
            (4, 8),
            (5, 6),
            (6, 7),
            (7, 8),
        ]),
    ),
]
# vertex permutated versions of cubic_graphs
cubic_graphs_perm = []

rng = StableRNG(1)
for graph in cubic_graphs
    push!(cubic_graphs_perm, shuffle_vertices(graph, randperm(rng, 8)))
end

@testset "Isomorphism" begin
    @test has_isomorph(grid([2, 3]), grid([3, 2]))

    # the cubic graphs should only be isomorphic to themselves
    # the same holds for subgraph isomorphism and induced subgraph isomorphism
    for i in eachindex(cubic_graphs), j in eachindex(cubic_graphs)
        @test (i == j) == has_isomorph(cubic_graphs[i], cubic_graphs[j])
        @test (i == j) == has_subgraphisomorph(cubic_graphs[i], cubic_graphs[j])
        @test (i == j) == has_induced_subgraphisomorph(cubic_graphs[i], cubic_graphs[j])
    end

    # the cubic graphs should only be isomorphic to a permutation of themselves
    # the same holds for subgraph isomorphism and induced subgraph isomorphism
    for i in eachindex(cubic_graphs), j in eachindex(cubic_graphs_perm)
        @test (i == j) == has_isomorph(cubic_graphs[i], cubic_graphs_perm[j])
        @test (i == j) == has_subgraphisomorph(cubic_graphs[i], cubic_graphs_perm[j])
        @test (i == j) ==
            has_induced_subgraphisomorph(cubic_graphs[i], cubic_graphs_perm[j])
    end

    # count_isomorph, count_subgraphisomorph and count_induced_subgraphisomorph are commutative
    for i in eachindex(cubic_graphs)
        g1 = cubic_graphs[i]
        g2 = cubic_graphs_perm[i]
        @test count_isomorph(g1, g1) ==
            count_isomorph(g1, g2) ==
            count_isomorph(g2, g1) ==
            count_isomorph(g2, g2)
        @test count_subgraphisomorph(g1, g1) ==
            count_subgraphisomorph(g1, g2) ==
            count_subgraphisomorph(g2, g1) ==
            count_subgraphisomorph(g2, g2)
        @test count_induced_subgraphisomorph(g1, g1) ==
            count_subgraphisomorph(g1, g2) ==
            count_subgraphisomorph(g2, g1) ==
            count_subgraphisomorph(g2, g2)
    end

    for i in eachindex(cubic_graphs)
        g1 = cubic_graphs[i]
        g2 = cubic_graphs_perm[i]
        length(collect(all_isomorph(g1, g1))) == count_isomorph(g1, g2)
        length(collect(all_subgraphisomorph(g1, g1))) == count_isomorph(g1, g2)
        length(collect(all_induced_subgraphisomorph(g1, g1))) == count_isomorph(g1, g2)
    end

    # The frucht-graph is a 3-regular graph that has only one automorphism
    g = smallgraph(:frucht)
    perm = randperm(rng, 12)
    g2 = shuffle_vertices(g, perm)
    perm_reconstructed = map(uv -> first(uv), first(all_isomorph(g2, g)))
    @test perm == perm_reconstructed

    # TODO better tests for vertex_relation and edge_relation
    vrel(u, v) = false
    erel(e1, e2) = false
    @test has_isomorph(complete_graph(4), complete_graph(4); vertex_relation=vrel) == false
    @test has_isomorph(complete_graph(4), complete_graph(4); edge_relation=erel) == false
    @test has_subgraphisomorph(
        complete_graph(4), complete_graph(3); vertex_relation=vrel
    ) == false
    @test has_subgraphisomorph(complete_graph(4), complete_graph(3); edge_relation=erel) ==
        false
    @test has_induced_subgraphisomorph(
        complete_graph(4), complete_graph(3); vertex_relation=vrel
    ) == false
    @test has_induced_subgraphisomorph(
        complete_graph(4), complete_graph(3); edge_relation=erel
    ) == false

    @test count_isomorph(complete_graph(4), complete_graph(4); vertex_relation=vrel) == 0
    @test count_isomorph(complete_graph(4), complete_graph(4); edge_relation=erel) == 0
    @test count_subgraphisomorph(
        complete_graph(4), complete_graph(3); vertex_relation=vrel
    ) == 0
    @test count_subgraphisomorph(
        complete_graph(4), complete_graph(3); edge_relation=erel
    ) == 0
    @test count_induced_subgraphisomorph(
        complete_graph(4), complete_graph(3); vertex_relation=vrel
    ) == 0
    @test count_induced_subgraphisomorph(
        complete_graph(4), complete_graph(3); edge_relation=erel
    ) == 0

    @test isempty(all_isomorph(complete_graph(4), complete_graph(4); vertex_relation=vrel))
    @test isempty(all_isomorph(complete_graph(4), complete_graph(4); edge_relation=erel))
    @test isempty(
        all_subgraphisomorph(complete_graph(4), complete_graph(3); vertex_relation=vrel)
    )
    @test isempty(
        all_subgraphisomorph(complete_graph(4), complete_graph(3); edge_relation=erel)
    )
    @test isempty(
        all_induced_subgraphisomorph(
            complete_graph(4), complete_graph(3); vertex_relation=vrel
        ),
    )
    @test isempty(
        all_induced_subgraphisomorph(
            complete_graph(4), complete_graph(3); edge_relation=erel
        ),
    )

    # some test for early returns if there is no isomorphism
    @test count_isomorph(complete_graph(4), cycle_graph(4)) == 0
    @test isempty(all_isomorph(complete_graph(4), cycle_graph(4)))
    @test count_subgraphisomorph(complete_graph(3), complete_graph(4)) == 0

    # this tests triggers the shortcut in the vf2 algorithm if the first graph is smaller than the second one
    @test has_isomorph(complete_graph(3), complete_graph(4)) == false

    # this test is mainly to cover a certain branch of vf2
    # TODO cover directed graphs better
    gd = SimpleDiGraph(Edge.([(2, 1)]))
    @test has_isomorph(gd, gd, VF2()) == true

    # Test for correct handling of self-loops
    g1 = SimpleGraph(1)
    add_edge!(g1, 1, 1)
    g2 = SimpleGraph(1)
    @test has_isomorph(g1, g1) == true
    @test has_isomorph(g1, g2) == false
    @test has_isomorph(g2, g1) == false
    @test has_isomorph(g1, g1) == true

    @test has_induced_subgraphisomorph(g1, g1) == true
    @test has_induced_subgraphisomorph(g1, g2) == false
    @test has_induced_subgraphisomorph(g2, g1) == false
    @test has_induced_subgraphisomorph(g2, g2) == true

    @test has_subgraphisomorph(g1, g1) == true
    @test has_subgraphisomorph(g1, g2) == true
    @test has_subgraphisomorph(g2, g1) == false
    @test has_subgraphisomorph(g2, g2) == true
end

@testset "Parallel.Greedy Coloring" for parallel in [:threads, :distributed]
    g3 = star_graph(10)
    for g in testgraphs(g3)
        for op_sort in (true, false)
            C = @inferred(Parallel.greedy_color(g; reps=5, sort_degree=op_sort, parallel))
            @test C.num_colors == 2
        end
    end

    g4 = path_graph(20)
    g5 = complete_graph(20)

    let g = testgraphs(g4)[1]
        # An error should be reported if the parallel mode could not be understood
        @test_throws ArgumentError Parallel.greedy_color(
            g; reps=5, sort_degree=false, parallel=:thread
        )
        @test_throws ArgumentError Parallel.greedy_color(
            g; reps=5, sort_degree=false, parallel=:distriibuted
        )
    end

    for graph in [g4, g5]
        for g in testgraphs(graph)
            for op_sort in (true, false)
                C = @inferred(
                    Parallel.greedy_color(g; reps=5, sort_degree=op_sort, parallel)
                )

                @test C.num_colors <= maximum(degree(g)) + 1
                correct = true
                for e in edges(g)
                    C.colors[src(e)] == C.colors[dst(e)] && (correct = false)
                end
                @test correct
            end
        end
    end
end

module ShortestPaths
using SparseArrays: sparse
using Graphs
using Graphs.Experimental.Traversals
using Graphs: AbstractGraph, AbstractEdge
using Graphs.SimpleGraphs: AbstractSimpleGraph
using DataStructures: PriorityQueue

import Graphs.Experimental.Traversals:
    initfn!, previsitfn!, newvisitfn!, visitfn!, postvisitfn!, postlevelfn!

# TODO: figure out how we keep environmental params.
# struct LGEnvironment
#     threaded::Bool
#     parallel::Bool
#     LGEnvironment() = new(false, false)
# end

abstract type AbstractGraphResult end
abstract type AbstractGraphAlgorithm end

"""
    ShortestPathResult <: AbstractGraphResult

Concrete subtypes of `ShortestPathResult` contain the
results of a shortest-path calculation using a specific
[`ShortestPathAlgorithm`](@ref).

In general, the fields in these structs should not be
accessed directly; use the [`dists`](@ref) and
[`paths`](@ref) functions to obtain the results of the
calculation.
"""
abstract type ShortestPathResult <: AbstractGraphResult end

"""
    ShortestPathAlgorithm <: AbstractGraphAlgorithm

Concrete subtypes of `ShortestPathAlgorithm` are used to specify
the type of shortest path calculation used by [`shortest_paths`](@ref).
Some concrete subtypes (most notably [`Dijkstra`](@ref) have fields
that specify algorithm parameters.

See [`AStar`](@ref), [`BellmanFord`](@ref), [`BFS`](@ref),
[`DEsopoPape`](@ref), [`Dijkstra`](@ref), [`FloydWarshall`](@ref),
[`Johnson`](@ref), and [`SPFA`](@ref) for specific requirements and
usage details.
"""
abstract type ShortestPathAlgorithm <: AbstractGraphAlgorithm end

include("astar.jl")
include("bellman-ford.jl")
include("bfs.jl")
include("desopo-pape.jl")
include("dijkstra.jl")
include("floyd-warshall.jl")
include("johnson.jl")
include("spfa.jl")

################################
# Shortest Paths via algorithm #
################################
# if we don't pass in distances but specify an algorithm, use weights.
"""
    shortest_paths(g, s, distmx, alg)
    shortest_paths(g, s, t, alg)
    shortest_paths(g, s, alg)
    shortest_paths(g, s)
    shortest_paths(g)

Return a `ShortestPathResult` that allows construction of the shortest path
between sets of vertices in graph `g`. Depending on the algorithm specified,
other information may be required: (e.g., a distance matrix `distmx`, and/or
a target vertex `t`). Some algorithms will accept multiple source vertices
`s`; algorithms that do not accept any source vertex `s` produce all-pairs
shortest paths.

See `ShortestPathAlgorithm` for more details on the algorithm specifications.

### Implementation Notes
The elements of `distmx` may be of any type that has a [Total Ordering](https://en.wikipedia.org/wiki/Total_order)
and valid comparator, `zero` and `typemax` functions. Concretely, this means that
distance matrices containing complex numbers are invalid.

### Examples
```
g = path_graph(4)
w = zeros(4, 4)
for i in 1:3
    w[i, i+1] = 1.0
    w[i+1, i] = 1.0
end

s1 = shortest_paths(g)                   # `alg` defaults to `FloydWarshall`
s2 = shortest_paths(g, 1)                # `alg` defaults to `BFS`
s3 = shortest_paths(g, 1, w)             # `alg` defaults to `Dijkstra`
s4 = shortest_paths(g, 1, BellmanFord())
s5 = shortest_paths(g, 1, w, DEsopoPape())
```
"""
function shortest_paths(g::AbstractGraph, s, alg::ShortestPathAlgorithm)
    return shortest_paths(g, s, weights(g), alg)
end

# If we don't specify an algorithm AND there are no dists, use BFS.
function shortest_paths(g::AbstractGraph{T}, s::Integer) where {T<:Integer}
    return shortest_paths(g, s, BFS())
end
function shortest_paths(g::AbstractGraph{T}, ss::AbstractVector) where {T<:Integer}
    return shortest_paths(g, ss, BFS())
end

# Full-formed methods.
"""
    paths(state[, v])
    paths(state[, vs])
    paths(state[, v, d]))

Given the output of a [`shortest_paths`](@ref) calculation of type
[`ShortestPathResult`](@ref), return a vector (indexed by vertex)
of the paths between the source vertex used to compute the shortest path
and a single destination vertex `v`, a vector of destination vertices `vs`,
or the entire graph.

For multiple destination vertices, each path is represented by a vector of
vertices on the path between the source and the destination. Nonexistent
paths will be indicated by an empty vector. For single destinations, the
path is represented by a single vector of vertices, and will be length 0
if the path does not exist.

For [`ShortestPathAlgorithm`](@ref)s that compute all shortest paths for all
pairs of vertices, `paths(state)` will return a vector (indexed by source
vertex) of vectors (indexed by destination vertex) of paths. `paths(state, v)`
will return a vector (indexed by destination vertex) of paths from source `v`
to all other vertices. In addition, `paths(state, v, d)` will return a vector
representing the path from vertex `v` to vertex `d`.
"""
function paths(state::ShortestPathResult, vs::AbstractVector{<:Integer})
    parents = state.parents
    T = eltype(parents)

    num_vs = length(vs)
    all_paths = Vector{Vector{T}}(undef, num_vs)
    for i in 1:num_vs
        all_paths[i] = Vector{T}()
        index = T(vs[i])
        if parents[index] != 0 || parents[index] == index
            while parents[index] != 0
                pushfirst!(all_paths[i], index)
                index = parents[index]
            end
            pushfirst!(all_paths[i], index)
        end
    end
    return all_paths
end

paths(state::ShortestPathResult, v::Integer) = paths(state, [v])[1]
paths(state::ShortestPathResult) = paths(state, [1:length(state.parents);])

"""
    dists(state[, v])

Given the output of a [`shortest_paths`](@ref) calculation of type
[`ShortestPathResult`](@ref), return a vector (indexed by vertex)
of the distances between the source vertex used to compute the
shortest path and a single destination vertex `v` or the entire graph.

For [`ShortestPathAlgorithm`](@ref)s that compute all-pairs shortest
paths, `dists(state)` will return a matrix (indexed by source and destination
vertices) of distances.
"""
dists(state::ShortestPathResult, v::Integer) = state.dists[v]
dists(state::ShortestPathResult) = state.dists

"""
    has_negative_weight_cycle(g[, distmx=weights(g), alg=BellmanFord()])

Given a graph `g`, an optional distance matrix `distmx`, and an optional
algorithm `alg` (one of [`BellmanFord`](@ref) or [`SPFA`](@ref)), return
`true` if any cycle detected in the graph has a negative weight.
# Examples

```jldoctest
julia> using Graphs, Graphs.Experimental.ShortestPaths

julia> g = complete_graph(3);

julia> d = [1 -3 1; -3 1 1; 1 1 1];

julia> has_negative_weight_cycle(g, d)
true

julia> g = complete_graph(4);

julia> d = [1 1 -1 1; 1 1 -1 1; 1 1 1 1; 1 1 1 1];

julia> has_negative_weight_cycle(g, d, SPFA())
false
```
"""
function has_negative_weight_cycle(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return has_negative_weight_cycle(g, distmx, BellmanFord())
end
has_negative_weight_cycle(g::AbstractSimpleGraph) = false

export ShortestPathAlgorithm
export paths, dists, shortest_paths, has_negative_weight_cycle
export Dijkstra, AStar, BellmanFord, FloydWarshall, DEsopoPape, Johnson, SPFA, BFS
export NegativeCycleError

end  # module

"""
    AbstractPathState

An abstract type that provides information from shortest paths calculations.
"""
abstract type AbstractPathState end

"""
    is_ordered(e)

Return true if the source vertex of edge `e` is less than or equal to
the destination vertex.

# Examples
```jldoctest
julia> using Graphs

julia> g = DiGraph(2);

julia> add_edge!(g, 2, 1);

julia> is_ordered(first(edges(g)))
false
```
"""
is_ordered(e::AbstractEdge) = src(e) <= dst(e)

"""
    add_vertices!(g, n)

Add `n` new vertices to the graph `g`.
Return the number of vertices that were added successfully.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph()
{0, 0} undirected simple Int64 graph

julia> add_vertices!(g, 2)
2
```
"""
add_vertices!(g::AbstractGraph, n::Integer) = sum([add_vertex!(g) for i in 1:n])

"""
    indegree(g[, v])

Return a vector containing the indegrees of every vertex of the graph `g`, where
the indegree of a vertex is defined as the number of edges which end at that
vertex. If `v` is specified and is a single vertex, only return the indegree of
`v`. If `v` is specified and is a vector of vertices, only return the indegrees
of the vertices in `v`.

# Examples
```jldoctest
julia> using Graphs

julia> g = DiGraph(3);

julia> add_edge!(g, 2, 3);

julia> add_edge!(g, 3, 1);

julia> indegree(g)
3-element Vector{Int64}:
 1
 0
 1

julia> indegree(g,[2,3])
2-element Vector{Int64}:
 0
 1

julia> indegree(g,2)
0
```
"""
indegree(g::AbstractGraph, v::Integer) = length(inneighbors(g, v))
indegree(g::AbstractGraph, vs=vertices(g)) = [indegree(g, x) for x in vs]

"""
    outdegree(g[, v])

Return a vector containing the outdegrees of every vertex of the graph `g`, where
the outdegree of a vertex is defined as the number of edges which start at that
vertex. If `v` is specified and is a single vertex, only return the outdegree of
`v`. If `v` is specified and is a vector of vertices, only return the outdegrees
of the vertices in `v`.

# Examples
```jldoctest
julia> using Graphs

julia> g = DiGraph(3);

julia> add_edge!(g, 2, 3);

julia> add_edge!(g, 3, 1);

julia> outdegree(g)
3-element Vector{Int64}:
 0
 1
 1

julia> outdegree(g,[1,2])
2-element Vector{Int64}:
 0
 1

julia> outdegree(g,2)
1
```
"""
outdegree(g::AbstractGraph, v::Integer) = length(outneighbors(g, v))
outdegree(g::AbstractGraph, vs=vertices(g)) = [outdegree(g, x) for x in vs]

"""
    degree(g[, v])

Return a vector containing the degrees of every vertex of the graph `g`, where
the degree of a vertex is defined as the number of edges which start or end at
that vertex. For directed graphs, the degree of a vertex is equal to the sum of
its indegree and outdegree. If `v` is specified and is a single vertex, only
return the degree of `v`. If `v` is specified and is a vector of vertices, only
return the degrees of the vertices in `v`.

# Examples
```jldoctest
julia> using Graphs

julia> g = DiGraph(3);

julia> add_edge!(g, 2, 3);

julia> add_edge!(g, 3, 1);

julia> degree(g)
3-element Vector{Int64}:
 1
 1
 2

julia> degree(g,[1,3])
2-element Vector{Int64}:
 1
 2

julia> degree(g,3)
2
```
"""
function degree end

function degree(g::AbstractGraph, v::Integer)
    if !is_directed(g)
        return outdegree(g, v)
    end
    return indegree(g, v) + outdegree(g, v)
end

degree(g::AbstractGraph, vs=vertices(g)) = [degree(g, x) for x in vs]

"""
    Δout(g)

Return the maximum [`outdegree`](@ref) of vertices in `g`.
"""
Δout(g) = noallocextreme(outdegree, (>), typemin(Int), g)
"""
    δout(g)

Return the minimum [`outdegree`](@ref) of vertices in `g`.
"""
δout(g) = noallocextreme(outdegree, (<), typemax(Int), g)

"""
    Δin(g)

Return the maximum [`indegree`](@ref) of vertices in `g`.
"""
Δin(g) = noallocextreme(indegree, (>), typemin(Int), g)

"""
    δin(g)

Return the minimum [`indegree`](@ref) of vertices in `g`.
"""
δin(g) = noallocextreme(indegree, (<), typemax(Int), g)

"""
    Δ(g)

Return the maximum [`degree`](@ref) of vertices in `g`.
"""
Δ(g) = noallocextreme(degree, (>), typemin(Int), g)

"""
    δ(g)

Return the minimum [`degree`](@ref) of vertices in `g`.
"""
δ(g) = noallocextreme(degree, (<), typemax(Int), g)

"""
    noallocextreme(f, comparison, initial, g)

Compute the extreme value of `[f(g,i) for i=i:nv(g)]` without gathering them all
"""
function noallocextreme(f, comparison, initial, g)
    value = initial
    for i in vertices(g)
        funci = f(g, i)
        if comparison(funci, value)
            value = funci
        end
    end
    return value
end

"""
    degree_histogram(g, degfn=degree)

Return a `Dict` with values representing the number of vertices that have degree
represented by the key.

Degree function (for example, [`indegree`](@ref) or [`outdegree`](@ref)) may be specified by
overriding `degfn`.
"""
function degree_histogram(g::AbstractGraph{T}, degfn=degree) where {T}
    hist = Dict{T,Int}()
    for v in vertices(g)        # minimize allocations by
        for d in degfn(g, v)    # iterating over vertices
            hist[d] = get(hist, d, 0) + 1
        end
    end
    return hist
end

"""
    neighbors(g, v)

Return a list of all neighbors reachable from vertex `v` in `g`.
For directed graphs, the default is equivalent to [`outneighbors`](@ref);
use [`all_neighbors`](@ref) to list inbound and outbound neighbors.

### Implementation Notes
In some cases might return a reference to the current graph's internal structures,
not a copy. Do not modify result. If the graph is modified, the behavior is undefined:
the array behind this reference may be modified too, but this is not guaranteed.
If you need to modify the result use `collect` or `copy` to create a copy.

# Examples
```jldoctest; filter = r"0-element Graphs\\.FrozenVector\\{Int64\\}|Int64\\[\\]"
julia> using Graphs

julia> g = DiGraph(3);

julia> add_edge!(g, 2, 3);

julia> add_edge!(g, 3, 1);

julia> neighbors(g, 1)
0-element Graphs.FrozenVector{Int64}

julia> neighbors(g, 2)
1-element Graphs.FrozenVector{Int64}:
 3

julia> neighbors(g, 3)
1-element Graphs.FrozenVector{Int64}:
 1
```
"""
neighbors(g::AbstractGraph, v::Integer) = outneighbors(g, v)

"""
    all_neighbors(g, v)

Return a list of all inbound and outbound neighbors of `v` in `g`.
For undirected graphs, this is equivalent to both [`outneighbors`](@ref)
and [`inneighbors`](@ref).

### Implementation Notes
In some cases might return a reference to the current graph's internal structures,
not a copy. Do not modify result. If the graph is modified, the behavior is undefined:
the array behind this reference may be modified too, but this is not guaranteed.
If you need to modify the result use `collect` or `copy` to create a copy.

# Examples
```jldoctest
julia> using Graphs

julia> g = DiGraph(3);

julia> add_edge!(g, 2, 3);

julia> add_edge!(g, 3, 1);

julia> all_neighbors(g, 1)
1-element Vector{Int64}:
 3

julia> all_neighbors(g, 2)
1-element Vector{Int64}:
 3

julia> all_neighbors(g, 3)
2-element Vector{Int64}:
 1
 2
```
"""
function all_neighbors end
@traitfn function all_neighbors(g::::IsDirected, v::Integer)
    return union(outneighbors(g, v), inneighbors(g, v))
end
@traitfn all_neighbors(g::::(!IsDirected), v::Integer) = neighbors(g, v)

"""
    common_neighbors(g, u, v)

Return the neighbors common to vertices `u` and `v` in `g`.

### Implementation Notes
Returns a reference to the current graph's internal structures, not a copy.
Do not modify result. If the graph is modified, the behavior is undefined:
the array behind this reference may be modified too, but this is not guaranteed.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(4);

julia> add_edge!(g, 1, 2);

julia> add_edge!(g, 2, 3);

julia> add_edge!(g, 3, 4);

julia> add_edge!(g, 4, 1);

julia> add_edge!(g, 1, 3);

julia> common_neighbors(g, 1, 3)
2-element Vector{Int64}:
 2
 4

julia> common_neighbors(g, 1, 4)
1-element Vector{Int64}:
 3
```
"""
function common_neighbors(g::AbstractGraph, u::Integer, v::Integer)
    return intersect(neighbors(g, u), neighbors(g, v))
end

"""
    has_self_loops(g)

Return true if `g` has any self loops.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(2);

julia> add_edge!(g, 1, 2);

julia> has_self_loops(g)
false

julia> add_edge!(g, 1, 1);

julia> has_self_loops(g)
true
```
"""
function has_self_loops(g::AbstractGraph)
    return nv(g) == 0 ? false : any(v -> has_edge(g, v, v), vertices(g))
end

"""
    num_self_loops(g)

Return the number of self loops in `g`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(2);

julia> add_edge!(g, 1, 2);

julia> num_self_loops(g)
0

julia> add_edge!(g, 1, 1);

julia> num_self_loops(g)
1
```
"""
num_self_loops(g::AbstractGraph) = nv(g) == 0 ? 0 : sum(v -> has_edge(g, v, v), vertices(g))

"""
    density(g)

Return the density of `g`.
Density is defined as the ratio of the number of actual edges to the
number of possible edges (``|V|×(|V|-1)`` for directed graphs and
``\\frac{|V|×(|V|-1)}{2}`` for undirected graphs).
"""
function density end
@traitfn density(g::::IsDirected) = ne(g) / (nv(g) * (nv(g) - 1))
@traitfn density(g::::(!IsDirected)) = (2 * ne(g)) / (nv(g) * (nv(g) - 1))

"""
    squash(g)

Return a copy of a graph with the smallest practical eltype that
can accommodate all vertices.

May also return the original graph if the eltype does not change.
"""
function squash(g::AbstractGraph)
    deprecation_msg = "squash(::AbstractGraph) is deprecated in favor of methods that specialize on the graph type."
    Base.depwarn(deprecation_msg, :squash; force=true)

    gtype = is_directed(g) ? DiGraph : Graph
    validtypes = [UInt8, UInt16, UInt32, UInt64, Int64]
    nvg = nv(g)
    for T in validtypes
        nvg < typemax(T) && return gtype{T}(g)
    end
end

"""
    weights(g)

Return the weights of the edges of a graph `g` as a matrix. Defaults
to [`Graphs.DefaultDistance`](@ref).

### Implementation Notes
In general, referencing the weight of a nonexistent edge is undefined behavior. Do not rely on the `weights` matrix
as a substitute for the graph's [`adjacency_matrix`](@ref).
"""
weights(g::AbstractGraph) = DefaultDistance(nv(g))

# TODO we cannot run the test here with GenericGraph yet,
# as the functions don't work for arbitrary graphs yet.

@testset "Cycles" begin
    rng = StableRNG(1)
    completedg = complete_digraph(4)
    pathdg = path_digraph(5)
    triangle = random_regular_graph(3, 2; rng=rng)
    quadrangle = random_regular_graph(4, 2; rng=rng)
    pentagon = random_regular_graph(5, 2; rng=rng)

    @testset "path digraph" for g in testgraphs(pathdg)
        @test maxsimplecycles(g) == 0
        @test maxsimplecycles(g, false) == 84
        @test simplecyclescount(g) == 0
        @test length(simplecycles(g)) == 0
        @test isempty(simplecycles(g)) == true
        @test isempty(simplecycles_iter(g)) == true
        @test simplecycleslength(g) == (zeros(5), 0)
        @test simplecyclescount(g, 10) == 0
        @test isempty(simplecycles_iter(g, 10)) == true
        @test simplecycleslength(g, 10) == (zeros(5), 0)
    end

    @testset "maxsimplecycles(4)" begin
        @test maxsimplecycles(4) == 20
    end

    @testset "complete digraph" for g in testgraphs(completedg)
        @test maxsimplecycles(g) == 20
        @test length(simplecycles(g)) == 20
        @test simplecycles(g) == @inferred(simplecycles_iter(g))
        @test simplecyclescount(g) == 20
        @test simplecycleslength(g) == ([0, 6, 8, 6], 20)
        @test simplecyclescount(g, 10) == 10
        @test simplecycleslength(g, 10)[2] == 10
    end

    @testset "triangle" for g in testgraphs(triangle)
        trianglelengths, triangletotal = simplecycleslength(DiGraph(g))
        @test sum(trianglelengths) == triangletotal
    end

    @testset "quadrangle" for g in testgraphs(quadrangle)
        quadranglelengths, quadrangletotal = simplecycleslength(DiGraph(g))
        @test sum(quadranglelengths) == quadrangletotal
        @test simplecycles(DiGraph(g)) == @inferred(simplecycles_iter(DiGraph(g)))
    end

    @testset "pentagon" for g in testgraphs(pentagon)
        pentagonlengths, pentagontotal = simplecycleslength(DiGraph(g))
        @test sum(pentagonlengths) == pentagontotal
    end

    selfloopg = DiGraph([
        0 1 0 0
        0 0 1 0
        1 0 1 0
        0 0 0 1
    ])

    @testset "self loops" for g in testgraphs(selfloopg)
        cycles = simplecycles(g)
        @test [3] in cycles
        @test [4] in cycles
        @test [1, 2, 3] in cycles || [2, 3, 1] in cycles || [3, 1, 2] in cycles
        @test length(cycles) == 3

        cycles2 = simplecycles_iter(g)
        @test [3] in cycles2
        @test [4] in cycles2
        @test [1, 2, 3] in cycles2 || [2, 3, 1] in cycles2 || [3, 1, 2] in cycles2
        @test length(cycles2) == 3
    end
end

@testset "Minimal Dominating Set" begin
    g0 = SimpleGraph(0)
    for g in testgraphs(g0)
        for parallel in [:threads, :distributed]
            d = @inferred(
                Parallel.dominating_set(
                    g, 4, MinimalDominatingSet(); parallel=parallel, rng=StableRNG(0)
                )
            )
            @test isempty(d)
        end
    end

    g1 = SimpleGraph(1)
    for g in testgraphs(g1)
        for parallel in [:threads, :distributed]
            d = @inferred(
                Parallel.dominating_set(
                    g, 4, MinimalDominatingSet(); parallel=parallel, rng=StableRNG(0)
                )
            )
            @test (d == [1])

            add_edge!(g, 1, 1)
            d = @inferred(
                Parallel.dominating_set(
                    g, 4, MinimalDominatingSet(); parallel=parallel, rng=StableRNG(0)
                )
            )
            @test (d == [1])
        end
    end

    g3 = star_graph(5)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g3)
            d = @inferred(
                Parallel.dominating_set(
                    g, 4, MinimalDominatingSet(); parallel=parallel, rng=StableRNG(0)
                )
            )
            @test (length(d) == 1 || (length(d) == 4 && minimum(d) > 1))
        end
    end

    g4 = complete_graph(5)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g4)
            d = @inferred(
                Parallel.dominating_set(
                    g, 4, MinimalDominatingSet(); parallel=parallel, rng=StableRNG(0)
                )
            )
            @test length(d) == 1 # Exactly one vertex
        end
    end

    g5 = path_graph(4)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g5)
            d = @inferred(
                Parallel.dominating_set(
                    g, 4, MinimalDominatingSet(); parallel=parallel, rng=StableRNG(0)
                )
            )
            sort!(d)
            @test (
                d == [1, 2, 4] || d == [1, 3] || d == [1, 4] || d == [2, 3] || d == [2, 4]
            )
        end
    end

    add_edge!(g5, 2, 2)
    add_edge!(g5, 3, 3)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g5)
            d = @inferred(
                Parallel.dominating_set(
                    g, 4, MinimalDominatingSet(); parallel=parallel, rng=StableRNG(0)
                )
            )
            sort!(d)
            @test (
                d == [1, 2, 4] || d == [1, 3] || d == [1, 4] || d == [2, 3] || d == [2, 4]
            )
        end
    end
end

# Parts of this code were taken / derived from Graphs.jl. See LICENSE for
# licensing details.

# A* shortest-path algorithm

function reconstruct_path!(
    total_path, # a vector to be filled with the shortest path
    came_from, # a vector holding the parent of each node in the A* exploration
    end_idx, # the end vertex
    g,  # the graph
    edgetype_to_return::Type{E}=edgetype(g),
) where {E<:AbstractEdge}
    curr_idx = end_idx
    while came_from[curr_idx] != curr_idx
        pushfirst!(total_path, edgetype_to_return(came_from[curr_idx], curr_idx))
        curr_idx = came_from[curr_idx]
    end
end

function a_star_impl!(
    g, # the graph
    goal, # the end vertex
    open_set, # an initialized heap containing the active vertices
    closed_set, # an (initialized) color-map to indicate status of vertices
    g_score, # a vector holding g scores for each node
    came_from, # a vector holding the parent of each node in the A* exploration
    distmx,
    heuristic,
    edgetype_to_return::Type{E},
) where {E<:AbstractEdge}
    total_path = Vector{edgetype_to_return}()

    @inbounds while !isempty(open_set)
        current = popfirst!(open_set).first

        if current == goal
            reconstruct_path!(total_path, came_from, current, g, edgetype_to_return)
            return total_path
        end

        closed_set[current] = true

        for neighbor in Graphs.outneighbors(g, current)
            closed_set[neighbor] && continue

            tentative_g_score = g_score[current] + distmx[current, neighbor]

            if tentative_g_score < g_score[neighbor]
                g_score[neighbor] = tentative_g_score
                priority = tentative_g_score + heuristic(neighbor)
                open_set[neighbor] = priority
                came_from[neighbor] = current
            end
        end
    end
    return total_path
end

"""
    a_star(g, s, t[, distmx][, heuristic][, edgetype_to_return])

Compute a shortest path using the [A* search algorithm](http://en.wikipedia.org/wiki/A%2A_search_algorithm).

Return a vector of edges.

# Arguments
- `g::AbstractGraph`: the graph
- `s::Integer`: the source vertex
- `t::Integer`: the target vertex
- `distmx::AbstractMatrix`: an optional (possibly sparse) `n × n` matrix of edge weights. It is set to `weights(g)` by default (which itself falls back on [`Graphs.DefaultDistance`](@ref)).
- `heuristic`: an optional function mapping each vertex to a lower estimate of the remaining distance from `v` to `t`. It is set to `v -> 0` by default (which corresponds to Dijkstra's algorithm). Note that the heuristic values should have the same type as the edge weights!
- `edgetype_to_return::Type{E}`: the type `E<:AbstractEdge` of the edges in the return vector. It is set to `edgetype(g)` by default. Note that the two-argument constructor `E(u, v)` must be defined, even for weighted edges: if it isn't, consider using `E = Graphs.SimpleEdge`.

!!! warning
    Since a two-argument edge constructor `E(u, v)` is used to construct the path, metadata associated with the edge (like its weight) will be lost in the result. You might need to code a post-processing step yourself.
"""
function a_star(
    g::AbstractGraph{U},  # the g
    s::Integer,                       # the start vertex
    t::Integer,                       # the end vertex
    distmx::AbstractMatrix{T}=weights(g),
    heuristic=n -> zero(T),
    edgetype_to_return::Type{E}=edgetype(g),
) where {T,U,E<:AbstractEdge}
    # if we do checkbounds here, we can use @inbounds in a_star_impl!
    checkbounds(distmx, Base.OneTo(nv(g)), Base.OneTo(nv(g)))

    open_set = PriorityQueue{U,T}()
    push!(open_set, s => 0)

    closed_set = zeros(Bool, nv(g))

    g_score = fill(Inf, nv(g))
    g_score[s] = 0

    came_from = fill(-one(s), nv(g))
    came_from[s] = s

    return a_star_impl!(
        g,
        t,
        open_set,
        closed_set,
        g_score,
        came_from,
        distmx,
        heuristic,
        edgetype_to_return,
    )
end

"""
    rich_club(g, k)

Return the non-normalised [rich-club coefficient](https://en.wikipedia.org/wiki/Rich-club_coefficient) of graph `g`,
with degree cut-off `k`.

```jldoctest
julia> using Graphs

julia> g = star_graph(5)
{5, 4} undirected simple Int64 graph

julia> rich_club(g, 1)
0.4
```
"""
function rich_club(g::AbstractGraph{T}, k::Int) where {T}
    E = zero(T)
    for e in edges(g)
        if (outdegree(g, src(e)) >= k) && (indegree(g, dst(e)) >= k)
            E += 1
        end
    end
    N = count(degree(g) .>= k)
    if is_directed(g)
        return E / (N * (N - 1))
    else
        return 2 * E / (N * (N - 1))
    end
end

@testset "Degree" begin
    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)
    for g in test_generic_graphs(g5)
        @test @inferred(degree_centrality(g)) ==
            [0.6666666666666666, 0.6666666666666666, 1.0, 0.3333333333333333]
        @test @inferred(indegree_centrality(g, normalize=false)) == [0.0, 1.0, 2.0, 1.0]
        @test @inferred(outdegree_centrality(g; normalize=false)) == [2.0, 1.0, 1.0, 0.0]
    end
end

"""
	planar_maximally_filtered_graph(g)

Compute the Planar Maximally Filtered Graph (PMFG) of weighted graph `g`. Returns a `SimpleGraph{eltype(g)}`.

### Examples
```
using Graphs, SimpleWeightedGraphs
N = 20
M = Symmetric(randn(N, N))
g = SimpleWeightedGraph(M) 
p_g = planar_maximally_filtered_graph(g)
```

### References 
- [Tuminello et al. 2005](https://doi.org/10.1073/pnas.0500298102)
"""
function planar_maximally_filtered_graph(
    g::AG, distmx::AbstractMatrix{T}=weights(g); minimize=true
) where {T<:Real,U,AG<:AbstractGraph{U}}

    #if graph has <= 6 edges, just return it
    if ne(g) <= 6
        test_graph = SimpleGraph{U}(nv(g))
        for e in edges(g)
            add_edge!(test_graph, e)
        end
        return test_graph
    end

    #construct a list of edge weights
    edge_list = collect(edges(g))
    weights = [distmx[src(e), dst(e)] for e in edge_list]
    #sort the set of edges by weight
    #we try to maximally filter the graph and assume that weights
    #represent distances. Thus we want to add edges with the 
    #smallest distances first. We sort edges in ascending order
    #of weight (if minimize=true) and iterate from the start of
    #the list.
    edge_list .= edge_list[sortperm(weights; rev=(!minimize))]

    #construct an initial graph
    test_graph = SimpleGraph{U}(nv(g))

    for e in edge_list[1:min(6, length(edge_list))]
        #we can always add the first six edges of a graph 
        add_edge!(test_graph, src(e), dst(e))
    end

    #go through the rest of the edge list 
    for e in edge_list[7:end]
        add_edge!(test_graph, src(e), dst(e)) #add it to graph
        if !is_planar(test_graph) #if resulting graph is not planar, remove it again
            rem_edge!(test_graph, src(e), dst(e))
        end
        (ne(test_graph) >= 3 * nv(test_graph) - 6) && break #break if limit reached
    end

    return test_graph
end

module Graphs

using SimpleTraits

### Remove the following line once #915 is closed
using ArnoldiMethod: LM, SR, LR, partialschur, partialeigen
using Statistics: mean

using Inflate: InflateGzipStream
using DataStructures:
    IntDisjointSets,
    PriorityQueue,
    dequeue!,
    dequeue_pair!,
    enqueue!,
    heappop!,
    heappush!,
    in_same_set,
    peek,
    union!,
    find_root!,
    BinaryMaxHeap,
    BinaryMinHeap,
    Stack
using LinearAlgebra: I, Symmetric, diagm, eigen, eigvals, norm, rmul!, tril, triu
import LinearAlgebra: Diagonal, issymmetric, mul!
using Random:
    AbstractRNG,
    GLOBAL_RNG,
    MersenneTwister,
    randperm,
    randsubseq!,
    seed!,
    shuffle,
    shuffle!
using SparseArrays: SparseMatrixCSC, nonzeros, nzrange, rowvals
import SparseArrays: blockdiag, sparse
import Base:
    adjoint,
    write,
    ==,
    <,
    *,
    ≈,
    convert,
    isless,
    issubset,
    union,
    intersect,
    reverse,
    reverse!,
    isassigned,
    getindex,
    setindex!,
    show,
    print,
    copy,
    in,
    sum,
    size,
    eltype,
    length,
    ndims,
    transpose,
    join,
    iterate,
    eltype,
    get,
    Pair,
    Tuple,
    zero

export
    # Interface
    AbstractGraph,
    AbstractEdge,
    AbstractEdgeIter,
    Edge,
    Graph,
    SimpleGraph,
    SimpleGraphFromIterator,
    DiGraph,
    SimpleDiGraphFromIterator,
    SimpleDiGraph,
    vertices,
    edges,
    edgetype,
    nv,
    ne,
    src,
    dst,
    is_directed,
    IsDirected,
    has_vertex,
    has_edge,
    inneighbors,
    outneighbors,

    # core
    is_ordered,
    add_vertices!,
    indegree,
    outdegree,
    degree,
    Δout,
    Δin,
    δout,
    δin,
    Δ,
    δ,
    degree_histogram,
    neighbors,
    all_neighbors,
    common_neighbors,
    has_self_loops,
    num_self_loops,
    density,
    squash,
    weights,

    # simplegraphs
    add_edge!,
    add_vertex!,
    add_vertices!,
    rem_edge!,
    rem_vertex!,
    rem_vertices!,

    # decomposition
    core_number,
    k_core,
    k_shell,
    k_crust,
    k_corona,

    # distance
    eccentricity,
    diameter,
    periphery,
    radius,
    center,

    # distance between graphs
    spectral_distance,
    edit_distance,

    # edit path cost functions
    MinkowskiCost,
    BoundedMinkowskiCost,

    # operators
    complement,
    reverse,
    reverse!,
    blockdiag,
    union,
    intersect,
    difference,
    symmetric_difference,
    join,
    tensor_product,
    cartesian_product,
    crosspath,
    induced_subgraph,
    egonet,
    merge_vertices!,
    merge_vertices,

    # bfs
    gdistances,
    gdistances!,
    bfs_tree,
    bfs_parents,
    has_path,

    # bipartition
    is_bipartite,
    bipartite_map,

    # dfs
    is_cyclic,
    topological_sort_by_dfs,
    dfs_tree,
    dfs_parents,

    # iterators
    DFSIterator,
    BFSIterator,

    # random
    randomwalk,
    self_avoiding_walk,
    non_backtracking_randomwalk,

    # diffusion
    diffusion,
    diffusion_rate,

    # eulerian
    eulerian,

    # all simple paths
    all_simple_paths,

    # coloring
    greedy_color,

    # connectivity
    connected_components,
    strongly_connected_components,
    strongly_connected_components_kosaraju,
    strongly_connected_components_tarjan,
    weakly_connected_components,
    is_connected,
    is_strongly_connected,
    is_weakly_connected,
    period,
    condensation,
    attracting_components,
    neighborhood,
    neighborhood_dists,
    isgraphical,
    isdigraphical,

    # cycles
    simplecycles_hawick_james,
    maxsimplecycles,
    simplecycles,
    simplecycles_iter,
    simplecyclescount,
    simplecycleslength,
    karp_minimum_cycle_mean,
    cycle_basis,
    simplecycles_limited_length,

    # incremental cycles
    IncrementalCycleTracker,
    add_edge_checked!,
    topological_sort,

    # maximum_adjacency_visit
    mincut,
    maximum_adjacency_visit,

    # a-star, dijkstra, bellman-ford, floyd-warshall, desopo-pape, spfa
    a_star,
    dijkstra_shortest_paths,
    bellman_ford_shortest_paths,
    spfa_shortest_paths,
    has_negative_edge_cycle_spfa,
    has_negative_edge_cycle,
    enumerate_paths,
    enumerate_paths!,
    johnson_shortest_paths,
    floyd_warshall_shortest_paths,
    transitiveclosure!,
    transitiveclosure,
    transitivereduction,
    yen_k_shortest_paths,
    desopo_pape_shortest_paths,

    # centrality
    betweenness_centrality,
    closeness_centrality,
    degree_centrality,
    indegree_centrality,
    outdegree_centrality,
    katz_centrality,
    pagerank,
    eigenvector_centrality,
    stress_centrality,
    radiality_centrality,

    # spectral
    adjacency_matrix,
    laplacian_matrix,
    adjacency_spectrum,
    laplacian_spectrum,
    non_backtracking_matrix,
    incidence_matrix,
    Nonbacktracking,
    contract,

    # persistence
    loadgraph,
    loadgraphs,
    savegraph,
    LGFormat,

    # randgraphs
    erdos_renyi,
    expected_degree_graph,
    watts_strogatz,
    newman_watts_strogatz,
    random_regular_graph,
    uniform_tree,
    random_regular_digraph,
    random_configuration_model,
    random_tournament_digraph,
    StochasticBlockModel,
    make_edgestream,
    nearbipartiteSBM,
    blockcounts,
    blockfractions,
    stochastic_block_model,
    barabasi_albert,
    barabasi_albert!,
    static_fitness_model,
    static_scale_free,
    kronecker,
    dorogovtsev_mendes,
    random_orientation_dag,

    # community
    modularity,
    core_periphery_deg,
    local_clustering,
    local_clustering_coefficient,
    global_clustering_coefficient,
    triangles,
    label_propagation,
    maximal_cliques,
    clique_percolation,
    assortativity,
    rich_club,

    # generators
    complete_graph,
    star_graph,
    path_graph,
    wheel_graph,
    cycle_graph,
    complete_bipartite_graph,
    complete_multipartite_graph,
    turan_graph,
    complete_digraph,
    star_digraph,
    path_digraph,
    grid,
    wheel_digraph,
    cycle_digraph,
    binary_tree,
    double_binary_tree,
    roach_graph,
    clique_graph,
    ladder_graph,
    circular_ladder_graph,
    barbell_graph,
    lollipop_graph,

    # generator deprecations
    BullGraph,
    ChvatalGraph,
    CubicalGraph,
    DesarguesGraph,
    DiamondGraph,
    DodecahedralGraph,
    FruchtGraph,
    HeawoodGraph,
    HouseGraph,
    HouseXGraph,
    IcosahedralGraph,
    KarateGraph,
    KrackhardtKiteGraph,
    MoebiusKantorGraph,
    OctahedralGraph,
    PappusGraph,
    PetersenGraph,
    SedgewickMazeGraph,
    TetrahedralGraph,
    TruncatedCubeGraph,
    TruncatedTetrahedronGraph,
    TruncatedTetrahedronDiGraph,
    TutteGraph,
    CompleteGraph,
    CompleteBipartiteGraph,
    CompleteMultipartiteGraph,
    TuranGraph,
    CompleteDiGraph,
    StarGraph,
    StarDigraph,
    PathGraph,
    PathDiGraph,
    CycleGraph,
    CycleDiGraph,
    WheelGraph,
    WheelDiGraph,
    Grid,
    BinaryTree,
    Doublebinary_tree,
    RoachGraph,
    CliqueGraph,
    LadderGraph,
    Circularladder_graph,
    BarbellGraph,
    LollipopGraph,

    # smallgraphs
    smallgraph,

    # Euclidean graphs
    euclidean_graph,

    # minimum_spanning_trees
    boruvka_mst,
    kruskal_mst,
    prim_mst,

    # trees and prufer
    is_tree,
    prufer_encode,
    prufer_decode,

    # steinertree
    steiner_tree,

    # biconnectivity and articulation points
    articulation,
    biconnected_components,
    bridges,

    # graphcut
    normalized_cut,
    karger_min_cut,
    karger_cut_cost,
    karger_cut_edges,

    # dominatingset
    dominating_set,

    # independentset
    independent_set,

    # vertexcover
    vertex_cover,

    # longestpaths
    dag_longest_path

"""
    Graphs

An optimized graphs package.

Simple graphs (not multi- or hypergraphs) are represented in a memory- and
time-efficient manner with adjacency lists and edge sets. Both directed and
undirected graphs are supported via separate types, and conversion is available
from directed to undirected.

The project goal is to mirror the functionality of robust network and graph
analysis libraries such as NetworkX while being simple to use and efficient.
It is an explicit design decision that any data not required for graph manipulation
(attributes and other information, for example) is expected to be stored
outside of the graph structure itself. Such data lends itself to storage in
more traditional and better-optimized mechanisms.

[Full documentation](https://juliagraphs.org/Graphs.jl/stable/) is available,
and tutorials are available at the
[JuliaGraphsTutorials repository](https://github.com/JuliaGraphs/JuliaGraphsTutorials).
"""
Graphs
include("interface.jl")
include("utils.jl")
include("deprecations.jl")
include("core.jl")

include("SimpleGraphs/SimpleGraphs.jl")
using .SimpleGraphs
"""
    Graph

A datastruture representing an undirected graph.
"""
const Graph = Graphs.SimpleGraphs.SimpleGraph
"""
    DiGraph

A datastruture representing a directed graph.
"""
const DiGraph = Graphs.SimpleGraphs.SimpleDiGraph
"""
    Edge

A datastruture representing an edge between two vertices in
a `Graph` or `DiGraph`.
"""
const Edge = Graphs.SimpleGraphs.SimpleEdge

include("degeneracy.jl")
include("digraph/transitivity.jl")
include("cycles/johnson.jl")
include("cycles/hawick-james.jl")
include("cycles/karp.jl")
include("cycles/basis.jl")
include("cycles/limited_length.jl")
include("cycles/incremental.jl")
include("traversals/bfs.jl")
include("traversals/bipartition.jl")
include("traversals/greedy_color.jl")
include("traversals/dfs.jl")
include("traversals/maxadjvisit.jl")
include("traversals/randomwalks.jl")
include("traversals/diffusion.jl")
include("iterators/bfs.jl")
include("iterators/dfs.jl")
include("traversals/eulerian.jl")
include("traversals/all_simple_paths.jl")
include("connectivity.jl")
include("distance.jl")
include("editdist.jl")
include("shortestpaths/utils.jl")
include("shortestpaths/astar.jl")
include("shortestpaths/bellman-ford.jl")
include("shortestpaths/dijkstra.jl")
include("shortestpaths/johnson.jl")
include("shortestpaths/desopo-pape.jl")
include("shortestpaths/floyd-warshall.jl")
include("shortestpaths/yen.jl")
include("shortestpaths/spfa.jl")
include("shortestpaths/longest_path.jl")
include("linalg/LinAlg.jl")
include("operators.jl")
include("persistence/common.jl")
include("persistence/lg.jl")
include("centrality/betweenness.jl")
include("centrality/closeness.jl")
include("centrality/stress.jl")
include("centrality/degree.jl")
include("centrality/katz.jl")
include("centrality/pagerank.jl")
include("centrality/eigenvector.jl")
include("centrality/radiality.jl")
include("community/modularity.jl")
include("community/label_propagation.jl")
include("community/core-periphery.jl")
include("community/clustering.jl")
include("community/cliques.jl")
include("community/clique_percolation.jl")
include("community/assortativity.jl")
include("community/rich_club.jl")
include("spanningtrees/boruvka.jl")
include("spanningtrees/kruskal.jl")
include("spanningtrees/prim.jl")
include("trees/prufer.jl")
include("steinertree/steiner_tree.jl")
include("biconnectivity/articulation.jl")
include("biconnectivity/biconnect.jl")
include("biconnectivity/bridge.jl")
include("graphcut/normalized_cut.jl")
include("graphcut/karger_min_cut.jl")
include("dominatingset/degree_dom_set.jl")
include("dominatingset/minimal_dom_set.jl")
include("independentset/degree_ind_set.jl")
include("independentset/maximal_ind_set.jl")
include("vertexcover/degree_vertex_cover.jl")
include("vertexcover/random_vertex_cover.jl")
include("Experimental/Experimental.jl")
include("Parallel/Parallel.jl")
include("Test/Test.jl")

using .LinAlg
end # module

export MaximalIndependentSet

struct MaximalIndependentSet end

"""
    independent_set(g, MaximalIndependentSet(); rng=nothing, seed=nothing)

Find a random set of vertices that are independent (no two vertices are adjacent to each other) and 
it is not possible to insert a vertex into the set without sacrificing the independence property.

### Implementation Notes
Performs [Approximate Maximum Independent Set](https://en.wikipedia.org/wiki/Maximal_independent_set#Sequential_algorithm) once.
Returns a vector of vertices representing the vertices in the independent set.

### Performance
Runtime: O(|V|+|E|)
Memory: O(|V|)
Approximation Factor: maximum(degree(g))+1

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- If `seed >= 0`, a random generator is seeded with this value.
"""
function independent_set(
    g::AbstractGraph{T},
    alg::MaximalIndependentSet;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    rng = rng_from_rng_or_seed(rng, seed)
    nvg = nv(g)
    ind_set = Vector{T}()
    sizehint!(ind_set, nvg)
    deleted = falses(nvg)

    for v in randperm(rng, nvg)
        (deleted[v] || has_edge(g, v, v)) && continue

        deleted[v] = true
        push!(ind_set, v)
        deleted[neighbors(g, v)] .= true
    end

    return ind_set
end

@testset "Planarity tests" begin
    @testset "LRP constructor tests" begin
        function lrp_constructor_test(g)
            try
                lrp = Graphs.LRPlanarity(g)
                return true
            catch e
                return false
            end
        end
        g = SimpleGraph(10, 10)
        @test lrp_constructor_test(g)
        g = SimpleGraph{Int8}(10, 10)
        @test lrp_constructor_test(g)
    end

    @testset "DFS orientation tests" begin
        dfs_test_edges = [
            (1, 2),
            (1, 4),
            (1, 6),
            (2, 3),
            (2, 4),
            (2, 5),
            (3, 5),
            (3, 6),
            (4, 5),
            (4, 6),
            (5, 6),
        ]

        dfs_g = Graph(6)
        for edge in dfs_test_edges
            add_edge!(dfs_g, edge)
        end

        self = Graphs.LRPlanarity(dfs_g)
        #want to test dfs orientation 
        # make adjacency lists for dfs
        for v in 1:(self.V) #for all vertices in G,
            self.adjs[v] = neighbors(dfs_g, v) ##neighbourhood of v
        end
        T = eltype(dfs_g)

        # orientation of the graph by depth first search traversal
        for v in 1:(self.V)
            if self.height[v] == -one(T) #using -1 rather than nothing for type stability. 
                self.height[v] = zero(T)
                push!(self.roots, v)
                Graphs.dfs_orientation!(self, v)
            end
        end

        #correct data
        parent_edges = Dict([
            (1, Edge(0, 0)),
            (2, Edge(1, 2)),
            (3, Edge(2, 3)),
            (4, Edge(5, 4)),
            (5, Edge(3, 5)),
            (6, Edge(4, 6)),
        ])

        @test parent_edges == self.parent_edge

        correct_heights = Dict([(1, 0), (2, 1), (3, 2), (4, 4), (5, 3), (6, 5)])

        @test correct_heights == self.height
    end

    @testset "Planarity results" begin
        #Construct example planar graph
        planar_edges = [
            (1, 2), (1, 3), (2, 4), (2, 7), (3, 4), (3, 5), (4, 6), (4, 7), (5, 6)
        ]

        g = Graph(7)

        for edge in planar_edges
            add_edge!(g, edge)
        end

        @test is_planar(g) == true

        #another planar graph 
        cl = circular_ladder_graph(8)
        @test is_planar(cl) == true

        # one more planar graph 
        w = wheel_graph(10)
        @test is_planar(w) == true

        #Construct some non-planar graphs
        g = complete_graph(10)
        @test is_planar(g) == false

        petersen = smallgraph(:petersen)
        @test is_planar(petersen) == false

        d = smallgraph(:desargues)
        @test is_planar(d) == false

        h = smallgraph(:heawood)
        @test is_planar(h) == false

        mb = smallgraph(:moebiuskantor)
        @test is_planar(mb) == false

        #Directed, planar example
        dg = SimpleDiGraphFromIterator([Edge(1, 2), Edge(2, 3), Edge(3, 1)])

        @test is_planar(dg) == true
    end

    @testset "ManualDict tests" begin
        md = Graphs.ManualDict(Int64, Int64, 0)
        @test md[0] == 0
        md[0] = 1
        @test md[0] == 1
    end
end

"""
    all_simple_paths(g, u, v; cutoff)  --> Graphs.SimplePathIterator
    all_simple_paths(g, u, vs; cutoff) --> Graphs.SimplePathIterator

Returns an iterator that generates all 
[simple paths](https://en.wikipedia.org/wiki/Path_(graph_theory)#Walk,_trail,_and_path) in 
the graph `g` from a source vertex `u` to a target vertex `v` or iterable of target vertices
`vs`. A simple path has no repeated vertices.

The iterator's elements (i.e., the paths) can be materialized via `collect` or `iterate`.
Paths are iterated in the order of a depth-first search.

If the requested path has identical source and target vertices, i.e., if `u = v`, a
zero-length path `[u]` is included among the iterates.

## Keyword arguments
The maximum path length (i.e., number of edges) is limited by the keyword argument `cutoff`
(default, `nv(g)-1`). If a path's path length is greater than `cutoff`, it is
omitted.

## Examples
```jldoctest allsimplepaths; setup = :(using Graphs)
julia> g = complete_graph(4);

julia> spi = all_simple_paths(g, 1, 4)
SimplePathIterator{SimpleGraph{Int64}}(1 → 4)

julia> collect(spi)
5-element Vector{Vector{Int64}}:
 [1, 2, 3, 4]
 [1, 2, 4]
 [1, 3, 2, 4]
 [1, 3, 4]
 [1, 4]
```
We can restrict the search to path lengths less than or equal to a specified cut-off (here, 
2 edges):
```jldoctest allsimplepaths; setup = :(using Graphs)
julia> collect(all_simple_paths(g, 1, 4; cutoff=2))
3-element Vector{Vector{Int64}}:
 [1, 2, 4]
 [1, 3, 4]
 [1, 4]
```
"""
function all_simple_paths(
    g::AbstractGraph{T}, u::T, vs; cutoff::T=nv(g) - one(T)
) where {T<:Integer}
    vs = vs isa Set{T} ? vs : Set{T}(vs)
    return SimplePathIterator(g, u, vs, cutoff)
end

# iterator over all simple paths from `u` to `vs` in `g` of length less than `cutoff`
struct SimplePathIterator{T<:Integer,G<:AbstractGraph{T}}
    g::G
    u::T       # start vertex
    vs::Set{T} # target vertices
    cutoff::T  # max length of resulting paths
end

function Base.show(io::IO, spi::SimplePathIterator)
    print(io, "SimplePathIterator{", typeof(spi.g), "}(", spi.u, " → ")
    if length(spi.vs) == 1
        print(io, only(spi.vs))
    else
        print(io, '[')
        join(io, spi.vs, ", ")
        print(io, ']')
    end
    print(io, ')')
    return nothing
end
Base.IteratorSize(::Type{<:SimplePathIterator}) = Base.SizeUnknown()
Base.eltype(::SimplePathIterator{T}) where {T} = Vector{T}

mutable struct SimplePathIteratorState{T<:Integer}
    stack::Stack{Tuple{T,T}} # used to restore iteration of child vertices: elements are ↩
    # (parent vertex, index of children)
    visited::Stack{T}         # current path candidate
    queued::Vector{T}         # remaining targets if path length reached cutoff
    self_visited::Bool        # in case `u ∈ vs`, we want to return a `[u]` path once only
end
function SimplePathIteratorState(spi::SimplePathIterator{T}) where {T<:Integer}
    stack = Stack{Tuple{T,T}}()
    visited = Stack{T}()
    queued = Vector{T}()
    push!(visited, spi.u)    # add a starting vertex to the path candidate
    push!(stack, (spi.u, one(T))) # add a child node with index 1
    return SimplePathIteratorState{T}(stack, visited, queued, false)
end

function _stepback!(state::SimplePathIteratorState) # updates iterator state.
    pop!(state.stack)
    pop!(state.visited)
    return nothing
end

# iterates to the next simple path in `spi`, according to a depth-first search
function Base.iterate(
    spi::SimplePathIterator{T}, state::SimplePathIteratorState=SimplePathIteratorState(spi)
) where {T<:Integer}
    while !isempty(state.stack)
        if !isempty(state.queued) # consume queued targets
            target = pop!(state.queued)
            result = vcat(reverse(collect(state.visited)), target)
            if isempty(state.queued)
                _stepback!(state)
            end
            return result, state
        end

        parent_node, next_child_index = first(state.stack)
        children = outneighbors(spi.g, parent_node)
        if length(children) < next_child_index
            _stepback!(state) # all children have been checked, step back
            continue
        end

        child = children[next_child_index]
        next_child_index_tmp = pop!(state.stack)[2]                      # move child ↩ 
        push!(state.stack, (parent_node, next_child_index_tmp + one(T))) # index forward
        child in state.visited && continue

        if length(state.visited) == spi.cutoff
            # collect adjacent targets if more exist and add them to queue
            rest_children = Set(children[next_child_index:end])
            state.queued = collect(
                setdiff(intersect(spi.vs, rest_children), Set(state.visited))
            )

            if isempty(state.queued)
                _stepback!(state)
            end
        else
            result = if child in spi.vs
                vcat(reverse(collect(state.visited)), child)
            else
                nothing
            end

            # update state variables
            push!(state.visited, child) # move to child vertex
            if !isempty(setdiff(spi.vs, state.visited)) # expand stack until all targets are found
                push!(state.stack, (child, one(T))) # add the child node as a parent for next iteration
            else
                pop!(state.visited) # step back and explore the remaining child nodes
            end

            if !isnothing(result) # found a new path, return it
                return result, state
            end
        end
    end

    # special-case: when `vs` includes `u`, return also a 1-vertex, 0-length path `[u]`
    if spi.u in spi.vs && !state.self_visited
        state.self_visited = true
        return [spi.u], state
    end
end

@testset "Utils" begin
    rng = StableRNG(1)
    s = @inferred(Graphs.sample!(rng, [1:10;], 3))
    @test length(s) == 3
    for e in s
        @test 1 <= e <= 10
    end

    s = @inferred(Graphs.sample!(rng, [1:10;], 6, exclude=[1, 2]))
    @test length(s) == 6
    for e in s
        @test 3 <= e <= 10
    end

    s = @inferred(Graphs.sample(1:10, 6, exclude=[1, 2], rng=rng))
    @test length(s) == 6
    for e in s
        @test 3 <= e <= 10
    end

    # tests if isbounded has the correct behaviour
    bounded_int_types = [
        Int8, Int16, Int32, Int64, Int128, UInt8, UInt16, UInt32, UInt64, UInt128, Int, Bool
    ]
    unbounded_int_types = [BigInt, Signed, Unsigned, Integer, Union{Int8,UInt8}]
    for T in bounded_int_types
        @test Graphs.isbounded(T) == true
        @test Graphs.isbounded(T(0)) == true
    end
    for T in unbounded_int_types
        @test Graphs.isbounded(T) == false
        if isconcretetype(T)
            @test Graphs.isbounded(T(0)) == false
        end
    end

    @testset "rng_from_rng_or_seed" begin
        @test Graphs.rng_from_rng_or_seed(nothing, nothing) === Random.GLOBAL_RNG
        @test Graphs.rng_from_rng_or_seed(nothing, -10) === Random.GLOBAL_RNG
        @test Graphs.rng_from_rng_or_seed(nothing, 456) == Graphs.getRNG(456)
        if ismutable(Random.GLOBAL_RNG)
            @test Graphs.rng_from_rng_or_seed(nothing, 456) !== Random.GLOBAL_RNG
        end
        rng = Random.MersenneTwister(789)
        @test Graphs.rng_from_rng_or_seed(rng, nothing) === rng
        @test_throws ArgumentError Graphs.rng_from_rng_or_seed(rng, -1)
    end

    A = [false, true, false, false, true, true]
    @test findall(A) == Graphs.findall!(A, Vector{Int16}(undef, 6))[1:3]
end

@testset "Unweighted Contiguous Partition" begin
    p = @inferred(Graphs.unweighted_contiguous_partition(4, 2))
    @test p == [1:2, 3:4]

    p = @inferred(Graphs.unweighted_contiguous_partition(10, 3))
    @test p == [1:3, 4:6, 7:10]

    p = @inferred(Graphs.unweighted_contiguous_partition(4, 4))
    @test p == [1:1, 2:2, 3:3, 4:4]
end

@testset "Greedy Contiguous Partition" begin
    p = @inferred(Graphs.greedy_contiguous_partition([1, 1, 1, 3], 2))
    @test p == [1:3, 4:4]

    p = @inferred(Graphs.greedy_contiguous_partition([1, 2, 3, 4, 5, 100, 1, 3, 1, 1], 3))
    @test p == [1:5, 6:6, 7:10]

    p = @inferred(Graphs.greedy_contiguous_partition([1, 1, 1, 1], 4))
    @test p == [1:1, 2:2, 3:3, 4:4]
end

@testset "Optimal Contiguous Partition" begin
    p = @inferred(Graphs.optimal_contiguous_partition([1, 1, 1, 3], 2))
    @test p == [1:3, 4:4]

    p = @inferred(Graphs.optimal_contiguous_partition([1, 2, 3, 4, 5, 100, 1, 3, 1, 1], 3))
    @test p == [1:5, 6:6, 7:10]

    p = @inferred(Graphs.optimal_contiguous_partition([1, 1, 1, 1], 4))
    @test p == [1:1, 2:2, 3:3, 4:4]
end

@testset "collect_if_not_vector" begin
    vectors = [["ab", "cd"], 1:2:9, BitVector([0, 1, 0])]
    not_vectors = [Set([1, 2]), (x for x in Int8[3, 4]), "xyz"]

    @testset "identitcal if vector" for v in vectors
        @test Graphs.collect_if_not_vector(v) === v
    end

    @testset "not identical if not vector" for v in not_vectors
        @test Graphs.collect_if_not_vector(v) !== v
    end

    @testset "collected if not vector" for v in not_vectors
        actual = Graphs.collect_if_not_vector(v)
        expected = collect(v)
        @test typeof(actual) == typeof(expected)
        @test actual == expected
    end
end

function _harmonize_type(g::AbstractGraph{T}, c::Vector{S}) where {T,S<:Integer}
    return convert(Vector{T}, c)
end

@testset "Tree utilities" begin
    t1 = Graph(6)
    for e in [(1, 4), (2, 4), (3, 4), (4, 5), (5, 6)]
        add_edge!(t1, e...)
    end
    code = [4, 4, 4, 5]

    t2 = path_graph(2)
    t3 = star_graph(10)
    t4 = binary_tree(3)

    f1 = Graph(8, 0) #forest with 4 tree components
    for e in [(1, 2), (2, 3), (4, 5), (6, 7)]
        add_edge!(f1, e...)
    end

    g1 = cycle_graph(8)
    g2 = complete_graph(4)
    g3 = Graph(1, 0)
    g4 = Graph(2, 0)
    g5 = Graph(1, 0)
    add_edge!(g5, 1, 1) # loop

    d1 = cycle_digraph(5)
    d2 = path_digraph(5)
    d3 = DiGraph(2)
    add_edge!(d3, 1, 2)
    add_edge!(d3, 2, 1)

    @testset "tree_check" begin
        for t in testgraphs(t1, t2, t3, t4, g3)
            @test is_tree(t)
        end
        for g in testgraphs(g1, g2, g4, g5, f1)
            @test !is_tree(g)
        end
        for g in testgraphs(d1, d2, d3)
            @test_throws MethodError is_tree(g)
        end
    end

    @testset "encode/decode" begin
        @test prufer_decode(code) == t1
        @test prufer_encode(t1) == code
        for g in testgraphs(t2, t3, t4)
            ret_code = prufer_encode(g)
            @test prufer_decode(ret_code) == g
        end
    end

    @testset "errors" begin
        b1 = [5, 8, 10, 1, 2]
        b2 = [0.5, 1.1]
        @test_throws ArgumentError prufer_decode(b1)
        @test_throws MethodError prufer_decode(b2)

        for g in testgraphs(g1, g2, g3, g4, g5, f1)
            @test_throws ArgumentError prufer_encode(g)
        end

        for g in testgraphs(d1, d2, d3)
            @test_throws MethodError prufer_encode(g)
        end
    end
end

@testset "Edit distance" begin
    rng = StableRNG(1)
    gtri = random_regular_graph(3, 2; rng=rng)
    gquad = random_regular_graph(4, 2; rng=rng)
    gpent = random_regular_graph(5, 2; rng=rng)

    g1 = star_graph(4)
    g2 = cycle_graph(3)

    vertex_insert_cost = v -> 1.0
    vertex_delete_cost = v -> 2.0
    vertex_subst_cost = (u, v) -> 3.0
    edge_insert_cost = e -> 4.0
    edge_delete_cost = e -> 5.0
    edge_subst_cost = (e1, e2) -> 6.0

    @testset "undirected edit_distance" for G1 in test_generic_graphs(g1),
        G2 in test_generic_graphs(g2)

        d, λ = @inferred(edit_distance(G1, G2))
        @test d == 2.0
        d, λ = @inferred(
            edit_distance(
                G1,
                G2,
                vertex_insert_cost=vertex_insert_cost,
                vertex_delete_cost=vertex_delete_cost,
                vertex_subst_cost=vertex_subst_cost,
                edge_insert_cost=edge_insert_cost,
                edge_delete_cost=edge_delete_cost,
                edge_subst_cost=edge_subst_cost,
            )
        )
        # 1 vertex deletion, 3 vertex substitution, 1 edge insertio n, 1 edge deletion, 2 edge substitution
        @test d == 32.0
    end

    g1 = DiGraph(4)
    edges = [(1, 2), (1, 4), (2, 3), (3, 1), (3, 4), (4, 1), (1, 1), (4, 4)]
    for e in edges
        add_edge!(g1, e)
    end
    g2 = DiGraph(4)
    edges = [(2, 1), (2, 3), (3, 1), (3, 2), (4, 1), (4, 2), (2, 2), (3, 3)]
    for e in edges
        add_edge!(g2, e)
    end

    @testset "directed edit_distance" for G1 in test_generic_graphs(g1),
        G2 in test_generic_graphs(g2)

        d, λ = @inferred(edit_distance(G1, G2))
        @test d == 4.0
    end
end

function closeness_centrality(
    g::AbstractGraph,
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    parallel=:distributed,
)
    return if parallel == :distributed
        distr_closeness_centrality(g, distmx; normalize=normalize)
    else
        threaded_closeness_centrality(g, distmx; normalize=normalize)
    end
end

function distr_closeness_centrality(
    g::AbstractGraph, distmx::AbstractMatrix=weights(g); normalize=true
)::Vector{Float64}
    n_v = Int(nv(g))
    closeness = SharedVector{Float64}(n_v)
    fill!(closeness, 0.0)

    @sync @distributed for u in vertices(g)
        if degree(g, u) == 0     # no need to do Dijkstra here
            closeness[u] = 0.0
        else
            d = Graphs.dijkstra_shortest_paths(g, u, distmx).dists
            δ = filter(x -> x != typemax(x), d)
            σ = sum(δ)
            l = length(δ) - 1
            if σ > 0
                closeness[u] = l / σ
                if normalize
                    n = l * 1.0 / (n_v - 1)
                    closeness[u] *= n
                end
            else
                closeness[u] = 0.0
            end
        end
    end
    return sdata(closeness)
end

function threaded_closeness_centrality(
    g::AbstractGraph, distmx::AbstractMatrix=weights(g); normalize=true
)::Vector{Float64}
    n_v = Int(nv(g))
    closeness = zeros(Float64, n_v)

    Base.Threads.@threads for u in vertices(g)
        if degree(g, u) == 0     # no need to do Dijkstra here
            closeness[u] = 0.0
        else
            d = Graphs.dijkstra_shortest_paths(g, u, distmx).dists
            δ = filter(x -> x != typemax(x), d)
            σ = sum(δ)
            l = length(δ) - 1
            if σ > 0
                closeness[u] = l / σ
                if normalize
                    n = l * 1.0 / (n_v - 1)
                    closeness[u] *= n
                end
            else
                closeness[u] = 0.0
            end
        end
    end
    return closeness
end

abstract type GraphMorphismProblem end
struct IsomorphismProblem <: GraphMorphismProblem end
struct SubGraphIsomorphismProblem <: GraphMorphismProblem end
struct InducedSubGraphIsomorphismProblem <: GraphMorphismProblem end

"""
    IsomorphismAlgorithm

An abstract type used for method dispatch on isomorphism functions.
"""
abstract type IsomorphismAlgorithm end

"""
    could_have_isomorph(g1, g2)

Run quick test to check if `g1 and `g2` could be isomorphic.

If the result is `false`, then `g1` and `g2` are definitely not isomorphic,
but if the result is `true` this is not guaranteed.

# Examples
```jldoctest
julia> using Graphs

julia> Graphs.Experimental.could_have_isomorph(path_graph(3), star_graph(4))
false

julia> Graphs.Experimental.could_have_isomorph(path_graph(3), star_graph(3))
true
```
"""
function could_have_isomorph(g1::AbstractGraph, g2::AbstractGraph)
    nv(g1) == nv(g2) || return false

    indegs1 = indegree(g1)
    indegs2 = indegree(g2)
    sort!(indegs1)
    sort!(indegs2)
    indegs1 == indegs2 || return false

    if Graphs.is_directed(g1) || Graphs.is_directed(g2)
        outdegs1 = outdegree(g1)
        outdegs2 = outdegree(g2)
        sort!(outdegs1)
        sort!(outdegs2)
        outdegs1 == outdegs2 || return false
    end

    return true
end

"""
    has_induced_subgraphisomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return `true` if the graph `g1` contains a vertex induced subgraph that is isomorphic to `g2`.

### Optional Arguments
- `alg`: The algorithm that is used to find the induced subgraph isomorphism. Can be only
    `VF2()` at the moment.
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> has_induced_subgraphisomorph(complete_graph(5), complete_graph(4))
true
julia> has_induced_subgraphisomorph(complete_graph(5), cycle_graph(4))
false

julia> g1 = path_digraph(3); color1 = [1, 1, 1]
julia> g2 = path_digraph(2); color2 = [1, 2]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> has_induced_subgraphisomorph(g1, g2)
true
julia> has_induced_subgraphisomorph(g1, g2, vertex_relation=color_rel)
false
```
### See also 
[`has_subgraphisomorph`](@ref), [`has_isomorph`](@ref), [`count_induced_subgraphisomorph`](@ref), [`all_induced_subgraphisomorph`](@ref)
"""
function has_induced_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Bool
    return has_induced_subgraphisomorph(
        g1, g2, alg; vertex_relation=vertex_relation, edge_relation=edge_relation
    )
end

"""
    has_subgraphisomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return `true` if the graph `g1` contains a subgraph that is isomorphic to `g2`.

### Optional Arguments
- `alg`: The algorithm that is used to find the induced subgraph isomorphism. Can be only
    `VF2()` at the moment.
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> has_subgraphisomorph(complete_graph(5), complete_graph(4))
true
julia> has_subgraphisomorph(complete_graph(5), cycle_graph(4))
true

julia> g1 = path_digraph(3); color1 = [1, 1, 1]
julia> g2 = path_digraph(2); color2 = [1, 2]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> has_subgraphisomorph(g1, g2)
true
julia> has_subgraphisomorph(g1, g2, vertex_relation=color_rel)
false
```
### See also 
[`has_induced_subgraphisomorph`](@ref), [`has_isomorph`](@ref), [`count_subgraphisomorph`](@ref), [`all_subgraphisomorph`](@ref)
"""
function has_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Bool
    return has_subgraphisomorph(
        g1, g2, alg; vertex_relation=vertex_relation, edge_relation=edge_relation
    )
end

"""
    has_isomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return `true` if the graph `g1` is isomorphic to `g2`.

### Optional Arguments
- `alg`: The algorithm that is used to find the induced subgraph isomorphism. Can be only
    `VF2()` at the moment.
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> has_isomorph(complete_graph(3), cycle_graph(3))
true
julia> has_isomorph(complete_graph(4), cycle_graph(4))
false

julia> g1 = path_digraph(4); color1 = [1, 2, 1, 1]
julia> g2 = path_digraph(4); color2 = [1, 2, 2, 1]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> has_isomorph(g1, g2)
true
julia> has_isomorph(g1, g2, vertex_relation=color_rel)
false
```
### See also 
[`has_induced_subgraphisomorph`](@ref), [`has_subgraphisomorph`](@ref), [`count_subgraphisomorph`](@ref), [`all_subgraphisomorph`](@ref)
"""
function has_isomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Bool
    return has_isomorph(
        g1, g2, alg; vertex_relation=vertex_relation, edge_relation=edge_relation
    )
end

"""
    count_induced_subgraphisomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return the number of vertex induced subgraphs of the graph `g1` that are isomorphic to `g2`.

### Optional Arguments
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> count_induced_subgraphisomorph(complete_graph(5), complete_graph(4))
120
julia> count_induced_subgraphisomorph(complete_graph(5), cycle_graph(4))
0

julia> g1 = path_graph(3); color1 = [1, 1, 2]
julia> g2 = path_graph(2); color2 = [1, 2]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> count_induced_subgraphisomorph(g1, g2)
2
julia> count_induced_subgraphisomorph(g1, g2, vertex_relation=color_rel)
1
```
### See also 
[`count_subgraphisomorph`](@ref), [`count_isomorph`](@ref), [`has_induced_subgraphisomorph`](@ref), [`all_induced_subgraphisomorph`](@ref)
"""
function count_induced_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Int
    return count_induced_subgraphisomorph(
        g1, g2, alg; vertex_relation=vertex_relation, edge_relation=edge_relation
    )
end

"""
    count_subgraphisomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return the number of subgraphs of the graph `g1` that are isomorphic to `g2`.

### Optional Arguments
- `alg`: The algorithm that is used to find the induced subgraph isomorphism. Can be only
    `VF2()` at the moment.
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> count_subgraphisomorph(complete_graph(5), complete_graph(4))
120
julia> count_subgraphisomorph(complete_graph(5), cycle_graph(4))
120

julia> g1 = cycle_digraph(3); color1 = [1, 1, 2]
julia> g2 = SimpleDiGraph(2); color2 = [1, 2]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> count_subgraphisomorph(g1, g2)
6
julia> count_subgraphisomorph(g1, g2, vertex_relation=color_rel)
2
```
### See also 
[`count_induced_subgraphisomorph`](@ref), [`count_isomorph`](@ref), [`has_subgraphisomorph`](@ref), [`all_subgraphisomorph`](@ref)
"""
function count_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Int
    return count_subgraphisomorph(
        g1::AbstractGraph,
        g2::AbstractGraph,
        VF2();
        vertex_relation=vertex_relation,
        edge_relation=edge_relation,
    )
end

"""
    count_isomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return the number of isomorphism from graph `g1` to `g2`.

### Optional Arguments
- `alg`: The algorithm that is used to find the induced subgraph isomorphism. Can be only
    `VF2()` at the moment.
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> count_isomorph(cycle_graph(5), cycle_graph(5))
10
julia> count_isomorph(complete_graph(5), cycle_graph(5))
0

julia> g1 = cycle_digraph(3); color1 = [1, 1, 2]
julia> g2 = cycle_digraph(3); color2 = [1, 1, 1]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> count_isomorph(g1, g2)
3
julia> count_isomorph(g1, g2, vertex_relation=color_rel)
0
```
### See also 
[`count_induced_subgraphisomorph`](@ref), [`count_subgraphisomorph`](@ref), [`has_isomorph`](@ref), [`all_isomorph`](@ref)
"""
function count_isomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Int
    return count_isomorph(
        g1, g2, alg; vertex_relation=vertex_relation, edge_relation=edge_relation
    )
end

"""
    all_induced_subgraphisomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return all isomorphism from vertex induced subgraphs of `g1` to `g2`.
The isomorphisms are returned as an iterator of vectors of tuples, where the i-th vector is 
the i-th isomorphism and a tuple (u, v) in this vector means that u ∈ g1 is
mapped to v ∈ g2.

### Optional Arguments
- `alg`: The algorithm that is used to find the induced subgraph isomorphism. Can be only
    `VF2()` at the moment.
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> all_induced_subgraphisomorph(path_graph(3), SimpleGraph(2)) |> collect
2-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(1, 1), (3, 2)]
 [(3, 1), (1, 2)]

julia> g1 = path_digraph(3); color1 = [1, 1, 2]
julia> g2 = path_digraph(2); color2 = [1, 2]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> all_induced_subgraphisomorph(g1, g2) |> collect
2-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(1, 1), (2, 2)]
 [(2, 1), (3, 2)]
julia> all_induced_subgraphisomorph(g1, g2, vertex_relation=color_rel) |> collect
1-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(1, 1), (2, 2)]
```
### See also 
[`all_subgraphisomorph`](@ref), [`all_isomorph`](@ref), [`has_induced_subgraphisomorph`](@ref), [`count_induced_subgraphisomorph`](@ref)
"""
function all_induced_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Channel{Vector{Tuple{eltype(g1),eltype(g2)}}}
    return all_induced_subgraphisomorph(
        g1, g2, alg; vertex_relation=vertex_relation, edge_relation=edge_relation
    )
end

"""
    all_subgraphisomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return all isomorphism from  subgraphs of `g1` to `g2`.
The isomorphisms are returned as an iterator of vectors of tuples, where the i-th vector is 
the i-th isomorphism and a tuple (u, v) in this vector means that u ∈ g1 is
mapped to v ∈ g2.

### Optional Arguments
- `alg`: The algorithm that is used to find the induced subgraph isomorphism. Can be only
    `VF2()` at the moment.
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> all_subgraphisomorph(path_graph(3), path_graph(2)) |> collect
4-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(1, 1), (2, 2)]
 [(2, 1), (1, 2)]
 [(2, 1), (3, 2)]
 [(3, 1), (2, 2)]

julia> g1 = path_digraph(3); color1 = [1, 1, 2]
julia> g2 = path_digraph(2); color2 = [1, 2]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> all_subgraphisomorph(g1, g2) |> collect
2-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(1, 1), (2, 2)]
 [(2, 1), (3, 2)]
julia> all_subgraphisomorph(g1, g2, vertex_relation=color_rel)
1-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(2, 1), (3, 2)]
```
### See also 
[`all_induced_subgraphisomorph`](@ref), [`all_isomorph`](@ref), [`has_subgraphisomorph`](@ref), [`count_subgraphisomorph`](@ref)
"""
function all_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Channel{Vector{Tuple{eltype(g1),eltype(g2)}}}
    return all_subgraphisomorph(
        g1, g2, alg; vertex_relation=vertex_relation, edge_relation=edge_relation
    )
end

"""
    all_isomorph(g1, g2, alg::IsomorphismAlgorithm=VF2(); vertex_relation=nothing, edge_relation=nothing)

Return all isomorphism from `g1` to `g2`.
The isomorphisms are returned as an iterator of vectors of tuples, where the i-th vector is 
the i-th isomorphism and a tuple (u, v) in this vector means that u ∈ g1 is
mapped to v ∈ g2.

### Optional Arguments
- `alg`: The algorithm that is used to find the induced subgraph isomorphism. Can be only
    `VF2()` at the moment.
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### Examples
```doctest.jl
julia> all_isomorph(star_graph(4), star_graph(4)) |> collect
6-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(1, 1), (2, 2), (3, 3), (4, 4)]
 [(1, 1), (2, 2), (4, 3), (3, 4)]
 [(1, 1), (3, 2), (2, 3), (4, 4)]
 [(1, 1), (3, 2), (4, 3), (2, 4)]
 [(1, 1), (4, 2), (2, 3), (3, 4)]
 [(1, 1), (4, 2), (3, 3), (2, 4)]
 
julia> g1 = cycle_digraph(3); color1 = [1, 1, 2]
julia> g2 = cycle_digraph(3); color2 = [2, 1, 1]
julia> color_rel(u, v) = (color1[u] == color2[v])
julia> all_isomorph(g1, g2) |> collect
3-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(1, 1), (2, 2), (3, 3)]
 [(2, 1), (3, 2), (1, 3)]
 [(3, 1), (1, 2), (2, 3)]
julia> all_subgraphisomorph(g1, g2, vertex_relation=color_rel)
1-element Array{Array{Tuple{Int64,Int64},1},1}:
 [(3, 1), (1, 2), (2, 3)]
```
### See also 
[`all_induced_subgraphisomorph`](@ref), [`all_subgraphisomorph`](@ref), [`has_isomorph`](@ref), [`count_isomorph`](@ref)
"""
function all_isomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::IsomorphismAlgorithm=VF2();
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Channel{Vector{Tuple{eltype(g1),eltype(g2)}}}
    return all_isomorph(
        g1, g2, alg; vertex_relation=vertex_relation, edge_relation=edge_relation
    )
end

SUITE["traversals"] = BenchmarkGroup(
    [], "graphs" => BenchmarkGroup([]), "digraphs" => BenchmarkGroup([])
)

SUITE["traversals"]["graphs"]["bfs_tree"] = @benchmarkable [
    Graphs.bfs_tree(g, 1) for (_, g) in $GRAPHS
]
SUITE["traversals"]["graphs"]["dfs_tree"] = @benchmarkable [
    Graphs.dfs_tree(g, 1) for (_, g) in $GRAPHS
]

SUITE["traversals"]["digraphs"]["bfs_tree"] = @benchmarkable [
    Graphs.bfs_tree(g, 1) for (_, g) in $DIGRAPHS
]
SUITE["traversals"]["digraphs"]["dfs_tree"] = @benchmarkable [
    Graphs.dfs_tree(g, 1) for (_, g) in $DIGRAPHS
]

# Parts of this code were taken / derived from Graphs.jl. See LICENSE for
# licensing details.

"""
    struct FloydWarshall <: ShortestPathAlgorithm

The structure used to configure and specify that [`shortest_paths`](@ref)
should use the [Floyd-Warshall algorithm](http://en.wikipedia.org/wiki/Floyd–Warshall_algorithm).
No additional configuration parameters are specified or required.

`FloydWarshall` is the default all-pairs algorithm used when no source is specified.

### Implementation Notes
`FloydWarshall` supports the following shortest-path functionality:
- non-negative distance matrices / weights
- all-pairs shortest paths

### Performance
Space complexity is on the order of ``\\mathcal{O}(|V|^2)``.
"""
struct FloydWarshall <: ShortestPathAlgorithm end
struct FloydWarshallResult{T,U<:Integer} <: ShortestPathResult
    dists::Matrix{T}
    parents::Matrix{U}
end

function shortest_paths(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}, ::FloydWarshall
) where {T,U<:Integer}
    nvg = nv(g)
    # if we do checkbounds here, we can use @inbounds later
    checkbounds(distmx, Base.OneTo(nvg), Base.OneTo(nvg))

    fwdists = fill(typemax(T), (Int(nvg), Int(nvg)))
    parents = zeros(U, (Int(nvg), Int(nvg)))

    @inbounds for v in vertices(g)
        fwdists[v, v] = zero(T)
    end
    undirected = !is_directed(g)
    @inbounds for e in edges(g)
        u = src(e)
        v = dst(e)

        d = distmx[u, v]

        fwdists[u, v] = min(d, fwdists[u, v])
        parents[u, v] = u
        if undirected
            fwdists[v, u] = min(d, fwdists[v, u])
            parents[v, u] = v
        end
    end

    @inbounds for pivot in vertices(g)
        # Relax fwdists[u, v] = min(fwdists[u, v], fwdists[u, pivot]+fwdists[pivot, v]) for all u, v
        for v in vertices(g)
            d = fwdists[pivot, v]
            d == typemax(T) && continue
            p = parents[pivot, v]
            for u in vertices(g)
                ans = (fwdists[u, pivot] == typemax(T) ? typemax(T) : fwdists[u, pivot] + d)
                if fwdists[u, v] > ans
                    fwdists[u, v] = ans
                    parents[u, v] = p
                end
            end
        end
    end
    fws = FloydWarshallResult(fwdists, parents)
    return fws
end

function paths(s::FloydWarshallResult{T,U}, v::Integer) where {T,U<:Integer}
    pathinfo = s.parents[v, :]
    fwpaths = Vector{Vector{U}}()
    for i in 1:length(pathinfo)
        if (i == v) || (s.dists[v, i] == typemax(T))
            push!(fwpaths, Vector{U}())
        else
            path = Vector{U}()
            currpathindex = U(i)
            while currpathindex != 0
                push!(path, currpathindex)
                if pathinfo[currpathindex] == currpathindex
                    currpathindex = zero(currpathindex)
                else
                    currpathindex = pathinfo[currpathindex]
                end
            end
            push!(fwpaths, reverse(path))
        end
    end
    return fwpaths
end

shortest_paths(g::AbstractGraph, alg::FloydWarshall) = shortest_paths(g, weights(g), alg)

# If we don't specify an algorithm AND there's no source, use Floyd-Warshall.
function shortest_paths(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return shortest_paths(g, distmx, FloydWarshall())
end

paths(s::FloydWarshallResult) = [paths(s, v) for v in 1:size(s.parents, 1)]
paths(st::FloydWarshallResult, s::Integer, d::Integer) = paths(st, s)[d]

# TODO most of the tests here do not work with generic graphs yet
# as the require the ability to copy or modify graphs, which is not provided
# by the AbstractGraph interface

@testset "Operators" begin
    rng = StableRNG(1)

    g3 = path_graph(5)
    g4 = path_digraph(5)

    @testset "$g" for g in testlargegraphs(g3)
        T = eltype(g)
        @testset "complement" begin
            c = @inferred(complement(g))
            @test nv(c) == 5
            @test ne(c) == 6
        end

        @testset "blockdiag" begin
            gb = @inferred(blockdiag(g, g))
            @test nv(gb) == 10
            @test ne(gb) == 8
        end

        @testset "intersect" begin
            hp = path_graph(2)
            h = Graph{T}(hp)
            @test @inferred(intersect(g, h)) == h
        end

        @testset "difference / symmetric difference" begin
            hp = path_graph(4)
            h = Graph{T}(hp)

            z = @inferred(difference(g, h))
            @test nv(z) == 5
            @test ne(z) == 1
            z = @inferred(difference(h, g))
            @test nv(z) == 4
            @test ne(z) == 0
            z = @inferred(symmetric_difference(h, g))
            @test z == symmetric_difference(g, h)
            @test nv(z) == 5
            @test ne(z) == 1
        end

        @testset "union" begin
            h = Graph{T}(6)
            add_edge!(h, 5, 6)
            e = SimpleEdge(5, 6)

            z = @inferred(union(g, h))
            @test has_edge(z, e)
            @test z == path_graph(6)
        end

        @testset "merge vertices" begin
            # Check merge_vertices function.
            h1 = Graph{T}(7)
            add_edge!(h1, 2, 5)
            add_edge!(h1, 3, 6)
            add_edge!(h1, 1, 7)
            add_edge!(h1, 6, 5)
            vs = [2, 3, 7, 3, 3, 2]
            hmerged = @inferred merge_vertices(h1, vs)
            @test neighbors(hmerged, 1) == [2]
            @test neighbors(hmerged, 2) == [1, 4, 5]
            @test neighbors(hmerged, 3) == []
            @test neighbors(hmerged, 4) == [2, 5]
            @test eltype(hmerged) == eltype(g)

            new_map = @inferred(merge_vertices!(h1, vs))
            @test new_map == [1, 2, 2, 3, 4, 5, 2]
            @test neighbors(h1, 1) == [2]
            @test neighbors(h1, 2) == [1, 4, 5]
            @test neighbors(h1, 3) == []
            @test neighbors(h1, 4) == [2, 5]
            @test hmerged == h1

            h2 = path_digraph(4)
            h2 = DiGraph{T}(h2)
            hmerged = @inferred merge_vertices(h2, [2, 3])
            @test is_directed(hmerged)
            @test inneighbors(hmerged, 1) == []
            @test inneighbors(hmerged, 2) == [1]
            @test inneighbors(hmerged, 3) == [2]
            @test outneighbors(hmerged, 1) == [2]
            @test outneighbors(hmerged, 2) == [3]
            @test outneighbors(hmerged, 3) == []
            @test eltype(hmerged) == eltype(h2)

            h3 = Graph{T}(7)
            add_edge!(h3, 1, 2)
            add_edge!(h3, 2, 3)
            add_edge!(h3, 2, 4)
            add_edge!(h3, 3, 4)
            add_edge!(h3, 3, 7)
            new_map = @inferred(merge_vertices!(h3, [2, 3, 2, 2]))
            @test new_map == [1, 2, 2, 3, 4, 5, 6]
            @test neighbors(h3, 2) == [1, 3, 6]
            @test neighbors(h3, 1) == [2]
            @test neighbors(h3, 3) == [2]
            @test neighbors(h3, 4) == Int[]
            @test neighbors(h3, 6) == [2]
            @test ne(h3) == 3
            @test nv(h3) == 6

            h4 = Graph{T}(7)
            add_edge!(h4, 1, 2)
            add_edge!(h4, 2, 3)
            add_edge!(h4, 2, 4)
            add_edge!(h4, 3, 4)
            add_edge!(h4, 3, 7)
            add_edge!(h4, 6, 7)
            new_map = @inferred(merge_vertices!(h4, [2, 7, 3, 2]))
            @test new_map == [1, 2, 2, 3, 4, 5, 2]
            @test neighbors(h4, 2) == [1, 3, 5]
            @test neighbors(h4, 1) == [2]
            @test neighbors(h4, 3) == [2]
            @test neighbors(h4, 4) == Int[]
            @test neighbors(h4, 5) == [2]
            @test ne(h4) == 3
            @test nv(h4) == 5

            h5 = star_graph(5)
            h5 = Graph{T}(h5)
            h5merged = merge_vertices(h5, [1, 2])
            @test neighbors(h5merged, 1) == [2, 3, 4]
            @test neighbors(h5merged, 2) == [1]
            @test neighbors(h5merged, 3) == [1]
            @test neighbors(h5merged, 4) == [1]
        end
    end

    @testset "$g" for g in testlargegraphs(g4)
        T = eltype(g)
        @testset "complement" begin
            c = @inferred(complement(g))
            @test nv(c) == 5
            @test ne(c) == 16
        end

        @testset "union" begin
            h = DiGraph{T}(6)
            add_edge!(h, 5, 6)
            e = SimpleEdge(5, 6)

            z = @inferred(union(g, h))
            @test has_edge(z, e)
            @test z == path_digraph(6)
        end
    end

    re1 = Edge(2, 1)
    gr = @inferred(reverse(g4))
    @testset "Reverse $g" for g in testdigraphs(gr)
        T = eltype(g)
        @test re1 in edges(g)
        @inferred(reverse!(g))
        @test g == DiGraph{T}(g4)
    end

    gx = complete_graph(2)

    @testset "Blockdiag $g" for g in testlargegraphs(gx)
        T = eltype(g)
        hc = complete_graph(2)
        h = Graph{T}(hc)
        z = @inferred(blockdiag(g, h))
        @test nv(z) == nv(g) + nv(h)
        @test ne(z) == ne(g) + ne(h)
        @test has_edge(z, 1, 2)
        @test has_edge(z, 3, 4)
        @test !has_edge(z, 1, 3)
        @test !has_edge(z, 1, 4)
        @test !has_edge(z, 2, 3)
        @test !has_edge(z, 2, 4)
    end

    gx = SimpleGraph(2)
    @testset "Join $g" for g in testgraphs(gx)
        T = eltype(g)
        h = Graph{T}(2)
        z = @inferred(join(g, h))
        @test nv(z) == nv(g) + nv(h)
        @test ne(z) == 4
        @test !has_edge(z, 1, 2)
        @test !has_edge(z, 3, 4)
        @test has_edge(z, 1, 3)
        @test has_edge(z, 1, 4)
        @test has_edge(z, 2, 3)
        @test has_edge(z, 2, 4)
    end

    px = path_graph(10)
    @testset "Matrix operations: $(typeof(p))" for p in test_generic_graphs(px)
        x = @inferred(p * ones(10))
        @test x[1] == 1.0 && all(x[2:(end - 1)] .== 2.0) && x[end] == 1.0
        @test size(p) == (10, 10)
        @test size(p, 1) == size(p, 2) == 10
        @test size(p, 3) == 1
        @test sum(p, 1) == sum(p, 2)
        @test_throws ArgumentError sum(p, 3)
        @test sparse(p) == adjacency_matrix(p)
        @test length(p) == 100
        @test ndims(p) == 2
        @test issymmetric(p)
    end

    gx = SimpleDiGraph(4)
    add_edge!(gx, 1, 2)
    add_edge!(gx, 2, 3)
    add_edge!(gx, 1, 3)
    add_edge!(gx, 3, 4)
    @testset "Matrix operations: $(typeof(g))" for g in test_generic_graphs(gx)
        @test @inferred(g * ones(nv(g))) == [2.0, 1.0, 1.0, 0.0]
        @test sum(g, 1) == [0, 1, 2, 1]
        @test sum(g, 2) == [2, 1, 1, 0]
        @test sum(g) == 4
        @test @inferred(!issymmetric(g))
    end

    gx = SimpleDiGraph(4)
    add_edge!(gx, 1, 2)
    add_edge!(gx, 2, 1)
    add_edge!(gx, 1, 3)
    add_edge!(gx, 3, 1)
    @testset "Matrix operations: $(typeof(g))" for g in test_generic_graphs(gx)
        @test @inferred(issymmetric(g))
    end

    nx = 20
    ny = 21
    @testset "Cartesian Product / Crosspath: $g" for g in testlargegraphs(path_graph(ny))
        T = eltype(g)
        hp = path_graph(nx)
        h = Graph{T}(hp)
        c = @inferred(cartesian_product(g, h))
        gz = @inferred(crosspath(ny, path_graph(nx)))
        @test gz == c
    end
    function crosspath_slow(len, h)
        g = h
        m = nv(h)
        for i in 1:(len - 1)
            k = nv(g)
            g = blockdiag(g, h)
            for v in 1:m
                add_edge!(g, v + (k - m), v + k)
            end
        end
        return g
    end

    @testset "Cartesian Product / Tensor Product: $g" for g in testgraphs(complete_graph(2))
        h = @inferred(cartesian_product(g, g))
        @test nv(h) == 4
        @test ne(h) == 4

        h = @inferred(tensor_product(g, g))
        @test nv(h) == 4
        @test ne(h) == 2
    end
    g2 = complete_graph(2)
    @testset "Crosspath: $g" for g in testgraphs(g2)
        @test crosspath_slow(2, g) == crosspath(2, g)
    end
    for i in 3:4
        @testset "Tensor Product: $g" for g in testgraphs(path_graph(i))
            @test length(connected_components(tensor_product(g, g))) == 2
            @test count_connected_components(tensor_product(g, g)) == 2
        end
    end

    gx = SimpleGraph(10, 20)
    gy = SimpleGraph(15, 34)
    @testset "Graph product edge counts" for (g1, g2) in zip(testgraphs(gx), testgraphs(gy))
        v1 = nv(g1)
        v2 = nv(g2)
        e1 = ne(g1)
        e2 = ne(g2)
        # Edge counts from https://en.wikipedia.org/wiki/Graph_product
        @test ne(cartesian_product(g1, g2)) == v1 * e2 + v2 * e1
        @test ne(tensor_product(g1, g2)) == 2 * e1 * e2
        @test ne(lexicographic_product(g1, g2)) == v1 * e2 + e1 * v2^2
        @test ne(strong_product(g1, g2)) == v1 * e2 + v2 * e1 + 2 * e1 * e2
        @test ne(disjunctive_product(g1, g2)) == v1^2 * e2 + e1 * v2^2 - 2 * e1 * e2
        @test ne(homomorphic_product(g1, g2)) ==
            v1 * v2 * (v2 - 1) / 2 + e1 * (v2^2 - 2 * e2)
    end

    ## test subgraphs ##

    gb = smallgraph(:bull)
    @testset "Subgraphs: $g" for g in testgraphs(gb)
        n = 3
        h = @inferred(g[1:n])
        @test nv(h) == n
        @test ne(h) == 3

        h = @inferred(g[[1, 2, 4]])
        @test nv(h) == n
        @test ne(h) == 2

        h = @inferred(g[[1, 5]])
        @test nv(h) == 2
        @test ne(h) == 0
        @test typeof(h) == typeof(g)
    end

    gx = SimpleDiGraph(100, 200; rng=rng)
    @testset "Subgraphs: $g" for g in testdigraphs(gx)
        h = @inferred(g[5:26])
        @test nv(h) == 22
        @test typeof(h) == typeof(g)
        @test_throws ArgumentError g[[1, 1]]

        r = 5:26
        h2, vm = @inferred(induced_subgraph(g, r))
        @test h2 == h
        @test vm == collect(r)
        @test h2 == g[r]

        r2 = falses(length(g))
        r2[r] .= true
        h2, vm = @inferred(induced_subgraph(g, r2))
        @test h2 == h
        @test vm == findall(r2)
        @test h2 == g[r2]
    end

    g10 = complete_graph(10)
    @testset "Induced Subgraphs: $g" for g in testgraphs(g10)
        sg, vm = @inferred(induced_subgraph(g, 5:8))
        @test nv(sg) == 4
        @test ne(sg) == 6

        sg2, vm = @inferred(induced_subgraph(g, [5, 6, 7, 8]))
        @test sg2 == sg
        @test vm[4] == 8

        bv = falses(length(g))
        bv[5:8] .= true
        sg2, vm = @inferred(induced_subgraph(g, bv))
        @test sg2 == sg
        @test vm[4] == 8

        elist = [
            SimpleEdge(1, 2),
            SimpleEdge(2, 3),
            SimpleEdge(3, 4),
            SimpleEdge(4, 5),
            SimpleEdge(5, 1),
        ]
        sg, vm = @inferred(induced_subgraph(g, elist))
        @test sg == cycle_graph(5)
        @test sort(vm) == [1:5;]
    end

    gs = star_graph(10)
    distgs = fill(4.0, 10, 10)
    @testset "Egonet: $g" for g in testgraphs(gs)
        T = eltype(g)
        @test @inferred(egonet(g, 1, 0)) == Graph{T}(1)
        @test @inferred(egonet(g, 1, 3, distgs)) == Graph{T}(1)
        @test @inferred(egonet(g, 1, 1)) == g
        @test @inferred(ndims(g)) == 2
    end

    @testset "Length: $(typeof(g))" for g in test_generic_graphs(SimpleGraph(100))
        @test length(g) == 10000
    end
end

@testset "Parallel.Closeness" begin
    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)

    for g in testdigraphs(g5)
        dy = @inferred(
            Parallel.closeness_centrality(g; normalize=false, parallel=:distributed)
        )
        @test dy ≈ [0.75, 0.6666666666666666, 1.0, 0.0]
        ty = @inferred(Parallel.closeness_centrality(g; normalize=false, parallel=:threads))
        @test ty ≈ [0.75, 0.6666666666666666, 1.0, 0.0]

        dz = @inferred(Parallel.closeness_centrality(g; parallel=:distributed))
        @test dz ≈ [0.75, 0.4444444444444444, 0.3333333333333333, 0.0]
        tz = @inferred(Parallel.closeness_centrality(g; parallel=:threads))
        @test tz ≈ [0.75, 0.4444444444444444, 0.3333333333333333, 0.0]
    end

    adjmx2 = [0 1 0; 1 0 1; 1 1 0] # digraph
    a2 = SimpleDiGraph(adjmx2)
    for g in testdigraphs(a2)
        distmx2 = [Inf 2.0 Inf; 3.2 Inf 4.2; 5.5 6.1 Inf]
        c2 = [0.24390243902439027, 0.27027027027027023, 0.1724137931034483]

        dy = @inferred(
            Parallel.closeness_centrality(
                g, distmx2; normalize=false, parallel=:distributed
            )
        )
        @test isapprox(dy, c2)
        ty = @inferred(
            Parallel.closeness_centrality(g, distmx2; normalize=false, parallel=:threads)
        )
        @test isapprox(ty, c2)

        dz = @inferred(Parallel.closeness_centrality(g, distmx2; parallel=:distributed))
        @test isapprox(dz, c2)
        tz = @inferred(Parallel.closeness_centrality(g, distmx2; parallel=:threads))
        @test isapprox(tz, c2)
    end

    g5 = SimpleGraph(5)
    add_edge!(g5, 1, 2)
    for g in testgraphs(g5)
        y = @inferred(Parallel.closeness_centrality(g; parallel=:distributed))
        @test y[1] == y[2] == 0.25
        @test y[3] == y[4] == y[5] == 0.0

        y = @inferred(Parallel.closeness_centrality(g; parallel=:threads))
        @test y[1] == y[2] == 0.25
        @test y[3] == y[4] == y[5] == 0.0
    end

    adjmx1 = [0 1 0; 1 0 1; 0 1 0] # graph
    a1 = SimpleGraph(adjmx1)
    for g in testgraphs(a1)
        distmx1 = [Inf 2.0 Inf; 2.0 Inf 4.2; Inf 4.2 Inf]
        c1 = [0.24390243902439027, 0.3225806451612903, 0.1923076923076923]
        dy = @inferred(
            Parallel.closeness_centrality(
                g, distmx1; normalize=false, parallel=:distributed
            )
        )
        dz = @inferred(Parallel.closeness_centrality(g, distmx1; parallel=:distributed))
        @test isapprox(dy, c1)
        @test isapprox(dz, c1)

        ty = @inferred(
            Parallel.closeness_centrality(g, distmx1; normalize=false, parallel=:threads)
        )
        tz = @inferred(Parallel.closeness_centrality(g, distmx1; parallel=:threads))
        @test isapprox(ty, c1)
        @test isapprox(tz, c1)
    end
end

@testset "Max adj visit" begin
    gx = SimpleGraph(8)

    # Test of Min-Cut and maximum adjacency visit
    # Original example by Stoer

    wedges = [
        (1, 2, 2.0),
        (1, 5, 3.0),
        (2, 3, 3.0),
        (2, 5, 2.0),
        (2, 6, 2.0),
        (3, 4, 4.0),
        (3, 7, 2.0),
        (4, 7, 2.0),
        (4, 8, 2.0),
        (5, 6, 3.0),
        (6, 7, 1.0),
        (7, 8, 3.0),
    ]

    m = length(wedges)
    eweights = spzeros(nv(gx), nv(gx))

    for (s, d, w) in wedges
        add_edge!(gx, s, d)
        eweights[s, d] = w
        eweights[d, s] = w
    end
    for g in testgraphs(gx)
        @test nv(g) == 8
        @test ne(g) == m

        parity, bestcut = @inferred(mincut(g, eweights))
        if parity[1] == 2
            parity .= 3 .- parity
        end

        @test length(parity) == 8
        @test parity == [1, 1, 2, 2, 1, 1, 2, 2]
        @test bestcut == 4.0

        parity, bestcut = @inferred(mincut(g))

        @test length(parity) == 8
        @test bestcut == 2.0

        v = @inferred(maximum_adjacency_visit(g))
        @test v == Vector{Int64}([1, 2, 5, 6, 3, 7, 4, 8])
    end

    g1 = SimpleGraph(1)
    for g in testgraphs(g1)
        @test @inferred(maximum_adjacency_visit(g)) == collect(vertices(g))
        @test @inferred(mincut(g)) == ([1], zero(eltype(g)))
    end
    @test maximum_adjacency_visit(gx, 1) == [1, 2, 5, 6, 3, 7, 4, 8]
    @test maximum_adjacency_visit(gx, 3) == [3, 2, 7, 4, 6, 8, 5, 1]

    # non regression test for #64
    g = clique_graph(4, 2)
    w = zeros(Int, 8, 8)
    for e in edges(g)
        if src(e) in [1, 5] || dst(e) in [1, 5]
            w[src(e), dst(e)] = 3
        else
            w[src(e), dst(e)] = 2
        end
        w[dst(e), src(e)] = w[src(e), dst(e)]
    end
    w[1, 5] = 6
    w[5, 1] = 6
    parity, bestcut = @inferred(mincut(g, w))
    if parity[1] == 2
        parity .= 3 .- parity
    end
    @test parity == [1, 1, 1, 1, 2, 2, 2, 2]
    @test bestcut == 6

    w[6, 7] = -1
    @test_throws DomainError mincut(g, w)
end

"""
	kruskal_mst(g, distmx=weights(g); minimize=true)
	kruskal_mst(g, weight_vector; minimize=true)

Return a vector of edges representing the minimum (by default) spanning tree of a connected, 
undirected graph `g` with optional distance matrix `distmx` using [Kruskal's algorithm](https://en.wikipedia.org/wiki/Kruskal%27s_algorithm).

Alternative to the distance matrix `distmx`, one can pass a `weight_vector` with weights ordered as `edges(g)`.

### Optional Arguments
- `minimize=true`: if set to `false`, calculate the maximum spanning tree.
"""
function kruskal_mst end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function kruskal_mst(
    g::AG::(!IsDirected), distmx::AbstractMatrix{T}=weights(g); minimize=true
) where {T<:Number,U,AG<:AbstractGraph{U}}
    weight_vector = Vector{T}()
    sizehint!(weight_vector, ne(g))
    for e in edges(g)
        push!(weight_vector, distmx[src(e), dst(e)])
    end
    return kruskal_mst(g, weight_vector; minimize=minimize)
end

@traitfn function kruskal_mst(
    g::AG::(!IsDirected), weight_vector::AbstractVector{T}; minimize=true
) where {T<:Number,U,AG<:AbstractGraph{U}}
    connected_vs = IntDisjointSet(nv(g))

    mst = Vector{edgetype(g)}()
    nv(g) <= 1 && return mst
    sizehint!(mst, nv(g) - 1)

    edge_list = collect(edges(g))
    for e in edge_list[sortperm(weight_vector; rev=(!minimize))]
        if !in_same_set(connected_vs, src(e), dst(e))
            union!(connected_vs, src(e), dst(e))
            push!(mst, e)
            (length(mst) >= nv(g) - 1) && break
        end
    end

    return mst
end

@testset "Betweenness" begin
    rng = StableRNG(1)
    # self loops
    s1 = GenericGraph(SimpleGraph(Edge.([(1, 2), (2, 3), (3, 3)])))
    s2 = GenericDiGraph(SimpleDiGraph(Edge.([(1, 2), (2, 3), (3, 3)])))

    g3 = GenericGraph(path_graph(5))

    gint = loadgraph(joinpath(testdir, "testdata", "graph-50-500.jgz"), "graph-50-500")

    c = vec(readdlm(joinpath(testdir, "testdata", "graph-50-500-bc.txt"), ','))
    for g in test_generic_graphs(gint)
        z = @inferred(betweenness_centrality(g))
        @test map(Float32, z) == map(Float32, c)

        y = @inferred(betweenness_centrality(g, endpoints=true, normalize=false))
        @test round.(y[1:3], digits=4) ==
            round.([122.10760591498584, 159.0072453120582, 176.39547945994505], digits=4)

        x = @inferred(betweenness_centrality(g, 3, rng=rng))
        x2 = @inferred(betweenness_centrality(g, collect(1:20)))

        @test length(x) == 50
        @test length(x2) == 50
    end

    @test @inferred(betweenness_centrality(s1)) == [0, 1, 0]
    @test @inferred(betweenness_centrality(s2)) == [0, 0.5, 0]

    g = GenericGraph(path_graph(2))
    z = @inferred(betweenness_centrality(g; normalize=true))
    @test z[1] == z[2] == 0.0
    z2 = @inferred(betweenness_centrality(g, vertices(g)))
    z3 = @inferred(betweenness_centrality(g, collect(vertices(g))))
    @test z == z2 == z3

    z = @inferred(betweenness_centrality(g3; normalize=false))
    @test z[1] == z[5] == 0.0

    # Weighted Graph tests
    g = GenericGraph(SimpleGraph(Edge.([(1, 2), (2, 3), (2, 5), (3, 4), (4, 5), (5, 6)])))

    distmx = [
        0.0 2.0 0.0 0.0 0.0 0.0
        2.0 0.0 4.2 0.0 1.2 0.0
        0.0 4.2 0.0 5.5 0.0 0.0
        0.0 0.0 5.5 0.0 0.9 0.0
        0.0 1.2 0.0 0.9 0.0 0.6
        0.0 0.0 0.0 0.0 0.6 0.0
    ]

    @test isapprox(
        betweenness_centrality(g, vertices(g), distmx; normalize=false),
        [0.0, 6.0, 0.0, 0.0, 6.0, 0.0],
    )
    @test isapprox(
        betweenness_centrality(g, vertices(g), distmx; normalize=false, endpoints=true),
        [5.0, 11.0, 5.0, 5.0, 11.0, 5.0],
    )
    @test isapprox(
        betweenness_centrality(g, vertices(g), distmx; normalize=true),
        [0.0, 0.6000000000000001, 0.0, 0.0, 0.6000000000000001, 0.0],
    )
    @test isapprox(
        betweenness_centrality(g, vertices(g), distmx; normalize=true, endpoints=true),
        [0.5, 1.1, 0.5, 0.5, 1.1, 0.5],
    )

    adjmx2 = [0 1 0; 1 0 1; 1 1 0] # digraph
    a2 = SimpleDiGraph(adjmx2)
    for g in test_generic_graphs(a2)
        distmx2 = [Inf 2.0 Inf; 3.2 Inf 4.2; 5.5 6.1 Inf]
        c2 = [0.24390243902439027, 0.27027027027027023, 0.1724137931034483]
        @test isapprox(
            betweenness_centrality(g, vertices(g), distmx2; normalize=false),
            [0.0, 1.0, 0.0],
        )
        @test isapprox(
            betweenness_centrality(
                g, vertices(g), distmx2; normalize=false, endpoints=true
            ),
            [4.0, 5.0, 4.0],
        )
        @test isapprox(
            betweenness_centrality(g, vertices(g), distmx2; normalize=true), [0.0, 0.5, 0.0]
        )
        @test isapprox(
            betweenness_centrality(g, vertices(g), distmx2; normalize=true, endpoints=true),
            [2.0, 2.5, 2.0],
        )
    end
    # test #1405 / #1406
    g = GenericGraph(grid([50, 50]))
    z = betweenness_centrality(g; normalize=false)
    @test maximum(z) < nv(g) * (nv(g) - 1)
end

@testset "SimpleEdgeIter" begin
    rng = StableRNG(1)

    ga = @inferred(SimpleGraph(10, 20; rng=StableRNG(1)))
    gb = @inferred(SimpleGraph(10, 20; rng=StableRNG(1)))
    dga = @inferred(SimpleDiGraph(10, 20; rng=StableRNG(1)))
    dgb = @inferred(SimpleDiGraph(10, 20; rng=StableRNG(1)))
    @testset "string representation" begin
        @test sprint(show, edges(ga)) == "SimpleEdgeIter 20"
    end

    @test length(collect(edges(Graph(0, 0; rng=rng)))) == 0

    @testset "collection operations" begin
        @test @inferred(edges(ga)) == edges(gb)
        @test @inferred(edges(ga)) == collect(Edge, edges(gb))
        @test edges(ga) != collect(Edge, Base.Iterators.take(edges(gb), 5))
        @test collect(Edge, edges(gb)) == edges(ga)
        @test Set{Edge}(collect(Edge, edges(gb))) == edges(ga)
        @test @inferred(edges(ga)) == Set{Edge}(collect(Edge, edges(gb)))

        @test @inferred(edges(dga)) == edges(dgb)
        @test @inferred(edges(dga)) == collect(SimpleEdge, edges(dgb))
        @test edges(dga) != collect(Edge, Base.Iterators.take(edges(dgb), 5))
        @test collect(SimpleEdge, edges(dgb)) == edges(dga)
        @test Set{Edge}(collect(SimpleEdge, edges(dgb))) == edges(dga)
        @test @inferred(edges(dga)) == Set{SimpleEdge}(collect(SimpleEdge, edges(dgb)))
    end
    @testset "eltype" begin
        @test @inferred(eltype(edges(ga))) == eltype(typeof(edges(ga))) == edgetype(ga)
        @test eltype(collect(edges(ga))) == edgetype(ga)
        @test eltype(collect(edges(dga))) == edgetype(dga)
        #
        # codecov for eltype(::Type{SimpleEdgeIter{SimpleDiGraph{T}}}) where {T} = SimpleDiGraphEdge{T}
        gd = SimpleDiGraph{UInt8}(10, 20; rng=rng)
        @test @inferred(eltype(edges(gd))) ==
            eltype(typeof(edges(gd))) ==
            edgetype(gd) ==
            SimpleDiGraphEdge{UInt8}
    end

    ga = SimpleGraph(10)
    add_edge!(ga, 3, 2)
    add_edge!(ga, 3, 10)
    add_edge!(ga, 5, 10)
    add_edge!(ga, 10, 3)

    dga = SimpleDiGraph(10)
    add_edge!(dga, 3, 2)
    add_edge!(dga, 3, 10)
    add_edge!(dga, 5, 10)
    add_edge!(dga, 10, 3)

    e1 = Edge(3, 10)
    e2 = (3, 10)
    @testset "membership operations" begin
        @test e1 ∈ edges(ga)
        @test e2 ∈ edges(ga)
        @test (3, 9) ∉ edges(ga)

        for u in 1:12, v in 1:12
            b = has_edge(ga, u, v)
            @test b == @inferred (u, v) ∈ edges(ga)
            @test b == @inferred (u => v) ∈ edges(ga)
            @test b == @inferred Edge(u, v) ∈ edges(ga)

            db = has_edge(dga, u, v)
            @test db == @inferred (u, v) ∈ edges(dga)
            @test db == @inferred (u => v) ∈ edges(dga)
            @test db == @inferred Edge(u, v) ∈ edges(dga)
        end
    end

    @testset "iterator protocol" begin
        eit = edges(ga)
        # @inferred not valid for new interface anymore (return type is a Union)
        @test collect(eit) == [Edge(2, 3), Edge(3, 10), Edge(5, 10)]

        eit = @inferred(edges(dga))
        @test collect(eit) ==
            [SimpleEdge(3, 2), SimpleEdge(3, 10), SimpleEdge(5, 10), SimpleEdge(10, 3)]
    end

    @testset "graph modifications" begin
        gb = copy(ga)
        add_vertex!(gb)
        @test edges(ga) == edges(gb)
        @test edges(gb) == edges(ga)

        dgb = copy(dga)
        add_vertex!(dgb)
        @test edges(dga) == edges(dgb)
        @test edges(dgb) == edges(dga)
    end
end

"""
    struct DEposoPapeState{T, U}

An [`AbstractPathState`](@ref) designed for D`Esopo-Pape shortest-path calculations.

# Fields

- `parents::Vector{U}`: `parents[v]` is the predecessor of vertex `v` on the shortest path from the source to `v`
- `dists::Vector{T}`: `dists[v]` is the length of the shortest path from the source to `v`
"""
struct DEsopoPapeState{T<:Number,U<:Integer} <: AbstractPathState
    parents::Vector{U}
    dists::Vector{T}
end

"""
    desopo_pape_shortest_paths(g, src, distmx=weights(g))

Compute shortest paths between a source `src` and all
other nodes in graph `g` using the [D'Esopo-Pape algorithm](http://web.mit.edu/dimitrib/www/SLF.pdf).
Return a [`Graphs.DEsopoPapeState`](@ref) with relevant traversal information (try querying `state.parents` or `state.dists`).

# Examples
```jldoctest
julia> using Graphs

julia> ds = desopo_pape_shortest_paths(cycle_graph(5), 2);

julia> ds.dists
5-element Vector{Int64}:
 1
 0
 1
 2
 2

julia> ds = desopo_pape_shortest_paths(path_graph(5), 2);

julia> ds.dists
5-element Vector{Int64}:
 1
 0
 1
 2
 3
```
"""
function desopo_pape_shortest_paths(
    g::AbstractGraph, src::Integer, distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number}
    U = eltype(g)
    nvg = nv(g)
    (src in 1:nvg) || throw(DomainError(src, "src should be in between 1 and $nvg"))
    dists = fill(typemax(T), nvg)
    parents = zeros(U, nvg)
    state = Vector{Int8}()
    state = fill(Int8(2), nvg)
    q = U[src]
    @inbounds dists[src] = 0

    @inbounds while !isempty(q)
        u = popfirst!(q)
        state[u] = 0

        for v in outneighbors(g, u)
            alt = dists[u] + distmx[u, v]
            if (dists[v] > alt)
                dists[v] = alt
                parents[v] = u

                if state[v] == 2
                    state[v] = 1
                    push!(q, v)
                elseif state[v] == 0
                    state[v] = 1
                    pushfirst!(q, v)
                end
            end
        end
    end

    return DEsopoPapeState{T,U}(parents, dists)
end

@testset "Karger Minimum Cut" begin
    gx = path_graph(5)

    #Assumes cut[1] = 1
    for g in testgraphs(gx)
        cut = @inferred(karger_min_cut(g))
        @test findfirst(isequal(2), cut) == findlast(isequal(1), cut) + 1
        @test karger_cut_cost(g, cut) == 1
        @test karger_cut_edges(g, cut) ==
            [Edge(findlast(isequal(1), cut), findfirst(isequal(2), cut))]
    end

    add_vertex!(gx)

    for g in testgraphs(gx)
        cut = @inferred(karger_min_cut(g))
        @test cut == [1, 1, 1, 1, 1, 2]
        @test karger_cut_cost(g, cut) == 0
        @test karger_cut_edges(g, cut) == Vector{Edge}()
    end

    gx = star_graph(5)
    for g in testgraphs(gx)
        cut = @inferred(karger_min_cut(g))
        @test count(isequal(2), cut) == 1
        @test karger_cut_cost(g, cut) == 1
        @test karger_cut_edges(g, cut) == [Edge(1, findfirst(isequal(2), cut))]
    end

    gx = SimpleGraph(1)
    for g in testgraphs(gx)
        cut = @inferred(karger_min_cut(g))
        @test cut == zeros(Int, 1)
    end
end

@testset "Distance" begin
    g4 = path_digraph(5)
    adjmx1 = [0 1 0; 1 0 1; 0 1 0] # graph
    adjmx2 = [0 1 0; 1 0 1; 1 1 0] # digraph
    adjmx3 = [0 1 0; 0 0 0; 0 0 0]
    a1 = SimpleGraph(adjmx1)
    a2 = SimpleDiGraph(adjmx2)
    a3 = SimpleDiGraph(adjmx3)
    a4 = blockdiag(complete_graph(5), complete_graph(5));
    add_edge!(a4, 1, 6)
    distmx1 = [Inf 2.0 Inf; 2.0 Inf 4.2; Inf 4.2 Inf]
    distmx2 = [Inf 2.0 Inf; 3.2 Inf 4.2; 5.5 6.1 Inf]

    @testset "$(typeof(g))" for g in test_generic_graphs(a1)
        z = @inferred(eccentricity(g, distmx1))
        @testset "eccentricity" begin
            @test z == [6.2, 4.2, 6.2]
        end
        @testset "diameter" begin
            @test @inferred(diameter(z)) == diameter(g, distmx1) == 6.2
        end
        @testset "periphery" begin
            @test @inferred(periphery(z)) == periphery(g, distmx1) == [1, 3]
        end
        @testset "radius" begin
            @test @inferred(radius(z)) == radius(g, distmx1) == 4.2
        end
        @testset "center" begin
            @test @inferred(center(z)) == center(g, distmx1) == [2]
        end
    end

    @testset "$(typeof(g))" for g in test_generic_graphs(a2)
        z = @inferred(eccentricity(g, distmx2))
        @testset "eccentricity" begin
            @test z == [6.2, 4.2, 6.1]
        end
        @testset "diameter" begin
            @test @inferred(diameter(z)) == diameter(g, distmx2) == 6.2
        end
        @testset "periphery" begin
            @test @inferred(periphery(z)) == periphery(g, distmx2) == [1]
        end
        @testset "radius" begin
            @test @inferred(radius(z)) == radius(g, distmx2) == 4.2
        end
        @testset "center" begin
            @test @inferred(center(z)) == center(g, distmx2) == [2]
        end
    end

    @testset "Disconnected graph diameter" for g in test_generic_graphs(a3)
        @test @inferred(diameter(g)) == typemax(Int)
    end

    @testset "simplegraph diameter" for g in test_generic_graphs(a4)
        @test @inferred(diameter(g)) == 3
    end

    @testset "Empty graph diameter" begin
        @test @inferred(diameter(SimpleGraph(0))) == 0
        @test @inferred(diameter(SimpleDiGraph(0))) == 0
    end

    @testset "iFUB diameter" begin
        # 1. Comparing against large graphs with known diameters  
        n_large = 5000
        g_path = path_graph(n_large)
        @test diameter(g_path) == n_large - 1

        g_cycle = cycle_graph(n_large)
        @test diameter(g_cycle) == floor(Int, n_large / 2)

        g_star = star_graph(n_large)
        @test diameter(g_star) == 2

        # 2. Comparing against the original implementation for random graphs
        function diameter_naive(g)
            return maximum(eccentricity(g))
        end

        NUM_SAMPLES = 50 # Adjust this to change test duration

        # Silence the many "Infinite path length detected" warnings from
        # eccentricity on disconnected random graphs.
        with_logger(NullLogger()) do
            for i in 1:NUM_SAMPLES
                # Random unweighted Graphs
                n = rand(10:1000) # Small to Medium size graphs
                p = rand() * 0.1 + 0.005 # Sparse to medium density

                # Undirected Graphs
                g = erdos_renyi(n, p)
                @test diameter(g) == diameter_naive(g)

                ccs = connected_components(g)
                largest_component = ccs[argmax(length.(ccs))]
                g_lscc, _ = induced_subgraph(g, largest_component)

                if nv(g_lscc) > 1
                    d_new = @inferred diameter(g_lscc)
                    d_ref = diameter_naive(g_lscc)
                    @test d_new == d_ref
                end

                # Directed Graphs
                g_dir = erdos_renyi(n, p, is_directed=true)
                @test diameter(g_dir) == diameter_naive(g_dir)

                sccs = strongly_connected_components(g_dir)
                largest_component_directed = sccs[argmax(length.(sccs))]
                g_dir_lscc, _ = induced_subgraph(g_dir, largest_component_directed)

                if nv(g_dir_lscc) > 1
                    d_new_dir = @inferred diameter(g_dir_lscc)
                    d_ref_dir = diameter_naive(g_dir_lscc)
                    @test d_new_dir == d_ref_dir
                end
            end
        end
    end

    @testset "DefaultDistance" begin
        @test size(Graphs.DefaultDistance()) == (typemax(Int), typemax(Int))
        d = @inferred(Graphs.DefaultDistance(3))
        @test size(d) == (3, 3)
        @test d[1, 1] == getindex(d, 1, 1) == 1
        @test d[1:2, 1:2] == Graphs.DefaultDistance(2)
        @test d == transpose(d) == adjoint(d)
        @test sprint(show, d) ==
            stringmime("text/plain", d) ==
            "$(d.nv) × $(d.nv) default distance matrix (value = 1)"
    end

    @testset "warnings and errors" begin
        # ensures that eccentricity only throws an error if there is more than one component
        g1 = GenericGraph(SimpleGraph(2))
        @test_logs (:warn, "Infinite path length detected for vertex 1") match_mode = :any eccentricity(
            g1
        )
        @test_logs (:warn, "Infinite path length detected for vertex 2") match_mode = :any eccentricity(
            g1
        )
        g2 = GenericGraph(path_graph(2))
        @test_logs eccentricity(g2)
    end
end

using Aqua
using Documenter
using Graphs
using Graphs.SimpleGraphs
using Graphs.Experimental
if isempty(VERSION.prerelease)
    using JET
end
using Graphs.Test
using Test
using SparseArrays
using LinearAlgebra
using DelimitedFiles
using Base64
using Random
using Logging: NullLogger, with_logger
using Statistics: mean, std
using StableRNGs
using Pkg
using Unitful

const testdir = dirname(@__FILE__)
const KMf = typeof(u"1.0km")

function get_pkg_version(name::AbstractString)
    for dep in values(Pkg.dependencies())
        if dep.name == name
            return dep.version
        end
    end
    return error("Dependency not available")
end

function testgraphs(g)
    return if is_directed(g)
        [g, DiGraph{UInt8}(g), DiGraph{Int16}(g)]
    else
        [g, Graph{UInt8}(g), Graph{Int16}(g)]
    end
end
testgraphs(gs...) = vcat((testgraphs(g) for g in gs)...)
testdigraphs = testgraphs

# some operations will create a large graph from two smaller graphs. We
# might error out on very small eltypes.
function testlargegraphs(g)
    return if is_directed(g)
        [g, DiGraph{UInt16}(g), DiGraph{Int32}(g)]
    else
        [g, Graph{UInt16}(g), Graph{Int32}(g)]
    end
end
testlargegraphs(gs...) = vcat((testlargegraphs(g) for g in gs)...)

function test_generic_graphs(g; eltypes=[UInt8, Int16], skip_if_too_large::Bool=false)
    SG = is_directed(g) ? SimpleDiGraph : SimpleGraph
    GG = is_directed(g) ? GenericDiGraph : GenericGraph
    result = GG[]
    for T in eltypes
        if skip_if_too_large && nv(g) > typemax(T)
            continue
        end
        push!(result, GG(SG{T}(g)))
    end
    return result
end

function test_generic_graphs(gs...; kwargs...)
    return vcat((test_generic_graphs(g; kwargs...) for g in gs)...)
end

function test_large_generic_graphs(g; skip_if_too_large::Bool=false)
    return test_generic_graphs(
        g; eltypes=[UInt16, Int32], skip_if_too_large=skip_if_too_large
    )
end

tests = [
    "simplegraphs/runtests",
    "linalg/runtests",
    "parallel/runtests",
    "interface",
    "core",
    "operators",
    "wrappedGraphs/graphviews",
    "degeneracy",
    "distance",
    "digraph/transitivity",
    "cycles/hawick-james",
    "cycles/johnson",
    "cycles/karp",
    "cycles/basis",
    "cycles/limited_length",
    "cycles/incremental",
    "edit_distance",
    "connectivity",
    "persistence/persistence",
    "shortestpaths/utils",
    "shortestpaths/astar",
    "shortestpaths/bellman-ford",
    "shortestpaths/desopo-pape",
    "shortestpaths/dijkstra",
    "shortestpaths/johnson",
    "shortestpaths/floyd-warshall",
    "shortestpaths/yen",
    "shortestpaths/spfa",
    "shortestpaths/longest_path",
    "traversals/bfs",
    "traversals/bipartition",
    "traversals/greedy_color",
    "traversals/dfs",
    "traversals/maxadjvisit",
    "traversals/randomwalks",
    "traversals/diffusion",
    "iterators/bfs",
    "iterators/dfs",
    "traversals/eulerian",
    "traversals/all_simple_paths",
    "community/cliques",
    "community/core-periphery",
    "community/independent_sets",
    "community/label_propagation",
    "community/louvain",
    "community/modularity",
    "community/clustering",
    "community/clique_percolation",
    "community/assortativity",
    "community/rich_club",
    "centrality/betweenness",
    "centrality/closeness",
    "centrality/degree",
    "centrality/katz",
    "centrality/pagerank",
    "centrality/eigenvector",
    "centrality/stress",
    "centrality/radiality",
    "utils",
    "deprecations",
    "spanningtrees/boruvka",
    "spanningtrees/kruskal",
    "spanningtrees/prim",
    "spanningtrees/planar_maximally_filtered_graph",
    "steinertree/steiner_tree",
    "biconnectivity/articulation",
    "biconnectivity/biconnect",
    "biconnectivity/bridge",
    "graphcut/normalized_cut",
    "graphcut/karger_min_cut",
    "dominatingset/degree_dom_set",
    "dominatingset/minimal_dom_set",
    "independentset/degree_ind_set",
    "independentset/maximal_ind_set",
    "vertexcover/degree_vertex_cover",
    "vertexcover/random_vertex_cover",
    "trees/prufer",
    "experimental/experimental",
    "planarity",
]

@testset verbose = true "Graphs" begin
    if isempty(VERSION.prerelease)
        @testset "Code quality (JET.jl)" begin
            @assert get_pkg_version("JET") >= v"0.8.4"
            JET.test_package(
                Graphs;
                target_defined_modules=true,
                ignore_missing_comparison=true,
                mode=:typo,  # TODO: switch back to `:basic` once the union split caused by traits is fixed
            )
        end
    end

    @testset "Code quality (Aqua.jl)" begin
        Aqua.test_all(Graphs; ambiguities=false)
    end

    if !Sys.iswindows()
        doctest(Graphs)
    end

    @testset verbose = true "Actual tests" begin
        for t in tests
            tp = joinpath(testdir, "$(t).jl")
            include(tp)
        end
    end
end;

"""
    struct JohnsonState{T, U}

An [`AbstractPathState`](@ref) designed for Johnson shortest-paths calculations.

# Fields

- `dists::Matrix{T}`: `dists[u, v]` is the length of the shortest path from `u` to `v` 
- `parents::Matrix{U}`: `parents[u, v]` is the predecessor of vertex `v` on the shortest path from `u` to `v`
"""
struct JohnsonState{T<:Number,U<:Integer} <: AbstractPathState
    dists::Matrix{T}
    parents::Matrix{U}
end

"""
    johnson_shortest_paths(g, distmx=weights(g))

Use the [Johnson algorithm](https://en.wikipedia.org/wiki/Johnson%27s_algorithm)
to compute the shortest paths between all pairs of vertices in graph `g` using an
optional distance matrix `distmx`.

Return a [`Graphs.JohnsonState`](@ref) with relevant
traversal information (try querying `state.parents` or `state.dists`).

### Performance
Complexity: `O(|V|*|E|)`
"""
function johnson_shortest_paths(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number} where {U<:Integer}
    nvg = nv(g)
    type_distmx = typeof(distmx)
    # Change when parallel implementation of Bellman Ford available
    wt_transform =
        bellman_ford_shortest_paths(g, collect_if_not_vector(vertices(g)), distmx).dists

    if !ismutable(distmx) && type_distmx != Graphs.DefaultDistance
        distmx = sparse(distmx) # Change reference, not value
    end

    # Weight transform not needed if all weights are positive.
    if type_distmx != Graphs.DefaultDistance
        for e in edges(g)
            distmx[src(e), dst(e)] += wt_transform[src(e)] - wt_transform[dst(e)]
        end
    end

    dists = Matrix{T}(undef, nvg, nvg)
    parents = Matrix{U}(undef, nvg, nvg)
    for v in vertices(g)
        dijk_state = dijkstra_shortest_paths(g, v, distmx)
        dists[v, :] = dijk_state.dists
        parents[v, :] = dijk_state.parents
    end

    broadcast!(-, dists, dists, wt_transform)
    for v in vertices(g)
        dists[:, v] .+= wt_transform[v] # Vertical traversal preferred
    end

    if ismutable(distmx)
        for e in edges(g)
            distmx[src(e), dst(e)] += wt_transform[dst(e)] - wt_transform[src(e)]
        end
    end

    return JohnsonState(dists, parents)
end

function enumerate_paths(
    s::JohnsonState{T,U}, v::Integer
) where {T<:Number} where {U<:Integer}
    pathinfo = s.parents[v, :]
    paths = Vector{Vector{U}}()
    for i in 1:length(pathinfo)
        if (i == v) || (s.dists[v, i] == typemax(T))
            push!(paths, Vector{U}())
        else
            path = Vector{U}()
            currpathindex = U(i)
            while currpathindex != 0
                push!(path, currpathindex)
                currpathindex = pathinfo[currpathindex]
            end
            push!(paths, reverse(path))
        end
    end
    return paths
end

enumerate_paths(s::JohnsonState) = [enumerate_paths(s, v) for v in 1:size(s.parents, 1)]
enumerate_paths(st::JohnsonState, s::Integer, d::Integer) = enumerate_paths(st, s)[d]

@testset "Randgraphs" begin
    rng = StableRNG(1)

    @testset "(Int, Int)" begin
        r1 = SimpleGraph(10, 20; rng=rng)
        r2 = SimpleDiGraph(5, 10; rng=rng)
        @test nv(r1) == 10
        @test ne(r1) == 20
        @test nv(r2) == 5
        @test ne(r2) == 10
        @test eltype(r1) == Int
        @test eltype(r2) == Int

        @test SimpleGraph(10, 20; rng=StableRNG(3)) == SimpleGraph(10, 20; rng=StableRNG(3))
        @test SimpleGraph(10, 40; rng=StableRNG(3)) == SimpleGraph(10, 40; rng=StableRNG(3))
        @test SimpleDiGraph(10, 20; rng=StableRNG(3)) ==
            SimpleDiGraph(10, 20; rng=StableRNG(3))
        @test SimpleDiGraph(10, 80; rng=StableRNG(3)) ==
            SimpleDiGraph(10, 80; rng=StableRNG(3))
        @test SimpleGraph(10, 20; rng=StableRNG(3)) ==
            erdos_renyi(10, 20; rng=rng = StableRNG(3))
        @test ne(Graph(10, 40; rng=StableRNG(3))) == 40
        @test ne(DiGraph(10, 80; rng=StableRNG(3))) == 80
    end

    @testset "(UInt8, Mixed) eltype" begin
        @test eltype(Graph(0x5, 0x2; rng=rng)) == eltype(Graph(0x5, 2; rng=rng)) == UInt8
    end

    @testset "(Graph{$T}(Int, Int) eltype" for T in [
        UInt8, Int8, UInt16, Int16, UInt32, Int32, UInt, Int
    ]
        @test eltype(Graph{T}(5, 2; rng=rng)) == T
        @test eltype(DiGraph{T}(5, 2; rng=rng)) == T
        @test eltype(Graph{T}(5, 8; rng=rng)) == T
        @test eltype(DiGraph{T}(5, 8; rng=rng)) == T
    end

    @testset "Erdös-Renyí" begin
        er = erdos_renyi(10, 0.5; rng=rng)
        @test nv(er) == 10
        @test is_directed(er) == false
        er = erdos_renyi(10, 0.5; is_directed=true, rng=rng)
        @test nv(er) == 10
        @test is_directed(er) == true

        er = erdos_renyi(10, 0.5; rng=StableRNG(17))
        @test nv(er) == 10
        @test is_directed(er) == false

        @test erdos_renyi(5, 1.0; rng=rng) == complete_graph(5)
        @test erdos_renyi(5, 1.0; is_directed=true, rng=rng) == complete_digraph(5)
        @test erdos_renyi(5, 2.1; rng=rng) == complete_graph(5)
        @test erdos_renyi(5, 2.1; is_directed=true, rng=rng) == complete_digraph(5)

        # issue #173
        er = erdos_renyi(4, 6; seed=1)
        @test nv(er) == 4
        @test ne(er) == 6
    end

    @testset "expected degree" begin
        cl = expected_degree_graph(zeros(10); rng=StableRNG(17))
        @test nv(cl) == 10
        @test ne(cl) == 0
        @test is_directed(cl) == false

        cl = expected_degree_graph([3, 2, 1, 2]; rng=StableRNG(17))
        @test nv(cl) == 4
        @test is_directed(cl) == false

        cl = expected_degree_graph(fill(99, 100); rng=StableRNG(17))
        @test nv(cl) == 100
        @test all(degree(cl) .> 90)
    end

    @testset "Watts-Strogatz" begin
        ws = watts_strogatz(10, 4, 0.2; rng=rng)
        @test nv(ws) == 10
        @test ne(ws) == 20
        @test is_directed(ws) == false

        ws = watts_strogatz(10, 4, 0.2; is_directed=true, rng=rng)
        @test nv(ws) == 10
        @test ne(ws) == 20
        @test is_directed(ws) == true
    end

    @testset "Newman-Watts-Strogatz" begin
        # Each iteration creates, on average, n*k/2*(1+β) edges (if the network is large enough).
        # As such, we need to average to check if the function works.
        nsamp = 100
        n = 1000
        β = 0.2
        k = 4
        mean_num_edges = n * k / 2 * (1 + β)
        nes = 0
        for i in 1:nsamp
            nws = newman_watts_strogatz(n, k, β; rng=rng)
            nes += ne(nws)
            @test nv(nws) == n
            @test is_directed(nws) == false
        end
        @test abs(sum(nes) / nsamp - mean_num_edges) / mean_num_edges < 0.01

        nes = 0
        for i in 1:nsamp
            nws = newman_watts_strogatz(n, k, β; is_directed=true, rng=rng)
            nes += ne(nws)
            @test nv(nws) == n
            @test is_directed(nws) == true
        end
        @test abs(sum(nes) / nsamp - mean_num_edges) / mean_num_edges < 0.01
    end

    @testset "Barabasi-Albert" begin
        ba = barabasi_albert(10, 2; rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 16
        @test is_directed(ba) == false

        ba = barabasi_albert(10, 2, 2; rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 16
        @test is_directed(ba) == false

        ba = barabasi_albert(10, 4, 2; rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 12
        @test is_directed(ba) == false

        ba = barabasi_albert(10, 2; complete=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 17
        @test is_directed(ba) == false

        ba = barabasi_albert(10, 2, 2; complete=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 17
        @test is_directed(ba) == false

        ba = barabasi_albert(10, 4, 2; complete=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 18
        @test is_directed(ba) == false

        ba = barabasi_albert(10, 2; is_directed=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 16
        @test is_directed(ba) == true

        ba = barabasi_albert(10, 2, 2; is_directed=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 16
        @test is_directed(ba) == true

        ba = barabasi_albert(10, 4, 2; is_directed=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 12
        @test is_directed(ba) == true

        ba = barabasi_albert(10, 2; is_directed=true, complete=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 18
        @test is_directed(ba) == true

        ba = barabasi_albert(10, 2, 2; is_directed=true, complete=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 18
        @test is_directed(ba) == true

        ba = barabasi_albert(10, 4, 2; is_directed=true, complete=true, rng=rng)
        @test nv(ba) == 10
        @test ne(ba) == 24
        @test is_directed(ba) == true
    end

    @testset "static fitness" begin
        fm = static_fitness_model(20, rand(10); rng=rng)
        @test nv(fm) == 10
        @test ne(fm) == 20
        @test is_directed(fm) == false

        fm = static_fitness_model(20, rand(10), rand(10); rng=rng)
        @test nv(fm) == 10
        @test ne(fm) == 20
        @test is_directed(fm) == true
    end

    @testset "static scale-free" begin
        sf = static_scale_free(10, 20, 2.0; rng=rng)
        @test nv(sf) == 10
        @test ne(sf) == 20
        @test is_directed(sf) == false

        sf = static_scale_free(10, 20, 2.0, 2.0; rng=rng)
        @test nv(sf) == 10
        @test ne(sf) == 20
        @test is_directed(sf) == true
    end

    @testset "random regular" begin
        rr = random_regular_graph(5, 0; rng=rng)
        @test nv(rr) == 5
        @test ne(rr) == 0
        @test is_directed(rr) == false

        rd = random_regular_digraph(10, 0; rng=rng)
        @test nv(rd) == 10
        @test ne(rd) == 0
        @test is_directed(rd)

        rr = random_regular_graph(10, 8; rng=StableRNG(4))
        @test nv(rr) == 10
        @test ne(rr) == 40
        @test is_directed(rr) == false
        for v in vertices(rr)
            @test degree(rr, v) == 8
        end

        rr = random_regular_graph(1000, 50; rng=rng)
        @test nv(rr) == 1000
        @test ne(rr) == 25000
        @test is_directed(rr) == false
        for v in vertices(rr)
            @test degree(rr, v) == 50
        end
        rd = random_regular_digraph(1000, 4; rng=rng)
        @test nv(rd) == 1000
        @test ne(rd) == 4000
        @test is_directed(rd)
        outdegree_rd = @inferred(outdegree(rd))
        @test all(outdegree_rd .== outdegree_rd[1])

        rd = random_regular_digraph(1000, 4; dir=:in, rng=rng)
        @test nv(rd) == 1000
        @test ne(rd) == 4000
        @test is_directed(rd)
        indegree_rd = @inferred(indegree(rd))
        @test all(indegree_rd .== indegree_rd[1])

        rd = random_regular_digraph(10, 8; dir=:out, rng=StableRNG(4))
        @test nv(rd) == 10
        @test ne(rd) == 80
        @test is_directed(rd)
    end

    @testset "uniform trees" begin
        t = uniform_tree(50; rng=rng)
        @test nv(t) == 50
        @test ne(t) == 49
        @test is_tree(t)

        t2 = uniform_tree(50; rng=StableRNG(4))
        @test nv(t2) == 50
        @test ne(t2) == 49
        @test is_tree(t2)
    end

    @testset "random configuration model" begin
        rr = random_configuration_model(10, repeat([2, 4], 5); rng=StableRNG(3))
        @test nv(rr) == 10
        @test ne(rr) == 15
        @test is_directed(rr) == false
        num2 = 0
        num4 = 0
        for v in vertices(rr)
            d = degree(rr, v)
            @test d == 2 || d == 4
            d == 2 ? num2 += 1 : num4 += 1
        end
        @test num4 == 5
        @test num2 == 5

        rr = random_configuration_model(1000, zeros(Int, 1000); rng=rng)
        @test nv(rr) == 1000
        @test ne(rr) == 0
        @test is_directed(rr) == false

        rr = random_configuration_model(3, [2, 2, 2]; check_graphical=true, rng=rng)
        @test nv(rr) == 3
        @test ne(rr) == 3
        @test is_directed(rr) == false
    end

    @testset "random tournament" begin
        rt = random_tournament_digraph(10; rng=rng)
        @test nv(rt) == 10
        @test ne(rt) == 45
        @test is_directed(rt)
        @test all(degree(rt) .== 9)
        Edges = edges(rt)
        for i in 1:10, j in 1:10
            if i != j
                edge = Edge(i, j)
                @test xor(edge ∈ Edges, reverse(edge) ∈ Edges)
            end
        end
    end

    @testset "SBM" begin
        g = stochastic_block_model(2.0, 3.0, [100, 100]; rng=rng)
        @test 4.0 < mean(degree(g)) < 6.0
        g = stochastic_block_model(3.0, 4.0, [100, 100, 100]; rng=rng)
        @test 10.0 < mean(degree(g)) < 12.0

        function generate_nbp_sbm(numedges, sizes)
            density = 1
            between = density * 0.90
            intra = density * -0.005
            noise = density * 0.00501
            sbm = nearbipartiteSBM(sizes, between, intra, noise)
            edgestream = make_edgestream(sbm; rng=rng)
            g = SimpleGraph(sum(sizes), numedges, edgestream)
            return sbm, g
        end

        function test_sbm(sbm, bp)
            @test sum(sbm.affinities) != NaN
            @test all(sbm.affinities .> 0)
            @test sum(sbm.affinities) != 0
            @test all(bp .>= 0)
            @test all(bp .!= NaN)
        end

        numedges = 100
        sizes = [10, 10, 10, 10]

        n = sum(sizes)
        sbm, g = generate_nbp_sbm(numedges, sizes)
        @test ne(g) >= 0.9numedges
        bc = blockcounts(sbm, g)
        bp = blockfractions(sbm, g) ./ (sizes * sizes')
        ratios = bp ./ (sbm.affinities ./ sum(sbm.affinities))
        test_sbm(sbm, bp)
        @test norm(collect(ratios)) < 0.25

        sizes = [200, 200, 100]
        internaldeg = 15
        externaldeg = 6
        internalp = Float64[internaldeg / i for i in sizes]
        externalp = externaldeg / sum(sizes)
        numedges = internaldeg + externaldeg #+ sum(externaldeg.*sizes[2:end])
        numedges *= div(sum(sizes), 2)
        sbm = StochasticBlockModel(internalp, externalp, sizes)

        g = SimpleGraph(sum(sizes), numedges, sbm; rng=rng)
        @test ne(g) >= 0.9numedges
        @test ne(g) <= numedges
        @test nv(g) == sum(sizes)
        bc = blockcounts(sbm, g)
        bp = blockfractions(sbm, g) ./ (sizes * sizes')
        test_sbm(sbm, bp)
        ratios = bp ./ (sbm.affinities ./ sum(sbm.affinities))
        @test norm(collect(ratios)) < 0.25

        # check that average degree is not too high
        # factor of two is cushion for random process
        @test mean(degree(g)) <= 4//2 * numedges / sum(sizes)
        # check that the internal degrees are higher than the external degrees
        # 5//4 is cushion for random process.
        @test all(sum(bc - diagm(0 => diag(bc)); dims=1) .<= 5//4 .* diag(bc))

        sbm2 = StochasticBlockModel(0.5 * ones(4), 0.3, 10 * ones(Int, 4))
        sbm = StochasticBlockModel(0.5, 0.3, 10, 4)
        @test sbm == sbm2
        sbm.affinities[1, 1] = 0
        @test sbm != sbm2
    end

    @testset "Kronecker" begin
        kg = @inferred kronecker(5, 5, rng=rng)
        @test nv(kg) == 32
        @test is_directed(kg)
    end

    @testset "Dorogovtsev-Mendes" begin
        g = @inferred(dorogovtsev_mendes(10, rng=rng))
        @test nv(g) == 10 && ne(g) == 17
        g = dorogovtsev_mendes(11; rng=rng)
        @test nv(g) == 11 && ne(g) == 19
        @test δ(g) == 2
        g = dorogovtsev_mendes(3; rng=rng)
        @test nv(g) == 3 && ne(g) == 3
        @test δ(g) == 2 && Δ(g) == 2

        # Testing that n=4 graph is one on the possible graphs
        g = dorogovtsev_mendes(4; rng=rng)
        @test has_edge(g, 1, 2) &&
            has_edge(g, 1, 3) &&
            has_edge(g, 2, 3) &&
            (
                has_edge(g, 1, 4) && has_edge(g, 2, 4) ||
                has_edge(g, 2, 4) && has_edge(g, 3, 4) ||
                has_edge(g, 1, 4) && has_edge(g, 3, 4)
            )

        # testing domain errors
        @test_throws DomainError dorogovtsev_mendes(2, rng=rng)
        @test_throws DomainError dorogovtsev_mendes(-1, rng=rng)
    end

    @testset "random orientation DAG" begin
        # testing if returned graph is acyclic and valid SimpleGraph
        rog = random_orientation_dag(SimpleGraph(5, 10; rng=rng); rng=rng)
        @test isvalid_simplegraph(rog)
        @test !is_cyclic(rog)

        # testing if returned graph is acyclic and valid ComplexGraph
        rog2 = random_orientation_dag(complete_graph(5); rng=rng)
        @test isvalid_simplegraph(rog2)
        @test !is_cyclic(rog2)

        # testing with abstract RNG
        rog3 = random_orientation_dag(SimpleGraph(10, 15; rng=rng); rng=rng)
        @test isvalid_simplegraph(rog3)
        @test !is_cyclic(rog3)
    end

    @testset "randbn" begin
        for i in 0:10
            @test Graphs.SimpleGraphs.randbn(i, 0.0; rng=rng) == 0
            @test Graphs.SimpleGraphs.randbn(i, 1.0; rng=rng) == i
        end
        N = 30
        s1 = zeros(N)
        s2 = zeros(N)
        for i in 1:N
            s1[i] = Graphs.SimpleGraphs.randbn(5, 0.3)
            s2[i] = Graphs.SimpleGraphs.randbn(3, 0.7)
        end
        μ1 = mean(s1)
        μ2 = mean(s2)
        sv1 = std(s1)
        sv2 = std(s2)
        @test μ1 - sv1 <= 0.3 * 5 <= μ1 + sv1 # since the stdev of μ1 is around sv1/sqrt(N), this should rarely fail
        @test μ2 - sv2 <= 0.7 * 3 <= μ2 + sv2
    end
end

"""
    louvain(g, distmx=weights(g), γ=1; max_moves::Integer=1000, max_merges::Integer=1000, move_tol::Real=10e-10, merge_tol::Real=10e-10, rng=nothing, seed=nothing)

Community detection using the louvain algorithm. Finds a partition of the vertices that
attempts to maximize the modularity. Returns a vector of community ids.

### Optional Arguments
- `distmx=weights(g)`: distance matrix for weighted graphs
- `γ=1.0`: where `γ > 0` is a resolution parameter. Higher resolutions lead to more
    communities, while lower resolutions lead to fewer communities. Where `γ=1.0` it
    leads to the traditional definition of the modularity.
- `max_moves=1000`: maximum number of rounds moving vertices before merging.
- `max_merges=1000`: maximum number of merges.
- `move_tol=10e-10`: necessary increase of modularity to move a vertex.
- `merge_tol=10e-10`: necessary increase of modularity in the move stage to merge.
- `rng=nothing`: rng to use for reproducibility. May only pass one of rng or seed.
- `seed=nothing`: seed to use for reproducibility. May only pass one of rng or seed.

### References
- [Vincent D Blondel et al J. Stat. Mech. (2008) P10008][https://doi.org/10.1088/1742-5468/2008/10/P10008]
- [Nicolas Dugué, Anthony Perez. Directed Louvain : maximizing modularity in directed networks.][https://hal.science/hal-01231784/document]

# Examples 
```jldoctest
julia> using Graphs

julia> barbell = blockdiag(complete_graph(3), complete_graph(3));

julia> add_edge!(barbell, 1, 4);

julia> louvain(barbell)
6-element Vector{Int64}:
 1
 1
 1
 2
 2
 2

julia> louvain(barbell, γ=0.01)
6-element Vector{Int64}:
 1
 1
 1
 1
 1
 1
```
"""
function louvain(
    g::AbstractGraph{T};
    γ=1.0,
    distmx::AbstractArray{<:Number}=weights(g),
    max_moves::Integer=1000,
    max_merges::Integer=1000,
    move_tol::Real=10e-10,
    merge_tol::Real=10e-10,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T}
    rng = rng_from_rng_or_seed(rng, seed)
    n = nv(g)
    if n == 0
        return T[]
    end

    @debug "Running louvain with parameters γ=$(γ), max_moves=$(max_moves), " *
        "max_merges=$(max_merges), move_tol=$(move_tol), merge_tol=$(merge_tol)"

    actual_coms = collect(one(T):nv(g))
    current_coms = copy(actual_coms)
    # actual_coms is always of length nv(g) and holds the current com for each v in g
    # current_coms is for the current graph; after merges it will be smaller than nv(g)

    for iter in 0:max_merges
        current_modularity = modularity(g, current_coms; distmx=distmx, γ=γ)
        @debug "Merge iteration $(iter). Current modularity is $(current_modularity)"
        louvain_move!(g, γ, current_coms, rng, distmx, max_moves, move_tol)
        # remap communities to 1-nc
        com_map = Dict(old => new for (new, old) in enumerate(unique(current_coms)))
        for i in eachindex(actual_coms)
            actual_coms[i] = com_map[current_coms[actual_coms[i]]]
        end
        @debug "Communities after moving in iteration $(iter): $(actual_coms)"
        for i in eachindex(current_coms)
            current_coms[i] = com_map[current_coms[i]]
        end

        # Stop if modularity gain is too small
        new_modularity = modularity(g, current_coms; distmx=distmx, γ=γ)
        @debug "New modularity is $(new_modularity) for a gain of $(new_modularity -
        current_modularity)"
        if new_modularity - current_modularity < merge_tol
            break
        end
        g, distmx = louvain_merge(g, current_coms, distmx)
        if nv(g) == 1 # nothing left to merge
            break
        end
        current_coms = collect(one(T):nv(g))
    end
    return actual_coms
end

"""
    louvain_move!(g, γ, c, rng, distmx=weights(g), max_moves=1000, move_tol=10e-10)

The move stage of the louvain algorithm.
"""
function louvain_move!(
    g, γ, c, rng, distmx=weights(g), max_moves::Integer=1000, move_tol::Real=10e-10
)
    vertex_order = shuffle!(rng, collect(vertices(g)))
    nc = maximum(c)

    # Compute graph and community volumes
    m = 0
    c_vols = zeros(eltype(distmx), ((is_directed(g) ? 2 : 1), nc))
    # if is_directed use row 1 for in and 2 for out
    for e in edges(g)
        m += distmx[src(e), dst(e)]
        c_vols[1, c[src(e)]] += distmx[src(e), dst(e)]
        if is_directed(g)
            c_vols[2, c[dst(e)]] += distmx[src(e), dst(e)]
        else
            c_vols[1, c[dst(e)]] += distmx[src(e), dst(e)]
        end
    end

    for _ in 1:max_moves
        last_change = nothing
        for v in vertex_order
            if v == last_change  # stop if we see each vertex and no movement
                return nothing
            end
            potential_coms = unique(c[u] for u in all_neighbors(g, v))
            filter!(!=(c[v]), potential_coms)
            @debug "Moving vertex $(v) from com $(c[v]) to potential_coms $(potential_coms)"
            if isempty(potential_coms)  # Continue if there are no other neighboring coms
                continue
            end
            shuffle!(rng, potential_coms)  # Break ties randomly by first com

            #Remove vertex degrees from current community
            out_degree = sum(
                u == v ? 2distmx[v, u] : distmx[v, u] for u in outneighbors(g, v)
            )
            c_vols[1, c[v]] -= out_degree

            in_degree = 0.0  # defined outside to keep JET.jl happy
            if is_directed(g)
                in_degree = sum(
                    u == v ? 2distmx[v, u] : distmx[v, u] for u in inneighbors(g, v)
                )
                c_vols[2, c[v]] -= in_degree
            end

            # Compute loss in modularity by removing vertex
            loss = ΔQ(g, γ, distmx, c, v, m, c[v], c_vols)
            @debug "Q loss of removing vertex $(v) from its community: $(loss)"
            # Compute gain by moving to alternate neighboring community
            this_ΔQ = c_potential -> ΔQ(g, γ, distmx, c, v, m, c_potential, c_vols)
            best_ΔQ, best_com_id = findmax(this_ΔQ, potential_coms)
            best_com = potential_coms[best_com_id]
            @debug "Best move is to $(best_com) with Q gain of $(best_ΔQ)"
            if best_ΔQ - loss > move_tol
                c[v] = best_com
                c_vols[1, best_com] += out_degree
                if is_directed(g)
                    c_vols[2, best_com] += in_degree
                end
                last_change = v
                @debug "Moved vertex $(v) to community $(best_com)"
            else
                c_vols[1, c[v]] += out_degree
                if is_directed(g)
                    c_vols[2, c[v]] += in_degree
                end
                @debug "Insufficient Q gain, vertex $(v) stays in community $(c[v])"
            end
        end
        if isnothing(last_change) # No movement
            return nothing
        end
    end
end

"""
    ΔQ(g, γ, distmx, c, v, m, c_potential, c_vols)

Compute the change in modularity when adding vertex v a potential community.
"""
function ΔQ(g, γ, distmx, c, v, m, c_potential, c_vols)
    if is_directed(g)
        out_degree = 0
        com_out_degree = 0
        for u in outneighbors(g, v)
            out_degree += distmx[v, u]
            if c[u] == c_potential || u == v
                com_out_degree += distmx[v, u]
            end
        end

        in_degree = 0
        com_in_degree = 0
        for u in inneighbors(g, v)
            in_degree += distmx[u, v]
            if c[u] == c_potential || u == v
                com_in_degree += distmx[u, v]
            end
        end

        # Singleton special case
        if c_vols[1, c_potential] == 0 && c_vols[2, c_potential] == 0
            return (com_in_degree+com_out_degree)/m - γ*2(in_degree + out_degree)/m^2
        end
        return (com_in_degree+com_out_degree)/m -
               γ*(in_degree*c_vols[1, c_potential]+out_degree*c_vols[2, c_potential])/m^2
    else
        degree = 0
        com_degree = 0
        for u in neighbors(g, v)
            degree += u == v ? 2distmx[u, v] : distmx[u, v]
            if u == v
                com_degree += 2distmx[u, v]
            elseif c[u] == c_potential
                com_degree += distmx[u, v]
            end
        end
        # Singleton special case
        if c_vols[1, c_potential] == 0
            return com_degree/2m - γ*(degree/2m)^2
        end
        return com_degree/2m - γ*degree*c_vols[1, c_potential]/2m^2
    end
end

"""
    louvain_merge(g, c, distmx)

Merge stage of the louvain algorithm.
"""
function louvain_merge(g::AbstractGraph{T}, c, distmx) where {T}
    # c is assumed to be 1:nc
    nc = maximum(c)
    new_distmx = Dict{Tuple{T,T},eltype(distmx)}()
    new_graph = is_directed(g) ? SimpleDiGraph{T}(nc) : SimpleGraph{T}(nc)
    for e in edges(g)
        new_src = c[src(e)]
        new_dst = c[dst(e)]
        if haskey(new_distmx, (new_src, new_dst))
            new_distmx[(new_src, new_dst)] += distmx[src(e), dst(e)]
        else
            new_distmx[(new_src, new_dst)] = distmx[src(e), dst(e)]
        end
        add_edge!(new_graph, new_src, new_dst)
    end

    # Convert new_distmx Dict to SparseArray
    r = [k[1] for k in keys(new_distmx)]
    c = [k[2] for k in keys(new_distmx)]
    v = [v for v in values(new_distmx)]
    new_distmx = sparse(r, c, v, nc, nc)

    if !is_directed(new_graph)
        new_distmx = new_distmx + transpose(new_distmx)
        new_distmx[diagind(new_distmx)] ./= 2
    end

    return new_graph, new_distmx
end

export DegreeIndependentSet

struct DegreeIndependentSet end

"""
    independent_set(g, DegreeIndependentSet())

Obtain an [independent set](https://en.wikipedia.org/wiki/Independent_set_(graph_theory)) of
`g` using a greedy heuristic based on the degree of the vertices.

### Implementation Notes
A vertex is said to be valid if it is not in the independent set or adjacent to any vertex
in the independent set.
Initilalise the independent set to an empty set and iteratively choose the vertex that is 
adjacent to the fewest valid vertices in the independent set until all vertices are invalid.

### Performance
Runtime: O((|V|+|E|)*log(|V|))
Memory: O(|V|)

### See also
[`maximum_independent_set`](@ref)
"""
function independent_set(g::AbstractGraph{T}, alg::DegreeIndependentSet) where {T<:Integer}
    nvg = nv(g)
    ind_set = Vector{T}()
    sizehint!(ind_set, nvg)
    deleted = falses(nvg)
    degree_queue = PriorityQueue(enumerate(degree(g)))

    while !isempty(degree_queue)
        v = popfirst!(degree_queue).first
        (deleted[v] || has_edge(g, v, v)) && continue
        deleted[v] = true
        push!(ind_set, v)

        for u in neighbors(g, v)
            deleted[u] && continue
            deleted[u] = true
            @inbounds @simd for w in neighbors(g, u)
                if !deleted[w]
                    degree_queue[w] -= 1
                end
            end
        end
    end
    return ind_set
end

abstract type AbstractGraphFormat end

"""
    loadgraph(file, gname="graph", format=LGFormat())

Read a graph named `gname` from `file` in the format `format`.

### Implementation Notes
`gname` is graph-format dependent and is only used if the file contains
multiple graphs; if the file format does not support multiple graphs, this
value is ignored. The default value may change in the future.
"""
function loadgraph(fn::AbstractString, gname::AbstractString, format::AbstractGraphFormat)
    open(fn, "r") do io
        loadgraph(auto_decompress(io), gname, format)
    end
end
loadgraph(fn::AbstractString) = loadgraph(fn, "graph", LGFormat())
loadgraph(fn::AbstractString, gname::AbstractString) = loadgraph(fn, gname, LGFormat())
loadgraph(fn::AbstractString, format::AbstractGraphFormat) = loadgraph(fn, "graph", format)

"""
    loadgraphs(file, format=LGFormat())

Load multiple graphs from `file` in the format `format`.
Return a dictionary mapping graph name to graph.

### Implementation Notes
For unnamed graphs the default name \"graph\" will be used. This default
may change in the future.
"""
function loadgraphs(fn::AbstractString, format::AbstractGraphFormat)
    open(fn, "r") do io
        loadgraphs(auto_decompress(io), format)
    end
end

loadgraphs(fn::AbstractString) = loadgraphs(fn, LGFormat())

function auto_decompress(io::IO)
    format = :raw
    mark(io)
    if !eof(io)
        b1 = read(io, UInt8)
        if !eof(io)
            b2 = read(io, UInt8)
            if (b1, b2) == (0x1f, 0x8b)  # check magic bytes
                format = :gzip
            end
        end
    end
    reset(io)
    if format == :gzip
        io = InflateGzipStream(io)
    end
    return io
end

"""
    savegraph(file, g, gname="graph", format=LGFormat)

Saves a graph `g` with name `gname` to `file` in the format `format`.
Return the number of graphs written.

### Implementation Notes
The default graph name assigned to `gname` may change in the future.
"""
function savegraph(
    fn::AbstractString,
    g::AbstractGraph,
    gname::AbstractString,
    format::AbstractGraphFormat;
    compress=nothing,
)
    if compress !== nothing
        if !compress
            @info(
                "Note: the `compress` keyword is no longer supported in Graphs. Saving uncompressed."
            )
        else
            Base.depwarn(
                "Saving compressed graphs is no longer supported in Graphs. Use `LGCompressedFormat()` from the `GraphIO.jl` package instead. Saving uncompressed.",
                :savegraph,
            )
        end
    end
    io = open(fn, "w")
    try
        return savegraph(io, g, gname, format)
    catch
        rethrow()
    finally
        close(io)
    end
end

# without graph name
function savegraph(
    fn::AbstractString, g::AbstractGraph, format::AbstractGraphFormat; compress=nothing
)
    return savegraph(fn, g, "graph", format; compress=compress)
end

# without format - default to LGFormat()
function savegraph(fn::AbstractString, g::AbstractSimpleGraph; compress=nothing)
    return savegraph(fn, g, "graph", LGFormat(); compress=compress)
end

"""
    savegraph(file, d, format=LGFormat())

Save a dictionary `d` of `graphname => graph` to `file` in the format `format`.
Return the number of graphs written.

# Examples
```jldoctest
julia> using Graphs

julia> g1 = SimpleGraph(5,8)
{5, 8} undirected simple Int64 graph

julia> g2 = SimpleGraph(7,10)
{7, 10} undirected simple Int64 graph

julia> d = Dict("graph_1" => g1, "graph_2" => g2);

julia> savegraph("myfile.txt", d, LGFormat())
2
```

### Implementation Notes
Will only work if the file format supports multiple graph types.
"""
function savegraph(
    fn::AbstractString, d::Dict{T,U}, format::AbstractGraphFormat; compress=nothing
) where {T<:AbstractString} where {U<:AbstractGraph}
    compress === nothing || Base.depwarn(
        "Saving compressed graphs is no longer supported in Graphs. Use `LGCompressedFormat()` from the `GraphIO.jl` package instead. Saving uncompressed.",
        :savegraph,
    )
    io = open(fn, "w")

    try
        return savegraph(io, d, format)
    catch
        rethrow()
    finally
        close(io)
    end
end

savegraph(fn::AbstractString, d::Dict) = savegraph(fn, d, LGFormat())

"""
    eigenvector_centrality(g)

Compute the eigenvector centrality for the graph `g`.

Eigenvector centrality computes the centrality for a node based on the
centrality of its neighbors. The eigenvector centrality for node `i` is
the \$i^{th}\$ element of \$\\mathbf{x}\$ in the equation
``
    \\mathbf{Ax} = λ \\mathbf{x}
``
where \$\\mathbf{A}\$ is the adjacency matrix of the graph `g` 
with eigenvalue λ.

By virtue of the Perron–Frobenius theorem, there is a unique and positive
solution if λ is the largest eigenvalue associated with the
eigenvector of the adjacency matrix \$\\mathbf{A}\$.

### References

- Phillip Bonacich: Power and Centrality: A Family of Measures.
    American Journal of Sociology 92(5):1170–1182, 1986
    http://www.leonidzhukov.net/hse/2014/socialnetworks/papers/Bonacich-Centrality.pdf
- Mark E. J. Newman: Networks: An Introduction.
       Oxford University Press, USA, 2010, pp. 169.
"""
function eigenvector_centrality(g::AbstractGraph)
    return abs.(vec(eigs(adjacency_matrix(g); which=LM(), nev=1)[2]))::Vector{Float64}
end

# This file contains the common interface for Graphs.

"""
    NotImplementedError{M}(m)

`Exception` thrown when a method from the `AbstractGraph` interface
is not implemented by a given graph type.
"""
struct NotImplementedError{M} <: Exception
    m::M
    NotImplementedError(m::M) where {M} = new{M}(m)
end

function Base.showerror(io::IO, ie::NotImplementedError)
    return print(io, "method $(ie.m) not implemented.")
end

_NI(m) = throw(NotImplementedError(m))

"""
    AbstractEdge

An abstract type representing a single edge between two vertices of a graph.
"""
abstract type AbstractEdge{T} end

"""
    AbstractEdgeIter

An abstract type representing an edge iterator.
"""
abstract type AbstractEdgeIter end

"""
    AbstractGraph

An abstract type representing a graph.
"""
abstract type AbstractGraph{T} end

@traitdef IsDirected{G<:AbstractGraph}
@traitimpl IsDirected{G} < -is_directed(G)

#
# Interface for AbstractEdges
#

"""
    src(e)

Return the source vertex of edge `e`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(2);

julia> add_edge!(g, 1, 2);

julia> src(first(edges(g)))
1
```
"""
src(e::AbstractEdge) = _NI("src")

"""
    dst(e)

Return the destination vertex of edge `e`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(2);

julia> add_edge!(g, 1, 2);

julia> dst(first(edges(g)))
2
```
"""
dst(e::AbstractEdge) = _NI("dst")

Pair(e::AbstractEdge) = _NI("Pair")
Tuple(e::AbstractEdge) = _NI("Tuple")

"""
    reverse(e)

Create a new edge from `e` with source and destination vertices reversed.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph(2);

julia> add_edge!(g, 1, 2);

julia> reverse(first(edges(g)))
Edge 2 => 1
```
"""
reverse(e::AbstractEdge) = _NI("reverse")

==(e1::AbstractEdge, e2::AbstractEdge) = _NI("==")

#
# Interface for AbstractGraphs
#
"""
    edgetype(g)

Return the type of graph `g`'s edge
"""
edgetype(g::AbstractGraph) = _NI("edgetype")

"""
    eltype(G)

Return the type of the graph's vertices (must be <: Integer)
"""
eltype(::Type{<:AbstractGraph{T}}) where {T} = T

"""
    nv(g)

Return the number of vertices in `g`.

# Examples
```jldoctest
julia> using Graphs

julia> nv(SimpleGraph(3))
3
```
"""
nv(g::AbstractGraph) = _NI("nv")

"""
    ne(g)

Return the number of edges in `g`.

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(3);

julia> ne(g)
2
```
"""
ne(g::AbstractGraph) = _NI("ne")

"""
    vertices(g)

Return (an iterator to or collection of) the vertices of a graph.

### Implementation Notes
A returned iterator is valid for one pass over the vertices, and
is invalidated by changes to `g`.

# Examples
```jldoctest
julia> using Graphs

julia> collect(vertices(SimpleGraph(4)))
4-element Vector{Int64}:
 1
 2
 3
 4
```
"""
vertices(g::AbstractGraph) = _NI("vertices")

"""
    edges(g)

Return (an iterator to or collection of) the edges of a graph.
For `AbstractSimpleGraph`s it returns a `SimpleEdgeIter` (lexicographical order).
The expressions `e in edges(g)` and `e ∈ edges(g)` evaluate as
calls to [`has_edge`](@ref).

### Implementation Notes
A returned iterator is valid for one pass over the edges, and
is invalidated by changes to `g`.

# Examples
```jldoctest
julia> using Graphs

julia> g = path_graph(3);

julia> collect(edges(g))
2-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 3
```
"""
edges(g) = _NI("edges")

"""
    is_directed(G)

Return `true` if the graph type `G` is a directed graph; `false` otherwise.
New graph types must implement `is_directed(::Type{<:G})`.
The method can also be called with `is_directed(g::G)`
# Examples
```jldoctest
julia> using Graphs

julia> is_directed(SimpleGraph(2))
false

julia> is_directed(SimpleGraph)
false

julia> is_directed(SimpleDiGraph(2))
true
```
"""
is_directed(::G) where {G} = is_directed(G)
is_directed(::Type{T}) where {T} = _NI("is_directed")

"""
    has_vertex(g, v)

Return true if `v` is a vertex of `g`.

# Examples
```jldoctest
julia> using Graphs

julia> has_vertex(SimpleGraph(2), 1)
true

julia> has_vertex(SimpleGraph(2), 3)
false
```
"""
has_vertex(x, v) = _NI("has_vertex")

"""
    has_edge(g, s, d)

Return true if the graph `g` has an edge from node `s` to node `d`.

An optional `has_edge(g, e)` can be implemented to check if an edge belongs
to a graph, including any data other than source and destination node.

`e in edges(g)` or `e ∈ edges(g)` evaluate as
calls to `has_edge`, c.f. [`edges`](@ref).

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph(2);

julia> add_edge!(g, 1, 2);

julia> has_edge(g, 1, 2)
true

julia> has_edge(g, 2, 1)
false
```
"""
has_edge(g, s, d) = _NI("has_edge")
has_edge(g, e) = has_edge(g, src(e), dst(e))

"""
    inneighbors(g, v)

Return a list of all neighbors connected to vertex `v` by an incoming edge.

### Implementation Notes
Returns a reference to the current graph's internal structures, not a copy.
Do not modify result. If the graph is modified, the behavior is undefined:
the array behind this reference may be modified too, but this is not guaranteed.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> inneighbors(g, 4)
2-element Vector{Int64}:
 3
 5
```
"""
inneighbors(x, v) = _NI("inneighbors")

"""
    outneighbors(g, v)

Return a list of all neighbors connected to vertex `v` by an outgoing edge.

# Implementation Notes
Returns a reference to the current graph's internal structures, not a copy.
Do not modify result. If the graph is modified, the behavior is undefined:
the array behind this reference may be modified too, but this is not guaranteed.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> outneighbors(g, 4)
1-element Vector{Int64}:
 5
```
"""
outneighbors(x, v) = _NI("outneighbors")

"""
    zero(G)

Return a zero-vertex, zero-edge version of the graph type `G`.
The fallback is defined for graph values `zero(g::G) = zero(G)`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> zero(typeof(g))
{0, 0} directed simple Int64 graph

julia> zero(g)
{0, 0} directed simple Int64 graph
```
"""
zero(::Type{<:AbstractGraph}) = _NI("zero")

zero(g::G) where {G<:AbstractGraph} = zero(G)

@testset "Core periphery" begin
    g10 = star_graph(10)
    for g in test_generic_graphs(g10)
        c = core_periphery_deg(g)
        @test @inferred(degree(g, 1)) == 9
        @test c[1] == 1
        for i in 2:10
            @test c[i] == 2
        end
    end

    g10 = star_graph(10)
    g10 = blockdiag(g10, g10)
    add_edge!(g10, 1, 11)
    for g in test_generic_graphs(g10)
        c = @inferred(core_periphery_deg(g))
        @test c[1] == 1
        @test c[11] == 1
        for i in 2:10
            @test c[i] == 2
        end
        for i in 12:20
            @test c[i] == 2
        end
    end
end

@testset "Diffusion Simulation" begin
    rng = StableRNG(1)

    gx = complete_graph(5)

    for g in testgraphs(gx)  # this makes graphs of different eltypes
        # Most basic
        @test @inferred(diffusion_rate(g, 1.0, 4; rng=rng)) == [1, 5, 5, 5]
    end

    for i in 1:5
        add_vertex!(gx)
    end

    for g in testgraphs(gx)  # this makes graphs of different eltypes

        ######
        # Check on fully connected, prob = 1
        ######

        # Add disconnected for more dynamics

        # Basic test. Watch connected vertices
        @test @inferred(
            diffusion_rate(g, 1.0, 4, watch=collect(1:5), initial_infections=[2], rng=rng)
        ) == [1, 5, 5, 5]

        # Watching unconnected vertices
        @test @inferred(
            diffusion_rate(g, 1.0, 4, watch=collect(6:10), initial_infections=[2], rng=rng)
        ) == [0, 0, 0, 0]

        # Watch subset
        @test @inferred(
            diffusion_rate(g, 1.0, 4, watch=collect(1:2), initial_infections=[2], rng=rng)
        ) == [1, 2, 2, 2]

        @test @inferred(
            diffusion_rate(g, 1.0, 4, watch=collect(1:5), initial_infections=[10], rng=rng)
        ) == [0, 0, 0, 0]
    end

    ######
    # Check along path graph
    ######

    gx = path_graph(5)

    for g in testgraphs(gx)  # this makes graphs of different eltypes
        @test @inferred(
            diffusion_rate(g, 1.0, 4, watch=collect(1:5), initial_infections=[1], rng=rng)
        ) == [1, 2, 3, 4]

        @test @inferred(
            diffusion_rate(g, 1.0, 4, watch=collect(1:5), initial_infections=[3], rng=rng)
        ) == [1, 3, 5, 5]
    end

    gx = path_graph(30)
    for g in testgraphs(gx)
        # Check normalize
        @test @inferred(
            diffusion_rate(g, 1.0, 6, initial_infections=[15], normalize=false, rng=rng)
        ) == [1, 3, 5, 7, 9, 11]

        @test @inferred(
            diffusion_rate(g, 2.0, 6, initial_infections=[15], normalize=true, rng=rng)
        ) == [1, 3, 5, 7, 9, 11]

        # Test probability accurate
        # In a Path network,
        # number of nodes infected (minus 1)
        # is equal to number of successes of a
        # Burnoulli process.
        # So if p = 0.2, in 5 steps (seed +
        # 4 trials) expected value is 0.8,
        # with standard deviation 0.8.

        means = Dict(0.2 => 0.8, 0.4 => 1.6)
        stds = Dict(0.2 => 0.8, 0.4 => 0.98)
        runs = 20
        for p in [0.2, 0.4]
            final_value = 0.0

            for i in 1:20
                result = @inferred(diffusion_rate(g, p, 5, initial_infections=[1], rng=rng))
                final_value += result[5]
            end

            # Pretty loose bounds so don't get lots of failed tests.
            # Just want some safeguard.
            # Note 5 steps = 4 Bernoullis + initial infection.
            # False rate less than 1 in 1000
            # Subtract 1 for initial infection
            avg = final_value / runs - 1
            @test avg < means[p] + stds[p] / sqrt(runs) * 3.5
            @test avg > means[p] - stds[p] / sqrt(runs) * 3.5
        end
    end

    gx = path_digraph(10)

    for g in testdigraphs(gx)

        ######
        # Check on digraphs
        ######

        @test @inferred(diffusion_rate(g, 1.0, 9, initial_infections=[1], rng=rng)) ==
            collect(1:9)

        @test @inferred(diffusion_rate(g, 1.0, 9, initial_infections=[10], rng=rng)) ==
            ones(Int, 9)

        # Check probabilities.
        # See note in analogous tests above for undirected tests.
        runs = 20
        means = Dict(0.2 => 2, 0.4 => 4)
        stds = Dict(0.2 => 1.2649110640673518, 0.4 => 1.5491933384829668)

        for p in [0.2, 0.4]
            final_value = 0.0

            for i in 1:20
                result = @inferred(
                    diffusion_rate(g, p, 11, initial_infections=[1], rng=rng)
                )
                final_value += result[11]
            end

            # Pretty loose bounds so don't get lots of failed tests.
            # Just want some safeguard.
            # False rate less than 1 in 1000
            # Subtract 1 for initial infection
            avg = final_value / runs - 1
            @test avg < means[p] + stds[p] / sqrt(runs) * 3.5
            @test avg > means[p] - stds[p] / sqrt(runs) * 3.5
        end
    end
end

# This file provides reexported functions.

"""
    adjacency_matrix(g[, T=Int; dir=:out])

Return a sparse adjacency matrix for a graph, indexed by `[u, v]`
vertices. Non-zero values indicate an edge from `u` to `v`. Users may
override the default data type (`Int`) and specify an optional direction.

### Optional Arguments
`dir=:out`: `:in`, `:out`, or `:both` are currently supported.

### Implementation Notes
This function is optimized for speed and directly manipulates CSC sparse matrix fields.
"""
function adjacency_matrix(g::AbstractGraph, T::DataType=Int; dir::Symbol=:out)
    nzmult = 1
    # see below - we iterate over columns. That's why we take the
    # "opposite" neighbor function. It's faster than taking the transpose
    # at the end.
    if (dir == :out)
        _adjacency_matrix(g, T, inneighbors, 1)
    elseif (dir == :in)
        _adjacency_matrix(g, T, outneighbors, 1)
    elseif (dir == :both)
        if is_directed(g)
            _adjacency_matrix(g, T, all_neighbors, 2)
        else
            _adjacency_matrix(g, T, outneighbors, 1)
        end
    else
        error("Not implemented")
    end
end

@generated function _find_correct_type(g::AbstractGraph{T}) where {T}
    TT = widen(T)
    if typemax(TT) >= typemax(Int64)
        TT = Int64
    end
    return :($TT)
end

function _adjacency_matrix(
    g::AbstractGraph, T::DataType, neighborfn::Function, nzmult::Int=1
)
    n_v = nv(g)
    nz = ne(g) * (is_directed(g) ? 1 : 2) * nzmult
    TT = _find_correct_type(g)
    colpt = ones(TT, n_v + 1)

    rowval = sizehint!(Vector{TT}(), nz)
    selfloops = Vector{TT}()
    for j in 1:n_v  # this is by column, not by row.
        if has_edge(g, j, j)
            push!(selfloops, j)
        end
        dsts = sort(collect(neighborfn(g, j))) # TODO for most graphs it might not be necessary to sort
        colpt[j + 1] = colpt[j] + length(dsts)
        append!(rowval, dsts)
    end
    spmx = SparseMatrixCSC(n_v, n_v, colpt, rowval, ones(T, length(rowval)))

    # this is inefficient. There should be a better way of doing this.
    # the issue is that adjacency matrix entries for self-loops are 2,
    # not one(T).
    if !(T <: Bool) && !is_directed(g)
        for i in selfloops
            spmx[i, i] += one(T)
        end
    end
    return spmx
end

"""
    laplacian_matrix(g[, T=Int; dir=:unspec])

Return a sparse [Laplacian matrix](https://en.wikipedia.org/wiki/Laplacian_matrix)
for a graph `g`, indexed by `[u, v]` vertices. `T` defaults to `Int` for both graph types.

### Optional Arguments
`dir=:unspec`: `:unspec`, `:both`, `:in`, and `:out` are currently supported.
For undirected graphs, `dir` defaults to `:out`; for directed graphs,
`dir` defaults to `:both`.
"""
function laplacian_matrix(
    g::AbstractGraph{U}, T::DataType=Int; dir::Symbol=:unspec
) where {U}
    if dir == :unspec
        dir = is_directed(g) ? :both : :out
    end
    A = adjacency_matrix(g, T; dir=dir)
    s = sum(A; dims=2)
    D = convert(SparseMatrixCSC{T,U}, spdiagm(0 => s[:]))
    return D - A
end

"""
    laplacian_spectrum(g[, T=Int; dir=:unspec])

Return the eigenvalues of the Laplacian matrix for a graph `g`, indexed
by vertex. Default values for `T` are the same as those in
[`laplacian_matrix`](@ref).

### Optional Arguments
`dir=:unspec`: Options for `dir` are the same as those in [`laplacian_matrix`](@ref).

### Performance
Converts the matrix to dense with ``nv^2`` memory usage.

### Implementation Notes
Use `eigvals(Matrix(laplacian_matrix(g, args...)))` to compute some of the
eigenvalues/eigenvectors.
"""
function laplacian_spectrum(g::AbstractGraph, T::DataType=Int; dir::Symbol=:unspec)
    return eigvals(Matrix(laplacian_matrix(g, T; dir=dir)))
end

"""
    adjacency_spectrum(g[, T=Int; dir=:unspec])

Return the eigenvalues of the adjacency matrix for a graph `g`, indexed
by vertex. Default values for `T` are the same as those in
[`adjacency_matrix`](@ref).

### Optional Arguments
`dir=:unspec`: Options for `dir` are the same as those in [`laplacian_matrix`](@ref).

### Performance
Converts the matrix to dense with ``nv^2`` memory usage.

### Implementation Notes
Use `eigvals(Matrix(adjacency_matrix(g, args...)))` to compute some of the
eigenvalues/eigenvectors.
"""
function adjacency_spectrum(g::AbstractGraph, T::DataType=Int; dir::Symbol=:unspec)
    if dir == :unspec
        dir = is_directed(g) ? :both : :out
    end
    return eigvals(Matrix(adjacency_matrix(g, T; dir=dir)))
end

"""
    incidence_matrix(g[, T=Int; oriented=false])

Return a sparse node-arc incidence matrix for a graph, indexed by
`[v, i]`, where `i` is in `1:ne(g)`, indexing an edge `e`. For
directed graphs, a value of `-1` indicates that `src(e) == v`, while a
value of `1` indicates that `dst(e) == v`. Otherwise, the value is
`0`. For undirected graphs, both entries are `1` by default (this behavior
can be overridden by the `oriented` optional argument).

If `oriented` (default false) is true, for an undirected graph `g`, the
matrix will contain arbitrary non-zero values representing connectivity
between `v` and `i`.
"""
function incidence_matrix(g::AbstractGraph, T::DataType=Int; oriented=false)
    isdir = is_directed(g)
    n_e = ne(g)
    I = vcat(src.(edges(g)), dst.(edges(g)))
    J = vcat(1:n_e, 1:n_e)
    V = vcat(
        (isdir || oriented) ? -fill(one(T), n_e) : fill(one(T), n_e), fill(one(T), n_e)
    )
    return sparse(I, J, V, nv(g), ne(g))
end

"""
    spectral_distance(G₁, G₂ [, k])

Compute the spectral distance between undirected n-vertex
graphs `G₁` and `G₂` using the top `k` greatest eigenvalues.
If `k` is omitted, uses full spectrum.

### References
- JOVANOVIC, I.; STANIC, Z., 2014. Spectral Distances of Graphs Based on their Different Matrix Representations
"""
function spectral_distance end

# can't use Traitor syntax here (https://github.com/mauro3/SimpleTraits.jl/issues/36)
@traitfn function spectral_distance(
    G₁::G, G₂::G, k::Integer
) where {G<:AbstractGraph;!IsDirected{G}}
    A₁ = adjacency_matrix(G₁)
    A₂ = adjacency_matrix(G₂)

    λ₁ = if k < nv(G₁) - 1
        eigs(A₁; nev=k, which=LR())[1]
    else
        eigvals(Matrix(A₁))[end:-1:(end - (k - 1))]
    end
    λ₂ = if k < nv(G₂) - 1
        eigs(A₂; nev=k, which=LR())[1]
    else
        eigvals(Matrix(A₂))[end:-1:(end - (k - 1))]
    end

    return sum(abs, (λ₁ - λ₂))
end

# can't use Traitor syntax here (https://github.com/mauro3/SimpleTraits.jl/issues/36)
@traitfn function spectral_distance(G₁::G, G₂::G) where {G<:AbstractGraph;!IsDirected{G}}
    nv(G₁) == nv(G₂) ||
        throw(ArgumentError("Spectral distance not defined for |G₁| != |G₂|"))
    return spectral_distance(G₁, G₂, nv(G₁))
end

import Base.Sort, Base.Sort.Algorithm
import Base: sort!

struct NOOPSortAlg <: Base.Sort.Algorithm end
const NOOPSort = NOOPSortAlg()

sort!(x::AbstractVector, ::Integer, ::Integer, ::NOOPSortAlg, ::Base.Sort.Ordering) = x

struct BFS{T<:Base.Sort.Algorithm} <: TraversalAlgorithm
    sort_alg::T
end

BFS() = BFS(NOOPSort)

"""
    traverse_graph!(g, s, alg, state, neighborfn=outneighbors)
    traverse_graph!(g, ss, alg, state, neighborfn=outneighbors)

    Traverse a graph `g` starting at vertex `s` / vertices `ss` using algorithm `alg`, maintaining state in [`AbstractTraversalState`](@ref) `state`. Next vertices to be visited are determined by `neighborfn` (default `outneighbors`). Return `true` if traversal finished; `false` if one of the visit functions caused an early termination.
    
"""
function traverse_graph!(
    g::AbstractGraph{U},
    ss::AbstractVector,
    alg::BFS,
    state::AbstractTraversalState,
    neighborfn::Function=outneighbors,
) where {U<:Integer}
    n = nv(g)
    visited = falses(n)
    cur_level = Vector{U}()
    sizehint!(cur_level, n)
    next_level = Vector{U}()
    sizehint!(next_level, n)
    @inbounds for s in ss
        us = U(s)
        visited[us] = true
        push!(cur_level, us)
        initfn!(state, us) || return false
    end
    while !isempty(cur_level)
        @inbounds for v in cur_level
            previsitfn!(state, v) || return false
            @inbounds @simd for i in neighborfn(g, v)
                visitfn!(state, v, i) || return false
                if !visited[i]
                    newvisitfn!(state, v, i) || return false
                    push!(next_level, i)
                    visited[i] = true
                end
            end
            postvisitfn!(state, v) || return false
        end
        postlevelfn!(state) || return false
        empty!(cur_level)
        cur_level, next_level = next_level, cur_level
        sort!(cur_level; alg=alg.sort_alg)
    end
    return true
end

mutable struct DistanceState{T<:Integer} <: AbstractTraversalState
    distances::Vector{T}
    n_level::T
end

@inline function initfn!(s::DistanceState{T}, u) where {T}
    s.distances[u] = zero(T)
    return true
end
@inline function newvisitfn!(s::DistanceState, u, v)
    s.distances[v] = s.n_level
    return true
end
@inline function postlevelfn!(s::DistanceState{T}) where {T}
    s.n_level += one(T)
    return true
end

"""
    distances(g, s, alg=BFS())
    distances(g, ss, alg=BFS())

Return a vector filled with the geodesic distances of vertices in  `g` from vertex `s` / unique vertices `ss`
using BFS traversal algorithm `alg`.  For vertices in disconnected components the default distance is `typemax(T)`.
"""
function distances(g::AbstractGraph{T}, s, alg::BFS=BFS()) where {T}
    d = fill(typemax(T), nv(g))
    state = DistanceState(d, one(T))
    traverse_graph!(g, s, alg, state)
    return state.distances
end

"""
    stress_centrality(g[, vs])
    stress_centrality(g, k)

Calculate the [stress centrality](http://med.bioinf.mpi-inf.mpg.de/netanalyzer/help/2.7/#stressDist)
of a graph `g` across all vertices, a specified subset of vertices `vs`, or a random subset of `k`
vertices. Return a vector representing the centrality calculated for each node in `g`.

The stress centrality of a vertex ``n`` is defined as the number of shortest paths passing through ``n``.

### References
- Barabási, A.L., Oltvai, Z.N.: Network biology: understanding the cell's functional organization. Nat Rev Genet 5 (2004) 101-113
- Shimbel, A.: Structural parameters of communication networks. Bull Math Biophys 15 (1953) 501-507.

# Examples
```jldoctest
julia> using Graphs

julia> stress_centrality(star_graph(3))
3-element Vector{Int64}:
 2
 0
 0

julia> stress_centrality(cycle_graph(4))
4-element Vector{Int64}:
 2
 2
 2
 2
```
"""
function stress_centrality(g::AbstractGraph, vs=vertices(g))
    n_v = nv(g)
    k = length(vs)
    isdir = is_directed(g)

    stress = zeros(Int, n_v)
    for s in vs
        if degree(g, s) > 0
            state = dijkstra_shortest_paths(g, s; allpaths=true, trackvertices=true)
            _stress_accumulate_basic!(stress, state, g, s)
        end
    end
    return stress
end

function stress_centrality(
    g::AbstractGraph,
    k::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    return stress_centrality(
        g, sample(collect_if_not_vector(vertices(g)), k; rng=rng, seed=seed)
    )
end

function _stress_accumulate_basic!(
    stress::Vector{<:Integer}, state::DijkstraState, g::AbstractGraph, si::Integer
)
    n_v = length(state.parents) # this is the ttl number of vertices
    δ = zeros(Int, n_v)
    P = state.predecessors

    laststress = copy(stress)
    # make sure the source index has no parents.
    P[si] = []
    # we need to order the source vertices by decreasing distance for this to work.
    S = reverse(state.closest_vertices) # Replaced sortperm with this
    for w in S  # w is the farthest vertex from si
        for v in P[w]  # get the predecessors of w
            if v > 0
                δ[v] += δ[w] + 1 # increment sp of pred
            end
        end
        δ[w] *= length(P[w]) # adjust the # of sps of vertex
        if w != si
            stress[w] += δ[w]
        end
    end
    return nothing
end

@testset "Boruvka" begin
    g4 = complete_graph(4)

    distmx = [
        0 1 5 6
        1 0 4 10
        5 4 0 3
        6 10 3 0
    ]

    vec_mst = Vector{Edge}([Edge(1, 2), Edge(3, 4), Edge(2, 3)])
    cost_mst = sum(distmx[src(e), dst(e)] for e in vec_mst)

    max_vec_mst = Vector{Edge}([Edge(1, 4), Edge(2, 4), Edge(1, 3)])
    cost_max_vec_mst = sum(distmx[src(e), dst(e)] for e in max_vec_mst)

    for g in test_generic_graphs(g4)
        # Testing Boruvka's algorithm
        res1 = boruvka_mst(g, distmx)
        edges1 = [Edge(src(e), dst(e)) for e in res1.mst]
        g1t = GenericGraph(SimpleGraph(edges1))
        @test res1.weight == cost_mst
        # acyclic graphs have n - c edges
        @test nv(g1t) - length(connected_components(g1t)) == ne(g1t)
        @test nv(g1t) == nv(g)

        res2 = boruvka_mst(g, distmx; minimize=false)
        edges2 = [Edge(src(e), dst(e)) for e in res2.mst]
        g2t = GenericGraph(SimpleGraph(edges2))
        @test res2.weight == cost_max_vec_mst
        @test nv(g2t) - length(connected_components(g2t)) == ne(g2t)
        @test nv(g2t) == nv(g)
    end
    # second test
    distmx_sec = [
        0 0 0.26 0 0.38 0 0.58 0.16
        0 0 0.36 0.29 0 0.32 0 0.19
        0.26 0.36 0 0.17 0 0 0.4 0.34
        0 0.29 0.17 0 0 0 0.52 0
        0.38 0 0 0 0 0.35 0.93 0.37
        0 0.32 0 0 0.35 0 0 0.28
        0.58 0 0.4 0.52 0.93 0 0 0
        0.16 0.19 0.34 0 0.37 0.28 0 0
    ]

    gx = SimpleGraph(distmx_sec)

    vec2 = Vector{Edge}([
        Edge(1, 8), Edge(2, 8), Edge(3, 4), Edge(5, 6), Edge(6, 8), Edge(3, 7), Edge(1, 3)
    ])
    weight_vec2 = sum(distmx_sec[src(e), dst(e)] for e in vec2)

    max_vec2 = Vector{Edge}([
        Edge(1, 7), Edge(2, 3), Edge(3, 7), Edge(4, 7), Edge(5, 7), Edge(5, 6), Edge(5, 8)
    ])
    weight_max_vec2 = sum(distmx_sec[src(e), dst(e)] for e in max_vec2)

    for g in test_generic_graphs(gx)
        res3 = boruvka_mst(g, distmx_sec)
        edges3 = [Edge(src(e), dst(e)) for e in res3.mst]
        g3t = GenericGraph(SimpleGraph(edges3))
        @test res3.weight == weight_vec2
        @test nv(g3t) - length(connected_components(g3t)) == ne(g3t)
        @test nv(g3t) == nv(gx)

        res4 = boruvka_mst(g, distmx_sec; minimize=false)
        edges4 = [Edge(src(e), dst(e)) for e in res4.mst]
        g4t = GenericGraph(SimpleGraph(edges4))
        @test res4.weight == weight_max_vec2
        @test nv(g4t) - length(connected_components(g4t)) == ne(g4t)
        @test nv(g4t) == nv(gx)
    end

    # third test with two components

    distmx_third = [
        0 0 0.26 0 0.38 0 0.58 0.16 0 0 0 0
        0 0 0.36 0.29 0 0.32 0 0.19 0 0 0 0
        0.26 0.36 0 0.17 0 0 0.4 0.34 0 0 0 0
        0 0.29 0.17 0 0 0 0.52 0 0 0 0 0
        0.38 0 0 0 0 0.35 0.93 0.37 0 0 0 0
        0 0.32 0 0 0.35 0 0 0.28 0 0 0 0
        0.58 0 0.4 0.52 0.93 0 0 0 0 0 0 0
        0.16 0.19 0.34 0 0.37 0.28 0 0 0 0 0 0
        0 0 0 0 0 0 0 0 0 1 5 6
        0 0 0 0 0 0 0 0 1 0 4 10
        0 0 0 0 0 0 0 0 5 4 0 3
        0 0 0 0 0 0 0 0 6 10 3 0
    ]

    gd = SimpleGraph(distmx_third)

    vec3 = Vector{Edge}([
        Edge(1, 8),
        Edge(2, 8),
        Edge(3, 4),
        Edge(5, 6),
        Edge(6, 8),
        Edge(3, 7),
        Edge(9, 10),
        Edge(11, 12),
        Edge(1, 3),
        Edge(10, 11),
    ])
    weight_vec3 = sum(distmx_third[src(e), dst(e)] for e in vec3)

    max_vec3 = Vector{Edge}([
        Edge(1, 7),
        Edge(2, 3),
        Edge(3, 7),
        Edge(4, 7),
        Edge(5, 7),
        Edge(5, 6),
        Edge(5, 8),
        Edge(9, 12),
        Edge(10, 12),
        Edge(9, 11),
    ])
    weight_max_vec3 = sum(distmx_third[src(e), dst(e)] for e in max_vec3)

    for g in test_generic_graphs(gd)
        res5 = boruvka_mst(g, distmx_third)
        edges5 = [Edge(src(e), dst(e)) for e in res5.mst]
        g5t = GenericGraph(SimpleGraph(edges5))
        @test res5.weight == weight_vec3
        @test nv(g5t) - length(connected_components(g5t)) == ne(g5t)
        @test nv(g5t) == nv(gd)

        res6 = boruvka_mst(g, distmx_third; minimize=false)
        edges6 = [Edge(src(e), dst(e)) for e in res6.mst]
        g6t = GenericGraph(SimpleGraph(edges6))
        @test res6.weight == weight_max_vec3
        @test nv(g6t) - length(connected_components(g6t)) == ne(g6t)
        @test nv(g6t) == nv(gd)
    end
end

@testset "BFSIterator" begin
    g = Graph()
    error_exc = ErrorException("Some source nodes for the iterator are not in the graph")
    @test_throws error_exc BFSIterator(g, 3)
    g = path_graph(7)
    add_edge!(g, 6, 3)
    add_edge!(g, 3, 1)
    add_edge!(g, 4, 7)
    g2 = deepcopy(g)
    add_vertex!(g2)
    add_vertex!(g2)
    add_edge!(g2, 8, 9)

    for g in testgraphs(g)
        nodes_visited = fill(0, nv(g))
        for (i, node) in enumerate(BFSIterator(g, 6))
            nodes_visited[i] = node
        end
        @test nodes_visited[1] == 6
        @test any(nodes_visited[2] .== [3, 5, 7])
        if nodes_visited[2] == 3
            @test nodes_visited[3:4] == [5, 7] || nodes_visited[3:4] == [7, 5]
        elseif nodes_visited[2] == 5
            @test nodes_visited[3:4] == [3, 7] || nodes_visited[3:4] == [7, 3]
        else
            @test nodes_visited[3:4] == [3, 5] || nodes_visited[3:4] == [5, 3]
        end
        @test any(nodes_visited[5] .== [1, 2, 4])
        if nodes_visited[5] == 1
            @test nodes_visited[6:7] == [2, 4] || nodes_visited[6:7] == [4, 2]
        elseif nodes_visited[5] == 2
            @test nodes_visited[6:7] == [1, 4] || nodes_visited[6:7] == [4, 1]
        else
            @test nodes_visited[6:7] == [1, 2] || nodes_visited[6:7] == [2, 1]
        end
    end
    nodes_visited = collect(BFSIterator(g2, [1, 6]))
    levels = ([1, 6], [2, 3, 5, 7], [4])
    @test sort(nodes_visited[1:2]) == sort(levels[1])
    @test sort(nodes_visited[3:6]) == sort(levels[2])
    @test sort(nodes_visited[7:end]) == sort(levels[3])

    nodes_visited = collect(BFSIterator(g2, [8, 1, 6]))
    levels = ([8, 1, 6], [2, 3, 5, 7, 9], [4])
    @test sort(nodes_visited[1:3]) == sort(levels[1])
    @test sort(nodes_visited[4:8]) == sort(levels[2])
    @test sort(nodes_visited[9:end]) == sort(levels[3])

    nodes_visited = collect(BFSIterator(g2, [8, 1, 6]; depth_limit=1))
    @test sort(nodes_visited[1:3]) == sort(levels[1])
    @test sort(nodes_visited[4:end]) == sort(levels[2])

    g = path_digraph(7)
    nodes_visited = collect(BFSIterator(g, 7; neighbors_type=inneighbors))
    @test nodes_visited == collect(7:-1:1)
end

# used in shortest path calculations

"""
    DefaultDistance

An array-like structure that provides distance values of `1` for any `src, dst` combination.
"""
struct DefaultDistance <: AbstractMatrix{Int}
    nv::Int
    DefaultDistance(nv::Int=typemax(Int)) = new(nv)
end

DefaultDistance(nv::Integer) = DefaultDistance(Int(nv))

function show(io::IO, x::DefaultDistance)
    return print(io, "$(x.nv) × $(x.nv) default distance matrix (value = 1)")
end
show(io::IO, z::MIME"text/plain", x::DefaultDistance) = show(io, x)

getindex(::DefaultDistance, s::Integer, d::Integer) = 1
getindex(::DefaultDistance, s::UnitRange, d::UnitRange) = DefaultDistance(length(s))
size(d::DefaultDistance) = (d.nv, d.nv)
transpose(d::DefaultDistance) = d
adjoint(d::DefaultDistance) = d

"""
    eccentricity(g[, v][, distmx])
    eccentricity(g[, vs][, distmx])

Return the eccentricity[ies] of a vertex / vertex list `v` or a set of vertices
`vs` defaulting to the entire graph. An optional matrix of edge distances may
be supplied; if missing, edge distances default to `1`.

The eccentricity of a vertex is the maximum shortest-path distance between it
and all other vertices in the graph.

The output is either a single float (when a single vertex is provided) or a
vector of floats corresponding to the vertex vector. If no vertex vector is
provided, the vector returned corresponds to each vertex in the graph.

### Performance
Because this function must calculate shortest paths for all vertices supplied
in the argument list, it may take a long time.

### Implementation Notes
The eccentricity vector returned by `eccentricity()` may be used as input
for the rest of the distance measures below. If an eccentricity vector is
provided, it will be used. Otherwise, an eccentricity vector will be calculated
for each call to the function. It may therefore be more efficient to calculate,
store, and pass the eccentricities if multiple distance measures are desired.

An infinite path length is represented by the `typemax` of the distance matrix.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph([0 1 0; 1 0 1; 0 1 0]);

julia> eccentricity(g, 1)
2

julia> eccentricity(g, [1; 2])
2-element Vector{Int64}:
 2
 1

julia> eccentricity(g, [1; 2], [0 2 0; 0.5 0 0.5; 0 2 0])
2-element Vector{Float64}:
 2.5
 0.5
```
"""
function eccentricity(
    g::AbstractGraph, v::Integer, distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number}
    e = maximum(dijkstra_shortest_paths(g, v, distmx).dists)
    e == typemax(T) && @warn("Infinite path length detected for vertex $v")

    return e
end

function eccentricity(g::AbstractGraph, vs=vertices(g), distmx::AbstractMatrix=weights(g))
    return [eccentricity(g, v, distmx) for v in vs]
end

function eccentricity(g::AbstractGraph, distmx::AbstractMatrix)
    return eccentricity(g, vertices(g), distmx)
end

"""
    diameter(eccentricities)
    diameter(g, distmx=weights(g))

Given a graph and optional distance matrix, or a vector of precomputed
eccentricities, return the maximum eccentricity of the graph.

An optimizied BFS algorithm (iFUB) is used for unweighted graphs, both in [undirected](https://www.sciencedirect.com/science/article/pii/S0304397512008687) 
and [directed](https://link.springer.com/chapter/10.1007/978-3-642-30850-5_10) cases.

# Examples
```jldoctest
julia> using Graphs

julia> diameter(star_graph(5))
2

julia> diameter(path_graph(5))
4
```
"""
function diameter end

diameter(eccentricities::Vector) = maximum(eccentricities)

diameter(g::AbstractGraph) = diameter(g, weights(g))

function diameter(g::AbstractGraph, ::DefaultDistance)
    if nv(g) == 0
        return 0
    end

    connected = is_directed(g) ? is_strongly_connected(g) : is_connected(g)

    if !connected
        return typemax(Int)
    end

    return _diameter_ifub(g)
end

function diameter(g::AbstractGraph, distmx::AbstractMatrix)
    return maximum(eccentricity(g, distmx))
end

function _diameter_ifub(g::AbstractGraph{T}) where {T<:Integer}
    nvg = nv(g)
    out_list = [outneighbors(g, v) for v in vertices(g)]

    if is_directed(g)
        in_list = [inneighbors(g, v) for v in vertices(g)]
    else
        in_list = out_list
    end

    active = trues(nvg)
    visited = falses(nvg)
    queue = Vector{T}(undef, nvg)
    distbuf = fill(typemax(T), nvg)
    diam = 0

    # Sort vertices by total degree (descending) to maximize pruning potential
    vs = collect(vertices(g))
    sort!(vs; by=v -> -(length(out_list[v]) + length(in_list[v])))

    for u in vs
        if !active[u]
            continue
        end

        # Forward BFS from u
        fill!(visited, false)
        visited[u] = true
        queue[1] = u
        front = 1
        back = 2
        level_end = 1
        e = 0

        while front < back
            v = queue[front]
            front += 1

            @inbounds for w in out_list[v]
                if !visited[w]
                    visited[w] = true
                    queue[back] = w
                    back += 1
                end
            end

            if front > level_end && front < back
                e += 1
                level_end = back - 1
            end
        end
        diam = max(diam, e)

        # Backward BFS (Pruning)
        dmax = diam - e

        # Only prune if we have a chance to exceed the current diameter
        if dmax >= 0
            fill!(distbuf, typemax(T))
            distbuf[u] = 0
            queue[1] = u
            front = 1
            back = 2

            while front < back
                v = queue[front]
                front += 1

                if distbuf[v] >= dmax
                    continue
                end

                @inbounds for w in in_list[v]
                    if distbuf[w] == typemax(T)
                        distbuf[w] = distbuf[v] + 1
                        queue[back] = w
                        back += 1
                    end
                end
            end

            # Prune vertices that cannot lead to a longer diameter
            @inbounds for v in vertices(g)
                if active[v] && distbuf[v] != typemax(T) && (distbuf[v] + e <= diam)
                    active[v] = false
                end
            end
        end

        if !any(active)
            break
        end
    end

    return diam
end

"""
    periphery(eccentricities)
    periphery(g, distmx=weights(g))

Given a graph and optional distance matrix, or a vector of precomputed
eccentricities, return the set of all vertices whose eccentricity is
equal to the graph's diameter (that is, the set of vertices with the
largest eccentricity).

# Examples
```jldoctest
julia> using Graphs

julia> periphery(star_graph(5))
4-element Vector{Int64}:
 2
 3
 4
 5

julia> periphery(path_graph(5))
2-element Vector{Int64}:
 1
 5
```
"""
function periphery(eccentricities::Vector)
    diam = maximum(eccentricities)
    return filter(x -> eccentricities[x] == diam, 1:length(eccentricities))
end

function periphery(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return periphery(eccentricity(g, distmx))
end

"""
    radius(eccentricities)
    radius(g, distmx=weights(g))

Given a graph and optional distance matrix, or a vector of precomputed
eccentricities, return the minimum eccentricity of the graph.

# Examples
```jldoctest
julia> using Graphs

julia> radius(star_graph(5))
1

julia> radius(path_graph(5))
2
```
"""
radius(eccentricities::Vector) = minimum(eccentricities)
function radius(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return minimum(eccentricity(g, distmx))
end

"""
    center(eccentricities)
    center(g, distmx=weights(g))

Given a graph and optional distance matrix, or a vector of precomputed
eccentricities, return the set of all vertices whose eccentricity is equal
to the graph's radius (that is, the set of vertices with the smallest eccentricity).

# Examples
```jldoctest
julia> using Graphs

julia> center(star_graph(5))
1-element Vector{Int64}:
 1

julia> center(path_graph(5))
1-element Vector{Int64}:
 3
```
"""
function center(eccentricities::Vector)
    rad = radius(eccentricities)
    return filter(x -> eccentricities[x] == rad, 1:length(eccentricities))
end

function center(g::AbstractGraph, distmx::AbstractMatrix=weights(g))
    return center(eccentricity(g, distmx))
end

import Base: size
"""
    non_backtracking_matrix(g)

Return a non-backtracking matrix `B` and an edgemap storing the oriented
edges' positions in `B`.

Given two arcs ``A_{i j}` and `A_{k l}` in `g`, the
non-backtracking matrix ``B`` is defined as

``B_{A_{i j}, A_{k l}} = δ_{j k} * (1 - δ_{i l})``
"""
function non_backtracking_matrix(g::AbstractGraph)
    # idedgemap = Dict{Int,Edge}()
    edgeidmap = Dict{Edge,Int}()
    m = 0
    for e in edges(g)
        m += 1
        edgeidmap[e] = m
    end

    if !is_directed(g)
        for e in edges(g)
            m += 1
            edgeidmap[reverse(e)] = m
        end
    end

    nz = if is_directed(g)
        sum(indegree(g, v) * outdegree(g, v) for v in vertices(g))
    else
        sum(degree(g, v) * (degree(g, v) - 1) for v in vertices(g))
    end
    rowidx = sizehint!(Vector{Int}(), nz)
    colidx = sizehint!(Vector{Int}(), nz)
    for (e, u) in edgeidmap
        i, j = src(e), dst(e)
        for k in inneighbors(g, i)
            k == j && continue
            v = edgeidmap[Edge(k, i)]

            push!(rowidx, v)
            push!(colidx, u)
        end
    end

    B = sparse(rowidx, colidx, ones(Int, length(rowidx)), m, m)
    return B, edgeidmap
end

"""
    Nonbacktracking{G}

A compact representation of the nonbacktracking operator.

The Nonbacktracking operator can be used for community detection.
This representation is compact in that it uses only ne(g) additional storage
and provides an implicit representation of the matrix B_g defined below.

Given two arcs ``A_{i j}` and `A_{k l}` in `g`, the
non-backtraking matrix ``B`` is defined as

``B_{A_{i j}, A_{k l}} = δ_{j k} * (1 - δ_{i l})``

This type is in the style of GraphMatrices.jl and supports the necessary operations
for computed eigenvectors and conducting linear solves.

Additionally the `contract!(vertexspace, nbt, edgespace)` method takes vectors
represented in the domain of ``B`` and represents them in the domain of the
adjacency matrix of `g`.
"""
struct Nonbacktracking{G<:AbstractGraph}
    g::G
    edgeidmap::Dict{Edge,Int}
    m::Int
end

function Nonbacktracking(g::AbstractGraph)
    edgeidmap = Dict{Edge,Int}()
    m = 0
    for e in edges(g)
        m += 1
        edgeidmap[e] = m
    end
    if !is_directed(g)
        for e in edges(g)
            m += 1
            edgeidmap[reverse(e)] = m
        end
    end
    return Nonbacktracking(g, edgeidmap, m)
end

size(nbt::Nonbacktracking) = (nbt.m, nbt.m)
size(nbt::Nonbacktracking, i::Number) = size(nbt)[i]
eltype(::Type{<:Nonbacktracking}) = Float64
issymmetric(nbt::Nonbacktracking) = false

function *(nbt::Nonbacktracking, x::Vector{T}) where {T<:Number}
    length(x) == nbt.m || error("dimension mismatch")
    y = zeros(T, length(x))
    for (e, u) in nbt.edgeidmap
        i, j = src(e), dst(e)
        for k in inneighbors(nbt.g, i)
            k == j && continue
            v = nbt.edgeidmap[Edge(k, i)]
            y[v] += x[u]
        end
    end
    return y
end
function mul!(C, nbt::Nonbacktracking, B)
    # computs C = A * B
    for i in 1:size(B, 2)
        C[:, i] = nbt * B[:, i]
    end
    return C
end

function coo_sparse(nbt::Nonbacktracking)
    m = nbt.m#= I,J = zeros(Int, m), zeros(Int, m) =#

    I, J = zeros(Int, 0), zeros(Int, 0)
    for (e, u) in nbt.edgeidmap
        i, j = src(e), dst(e)
        for k in inneighbors(nbt.g, i)
            k == j && continue
            v = nbt.edgeidmap[Edge(k, i)]#= J[u] = v =##= I[u] = u =#

            push!(I, v)
            push!(J, u)
        end
    end
    return I, J, 1.0
end

sparse(nbt::Nonbacktracking) = sparse(coo_sparse(nbt)..., nbt.m, nbt.m)

function *(nbt::Nonbacktracking, x::AbstractMatrix)
    y = zero(x)
    for i in 1:(nbt.m)
        y[:, i] = nbt * x[:, i]
    end
    return y
end

"""
    contract!(vertexspace, nbt, edgespace)

The mutating version of `contract(nbt, edgespace)`. Modifies `vertexspace`.
"""
function contract!(vertexspace::Vector, nbt::Nonbacktracking, edgespace::Vector)
    T = eltype(nbt.g)
    for i in one(T):nv(nbt.g), j in neighbors(nbt.g, i)
        u = nbt.edgeidmap[i > j ? Edge(j, i) : Edge(i, j)]
        vertexspace[i] += edgespace[u]
    end
end

# TODO: documentation needs work. sbromberger 20170326
"""
    contract(nbt, edgespace)

Integrate out the edges by summing over the edges incident to each vertex.
"""
function contract(nbt::Nonbacktracking, edgespace::Vector)
    y = zeros(eltype(edgespace), nv(nbt.g))
    contract!(y, nbt, edgespace)
    return y
end

using Random: Random
using Graphs.Test

@testset "SimpleGraphs" begin
    rng = StableRNG(1)
    adjmx1 = [0 1 0; 1 0 1; 0 1 0] # graph
    adjmx2 = [0 1 0; 1 0 1; 1 1 0] # digraph
    # specific concrete generators - no need for loop
    @test @inferred(eltype(SimpleGraph())) == Int
    @test @inferred(eltype(SimpleGraph(adjmx1))) == Int
    @test_throws ArgumentError SimpleGraph(adjmx2)

    @test_throws Graphs.NotImplementedError badj(DummySimpleGraph())

    @test @inferred(ne(SimpleGraph(path_digraph(5)))) == 4
    @test @inferred(!is_directed(SimpleGraph))
    @test @inferred(!is_directed(SimpleGraph{Int}))

    @test @inferred(eltype(SimpleDiGraph())) == Int
    @test @inferred(eltype(SimpleDiGraph(adjmx2))) == Int
    @test @inferred(ne(SimpleDiGraph(path_graph(5)))) == 8
    @test @inferred(is_directed(SimpleDiGraph))
    @test @inferred(is_directed(SimpleDiGraph{Int}))

    for gbig in [SimpleGraph(0xff), SimpleDiGraph(0xff)]
        @test @inferred(!add_vertex!(gbig))    # overflow
        @test @inferred(add_vertices!(gbig, 10) == 0)
    end

    gdx = path_digraph(4)
    gx = SimpleGraph()
    for g in testgraphs(gx)
        T = eltype(g)
        @test repr("text/plain", g) == "{0, 0} undirected simple $T graph"
        @test @inferred(add_vertices!(g, 5) == 5)
        @test repr("text/plain", g) == "{5, 0} undirected simple $T graph"
        @test eval(Meta.parse(repr(g))) == g
    end
    gx = SimpleDiGraph()
    for g in testdigraphs(gx)
        T = eltype(g)
        @test repr("text/plain", g) == "{0, 0} directed simple $T graph"
        @test @inferred(add_vertices!(g, 5) == 5)
        @test repr("text/plain", g) == "{5, 0} directed simple $T graph"
        @test eval(Meta.parse(repr(g))) == g
    end

    gx = path_graph(4)
    for g in testgraphs(gx)
        @test @inferred(vertices(g)) == 1:4
        @test Edge(2, 3) in edges(g)
        @test @inferred(nv(g)) == 4
        @test @inferred(fadj(g)) == badj(g) == adj(g) == g.fadjlist
        @test @inferred(fadj(g, 2)) == badj(g, 2) == adj(g, 2) == g.fadjlist[2]

        @test @inferred(has_edge(g, 2, 3))
        @test @inferred(!has_edge(g, 20, 3))
        @test @inferred(!has_edge(g, 2, 30))
        @test @inferred(has_edge(g, 3, 2))

        gc = copy(g)
        @test @inferred(add_edge!(gc, 4 => 1)) && gc == cycle_graph(4)
        @test @inferred(has_edge(gc, 4 => 1)) && has_edge(gc, 0x04 => 0x01)
        gc = copy(g)
        @test @inferred(add_edge!(gc, (4, 1))) && gc == cycle_graph(4)
        @test @inferred(has_edge(gc, (4, 1))) && has_edge(gc, (0x04, 0x01))
        gc = copy(g)
        @test add_edge!(gc, 4, 1) && gc == cycle_graph(4)

        @test @inferred(inneighbors(g, 2)) ==
            @inferred(outneighbors(g, 2)) ==
            @inferred(neighbors(g, 2)) ==
            [1, 3]
        @test @inferred(add_vertex!(gc))   # out of order, but we want it for issubset
        @test @inferred(g ⊆ gc)
        @test @inferred(has_vertex(gc, 5))

        @test @inferred(ne(g)) == 3

        @test @inferred(rem_edge!(gc, 1, 2)) && @inferred(!has_edge(gc, 1, 2))
        ga = @inferred(copy(g))
        @test @inferred(rem_vertex!(ga, 2)) && ne(ga) == 1
        @test @inferred(!rem_vertex!(ga, 10))

        @test @inferred(zero(g)) == SimpleGraph{eltype(g)}()

        # concrete tests below

        @test @inferred(eltype(g)) == eltype(fadj(g, 1)) == eltype(nv(g))
        T = @inferred(eltype(g))
        @test @inferred(nv(SimpleGraph{T}(6))) == 6

        @test @inferred(eltype(SimpleGraph{T})) == T
        @test @inferred(eltype(SimpleGraph{T}(adjmx1))) == T

        ga = SimpleGraph(10)
        @test @inferred(eltype(SimpleGraph{T}(ga))) == T

        for gd in testdigraphs(gdx)
            U = eltype(gd)
            @test @inferred(eltype(SimpleGraph(gd))) == U
        end

        @test @inferred(edgetype(g)) == SimpleGraphEdge{T}
        @test @inferred(copy(g)) == g
        @test @inferred(!is_directed(g))

        e = first(edges(g))
        @test @inferred(has_edge(g, e))
    end

    gdx = path_digraph(4)
    for g in testdigraphs(gdx)
        @test @inferred(vertices(g)) == 1:4
        @test Edge(2, 3) in edges(g)
        @test !(Edge(3, 2) in edges(g))
        @test @inferred(nv(g)) == 4
        @test @inferred(fadj(g)[2]) == fadj(g, 2) == [3]
        @test @inferred(badj(g)[2]) == badj(g, 2) == [1]
        @test_throws MethodError adj(g)

        @test @inferred(has_edge(g, 2, 3))
        @test @inferred(!has_edge(g, 3, 2))
        @test @inferred(!has_edge(g, 20, 3))
        @test @inferred(!has_edge(g, 2, 30))

        gc = copy(g)
        @test @inferred(add_edge!(gc, 4 => 1)) && gc == cycle_digraph(4)
        @test @inferred(has_edge(gc, 4 => 1)) && has_edge(gc, 0x04 => 0x01)
        gc = copy(g)
        @test @inferred(add_edge!(gc, (4, 1))) && gc == cycle_digraph(4)
        @test @inferred(has_edge(gc, (4, 1))) && has_edge(gc, (0x04, 0x01))
        gc = @inferred(copy(g))
        @test @inferred(add_edge!(gc, 4, 1)) && gc == cycle_digraph(4)

        @test @inferred(inneighbors(g, 2)) == [1]
        @test @inferred(outneighbors(g, 2)) == @inferred(neighbors(g, 2)) == [3]
        @test @inferred Set(all_neighbors(g, 2)) ==
            Set(union(inneighbors(g, 2), outneighbors(g, 2)))
        @test @inferred(add_vertex!(gc))   # out of order, but we want it for issubset
        @test @inferred(g ⊆ gc)
        @test @inferred(has_vertex(gc, 5))

        @test @inferred(ne(g)) == 3

        @test @inferred(!rem_edge!(gc, 2, 1))
        @test @inferred(rem_edge!(gc, 1, 2)) && @inferred(!has_edge(gc, 1, 2))
        ga = @inferred(copy(g))
        @test @inferred(rem_vertex!(ga, 2)) && ne(ga) == 1
        @test @inferred(!rem_vertex!(ga, 10))

        @test @inferred(zero(g)) == SimpleDiGraph{eltype(g)}()

        # concrete tests below

        @test @inferred(eltype(g)) == eltype(@inferred(fadj(g, 1))) == eltype(nv(g))
        T = @inferred(eltype(g))
        @test @inferred(nv(SimpleDiGraph{T}(6))) == 6

        @test @inferred(eltype(SimpleDiGraph{T})) == T
        @test @inferred(eltype(SimpleDiGraph{T}(adjmx2))) == T

        ga = SimpleDiGraph(10)
        @test @inferred(eltype(SimpleDiGraph{T}(ga))) == T

        for gu in testgraphs(gx)
            U = @inferred(eltype(gu))
            @test @inferred(eltype(SimpleDiGraph(gu))) == U
        end

        @test @inferred(edgetype(g)) == SimpleDiGraphEdge{T}
        @test @inferred(copy(g)) == g
        @test @inferred(is_directed(g))

        e = first(@inferred(edges(g)))
        @test @inferred(has_edge(g, e))
    end

    gx = complete_graph(4)
    for g in testgraphs(gx)
        h = Graph(g)
        @test g == h
        @test rem_vertex!(g, 2)
        @test nv(g) == 3 && ne(g) == 3
        @test g != h
    end

    gdx = complete_digraph(4)
    for g in testdigraphs(gdx)
        h = DiGraph(g)
        @test g == h
        @test rem_vertex!(g, 2)
        @test nv(g) == 3 && ne(g) == 6
        @test g != h
    end
    # tests for #820
    g = complete_graph(3)
    add_edge!(g, 3, 3)
    rem_vertex!(g, 1)
    @test nv(g) == 2 && ne(g) == 2 && has_edge(g, 1, 1)

    g = path_digraph(3)
    add_edge!(g, 3, 3)
    rem_vertex!(g, 1)
    @test nv(g) == 2 && ne(g) == 2 && has_edge(g, 1, 1)

    @testset "Cannot create graphs for noncrete integer type $T" for T in [Signed, Integer]
        @test_throws DomainError SimpleGraph{T}()
        @test_throws DomainError SimpleGraph{T}(one(T))

        @test_throws DomainError SimpleDiGraph{T}()
        @test_throws DomainError SimpleDiGraph{T}(one(T))
    end

    # Tests for constructors from iterators of edges
    @testset "Constructors from edge lists" begin
        g_undir = erdos_renyi(200, 100; rng=StableRNG(0))
        add_edge!(g_undir, 200, 1) # ensure that the result uses all vertices
        add_edge!(g_undir, 2, 2) # add a self-loop

        @testset "SimpleGraphFromIterator for edgetype $(edgetype(g))" for g in testgraphs(
            g_undir
        )

            # We create an edge list, shuffle it and reverse half of its edges
            # using this edge list should result in the same graph
            edge_list = [e for e in edges(g)]
            shuffle!(rng, edge_list)
            for i in rand(rng, 1:length(edge_list), length(edge_list) ÷ 2)
                e = edge_list[i]
                Te = typeof(e)
                edge_list[i] = Te(dst(e), src(e))
            end

            edge_iter = (e for e in edge_list)
            edge_set = Set(edge_list)
            edge_set_any = Set{Any}(edge_list)

            g1 = @inferred SimpleGraph(edge_list)
            # we can't infer the return type of SimpleGraphFromIterator at the moment 
            g2 = SimpleGraphFromIterator(edge_list)
            g3 = SimpleGraphFromIterator(edge_iter)
            g4 = SimpleGraphFromIterator(edge_set)
            g5 = SimpleGraphFromIterator(edge_set_any)

            @test g == g1
            @test g == g2
            @test g == g3
            @test g == g4
            @test g == g5
            @test edgetype(g) == edgetype(g1)
            @test edgetype(g) == edgetype(g2)
            @test edgetype(g) == edgetype(g3)
            @test edgetype(g) == edgetype(g4)
            @test edgetype(g) == edgetype(g5)
        end

        g_dir = erdos_renyi(200, 100; is_directed=true, rng=StableRNG(0))
        add_edge!(g_dir, 200, 1)
        add_edge!(g_dir, 2, 2)

        @testset "SimpleGraphFromIterator for edgetype $(edgetype(g))" for g in
                                                                           testdigraphs(
            g_dir
        )
            # We create an edge list and shuffle it
            edge_list = [e for e in edges(g)]
            shuffle!(rng, edge_list)

            edge_iter = (e for e in edge_list)
            edge_set = Set(edge_list)
            edge_set_any = Set{Any}(edge_list)

            g1 = @inferred SimpleDiGraph(edge_list)
            # we can't infer the return type of SimpleDiGraphFromIterator at the moment
            g2 = SimpleDiGraphFromIterator(edge_list)
            g3 = SimpleDiGraphFromIterator(edge_iter)
            g4 = SimpleDiGraphFromIterator(edge_set)
            g5 = SimpleDiGraphFromIterator(edge_set_any)

            @test g == g1
            @test g == g2
            @test g == g3
            @test g == g4
            @test g == g5
            @test edgetype(g) == edgetype(g1)
            @test edgetype(g) == edgetype(g2)
            @test edgetype(g) == edgetype(g3)
            @test edgetype(g) == edgetype(g4)
            @test edgetype(g) == edgetype(g5)
        end

        # SimpleGraphFromIterator of an empty iterator should result
        # in an empty graph of default edgetype
        empty_iter = (x for x in [])
        @testset "SimpleGraphFromIterator for empty iterator" begin
            @test SimpleGraphFromIterator(empty_iter) == SimpleGraph(0)
            @test edgetype(SimpleGraphFromIterator(empty_iter)) == edgetype(SimpleGraph(0))
        end
        @testset "SimpleGraphDiFromIterator for empty iterator" begin
            @test SimpleDiGraphFromIterator(empty_iter) == SimpleDiGraph(0)
            @test edgetype(SimpleDiGraphFromIterator(empty_iter)) ==
                edgetype(SimpleDiGraph(0))
        end

        @testset "SimpleGraphFromIterator for wrong edge types" begin
            @test_throws DomainError SimpleGraphFromIterator((i for i in 1:2))
        end

        @testset "SimpleDiGraphFromIterator for wrong edge types" begin
            @test_throws DomainError SimpleDiGraphFromIterator((
                SimpleDiGraphEdge(1, 2), "a string"
            ))
        end

        # check if multiple edges && multiple self-loops result in the
        # correct number of edges & vertices
        # edges using integers < 1 should be ignored
        g_undir = SimpleGraph(0)
        @testset "SimpleGraphFromIterator with self-loops and multiple edges, edgetype $(edgetype(g))" for g in
                                                                                                           testgraphs(
            SimpleGraph(0)
        )
            E = edgetype(g)
            edge_list =
                E.([(4, 4), (1, 2), (4, 4), (1, 2), (4, 4), (2, 1), (0, 1), (1, 0), (0, 0)])
            edge_iter = (e for e in edge_list)
            edge_set = Set(edge_list)
            edge_set_any = Set{Any}(edge_list)

            g1 = @inferred SimpleGraph(edge_list)
            g2 = SimpleGraphFromIterator(edge_list)
            g3 = SimpleGraphFromIterator(edge_iter)
            g4 = SimpleGraphFromIterator(edge_set)
            g5 = SimpleGraphFromIterator(edge_set_any)

            @test nv(g1) == 4
            @test nv(g2) == 4
            @test nv(g3) == 4
            @test nv(g4) == 4
            @test nv(g5) == 4

            @test ne(g1) == 2
            @test ne(g2) == 2
            @test ne(g3) == 2
            @test ne(g4) == 2
            @test ne(g5) == 2
        end

        @testset "SimpleDiGraphFromIterator with self-loops and multiple edges, edgetype $(edgetype(g))" for g in
                                                                                                             testdigraphs(
            SimpleDiGraph(0)
        )
            E = edgetype(g)
            edge_list =
                E.([(4, 4), (1, 2), (4, 4), (1, 2), (4, 4), (2, 1), (0, 1), (1, 0), (0, 0)])
            edge_iter = (e for e in edge_list)
            edge_set = Set(edge_list)
            edge_set_any = Set{Any}(edge_list)

            g1 = @inferred SimpleDiGraph(edge_list)
            g2 = SimpleDiGraphFromIterator(edge_list)
            g3 = SimpleDiGraphFromIterator(edge_iter)
            g4 = SimpleDiGraphFromIterator(edge_set)
            g5 = SimpleDiGraphFromIterator(edge_set_any)

            @test nv(g1) == 4
            @test nv(g2) == 4
            @test nv(g3) == 4
            @test nv(g4) == 4
            @test nv(g5) == 4

            @test ne(g1) == 3
            @test ne(g2) == 3
            @test ne(g3) == 3
            @test ne(g4) == 3
            @test ne(g5) == 3
        end

        # test for iterators where the type of the elements can only be determined at runtime
        g_undir = SimpleGraph(0)
        @testset "SimpleGraphFromIterator with edgelist of eltype Any" for g in testgraphs(
            g_undir
        )
            T = edgetype(g)
            edge_list_good = Any[T.(1, 2), T.(3, 4)]
            edge_list_bad = Any[T.(1, 2), Int64(1)]

            g1 = SimpleGraphFromIterator(edge_list_good)
            @test edgetype(g1) == T
            @test_throws DomainError SimpleGraphFromIterator(edge_list_bad)
        end
        g_dir = SimpleDiGraph(0)
        @testset "SimpleGraphDiFromIterator with edgelist of eltype Any" for g in
                                                                             testdigraphs(
            g_dir
        )
            T = edgetype(g)
            edge_list_good = Any[T.(1, 2), T.(3, 4)]
            edge_list_bad = Any[T.(1, 2), Int64(1)]

            g1 = SimpleDiGraphFromIterator(edge_list_good)
            @test edgetype(g1) == T
            @test_throws DomainError SimpleDiGraphFromIterator(edge_list_bad)
        end

        @testset "SimpleGraphFromIterator with edgelist of eltype Any" begin
            # If there are edges of multiple types, the construction should fail
            edge_list_1 = Any[Edge{Int8}(1, 2), Edge{Int16}(3, 4)]
            edge_list_2 = Any[Edge{Int16}(1, 2), Edge{Int8}(3, 4)]
            @test_throws DomainError SimpleGraphFromIterator(edge_list_1)
            @test_throws DomainError SimpleGraphFromIterator(edge_list_2)
        end

        @testset "SimpleDiGraphFromIterator with edgelist of eltype Any" begin
            edge_list_1 = Any[Edge{Int8}(1, 2), Edge{Int16}(3, 4)]
            edge_list_2 = Any[Edge{Int16}(1, 2), Edge{Int8}(3, 4)]
            @test_throws DomainError SimpleDiGraphFromIterator(edge_list_1)
            @test_throws DomainError SimpleDiGraphFromIterator(edge_list_2)
        end
    end

    # test for rem_vertices!
    let
        g_undir = complete_graph(5)
        g_dir = complete_digraph(5)
        for g in (testgraphs(g_undir) ∪ testdigraphs(g_dir))
            T = eltype(g)

            g5 = copy(g)
            vmap = @inferred rem_vertices!(g5, T[], keep_order=true)
            @test g5 == g
            @test vmap == 1:5
            @test isvalid_simplegraph(g5)

            g4 = copy(g)
            vmap = rem_vertices!(g4, T[3]; keep_order=true)
            @test g4 == (is_directed(g) ? complete_digraph(T(4)) : complete_graph(T(4)))
            @test vmap == [1, 2, 4, 5]
            @test isvalid_simplegraph(g4)

            g4 = copy(g)
            add_edge!(g4, 1, 1) # some self_loops
            add_edge!(g4, 2, 2)
            vmap = rem_vertices!(g4, T[1, 1, 1]; keep_order=false)
            @test ne(g4) == (is_directed(g) ? 13 : 7)
            @test sort(vmap) == [2, 3, 4, 5]
            @test isvalid_simplegraph(g4)

            g2 = copy(g)
            vmap = rem_vertices!(g2, T[2, 1, 4]; keep_order=false)
            @test g2 == (is_directed(g) ? complete_digraph(T(2)) : complete_graph(T(2)))
            @test sort(vmap) == [3, 5]
            @test isvalid_simplegraph(g2)

            g0 = copy(g)
            vmap = rem_vertices!(g0, T[1, 3, 2, 3, 5, 4]; keep_order=false)
            @test g0 == (is_directed(g) ? SimpleDiGraph(T(0)) : SimpleGraph(T(0)))
            @test isempty(vmap)
            @test isvalid_simplegraph(g0)
            vmap = rem_vertices!(g0, T[]; keep_order=false)
            @test g0 == (is_directed(g) ? SimpleDiGraph(T(0)) : SimpleGraph(T(0)))
            @test isempty(vmap)
            @test isvalid_simplegraph(g0)

            g5 = copy(g)
            @test_throws ArgumentError rem_vertices!(g5, T[2, 6], keep_order=true)
            g5 = copy(g)
            @test_throws ArgumentError rem_vertices!(g5, T[3, 0], keep_order=false)
        end

        g_undir = erdos_renyi(10, 0.5; rng=rng)
        g_dir = erdos_renyi(10, 0.5; is_directed=true, rng=rng)
        for u in 1:2:10
            add_edge!(g_undir, u, u)
            add_edge!(g_dir, u, u)
        end
        a = Random.randsubseq(1:10, 0.5)
        for g in (testgraphs(g_undir) ∪ testdigraphs(g_dir))
            T = eltype(g)

            gt = copy(g)
            gf = copy(g)
            a_converted = convert(Vector{T}, a)
            vmap_t = rem_vertices!(gt, a_converted; keep_order=true)
            vmap_f = rem_vertices!(gf, a_converted; keep_order=false)
            @test issorted(vmap_t)
            @test allunique(vmap_t)
            @test allunique(vmap_f)
            @test sort(vmap_f) == vmap_t
            @test length(vmap_f) == nv(g) - length(a_converted)
            @test vmap_t == setdiff(collect(vertices(g)), a_converted)
            @test Graphs.Experimental.has_isomorph(gt, gf)
            gi = g[setdiff(collect(vertices(g)), a_converted)]
            @test Graphs.Experimental.has_isomorph(gf, gi)
            @test isvalid_simplegraph(gt)
            @test isvalid_simplegraph(gf)
        end
    end
    # codecov for has_edge(::AbstractSimpleGraph, x, y)
    @test @inferred has_edge(DummySimpleGraph(), 1, 2)

    # Test for SimpleDiGraph equality #249
    @test SimpleGraph(1) != SimpleGraph(0)
    @test SimpleGraph(1) != SimpleGraph(2)
    @test SimpleGraph(2) != SimpleDiGraphFromIterator(Edge.([(1, 2)]))
    @test SimpleDiGraphFromIterator(Edge.([(1, 2)])) !=
        SimpleDiGraphFromIterator(Edge.([(2, 1)]))
    @test SimpleDiGraphFromIterator(Edge.([(1, 2), (2, 3)])) !=
        SimpleDiGraphFromIterator(Edge.([(1, 2), (3, 2)]))
    @test SimpleDiGraphFromIterator(Edge.([(1, 2), (2, 3)])) !=
        SimpleDiGraphFromIterator(Edge.([(1, 2), (1, 3)]))

    # Tests for constructors from AbstractGraph

    g = path_graph(4)
    add_vertex!(g)
    for h in [g, GenericGraph(g)]
        hu = SimpleGraph(h)
        hd = SimpleDiGraph(h)
        @test nv(hu) == 5
        @test ne(hu) == 3
        @test nv(hd) == 5
        @test ne(hd) == 6
        @test eltype(SimpleGraph{Int32}(h)) == Int32
        @test eltype(SimpleDiGraph{Int32}(h)) == Int32
    end

    g = path_digraph(4)
    add_vertex!(g)
    for h in [g, GenericDiGraph(g)]
        hu = SimpleGraph(h)
        hd = SimpleDiGraph(h)
        @test nv(hu) == 5
        @test ne(hu) == 3
        @test nv(hd) == 5
        @test ne(hd) == 3
    end

    g = union(path_digraph(4), reverse(path_digraph(4)))
    add_vertex!(g)
    for h in [g, GenericDiGraph(g)]
        hu = SimpleGraph(h)
        hd = SimpleDiGraph(h)
        @test nv(hu) == 5
        @test ne(hu) == 3
        @test nv(hd) == 5
        @test ne(hd) == 6
    end
end

"""
    struct DEsopoPape <: ShortestPathAlgorithm

The structure used to configure and specify that [`shortest_paths`](@ref)
should use the [D'Esopo-Pape algorithm](http://web.mit.edu/dimitrib/www/SLF.pdf).
No fields are specified or required.

### Implementation Notes
`DEsopoPape` supports the following shortest-path functionality:
- non-negative distance matrices / weights
- all destinations
"""
struct DEsopoPape <: ShortestPathAlgorithm end
struct DEsopoPapeResult{T,U<:Integer} <: ShortestPathResult
    parents::Vector{U}
    dists::Vector{T}
end

function shortest_paths(
    g::AbstractGraph, src::Integer, distmx::AbstractMatrix, ::DEsopoPape
)
    T = eltype(distmx)
    U = eltype(g)
    nvg = nv(g)
    (src in 1:nvg) || throw(DomainError(src, "src should be in between 1 and $nvg"))
    dists = fill(typemax(T), nvg)
    parents = zeros(U, nvg)
    state = Vector{Int8}()
    state = fill(Int8(2), nvg)
    q = U[src]
    @inbounds dists[src] = 0

    @inbounds while !isempty(q)
        u = popfirst!(q)
        state[u] = 0

        for v in outneighbors(g, u)
            alt = dists[u] + distmx[u, v]
            if (dists[v] > alt)
                dists[v] = alt
                parents[v] = u

                if state[v] == 2
                    state[v] = 1
                    push!(q, v)
                elseif state[v] == 0
                    state[v] = 1
                    pushfirst!(q, v)
                end
            end
        end
    end

    return DEsopoPapeResult{T,U}(parents, dists)
end

### DEVELOPERS NOTE: BFS optimization experiments are typically
### prototyped in gdistances!, since it's one of the simplest
### BFS implementations.

"""
    tree(parents)

Convert a parents array into a directed graph.
"""
function tree(parents::AbstractVector{T}) where {T<:Integer}
    n = T(length(parents))
    t = DiGraph{T}(n)
    for (v, u) in enumerate(parents)
        if u > zero(T) && u != v
            add_edge!(t, u, v)
        end
    end
    return t
end

"""
    bfs_parents(g, s[; dir=:out])

Perform a breadth-first search of graph `g` starting from vertex `s`.
Return a vector of parent vertices indexed by vertex. If `dir` is specified,
use the corresponding edge direction (`:in` and `:out` are acceptable values).


### Performance
This implementation is designed to perform well on large graphs. There are
implementations which are marginally faster in practice for smaller graphs,
but the performance improvements using this implementation on large graphs
can be significant.
"""
function bfs_parents(g::AbstractGraph, s::Integer; dir=:out)
    return if (dir == :out)
        _bfs_parents(g, s, outneighbors)
    else
        _bfs_parents(g, s, inneighbors)
    end
end

function _bfs_parents(g::AbstractGraph{T}, source, neighborfn::Function) where {T}
    n = nv(g)
    visited = falses(n)
    parents = zeros(T, n)
    cur_level = Vector{T}()
    sizehint!(cur_level, n)
    next_level = Vector{T}()
    sizehint!(next_level, n)
    k = 0
    @inbounds for s in source
        if !visited[s]
            visited[s] = true
            push!(cur_level, s)
            parents[s] = s
            k += 1
        end
    end
    while !isempty(cur_level)
        @inbounds for v in cur_level
            # TODO we previously used @simd on the loop below, but this would fail
            # if the result of neighorfn(g, v) would not implement firstindex
            # If @simd really has a performance advantage, then maybe we make
            # two different cases here.
            @inbounds for i in neighborfn(g, v)
                if !visited[i]
                    push!(next_level, i)
                    parents[i] = v
                    visited[i] = true
                    k += 1
                end
            end
            k == n && return parents
        end
        empty!(cur_level)
        cur_level, next_level = next_level, cur_level
        sort!(cur_level)
    end
    return parents
end

"""
    bfs_tree(g, s[; dir=:out])

Provide a breadth-first traversal of the graph `g` starting with source vertex `s`,
and return a directed acyclic graph of vertices in the order they were discovered.
If `dir` is specified, use the corresponding edge direction (`:in` and `:out` are
acceptable values).
"""
bfs_tree(g::AbstractGraph, s::Integer; dir=:out) = tree(bfs_parents(g, s; dir=dir))

"""
    gdistances!(g, source, dists; sort_alg=QuickSort)

Fill `dists` with the geodesic distances of vertices in `g` from source vertex (or
collection of vertices) `source`. `dists` should be a vector of length `nv(g)` 
filled with `typemax(T)`. Return `dists`.

For vertices in disconnected components the default distance is `typemax(T)`.

An optional sorting algorithm may be specified (see Performance section).

### Performance
`gdistances` uses `QuickSort` internally for its default sorting algorithm, since it performs
the best of the algorithms built into Julia Base. However, passing a `RadixSort` (available via
[SortingAlgorithms.jl](https://github.com/JuliaCollections/SortingAlgorithms.jl)) will provide
significant performance improvements on larger graphs.
"""
function gdistances!(g::AbstractGraph{T}, source, vert_level; sort_alg=QuickSort) where {T}
    n = nv(g)
    visited = falses(n)
    n_level = one(T)
    cur_level = Vector{T}()
    sizehint!(cur_level, n)
    next_level = Vector{T}()
    sizehint!(next_level, n)
    k = 0
    @inbounds for s in source
        if !visited[s]
            vert_level[s] = zero(T)
            visited[s] = true
            push!(cur_level, s)
            k += 1
        end
    end
    while !isempty(cur_level)
        @inbounds for v in cur_level
            @inbounds @simd for i in outneighbors(g, v)
                if !visited[i]
                    push!(next_level, i)
                    vert_level[i] = n_level
                    visited[i] = true
                    k += 1
                end
            end
            k == n && return vert_level
        end
        n_level += one(T)
        empty!(cur_level)
        cur_level, next_level = next_level, cur_level
        sort!(cur_level; alg=sort_alg)
    end
    return vert_level
end

"""
    gdistances(g, source; sort_alg=QuickSort)

Return a vector filled with the geodesic distances of vertices in  `g` from
`source`. If `source` is a collection of vertices each element should be unique.
For vertices in disconnected components the default distance is `typemax(T)`.

An optional sorting algorithm may be specified (see Performance section).

### Performance
`gdistances` uses `QuickSort` internally for its default sorting algorithm, since it performs
the best of the algorithms built into Julia Base. However, passing a `RadixSort` (available via
[SortingAlgorithms.jl](https://github.com/JuliaCollections/SortingAlgorithms.jl)) will provide
significant performance improvements on larger graphs.
"""
function gdistances(g::AbstractGraph{T}, source; sort_alg=Base.Sort.QuickSort) where {T}
    return gdistances!(g, source, fill(typemax(T), nv(g)); sort_alg=sort_alg)
end

"""
    has_path(g::AbstractGraph, u, v; exclude_vertices=Vector())

Return `true` if there is a path from `u` to `v` in `g` (while avoiding vertices in
`exclude_vertices`) or `u == v`. Return false if there is no such path or if `u` or `v`
is in `excluded_vertices`. 
"""
function has_path(
    g::AbstractGraph{T},
    u::Integer,
    v::Integer;
    exclude_vertices::AbstractVector=Vector{T}(),
) where {T}
    seen = zeros(Bool, nv(g))
    for ve in exclude_vertices # mark excluded vertices as seen
        seen[ve] = true
    end
    (seen[u] || seen[v]) && return false
    u == v && return true # cannot be separated
    next = Vector{T}()
    push!(next, u)
    seen[u] = true
    while !isempty(next)
        src = popfirst!(next) # get new element from queue
        for vertex in outneighbors(g, src)
            vertex == v && return true
            if !seen[vertex]
                push!(next, vertex) # push onto queue
                seen[vertex] = true
            end
        end
    end
    return false
end

@testset "Normalized Cut" begin
    gx = SimpleGraph(6)
    add_edge!(gx, 1, 2)
    add_edge!(gx, 2, 3)
    add_edge!(gx, 1, 3)
    add_edge!(gx, 4, 5)
    add_edge!(gx, 4, 6)
    add_edge!(gx, 5, 6)
    add_edge!(gx, 1, 6)
    add_edge!(gx, 3, 4)

    w = zeros(6, 6)
    w[2, 1] = 1.0
    w[3, 1] = 1.0
    w[6, 1] = 0.1
    w[1, 2] = 1.0
    w[3, 2] = 1.0
    w[1, 3] = 1.0
    w[2, 3] = 1.0
    w[4, 3] = 0.2
    w[3, 4] = 0.2
    w[5, 4] = 1.0
    w[6, 4] = 1.0
    w[4, 5] = 1.0
    w[6, 5] = 1.0
    w[1, 6] = 0.1
    w[4, 6] = 1.0
    w[5, 6] = 1.0

    for g in testgraphs(gx)
        labels = @inferred(normalized_cut(g, 1, w))
        @test labels == [1, 1, 1, 2, 2, 2] || labels == [2, 2, 2, 1, 1, 1]
    end

    w = SparseMatrixCSC(w)
    for g in testgraphs(gx)
        labels = @inferred(normalized_cut(g, 1, w))
        @test labels == [1, 1, 1, 2, 2, 2] || labels == [2, 2, 2, 1, 1, 1]
    end

    gx = SimpleGraph(4)
    add_edge!(gx, 1, 2)
    add_edge!(gx, 3, 4)

    w = zeros(4, 4)
    w[2, 1] = 1.0
    w[1, 2] = 1.0
    w[4, 3] = 1.0
    w[3, 4] = 1.0
    for g in testgraphs(gx)
        labels = @inferred(normalized_cut(g, 0.1, w))
        @test labels == [1, 1, 2, 2] || labels == [2, 2, 1, 1]
    end

    w = SparseMatrixCSC(w)
    for g in testgraphs(gx)
        labels = @inferred(normalized_cut(g, 0.1, w))
        @test labels == [1, 1, 2, 2] || labels == [2, 2, 1, 1]
    end

    w = ones(12, 12)
    for g in testgraphs(gx)
        labels = @inferred(normalized_cut(g, 0.1, w))
        @test labels == [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
    end

    w = ones(12, 12)
    for g in testgraphs(gx)
        labels = @inferred(normalized_cut(g, 0.1, w))
        @test labels == [1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1]
    end

    g = path_graph(50)

    function contiguous(labels::Vector{Int})::Bool
        changes = 0
        for i in 1:(length(labels) - 1)
            if labels[i] != labels[i + 1]
                changes += 1
            end
        end
        return changes == length(unique(labels)) - 1
    end

    num_subgraphs = Vector{Int}(undef, 9)

    for t in [0.1, 0.2, 0.3, 0.4, 0.5, 0.6, 0.7, 0.8, 0.9]
        labels = @inferred(normalized_cut(g, t))
        @test contiguous(labels) == true
        num_subgraphs[convert(Int, 10 * t)] = size(unique(labels), 1)
    end

    @test issorted(num_subgraphs) == true

    @test any(
        length(unique(normalized_cut(g, t))) == 4 for t in [0.125, 0.15, 0.16, 0.175, 0.20]
    )
end

@testset "Clique percolation" begin
    function setofsets(array_of_arrays)
        return Set(map(BitSet, array_of_arrays))
    end

    function test_cliques(graph, expected)
        # Make test results insensitive to ordering
        return Set(clique_percolation(graph)) == setofsets(expected)
    end

    g = Graph(5)
    add_edge!(g, 1, 2)
    add_edge!(g, 2, 3)
    add_edge!(g, 3, 1)
    add_edge!(g, 1, 4)
    add_edge!(g, 4, 5)
    add_edge!(g, 5, 1)
    @test test_cliques(GenericGraph(g), Array[[1, 2, 3], [1, 4, 5]])
end

using Graphs.Experimental.Traversals

"""
    struct BFS <: ShortestPathAlgorithm

The structure used to configure and specify that [`shortest_paths`](@ref)
should use the [Breadth-First Search algorithm](https://en.wikipedia.org/wiki/Breadth-first_search).

An optional sorting algorithm may be specified (default = no sorting).
Sorting helps maintain cache locality and will improve performance on
very large graphs; for normal use, sorting will incur a performance
penalty.

`BFS` is the default algorithm used when a source is specified
but no distance matrix is specified.

### Implementation Notes
`BFS` supports the following shortest-path functionality:
- (optional) multiple sources
- all destinations
"""
struct BFS{T} <: ShortestPathAlgorithm
    traversal::T
end

BFS() = BFS(Traversals.BFS())
BFS(a::Base.Sort.Algorithm) = BFS(Traversals.BFS(a))

mutable struct BFSSPState{U} <: Traversals.AbstractTraversalState
    parents::Vector{U}
    dists::Vector{U}
    n_level::U
end

@inline function initfn!(s::BFSSPState, u)
    s.dists[u] = 0
    return true
end
@inline function newvisitfn!(s::BFSSPState, u, v)
    s.dists[v] = s.n_level
    s.parents[v] = u
    return true
end
@inline function postlevelfn!(s::BFSSPState{U}) where {U}
    s.n_level += one(U)
    return true
end

struct BFSResult{U<:Integer} <: ShortestPathResult
    parents::Vector{U}
    dists::Vector{U}
end

function shortest_paths(
    g::AbstractGraph{U}, ss::AbstractVector{U}, alg::BFS
) where {U<:Integer}
    n = nv(g)
    dists = fill(typemax(U), n)
    parents = zeros(U, n)
    state = BFSSPState(parents, dists, one(U))
    Traversals.traverse_graph!(g, ss, alg.traversal, state)
    return BFSResult(state.parents, state.dists)
end

function shortest_paths(
    g::AbstractGraph{U}, ss::AbstractVector{<:Integer}, alg::BFS
) where {U<:Integer}
    return shortest_paths(g, U.(ss), alg)
end
function shortest_paths(g::AbstractGraph{U}, s::Integer, alg::BFS) where {U<:Integer}
    return shortest_paths(g, Vector{U}([s]), alg)
end

##################################################################
#
#   Maximal independent sets of undirected graph
#   Derived from Graphs.jl: https://github.com/julialang/Graphs.jl
#
##################################################################

@testset "Independent Sets" begin
    function setofsets(array_of_arrays)
        return Set(map(Set, array_of_arrays))
    end

    function test_independent_sets(graph, expected)
        # Make test results insensitive to ordering
        okay_maximal =
            setofsets(@inferred(maximal_independent_sets(graph))) == setofsets(expected)
        okay_maximum = Set(@inferred(maximum_independent_set(graph))) in setofsets(expected)
        okay_maximum2 =
            length(@inferred(maximum_independent_set(graph))) == maximum(length.(expected))
        okay_number = @inferred(independence_number(graph)) == maximum(length.(expected))
        return okay_maximal && okay_maximum && okay_maximum2 && okay_number
    end

    gx = SimpleGraph(3)
    add_edge!(gx, 1, 2)
    for g in test_generic_graphs(gx)
        @test test_independent_sets(g, Array[[1, 3], [2, 3]])
    end
    add_edge!(gx, 2, 3)
    for g in test_generic_graphs(gx)
        @test test_independent_sets(g, Array[[1, 3], [2]])
    end
    @test independence_number(cycle_graph(11)) == 5
end

module GraphsSharedArraysExt

using Graphs
using SharedArrays: SharedArrays, SharedMatrix, SharedVector, sdata
using SharedArrays.Distributed: @distributed
using Random: shuffle

# betweenness
function Graphs.Parallel.distr_betweenness_centrality(
    g::AbstractGraph,
    vs=vertices(g),
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    endpoints=false,
)::Vector{Float64}
    n_v = nv(g)
    k = length(vs)
    isdir = is_directed(g)

    # Parallel reduction

    betweenness = @distributed (+) for s in vs
        temp_betweenness = zeros(n_v)
        if degree(g, s) > 0  # this might be 1?
            state = Graphs.dijkstra_shortest_paths(
                g, s, distmx; allpaths=true, trackvertices=true
            )
            if endpoints
                Graphs._accumulate_endpoints!(temp_betweenness, state, g, s)
            else
                Graphs._accumulate_basic!(temp_betweenness, state, g, s)
            end
        end
        temp_betweenness
    end

    Graphs._rescale!(betweenness, n_v, normalize, isdir, k)

    return betweenness
end

# closeness
function Graphs.Parallel.distr_closeness_centrality(
    g::AbstractGraph, distmx::AbstractMatrix=weights(g); normalize=true
)::Vector{Float64}
    n_v = Int(nv(g))
    closeness = SharedVector{Float64}(n_v)
    fill!(closeness, 0.0)

    @sync @distributed for u in vertices(g)
        if degree(g, u) == 0     # no need to do Dijkstra here
            closeness[u] = 0.0
        else
            d = Graphs.dijkstra_shortest_paths(g, u, distmx).dists
            δ = filter(x -> x != typemax(x), d)
            σ = sum(δ)
            l = length(δ) - 1
            if σ > 0
                closeness[u] = l / σ
                if normalize
                    n = l * 1.0 / (n_v - 1)
                    closeness[u] *= n
                end
            else
                closeness[u] = 0.0
            end
        end
    end
    return sdata(closeness)
end

# radiality
function Graphs.Parallel.distr_radiality_centrality(g::AbstractGraph)::Vector{Float64}
    n_v = nv(g)
    vs = vertices(g)
    n = ne(g)
    meandists = SharedVector{Float64}(Int(n_v))
    maxdists = SharedVector{Float64}(Int(n_v))

    @sync @distributed for i in 1:n_v
        d = Graphs.dijkstra_shortest_paths(g, vs[i])
        maxdists[i] = maximum(d.dists)
        meandists[i] = sum(d.dists) / (n_v - 1)
        nothing
    end
    dmtr = maximum(maxdists)
    radialities = collect(meandists)
    return ((dmtr + 1) .- radialities) ./ dmtr
end

# stress
function Graphs.Parallel.distr_stress_centrality(
    g::AbstractGraph, vs=vertices(g)
)::Vector{Int64}
    n_v = nv(g)
    k = length(vs)
    isdir = is_directed(g)

    # Parallel reduction
    stress = @distributed (+) for s in vs
        temp_stress = zeros(Int64, n_v)
        if degree(g, s) > 0  # this might be 1?
            state = Graphs.dijkstra_shortest_paths(g, s; allpaths=true, trackvertices=true)
            Graphs._stress_accumulate_basic!(temp_stress, state, g, s)
        end
        temp_stress
    end
    return stress
end

# generate_reduce
function Graphs.Parallel.distr_generate_reduce(
    g::AbstractGraph{T}, gen_func::Function, comp::Comp, reps::Integer
) where {T<:Integer,Comp}
    # Type assert required for type stability
    min_set::Vector{T} = @distributed ((x, y) -> comp(x, y) ? x : y) for _ in 1:reps
        gen_func(g)
    end
    return min_set
end

# eccentricity
function Graphs.Parallel.distr_eccentricity(
    g::AbstractGraph, vs=vertices(g), distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number}
    vlen = length(vs)
    eccs = SharedVector{T}(vlen)
    @sync @distributed for i in 1:vlen
        local d = Graphs.dijkstra_shortest_paths(g, vs[i], distmx)
        eccs[i] = maximum(d.dists)
    end
    d = sdata(eccs)
    maximum(d) == typemax(T) && @warn("Infinite path length detected")
    return d
end

# dijkstra shortest paths
function Graphs.Parallel.distr_dijkstra_shortest_paths(
    g::AbstractGraph{U}, sources=vertices(g), distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number} where {U}
    n_v = nv(g)
    r_v = length(sources)

    # TODO: remove `Int` once julialang/#23029 / #23032 are resolved
    dists = SharedMatrix{T}(Int(r_v), Int(n_v))
    parents = SharedMatrix{U}(Int(r_v), Int(n_v))

    @sync @distributed for i in 1:r_v
        state = Graphs.dijkstra_shortest_paths(g, sources[i], distmx)
        dists[i, :] = state.dists
        parents[i, :] = state.parents
    end

    result = Graphs.Parallel.MultipleDijkstraState(sdata(dists), sdata(parents))
    return result
end

# random greedy color
function Graphs.Parallel.distr_random_greedy_color(
    g::AbstractGraph{T}, reps::Integer
) where {T<:Integer}
    best = @distributed (Graphs.best_color) for i in 1:reps
        seq = shuffle(vertices(g))
        Graphs.perm_greedy_color(g, seq)
    end

    return convert(Graphs.Coloring{T}, best)
end

end

module Experimental

using Graphs
using Graphs.SimpleGraphs

export description,
    # isomorphism
    VF2,
    vf2,
    IsomorphismProblem,
    SubGraphIsomorphismProblem,
    InducedSubGraphIsomorphismProblem,
    could_have_isomorph,
    has_isomorph,
    all_isomorph,
    count_isomorph,
    has_induced_subgraphisomorph,
    count_induced_subgraphisomorph,
    all_induced_subgraphisomorph,
    has_subgraphisomorph,
    count_subgraphisomorph,
    all_subgraphisomorph,
    ShortestPaths
description() = "This module contains experimental graph functions."

include("isomorphism.jl")
include("vf2.jl") # Julian implementation of VF2 algorithm
include("Parallel/Parallel.jl")
include("Traversals/Traversals.jl")
include("ShortestPaths/ShortestPaths.jl")

end

@testset "DFSIterator" begin
    g = Graph()
    error_exc = ErrorException("Some source nodes for the iterator are not in the graph")
    @test_throws error_exc DFSIterator(g, 3)
    g = path_graph(7)
    add_edge!(g, 6, 3)
    add_edge!(g, 3, 1)
    add_edge!(g, 4, 7)
    g2 = deepcopy(g)
    add_vertex!(g2)
    add_vertex!(g2)
    add_edge!(g2, 8, 9)

    for g in testgraphs(g)
        nodes_visited = fill(0, nv(g))
        for (i, node) in enumerate(DFSIterator(g, 6))
            nodes_visited[i] = node
        end
        @test nodes_visited[1:2] == [6, 3]
        @test any(nodes_visited[3] .== [1, 4])
        if nodes_visited[3] == 1
            @test nodes_visited[4] == 2
            @test nodes_visited[5] == 4
            @test any(nodes_visited[6] .== [5, 7])
            if nodes_visited[6] == 5
                @test nodes_visited[7] == 7
            end
        else
            @test any(nodes_visited[4] .== [5, 7])
            if nodes_visited[4] == 5
                @test nodes_visited[5] == 7
            end
            @test nodes_visited[6] == 1
            @test nodes_visited[7] == 2
        end
    end
    nodes_visited = collect(DFSIterator(g2, [1, 6]))
    @test nodes_visited == [1, 2, 3, 4, 5, 6, 7]
    nodes_visited = collect(DFSIterator(g2, [8, 1, 6]))
    @test nodes_visited == [8, 9, 1, 2, 3, 4, 5, 6, 7]
end

@deprecate BullGraph() bull_graph()
@deprecate ChvatalGraph() chvatal_graph()
@deprecate CubicalGraph() cubical_graph()
@deprecate DesarguesGraph() desargues_graph()
@deprecate DiamondGraph() diamond_graph()
@deprecate DodecahedralGraph() dodecahedral_graph()
@deprecate FruchtGraph() frucht_graph()
@deprecate HeawoodGraph() heawood_graph()
@deprecate HouseGraph() house_graph()
@deprecate HouseXGraph() house_x_graph()
@deprecate IcosahedralGraph() icosahedral_graph()
@deprecate KarateGraph() karate_graph()
@deprecate KrackhardtKiteGraph() krackhardt_kite_graph()
@deprecate MoebiusKantorGraph() moebius_kantor_graph()
@deprecate OctahedralGraph() octahedral_graph()
@deprecate PappusGraph() pappus_graph()
@deprecate PetersenGraph() petersen_graph()
@deprecate SedgewickMazeGraph() sedgewick_maze_graph()
@deprecate TetrahedralGraph() tetrahedral_graph()
@deprecate TruncatedCubeGraph() truncated_cube_graph()
@deprecate TruncatedTetrahedronGraph() truncated_tetrahedron_graph()
@deprecate TruncatedTetrahedronDiGraph() truncated_tetrahedron_digraph()
@deprecate TutteGraph() tutte_graph()
@deprecate CompleteGraph(n) complete_graph(n)
@deprecate CompleteBipartiteGraph(n1, n2) complete_bipartite_graph(n1, n2)
@deprecate CompleteMultipartiteGraph(partitions) complete_multipartite_graph(partitions)
@deprecate TuranGraph(n, r) turan_graph(n, r)
@deprecate CompleteDiGraph(n) complete_digraph(n)
@deprecate StarGraph(n) star_graph(n)
@deprecate StarDigraph(n) star_digraph(n)
@deprecate PathGraph(n) path_graph(n)
@deprecate PathDiGraph(n) path_digraph(n)
@deprecate CycleGraph(n) cycle_graph(n)
@deprecate CycleDiGraph(n) cycle_digraph(n)
@deprecate WheelGraph(n) wheel_graph(n)
@deprecate WheelDiGraph(n) wheel_digraph(n)
@deprecate Grid(dims; periodic=false) grid(dims; periodic=false)
@deprecate BinaryTree(k) binary_tree(k)
@deprecate Doublebinary_tree(k) double_binary_tree(k)
@deprecate RoachGraph(k) roach_graph(k)
@deprecate CliqueGraph(k, n) clique_graph(k, n)
@deprecate LadderGraph(n) ladder_graph(n)
@deprecate Circularladder_graph(n) circular_ladder_graph(n)
@deprecate BarbellGraph(n1, n2) barbell_graph(n1, n2)
@deprecate LollipopGraph(n1, n2) lollipop_graph(n1, n2)

@testset "Core" begin
    e2 = GenericEdge(Edge(1, 3))
    e3 = GenericEdge(Edge(1, 4))
    # TODO do these tests make sense? One might define an edge type for some undirected
    # graph that is more like a set than a tuple -then reverse would not change the order
    @test @inferred(is_ordered(e2))
    @test @inferred(!is_ordered(reverse(e3)))

    # TODO we cannot test add_vertices! with generic graphs
    @testset "add_vertices!" begin
        gx = SimpleGraph(10)
        gdx = SimpleDiGraph(10)
        @testset "$g" for g in testgraphs(gx, gdx)
            gc = copy(g)
            @test add_vertices!(gc, 5) == 5
            @test @inferred(nv(gc)) == 15
        end
    end

    g5w = wheel_graph(5)
    g5wd = wheel_digraph(5)
    @testset "degree functions" begin
        @testset "$(typeof(g))" for g in test_generic_graphs(g5w)
            @test @inferred(indegree(g, 1)) == @inferred(outdegree(g, 1)) == 4
            @test degree(g, 1) == 4 # explicit codecov
            @test @inferred(indegree(g)) ==
                @inferred(outdegree(g)) ==
                @inferred(degree(g)) ==
                [4, 3, 3, 3, 3]

            @test @inferred(Δout(g)) == @inferred(Δin(g)) == @inferred(Δ(g)) == 4
            @test @inferred(δout(g)) == @inferred(δin(g)) == @inferred(δ(g)) == 3
            z1 = @inferred(degree_histogram(g))
            z2 = @inferred(degree_histogram(g, indegree))
            z3 = @inferred(degree_histogram(g, outdegree))
            @test z1 == z2 == z3 == Dict(4 => 1, 3 => 4)
        end
        @testset "$(typeof(g))" for g in test_generic_graphs(g5wd)
            @test @inferred(indegree(g, 2)) == 2
            @test @inferred(outdegree(g, 2)) == 1
            @test @inferred(degree(g, 2)) == 3
            @test @inferred(indegree(g)) == [0, 2, 2, 2, 2]
            @test @inferred(outdegree(g)) == [4, 1, 1, 1, 1]
            @test @inferred(degree(g)) == [4, 3, 3, 3, 3]
            @test @inferred(Δout(g)) == @inferred(Δ(g)) == 4
            @test @inferred(Δin(g)) == 2
            @test @inferred(δout(g)) == 1
            @test @inferred(δin(g)) == 0
            @test @inferred(δ(g)) == 3
            z1 = @inferred(degree_histogram(g))
            z2 = @inferred(degree_histogram(g, indegree))
            z3 = @inferred(degree_histogram(g, outdegree))
            @test z1 == Dict(4 => 1, 3 => 4)
            @test z2 == Dict(0 => 1, 2 => 4)
            @test z3 == Dict(4 => 1, 1 => 4)
        end
    end

    @testset "weights" begin
        @testset "$(typeof(g))" for g in test_generic_graphs(g5w, g5wd)
            @test @inferred(weights(g)) == Graphs.DefaultDistance(nv(g))
        end
    end

    @testset "neighbor functions" begin
        @testset "$(typeof(g))" for g in test_generic_graphs(g5w)
            @test collect(@inferred(neighbors(g, 2))) == [1, 3, 5]
            @test collect(@inferred(all_neighbors(g, 2))) == [1, 3, 5]
            @test @inferred(common_neighbors(g, 1, 5)) == [2, 4]
        end
        @testset "$(typeof(g))" for g in test_generic_graphs(g5wd)
            @test collect(@inferred(neighbors(g, 2))) == [3]
            @test Set(@inferred(all_neighbors(g, 2))) == Set([1, 3, 5])
            @test @inferred(common_neighbors(g, 1, 5)) == [2]
        end
    end

    @testset "self loops" begin
        @testset "$(typeof(g))" for g in testgraphs(g5w, g5wd)
            gsl = copy(g)
            add_edge!(gsl, 3, 3)
            add_edge!(gsl, 2, 2)
            @test @inferred(!has_self_loops(generic_graph(g)))
            @test @inferred(has_self_loops(generic_graph(gsl)))
            @test @inferred(num_self_loops(generic_graph(g))) == 0
            @test @inferred(num_self_loops(generic_graph(gsl))) == 2
        end
    end

    @testset "density" begin
        @testset "$(typeof(g))" for g in test_generic_graphs(g5w)
            @test @inferred(density(g)) == 0.8
        end

        @testset "$(typeof(g))" for g in test_generic_graphs(g5wd)
            @test @inferred(density(g)) == 0.4
        end
    end

    @testset "squash" for (g_in, g_expected) in [
        (SimpleGraph{Int64}(), SimpleGraph{UInt8}()),
        (SimpleDiGraph{UInt8}(), SimpleDiGraph{UInt8}()),
        (path_graph(Int16(126)), path_graph(UInt8(126))),
        (path_digraph(Int16(127)), path_digraph(UInt8(127))),
        (path_graph(Int16(254)), path_graph(UInt8(254))),
        (path_digraph(Int16(255)), path_digraph(UInt16(255))),
        (path_graph(UInt16(255)), path_graph(UInt16(255))),
        (star_graph(Int16(32766)), star_graph(UInt16(32766))),
        (star_digraph(Int32(32767)), star_digraph(UInt16(32767))),
        (cycle_graph(Int128(123)), cycle_graph(UInt8(123))),
    ]
        g_actual = squash(generic_graph(g_in))
        @test typeof(g_actual) === typeof(g_expected)
        @test g_actual == g_expected
    end
end

"""
    sample!([rng, ]a, k)

Sample `k` element from array `a` without repetition and eventually excluding elements in `exclude`.

### Optional Arguments
- `exclude=()`: elements in `a` to exclude from sampling.

### Implementation Notes
Changes the order of the elements in `a`. For a non-mutating version, see [`sample`](@ref).
"""
function sample!(rng::AbstractRNG, a::AbstractVector, k::Integer; exclude=())
    minsize = k + length(exclude)
    length(a) < minsize && throw(ArgumentError("vector must be at least size $minsize"))
    res = Vector{eltype(a)}()
    sizehint!(res, k)
    n = length(a)
    i = 1
    while length(res) < k
        r = rand(rng, 1:(n - i + 1))
        if !(a[r] in exclude)
            push!(res, a[r])
            a[r], a[n - i + 1] = a[n - i + 1], a[r]
            i += 1
        end
    end
    return res
end

function sample!(
    a::AbstractVector,
    k::Integer;
    exclude=(),
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    return sample!(rng_from_rng_or_seed(rng, seed), a, k; exclude=exclude)
end

"""
    sample(a, k; exclude=(), rng=nothing, seed=nothing)

Sample `k` element from AbstractVector `a` without repetition and eventually excluding elements in `exclude`.

### Optional Arguments
- `exclude=()`: elements in `a` to exclude from sampling.
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: seed the Random Number Generator with this value.

### Implementation Notes
Unlike [`sample!`](@ref), does not produce side effects.
"""
function sample(
    a::AbstractVector,
    k::Integer;
    exclude=(),
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    return sample!(rng_from_rng_or_seed(rng, seed), collect(a), k; exclude=exclude)
end

getRNG(seed::Integer=-1) = seed >= 0 ? MersenneTwister(seed) : GLOBAL_RNG

"""
    rng_from_rng_or_seed(rng, seed)

Helper function for randomized functions that can take a random generator as well as a seed argument.

Currently most randomized functions in this package take a seed integer as an argument.
As modern randomized Julia functions tend to take a random generator instead of a seed,
this function helps with the transition by taking `rng` and `seed` as an argument and
always returning a random number generator.
At least one of these arguments must be `nothing`.
"""
function rng_from_rng_or_seed(rng::Union{Nothing,AbstractRNG}, seed::Union{Nothing,Integer})
    !(isnothing(seed) || isnothing(rng)) &&
        throw(ArgumentError("Cannot specify both, seed and rng"))
    # TODO at some point we might emit a deprecation warning if a seed is specified
    !isnothing(seed) && return getRNG(seed)
    isnothing(rng) && return GLOBAL_RNG
    return rng
end

"""
    insorted(item, collection)

Return true if `item` is in sorted collection `collection`.

### Implementation Notes
Does not verify that `collection` is sorted.
"""
function insorted(item, collection)
    index = searchsortedfirst(collection, item)
    @inbounds return (index <= length(collection) && collection[index] == item)
end

"""
    findall!(A, B)

Set the `B[1:|I|]` to `I` where `I` is the set of indices `A[I]` returns true.

Assumes `length(B) >= |I|`.
"""
function findall!(A::Union{BitArray{1},Vector{Bool}}, B::Vector{T}) where {T<:Integer}
    len = 0
    @inbounds for (i, a) in enumerate(A)
        if a
            len += 1
            B[len] = i
        end
    end
    return B
end

"""
    unweighted_contiguous_partition(num_items, required_partitions)

Partition `1:num_items` into `required_partitions` number of partitions such that the
difference in length of the largest and smallest partition is at most 1.

### Performance
Time: O(required_partitions)
"""
function unweighted_contiguous_partition(num_items::Integer, required_partitions::Integer)
    left = 1
    part = Vector{UnitRange}(undef, required_partitions)
    for i in 1:required_partitions
        len = fld(num_items + i - 1, required_partitions)
        part[i] = left:(left + len - 1)
        left += len
    end
    return part
end

"""
    greedy_contiguous_partition(weight, required_partitions, num_items=length(weight))

Partition `1:num_items` into at most `required_partitions` number of contiguous partitions with
the objective of minimising the largest partition.
The size of a partition is equal to the num of the weight of its elements.
`weight[i] > 0`.

### Performance
Time: O(num_items+required_partitions)
Requires only one iteration over `weight` but may not output the optimal partition.

### Implementation Notes
`Balance(wt, left, right, n_items, n_part) =
max(sum(wt[left:right])*(n_part-1), sum(wt[right+1:n_items]))`.
Find `right` that minimises `Balance(weight, 1, right, num_items, required_partitions)`.
Set the first partition as `1:right`.
Repeat on indices `right+1:num_items` and one less partition.
"""
function greedy_contiguous_partition(
    weight::Vector{<:Integer}, required_partitions::Integer, num_items::U=length(weight)
) where {U<:Integer}
    suffix_sum = cumsum(reverse(weight))
    reverse!(suffix_sum)
    push!(suffix_sum, 0) # Eg. [2, 3, 1] => [6, 4, 1, 0]

    partitions = Vector{UnitRange{U}}()
    sizehint!(partitions, required_partitions)

    left = one(U)
    for partitions_remain in reverse(1:(required_partitions - 1))
        left >= num_items && break

        partition_size = weight[left] * partitions_remain # At least one item in each partition
        right = left

        # Find right: sum(wt[left:right])*partitions_remain and sum(wt[(right+1):num_items]) is balanced
        while right + one(U) < num_items && partition_size < suffix_sum[right + one(U)]
            right += one(U)
            partition_size += weight[right] * partitions_remain
        end
        # max( sum(wt[left:right]), sum(wt[(right+1):num_items]) ) = partition_size
        # max( sum(wt[left:(right-1)]), sum(wt[right:num_items]) ) = suffix_sum[right]
        if left != right && partition_size > suffix_sum[right]
            right -= one(U)
        end

        push!(partitions, left:right)
        left = right + one(U)
    end
    push!(partitions, left:num_items)

    return partitions
end

"""
    optimal_contiguous_partition(weight, required_partitions, num_items=length(weight))

Partition `1:num_items` into at most `required_partitions` number of contiguous partitions such
that the largest partition is minimised.
The size of a partition is equal to the sum of the weight of its elements.
`weight[i] > 0`.

### Performance
Time: O(num_items*log(sum(weight)))

### Implementation Notes
Binary Search for the partitioning over `[fld(sum(weight)-1, required_partitions), sum(weight)]`.
"""
function optimal_contiguous_partition(
    weight::Vector{<:Integer}, required_partitions::Integer, num_items::U=length(weight)
) where {U<:Integer}
    item_it = Iterators.take(weight, num_items)

    up_bound = sum(item_it) # Smallest known possible value
    low_bound = fld(up_bound - 1, required_partitions) # Largest known impossible value

    # Find optimal balance
    while up_bound > low_bound + 1
        search_for = fld(up_bound + low_bound, 2)

        sum_part = 0
        remain_part = required_partitions

        possible = true
        for w in item_it
            sum_part += w
            if sum_part > search_for
                sum_part = w
                remain_part -= 1
                if remain_part == 0
                    possible = false
                    break
                end
            end
        end
        if possible
            up_bound = search_for
        else
            low_bound = search_for
        end
    end
    best_balance = up_bound

    # Find the partition with optimal balance
    partitions = Vector{UnitRange{U}}()
    sizehint!(partitions, required_partitions)
    sum_part = 0
    left = 1
    for (i, w) in enumerate(item_it)
        sum_part += w
        if sum_part > best_balance
            push!(partitions, left:(i - 1))
            sum_part = w
            left = i
        end
    end
    push!(partitions, left:num_items)

    return partitions
end

"""
    isbounded(n)

Returns true if `typemax(n)` of an integer `n` exists.
"""
isbounded(n::Integer) = true
isbounded(n::BigInt) = false

"""
    isbounded(T)

Returns true if `typemax(T)` of a type `T <: Integer` exists.
"""
isbounded(::Type{T}) where {T<:Integer} = isconcretetype(T)
isbounded(::Type{BigInt}) = false

"""
    deepcopy_adjlist(adjlist::Vector{Vector{T}})

Internal utility function for copying adjacency lists.
On adjacency lists this function is more efficient than `deepcopy` for two reasons:
-  As of Julia v1.0.2, `deepcopy` is not typestable.
- `deepcopy` needs to track all references when traversing a recursive data structure
    in order to ensure that references to the same location do need get assigned to
    different locations in the copy. Because we can assume that all lists in our
    adjacency list are different, we don't need to keep track of them.
If `T` is not a bitstype (e.g. `BigInt`), we use the standard `deepcopy`.
"""
function deepcopy_adjlist(adjlist::Vector{Vector{T}}) where {T}
    isbitstype(T) || return deepcopy(adjlist)

    result = Vector{Vector{T}}(undef, length(adjlist))
    @inbounds for (i, list) in enumerate(adjlist)
        result_list = Vector{T}(undef, length(list))
        for (j, item) in enumerate(list)
            result_list[j] = item
        end
        result[i] = result_list
    end

    return result
end

collect_if_not_vector(xs::AbstractVector) = xs
collect_if_not_vector(xs) = collect(xs)

import Base.showerror
struct CycleError <: Exception end
function Base.showerror(io::IO, e::CycleError)
    return print(io, "Cycles are not allowed in this function.")
end

struct DFS <: TraversalAlgorithm end

function traverse_graph!(
    g::AbstractGraph{U},
    ss::AbstractVector,
    alg::DFS,
    state::AbstractTraversalState,
    neighborfn::Function=outneighbors,
) where {U<:Integer}
    n = nv(g)
    visited = falses(n)
    S = Vector{U}()
    sizehint!(S, length(ss))
    @inbounds for s in ss
        us = U(s)
        visited[us] = true
        push!(S, us)
        initfn!(state, us) || return false
    end
    while !isempty(S)
        v = S[end]
        previsitfn!(state, v) || return false
        new_neighbor_found = false
        @inbounds for i in neighborfn(g, v)
            visitfn!(state, v, i) || return false
            if !visited[i]  # find the first unvisited neighbor
                newvisitfn!(state, v, i) || return false
                new_neighbor_found = true
                visited[i] = true
                push!(S, i)
                break
            end
        end
        postvisitfn!(state, v) || return false
        if !new_neighbor_found  # no more new neighbors. Let's go to the next source vertex.
            postlevelfn!(state) || return false
            pop!(S)
        end
    end
    return true
end

mutable struct TopoSortState{T<:Integer} <: AbstractTraversalState
    vcolor::Vector{UInt8}
    verts::Vector{T}
    w::T
end

# 1 = visited
# 2 = vcolor 2
# @inline initfn!(s::TopoSortState{T}, u) where T = s.vcolor[u] = one(T)
@inline function previsitfn!(s::TopoSortState{T}, u) where {T}
    s.w = 0
    return true
end
@inline function visitfn!(s::TopoSortState{T}, u, v) where {T}
    return s.vcolor[v] != one(T)
end
@inline function newvisitfn!(s::TopoSortState{T}, u, v) where {T}
    s.w = v
    return true
end
@inline function postvisitfn!(s::TopoSortState{T}, u) where {T}
    if s.w != 0
        s.vcolor[s.w] = one(T)
    else
        s.vcolor[u] = T(2)
        push!(s.verts, u)
    end
    return true
end

# TODO this function might return incorrect result (see tests) - use Graphs.topological_sort instead
@traitfn function topological_sort(g::AG::IsDirected) where {T,AG<:AbstractGraph{T}}
    vcolor = zeros(UInt8, nv(g))
    verts = Vector{T}()
    state = TopoSortState(vcolor, verts, zero(T))
    for v in vertices(g)
        state.vcolor[v] != 0 && continue
        state.vcolor[v] = 1
        if !traverse_graph!(g, v, DFS(), state)
            throw(CycleError())
        end
    end
    return reverse(state.verts)
end

mutable struct CycleState{T<:Integer} <: AbstractTraversalState
    vcolor::Vector{UInt8}
    w::T
end

@inline function previsitfn!(s::CycleState{T}, u) where {T}
    s.w = 0
    return true
end
@inline function visitfn!(s::CycleState{T}, u, v) where {T}
    return s.vcolor[v] != one(T)
end
@inline function newvisitfn!(s::CycleState{T}, u, v) where {T}
    s.w = v
    return true
end
@inline function postvisitfn!(s::CycleState{T}, u) where {T}
    if s.w != 0
        s.vcolor[s.w] = one(T)
    else
        s.vcolor[u] = T(2)
    end
    return true
end

@traitfn function is_cyclic(g::AG::IsDirected) where {T,AG<:AbstractGraph{T}}
    vcolor = zeros(UInt8, nv(g))
    state = CycleState(vcolor, zero(T))
    @inbounds for v in vertices(g)
        state.vcolor[v] != 0 && continue
        state.vcolor[v] = 1
        !traverse_graph!(g, v, DFS(), state) && return true
    end
    return false
end

# The test here cannot be done with GenericDiGraph, as the functions under test
# modify the graph. We probably need another generic graph type with more relaxed
# constraints for modifying graphs.

@testset "ICT" begin
    Gempty = SimpleDiGraph(3)
    Gsomedges = SimpleDiGraph(6)
    add_edge!(Gsomedges, 4, 5)
    add_edge!(Gsomedges, 6, 5)
    for Gtemplate in (Gempty, Gsomedges)
        for dir in (:out, :in)
            G = copy(Gtemplate)
            ict = IncrementalCycleTracker(G; dir=dir)
            @test_nowarn repr(ict)
            @test add_edge_checked!(ict, 1, 2)
            @test add_edge_checked!(ict, 2, 3)
            @test length(edges(G)) == 2 + length(edges(Gtemplate))
            @test !add_edge_checked!(ict, 3, 1)
            @test !add_edge_checked!(ict, 3, 2)
            if dir === :in
                @test !add_edge_checked!(ict, (2, 3), 1)
                @test !add_edge_checked!(ict, (1, 3), 2)
            else
                @test !add_edge_checked!(ict, 3, (1, 2))
                @test !add_edge_checked!(ict, 2, (1, 3))
            end
            @test length(edges(G)) == 2 + length(edges(Gtemplate))
            @test filter(in((1, 2, 3)), topological_sort(ict)) == [1, 2, 3]
        end
    end

    Gcycle2 = SimpleDiGraph(2)
    add_edge!(Gcycle2, 1, 2)
    add_edge!(Gcycle2, 2, 1)
    @test_throws ErrorException IncrementalCycleTracker(Gcycle2)

    Gcycle3 = SimpleDiGraph(3)
    add_edge!(Gcycle3, 1, 2)
    add_edge!(Gcycle3, 2, 3)
    add_edge!(Gcycle3, 3, 1)
    @test_throws ErrorException IncrementalCycleTracker(Gcycle3)
end

# DFS implementation optimized from http://www.cs.nott.ac.uk/~psznza/G5BADS03/graphs2.pdf
# Depth-first visit / traversal

"""
    is_cyclic(g)

Return `true` if graph `g` contains a cycle.

### Implementation Notes
The algorithm uses a DFS. Self-loops are counted as cycles.
"""
function is_cyclic end
@enum Vertex_state unvisited visited
@traitfn function is_cyclic(g::AG::(!IsDirected)) where {T,AG<:AbstractGraph{T}}
    visited = falses(nv(g))
    for v in vertices(g)
        visited[v] && continue
        visited[v] = true
        S = [(v, v)]
        while !isempty(S)
            parent, w = pop!(S)
            for u in neighbors(g, w)
                u == w && return true # self-loop
                u == parent && continue
                visited[u] && return true
                visited[u] = true
                push!(S, (w, u))
            end
        end
    end
    return false
end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function is_cyclic(g::AG::IsDirected) where {T,AG<:AbstractGraph{T}}
    # 0 if not visited, 1 if in the current dfs path, 2 if fully explored
    vcolor = zeros(UInt8, nv(g))
    vertex_stack = Vector{T}()
    for v in vertices(g)
        vcolor[v] != 0 && continue
        push!(vertex_stack, v)
        while !isempty(vertex_stack)
            u = vertex_stack[end]
            if vcolor[u] == 0
                vcolor[u] = 1
                for n in outneighbors(g, u)
                    # we hit a loop when reaching back a vertex of the main path
                    if vcolor[n] == 1
                        return true
                    elseif vcolor[n] == 0
                        # we store neighbors, but these are not yet on the path
                        push!(vertex_stack, n)
                    end
                end
            else
                pop!(vertex_stack)
                if vcolor[u] == 1
                    vcolor[u] = 2
                end
            end
        end
    end
    return false
end

"""
    topological_sort(g)

Return a [topological sort](https://en.wikipedia.org/wiki/Topological_sorting) of a directed
graph `g` as a vector of vertices in topological order.

### Implementation Notes
This is currently just an alias for `topological_sort_by_dfs`
"""
function topological_sort end

@traitfn function topological_sort(g::AG::IsDirected) where {AG<:AbstractGraph}
    return topological_sort_by_dfs(g)
end

# Topological sort using DFS
"""
    topological_sort_by_dfs(g)

Return a [topological sort](https://en.wikipedia.org/wiki/Topological_sorting) of a directed
graph `g` as a vector of vertices in topological order.
"""
function topological_sort_by_dfs end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function topological_sort_by_dfs(g::AG::IsDirected) where {T,AG<:AbstractGraph{T}}
    # 0 if not visited, 1 if in the current dfs path, 2 if fully explored
    vcolor = zeros(UInt8, nv(g))
    verts = Vector{T}()
    vertex_stack = Vector{T}()
    for v in vertices(g)
        vcolor[v] != 0 && continue
        push!(vertex_stack, v)
        while !isempty(vertex_stack)
            u = vertex_stack[end]
            if vcolor[u] == 0
                vcolor[u] = 1
                for n in outneighbors(g, u)
                    # we hit a loop when reaching back a vertex of the main path
                    if vcolor[n] == 1
                        error("The input graph contains at least one loop.") # TODO 0.7 should we use a different error?
                    elseif vcolor[n] == 0
                        # we store neighbors, but these are not yet on the path
                        push!(vertex_stack, n)
                    end
                end
            else
                pop!(vertex_stack)
                # if vcolor[u] == 2, the vertex was already explored and added to verts
                if vcolor[u] == 1
                    vcolor[u] = 2
                    pushfirst!(verts, u)
                end
            end
        end
    end
    return verts
end

"""
    dfs_tree(g, s[;dir=:out])

Provide a depth-first traversal of the graph `g` starting with source vertex `s`,
and return a directed acyclic graph of vertices in the order they were discovered.
If `dir` is specified, use the corresponding edge direction (`:in` and `:out` are
acceptable values).
"""
dfs_tree(g::AbstractGraph, s::Integer; dir=:out) = tree(dfs_parents(g, s; dir=dir))

"""
    dfs_parents(g, s[; dir=:out])

Perform a depth-first search of graph `g` starting from vertex `s`.
Return a vector of parent vertices indexed by vertex. If `dir` is specified,
use the corresponding edge direction (`:in` and `:out` are acceptable values).

### Implementation Notes
This version of DFS is iterative.
"""
function dfs_parents(g::AbstractGraph, s::Integer; dir=:out)
    return if (dir == :out)
        _dfs_parents(g, s, outneighbors)
    else
        _dfs_parents(g, s, inneighbors)
    end
end

function _dfs_parents(g::AbstractGraph{T}, s::Integer, neighborfn::Function) where {T}
    parents = zeros(T, nv(g))

    seen = zeros(Bool, nv(g))
    S = Vector{T}([s])
    seen[s] = true
    parents[s] = s
    while !isempty(S)
        v = S[end]
        u = 0
        for n in neighborfn(g, v)
            if !seen[n]
                u = n
                break
            end
        end
        if u == 0
            pop!(S)
        else
            seen[u] = true
            push!(S, u)
            parents[u] = v
        end
    end
    return parents
end

# export test_adjacency, test_laplacian, test_accessors, test_arithmetic, test_other
using ArnoldiMethod: LM, SR, LR, partialschur, partialeigen

@testset "Graph matrices" begin

    # TODO fixing the random number generator is not ideal, but currently
    # the tests here fail a bit too often when running them in ci/cd.

    rng = StableRNG(1)

    function converttest(T::Type, var)
        @test typeof(T(var)) == T
    end

    function constructors(mat)
        adjmat = CombinatorialAdjacency(mat)
        stochmat = StochasticAdjacency(adjmat)
        adjhat = NormalizedAdjacency(adjmat)
        avgmat = AveragingAdjacency(adjmat)
        return adjmat, stochmat, adjhat, avgmat
    end

    function test_adjacency(mat)
        adjmat, stochmat, adjhat, avgmat = constructors(mat)
        @test adjmat.D == vec(sum(mat; dims=1))
        @test adjmat.A == mat
        @test isa(sparse(mat), SparseMatrixCSC)
        @test isa(sparse(stochmat), SparseMatrixCSC)
        @test isa(sparse(adjhat), SparseMatrixCSC)
        @test isa(sparse(avgmat), SparseMatrixCSC)
        @test isa(convert(CombinatorialAdjacency, adjmat), CombinatorialAdjacency)
        @test isa(convert(CombinatorialAdjacency, avgmat), CombinatorialAdjacency)
        @test prescalefactor(adjhat) == postscalefactor(adjhat)
        @test postscalefactor(stochmat) == prescalefactor(avgmat)
        @test prescalefactor(adjhat) == postscalefactor(adjhat)
        @test prescalefactor(avgmat) == Noop()
    end

    function test_laplacian(mat)
        lapl = CombinatorialLaplacian(CombinatorialAdjacency(mat))
        @test typeof(lapl) <: Laplacian
        # constructors that work.
        @test adjacency(lapl).A == mat
        adj = adjacency(lapl)
        @test typeof(StochasticAdjacency(adj)) <: StochasticAdjacency
        @test typeof(NormalizedAdjacency(adj)) <: NormalizedAdjacency
        @test typeof(AveragingAdjacency(adj)) <: AveragingAdjacency

        @test typeof(adjacency(lapl)) <: CombinatorialAdjacency
        # converttest(SparseMatrix{Float64}, lapl)

        adjmat, stochmat, adjhat, avgmat = constructors(mat)
        @test typeof(adjacency(lapl)) <: CombinatorialAdjacency
        stochlapl = StochasticLaplacian(StochasticAdjacency(adjmat))
        @test typeof(adjacency(stochlapl)) <: StochasticAdjacency
        averaginglapl = AveragingLaplacian(AveragingAdjacency(adjmat))
        @test typeof(adjacency(averaginglapl)) <: AveragingAdjacency

        normalizedlapl = NormalizedLaplacian(NormalizedAdjacency(adjmat))
        @test typeof(adjacency(normalizedlapl)) <: NormalizedAdjacency
        @test !(typeof(adjacency(normalizedlapl)) <: CombinatorialAdjacency)

        # constructors that fail.
        @test_throws MethodError CombinatorialAdjacency(lapl)
        @test_throws MethodError StochasticLaplacian(lapl)
        @test_throws MethodError NormalizedLaplacian(lapl)
        @test_throws MethodError AveragingLaplacian(lapl)
        @test_throws MethodError convert(CombinatorialAdjacency, lapl)

        L = sparse(lapl)

        @test sum(abs, (sum(L; dims=1))) == 0
    end

    function test_accessors(mat, n)
        adjmat, stochmat, adjhat, avgmat = constructors(mat)
        dv = degrees(adjmat)
        @test degrees(StochasticLaplacian(stochmat)) == dv
        @test degrees(NormalizedLaplacian(adjhat)) == dv
        @test degrees(AveragingLaplacian(avgmat)) == dv

        for m in (adjmat, stochmat, adjhat, avgmat)
            @test degrees(m) == dv
            @test eltype(m) == eltype(m.A)
            @test size(m) == (n, n)
            #@fact length(m) --> length(adjmat.A)
        end
    end

    function test_arithmetic(mat, n)
        adjmat, stochmat, adjhat, avgmat = constructors(mat)
        lapl = CombinatorialLaplacian(adjmat)
        onevec = ones(Float64, n)
        v = adjmat * ones(Float64, n)
        @test sum(abs, (adjmat * onevec)) > 0.0
        @test sum(abs, ((stochmat * onevec) / sum(onevec))) ≈ 1.0
        @test sum(abs, (lapl * onevec)) == 0
        g(a) = sum(abs, (sum(sparse(a); dims=1)))

        @test g(lapl) == 0
        @test g(NormalizedLaplacian(adjhat)) > 1e-13
        @test g(StochasticLaplacian(stochmat)) > 1e-13

        @test eigs(adjmat; which=LR())[1][1] > 1.0
        @test eigs(stochmat; which=LR())[1][1] ≈ 1.0
        @test eigs(avgmat; which=LR())[1][1] ≈ 1.0
        @test eigs(lapl; which=LR())[1][1] > 2.0
        @test eigs(sparse(lapl); which=SR())[1][2] > 0.0
        @test eigs(sparse(lapl); which=SR())[1][1] < 1e-7

        lhat = NormalizedLaplacian(adjhat)
        @test eigs(lhat; which=LR())[1][1] < 2.0 + 1e-9
    end

    function test_other(mat, n)
        adjmat = CombinatorialAdjacency(mat)
        lapl = CombinatorialLaplacian(CombinatorialAdjacency(mat))
        @test size(lapl, 1) == n
        @test size(lapl, 2) == n
        @test size(lapl, 3) == 1

        @test_throws MethodError symmetrize(StochasticAdjacency(adjmat))
        @test_throws MethodError symmetrize(AveragingAdjacency(adjmat))
        @test !issymmetric(AveragingAdjacency(adjmat))
        @test !issymmetric(StochasticAdjacency(adjmat))
        @test_throws MethodError symmetrize(NormalizedAdjacency(adjmat)).A # --> adjmat.A

        begin
            @test CombinatorialAdjacency(mat) == CombinatorialAdjacency(mat)
            S = StochasticAdjacency(CombinatorialAdjacency(mat))
            @test S.A == S.A
            @test sparse(S) != S.A
            @test adjacency(S) == S.A
            @test NormalizedAdjacency(adjmat) != adjmat
            @test StochasticLaplacian(S) != adjmat
            @test_throws MethodError StochasticLaplacian(adjmat) # --> not(adjmat)
            @test !issymmetric(S)
        end
    end

    function test_symmetry(mat, n)
        adjmat = CombinatorialAdjacency(mat)
        lapl = CombinatorialLaplacian(CombinatorialAdjacency(mat))
        @test size(lapl, 1) == n
        @test size(lapl, 2) == n
        @test size(lapl, 3) == 1

        @test_throws MethodError symmetrize(StochasticAdjacency(adjmat))
        @test_throws MethodError symmetrize(AveragingAdjacency(adjmat))
        @test_throws MethodError symmetrize(NormalizedAdjacency(adjmat)).A # --> adjmat.A
        @test symmetrize(adjmat).A == adjmat.A
        # these tests are basically the code
        @test symmetrize(adjmat, :triu).A == triu(adjmat.A) + triu(adjmat.A)'
        @test symmetrize(adjmat, :tril).A == tril(adjmat.A) + tril(adjmat.A)'
        @test symmetrize(adjmat, :sum).A == adjmat.A + adjmat.A

        @test issymmetric(StochasticAdjacency(adjmat)) == false
        @test issymmetric(AveragingAdjacency(adjmat)) == false

        normalized_adjmat = NormalizedAdjacency(adjmat)
        @test issymmetric(normalized_adjmat) == issymmetric(normalized_adjmat.A)

        @test_throws ArgumentError symmetrize(adjmat, :fake)
    end

    function test_punchedmatrix(mat, n)
        adjmat = CombinatorialAdjacency(mat)
        ahatp = PunchedAdjacency(adjmat)
        y = ahatp * perron(ahatp)
        @test dot(y, ahatp.perron) ≈ 0.0 atol = 1.0e-8
        @test sum(abs, y) ≈ 0.0 atol = 1.0e-8
        eval, evecs = eigs(ahatp; which=LM())
        @test eval[1] - (1 + 1.0e-8) <= 0
        @test dot(perron(ahatp), evecs[:, 1]) ≈ 0.0 atol = 1e-8
        ahat = ahatp.A
        @test isa(ahat, NormalizedAdjacency)

        z = ahatp * perron(ahat)
        @test norm(z) ≈ 0.0 atol = 1e-8
    end

    n = 10

    mat = Float64.(sprand(rng, Bool, n, n, 0.3))

    test_adjacency(mat)
    test_laplacian(mat)
    test_accessors(mat, n)

    mat = symmetrize(Float64.(sprand(rng, Bool, n, n, 0.3)))
    test_arithmetic(mat, n)
    test_other(mat, n)
    test_symmetry(mat, n)
    test_punchedmatrix(mat, n)

    """Computes the stationary distribution of a random walk"""
    function stationarydistribution(R::StochasticAdjacency; kwargs...)
        er = eigs(R; nev=1, which=LR(), kwargs...)
        l1 = er[1][1]
        abs(l1 - 1) < 1e-8 || error("failed to compute stationary distribution") # TODO 0.7: should we change the error type to InexactError?
        p = real(er[2][:, 1])
        if p[1] < 0
            for i in eachindex(p)
                p[i] = -p[i]
            end
        end
        return p
    end

    function stationarydistribution(A::CombinatorialAdjacency; kwargs...)
        R = StochasticAdjacency(A)
        return stationarydistribution(R; kwargs...)
    end

    # Random walk demo
    n = 100
    p = 16 / n
    M = sprand(rng, n, n, p)
    M.nzval[:] .= 1.0
    A = CombinatorialAdjacency(M)
    sd = stationarydistribution(A; mindim=10)
    @test all(sd .>= 0)

    @testset "Noop" begin
        @testset "Noop broadcasted with * is identity" begin
            testobjects = [1, "string", 'c', cycle_graph(3), [1, 2, 3], sin, Noop()]
            for object in testobjects
                @test Noop() .* object === object
            end
        end

        @testset "Noop * is identity" begin
            testobjects = [1, "string", 'c', cycle_graph(3), [1, 2, 3], sin, Noop()]
            for object in testobjects
                @test Noop() * object === object
            end
        end
    end
end

# TODO the algorithms in this file probably relay on incorrect assumptions
# about the memory handling of Julia.
# See: https://github.com/JuliaGraphs/Graphs.jl/issues/10

"""
    partition_sources!(queue_list, sources)

Partition `sources` using [`Graphs.unweighted_contiguous_partition`](@ref) and place
the i^{th} partition  into `queue_list[i]` and set to empty_list[i] to true if the
i^{th} partition is empty.
"""
function partition_sources!(
    queue_list::Vector{Vector{T}}, sources::Vector{<:Integer}, empty_list::Vector{Bool}
) where {T<:Integer}
    partitions = Graphs.unweighted_contiguous_partition(length(sources), length(queue_list))
    for (i, p) in enumerate(partitions)
        append!(queue_list[i], sources[p])
        empty_list[i] = isempty(p)
    end
end

"""
    gdistances!(g, sources, vert_level; queue_segment_size=20)
    gdistances!(g, source, vert_level; queue_segment_size=20)

Parallel implementation of [`Graphs.gdistances!`](@ref) with dynamic load balancing.

### Optional Arguments
- `queue_segment_size = 20`: It is the number of vertices a thread can claim from a queue
at a time. For graphs with uniform degree, a larger value of `queue_segment_size` could
improve performance.

### References
- [Avoiding Locks and Atomic Instructions in Shared-Memory Parallel BFS Using Optimistic
Parallelization](https://www.computer.org/csdl/proceedings/ipdpsw/2013/4979/00/4979b628-abs.html).
"""
function gdistances!(
    g::AbstractGraph{T},
    sources::Vector{<:Integer},
    vert_level::Vector{T};
    queue_segment_size::Integer=20,
) where {T<:Integer}
    @warn "Graphs.Experimental.Parallel.gdistances is very likely broken at the moment and can return unreliable results."

    nvg = nv(g)
    n_t = nthreads()
    segment_size = convert(T, queue_segment_size) # Type stability
    fill!(vert_level, typemax(T))
    visited = zeros(Bool, nvg)

    # bitVector not thread safe
    next_level_t = [sizehint!(Vector{T}(), cld(nvg, n_t)) for _ in Base.OneTo(n_t)]
    cur_level_t = [sizehint!(Vector{T}(), cld(nvg, n_t)) for _ in Base.OneTo(n_t)]
    cur_front_t = ones(T, n_t)
    queue_explored_t = zeros(Bool, n_t)

    for s in sources
        visited[s] = true
        vert_level[s] = zero(T)
    end
    partition_sources!(cur_level_t, sources, queue_explored_t)
    is_cur_level_t_empty = isempty(sources)
    n_level = zero(T)

    while !is_cur_level_t_empty
        n_level += one(T)

        let n_level = n_level # let block used due to bug #15276
            @threads for thread_id in Base.OneTo(n_t)
                # Explore current level in parallel
                @inbounds next_level = next_level_t[thread_id]

                @inbounds for t_range in (thread_id:n_t, 1:(thread_id - 1)), t in t_range
                    queue_explored_t[t] && continue
                    cur_level = cur_level_t[t]
                    cur_len = length(cur_level)

                    # Explore cur_level_t[t] one segment at a time.
                    while true
                        local_front = cur_front_t[t]  # Data race, but first read always succeeds
                        cur_front_t[t] += segment_size # Failure of increment is acceptable

                        (local_front > cur_len || local_front <= zero(T)) && break
                        while local_front <= cur_len && cur_level[local_front] != zero(T)
                            v = cur_level[local_front]
                            cur_level[local_front] = zero(T)
                            local_front += one(T)

                            # Check if v was successfully read.
                            (visited[v] && vert_level[v] == n_level - one(T)) || continue
                            for i in outneighbors(g, v)
                                # Data race, but first read on visited[i] always succeeds
                                if !visited[i]
                                    vert_level[i] = n_level
                                    # Concurrent visited[i] = true always succeeds
                                    visited[i] = true
                                    push!(next_level, i)
                                end
                            end
                        end
                    end
                    queue_explored_t[t] = true
                end
            end
        end

        is_cur_level_t_empty = true
        @inbounds for t in Base.OneTo(n_t)
            cur_level_t[t], next_level_t[t] = next_level_t[t], cur_level_t[t]
            cur_front_t[t] = one(T)
            empty!(next_level_t[t])
            queue_explored_t[t] = isempty(cur_level_t[t])
            is_cur_level_t_empty = is_cur_level_t_empty && queue_explored_t[t]
        end
    end

    return vert_level
end

function gdistances!(
    g::AbstractGraph{T},
    source::Integer,
    vert_level::Vector{T};
    queue_segment_size::Integer=20,
) where {T<:Integer}
    return gdistances!(g, [source], vert_level; queue_segment_size=20)
end

"""
    gdistances(g, sources; queue_segment_size=20)
    gdistances(g, source; queue_segment_size=20)

Parallel implementation of [`Graphs.gdistances!`](@ref) with dynamic load balancing.

### Optional Arguments
- `queue_segment_size = 20`: It is the number of vertices a thread can claim from a queue at a time.
For denser graphs, a smaller value of `queue_segment_size` could improve performance.

### References
- [Avoiding Locks and Atomic Instructions in Shared-Memory Parallel BFS Using Optimistic
Parallelization](https://www.computer.org/csdl/proceedings/ipdpsw/2013/4979/00/4979b628-abs.html).
"""
function gdistances(
    g::AbstractGraph{T}, sources::Vector{<:Integer}; queue_segment_size::Integer=20
) where {T<:Integer}
    return gdistances!(g, sources, Vector{T}(undef, nv(g)); queue_segment_size=20)
end

function gdistances(
    g::AbstractGraph{T}, source::Integer; queue_segment_size::Integer=20
) where {T<:Integer}
    return gdistances!(g, [source], Vector{T}(undef, nv(g)); queue_segment_size=20)
end

@testset "Shortest_Path_Faster_Algorithm" begin
    @testset "Generic tests for graphs" begin
        g4 = path_digraph(5)
        d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])

        for g in test_generic_graphs(g4)
            y = @inferred(spfa_shortest_paths(g, 2, d1))
            @test y == [Inf, 0, 6, 17, 33]
        end

        @testset "Graph with cycle" begin
            gx = path_graph(5)
            add_edge!(gx, 2, 4)
            d = ones(Int, 5, 5)
            d[2, 3] = 100
            for g in test_generic_graphs(gx)
                z = @inferred(spfa_shortest_paths(g, 1, d))
                @test z == [0, 1, 3, 2, 3]
            end
        end

        m = [0 2 2 0 0; 2 0 0 0 3; 2 0 0 1 2; 0 0 1 0 1; 0 3 2 1 0]
        G = SimpleGraph(5)
        add_edge!(G, 1, 2)
        add_edge!(G, 1, 3)
        add_edge!(G, 2, 5)
        add_edge!(G, 3, 5)
        add_edge!(G, 3, 4)
        add_edge!(G, 4, 5)

        for g in test_generic_graphs(G)
            y = @inferred(spfa_shortest_paths(g, 1, m))
            @test y == [0, 2, 2, 3, 4]
        end
    end

    @testset "Graph with self loop" begin
        G = SimpleGraph(5)
        add_edge!(G, 2, 2)
        add_edge!(G, 1, 2)
        add_edge!(G, 1, 3)
        add_edge!(G, 3, 3)
        add_edge!(G, 1, 5)
        add_edge!(G, 2, 4)
        add_edge!(G, 4, 5)
        m = [0 10 2 0 15; 10 9 0 1 0; 2 0 1 0 0; 0 1 0 0 2; 15 0 0 2 0]
        for g in test_generic_graphs(G)
            z = @inferred(spfa_shortest_paths(g, 1, m))
            y = @inferred(dijkstra_shortest_paths(g, 1, m))
            @test isapprox(z, y.dists)
        end
    end

    @testset "Disconnected graph" begin
        G = SimpleGraph(5)
        add_edge!(G, 1, 2)
        add_edge!(G, 1, 3)
        add_edge!(G, 4, 5)
        inf = typemax(eltype(G))
        for g in test_generic_graphs(G)
            z = @inferred(spfa_shortest_paths(g, 1))
            @test z == [0, 1, 1, inf, inf]
        end
    end

    @testset "Empty graph" begin
        G = SimpleGraph(3)
        inf = typemax(eltype(G))
        for g in test_generic_graphs(G)
            z = @inferred(spfa_shortest_paths(g, 1))
            @test z == [0, inf, inf]
        end
    end

    @testset "Random Graphs" begin
        @testset "Simple graphs" begin
            for seed in 1:5
                rng = StableRNG(seed)
                nvg = Int(ceil(250 * rand(rng)))
                neg = Int(floor((nvg * (nvg - 1) / 2) * rand(rng)))
                g = GenericGraph(SimpleGraph(nvg, neg; rng=rng))
                z = spfa_shortest_paths(g, 1)
                y = dijkstra_shortest_paths(g, 1)
                @test isapprox(z, y.dists)
            end
        end

        @testset "Simple DiGraphs" begin
            for seed in 1:5
                rng = StableRNG(seed)
                nvg = Int(ceil(250 * rand(rng)))
                neg = Int(floor((nvg * (nvg - 1) / 2) * rand(rng)))
                g = GenericDiGraph(SimpleDiGraph(nvg, neg; rng=rng))
                z = spfa_shortest_paths(g, 1)
                y = dijkstra_shortest_paths(g, 1)
                @test isapprox(z, y.dists)
            end
        end
    end

    @testset "Different types of graph" begin
        G = GenericGraph(complete_graph(9))
        z = spfa_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z, y.dists)

        G = GenericDiGraph(complete_digraph(9))
        z = spfa_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z, y.dists)

        G = GenericGraph(cycle_graph(9))
        z = spfa_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z, y.dists)

        G = GenericDiGraph(cycle_digraph(9))
        z = spfa_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z, y.dists)

        G = GenericGraph(star_graph(9))
        z = spfa_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z, y.dists)

        G = GenericGraph(wheel_graph(9))
        z = spfa_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z, y.dists)

        G = GenericGraph(roach_graph(9))
        z = spfa_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z, y.dists)

        G = GenericGraph(clique_graph(5, 19))
        z = spfa_shortest_paths(G, 1)
        y = dijkstra_shortest_paths(G, 1)
        @test isapprox(z, y.dists)

        @testset "Small Graphs" begin
            for s in [
                :bull,
                :chvatal,
                :cubical,
                :desargues,
                :diamond,
                :dodecahedral,
                :frucht,
                :heawood,
                :house,
                :housex,
                :icosahedral,
                :krackhardtkite,
                :moebiuskantor,
                :octahedral,
                :pappus,
                :petersen,
                :sedgewickmaze,
                :tutte,
                :tetrahedral,
                :truncatedcube,
                :truncatedtetrahedron,
                :truncatedtetrahedron_dir,
            ]
                GS = smallgraph(s)
                GG = is_directed(GS) ? GenericDiGraph(GS) : GenericGraph(GS)
                z = spfa_shortest_paths(GG, 1)
                y = dijkstra_shortest_paths(GG, 1)
                @test isapprox(z, y.dists)
            end
        end
    end

    @testset "Normal graph" begin
        g4 = path_digraph(5)

        d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        d2 = sparse(
            float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
        )
        for g in test_generic_graphs(g4)
            y = @inferred(spfa_shortest_paths(g, 2, d1))
            z = @inferred(spfa_shortest_paths(g, 2, d2))
            @test y == z == [Inf, 0, 6, 17, 33]
            @test @inferred(!has_negative_edge_cycle_spfa(g))
            @test @inferred(!has_negative_edge_cycle_spfa(g, d1))

            y = @inferred(spfa_shortest_paths(g, 2, d1))
            z = @inferred(spfa_shortest_paths(g, 2, d2))
            @test y == z == [Inf, 0, 6, 17, 33]
            @test @inferred(!has_negative_edge_cycle_spfa(g))
            z = @inferred(spfa_shortest_paths(g, 2))
            @test z == [typemax(Int), 0, 1, 2, 3]
        end
    end

    @testset "Negative Cycle" begin
        # Negative Cycle 1
        gx = complete_graph(3)
        for g in test_generic_graphs(gx)
            d = [1 -3 1; -3 1 1; 1 1 1]
            @test_throws Graphs.NegativeCycleError spfa_shortest_paths(g, 1, d)
            @test has_negative_edge_cycle_spfa(g, d)

            d = [1 -1 1; -1 1 1; 1 1 1]
            @test_throws Graphs.NegativeCycleError spfa_shortest_paths(g, 1, d)
            @test has_negative_edge_cycle_spfa(g, d)
        end

        # Negative cycle of length 3 in graph of diameter 4
        gx = complete_graph(4)
        d = [1 -1 1 1; 1 1 1 -1; 1 1 1 1; 1 1 1 1]
        for g in test_generic_graphs(gx)
            @test_throws Graphs.NegativeCycleError spfa_shortest_paths(g, 1, d)
            @test has_negative_edge_cycle_spfa(g, d)
        end
    end
end

"""
    vertex_cover(g, reps, RandomVertexCover(); parallel=:threads, rng=nothing, seed=nothing)

Perform [`Graphs.vertex_cover(g, RandomVertexCover())`](@ref) `reps` times in parallel 
and return the solution with the fewest vertices.

### Optional Arguements
- `parallel=:threads`: If `parallel=:distributed` then the multiprocessor implementation is
used. This implementation is more efficient if `reps` is large.
"""
function vertex_cover(
    g::AbstractGraph{T},
    reps::Integer,
    alg::RandomVertexCover;
    parallel=:threads,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    return Graphs.Parallel.generate_reduce(
        g,
        (g::AbstractGraph{T}) -> Graphs.vertex_cover(g, alg; rng=rng, seed=seed),
        (x::Vector{T}, y::Vector{T}) -> length(x) < length(y),
        reps;
        parallel=parallel,
    )
end

# Parts of this code were taken / derived from NetworkX. See LICENSE for
# licensing details.

using Base.Threads

"""
    pagerank(g, α=0.85, n=100, ϵ=1.0e-6)

Calculate the [PageRank](https://en.wikipedia.org/wiki/PageRank) of the
graph `g` parameterized by damping factor `α`, number of iterations 
`n`, and convergence threshold `ϵ`. Return a vector representing the
centrality calculated for each node in `g`, or an error if convergence
is not reached within `n` iterations.
"""
function pagerank(g::AbstractGraph{U}, α=0.85, n::Integer=100, ϵ=1.0e-6) where {U<:Integer}
    α_div_outdegree = Vector{Float64}(undef, nv(g))
    dangling_nodes = Vector{U}()
    for v in vertices(g)
        if outdegree(g, v) == 0
            push!(dangling_nodes, v)
        end
        α_div_outdegree[v] = (α / outdegree(g, v))
    end
    N = Int(nv(g))
    # solution vector and temporary vector
    x = fill(1.0 / N, N)
    xlast = copy(x)
    for _ in 1:n
        dangling_sum = 0.0
        for v in dangling_nodes
            dangling_sum += x[v]
        end
        # flow from teleprotation
        for v in vertices(g)
            xlast[v] = (1 - α + α * dangling_sum) * (1.0 / N)
        end
        # flow from edges

        for v in vertices(g)
            for u in inneighbors(g, v)
                xlast[v] += (x[u] * α_div_outdegree[u])
            end
        end
        # l1 change in solution convergence criterion
        err = 0.0
        for v in vertices(g)
            err += abs(xlast[v] - x[v])
            x[v] = xlast[v]
        end
        if (err < N * ϵ)
            return x
        end
    end
    return error("Pagerank did not converge after $n iterations.") # TODO 0.7: change to InexactError with appropriate msg.
end

# The format of simplegraph files is as follows:
# a one line header: <num_vertices>, <num_edges>, {"d" | "u"}, <name>[, <ver>, <datatype>, <graphcode>]
#   - num_vertices is an integer
#   - num_edges is an integer
#   - "d" for directed graph, "u" for undirected. Note that this
#       option does not perform any additional edge construction; it's
#       merely used to return the correct type of graph.
#   - name is a string
#   - ver is optional and is an int
#   - datatype is mandatory if version is set and is a string ("UInt8", etc.)
#   - graphcode is mandatory if version is set and is a string.
# header followed by a list of (comma-delimited) edges - src,dst.
# Multiple graphs may be present in one file.

struct LGFormat <: AbstractGraphFormat end

struct LGHeader
    nv::Int
    ne::Int
    is_directed::Bool
    name::String
    ver::Int64
    dtype::DataType
    code::String
end
function show(io::IO, h::LGHeader)
    isdir = h.is_directed ? "d" : "u"
    return print(io, "$(h.nv),$(h.ne),$isdir,$(h.name),$(h.ver),$(h.dtype),$(h.code)")
end

function LGHeader(nv::Int, ne::Int, is_directed::Bool, name::AbstractString)
    return LGHeader(nv, ne, is_directed, name, 1, Int64, "simplegraph")
end

function _lg_read_one_graph(f::IO, header::LGHeader)
    T = header.dtype
    if header.is_directed
        g = DiGraph{T}(header.nv)
    else
        g = Graph{T}(header.nv)
    end
    for i in 1:(header.ne)
        line = chomp(readline(f))
        if length(line) > 0
            src_s, dst_s = split(line, r"\s*,\s*")
            src = parse(T, src_s)
            dst = parse(T, dst_s)
            add_edge!(g, src, dst)
        end
    end
    return g
end

function _lg_skip_one_graph(f::IO, n_e::Integer)
    for _ in 1:n_e
        readline(f)
    end
end

function _parse_header(s::AbstractString)
    addl_info = false
    nvstr, nestr, dirundir, graphname = split(s, r"s*,s*"; limit=4)
    if occursin(",", graphname) # version number and type
        graphname, _ver, _dtype, graphcode = split(graphname, r"s*,s*")
        ver = parse(Int, _ver)
        dtype = getfield(Main, Symbol(_dtype))
        addl_info = true
    end
    n_v = parse(Int, nvstr)
    n_e = parse(Int, nestr)
    dirundir = strip(dirundir)
    directed = !(dirundir == "u")
    graphname = strip(graphname)
    if !addl_info
        header = LGHeader(n_v, n_e, directed, graphname)
    else
        header = LGHeader(n_v, n_e, directed, graphname, ver, dtype, graphcode)
    end
    return header
end

"""
    loadlg_mult(io)

Return a dictionary of (name=>graph) loaded from IO stream `io`.
"""
function loadlg_mult(io::IO)
    graphs = Dict{String,AbstractGraph}()
    while !eof(io)
        line = strip(chomp(readline(io)))
        if !(startswith(line, "#") || line == "")
            header = _parse_header(line)
            g = _lg_read_one_graph(io, header)
            graphs[header.name] = g
        end
    end
    return graphs
end

function loadlg(io::IO, gname::String)
    while !eof(io)
        line = strip(chomp(readline(io)))
        (startswith(line, "#") || line == "") && continue
        header = _parse_header(line)
        if gname == header.name
            return _lg_read_one_graph(io, header)
        else
            _lg_skip_one_graph(io, header.ne)
        end
    end
    throw(ArgumentError("graph $gname not found"))
end

"""
    savelg(io, g, gname)

Write a graph `g` with name `gname` in a proprietary format
to the IO stream designated by `io`. Return 1 (number of graphs written).
"""
function savelg(io::IO, g::AbstractGraph{T}, gname::String) where {T}
    header = LGHeader(nv(g), ne(g), is_directed(g), gname, 2, T, "simplegraph")
    # write header line
    line = string(header)
    write(io, "$line\n")
    # write edges
    for e in edges(g)
        write(io, "$(src(e)),$(dst(e))\n")
    end
    return 1
end

"""
    savelg_mult(io, graphs)

Write a dictionary of (name=>graph) to an IO stream `io`,
with default `GZip` compression. Return number of graphs written.
"""
function savelg_mult(io::IO, graphs::Dict)
    ng = 0
    for (gname, g) in graphs
        ng += savelg(io, g, gname)
    end
    return ng
end

loadgraph(io::IO, gname::String, ::LGFormat) = loadlg(io, gname)
loadgraphs(io::IO, ::LGFormat) = loadlg_mult(io)
savegraph(io::IO, g::AbstractGraph, gname::String, ::LGFormat) = savelg(io, g, gname)
savegraph(io::IO, g::AbstractGraph, ::LGFormat) = savelg(io, g, "graph")
savegraph(io::IO, d::Dict, ::LGFormat) = savelg_mult(io, d)

@testset "Cycle Basis" begin
    function evaluate(x, y)
        x_sorted = sort(sort.(x))
        y_sorted = sort(sort.(y))
        @test x_sorted == y_sorted
    end

    # No Edges
    ex = Graph(1)
    expected_cyclebasis = Array{Int64,1}[]
    @testset "no edges" for g in test_generic_graphs(ex)
        ex_cyclebasis = @inferred cycle_basis(g)
        @test isempty(ex_cyclebasis)
    end

    # Only one self-edge
    elist = [(1, 1)]
    ex = Graph(SimpleEdge.(elist))
    expected_cyclebasis = Array{Int64,1}[[1]]
    @testset "one self-edge" for g in test_generic_graphs(ex)
        ex_cyclebasis = cycle_basis(g)
        evaluate(ex_cyclebasis, expected_cyclebasis)
    end

    # Graph with one cycle
    elist = [(1, 2), (2, 3), (3, 4), (4, 1), (1, 5)]
    ex = Graph(SimpleEdge.(elist))
    expected_cyclebasis = Array{Int64,1}[[1, 2, 3, 4]]
    @testset "one cycle" for g in test_generic_graphs(ex)
        ex_cyclebasis = cycle_basis(g)
        evaluate(ex_cyclebasis, expected_cyclebasis)
    end

    # Graph with 2 of 3 cycles forming a basis
    elist = [(1, 2), (1, 3), (2, 3), (2, 4), (3, 4)]
    ex = Graph(SimpleEdge.(elist))
    expected_cyclebasis = Array{Int64,1}[[2, 3, 4], [2, 1, 3]]
    @testset "2 of 3 cycles w/ basis" for g in test_generic_graphs(ex)
        ex_cyclebasis = cycle_basis(g)
        evaluate(ex_cyclebasis, expected_cyclebasis)
    end

    # Testing root argument
    elist = [(1, 2), (1, 3), (2, 3), (2, 4), (3, 4), (1, 5), (5, 6), (6, 4)]
    ex = Graph(SimpleEdge.(elist))
    expected_cyclebasis = Array{Int64,1}[[2, 4, 3], [1, 5, 6, 4, 3], [1, 2, 3]]
    @testset "root argument" for g in test_generic_graphs(ex)
        ex_cyclebasis = @inferred cycle_basis(g, 3)
        evaluate(ex_cyclebasis, expected_cyclebasis)
    end

    @testset "two isolated cycles" begin
        ex = blockdiag(cycle_graph(3), cycle_graph(4))
        expected_cyclebasis = [[1, 2, 3], [4, 5, 6, 7]]
        for g in test_generic_graphs(ex)
            found_cyclebasis = @inferred cycle_basis(g)
            evaluate(expected_cyclebasis, found_cyclebasis)
        end
    end
end

using Graphs.Experimental.Traversals
const LET = Graphs.Experimental.Traversals
struct DummyTraversalState <: LET.AbstractTraversalState end

@testset "Traversals" begin
    d = DummyTraversalState()
    @test LET.initfn!(d, 1) == true
    @test LET.previsitfn!(d, 1) == true
    @test LET.visitfn!(d, 1, 2) == true
    @test LET.newvisitfn!(d, 1, 2) == true
    @test LET.postvisitfn!(d, 1) == true
    @test LET.postlevelfn!(d) == true

    x = [3, 1, 2]
    @test sort!(x, 3, 1, LET.NOOPSort, Base.Sort.ForwardOrdering()) == x

    @testset "BFS" begin
        g1 = smallgraph(:house)
        dg1 = path_digraph(6)
        add_edge!(dg1, 2, 6)

        b1 = LET.BFS()
        @test b1 == LET.BFS(LET.NOOPSort)

        b2 = LET.BFS(QuickSort)

        @testset "undirected" begin
            for g in testgraphs(g1)
                v1 = @inferred LET.visited_vertices(g, 3, b1)
                v2 = @inferred LET.visited_vertices(g, 3, b2)
                v3 = @inferred LET.visited_vertices(g, [3], b1)
                @test v1 == v2 == v3 == [3, 1, 4, 5, 2]
                p1 = @inferred LET.parents(g, 2, b1)
                p2 = @inferred LET.parents(g, 2, b2)
                @test p1 == p2 == [2, 0, 1, 2, 4]
                d1 = @inferred LET.distances(g, 1, b1)
                d2 = @inferred LET.distances(g, 1, b2)
                d3 = @inferred LET.distances(g, [1], b1)
                @test d1 == d2 == d3 == [0, 1, 1, 2, 2]
                t1 = @inferred LET.tree(g, 2, b1)
                t2 = @inferred LET.tree(g, 2, b2)
                t3 = @inferred LET.tree(p1)
                t4 = @inferred LET.tree(p2)
                @test t1 == t2 == t3 == t4
            end
        end
        @testset "directed" begin
            for dg in testgraphs(dg1)
                v1 = @inferred LET.visited_vertices(dg, 1, b1)
                v2 = @inferred LET.visited_vertices(dg, 1, b2)
                v3 = @inferred LET.visited_vertices(dg, [1], b1)
                @test v1 == v2 == v3 == [1, 2, 3, 6, 4, 5]
                @test (@inferred LET.parents(dg, 2, b1)) ==
                    LET.parents(dg, 2, b2) ==
                    [0, 0, 2, 3, 4, 2]
                p1 = @inferred LET.parents(dg, 2, b1)
                p2 = @inferred LET.parents(dg, 2, b2)
                p3 = @inferred LET.parents(dg, 6, b1, inneighbors)
                p4 = @inferred LET.parents(dg, 6, b2, inneighbors)
                @test p1 == p2 == [0, 0, 2, 3, 4, 2]
                @test p3 == p4 == [2, 6, 4, 5, 6, 0]
                d1 = @inferred LET.distances(dg, 1, b1)
                d2 = @inferred LET.distances(dg, 1, b2)
                d3 = @inferred LET.distances(dg, [1], b1)
                @test d1 == d2 == d3 == [0, 1, 2, 3, 4, 2]
                t1 = @inferred LET.tree(dg, 2, b1)
                t2 = @inferred LET.tree(dg, 2, b2)
                t3 = @inferred LET.tree(p1)
                t4 = @inferred LET.tree(p2)
                @test t1 == t2 == t3 == t4
                t5 = @inferred LET.tree(dg, 6, b1, inneighbors)
                t6 = @inferred LET.tree(dg, 6, b2, inneighbors)
                t7 = @inferred LET.tree(p3)
                t8 = @inferred LET.tree(p4)
                @test t5 == t6 == t7 == t8
            end
        end
    end
    @testset "DFS" begin
        g1 = binary_tree(3)
        dg1 = DiGraph(g1)
        for e in edges(dg1)
            if src(e) > dst(e)
                rem_edge!(dg1, e)
            end
        end

        d = LET.DFS()
        @testset "undirected" begin
            for g in testgraphs(g1)
                v1 = @inferred LET.visited_vertices(g, 1, d)
                v2 = @inferred LET.visited_vertices(g, [1], d)
                @test v1 == v2 == [1, 2, 4, 5, 3, 6, 7]
                p1 = @inferred LET.parents(g, 2, d)
                @test p1 == [2, 0, 1, 2, 2, 3, 3]

                t1 = @inferred LET.tree(g, 2, d)
                t2 = @inferred LET.tree(p1)
                @test t1 == t2
            end
        end
        @testset "directed" begin
            for dg in testgraphs(dg1)
                dg2 = copy(dg)
                add_edge!(dg2, 6, 1)
                v1 = @inferred LET.visited_vertices(dg, 1, d)
                v2 = @inferred LET.visited_vertices(dg, [1], d)
                @test v1 == v2 == [1, 2, 4, 5, 3, 6, 7]

                p1 = @inferred LET.parents(dg, 2, d)
                @test p1 == [0, 0, 0, 2, 2, 0, 0]

                ts1 = @inferred LET.topological_sort(dg)
                @test ts1 == [1, 3, 7, 6, 2, 5, 4]
                @test_throws LET.CycleError LET.topological_sort(dg2)

                t1 = @inferred LET.tree(dg, 2, d)
                t2 = @inferred LET.tree(p1)
                @test t1 == t2

                @test !LET.is_cyclic(dg1)
                @test LET.is_cyclic(dg2)
            end

            # Currently there is an error in Traverals.topological_sort, so this test fails
            @test_broken LET.topological_sort(SimpleDiGraph([Edge(2, 1)])) == [2, 1]
        end
    end
end

# Parts of this code was written by @jpfairbanks.

# Parallel Breadth-first search / traversal using a frontier based parallelized
# approach.

#################################################
#
# Parallel frontier based Breadth-first search approach
#
#################################################
"""
    ThreadQueue

A thread safe queue implementation for using as the queue for BFS.
"""
struct ThreadQueue{T,N<:Integer}
    data::Vector{T}
    head::Atomic{N} # Index of the head
    tail::Atomic{N} # Index of the tail
end

function ThreadQueue(T::Type, maxlength::N) where {N<:Integer}
    q = ThreadQueue(Vector{T}(undef, maxlength), Atomic{N}(1), Atomic{N}(1))
    return q
end

function push!(q::ThreadQueue{T,N}, val::T) where {T} where {N}
    # TODO: check that head > tail
    offset = atomic_add!(q.tail, one(N))
    q.data[offset] = val
    return offset
end

function popfirst!(q::ThreadQueue{T,N}) where {T} where {N}
    # TODO: check that head < tail
    offset = atomic_add!(q.head, one(N))
    return q.data[offset]
end

function isempty(q::ThreadQueue{T,N}) where {T} where {N}
    return (q.head[] == q.tail[]) && q.head != one(N)
end

function getindex(q::ThreadQueue{T}, iter) where {T}
    return q.data[iter]
end

# Traverses the vertices in the queue and adds newly found successors to the queue.
function bfskernel(
    next::ThreadQueue, # Thread safe queue to add vertices to
    g::AbstractGraph, # The graph
    parents::Array{Atomic{T}}, # Parents array
    level::Array{T}, # Vertices in the current frontier
) where {T<:Integer}
    @threads for src in level
        vertexneighbors = neighbors(g, src) # Get the neighbors of the vertex
        for vertex in vertexneighbors
            # Atomically check and set parent value if not set yet.
            parent = atomic_cas!(parents[vertex], zero(T), src)
            if parent == 0
                push!(next, vertex) # Push onto queue if newly found
            end
        end
    end
end

"""
    bfs_tree!(g, src, parents)

Provide a parallel breadth-first traversal of the graph `g` starting with source vertex `s`,
and return a parents array. The returned array is an Array of `Atomic` integers.

### Implementation Notes
This function uses `@threads` for parallelism which depends on the `JULIA_NUM_THREADS`
environment variable to decide the number of threads to use. Refer `@threads` documentation
for more details.
"""
function bfs_tree!(
    next::ThreadQueue, # Thread safe queue to add vertices to
    g::AbstractGraph, # The graph
    source::T, # Source vertex
    parents::Array{Atomic{T}}, # Parents array
) where {T<:Integer}
    parents[source][] = source # Set source to source
    push!(next, source) # Add source to the queue
    while !isempty(next)
        level = next[next.head[]:(next.tail[] - 1)] # Get vertices in the frontier
        next.head[] = next.tail[] # reset the queue
        bfskernel(next, g, parents, level) # Find new frontier
    end
    return parents
end

function bfs_tree(g::AbstractGraph, source::T, nv::T) where {T<:Integer}
    next = ThreadQueue(T, nv) # Initialize threadqueue
    parents = [Atomic{T}(0) for i in 1:nv] # Create parents array
    Parallel.bfs_tree!(next, g, source, parents)
    return Graphs.tree([i[] for i in parents])
end

function bfs_tree(g::AbstractGraph, source::T) where {T<:Integer}
    nvg = nv(g)
    return Parallel.bfs_tree(g, source, nvg)
end

@testset "Limited Length Cycles" begin
    completedg = complete_digraph(4)
    pathdg = path_digraph(5)
    cycledg = cycle_digraph(5)

    @testset "complete digraph" for g in test_generic_graphs(completedg)
        @test length(simplecycles_limited_length(g, 0)) == 0
        @test length(simplecycles_limited_length(g, 1)) == 0
        @test length(simplecycles_limited_length(g, 2)) == 6
        @test length(simplecycles_limited_length(g, 3)) == 14
        @test length(simplecycles_limited_length(g, 4)) == 20
        @test length(simplecycles_limited_length(g, 4, 10)) == 10
        @test length(simplecycles_limited_length(g, 4, typemax(Int))) == 20
    end

    @testset "path digraph" for g in test_generic_graphs(pathdg)
        @test length(simplecycles_limited_length(g, 1)) == 0
        @test length(simplecycles_limited_length(g, 2)) == 0
        @test length(simplecycles_limited_length(g, 3)) == 0
        @test length(simplecycles_limited_length(g, 4)) == 0
        @test length(simplecycles_limited_length(g, 5)) == 0
    end

    @testset "cycle digraph" for g in test_generic_graphs(cycledg)
        @test length(simplecycles_limited_length(g, 1)) == 0
        @test length(simplecycles_limited_length(g, 2)) == 0
        @test length(simplecycles_limited_length(g, 3)) == 0
        @test length(simplecycles_limited_length(g, 4)) == 0
        @test length(simplecycles_limited_length(g, 5)) == 1
    end

    @testset "self loops" begin
        selfloopg = GenericDiGraph(DiGraph([
            0 1 0 0
            0 0 1 0
            1 0 1 0
            0 0 0 1
        ]))
        cycles = simplecycles_limited_length(selfloopg, nv(selfloopg))
        @test [3] in cycles
        @test [4] in cycles
        @test [1, 2, 3] in cycles || [2, 3, 1] in cycles || [3, 1, 2] in cycles
        @test length(cycles) == 3
    end

    @testset "octahedral graph" begin
        octag = smallgraph(:octahedral)
        octadg = DiGraph(octag)
        # TODO simplecycleslength does currently not yet work with GenericDiGraph.
        # This is probably because it uses induced_subgraph which fails on that graph type.
        octalengths, _ = simplecycleslength(octadg)
        for k in 1:6
            @test sum(octalengths[1:k]) ==
                length(simplecycles_limited_length(GenericGraph(octag), k))
            @test sum(octalengths[1:k]) ==
                length(simplecycles_limited_length(GenericDiGraph(octadg), k))
        end
    end
end

# Code in this file inspired by NetworkX.

"""
    cycle_basis(g, root=nothing)

Return a list of cycles which form a basis for cycles of the undirected graph `g`, optionally starting at node `root`.

A basis for cycles of a network is a minimal collection of
cycles such that any cycle in the network can be written
as a sum of cycles in the basis.  Here summation of cycles
is defined as "exclusive or" of the edges. Cycle bases are
useful, e.g. when deriving equations for electric circuits
using Kirchhoff's Laws.

# Examples
```jldoctest
julia> using Graphs

julia> elist = [(1,2),(2,3),(2,4),(3,4),(4,1),(1,5)];

julia> g = SimpleGraph(Graphs.SimpleEdge.(elist));

julia> cycle_basis(g)
2-element Vector{Vector{Int64}}:
 [2, 4, 1]
 [2, 3, 4]
```

### References
* Paton, K. An algorithm for finding a fundamental set of cycles of a graph. Comm. ACM 12, 9 (Sept 1969), 514-518. [https://dl.acm.org/citation.cfm?id=363232]
"""
function cycle_basis(g::AbstractGraph, root=nothing)
    T = eltype(g)
    cycles = Vector{Vector{T}}()

    nv(g) == 0 && return cycles

    gnodes = Set(vertices(g))
    r::T = isnothing(root) ? pop!(gnodes) : T(root)
    while true
        stack = [r]
        pred = Dict(r => r)
        keys_pred = Set(r)
        used = Dict(r => T[])
        keys_used = Set(r)
        while !isempty(stack)
            z = pop!(stack)
            zused = used[z]
            for nbr in neighbors(g, z)
                if !in(nbr, keys_used)
                    pred[nbr] = z
                    push!(keys_pred, nbr)
                    push!(stack, nbr)
                    used[nbr] = [z]
                    push!(keys_used, nbr)
                elseif nbr == z
                    push!(cycles, [z])
                elseif !in(nbr, zused)
                    pn = used[nbr]
                    cycle = [nbr, z]
                    p = pred[z]
                    while !in(p, pn)
                        push!(cycle, p)
                        p = pred[p]
                    end
                    push!(cycle, p)
                    push!(cycles, cycle)
                    push!(used[nbr], z)
                end
            end
        end
        setdiff!(gnodes, keys_pred)
        isempty(gnodes) && break
        r = pop!(gnodes)
    end
    return cycles
end

@testset "Louvain" begin
    # Basic Test case
    barbell = barbell_graph(3, 3)
    c = [1, 1, 1, 2, 2, 2]
    for g in test_generic_graphs(barbell)
        # Should work regardless of rng
        r = @inferred louvain(g)
        @test c == r
    end

    # Test clique
    clique = complete_graph(10)
    c = ones(10)
    for g in test_generic_graphs(clique)
        # Should work regardless of rng
        r = @inferred louvain(g)
        @test c == r
    end

    # Test disconnected
    disconnected = barbell_graph(4, 4)
    rem_edge!(disconnected, 4, 5)
    c = [1, 1, 1, 1, 2, 2, 2, 2]
    for g in test_generic_graphs(disconnected)
        # Should work regardless of rng
        r = @inferred louvain(g)
        @test c == r
    end

    # Test Empty Graph
    empty = SimpleGraph(10)
    c = collect(1:10)
    for g in test_generic_graphs(empty)
        # Should work regardless of rng
        r = @inferred louvain(g)
        @test c == r
    end

    # Test multiple merges
    g = blockdiag(barbell_graph(3, 3), complete_graph(10))
    add_edge!(g, 2, 5)
    c = [ones(6); 2*ones(10)]
    # Should work regardless of rng
    # generic_graphs uses UInt8 for T that is too small
    r = @inferred louvain(g)
    @test c == r

    # Test loops
    loops = complete_graph(2)
    add_edge!(loops, 1, 1)
    add_edge!(loops, 2, 2)
    c = [1, 2]
    for g in test_generic_graphs(loops)
        # Should work regardless of rng
        r = @inferred louvain(g)
        @test c == r
    end

    # Test γ
    g = complete_graph(2)
    c1 = [1, 1]
    c2 = [1, 2]
    for g in test_generic_graphs(g)
        # Should work regardless of rng
        r = @inferred louvain(g)
        @test c1 == r
        r = @inferred louvain(g, γ=2)
        @test c2 == r
    end

    # Test custom distmx
    square = CycleGraph(4)
    d = [
        [0 4 0 1]
        [4 0 1 0]
        [0 1 0 4]
        [1 0 4 0]
    ]
    c = [1, 1, 2, 2]
    for g in test_generic_graphs(square)
        # Should work regardless of rng
        r = @inferred louvain(g, distmx=d)
        @test c == r
    end

    # Test max_merges
    g = blockdiag(barbell_graph(3, 3), complete_graph(10))
    add_edge!(g, 2, 5)
    c = [ones(3); 2*ones(3)]
    # Should work regardless of rng
    # generic_graphs uses UInt8 for T that is too small
    r = @inferred louvain(g, max_merges=0)
    @test c == r[1:6]
    # the clique does not resolve in one step so we don't know what
    # the coms will be. But we know the barbell splits into two groups
    # of 3 in step one and merges in step two.

    # Directed cases

    # Simple
    triangle = SimpleDiGraph(3)
    add_edge!(triangle, 1, 2)
    add_edge!(triangle, 2, 3)
    add_edge!(triangle, 3, 1)

    barbell = blockdiag(triangle, triangle)
    add_edge!(barbell, 1, 4)
    c1 = [1, 1, 1, 2, 2, 2]
    c2 = [1, 1, 1, 1, 1, 1]
    for g in test_generic_graphs(barbell)
        r = @inferred louvain(g)
        @test r == c1
        r = @inferred louvain(g, γ=10e-5)
        @test r == c2
    end

    # Self loops
    barbell = SimpleDiGraph(2)
    add_edge!(barbell, 1, 1)
    add_edge!(barbell, 2, 2)
    add_edge!(barbell, 1, 2)
    c1 = [1, 2]
    c2 = [1, 1]
    for g in test_generic_graphs(barbell)
        r = @inferred louvain(g)
        @test r == c1
        r = @inferred louvain(g, γ=10e-5)
        @test r == c2
    end

    # Weighted
    square = SimpleDiGraph(4)
    add_edge!(square, 1, 2)
    add_edge!(square, 2, 3)
    add_edge!(square, 3, 4)
    add_edge!(square, 4, 1)
    d1 = [
        [0 5 0 0]
        [0 0 1 0]
        [0 0 0 5]
        [1 0 0 0]
    ]
    d2 = [
        [0 1 0 0]
        [0 0 5 0]
        [0 0 0 1]
        [5 0 0 0]
    ]
    c1 = [1, 1, 2, 2]
    c2 = [1, 2, 2, 1]
    for g in test_generic_graphs(square)
        r = @inferred louvain(g, distmx=d1)
        @test r == c1
        r = @inferred louvain(g, distmx=d2)
        @test r == c2
    end
end

SUITE["centrality"] = BenchmarkGroup(
    [], "graphs" => BenchmarkGroup([]), "digraphs" => BenchmarkGroup([])
)

# graphs
SUITE["centrality"]["graphs"]["degree_centrality"] = @benchmarkable [
    Graphs.degree_centrality(g) for (_, g) in $GRAPHS
]
SUITE["centrality"]["graphs"]["closeness_centrality"] = @benchmarkable [
    Graphs.closeness_centrality(g) for (_, g) in $GRAPHS
]
# if nv(g) < 1000 is needed ?
SUITE["centrality"]["graphs"]["betweenness_centrality"] = @benchmarkable [
    Graphs.betweenness_centrality(g) for (_, g) in $GRAPHS
]
SUITE["centrality"]["graphs"]["katz_centrality"] = @benchmarkable [
    Graphs.katz_centrality(g) for (_, g) in $GRAPHS
]

#digraphs
SUITE["centrality"]["digraphs"]["degree_centrality"] = @benchmarkable [
    Graphs.degree_centrality(g) for (_, g) in $DIGRAPHS
]
SUITE["centrality"]["digraphs"]["closeness_centrality"] = @benchmarkable [
    Graphs.closeness_centrality(g) for (_, g) in $DIGRAPHS
]
# if nv(g) < 1000 is needed ?
SUITE["centrality"]["digraphs"]["betweenness_centrality"] = @benchmarkable [
    Graphs.betweenness_centrality(g) for (_, g) in $DIGRAPHS
]
SUITE["centrality"]["digraphs"]["katz_centrality"] = @benchmarkable [
    Graphs.katz_centrality(g) for (_, g) in $DIGRAPHS
]
# if nv(g) < 500 is needed ?
SUITE["centrality"]["digraphs"]["pagerank"] = @benchmarkable [
    Graphs.pagerank(g) for (_, g) in $DIGRAPHS
]

"""
    boruvka_mst(g, distmx = weights(g); minimize = true)

Return a tuple `(mst, weights)` where `mst` is a vector of edges representing the
optimum (minimum, by default) spanning tree of a connected, undirected graph
`g` with optional matrix `distmx` that provides distinct edge weights, and
`weights` is the sum of all the edges in the solution by using
[Boruvka's algorithm](https://en.wikipedia.org/wiki/Bor%C5%AFvka%27s_algorithm).
The algorithm requires that all edges have different weights to correctly generate a minimum/maximum spanning tree
### Optional Arguments
- `minimize=true`: if set to `false`, calculate the maximum spanning tree.
"""
function boruvka_mst end

@traitfn function boruvka_mst(
    g::AG::(!IsDirected), distmx::AbstractMatrix{T}=weights(g); minimize=true
) where {T<:Number,U,AG<:AbstractGraph{U}}
    djset = IntDisjointSets(nv(g))
    # maximizing Z is the same as minimizing -Z
    # mode will indicate the need for the -1 multiplication
    mode = minimize ? 1 : -1
    mst = Vector{edgetype(g)}()
    sizehint!(mst, nv(g) - 1)
    weight = zero(T)

    while true
        cheapest = Vector{Union{edgetype(g),Nothing}}(nothing, nv(g))
        # find cheapest edge that connects two components
        found_edge = false
        for edge in edges(g)
            set1 = find_root!(djset, src(edge))
            set2 = find_root!(djset, dst(edge))
            if set1 != set2
                found_edge = true
                e1 = cheapest[set1]
                if e1 === nothing ||
                    distmx[src(e1), dst(e1)] * mode > distmx[src(edge), dst(edge)] * mode
                    cheapest[set1] = edge
                end
                e2 = cheapest[set2]
                if e2 === nothing ||
                    distmx[src(e2), dst(e2)] * mode > distmx[src(edge), dst(edge)] * mode
                    cheapest[set2] = edge
                end
            end
        end
        # no more edges between two components
        !found_edge && break
        # add cheapest edges to the tree
        for v in vertices(g)
            if cheapest[v] !== nothing
                edge = cheapest[v]
                if !in_same_set(djset, src(edge), dst(edge))
                    weight += distmx[src(edge), dst(edge)]
                    union!(djset, src(edge), dst(edge))
                    push!(mst, edge)
                end
            end
        end
    end
    return (mst=mst, weight=weight)
end

@testset "Hawick-James Cycles" begin

    # Simple graph gives expected circuits
    ex1 = SimpleDiGraph(5)
    add_edge!(ex1, 1, 2)
    add_edge!(ex1, 2, 3)
    add_edge!(ex1, 3, 4)
    add_edge!(ex1, 3, 5)
    add_edge!(ex1, 4, 5)
    add_edge!(ex1, 5, 2)

    @testset "subset" for g in testgraphs(ex1)
        expected_circuits = Vector{Int}[[2, 3, 4, 5], [2, 3, 5]]
        ex1_circuits = simplecycles_hawick_james(GenericDiGraph(g))

        @test issubset(expected_circuits, ex1_circuits)
        @test issubset(ex1_circuits, expected_circuits)

        # Adding self-edges gives new circuits
        add_edge!(g, 1, 1)
        add_edge!(g, 3, 3)

        ex1_circuits_self = simplecycles_hawick_james(GenericDiGraph(g))

        @test issubset(expected_circuits, ex1_circuits_self)
        @test [1] ∈ ex1_circuits_self && [3] ∈ ex1_circuits_self
    end

    # Path DiGraph
    ex2_size = 10
    ex2 = test_generic_graphs(path_digraph(ex2_size))
    @testset "empty" for g in ex2
        @test isempty(simplecycles_hawick_james(g))
    end

    # Complete DiGraph
    ex3_size = 5
    ex3 = test_generic_graphs(complete_digraph(ex3_size))
    @testset "length" for g in ex3
        ex3_circuits = simplecycles_hawick_james(g)
        @test length(ex3_circuits) == length(unique(ex3_circuits))
    end

    # Almost fully connected DiGraph
    ex4 = SimpleDiGraph(9)
    for (src, dest) in [
        (1, 2),
        (1, 5),
        (1, 7),
        (1, 8),
        (2, 9),
        (3, 4),
        (3, 6),
        (4, 5),
        (4, 7),
        (5, 6),
        (6, 7),
        (6, 8),
        (7, 9),
        (8, 9),
    ]
        add_edge!(ex4, src, dest)
        add_edge!(ex4, dest, src)
    end
    @testset "membership" for g in test_generic_graphs(ex4)
        ex4_output = simplecycles_hawick_james(g)
        @test [1, 2] ∈ ex4_output && [8, 9] ∈ ex4_output
    end

    # These test cases cover a bug that occurred in a previous version
    @testset "bugfix (unknown issue; PR#1007) ($seed)" for seed in [1, 2, 3],
        (n, k) in [(14, 18), (10, 22), (7, 16)]

        g = erdos_renyi(n, k; is_directed=true, rng=StableRNG(seed))
        # TODO simplecycles(g) does not yet work with GenericDiGraph
        cycles1 = simplecycles(g)
        cycles2 = simplecycles_hawick_james(GenericDiGraph(g))
        foreach(sort!, cycles1)
        foreach(sort!, cycles2)
        sort!(cycles1)
        sort!(cycles2)
        @test cycles1 == cycles2
    end
end

@testset "Experimental.Parallel.BFS" begin
    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)

    for g in testdigraphs(g5)
        @test @inferred(Experimental.Parallel.gdistances(g, 1)) == gdistances(g, 1)
        @test @inferred(Experimental.Parallel.gdistances(g, [1, 3])) ==
            gdistances(g, [1, 3])
    end

    g6 = smallgraph(:house)

    for g in testgraphs(g6)
        @test @inferred(Experimental.Parallel.gdistances(g, 2)) == gdistances(g, 2)
        @test @inferred(Experimental.Parallel.gdistances(g, [1, 2])) ==
            gdistances(g, [1, 2])
    end
end

import Base: Matrix
import Base: size
using ArnoldiMethod: LM, SR, LR, partialschur, partialeigen

# using Graphs.LinAlg: eigs
# just so that we can assert equality of matrices
Matrix(nbt::Nonbacktracking) = Matrix(sparse(nbt))
@testset "Spectral" begin
    rng = StableRNG(1)
    g3 = path_graph(5)
    g4 = path_digraph(5)
    g5 = SimpleDiGraph(4)
    for g in testgraphs(g3)
        @test adjacency_matrix(g, Bool) == adjacency_matrix(g, Bool; dir=:out)
        @test adjacency_matrix(g)[3, 2] == 1
        @test adjacency_matrix(g)[2, 4] == 0
        @test laplacian_matrix(g)[3, 2] == -1
        @test laplacian_matrix(g)[1, 3] == 0
        @test laplacian_spectrum(g)[5] ≈ 3.6180339887498945
        @test adjacency_spectrum(g)[1] ≈ -1.732050807568878
    end

    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)
    for g in testdigraphs(g5)
        @test adjacency_matrix(g, Bool) == adjacency_matrix(g, Bool; dir=:out)
        @test laplacian_spectrum(g)[3] == laplacian_spectrum(g; dir=:both)[3] == 3.0
        @test laplacian_spectrum(g; dir=:in)[3] == 1.0
        @test laplacian_spectrum(g; dir=:out)[3] == 1.0
    end

    # check adjacency matrices with self loops
    gx = copy(g3)
    add_edge!(gx, 1, 1)
    for g in testgraphs(gx)
        @test adjacency_matrix(g)[1, 1] == 2
    end
    g = copy(g5)
    add_edge!(g, 1, 1)
    @test adjacency_matrix(g)[1, 1] == 1
    @test indegree(g) == sum(adjacency_matrix(g); dims=1)[1, :]
    @test outdegree(g) == sum(adjacency_matrix(g); dims=2)[:, 1]

    g10 = complete_graph(10)
    for g in testgraphs(g10)
        B, em = non_backtracking_matrix(g)
        @test length(em) == 2 * ne(g)
        @test size(B) == (2 * ne(g), 2 * ne(g))
        for i in 1:10
            @test sum(B[:, i]) == 8
            @test sum(B[i, :]) == 8
        end
        @test !issymmetric(B)

        v = ones(Float64, ne(g))
        z = zeros(Float64, nv(g))
        n10 = Nonbacktracking(g)
        @test size(n10) == (2 * ne(g), 2 * ne(g))
        @test size(n10, 1) == n10.m
        @test size(n10, 2) == n10.m
        @test eltype(n10) == Float64
        @test eltype(typeof(n10)) == Float64
        @test !issymmetric(n10)

        contract!(z, n10, v)

        zprime = contract(n10, v)
        @test z == zprime
        @test z == 9 * ones(Float64, nv(g))
    end

    for g in testdigraphs(g5)
        @test adjacency_spectrum(g)[3] ≈ 0.311 atol = 0.001
    end

    for g in testgraphs(g3)
        @test adjacency_matrix(g) ==
            adjacency_matrix(g; dir=:out) ==
            adjacency_matrix(g; dir=:in) ==
            adjacency_matrix(g; dir=:both)

        @test_throws ErrorException adjacency_matrix(g; dir=:purple)
    end

    # that call signature works
    for g in testdigraphs(g5)
        inmat = adjacency_matrix(g, Int; dir=:in)
        outmat = adjacency_matrix(g, Int; dir=:out)
        bothmat = adjacency_matrix(g, Int; dir=:both)

        # relations that should be true
        @test inmat' == outmat
        @test all((bothmat - outmat) .>= 0)
        @test all((bothmat - inmat) .>= 0)

        # check properties of the undirected laplacian carry over.
        for dir in [:in, :out, :both]
            T = eltype(g)
            amat = adjacency_matrix(g, Float64; dir=dir)
            lmat = laplacian_matrix(g, Float64; dir=dir)
            evals = eigvals(Matrix(lmat))
            @test all(evals .>= -1e-15) # positive semidefinite
            @test (minimum(evals)) ≈ 0 atol = 1e-13
        end
    end

    for g in testdigraphs(g4)
        # testing incidence_matrix, first directed graph
        @test size(incidence_matrix(g)) == (5, 4)
        @test incidence_matrix(g)[1, 1] == -1
        @test incidence_matrix(g)[2, 1] == 1
        @test incidence_matrix(g)[3, 1] == 0

        A = incidence_matrix(g)
        B = incidence_matrix(reverse(g))
        @test all((A + B) .== 0)
    end

    for g in testgraphs(g3)
        # now undirected graph
        @test size(incidence_matrix(g)) == (5, 4)
        @test incidence_matrix(g)[1, 1] == 1
        @test incidence_matrix(g)[2, 1] == 1
        @test incidence_matrix(g)[3, 1] == 0

        # undirected graph with orientation
        @test size(incidence_matrix(g; oriented=true)) == (5, 4)
        @test incidence_matrix(g; oriented=true)[1, 1] == -1
        @test incidence_matrix(g; oriented=true)[2, 1] == 1
        @test incidence_matrix(g; oriented=true)[3, 1] == 0
    end

    # Check size of incidence matrix with isolated vertices
    g6 = complete_graph(4)
    for k in 1:3
        add_vertex!(g6)
    end
    for g in testgraphs(g6)
        @test size(incidence_matrix(g6)) == (7, 6)
    end

    # TESTS FOR Nonbacktracking operator.

    n = 10
    k = 5
    pg = complete_graph(n)
    # ϕ1 = nonbacktrack_embedding(pg, k)'
    for g in testgraphs(pg)
        nbt = Nonbacktracking(g)
        B, emap = non_backtracking_matrix(g)
        Bs = sparse(nbt)
        @test sparse(B) == Bs
        @test eigs(nbt; which=LR(), nev=1)[1] ≈ eigs(B; which=LR(), nev=1)[1] atol = 1e-5

        # check that matvec works
        x = ones(Float64, nbt.m)
        y = nbt * x
        z = B * x
        @test norm(y - z) < 1e-8

        # check that matmat works and Matrix(nbt) == B

        @test norm(nbt * Matrix{Float64}(I, nbt.m, nbt.m) - B) < 1e-8

        # check that matmat works and Matrix(nbt) == B
        @test norm(nbt * Matrix{Float64}(I, nbt.m, nbt.m) - B) < 1e-8

        @test size(y) == size(x)

        B₁ = Nonbacktracking(g10)

        @test Matrix(B₁) == Matrix(B)
        @test B₁ * ones(size(B₁)[2]) == B * ones(size(B)[2])
        @test size(B₁) == size(B)
        @test !issymmetric(B₁)
        @test eltype(B₁) == Float64
    end
    # END tests for Nonbacktracking

    # spectral distance checks
    for n in 3:10
        polygon = random_regular_graph(n, 2; rng=rng)
        for g in testgraphs(polygon)
            @test spectral_distance(g, g) ≈ 0 atol = 1e-8
            @test spectral_distance(g, g, 1) ≈ 0 atol = 1e-8
        end
    end

    @testset "adjacency_matrix with `dir=:both`" begin
        edges = [Edge(1, 3), Edge(1, 4), Edge(2, 1), Edge(4, 1)]
        g = SimpleDiGraph(edges)
        @test all(adjacency_matrix(g; dir=:out) .== [0 0 1 1; 1 0 0 0; 0 0 0 0; 1 0 0 0])
        @test all(adjacency_matrix(g; dir=:in) .== [0 1 0 1; 0 0 0 0; 1 0 0 0; 1 0 0 0])
        @test all(adjacency_matrix(g; dir=:both) .== [0 1 1 1; 1 0 0 0; 1 0 0 0; 1 0 0 0])
    end
end

@testset "Articulation" begin
    gint = SimpleGraph(13)
    add_edge!(gint, 1, 7)
    add_edge!(gint, 1, 2)
    add_edge!(gint, 1, 3)
    add_edge!(gint, 12, 13)
    add_edge!(gint, 10, 13)
    add_edge!(gint, 10, 12)
    add_edge!(gint, 12, 11)
    add_edge!(gint, 5, 4)
    add_edge!(gint, 6, 4)
    add_edge!(gint, 8, 9)
    add_edge!(gint, 6, 5)
    add_edge!(gint, 1, 6)
    add_edge!(gint, 7, 5)
    add_edge!(gint, 7, 3)
    add_edge!(gint, 7, 8)
    add_edge!(gint, 7, 10)
    add_edge!(gint, 7, 12)

    for g in test_generic_graphs(gint)
        art = @inferred(articulation(g))
        ans = [1, 7, 8, 12]
        @test art == ans
    end
    for level in 1:6
        btree = Graphs.binary_tree(level)
        for tree in test_generic_graphs(btree; eltypes=[Int, UInt8, Int16])
            artpts = @inferred(articulation(tree))
            @test artpts == collect(1:(2 ^ (level - 1) - 1))
        end
    end

    hint = blockdiag(wheel_graph(5), wheel_graph(5))
    add_edge!(hint, 5, 6)
    for h in test_generic_graphs(hint; eltypes=[Int, UInt8, Int16])
        @test @inferred(articulation(h)) == [5, 6]
    end
end

using Base.Iterators: repeated

# Abstract Interface

"""
    abstract type IncrementalCycleTracker

The supertype for incremental cycle detection problems. The abstract type
constructor IncrementalCycleTracker(G) may be used to automatically select
a specific incremental cycle detection algorithm. See [`add_edge_checked!`](@ref)
for a usage example.
"""
abstract type IncrementalCycleTracker{I} <: AbstractGraph{I} end

function (::Type{IncrementalCycleTracker})(
    s::AbstractGraph{I}; dir::Union{Symbol,Nothing}=nothing
) where {I}
    # TODO: Once we have more algorithms, the poly-algorithm decision goes here.
    # For now, we only have Algorithm N.
    return DenseGraphICT_BFGT_N{something(dir, :out)}(s)
end

# Cycle Detection Interface
"""
    add_edge_checked!([f!,], ict::IncrementalCycleTracker, v, w)

Using the incremental cycle tracker, ict, check whether adding the edge `v=>w`
would introduce a cycle in the underlying graph. If so, return false and leave
the ict intact. If not, update the underlying graph and return true.

# Optional `f!` Argument

By default the `add_edge!` function is used to update the underlying graph.
However, for more complicated graphs, users may wish to manually specify the
graph update operation. This may be accomplished by passing the optional `f!`
callback argument. This callback is called on the underlying graph when no
cycle is detected and is required to modify the underlying graph in order to
effectuate the proposed edge addition.

# Batched edge additions

Optionally, either `v` or `w` (depending on the `in_out_reverse` flag) may be a
collection of vertices representing a batched addition of vertices sharing a
common source or target more efficiently than individual updates.

## Example

```jldoctest
julia> using Graphs

julia> G = SimpleDiGraph(3)
{3, 0} directed simple Int64 graph

julia> ict = IncrementalCycleTracker(G)
BFGT_N cycle tracker on SimpleDiGraph{Int64}(0, [Int64[], Int64[], Int64[]], [Int64[], Int64[], Int64[]])

julia> add_edge_checked!(ict, 1, 2)
true

julia> collect(edges(G))
1-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2

julia> add_edge_checked!(ict, 2, 3)
true

julia> collect(edges(G))
2-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 3

julia> add_edge_checked!(ict, 3, 1) # Would add a cycle
false

julia> collect(edges(G))
2-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 3
```
"""
function add_edge_checked! end

to_edges(v::Integer, w::Integer) = (v => w,)
to_edges(v::Integer, ws) = zip(repeated(v), ws)
to_edges(vs, w::Integer) = zip(vs, repeated(w))

function add_edge_checked!(ict::IncrementalCycleTracker, vs, ws)
    add_edge_checked!(ict, vs, ws) do g
        foreach(((v, w),) -> add_edge!(g, v, w), to_edges(vs, ws))
    end
end

# Utilities
"""
    struct TransactionalVector

A vector with one checkpoint that may be reverted to by calling `revert!`. The setpoint itself
is set by calling `commit!`.
"""
struct TransactionalVector{T} <: AbstractVector{T}
    v::Vector{T}
    log::Vector{Pair{Int,T}}
    TransactionalVector(v::Vector{T}) where {T} = new{T}(v, Vector{Pair{Int,T}}())
end

function commit!(v::TransactionalVector)
    empty!(v.log)
    return nothing
end

function revert!(vec::TransactionalVector)
    for (idx, val) in reverse(vec.log)
        vec.v[idx] = val
    end
    return nothing
end

function Base.setindex!(vec::TransactionalVector, val, idx)
    oldval = vec.v[idx]
    vec.v[idx] = val
    push!(vec.log, idx => oldval)
    return nothing
end
Base.getindex(vec::TransactionalVector, idx) = vec.v[idx]
Base.size(vec::TransactionalVector) = size(vec.v)

function weak_topological_levels(g::AbstractGraph{I}) where {I}
    levels = fill(-1, nv(g))
    # Fill topological levels via dynamic programming dfs
    worklist = Vector{Int}()
    all_verts_max_level = 0
    for v in vertices(g)
        levels[v] != -1 && continue
        push!(worklist, v)
        while !isempty(worklist)
            v = last(worklist)
            levels[v] = -2
            visited_all = true
            maxlevel = -1
            for n in outneighbors(g, v)
                l = levels[n]
                maxlevel = max(l, maxlevel)
                l == -2 && error("Graph is not a DAG")
                if l == -1
                    visited_all = false
                    push!(worklist, n)
                end
            end
            visited_all || continue
            pop!(worklist)
            new_level = maxlevel + 1
            levels[v] = new_level
            all_verts_max_level = max(all_verts_max_level, new_level)
        end
    end
    return all_verts_max_level .- levels
end

# Specific Algorithms

const bibliography = """
## References

BFGT15: Michael A. Bender, Jeremy T. Fineman, Seth Gilbert, and Robert E. Tarjan. 2015
    A New Approach to Incremental Cycle Detection and Related Problems.
    ACM Trans. Algorithms 12, 2, Article 14 (December 2015), 22 pages.
    DOI: http://dx.doi.org/10.1145/2756553
"""

## Bender, Algorithm N

"""
    struct DenseGraphICT_BFGT_N

Implements the "Naive" (Algorithm N) Bender-Fineman-Gilbert-Tarjan one-way line search incremental cycle detector
for dense graphs from BFGT15 (Section 3).

$bibliography
"""
struct DenseGraphICT_BFGT_N{InOut,I,G<:AbstractGraph{I}} <: IncrementalCycleTracker{I}
    graph::G
    levels::TransactionalVector{Int}
    function DenseGraphICT_BFGT_N{InOut}(g::G) where {InOut,I,G<:AbstractGraph{I}}
        if ne(g) == 0
            # Common case fast path, no edges, all level start at 0.
            levels = fill(0, nv(g))
        else
            levels = weak_topological_levels(g)
        end
        return new{InOut,I,G}(g, TransactionalVector(levels))
    end
end

function Base.show(io::IO, ict::DenseGraphICT_BFGT_N)
    print(io, "BFGT_N cycle tracker on ")
    return show(io, ict.graph)
end

function topological_sort(ict::DenseGraphICT_BFGT_N{InOut}) where {InOut}
    # The ICT levels are a weak topological ordering, so a sort of the levels
    # will give a topological sort of the vertices.
    perm = sortperm(ict.levels)
    (InOut === :in) && (perm = reverse(perm))
    return perm
end

# Even when both `v` and `w` are integer, we know that `v` would come first, so
# we prefer to check for `v` as the cycle vertex in this case.
function add_edge_checked!(f!, ict::DenseGraphICT_BFGT_N{:out}, v::Integer, ws)
    return _check_cycle_add!(f!, ict, to_edges(v, ws), v)
end
function add_edge_checked!(f!, ict::DenseGraphICT_BFGT_N{:in}, vs, w::Integer)
    return _check_cycle_add!(f!, ict, to_edges(vs, w), w)
end

### [BFGT15] Algorithm N
#
# Implementation Notes
#
# This is Algorithm N from [BFGT15] (Section 3), plus limited patching support and
# a number of standard tricks. Namely:
#
# 1. Batching is supported as long as there is only a single source or destination
#    vertex. General batching is left as an open problem. The reason that the
#    single source/dest batching is easy to add is that we know that either the
#    source or the destination vertex is guaranteed to be a part of any cycle
#    that we may have added. Thus we're guaranteed to encounter one of the two
#    vertices in our cycle validation and the rest of the algorithm goes through
#    as usual.
# 2. We opportunistically traverse each edge when we see it and only add it
#    to the worklist if we know that traversal will recurse further.
# 3. We add some early out checks to detect we're about to do redundant work.
function _check_cycle_add!(f!, ict::DenseGraphICT_BFGT_N{InOut}, edges, v) where {InOut}
    g = ict.graph
    worklist = Pair{Int,Int}[]
    # TODO: In the case where there's a single target vertex, we could saturate
    # the level first before we assign it to the tracked vector to save some
    # log space.
    for (v, w) in edges
        (InOut === :in) && ((v, w) = (w, v))
        if ict.levels[v] < ict.levels[w]
            continue
        end
        v == w && return false
        ict.levels[w] = ict.levels[v] + 1
        push!(worklist, v => w)
    end
    while !isempty(worklist)
        (x, y) = popfirst!(worklist)
        xlevel = ict.levels[x]
        ylevel = ict.levels[y]
        if xlevel >= ylevel
            # The xlevel may have been incremented further since we added this
            # edge to the worklist.
            ict.levels[y] = ylevel = xlevel + 1
        elseif ylevel > xlevel + 1
            # Some edge traversal scheduled for later already incremented this
            # level past where we would have been. Delay processing until then.
            continue
        end
        for z in (InOut === :in ? inneighbors(g, y) : outneighbors(g, y))
            if z == v
                revert!(ict.levels)
                return false
            end
            if ylevel >= ict.levels[z]
                ict.levels[z] = ylevel + 1
                push!(worklist, y => z)
            end
        end
    end
    commit!(ict.levels)
    f!(g)
    return true
end

@testset "Random Vertex Cover" begin
    g0 = SimpleGraph(0)
    for g in testgraphs(g0)
        c = @inferred(vertex_cover(g, RandomVertexCover(); rng=StableRNG(3)))
        @test isempty(c)
    end

    g1 = SimpleGraph(1)
    for g in testgraphs(g1)
        c = @inferred(vertex_cover(g, RandomVertexCover(); rng=StableRNG(3)))
        @test isempty(c)
    end

    add_edge!(g1, 1, 1)
    for g in testgraphs(g1)
        c = @inferred(vertex_cover(g, RandomVertexCover(); rng=StableRNG(3)))
        @test c == [1]
    end

    g3 = star_graph(5)
    for g in testgraphs(g3)
        c = @inferred(vertex_cover(g, RandomVertexCover(); rng=StableRNG(3)))
        @test (length(c) == 2 && (c[1] == 1 || c[2] == 1))
    end

    g4 = complete_graph(5)
    for g in testgraphs(g4)
        c = @inferred(vertex_cover(g, RandomVertexCover(); rng=StableRNG(3)))
        @test length(c) == 4 #All except one vertex 
    end

    g5 = path_graph(5)
    for g in testgraphs(g5)
        c = @inferred(vertex_cover(g, RandomVertexCover(); rng=StableRNG(3)))
        sort!(c)
        @test (c == [1, 2, 3, 4] || c == [1, 2, 4, 5] || c == [2, 3, 4, 5])
    end

    add_edge!(g5, 2, 2)
    add_edge!(g5, 3, 3)
    for g in testgraphs(g5)
        c = @inferred(vertex_cover(g, RandomVertexCover(); rng=StableRNG(3)))
        sort!(c)
        @test (
            c == [1, 2, 3, 4] || c == [1, 2, 3, 4, 5] || c == [2, 3, 4] || c == [2, 3, 4, 5]
        )
    end
end

# Parts of this code were taken / derived from NetworkX. See LICENSE for
# licensing details.

"""
    complete_graph(n)

Create an undirected [complete graph](https://en.wikipedia.org/wiki/Complete_graph)
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> complete_graph(5)
{5, 10} undirected simple Int64 graph

julia> complete_graph(Int8(6))
{6, 15} undirected simple Int8 graph
```
"""
function complete_graph(n::T) where {T<:Integer}
    n <= 0 && return SimpleGraph{T}(0)
    ne = Int(n * (n - 1) ÷ 2)
    fadjlist = Vector{Vector{T}}(undef, n)
    @inbounds @simd for u in 1:n
        listu = Vector{T}(undef, n - 1)
        listu[1:(u - 1)] = 1:(u - 1)
        listu[u:(n - 1)] = (u + 1):n
        fadjlist[u] = listu
    end
    return SimpleGraph(ne, fadjlist)
end

"""
    complete_bipartite_graph(n1, n2)

Create an undirected [complete bipartite graph](https://en.wikipedia.org/wiki/Complete_bipartite_graph)
with `n1 + n2` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> complete_bipartite_graph(3, 4)
{7, 12} undirected simple Int64 graph

julia> complete_bipartite_graph(Int8(3), Int8(4))
{7, 12} undirected simple Int8 graph
```
"""
function complete_bipartite_graph(n1::T, n2::T) where {T<:Integer}
    (n1 < 0 || n2 < 0) && return SimpleGraph{T}(0)
    Tw = widen(T)
    nw = Tw(n1) + Tw(n2)
    n = T(nw)  # checks if T is large enough for n1 + n2

    ne = Int(n1) * Int(n2)

    fadjlist = Vector{Vector{T}}(undef, n)
    range1 = 1:n1
    range2 = (n1 + 1):n
    @inbounds @simd for u in range1
        fadjlist[u] = Vector{T}(range2)
    end
    @inbounds @simd for u in range2
        fadjlist[u] = Vector{T}(range1)
    end
    return SimpleGraph(ne, fadjlist)
end

"""
    complete_multipartite_graph(partitions)

Create an undirected [complete bipartite graph](https://en.wikipedia.org/wiki/Complete_bipartite_graph)
with `sum(partitions)` vertices. A partition with `0` vertices is skipped.

### Implementation Notes
Preserves the eltype of the partitions vector. Will error if the required number of vertices
exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> complete_multipartite_graph([1,2,3])
{6, 11} undirected simple Int64 graph

julia> complete_multipartite_graph(Int8[5,5,5])
{15, 75} undirected simple Int8 graph
```
"""
function complete_multipartite_graph(partitions::AbstractVector{T}) where {T<:Integer}
    any(x -> x < 0, partitions) && return SimpleGraph{T}(0)
    length(partitions) == 1 && return SimpleGraph{T}(partitions[1])
    length(partitions) == 2 && return complete_bipartite_graph(partitions[1], partitions[2])

    n = sum(partitions)

    ne = 0
    for p in partitions # type stability fails if we use sum and a generator here
        ne += p * (Int(n) - p) # overflow if we don't convert to Int
    end
    ne = div(ne, 2)

    fadjlist = Vector{Vector{T}}(undef, n)
    cur = 1
    for p in partitions
        currange = cur:(cur + p - 1) # all vertices in the current partition
        lowerrange = 1:(cur - 1)   # all vertices lower than the current partition
        upperrange = (cur + p):n   # all vertices higher than the current partition
        @inbounds @simd for u in currange
            fadjlist[u] = Vector{T}(undef, length(lowerrange) + length(upperrange))
            fadjlist[u][1:length(lowerrange)] = lowerrange
            fadjlist[u][(length(lowerrange) + 1):end] = upperrange
        end
        cur += p
    end

    return SimpleGraph{T}(ne, fadjlist)
end

"""
    turan_graph(n, r)

Creates a [Turán Graph](https://en.wikipedia.org/wiki/Tur%C3%A1n_graph), a complete
multipartite graph with `n` vertices and `r` partitions.

# Examples
```jldoctest
julia> using Graphs

julia> turan_graph(6, 2)
{6, 9} undirected simple Int64 graph

julia> turan_graph(Int8(7), 2)
{7, 12} undirected simple Int8 graph
```
"""
function turan_graph(n::Integer, r::Integer)
    !(1 <= r <= n) &&
        throw(DomainError("n=$n and r=$r are invalid, must satisfy 1 <= r <= n"))
    T = typeof(n)
    partitions = Vector{T}(undef, r)
    c = cld(n, r)
    f = fld(n, r)
    @inbounds @simd for i in 1:(n % r)
        partitions[i] = c
    end
    @inbounds @simd for i in ((n % r) + 1):r
        partitions[i] = f
    end
    return complete_multipartite_graph(partitions)
end

"""
    complete_digraph(n)

Create a directed [complete graph](https://en.wikipedia.org/wiki/Complete_graph)
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> complete_digraph(5)
{5, 20} directed simple Int64 graph

julia> complete_digraph(Int8(6))
{6, 30} directed simple Int8 graph
```
"""
function complete_digraph(n::T) where {T<:Integer}
    n <= 0 && return SimpleDiGraph{T}(0)

    ne = Int(n * (n - 1))
    fadjlist = Vector{Vector{T}}(undef, n)
    badjlist = Vector{Vector{T}}(undef, n)
    @inbounds @simd for u in 1:n
        listu = Vector{T}(undef, n - 1)
        listu[1:(u - 1)] = 1:(u - 1)
        listu[u:(n - 1)] = (u + 1):n
        fadjlist[u] = listu
        badjlist[u] = deepcopy(listu)
    end
    return SimpleDiGraph(ne, fadjlist, badjlist)
end

"""
    star_graph(n)

Create an undirected [star graph](https://en.wikipedia.org/wiki/Star_(graph_theory))
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> star_graph(3)
{3, 2} undirected simple Int64 graph

julia> star_graph(Int8(10))
{10, 9} undirected simple Int8 graph
```
"""
function star_graph(n::T) where {T<:Integer}
    n <= 0 && return SimpleGraph{T}(0)

    ne = Int(n - 1)
    fadjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = Vector{T}(2:n)
    @inbounds @simd for u in 2:n
        fadjlist[u] = T[1]
    end
    return SimpleGraph(ne, fadjlist)
end

"""
    star_digraph(n)

Create a directed [star graph](https://en.wikipedia.org/wiki/Star_(graph_theory))
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> star_digraph(3)
{3, 2} directed simple Int64 graph

julia> star_digraph(Int8(10))
{10, 9} directed simple Int8 graph
```
"""
function star_digraph(n::T) where {T<:Integer}
    n <= 0 && return SimpleDiGraph{T}(0)

    ne = Int(n - 1)
    fadjlist = Vector{Vector{T}}(undef, n)
    badjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = Vector{T}(2:n)
    @inbounds badjlist[1] = T[]
    @inbounds @simd for u in 2:n
        fadjlist[u] = T[]
        badjlist[u] = T[1]
    end
    return SimpleDiGraph(ne, fadjlist, badjlist)
end

"""
    path_graph(n)

Create an undirected [path graph](https://en.wikipedia.org/wiki/Path_graph)
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> path_graph(5)
{5, 4} undirected simple Int64 graph

julia> path_graph(Int8(10))
{10, 9} undirected simple Int8 graph
```
"""
function path_graph(n::T) where {T<:Integer}
    n <= 1 && return SimpleGraph(n)

    ne = Int(n - 1)
    fadjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = T[2]
    @inbounds fadjlist[n] = T[n - 1]

    @inbounds @simd for u in 2:(n - 1)
        fadjlist[u] = T[u - 1, u + 1]
    end
    return SimpleGraph(ne, fadjlist)
end

"""
    path_digraph(n)

Creates a directed [path graph](https://en.wikipedia.org/wiki/Path_graph)
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> path_digraph(5)
{5, 4} directed simple Int64 graph

julia> path_digraph(Int8(10))
{10, 9} directed simple Int8 graph
```
"""
function path_digraph(n::T) where {T<:Integer}
    n <= 1 && return SimpleDiGraph(n)

    ne = Int(n - 1)
    fadjlist = Vector{Vector{T}}(undef, n)
    badjlist = Vector{Vector{T}}(undef, n)

    @inbounds fadjlist[1] = T[2]
    @inbounds badjlist[1] = T[]
    @inbounds fadjlist[n] = T[]
    @inbounds badjlist[n] = T[n - 1]

    @inbounds @simd for u in 2:(n - 1)
        fadjlist[u] = T[u + 1]
        badjlist[u] = T[u - 1]
    end
    return SimpleDiGraph(ne, fadjlist, badjlist)
end

"""
    cycle_graph(n)

Create an undirected [cycle graph](https://en.wikipedia.org/wiki/Cycle_graph)
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> cycle_graph(3)
{3, 3} undirected simple Int64 graph

julia> cycle_graph(Int8(5))
{5, 5} undirected simple Int8 graph
```
"""
function cycle_graph(n::T) where {T<:Integer}
    n <= 1 && return SimpleGraph(n)
    n == 2 && return SimpleGraph(Edge{T}.([(1, 2)]))

    ne = Int(n)
    fadjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = T[2, n]
    @inbounds fadjlist[n] = T[1, n - 1]

    @inbounds @simd for u in 2:(n - 1)
        fadjlist[u] = T[u - 1, u + 1]
    end
    return SimpleGraph(ne, fadjlist)
end

"""
    cycle_digraph(n)

Create a directed [cycle graph](https://en.wikipedia.org/wiki/Cycle_graph)
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> cycle_digraph(3)
{3, 3} directed simple Int64 graph

julia> cycle_digraph(Int8(5))
{5, 5} directed simple Int8 graph
```
"""
function cycle_digraph(n::T) where {T<:Integer}
    n <= 1 && return SimpleDiGraph(n)
    n == 2 && return SimpleDiGraph(Edge{T}.([(1, 2), (2, 1)]))

    ne = Int(n)
    fadjlist = Vector{Vector{T}}(undef, n)
    badjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = T[2]
    @inbounds badjlist[1] = T[n]
    @inbounds fadjlist[n] = T[1]
    @inbounds badjlist[n] = T[n - 1]

    @inbounds @simd for u in 2:(n - 1)
        fadjlist[u] = T[u + 1]
        badjlist[u] = T[u + -1]
    end
    return SimpleDiGraph(ne, fadjlist, badjlist)
end

"""
    wheel_graph(n)

Create an undirected [wheel graph](https://en.wikipedia.org/wiki/Wheel_graph)
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> wheel_graph(5)
{5, 8} undirected simple Int64 graph

julia> wheel_graph(Int8(6))
{6, 10} undirected simple Int8 graph
```
"""
function wheel_graph(n::T) where {T<:Integer}
    n <= 1 && return SimpleGraph(n)
    n <= 3 && return cycle_graph(n)

    ne = Int(2 * (n - 1))
    fadjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = Vector{T}(2:n)
    @inbounds fadjlist[2] = T[1, 3, n]
    @inbounds fadjlist[n] = T[1, 2, n - 1]

    @inbounds @simd for u in 3:(n - 1)
        fadjlist[u] = T[1, u - 1, u + 1]
    end
    return SimpleGraph(ne, fadjlist)
end

"""
    wheel_digraph(n)

Create a directed [wheel graph](https://en.wikipedia.org/wiki/Wheel_graph)
with `n` vertices.

# Examples
```jldoctest
julia> using Graphs

julia> wheel_digraph(5)
{5, 8} directed simple Int64 graph

julia> wheel_digraph(Int8(6))
{6, 10} directed simple Int8 graph
```
"""
function wheel_digraph(n::T) where {T<:Integer}
    n <= 2 && return path_digraph(n)
    n == 3 && return SimpleDiGraph(Edge{T}.([(1, 2), (1, 3), (2, 3), (3, 2)]))

    ne = Int(2 * (n - 1))
    fadjlist = Vector{Vector{T}}(undef, n)
    badjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = Vector{T}(2:n)
    @inbounds badjlist[1] = T[]
    @inbounds fadjlist[2] = T[3]
    @inbounds badjlist[2] = T[1, n]
    @inbounds fadjlist[n] = T[2]
    @inbounds badjlist[n] = T[1, n - 1]

    @inbounds @simd for u in 3:(n - 1)
        fadjlist[u] = T[u + 1]
        badjlist[u] = T[1, u - 1]
    end
    return SimpleDiGraph(ne, fadjlist, badjlist)
end

"""
    grid(dims; periodic=false)

Create a ``|dims|``-dimensional cubic lattice, with length `dims[i]`
in dimension `i`.

### Optional Arguments
- `periodic=false`: If true, the resulting lattice will have periodic boundary
condition in each dimension.

# Examples
```jldoctest
julia> using Graphs

julia> grid([2,3])
{6, 7} undirected simple Int64 graph

julia> grid(Int8[2, 2, 2], periodic=true)
{8, 12} undirected simple Int8 graph

julia> grid((2,3))
{6, 7} undirected simple Int64 graph
```
"""
function grid(dims::AbstractVector{T}; periodic=false) where {T<:Integer}
    # checks if T is large enough for product(dims)
    Tw = widen(T)
    n = one(T)
    for d in dims
        d <= 0 && return SimpleGraph{T}(0)
        nw = Tw(n) * Tw(d)
        n = T(nw)
    end

    if periodic
        g = cycle_graph(dims[1])
        for d in dims[2:end]
            g = cartesian_product(cycle_graph(d), g)
        end
    else
        g = path_graph(dims[1])
        for d in dims[2:end]
            g = cartesian_product(path_graph(d), g)
        end
    end
    return g
end
grid(dims::Tuple; periodic=false) = grid(collect(dims); periodic=periodic)

"""
    binary_tree(k::Integer)

Create a [binary tree](https://en.wikipedia.org/wiki/Binary_tree)
of depth `k`.

# Examples
```jldoctest
julia> using Graphs

julia> binary_tree(4)
{15, 14} undirected simple Int64 graph

julia> binary_tree(Int8(5))
{31, 30} undirected simple Int8 graph
```
"""
function binary_tree(k::T) where {T<:Integer}
    k <= 0 && return SimpleGraph(0)
    k == 1 && return SimpleGraph(1)
    if Graphs.isbounded(k) && BigInt(2)^k - 1 > typemax(k)
        throw(DomainError(k, "2^k - 1 not representable by type $T"))
    end
    n = T(2^k - 1)

    ne = Int(n - 1)
    fadjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = T[2, 3]
    @inbounds for i in 1:(k - 2)
        @simd for j in (2 ^ i):(2 ^ (i + 1) - 1)
            fadjlist[j] = T[j ÷ 2, 2j, 2j + 1]
        end
    end
    i = k - 1
    @inbounds @simd for j in (2 ^ i):(2 ^ (i + 1) - 1)
        fadjlist[j] = T[j ÷ 2]
    end
    return SimpleGraph(ne, fadjlist)
end

"""
    double_binary_tree(k::Integer)

Create a double complete binary tree with `k` levels.

### References
- Used as an example for spectral clustering by Guattery and Miller 1998.

# Examples
```jldoctest
julia> using Graphs

julia> double_binary_tree(4)
{30, 29} undirected simple Int64 graph

julia> double_binary_tree(Int8(5))
{62, 61} undirected simple Int8 graph
```
"""
function double_binary_tree(k::Integer)
    gl = binary_tree(k)
    gr = binary_tree(k)
    g = blockdiag(gl, gr)
    add_edge!(g, 1, nv(gl) + 1)
    return g
end

"""
    regular_tree([T::Type], k, z)

Create a regular tree or [perfect z-ary tree](https://en.wikipedia.org/wiki/M-ary_tree#Types_of_m-ary_trees): 
a `k`-level tree where all nodes except the leaves have exactly `z` children. 
For `z = 2` one recovers a binary tree.
The optional `T` argument specifies the element type, which defaults to `Int64`.

# Examples
```jldoctest
julia> using Graphs

julia> regular_tree(4, 3)
{40, 39} undirected simple Int64 graph

julia> regular_tree(Int8, 3, 2)
{7, 6} undirected simple Int8 graph

julia> regular_tree(5, 2) == binary_tree(5)
true
```
"""
function regular_tree(T::Type{<:Integer}, k::Integer, z::Integer)
    z <= 0 && throw(DomainError(z, "number of children must be positive"))
    z == 1 && return path_graph(T(k))
    k <= 0 && return SimpleGraph(zero(T))
    k == 1 && return SimpleGraph(one(T))
    nbig = (BigInt(z)^k - 1) ÷ (z - 1)
    if Graphs.isbounded(k) && nbig > typemax(T)
        throw(InexactError(:convert, T, nbig))
    end

    n = T(nbig)
    ne = n - 1
    fadjlist = Vector{Vector{T}}(undef, n)
    @inbounds fadjlist[1] = convert.(T, 2:(z + 1))
    @inbounds for l in 2:(k - 1)
        w = (z^(l - 1) - 1) ÷ (z - 1)
        x = w + z^(l - 1)
        @simd for i in 1:(z ^ (l - 1))
            j = w + i
            fadjlist[j] = [
                T(ceil((j - x) / z) + w)
                convert.(T, (x + (i - 1) * z + 1):(x + i * z))
            ]
        end
    end
    l = k
    w = (z^(l - 1) - 1) ÷ (z - 1)
    x = w + z^(l - 1)
    @inbounds @simd for j in (w + 1):x
        fadjlist[j] = T[ceil((j - x) / z) + w]
    end
    return SimpleGraph(ne, fadjlist)
end

regular_tree(k::Integer, z::Integer) = regular_tree(Int64, k, z)

"""
    roach_graph(k)

Create a Roach graph of size `k`.

### References
- Guattery and Miller 1998

# Examples
```jldoctest
julia> using Graphs

julia> roach_graph(10)
{40, 48} undirected simple Int64 graph
```
"""
function roach_graph(k::Integer)
    dipole = complete_graph(2)
    nopole = SimpleGraph(2)
    antannae = crosspath(k, nopole)
    body = crosspath(k, dipole)
    roach = blockdiag(antannae, body)
    add_edge!(roach, nv(antannae) - 1, nv(antannae) + 1)
    add_edge!(roach, nv(antannae), nv(antannae) + 2)
    return roach
end

"""
    clique_graph(k, n)

Create a graph consisting of `n` connected `k`-cliques.

# Examples
```jldoctest
julia> using Graphs

julia> clique_graph(4, 10)
{40, 70} undirected simple Int64 graph

julia> clique_graph(Int8(10), Int8(4))
{40, 184} undirected simple Int8 graph
```
"""
function clique_graph(k::T, n::T) where {T<:Integer}
    Tw = widen(T)
    knw = Tw(k) * Tw(n)
    kn = T(knw)  # checks if T is large enough for k * n

    g = SimpleGraph(kn)
    for c in 1:n
        for i in ((c - 1) * k + 1):(c * k - 1), j in (i + 1):(c * k)
            add_edge!(g, i, j)
        end
    end
    for i in 1:(n - 1)
        add_edge!(g, (i - 1) * k + 1, i * k + 1)
    end
    add_edge!(g, 1, (n - 1) * k + 1)
    return g
end

"""
    ladder_graph(n)

Create a [ladder graph](https://en.wikipedia.org/wiki/Ladder_graph) consisting of `2n` nodes and `3n-2` edges.

### Implementation Notes
Preserves the eltype of `n`. Will error if the required number of vertices
exceeds the eltype.

# Examples
```jldoctest
julia> using Graphs

julia> ladder_graph(3)
{6, 7} undirected simple Int64 graph

julia> ladder_graph(Int8(4))
{8, 10} undirected simple Int8 graph
```
"""
function ladder_graph(n::T) where {T<:Integer}
    n <= 0 && return SimpleGraph{T}(0)
    n == 1 && return path_graph(T(2))
    Tw = widen(T)
    temp = T(Tw(n) + Tw(n)) # test to check if T is large enough

    fadjlist = Vector{Vector{T}}(undef, 2 * n)
    @inbounds @simd for i in 2:(n - 1)
        fadjlist[i] = T[i - 1, i + 1, i + n]
        fadjlist[n + i] = T[i, n + i - 1, n + i + 1]
    end
    fadjlist[1] = T[2, n + 1]
    fadjlist[n + 1] = T[1, n + 2]
    fadjlist[n] = T[n - 1, 2 * n]
    fadjlist[2 * n] = T[n, 2 * n - 1]

    return SimpleGraph(3 * n - 2, fadjlist)
end

"""
    circular_ladder_graph(n)

Create a [circular ladder graph](https://en.wikipedia.org/wiki/Ladder_graph#Circular_ladder_graph) consisting of `2n` nodes and `3n` edges.
This is also known as the [prism graph](https://en.wikipedia.org/wiki/Prism_graph).

### Implementation Notes
Preserves the eltype of the partitions vector. Will error if the required number of vertices
exceeds the eltype.
`n` must be at least 3 to avoid self-loops and multi-edges.

# Examples
```jldoctest
julia> using Graphs

julia> circular_ladder_graph(3)
{6, 9} undirected simple Int64 graph

julia> circular_ladder_graph(Int8(4))
{8, 12} undirected simple Int8 graph
```
"""
function circular_ladder_graph(n::Integer)
    n < 3 && throw(DomainError("n=$n must be at least 3"))
    g = ladder_graph(n)
    add_edge!(g, 1, n)
    add_edge!(g, n + 1, 2 * n)
    return g
end

"""
    barbell_graph(n1, n2)

Create a [barbell graph](https://en.wikipedia.org/wiki/Barbell_graph) consisting of a clique of size `n1` connected by an edge to a clique of size `n2`.

### Implementation Notes
Preserves the eltype of `n1` and `n2`. Will error if the required number of vertices
exceeds the eltype.
`n1` and `n2` must be at least 1 so that both cliques are non-empty.
The cliques are organized with nodes `1:n1` being the left clique and `n1+1:n1+n2` being the right clique. The cliques are connected by and edge `(n1, n1+1)`.

# Examples
```jldoctest
julia> using Graphs

julia> barbell_graph(3, 4)
{7, 10} undirected simple Int64 graph

julia> barbell_graph(Int8(5), Int8(5))
{10, 21} undirected simple Int8 graph
```
"""
function barbell_graph(n1::T, n2::T) where {T<:Integer}
    (n1 < 1 || n2 < 1) && throw(DomainError("n1=$n1 and n2=$n2 must be at least 1"))

    n = Base.Checked.checked_add(n1, n2) # check for overflow
    fadjlist = Vector{Vector{T}}(undef, n)

    ne = Int(n1) * (n1 - 1) ÷ 2 + Int(n2) * (n2 - 1) ÷ 2

    @inbounds @simd for u in 1:n1
        listu = Vector{T}(undef, n1 - 1)
        listu[1:(u - 1)] = 1:(u - 1)
        listu[u:(n1 - 1)] = (u + 1):n1
        fadjlist[u] = listu
    end

    @inbounds for u in 1:n2
        listu = Vector{T}(undef, n2 - 1)
        listu[1:(u - 1)] = (n1 + 1):(n1 + (u - 1))
        listu[u:(n2 - 1)] = (n1 + u + 1):(n1 + n2)
        fadjlist[n1 + u] = listu
    end

    g = SimpleGraph(ne, fadjlist)
    add_edge!(g, n1, n1 + 1)
    return g
end

"""
    lollipop_graph(n1, n2)

Create a [lollipop graph](https://en.wikipedia.org/wiki/Lollipop_graph) consisting of a clique of size `n1` connected by an edge to a path of size `n2`.

### Implementation Notes
Preserves the eltype of `n1` and `n2`. Will error if the required number of vertices
exceeds the eltype.
`n1` and `n2` must be at least 1 so that both the clique and the path have at least one vertex.
The graph is organized with nodes `1:n1` being the clique and `n1+1:n1+n2` being the path. The clique is connected to the path by an edge `(n1, n1+1)`.

# Examples
```jldoctest
julia> using Graphs

julia> lollipop_graph(2, 5)
{7, 6} undirected simple Int64 graph

julia> lollipop_graph(Int8(3), Int8(4))
{7, 7} undirected simple Int8 graph
```
"""
function lollipop_graph(n1::T, n2::T) where {T<:Integer}
    (n1 < 1 || n2 < 1) && throw(DomainError("n1=$n1 and n2=$n2 must be at least 1"))

    if n1 == 1
        return path_graph(T(n2 + 1))
    elseif n1 > 1 && n2 == 1
        g = complete_graph(n1)
        add_vertex!(g)
        add_edge!(g, n1, n1 + 1)
        return g
    end

    n = Base.Checked.checked_add(n1, n2) # check for overflow
    fadjlist = Vector{Vector{T}}(undef, n)

    ne = Int(Int(n1) * (n1 - 1) ÷ 2 + n2 - 1)

    @inbounds @simd for u in 1:n1
        listu = Vector{T}(undef, n1 - 1)
        listu[1:(u - 1)] = 1:(u - 1)
        listu[u:(n1 - 1)] = (u + 1):n1
        fadjlist[u] = listu
    end

    @inbounds fadjlist[n1 + 1] = T[n1 + 2]
    @inbounds fadjlist[n1 + n2] = T[n1 + n2 - 1]

    @inbounds @simd for u in (n1 + 2):(n1 + n2 - 1)
        fadjlist[u] = T[u - 1, u + 1]
    end

    g = SimpleGraph(ne, fadjlist)
    add_edge!(g, n1, n1 + 1)
    return g
end

@testset "Random walks" begin
    rng = StableRNG(1)

    """is_nonbacktracking: a predicate that tests if a walk is nonbacktracking.
        That is that for no index i walk[i+2]==walk[i]
    """
    function is_nonbacktracking(walk)
        n = length(walk)
        if n < 3
            return true
        end
        for i in 1:(n - 2)
            if walk[i + 2] == walk[i]
                return false
            end
        end
        return true
    end

    """test_nbw: check that a walk is nonbacktracking and print it if is isn't.
        Used only for testing and debugging.
    """
    function test_nbw(g, start, len)
        w = @inferred(non_backtracking_randomwalk(g, start, len, rng=rng))
        if is_nonbacktracking(w)
            return true
        else
            print("walk was:\n  $w")
        end
        return false
    end
    gx = path_digraph(10)
    for g in testdigraphs(gx)
        @test @inferred(randomwalk(g, 1, 5, rng=rng)) == [1:5;]
        @test @inferred(randomwalk(g, 2, 100, rng=rng)) == [2:10;]
        @test_throws BoundsError randomwalk(g, 20, 20, rng=rng)
        @test @inferred(non_backtracking_randomwalk(g, 10, 20, rng=rng)) == [10]
        @test @inferred(non_backtracking_randomwalk(g, 1, 20, rng=rng)) == [1:10;]
    end

    gx = path_graph(10)
    for g in testgraphs(gx)
        @test @inferred(self_avoiding_walk(g, 1, 20, rng=rng)) == [1:10;]
        @test_throws BoundsError self_avoiding_walk(g, 20, 20, rng=rng)
        @test @inferred(non_backtracking_randomwalk(g, 1, 20, rng=rng)) == [1:10;]
        @test_throws BoundsError non_backtracking_randomwalk(g, 20, 20, rng=rng)
    end

    gx = SimpleDiGraph(path_graph(10))
    for g in testdigraphs(gx)
        @test @inferred(non_backtracking_randomwalk(g, 1, 20, rng=rng)) == [1:10;]
        @test_throws BoundsError non_backtracking_randomwalk(g, 20, 20, rng=rng)
    end

    gx = cycle_graph(10)
    for g in testgraphs(gx)
        visited = @inferred(non_backtracking_randomwalk(g, 1, 20, rng=rng))
        @test visited == [1:10; 1:10] || visited == [1; 10:-1:1; 10:-1:2]
    end

    gx = cycle_digraph(10)
    for g in testdigraphs(gx)
        @test @inferred(non_backtracking_randomwalk(g, 1, 20, rng=rng)) == [1:10; 1:10]
    end

    n = 10
    gx = cycle_graph(n)
    for k in 3:(n - 1)
        add_edge!(gx, 1, k)
    end

    for g in testgraphs(gx)
        for len in 1:(3 * n)
            @test test_nbw(g, 1, len)
            @test test_nbw(g, 2, len)
        end
    end
    # test to make sure it works with self loops.
    add_edge!(gx, 1, 1)
    for g in testgraphs(gx)
        for len in 1:(3 * n)
            @test test_nbw(g, 1, len)
            @test test_nbw(g, 2, len)
        end
    end
end

using Graphs
using BenchmarkTools

SUITE["parallel"] = BenchmarkGroup([], "egonet" => BenchmarkGroup([]))

SUITE["serial"] = BenchmarkGroup([], "egonet" => BenchmarkGroup([]))

function vertex_function(g::Graph, i::Int)
    a = 0
    for u in neighbors(g, i)
        a += degree(g, u)
    end
    return a
end

function twohop(g::Graph, i::Int)
    a = 0
    for u in neighbors(g, i)
        for v in neighbors(g, u)
            a += degree(g, v)
        end
    end
    return a
end

function mapvertices(f, g::Graph)
    n = nv(g)
    a = zeros(Int, n)
    Threads.@threads for i in 1:n
        a[i] = f(g, i)
    end
    return a
end

function mapvertices_single(f, g)
    n = nv(g)
    a = zeros(Int, n)
    for i in 1:n
        a[i] = f(g, i)
    end
    return a
end

let
    nv_ = 10000
    g = SimpleGraph(nv_, 64 * nv_)

    SUITE["parallel"]["egonet"]["vertexfunction"] = @benchmarkable mapvertices(
        $vertex_function, $g
    )
    SUITE["parallel"]["egonet"]["twohop"] = @benchmarkable mapvertices($twohop, $g)

    SUITE["serial"]["egonet"]["vertexfunction"] = @benchmarkable mapvertices_single(
        $vertex_function, $g
    )
    SUITE["serial"]["egonet"]["twohop"] = @benchmarkable mapvertices_single($twohop, $g)
end

# NOTE: These tests are not part of the active test suite, because they require Distributions.jl.
# DO NOT INCORPORATE INTO runtests.jl.

using Distributions
using Graphs
using StatsBase
using Test
using Random: Random

import Base: -
import Graphs: randbn
import StatsBase: SummaryStats

function -(s::SummaryStats, t::SummaryStats)
    return SummaryStats(
        s.mean - t.mean,
        s.min - t.min,
        s.q25 - t.q25,
        s.median - t.median,
        s.q75 - t.q75,
        s.max - t.max,
    )
end
function binomial_test(n, p, s)
    drand = rand(Binomial(n, p), s)
    lrand = Int64[randbn(n, p) for i in 1:s]

    ds = summarystats(drand)
    ls = summarystats(lrand)
    dσ = std(drand)
    lσ = std(lrand)

    summarydiff = ds - ls
    @test abs(summarydiff.mean) / ds.mean < 0.10
    @test abs(summarydiff.median) / ds.median < 0.10
    @test abs(summarydiff.q25) / ds.q25 < 0.10
    @test abs(summarydiff.q75) / ds.q75 < 0.10

    @test abs(dσ - lσ) / dσ < 0.10
end
n = 10000
p = 0.3
s = 100000

@testset "($n, $p, $s)" for (n, p, s) in
                            [(100, 0.3, 1000), (1000, 0.8, 1000), (10000, 0.25, 1000)]
    binomial_test(n, p, s)
end

@testset "Parallel.Distance" begin
    g4 = path_digraph(5)
    adjmx1 = [0 1 0; 1 0 1; 0 1 0] # graph
    adjmx2 = [0 1 0; 1 0 1; 1 1 0] # digraph
    a1 = SimpleGraph(adjmx1)
    a2 = SimpleDiGraph(adjmx2)
    distmx1 = [Inf 2.0 Inf; 2.0 Inf 4.2; Inf 4.2 Inf]
    distmx2 = [Inf 2.0 Inf; 3.2 Inf 4.2; 5.5 6.1 Inf]

    for g in testgraphs(a1)
        z = @inferred(Graphs.eccentricity(g, distmx1))
        y = @inferred(Parallel.eccentricity(g, distmx1))
        @test isapprox(y, z)
        @test @inferred(Graphs.diameter(y)) ==
            @inferred(Parallel.diameter(g, distmx1)) ==
            6.2
        @test @inferred(Graphs.periphery(y)) ==
            @inferred(Parallel.periphery(g, distmx1)) ==
            [1, 3]
        @test @inferred(Graphs.radius(y)) == @inferred(Parallel.radius(g, distmx1)) == 4.2
        @test @inferred(Graphs.center(y)) == @inferred(Parallel.center(g, distmx1)) == [2]
    end

    for g in testdigraphs(a2)
        z = @inferred(Graphs.eccentricity(g, distmx2))
        y = @inferred(Parallel.eccentricity(g, distmx2))
        @test isapprox(y, z)
        @test @inferred(Graphs.diameter(y)) ==
            @inferred(Parallel.diameter(g, distmx2)) ==
            6.2
        @test @inferred(Graphs.periphery(y)) ==
            @inferred(Parallel.periphery(g, distmx2)) ==
            [1]
        @test @inferred(Graphs.radius(y)) == @inferred(Parallel.radius(g, distmx2)) == 4.2
        @test @inferred(Graphs.center(y)) == @inferred(Parallel.center(g, distmx2)) == [2]
    end
end

using Graphs.LinAlg
using Random
using SparseArrays
using LinearAlgebra
const linalgtestdir = dirname(@__FILE__)

tests = ["graphmatrices", "spectral", "nonbacktracking"]

@testset "Graphs.LinAlg" begin
    for t in tests
        tp = joinpath(linalgtestdir, "$(t).jl")
        include(tp)
    end
end

@testset "Small graphs" begin
    @testset "by string" begin
        g = smallgraph("diamondgraph")
        @test nv(g) == 4 && ne(g) == 5

        g = smallgraph("diamond")
        @test nv(g) == 4 && ne(g) == 5
    end

    smallgraphs = [
        (:diamond, 4, 5, false),
        (:bull, 5, 5, false),
        (:chvatal, 12, 24, false),
        (:cubical, 8, 12, false),
        (:desargues, 20, 30, false),
        (:dodecahedral, 20, 30, false),
        (:frucht, 12, 18, false),
        (:heawood, 14, 21, false),
        (:house, 5, 6, false),
        (:housex, 5, 8, false),
        (:icosahedral, 12, 30, false),
        (:krackhardtkite, 10, 18, false),
        (:moebiuskantor, 16, 24, false),
        (:octahedral, 6, 12, false),
        (:pappus, 18, 27, false),
        (:petersen, 10, 15, false),
        (:sedgewickmaze, 8, 10, false),
        (:tetrahedral, 4, 6, false),
        (:truncatedcube, 24, 36, false),
        (:truncatedtetrahedron, 12, 18, false),
        (:truncatedtetrahedron_dir, 12, 18, true),
        (:tutte, 46, 69, false),
    ]

    @testset "$(s[1])" for s in smallgraphs
        g = smallgraph(s[1])
        (nvg, neg, dir) = s[2:4]
        @test nv(g) == nvg
        @test ne(g) == neg
        @test is_directed(g) == dir
    end

    @testset "karate" begin
        g = smallgraph(:karate)
        degree_sequence = sort([
            16,
            9,
            10,
            6,
            3,
            4,
            4,
            4,
            5,
            2,
            3,
            1,
            2,
            5,
            2,
            2,
            2,
            2,
            2,
            3,
            2,
            2,
            2,
            5,
            3,
            3,
            2,
            4,
            3,
            4,
            4,
            6,
            12,
            17,
        ])
        @test nv(g) == 34 && ne(g) == 78 && sort(degree(g)) == degree_sequence
    end
    @testset "nonexistent graph" begin
        @test_throws ArgumentError g = smallgraph(:nonexistent)
    end
end

@testset "Transitivity" begin
    completedg = complete_digraph(4)
    circledg = path_digraph(4)
    add_edge!(circledg, 4, 1)
    @testset "$circle" for circle in testgraphs(circledg)
        T = eltype(circle)
        complete = DiGraph{T}(completedg)
        @testset "no self-loops" begin
            newcircle = @inferred(transitiveclosure(circle))
            @test newcircle == complete
            @test ne(circle) == 4
            c = copy(circle)
            @test newcircle == @inferred(transitiveclosure!(c))
            @test ne(c) == ne(newcircle) == 12
        end

        loopedcomplete = copy(complete)
        for i in vertices(loopedcomplete)
            add_edge!(loopedcomplete, i, i)
        end
        @testset "self-loops" begin
            newcircle = @inferred(transitiveclosure(circle, true))
            @test newcircle == loopedcomplete
            @test ne(circle) == 4
            c = copy(circle)
            @test newcircle == @inferred(transitiveclosure!(c, true))
            @test ne(c) == ne(newcircle) == 16
        end
    end

    # transitivereduction
    @testset "Transitive Reduction" begin
        # transitive reduction of the nullgraph is again a nullgraph
        @testset "nullgraph reduction" begin
            nullgraph = SimpleDiGraph(0)
            @testset "g" for g in testgraphs(nullgraph)
                @test g == @inferred(transitivereduction(g))
            end
        end

        # transitive reduction of a path is a path again
        @testset "pathgraph reduction" begin
            pathgraph = path_digraph(10)
            @testset "$g" for g in testgraphs(pathgraph)
                @test g == @inferred(transitivereduction(g))

                # transitive reduction of the transitive closure of a path is a path again
                gclosure = transitiveclosure(g)
                @test g == @inferred(transitivereduction(gclosure))
            end
        end

        # Transitive reduction of a complete graph should be s simple cycle
        @testset "completegraph reduction" begin
            completegraph = complete_digraph(9)
            @testset "$g" for g in testgraphs(completegraph)
                greduced = @inferred(transitivereduction(g))
                @test length(strongly_connected_components(greduced)) == 1 &&
                    ne(greduced) == nv(g)
            end
        end

        # transitive reduction a graph with no edges is the same graph again
        @testset "zero-edge reduction" begin
            noedgegraph = SimpleDiGraph(7)
            @testset "$g" for g in testgraphs(noedgegraph)
                @test g == @inferred(transitivereduction(g))
            end
        end

        # transitve reduction should maintain a selfloop only when selflooped==true
        @testset "selfloops reduction" begin
            selfloopgraph = SimpleDiGraph(1)
            add_edge!(selfloopgraph, 1, 1)
            @testset "$g" for g in testgraphs(selfloopgraph)
                @test g == @inferred(transitivereduction(g; selflooped=true))
                @test g != @inferred(transitivereduction(g; selflooped=false))
            end

            # transitive should not maintain selfloops for strongly connected components
            # of size > 1
            selfloopgraph2 = SimpleDiGraph(2)
            add_edge!(selfloopgraph2, 1, 1)
            add_edge!(selfloopgraph2, 1, 2)
            add_edge!(selfloopgraph2, 2, 1)
            add_edge!(selfloopgraph2, 2, 2)
            @testset "$g" for g in testgraphs(selfloopgraph2)
                @test g != @inferred(transitivereduction(g; selflooped=true))
            end
        end

        # directed barbell graph should result in two cycles connected by a single edge
        @testset "barbell" begin
            barbellgraph = SimpleDiGraph(9)
            for i in 1:4, j in 1:4
                i == j && continue
                add_edge!(barbellgraph, i, j)
                add_edge!(barbellgraph, j, i)
            end
            for i in 5:9, j in 5:9
                i == j && continue
                add_edge!(barbellgraph, i, j)
                add_edge!(barbellgraph, j, i)
            end
            add_edge!(barbellgraph, 1, 5)
            @testset "$g" for g in testgraphs(barbellgraph)
                greduced = @inferred(transitivereduction(g))
                scc = strongly_connected_components(greduced)
                @test Set(scc) == Set([[1:4;], [5:9;]])
                @test ne(greduced) == 10
                @test length(weakly_connected_components(greduced)) == 1
            end
        end
    end
end

# using Graphs
# using Graphs.Parallel
# using Base.Threads: @threads, Atomic

tests = [
# "traversals/gdistances",  # TODO currently disabled as the code in gdistances seems to be broken
]

@testset "Graphs.Experimental.Parallel" begin
    for t in tests
        tp = joinpath(dirname(@__FILE__), "$(t).jl")
        include(tp)
    end
end

# Inspiration for this code came from EvolvingGraphs:
# https://github.com/weijianzhang/EvolvingGraphs.jl
#
# The EvolvingGraphs.jl package is licensed under the MIT "Expat" License:
# Copyright (c) 2015: Weijian Zhang.
# Permission is hereby granted, free of charge, to any person obtaining a
# copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.#
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
# OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

"""
    katz_centrality(g, α=0.3)

Calculate the [Katz centrality](https://en.wikipedia.org/wiki/Katz_centrality)
of the graph `g` optionally parameterized by `α`. Return a vector representing
the centrality calculated for each node in `g`.
"""
function katz_centrality(g::AbstractGraph, α::Real=0.3)
    nvg = nv(g)
    v = ones(Float64, nvg)
    spI = sparse(one(Float64) * I, nvg, nvg)
    A = adjacency_matrix(g, Bool; dir=:in)
    v = (spI - α * A) \ v
    v /= norm(v)
    return v
end

@testset "Clustering" begin
    g10 = complete_graph(10)
    for g in test_generic_graphs(g10)
        @test @inferred(local_clustering_coefficient(g, 1)) == 1.0
        @test @inferred(local_clustering_coefficient(g)) == ones(10)
        @test @inferred(global_clustering_coefficient(g)) == 1.0
        @test @inferred(local_clustering(g)) == (fill(36, 10), fill(36, 10))
        @test @inferred(triangles(g)) == fill(36, 10)
        @test @inferred(triangles(g, 1)) == 36
    end
    # 1265 / 1266
    g = complete_graph(3)
    add_edge!(g, 2, 2)
    @test @inferred(triangles(GenericGraph(g))) == fill(1, 3)
end

@testset "Parallel.Radiality" begin
    gint = loadgraph(joinpath(testdir, "testdata", "graph-50-500.jgz"), "graph-50-500")
    c = vec(readdlm(joinpath(testdir, "testdata", "graph-50-500-rc.txt"), ','))
    for g in testdigraphs(gint)
        zd = @inferred(Parallel.radiality_centrality(g; parallel=:distributed))
        @test zd == c
        zt = @inferred(Parallel.radiality_centrality(g; parallel=:threads))
        @test zt == c
    end

    g1 = cycle_graph(4)
    add_vertex!(g1)
    add_edge!(g1, 4, 5)
    for g in testgraphs(g1)
        zd = @inferred(Parallel.radiality_centrality(g; parallel=:distributed))
        @test zd ≈ [5//6, 3//4, 5//6, 11//12, 2//3]
        zt = @inferred(Parallel.radiality_centrality(g; parallel=:threads))
        @test zt ≈ [5//6, 3//4, 5//6, 11//12, 2//3]
    end
end

import Graphs: tree
@testset "BFS" begin
    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)
    g6 = smallgraph(:house)

    @testset "bfs_tree and bfs_parents" begin
        for g in testdigraphs(g5)
            z = @inferred(bfs_tree(g, 1))
            t = bfs_parents(g, 1)
            @test t == [1, 1, 1, 3]
            @test nv(z) == 4 && ne(z) == 3 && !has_edge(z, 2, 3)
        end

        for g in testgraphs(g6)
            n = nv(g)
            parents = bfs_parents(g, 1)
            @test length(parents) == n
            t1 = @inferred(bfs_tree(g, 1))
            t2 = tree(parents)
            @test t1 == t2
            @test is_directed(t2)
            @test typeof(t2) <: AbstractGraph
            @test ne(t2) < nv(t2)
        end
    end

    @testset "gdistances" begin
        for g in testgraphs(g6)
            @test @inferred(gdistances(g, 2)) ==
                @inferred(gdistances(g, 2; sort_alg=MergeSort)) ==
                [1, 0, 2, 1, 2]
            @test @inferred(gdistances(g, [1, 2])) == [0, 0, 1, 1, 2]
            @test @inferred(gdistances(g, [])) == fill(typemax(eltype(g)), 5)
        end
    end

    @testset "is_bipartite" begin
        gx = SimpleGraph(5)
        add_edge!(gx, 1, 2)
        add_edge!(gx, 1, 4)
        add_edge!(gx, 2, 3)
        add_edge!(gx, 2, 5)
        add_edge!(gx, 3, 4)

        for g in testgraphs(gx)
            @test @inferred(is_bipartite(g))
        end
    end

    @testset "has_path" begin
        gx = SimpleGraph(6)
        d = nv(gx)
        for (i, j) in [(1, 2), (2, 3), (2, 4), (4, 5), (3, 5)]
            add_edge!(gx, i, j)
        end
        for g in testgraphs(gx)
            @test has_path(g, 1, 5)
            @test has_path(g, 1, 2)
            @test has_path(g, 1, 5; exclude_vertices=[3])
            @test has_path(g, 1, 5; exclude_vertices=[4])
            @test !has_path(g, 1, 5; exclude_vertices=[3, 4])
            @test has_path(g, 5, 1)
            @test has_path(g, 5, 1; exclude_vertices=[3])
            @test has_path(g, 5, 1; exclude_vertices=[4])
            @test !has_path(g, 5, 1; exclude_vertices=[3, 4])

            # Edge cases
            @test !has_path(g, 1, 6)
            @test !has_path(g, 6, 1)
            @test has_path(g, 1, 1) # inseparable 
            @test !has_path(g, 1, 2; exclude_vertices=[2])
            @test !has_path(g, 1, 2; exclude_vertices=[1])
        end
    end

    # import Graphs: TreeBFSVisitorVector, bfs_tree!, tree

    function istree(parents::Vector{T}, maxdepth, n::T) where {T<:Integer}
        flag = true
        for i in one(T):n
            s = i
            depth = 0
            while parents[s] > 0 && parents[s] != s
                s = parents[s]
                depth += 1
                if depth > maxdepth
                    return false
                end
            end
        end
        return flag
    end
end

function johnson_shortest_paths(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number} where {U<:Integer}
    nvg = nv(g)
    type_distmx = typeof(distmx)
    # Change when parallel implementation of Bellman Ford available
    wt_transform = bellman_ford_shortest_paths(g, vertices(g), distmx).dists

    if !ismutable(distmx) && type_distmx != Graphs.DefaultDistance
        distmx = sparse(distmx) # Change reference, not value
    end

    # Weight transform not needed if all weights are positive.
    if type_distmx != Graphs.DefaultDistance
        for e in edges(g)
            distmx[src(e), dst(e)] += wt_transform[src(e)] - wt_transform[dst(e)]
        end
    end

    dijk_state = Parallel.dijkstra_shortest_paths(g, vertices(g), distmx)
    dists = dijk_state.dists
    parents = dijk_state.parents

    broadcast!(-, dists, dists, wt_transform)
    for v in vertices(g)
        dists[:, v] .+= wt_transform[v] # Vertical traversal preferred
    end

    if ismutable(distmx)
        for e in edges(g)
            distmx[src(e), dst(e)] += wt_transform[dst(e)] - wt_transform[src(e)]
        end
    end

    return JohnsonState(dists, parents)
end

@testset "Greedy Coloring" begin
    g3 = star_graph(10)

    for g in testgraphs(g3)
        for op_sort in (true, false)
            C = @inferred(greedy_color(g, reps=5, sort_degree=op_sort))
            @test C.num_colors == 2
        end
    end

    g4 = path_graph(20)
    g5 = complete_graph(20)

    for graph in [g4, g5]
        for g in testgraphs(graph)
            for op_sort in (true, false)
                C = @inferred(greedy_color(g, reps=5, sort_degree=op_sort))

                @test C.num_colors <= maximum(degree(g)) + 1
                correct = true
                for e in edges(g)
                    C.colors[src(e)] == C.colors[dst(e)] && (correct = false)
                end
                @test correct
            end
        end
    end

    # non-regression test for #112
    g = Graph(1)
    add_edge!(g, 1, 1)
    @test_throws ArgumentError greedy_color(g)
end

module LinAlg

using ArnoldiMethod: LM, SR, LR, partialschur, partialeigen

using SimpleTraits
using SparseArrays: SparseMatrixCSC
import SparseArrays: blockdiag, sparse, spdiagm
using LinearAlgebra: I, Symmetric, diagm, dot, eigen, eigvals, norm, rmul!, tril, triu
import LinearAlgebra: Diagonal, diag, issymmetric, mul!

using ..Graphs

import Base: convert, size, eltype, ndims, ==, *, length

export convert,
    SparseMatrix,
    GraphMatrix,
    Adjacency,
    adjacency,
    Laplacian,
    CombinatorialAdjacency,
    CombinatorialLaplacian,
    NormalizedAdjacency,
    NormalizedLaplacian,
    StochasticAdjacency,
    StochasticLaplacian,
    AveragingAdjacency,
    AveragingLaplacian,
    PunchedAdjacency,
    Noop,
    diag,
    degrees,
    symmetrize,
    prescalefactor,
    postscalefactor,
    perron,
    non_backtracking_matrix,
    Nonbacktracking,
    contract!,
    contract,
    adjacency_matrix,
    laplacian_matrix,
    incidence_matrix,
    adjacency_spectrum,
    laplacian_spectrum,
    coo_sparse,
    spectral_distance,
    eigs

function eigs(A; kwargs...)
    schr = partialschur(A; kwargs...)
    vals, vectors = partialeigen(schr[1])
    reved = (kwargs[:which] == LR() || kwargs[:which] == LM())
    k = min(get(kwargs, :nev, length(vals))::Int, length(vals))
    perm = sortperm(vals; by=real, rev=reved)[1:k]
    λ = vals[perm]
    Q = vectors[:, perm]
    return λ, Q
end

include("./graphmatrices.jl")
include("./spectral.jl")
include("./nonbacktracking.jl")

end

function path_from_parents(target::Integer, parents::AbstractVector)
    v = target
    path = [v]
    while parents[v] != v && parents[v] != zero(v)
        v = parents[v]
        pushfirst!(path, v)
    end
    return path
end

using Statistics

@testset "Assortativity" begin
    # Test definition of assortativity as Pearson correlation coefficient
    # between excess of degrees
    @testset "Small graphs" for n in 5:10
        @test @inferred assortativity(GenericGraph(wheel_graph(n))) ≈ -1 / 3
    end
    @testset "Directed ($seed)" for seed in [1, 2, 3],
        (n, ne) in [(14, 18), (10, 22), (7, 16)]

        g = GenericDiGraph(erdos_renyi(n, ne; is_directed=true, rng=StableRNG(seed)))
        assort = assortativity(g)
        x = [outdegree(g, src(d)) - 1 for d in edges(g)]
        y = [indegree(g, dst(d)) - 1 for d in edges(g)]
        @test @inferred assort ≈ cor(x, y)
    end
    @testset "Undirected ($seed)" for seed in [1, 2, 3],
        (n, ne) in [(14, 18), (10, 22), (7, 16)]

        g = GenericGraph(erdos_renyi(n, ne; is_directed=false, rng=StableRNG(seed)))
        assort = assortativity(g)
        x = [outdegree(g, src(d)) - 1 for d in edges(g)]
        y = [indegree(g, dst(d)) - 1 for d in edges(g)]
        @test @inferred assort ≈ cor([x; y], [y; x])
    end
end

@testset "Bellman Ford" begin
    g4 = path_digraph(5)

    d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
    d2 = sparse(float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]))
    for g in test_generic_graphs(g4)
        y = @inferred(bellman_ford_shortest_paths(g, 2, d1))
        z = @inferred(bellman_ford_shortest_paths(g, 2, d2))
        @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
        @test @inferred(enumerate_paths(z))[2] == []
        @test @inferred(enumerate_paths(z))[4] == enumerate_paths(z, 4) == [2, 3, 4]
        @test @inferred(!has_negative_edge_cycle(g))
        @test @inferred(!has_negative_edge_cycle(g, d1))

        y = @inferred(bellman_ford_shortest_paths(g, 2, d1))
        z = @inferred(bellman_ford_shortest_paths(g, 2, d2))
        @test y.dists == z.dists == [Inf, 0, 6, 17, 33]
        @test @inferred(enumerate_paths(z))[2] == []
        @test @inferred(enumerate_paths(z))[4] == enumerate_paths(z, 4) == [2, 3, 4]
        @test @inferred(!has_negative_edge_cycle(g))
        z = @inferred(bellman_ford_shortest_paths(g, 2))
        @test z.dists == [typemax(Int), 0, 1, 2, 3]
    end

    # Negative Cycle
    gx = complete_graph(3)
    for g in test_generic_graphs(gx)
        d = [1 -3 1; -3 1 1; 1 1 1]
        @test_throws Graphs.NegativeCycleError bellman_ford_shortest_paths(g, 1, d)
        @test has_negative_edge_cycle(g, d)

        d = [1 -1 1; -1 1 1; 1 1 1]
        @test_throws Graphs.NegativeCycleError bellman_ford_shortest_paths(g, 1, d)
        @test has_negative_edge_cycle(g, d)
    end

    # Negative cycle of length 3 in graph of diameter 4
    gx = complete_graph(4)
    d = [1 -1 1 1; 1 1 1 -1; 1 1 1 1; 1 1 1 1]
    for g in test_generic_graphs(gx)
        @test_throws Graphs.NegativeCycleError bellman_ford_shortest_paths(g, 1, d)
        @test has_negative_edge_cycle(g, d)
    end

    # setting zeros with zero(T)
    struct CustomReal <: Real
        val::Float64
        bias::Int  # need this, to avoid auto conversion of CustomReal(0)
    end
    Base.zero(::T) where {T<:CustomReal} = zero(T)
    Base.zero(::Type{CustomReal}) = CustomReal(0.0, 4)
    Base.typemax(::T) where {T<:CustomReal} = typemax(T)
    Base.typemax(::Type{CustomReal}) = CustomReal(typemax(Float64), 0)
    Base.:+(a::CustomReal, b::CustomReal) = CustomReal(a.val + b.val, 0)
    Base.:<(a::CustomReal, b::CustomReal) = a.val < b.val

    d3 = [CustomReal(i, 3) for i in d1]
    d4 = sparse(d3)
    for g in test_generic_graphs(g4)
        y = @inferred(bellman_ford_shortest_paths(g, 2, d3))
        z = @inferred(bellman_ford_shortest_paths(g, 2, d4))
        @test getfield.(y.dists, :val) == getfield.(z.dists, :val) == [Inf, 0, 6, 17, 33]
        @test @inferred(enumerate_paths(z))[2] == []
        @test @inferred(enumerate_paths(z))[4] == enumerate_paths(z, 4) == [2, 3, 4]
        @test @inferred(enumerate_paths!([[0]], z, 4:4))[1] == [2, 3, 4]
        @test_throws ArgumentError enumerate_paths!([[0, 0], [0, 0]], z, 4:4)
        @test @inferred(!has_negative_edge_cycle(g))
        @test @inferred(!has_negative_edge_cycle(g, d3))

        y = @inferred(bellman_ford_shortest_paths(g, 2, d3))
        z = @inferred(bellman_ford_shortest_paths(g, 2, d4))
        @test getfield.(y.dists, :val) == getfield.(z.dists, :val) == [Inf, 0, 6, 17, 33]
        @test @inferred(enumerate_paths(z))[2] == []
        @test @inferred(enumerate_paths(z))[4] == enumerate_paths(z, 4) == [2, 3, 4]
        @test @inferred(!has_negative_edge_cycle(g))
        z = @inferred(bellman_ford_shortest_paths(g, 2))
        @test z.dists == [typemax(Int), 0, 1, 2, 3]
    end
end

using BenchmarkTools, Graphs

const BENCHDIR = dirname(@__FILE__)

const DIGRAPHS = Dict{String,DiGraph}(
    "complete100" => complete_digraph(100), "path500" => path_digraph(500)
)

const GRAPHS = Dict{String,Graph}(
    "complete100" => complete_graph(100),
    "tutte" => smallgraph(:tutte),
    "path500" => path_graph(500),
)

serialbenchmarks = [
    "serial/core.jl",
    "serial/connectivity.jl",
    "serial/centrality.jl",
    "serial/edges.jl",
    "serial/insertions.jl",
    "serial/traversals.jl",
]

const SUITE = BenchmarkGroup()

foreach(serialbenchmarks) do bm
    include(bm)
end

parallelbenchmarks = ["parallel/egonets.jl"]

foreach(parallelbenchmarks) do bm
    include(joinpath(BENCHDIR, bm))
end

"""
    VF2

An empty concrete type used to dispatch to [`vf2`](@ref) isomorphism functions.
"""
struct VF2 <: IsomorphismAlgorithm end

"""
    VF2State{G, T}

Structure that is internally used by vf2
"""
struct VF2State{G,T}
    g1::G
    g2::G
    core_1::Vector{T}
    core_2::Vector{T}
    in_1::Vector{T}
    in_2::Vector{T}
    out_1::Vector{T}
    out_2::Vector{T}

    function VF2State(g1::G, g2::G) where {G<:AbstractSimpleGraph{T}} where {T<:Integer}
        n1 = nv(g1)
        n2 = nv(g2)
        core_1 = zeros(T, n1)
        core_2 = zeros(T, n2)
        in_1 = zeros(T, n1)
        in_2 = zeros(T, n2)
        out_1 = zeros(T, n1)
        out_2 = zeros(T, n2)

        return new{G,T}(g1, g2, core_1, core_2, in_1, in_2, out_1, out_2)
    end
end

"""
    vf2(callback, g1, g2, problemtype; vertex_relation=nothing, edge_relation=nothing)

Iterate over all isomorphism between the graphs `g1` (or subgraphs thereof) and `g2`.
The problem that is solved depends on the value of `problemtype`:
- IsomorphismProblem(): Only isomorphisms between the whole graph `g1` and `g2` are considered.
- SubGraphIsomorphismProblem(): All isomorphism between subgraphs of `g1` and `g2` are considered.
- InducedSubGraphIsomorphismProblem(): All isomorphism between vertex induced subgraphs of `g1` and `g2` are considered.

Upon finding an isomorphism, the function `callback` is called with a vector `vmap` as an argument.
`vmap` is a vector where `vmap[v] == u` means that vertex `v` in `g2` is mapped to vertex `u` in `g1`.
If the algorithm should look for another isomorphism, then this function should return `true`.

### Optional Arguments
- `vertex_relation`: A binary function that takes a vertex from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched vertices.
- `edge_relation`: A binary function that takes an edge from `g1` and one from `g2`. An
    isomorphism only exists if this function returns `true` for all matched edges.

### References
Luigi P. Cordella, Pasquale Foggia, Carlo Sansone, Mario Vento
“A (Sub)Graph Isomorphism Algorithm for Matching Large Graphs”
"""
function vf2(
    callback::Function,
    g1::G,
    g2::G,
    problemtype::GraphMorphismProblem;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
) where {G<:AbstractSimpleGraph}
    if nv(g1) < nv(g2) || (problemtype == IsomorphismProblem() && nv(g1) != nv(g2))
        return nothing
    end

    start_state = VF2State(g1, g2)
    start_depth = 1
    vf2match!(
        start_state, start_depth, callback, problemtype, vertex_relation, edge_relation
    )
    return nothing
end

"""
    vf2check_feasibility(u, v, state, problemtype, vertex_relation, edge_relation)

Check whether two vertices of G₁ and G₂ can be matched. Used by [`vf2match!`](@ref).
"""
function vf2check_feasibility(
    u,
    v,
    state::VF2State,
    problemtype,
    vertex_relation::Union{Nothing,Function},
    edge_relation::Union{Nothing,Function},
)
    @inline function vf2rule_pred(u, v, state::VF2State, problemtype)
        if problemtype != SubGraphIsomorphismProblem()
            @inbounds for u2 in inneighbors(state.g1, u)
                if state.core_1[u2] != 0
                    found = false
                    # TODO can probably be replaced with has_edge for better performance
                    for v2 in inneighbors(state.g2, v)
                        if state.core_1[u2] == v2
                            found = true
                            break
                        end
                    end
                    found || return false
                end
            end
        end
        @inbounds for v2 in inneighbors(state.g2, v)
            if state.core_2[v2] != 0
                found = false
                for u2 in inneighbors(state.g1, u)
                    if state.core_2[v2] == u2
                        found = true
                        break
                    end
                end
                found || return false
            end
        end
        return true
    end

    @inline function vf2rule_succ(u, v, state::VF2State, problemtype)
        if problemtype != SubGraphIsomorphismProblem()
            @inbounds for u2 in outneighbors(state.g1, u)
                if state.core_1[u2] != 0
                    found = false
                    for v2 in outneighbors(state.g2, v)
                        if state.core_1[u2] == v2
                            found = true
                            break
                        end
                    end
                    found || return false
                end
            end
        end
        found = false
        @inbounds for v2 in outneighbors(state.g2, v)
            if state.core_2[v2] != 0
                found = false
                for u2 in outneighbors(state.g1, u)
                    if state.core_2[v2] == u2
                        found = true
                        break
                    end
                end
                found || return false
            end
        end
        return true
    end

    @inline function vf2rule_in(u, v, state::VF2State, problemtype)
        count1 = 0
        count2 = 0
        @inbounds for u2 in outneighbors(state.g1, u)
            if state.in_1[u2] != 0 && state.core_1[u2] == 0
                count1 += 1
            end
        end
        @inbounds for v2 in outneighbors(state.g2, v)
            if state.in_2[v2] != 0 && state.core_2[v2] == 0
                count2 += 1
            end
        end
        if problemtype == IsomorphismProblem()
            count1 == count2 || return false
        else
            count1 >= count2 || return false
        end
        count1 = 0
        count2 = 0
        @inbounds for u2 in inneighbors(state.g1, u)
            if state.in_1[u2] != 0 && state.core_1[u2] == 0
                count1 += 1
            end
        end
        @inbounds for v2 in inneighbors(state.g2, v)
            if state.in_2[v2] != 0 && state.core_2[v2] == 0
                count2 += 1
            end
        end
        problemtype == IsomorphismProblem() && return count1 == count2

        return count1 >= count2
    end

    @inline function vf2rule_out(u, v, state::VF2State, problemtype)
        count1 = 0
        count2 = 0
        @inbounds for u2 in outneighbors(state.g1, u)
            if state.out_1[u2] != 0 && state.core_1[u2] == 0
                count1 += 1
            end
        end
        @inbounds for v2 in outneighbors(state.g2, v)
            if state.out_2[v2] != 0 && state.core_2[v2] == 0
                count2 += 1
            end
        end
        if problemtype == IsomorphismProblem()
            count1 == count2 || return false
        else
            count1 >= count2 || return false
        end

        count1 = 0
        count2 = 0
        @inbounds for u2 in inneighbors(state.g1, u)
            if state.out_1[u2] != 0 && state.core_1[u2] == 0
                count1 += 1
            end
        end
        @inbounds for v2 in inneighbors(state.g2, v)
            if state.out_2[v2] != 0 && state.core_2[v2] == 0
                count2 += 1
            end
        end
        problemtype == IsomorphismProblem() && return count1 == count2

        return count1 >= count2
    end

    @inline function vf2rule_new(u, v, state::VF2State, problemtype)
        problemtype == SubGraphIsomorphismProblem() && return true
        count1 = 0
        count2 = 0
        @inbounds for u2 in inneighbors(state.g1, u)
            if state.in_1[u2] == 0 && state.out_1[u2] == 0
                count1 += 1
            end
        end
        @inbounds for v2 in inneighbors(state.g2, v)
            if state.in_2[v2] == 0 && state.out_2[v2] == 0
                count2 += 1
            end
        end
        if problemtype == IsomorphismProblem()
            count1 == count2 || return false
        else
            count1 >= count2 || return false
        end
        count1 = 0
        count2 = 0
        @inbounds for u2 in outneighbors(state.g1, u)
            if state.in_1[u2] == 0 && state.out_1[u2] == 0
                count1 += 1
            end
        end
        @inbounds for v2 in outneighbors(state.g2, v)
            if state.in_2[v2] == 0 && state.out_2[v2] == 0
                count2 += 1
            end
        end
        problemtype == IsomorphismProblem() && return count1 == count2

        return count1 >= count2
    end

    @inline function vf2rule_self_loops(u, v, state, problemtype)
        u_selflooped = has_edge(state.g1, u, u)
        v_selflooped = has_edge(state.g2, v, v)

        if problemtype == SubGraphIsomorphismProblem()
            return u_selflooped || !v_selflooped
        end
        return u_selflooped == v_selflooped
    end

    syntactic_feasability =
        vf2rule_pred(u, v, state, problemtype) &&
        vf2rule_succ(u, v, state, problemtype) &&
        vf2rule_in(u, v, state, problemtype) &&
        vf2rule_out(u, v, state, problemtype) &&
        vf2rule_new(u, v, state, problemtype) &&
        vf2rule_self_loops(u, v, state, problemtype)
    syntactic_feasability || return false

    if !isnothing(vertex_relation)
        vertex_relation(u, v) || return false
    end
    if !isnothing(edge_relation)
        E1 = edgetype(state.g1)
        E2 = edgetype(state.g2)
        for u2 in outneighbors(state.g1, u)
            state.core_1[u2] == 0 && continue
            v2 = state.core_1[u2]
            edge_relation(E1(u, u2), E2(v, v2)) || return false
        end
        for u2 in inneighbors(state.g1, u)
            state.core_1[u2] == 0 && continue
            v2 = state.core_1[u2]
            edge_relation(E1(u2, u), E2(v2, v)) || return false
        end
    end
    return true
end

"""
    vf2update_state!(state, u, v, depth)

Update state before recursing. Helper function for [`vf2match!`](@ref).
"""
function vf2update_state!(state::VF2State, u, v, depth)
    @inbounds begin
        state.core_1[u] = v
        state.core_2[v] = u
        for w in outneighbors(state.g1, u)
            if state.out_1[w] == 0
                state.out_1[w] = depth
            end
        end
        for w in inneighbors(state.g1, u)
            if state.in_1[w] == 0
                state.in_1[w] = depth
            end
        end
        for w in outneighbors(state.g2, v)
            if state.out_2[w] == 0
                state.out_2[w] = depth
            end
        end
        for w in inneighbors(state.g2, v)
            if state.in_2[w] == 0
                state.in_2[w] = depth
            end
        end
    end
end

"""
    vf2reset_state!(state, u, v, depth)

Reset state after returning from recursion. Helper function for [`vf2match!`](@ref).
"""
function vf2reset_state!(state::VF2State, u, v, depth)
    @inbounds begin
        state.core_1[u] = 0
        state.core_2[v] = 0
        for w in outneighbors(state.g1, u)
            if state.out_1[w] == depth
                state.out_1[w] = 0
            end
        end
        for w in inneighbors(state.g1, u)
            if state.in_1[w] == depth
                state.in_1[w] = 0
            end
        end
        for w in outneighbors(state.g2, v)
            if state.out_2[w] == depth
                state.out_2[w] = 0
            end
        end
        for w in inneighbors(state.g2, v)
            if state.in_2[w] == depth
                state.in_2[w] = 0
            end
        end
    end
end

"""
    vf2match!(state, depth, callback, problemtype, vertex_relation, edge_relation)

Perform isomorphic subgraph matching. Called by [`vf2`](@ref).
"""
function vf2match!(
    state,
    depth,
    callback::Function,
    problemtype::GraphMorphismProblem,
    vertex_relation,
    edge_relation,
)
    n1 = Int(nv(state.g1))
    n2 = Int(nv(state.g2))
    # if all vertices of G₂ are matched we call the callback function. If the
    # algorithm should look for another isomorphism then callback has to return true
    if depth > n2
        keepgoing = callback(state.core_2)
        return keepgoing
    end
    # First we try if there is a pair of unmatched vertices u∈G₁ v∈G₂ that are connected
    # by an edge going out of the set M(s) of already matched vertices
    found_pair = false
    v = 0
    @inbounds for j in 1:n2
        if state.out_2[j] != 0 && state.core_2[j] == 0
            v = j
            break
        end
    end
    if v != 0
        @inbounds for u in 1:n1
            if state.out_1[u] != 0 && state.core_1[u] == 0
                found_pair = true
                if vf2check_feasibility(
                    u, v, state, problemtype, vertex_relation, edge_relation
                )
                    vf2update_state!(state, u, v, depth)
                    keepgoing = vf2match!(
                        state,
                        depth + 1,
                        callback,
                        problemtype,
                        vertex_relation,
                        edge_relation,
                    )
                    keepgoing || return false
                    vf2reset_state!(state, u, v, depth)
                end
            end
        end
    end
    found_pair && return true
    # If that is not the case we try if there is a pair of unmatched vertices u∈G₁ v∈G₂ that
    # are connected  by an edge coming in from the set M(s) of already matched vertices
    v = 0
    @inbounds for j in 1:n2
        if state.in_2[j] != 0 && state.core_2[j] == 0
            v = j
            break
        end
    end
    if v != 0
        @inbounds for u in 1:n1
            if state.in_1[u] != 0 && state.core_1[u] == 0
                found_pair = true
                if vf2check_feasibility(
                    u, v, state, problemtype, vertex_relation, edge_relation
                )
                    vf2update_state!(state, u, v, depth)
                    keepgoing = vf2match!(
                        state,
                        depth + 1,
                        callback,
                        problemtype,
                        vertex_relation,
                        edge_relation,
                    )
                    keepgoing || return false
                    vf2reset_state!(state, u, v, depth)
                end
            end
        end
    end
    found_pair && return true
    # If this is also not the case, we try all pairs of vertices u∈G₁ v∈G₂ that are not
    # yet matched
    v = 0
    @inbounds for j in 1:n2
        if state.core_2[j] == 0
            v = j
            break
        end
    end
    if v != 0
        @inbounds for u in 1:n1
            if state.core_1[u] == 0
                if vf2check_feasibility(
                    u, v, state, problemtype, vertex_relation, edge_relation
                )
                    vf2update_state!(state, u, v, depth)
                    keepgoing = vf2match!(
                        state,
                        depth + 1,
                        callback,
                        problemtype,
                        vertex_relation,
                        edge_relation,
                    )
                    keepgoing || return false
                    vf2reset_state!(state, u, v, depth)
                end
            end
        end
    end
    return true
end

function has_induced_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Bool
    result = false
    callback(vmap) = (result=true; return false)
    vf2(
        callback,
        g1,
        g2,
        InducedSubGraphIsomorphismProblem();
        vertex_relation=vertex_relation,
        edge_relation=edge_relation,
    )
    return result
end

function has_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Bool
    result = false
    callback(vmap) = (result=true; return false)
    vf2(
        callback,
        g1,
        g2,
        SubGraphIsomorphismProblem();
        vertex_relation=vertex_relation,
        edge_relation=edge_relation,
    )
    return result
end

function has_isomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Bool
    !could_have_isomorph(g1, g2) && return false

    result = false
    callback(vmap) = (result=true; return false)
    vf2(
        callback,
        g1,
        g2,
        IsomorphismProblem();
        vertex_relation=vertex_relation,
        edge_relation=edge_relation,
    )
    return result
end

function count_induced_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Int
    result = 0
    callback(vmap) = (result += 1; return true)
    vf2(
        callback,
        g1,
        g2,
        InducedSubGraphIsomorphismProblem();
        vertex_relation=vertex_relation,
        edge_relation=edge_relation,
    )
    return result
end

function count_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Int
    result = 0
    callback(vmap) = (result += 1; return true)
    vf2(
        callback,
        g1,
        g2,
        SubGraphIsomorphismProblem();
        vertex_relation=vertex_relation,
        edge_relation=edge_relation,
    )
    return result
end

function count_isomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Int
    !could_have_isomorph(g1, g2) && return 0
    result = 0
    callback(vmap) = (result += 1; return true)
    vf2(
        callback,
        g1,
        g2,
        IsomorphismProblem();
        vertex_relation=vertex_relation,
        edge_relation=edge_relation,
    )
    return result
end

function all_induced_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Channel{Vector{Tuple{eltype(g1),eltype(g2)}}}
    make_callback(c) = vmap -> (put!(c, collect(zip(vmap, 1:length(vmap)))), return true)
    T = Vector{Tuple{eltype(g1),eltype(g2)}}
    return ch::Channel{T} = Channel(; ctype=T) do c
        vf2(
            make_callback(c),
            g1,
            g2,
            InducedSubGraphIsomorphismProblem();
            vertex_relation=vertex_relation,
            edge_relation=edge_relation,
        )
    end
end

function all_subgraphisomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Channel{Vector{Tuple{eltype(g1),eltype(g2)}}}
    make_callback(c) = vmap -> (put!(c, collect(zip(vmap, 1:length(vmap)))), return true)
    T = Vector{Tuple{eltype(g1),eltype(g2)}}
    ch::Channel{T} = Channel(; ctype=T) do c
        vf2(
            make_callback(c),
            g1,
            g2,
            SubGraphIsomorphismProblem();
            vertex_relation=vertex_relation,
            edge_relation=edge_relation,
        )
    end
    return ch
end

#! format: off
function all_isomorph(
    g1::AbstractGraph,
    g2::AbstractGraph,
    alg::VF2;
    vertex_relation::Union{Nothing,Function}=nothing,
    edge_relation::Union{Nothing,Function}=nothing,
)::Channel{Vector{Tuple{eltype(g1),eltype(g2)}}}
    T = Vector{Tuple{eltype(g1),eltype(g2)}}
    !could_have_isomorph(g1, g2) && return Channel(_ -> nothing, ctype = T)
    make_callback(c) = vmap -> (put!(c, collect(zip(vmap, 1:length(vmap)))), return true)
    ch::Channel{T} = Channel(; ctype=T) do c
        vf2(
            make_callback(c),
            g1,
            g2,
            IsomorphismProblem();
            vertex_relation=vertex_relation,
            edge_relation=edge_relation,
        )
    end
    return ch
end
#! format: on

@testset "Parallel.Random Vertex Cover" begin
    rng = StableRNG(1)

    g0 = SimpleGraph(0)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g0)
            c = @inferred(
                Parallel.vertex_cover(g, 4, RandomVertexCover(); parallel=parallel, rng=rng)
            )
            @test isempty(c)
        end
    end

    g1 = SimpleGraph(1)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g1)
            c = @inferred(
                Parallel.vertex_cover(g, 4, RandomVertexCover(); parallel=parallel, rng=rng)
            )
            @test isempty(c)
        end
    end

    add_edge!(g1, 1, 1)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g1)
            c = @inferred(
                Parallel.vertex_cover(g, 4, RandomVertexCover(); parallel=parallel, rng=rng)
            )
            @test c == [1]
        end
    end

    g3 = star_graph(5)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g3)
            c = @inferred(
                Parallel.vertex_cover(g, 4, RandomVertexCover(); parallel=parallel, rng=rng)
            )
            @test (length(c) == 2 && (c[1] == 1 || c[2] == 1))
        end
    end

    g4 = complete_graph(5)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g4)
            c = @inferred(
                Parallel.vertex_cover(g, 4, RandomVertexCover(); parallel=parallel, rng=rng)
            )
            @test length(c) == 4 #All except one vertex 
        end
    end

    g5 = path_graph(5)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g5)
            c = @inferred(
                Parallel.vertex_cover(g, 4, RandomVertexCover(); parallel=parallel, rng=rng)
            )
            sort!(c)
            @test (c == [1, 2, 3, 4] || c == [1, 2, 4, 5] || c == [2, 3, 4, 5])
        end
    end

    add_edge!(g5, 2, 2)
    add_edge!(g5, 3, 3)
    for parallel in [:threads, :distributed]
        for g in testgraphs(g5)
            c = @inferred(
                Parallel.vertex_cover(g, 4, RandomVertexCover(); parallel=parallel, rng=rng)
            )
            sort!(c)
            @test (
                c == [1, 2, 3, 4] ||
                c == [1, 2, 3, 4, 5] ||
                c == [2, 3, 4] ||
                c == [2, 3, 4, 5]
            )
        end
    end
end

# Parts of this code were taken / derived from Graphs.jl. See LICENSE for
# licensing details.
"""
    connected_components!(label, g, [search_queue])

Fill `label` with the `id` of the connected component in the undirected graph
`g` to which it belongs. Return a vector representing the component assigned
to each vertex. The component value is the smallest vertex ID in the component.

## Optional arguments
- `search_queue`, an empty `Vector{eltype(edgetype(g))}`, can be provided to avoid
   reallocating this work array repeatedly on repeated calls of `connected_components!`.
   If not provided, it is automatically instantiated.

!!! warning "Experimental"
    The `search_queue` argument is experimental and subject to potential change
    in future versions of Graphs.jl.

## Performance
This algorithm is linear in the number of edges of the graph.
"""
function connected_components!(
    label::AbstractVector{T}, g::AbstractGraph{T}, search_queue::Vector{T}=Vector{T}()
) where {T}
    empty!(search_queue)
    for u in vertices(g)
        label[u] != zero(T) && continue
        label[u] = u
        push!(search_queue, u)
        while !isempty(search_queue)
            src = popfirst!(search_queue)
            for vertex in all_neighbors(g, src)
                if label[vertex] == zero(T)
                    push!(search_queue, vertex)
                    label[vertex] = u
                end
            end
        end
    end
    return label
end

"""
    components_dict(labels)

Convert an array of labels to a map of component id to vertices, and return
a map with each key corresponding to a given component id
and each value containing the vertices associated with that component.
"""
function components_dict(labels::Vector{T}) where {T<:Integer}
    d = Dict{T,Vector{T}}()
    for (v, l) in enumerate(labels)
        vec = get(d, l, Vector{T}())
        push!(vec, v)
        d[l] = vec
    end
    return d
end

"""
    components(labels)

Given a vector of component labels, return a vector of vectors representing the vertices associated
with a given component id.
"""
function components(labels::Vector{T}) where {T<:Integer}
    d = Dict{T,T}()
    c = Vector{Vector{T}}()
    i = one(T)
    for (v, l) in enumerate(labels)
        index = get!(d, l, i)
        if length(c) >= index
            push!(c[index], v)
        else
            push!(c, [v])
            i += 1
        end
    end
    return c, d
end

"""
    connected_components(g)

Return the [connected components](https://en.wikipedia.org/wiki/Connectivity_(graph_theory))
of an undirected graph `g` as a vector of components, with each element a vector of vertices
belonging to the component.

For directed graphs, see [`strongly_connected_components`](@ref) and
[`weakly_connected_components`](@ref).

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph([0 1 0; 1 0 1; 0 1 0]);

julia> connected_components(g)
1-element Vector{Vector{Int64}}:
 [1, 2, 3]

julia> g = SimpleGraph([0 1 0 0 0; 1 0 1 0 0; 0 1 0 0 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> connected_components(g)
2-element Vector{Vector{Int64}}:
 [1, 2, 3]
 [4, 5]
```
"""
function connected_components(g::AbstractGraph{T}) where {T}
    label = zeros(T, nv(g))
    connected_components!(label, g)
    c, d = components(label)
    return c
end

"""
    is_connected(g)

Return `true` if graph `g` is connected. For directed graphs, return `true`
if graph `g` is weakly connected.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph([0 1 0; 1 0 1; 0 1 0]);

julia> is_connected(g)
true

julia> g = SimpleGraph([0 1 0 0 0; 1 0 1 0 0; 0 1 0 0 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> is_connected(g)
false

julia> g = SimpleDiGraph([0 1 0; 0 0 1; 1 0 0]);

julia> is_connected(g)
true
```
"""
function is_connected(g::AbstractGraph{T}) where {T}
    mult = is_directed(g) ? 2 : 1
    if mult * ne(g) + 1 >= nv(g)
        label = zeros(T, nv(g))
        connected_components!(label, g)
        return allequal(label)
    else
        return false
    end
end

"""
    count_connected_components( g, [label, search_queue]; reset_label::Bool=false)

Return the number of connected components in `g`.

Equivalent to `length(connected_components(g))` but uses fewer allocations by not
materializing the component vectors explicitly. 

## Optional arguments
Mutated work arrays, `label` and `search_queue` can be provided to avoid allocating these
arrays repeatedly on repeated calls of `count_connected_components`.
For `g :: AbstractGraph{T}`, `label` must be a zero-initialized `Vector{T}` of length
`nv(g)` and `search_queue` a `Vector{T}`. See also [`connected_components!`](@ref).

!!! warning "Experimental"
    The `search_queue` and `label` arguments are experimental and subject to potential
    change in future versions of Graphs.jl.

## Keyword arguments
- `reset_label :: Bool` (default, `false`): if `true`, `label` is reset to a zero-vector
  before returning.

## Example
```
julia> using Graphs

julia> g = Graph(Edge.([1=>2, 2=>3, 3=>1, 4=>5, 5=>6, 6=>4, 7=>8]));

length> connected_components(g)
3-element Vector{Vector{Int64}}:
 [1, 2, 3]
 [4, 5, 6]
 [7, 8]

julia> count_connected_components(g)
3
```
"""
function count_connected_components(
    g::AbstractGraph{T},
    label::AbstractVector{T}=zeros(T, nv(g)),
    search_queue::Vector{T}=Vector{T}();
    reset_label::Bool=false,
) where {T}
    connected_components!(label, g, search_queue)
    c = count_unique(label)
    reset_label && fill!(label, zero(eltype(label)))
    return c
end

function count_unique(label::Vector{T}) where {T}
    # effectively does `length(Set(label))` but faster, since `Set(label)` sizehints
    # aggressively and assumes that most elements of `label` will be unique, which very
    # rarely will be the case for caller `count_connected_components!`
    seen = T === Int ? BitSet() : Set{T}() # if `T=Int`, we can use faster BitSet
    for l in label
        # faster than direct `push!(seen, l)` when `label` has few unique elements relative
        # to `length(label)`
        l ∉ seen && push!(seen, l)
    end
    return length(seen)
end

"""
    weakly_connected_components(g)

Return the weakly connected components of the graph `g`. This
is equivalent to the connected components of the undirected equivalent of `g`.
For undirected graphs this is equivalent to the [`connected_components`](@ref) of `g`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0; 1 0 1; 0 0 0]);

julia> weakly_connected_components(g)
1-element Vector{Vector{Int64}}:
 [1, 2, 3]
```
"""
weakly_connected_components(g) = connected_components(g)

"""
    is_weakly_connected(g)

Return `true` if the graph `g` is weakly connected. If `g` is undirected,
this function is equivalent to [`is_connected(g)`](@ref).

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0; 0 0 1; 1 0 0]);

julia> is_weakly_connected(g)
true

julia> g = SimpleDiGraph([0 1 0; 1 0 1; 0 0 0]);

julia> is_connected(g)
true

julia> is_strongly_connected(g)
false

julia> is_weakly_connected(g)
true
```
"""
is_weakly_connected(g) = is_connected(g)

"""
    strongly_connected_components(g)

Compute the strongly connected components of a directed graph `g`.

Return an array of arrays, each of which is the entire connected component.

### Implementation Notes
The order of the components is not part of the API contract.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0; 1 0 1; 0 0 0]);

julia> strongly_connected_components(g)
2-element Vector{Vector{Int64}}:
 [3]
 [1, 2]

julia> g = SimpleDiGraph(11)
{11, 0} directed simple Int64 graph

julia> edge_list=[(1,2),(2,3),(3,4),(4,1),(3,5),(5,6),(6,7),(7,5),(5,8),(8,9),(9,8),(10,11),(11,10)];

julia> g = SimpleDiGraph(Edge.(edge_list))
{11, 13} directed simple Int64 graph

julia> strongly_connected_components(g)
4-element Vector{Vector{Int64}}:
 [8, 9]
 [5, 6, 7]
 [1, 2, 3, 4]
 [10, 11]
```
"""
strongly_connected_components(g) = strongly_connected_components_tarjan(g)

"""
    strongly_connected_components_tarjan(g)

Compute the strongly connected components of a directed graph `g` using Tarjan's algorithm.

Return an array of arrays, each of which is the entire connected component.

### Implementation Notes
The returned components will be ordered reverse topologically.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0; 1 0 1; 0 0 0]);

julia> strongly_connected_components_tarjan(g)
2-element Vector{Vector{Int64}}:
 [3]
 [1, 2]

julia> g = SimpleDiGraph(11)
{11, 0} directed simple Int64 graph

julia> edge_list=[(1,2),(2,3),(3,4),(4,1),(3,5),(5,6),(6,7),(7,5),(5,8),(8,9),(9,8),(10,11),(11,10)];

julia> g = SimpleDiGraph(Edge.(edge_list))
{11, 13} directed simple Int64 graph

julia> strongly_connected_components_tarjan(g)
4-element Vector{Vector{Int64}}:
 [8, 9]
 [5, 6, 7]
 [1, 2, 3, 4]
 [10, 11]
```
"""
function strongly_connected_components_tarjan end

# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function strongly_connected_components_tarjan(
    g::AG::IsDirected
) where {T<:Integer,AG<:AbstractGraph{T}}
    zero_t = zero(T)
    one_t = one(T)
    nvg = nv(g)
    count = one_t

    index = zeros(T, nvg)         # first time in which vertex is discovered
    stack = Vector{T}()           # stores vertices which have been discovered and not yet assigned to any component
    onstack = zeros(Bool, nvg)    # false if a vertex is waiting in the stack to receive a component assignment
    lowlink = zeros(T, nvg)       # lowest index vertex that it can reach through back edge (index array not vertex id number)
    parents = zeros(T, nvg)       # parent of every vertex in dfs
    components = Vector{Vector{T}}()    # maintains a list of scc (order is not guaranteed in API)

    dfs_stack = Vector{T}()

    @inbounds for s in vertices(g)
        if index[s] == zero_t
            index[s] = count
            lowlink[s] = count
            onstack[s] = true
            parents[s] = s
            push!(stack, s)
            count = count + one_t

            # start dfs from 's'
            push!(dfs_stack, s)

            while !isempty(dfs_stack)
                v = dfs_stack[end] # end is the most recently added item
                u = zero_t
                @inbounds for v_neighbor in outneighbors(g, v)
                    if index[v_neighbor] == zero_t
                        # unvisited neighbor found
                        u = v_neighbor
                        break
                        # GOTO A push u onto DFS stack and continue DFS
                    elseif onstack[v_neighbor]
                        # we have already seen n, but can update the lowlink of v
                        # which has the effect of possibly keeping v on the stack until n is ready to pop.
                        # update lowest index 'v' can reach through out neighbors
                        lowlink[v] = min(lowlink[v], index[v_neighbor])
                    end
                end
                if u == zero_t
                    # All out neighbors already visited or no out neighbors
                    # we have fully explored the DFS tree from v.
                    # time to start popping.
                    popped = pop!(dfs_stack)
                    lowlink[parents[popped]] = min(
                        lowlink[parents[popped]], lowlink[popped]
                    )

                    if index[v] == lowlink[v]
                        # found a cycle in a completed dfs tree.
                        component = Vector{T}()

                        while !isempty(stack) # break when popped == v
                            # drain stack until we see v.
                            # everything on the stack until we see v is in the SCC rooted at v.
                            popped = pop!(stack)
                            push!(component, popped)
                            onstack[popped] = false
                            # popped has been assigned a component, so we will never see it again.
                            if popped == v
                                # we have drained the stack of an entire component.
                                break
                            end
                        end

                        reverse!(component)
                        push!(components, component)
                    end

                else # LABEL A
                    # add unvisited neighbor to dfs
                    index[u] = count
                    lowlink[u] = count
                    onstack[u] = true
                    parents[u] = v
                    count = count + one_t

                    push!(stack, u)
                    push!(dfs_stack, u)
                    # next iteration of while loop will expand the DFS tree from u.
                end
            end
        end
    end

    return components
end

"""
    strongly_connected_components_kosaraju(g)

Compute the strongly connected components of a directed graph `g` using Kosaraju's Algorithm.
(https://en.wikipedia.org/wiki/Kosaraju%27s_algorithm).

Return an array of arrays, each of which is the entire connected component.

### Performance
Time Complexity : O(|E|+|V|)
Space Complexity : O(|V|) {Excluding the memory required for storing graph}

|V| = Number of vertices
|E| = Number of edges

### Examples
```jldoctest
julia> using Graphs

julia> g=SimpleDiGraph(3)
{3, 0} directed simple Int64 graph

julia> g = SimpleDiGraph([0 1 0 ; 0 0 1; 0 0 0])
{3, 2} directed simple Int64 graph

julia> strongly_connected_components_kosaraju(g)
3-element Vector{Vector{Int64}}:
 [1]
 [2]
 [3]


julia> g=SimpleDiGraph(11)
{11, 0} directed simple Int64 graph

julia> edge_list=[(1,2),(2,3),(3,4),(4,1),(3,5),(5,6),(6,7),(7,5),(5,8),(8,9),(9,8),(10,11),(11,10)]
13-element Vector{Tuple{Int64, Int64}}:
 (1, 2)
 (2, 3)
 (3, 4)
 (4, 1)
 (3, 5)
 (5, 6)
 (6, 7)
 (7, 5)
 (5, 8)
 (8, 9)
 (9, 8)
 (10, 11)
 (11, 10)

julia> g = SimpleDiGraph(Edge.(edge_list))
{11, 13} directed simple Int64 graph

julia> strongly_connected_components_kosaraju(g)
4-element Vector{Vector{Int64}}:
 [11, 10]
 [2, 3, 4, 1]
 [6, 7, 5]
 [9, 8]

```
"""
function strongly_connected_components_kosaraju end
@traitfn function strongly_connected_components_kosaraju(
    g::AG::IsDirected
) where {T<:Integer,AG<:AbstractGraph{T}}
    nvg = nv(g)

    components = Vector{Vector{T}}()    # Maintains a list of strongly connected components

    order = Vector{T}()         # Vector which will store the order in which vertices are visited
    sizehint!(order, nvg)

    color = zeros(UInt8, nvg)       # Vector used as for marking the colors during dfs

    dfs_stack = Vector{T}()   # Stack used for dfs

    # dfs1
    @inbounds for v in vertices(g)
        color[v] != 0 && continue
        color[v] = 1

        # Start dfs from v
        push!(dfs_stack, v)   # Push v to the stack

        while !isempty(dfs_stack)
            u = dfs_stack[end]
            w = zero(T)

            for u_neighbor in outneighbors(g, u)
                if color[u_neighbor] == 0
                    w = u_neighbor
                    break
                end
            end

            if w != 0
                push!(dfs_stack, w)
                color[w] = 1
            else
                push!(order, u)  # Push back in vector to store the order in which the traversal finishes(Reverse Topological Sort)
                color[u] = 2
                pop!(dfs_stack)
            end
        end
    end

    @inbounds for i in vertices(g)
        color[i] = 0    # Marking all the vertices from 1 to n as unvisited for dfs2
    end

    # dfs2
    @inbounds for i in 1:nvg
        v = order[end - i + 1]   # Reading the order vector in the decreasing order of finish time
        color[v] != 0 && continue
        color[v] = 1

        component = Vector{T}()   # Vector used to store the vertices of one component temporarily

        # Start dfs from v
        push!(dfs_stack, v)   # Push v to the stack

        while !isempty(dfs_stack)
            u = dfs_stack[end]
            w = zero(T)

            for u_neighbor in inneighbors(g, u)
                if color[u_neighbor] == 0
                    w = u_neighbor
                    break
                end
            end

            if w != 0
                push!(dfs_stack, w)
                color[w] = 1
            else
                color[u] = 2
                push!(component, u)   # Push u to the vector component
                pop!(dfs_stack)
            end
        end

        push!(components, component)
    end

    return components
end

"""
    is_strongly_connected(g)

Return `true` if directed graph `g` is strongly connected.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0; 0 0 1; 1 0 0]);

julia> is_strongly_connected(g)
true
```
"""
function is_strongly_connected end
@traitfn function is_strongly_connected(g::::IsDirected)
    return length(strongly_connected_components(g)) == 1
end

"""
    period(g)

Return the (common) period for all vertices in a strongly connected directed graph.
Will throw an error if the graph is not strongly connected.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0; 0 0 1; 1 0 0]);

julia> period(g)
3
```
"""
function period end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function period(g::AG::IsDirected) where {T,AG<:AbstractGraph{T}}
    !is_strongly_connected(g) && throw(ArgumentError("Graph must be strongly connected"))

    # First check if there's a self loop
    has_self_loops(g) && return 1

    g_bfs_tree = bfs_tree(g, 1)
    levels = gdistances(g_bfs_tree, 1)
    edge_values = Vector{T}()

    divisor = 0
    for e in edges(g)
        has_edge(g_bfs_tree, src(e), dst(e)) && continue
        @inbounds value = levels[src(e)] - levels[dst(e)] + 1
        divisor = gcd(divisor, value)
        isequal(divisor, 1) && return 1
    end

    return divisor
end

"""
    condensation(g[, scc])

Return the condensation graph of the strongly connected components `scc`
in the directed graph `g`. If `scc` is missing, generate the strongly
connected components first.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0])
{5, 6} directed simple Int64 graph

julia> strongly_connected_components(g)
2-element Vector{Vector{Int64}}:
 [4, 5]
 [1, 2, 3]

julia> foreach(println, edges(condensation(g)))
Edge 2 => 1
```
"""
function condensation end
@traitfn function condensation(g::::IsDirected, scc::Vector{Vector{T}}) where {T<:Integer}
    h = DiGraph{T}(length(scc))

    component = Vector{T}(undef, nv(g))

    for (i, s) in enumerate(scc)
        @inbounds component[s] .= i
    end

    @inbounds for e in edges(g)
        s, d = component[src(e)], component[dst(e)]
        if (s != d)
            add_edge!(h, s, d)
        end
    end
    return h
end
@traitfn condensation(g::::IsDirected) = condensation(g, strongly_connected_components(g))

"""
    attracting_components(g)

Return a vector of vectors of integers representing lists of attracting
components in the directed graph `g`.

The attracting components are a subset of the strongly
connected components in which the components do not have any leaving edges.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0])
{5, 6} directed simple Int64 graph

julia> strongly_connected_components(g)
2-element Vector{Vector{Int64}}:
 [4, 5]
 [1, 2, 3]

julia> attracting_components(g)
1-element Vector{Vector{Int64}}:
 [4, 5]
```
"""
function attracting_components end
# see https://github.com/mauro3/SimpleTraits.jl/issues/47#issuecomment-327880153 for syntax
@traitfn function attracting_components(g::AG::IsDirected) where {T,AG<:AbstractGraph{T}}
    scc = strongly_connected_components(g)
    cond = condensation(g, scc)

    attracting = Vector{T}()

    for v in vertices(cond)
        if outdegree(cond, v) == 0
            push!(attracting, v)
        end
    end
    return scc[attracting]
end

"""
    neighborhood(g, v, d, distmx=weights(g))

Return a vector of each vertex in `g` at a geodesic distance less than or equal to `d`, where distances
may be specified by `distmx`.

### Optional Arguments
- `dir=:out`: If `g` is directed, this argument specifies the edge direction
with respect to `v` of the edges to be considered. Possible values: `:in` or `:out`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> neighborhood(g, 1, 2)
3-element Vector{Int64}:
 1
 2
 3

julia> neighborhood(g, 1, 3)
4-element Vector{Int64}:
 1
 2
 3
 4

julia> neighborhood(g, 1, 3, [0 1 0 0 0; 0 0 1 0 0; 1 0 0 0.25 0; 0 0 0 0 0.25; 0 0 0 0.25 0])
5-element Vector{Int64}:
 1
 2
 3
 4
 5
```
"""
function neighborhood(
    g::AbstractGraph{T}, v::Integer, d, distmx::AbstractMatrix{U}=weights(g); dir=:out
) where {T<:Integer} where {U<:Real}
    return first.(neighborhood_dists(g, v, d, distmx; dir=dir))
end

"""
    neighborhood_dists(g, v, d, distmx=weights(g))

Return a a vector of tuples representing each vertex which is at a geodesic distance less than or equal to `d`, along with
its distance from `v`. Non-negative distances may be specified by `distmx`.

### Optional Arguments
- `dir=:out`: If `g` is directed, this argument specifies the edge direction
with respect to `v` of the edges to be considered. Possible values: `:in` or `:out`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleDiGraph([0 1 0 0 0; 0 0 1 0 0; 1 0 0 1 0; 0 0 0 0 1; 0 0 0 1 0]);

julia> neighborhood_dists(g, 1, 3)
4-element Vector{Tuple{Int64, Int64}}:
 (1, 0)
 (2, 1)
 (3, 2)
 (4, 3)

julia> neighborhood_dists(g, 1, 3, [0 1 0 0 0; 0 0 1 0 0; 1 0 0 0.25 0; 0 0 0 0 0.25; 0 0 0 0.25 0])
5-element Vector{Tuple{Int64, Float64}}:
 (1, 0.0)
 (2, 1.0)
 (3, 2.0)
 (4, 2.25)
 (5, 2.5)

julia> neighborhood_dists(g, 4, 3)
2-element Vector{Tuple{Int64, Int64}}:
 (4, 0)
 (5, 1)

julia> neighborhood_dists(g, 4, 3, dir=:in)
5-element Vector{Tuple{Int64, Int64}}:
 (4, 0)
 (3, 1)
 (5, 1)
 (2, 2)
 (1, 3)
```
"""
function neighborhood_dists(
    g::AbstractGraph{T}, v::Integer, d, distmx::AbstractMatrix{U}=weights(g); dir=:out
) where {T<:Integer} where {U<:Real}
    return if (dir == :out)
        _neighborhood(g, v, d, distmx, outneighbors)
    else
        _neighborhood(g, v, d, distmx, inneighbors)
    end
end

function _neighborhood(
    g::AbstractGraph{T},
    v::Integer,
    d::Real,
    distmx::AbstractMatrix{U},
    neighborfn::Function,
) where {T<:Integer} where {U<:Real}
    Q = Vector{Tuple{T,U}}()
    d < zero(U) && return Q
    push!(Q, (v, zero(U)))
    seen = fill(false, nv(g))
    seen[v] = true # Bool Vector benchmarks faster than BitArray
    for (src, currdist) in Q
        currdist >= d && continue
        for dst in neighborfn(g, src)
            if !seen[dst]
                seen[dst] = true
                if currdist + distmx[src, dst] <= d
                    push!(Q, (dst, currdist + distmx[src, dst]))
                end
            end
        end
    end
    return Q
end

"""
    isgraphical(degs)

Return true if the degree sequence `degs` is graphical.
A sequence of integers is called graphical, if there exists a graph where the degrees of its vertices form that same sequence.

### Performance
Time complexity: ``\\mathcal{O}(|degs|*\\log(|degs|))``.

### Implementation Notes
According to Erdös-Gallai theorem, a degree sequence ``\\{d_1, ...,d_n\\}`` (sorted in descending order) is graphic iff the sum of vertex degrees is even and the sequence obeys the property -
```math
\\sum_{i=1}^{r} d_i \\leq r(r-1) + \\sum_{i=r+1}^n min(r,d_i)
```
for each integer r <= n-1. 

See also: [`isdigraphical`](@ref)
"""
function isgraphical(degs::AbstractVector{<:Integer})
    # Check whether the degree sequence is empty
    !isempty(degs) || return true
    # Check whether the sum of degrees is even
    iseven(sum(degs)) || return false
    # Compute the length of the degree sequence
    n = length(degs)
    # Check that all degrees are non negative and less than n-1
    all(0 .<= degs .<= n - 1) || return false
    # Sort the degree sequence in non-increasing order
    sorted_degs = sort(degs; rev=true)
    # Initialise a sum variable
    cur_sum = zero(UInt64)
    right_deg_sum = zero(UInt64)
    # Initalise a pointer to track the smallest index with degree greater than r
    ptr = n
    # Check if the degree sequence satisfies the Erdös-Gallai condition
    @inbounds for r in 1:(n - 1)
        cur_sum += sorted_degs[r]
        #  Calculate the sum of the minimum of r and the degrees of the vertices
        min_idx = r + 1
        while ptr >= min_idx
            if sorted_degs[ptr] <= r
                # left_deg_sum = sum_{ptr+1}^n d_i
                right_deg_sum += sorted_degs[ptr]
                # move pointer to the 1-slot left
                ptr -= 1
            else
                # the ptr points to the degree greater than r
                break
            end
        end
        # calculate min_deg_sum: sum_{r+1}^n min(r, d_i)
        if ptr < min_idx
            # all required degrees are less than r
            # ptr is min_idx - 1
            min_deg_sum = right_deg_sum
            # prepare for the next iteration
            # shift ptr to the right
            ptr += 1
            # reduce right_deg_sum
            right_deg_sum -= sorted_degs[ptr]
        else
            # d_i with i between ptr and min_idx are greater than r 
            min_deg_sum = (ptr - r) * r + right_deg_sum
        end
        # Check the Erdös-Gallai condition
        cond = cur_sum <= (r * (r - 1) + min_deg_sum)
        cond || return false
    end
    return true
end

"""
    isdigraphical(indegree_sequence, outdegree_sequence)

Check whether the given indegree sequence and outdegree sequence are digraphical, that is whether they can be the indegree and outdegree sequence of a simple digraph (i.e. a directed graph with no loops). This implies that `indegree_sequence` and `outdegree_sequence` are not independent, as their elements respectively represent the indegrees and outdegrees that the vertices shall have.

### Implementation Notes
According to Fulkerson-Chen-Anstee theorem, a sequence ``\\{(a_1, b_1), ...,(a_n, b_n)\\}`` (sorted in descending order of a) is graphic iff ``\\sum_{i = 1}^{n} a_i = \\sum_{i = 1}^{n} b_i\\}`` and the sequence obeys the property -
```math
\\sum_{i=1}^{r} a_i \\leq \\sum_{i=1}^n min(r-1,b_i) + \\sum_{i=r+1}^n min(r,b_i)
```
for each integer 1 <= r <= n-1. 

See also: [`isgraphical`](@ref)
"""
function isdigraphical(
    indegree_sequence::AbstractVector{<:Integer},
    outdegree_sequence::AbstractVector{<:Integer},
)
    # Check whether the degree sequences have the same length 
    n = length(indegree_sequence)
    n == length(outdegree_sequence) || throw(
        ArgumentError("The indegree and outdegree sequences must have the same length.")
    )
    # Check whether the degree sequence is empty
    !(isempty(indegree_sequence) && isempty(outdegree_sequence)) || return true
    # Check all degrees are non negative and less than n-1
    all(0 .<= indegree_sequence .<= n - 1) || return false
    all(0 .<= outdegree_sequence .<= n - 1) || return false

    sum(indegree_sequence) == sum(outdegree_sequence) || return false

    _sortperm = sortperm(indegree_sequence; rev=true)

    sorted_indegree_sequence = indegree_sequence[_sortperm]
    sorted_outdegree_sequence = outdegree_sequence[_sortperm]

    indegree_sum = zero(Int64)
    outdegree_min_sum = zero(Int64)

    cum_min = zero(Int64)

    # The following approach, which requires substituting the line
    # cum_min = sum([min(sorted_outdegree_sequence[i], r) for i in (1+r):n])
    # with the line
    # cum_min -= mindeg[r]
    # inside the for loop below, work as well, but the values of `cum_min` at each iteration differ. To be on the safe side we implemented it as in https://en.wikipedia.org/wiki/Fulkerson%E2%80%93Chen%E2%80%93Anstee_theorem
    #=     mindeg = Vector{Int64}(undef, n)
        @inbounds for i = 1:n
            mindeg[i] = min(i, sorted_outdegree_sequence[i])
        end
        cum_min = sum(mindeg) =#
    # Similarly for `outdegree_min_sum`.

    @inbounds for r in 1:n
        indegree_sum += sorted_indegree_sequence[r]
        outdegree_min_sum = sum([min(sorted_outdegree_sequence[i], r - 1) for i in 1:r])
        cum_min = sum([min(sorted_outdegree_sequence[i], r) for i in (1 + r):n])
        cond = indegree_sum <= (outdegree_min_sum + cum_min)
        cond || return false
    end

    return true
end

const SimpleGraphEdge = SimpleEdge

"""
    SimpleGraph{T}

A type representing an undirected graph.
"""
mutable struct SimpleGraph{T<:Integer} <: AbstractSimpleGraph{T}
    ne::Int
    fadjlist::Vector{Vector{T}} # [src]: (dst, dst, dst)

    function SimpleGraph{T}(ne::Int, fadjlist::Vector{Vector{T}}) where {T}
        throw_if_invalid_eltype(T)
        return new{T}(ne, fadjlist)
    end
end

function SimpleGraph(ne, fadjlist::Vector{Vector{T}}) where {T}
    return SimpleGraph{T}(ne, fadjlist)
end

# Graph{UInt8}(6), Graph{Int16}(7), Graph{UInt8}()
"""
    SimpleGraph{T}(n=0)

Construct a `SimpleGraph{T}` with `n` vertices and 0 edges.
If not specified, the element type `T` is the type of `n`.

## Examples
```jldoctest
julia> using Graphs

julia> SimpleGraph(UInt8(10))
{10, 0} undirected simple UInt8 graph
```
"""
function SimpleGraph{T}(n::Integer=0) where {T<:Integer}
    fadjlist = [Vector{T}() for _ in one(T):n]
    return SimpleGraph{T}(0, fadjlist)
end

# SimpleGraph(6), SimpleGraph(0x5)
SimpleGraph(n::T) where {T<:Integer} = SimpleGraph{T}(n)

# SimpleGraph()
SimpleGraph() = SimpleGraph{Int}()

# SimpleGraph(UInt8)
"""
    SimpleGraph(::Type{T})

Construct an empty `SimpleGraph{T}` with 0 vertices and 0 edges.

## Examples
```jldoctest
julia> using Graphs

julia> SimpleGraph(UInt8)
{0, 0} undirected simple UInt8 graph
```
"""
SimpleGraph(::Type{T}) where {T<:Integer} = SimpleGraph{T}(zero(T))

# SimpleGraph(adjmx)
"""
    SimpleGraph{T}(adjm::AbstractMatrix)

Construct a `SimpleGraph{T}` from the adjacency matrix `adjm`.
If `adjm[i][j] != 0`, an edge `(i, j)` is inserted. `adjm` must be a square and symmetric matrix.
The element type `T` can be omitted.

## Examples
```jldoctest
julia> using Graphs

julia> A1 = [false true; true false];

julia> SimpleGraph(A1)
{2, 1} undirected simple Int64 graph

julia> A2 = [2 7; 7 0];

julia> SimpleGraph{Int16}(A2)
{2, 2} undirected simple Int16 graph
```
"""
SimpleGraph(adjmx::AbstractMatrix) = SimpleGraph{Int}(adjmx)

# Graph{UInt8}(adjmx)
function SimpleGraph{T}(adjmx::AbstractMatrix) where {T<:Integer}
    dima, dimb = size(adjmx)
    isequal(dima, dimb) ||
        throw(ArgumentError("Adjacency / distance matrices must be square"))
    issymmetric(adjmx) ||
        throw(ArgumentError("Adjacency / distance matrices must be symmetric"))

    g = SimpleGraph(T(dima))
    @inbounds for i in findall(triu(adjmx) .!= 0)
        add_edge!(g, i[1], i[2])
    end
    return g
end

# SimpleGraph of a SimpleGraph
"""
    SimpleGraph{T}(g::SimpleGraph)

Construct a copy of g.
If the element type `T` is specified, the vertices of `g` are converted to this type.
Otherwise the element type is the same as for `g`.

## Examples
```jldoctest
julia> using Graphs

julia> g = complete_graph(5)
{5, 10} undirected simple Int64 graph

julia> SimpleGraph{UInt8}(g)
{5, 10} undirected simple UInt8 graph
```
"""
SimpleGraph(g::SimpleGraph) = copy(g)

# converts Graph{Int} to Graph{Int32}
function SimpleGraph{T}(g::SimpleGraph) where {T<:Integer}
    h_fadj = [Vector{T}(x) for x in fadj(g)]
    return SimpleGraph(ne(g), h_fadj)
end

# SimpleGraph(digraph)
"""
    SimpleGraph(g::SimpleDiGraph)

Construct an undirected `SimpleGraph` from a directed `SimpleDiGraph`.
Every directed edge in `g` is added as an undirected edge.
The element type is the same as for `g`.

## Examples
```jldoctest
julia> using Graphs

julia> g = path_digraph(Int8(5))
{5, 4} directed simple Int8 graph

julia> SimpleGraph(g)
{5, 4} undirected simple Int8 graph
```
"""
function SimpleGraph(g::SimpleDiGraph)
    gnv = nv(g)
    edgect = 0
    newfadj = deepcopy_adjlist(g.fadjlist)
    @inbounds for i in vertices(g)
        for j in badj(g, i)
            index = searchsortedfirst(newfadj[i], j)
            if index <= length(newfadj[i]) && newfadj[i][index] == j
                edgect += 1     # this is an existing edge - we already have it
                if i == j
                    edgect += 1 # need to count self loops
                end
            else
                insert!(newfadj[i], index, j)
                edgect += 2      # this is a new edge only in badjlist
            end
        end
    end
    iseven(edgect) ||
        throw(AssertionError("invalid edgect in graph creation - please file bug report"))
    return SimpleGraph(edgect ÷ 2, newfadj)
end

@inbounds function cleanupedges!(fadjlist::Vector{Vector{T}}) where {T<:Integer}
    neg = 0
    for v in 1:length(fadjlist)
        if !issorted(fadjlist[v])
            sort!(fadjlist[v])
        end
        unique!(fadjlist[v])
        neg += length(fadjlist[v])
        # self-loops should count as one edge
        for w in fadjlist[v]
            if w == v
                neg += 1
                break
            end
        end
    end
    return neg ÷ 2
end

"""
    SimpleGraph(edge_list::Vector)

Construct a `SimpleGraph` from a vector of edges.
The element type is taken from the edges in `edge_list`.
The number of vertices is the highest that is used in an edge in `edge_list`.

### Implementation Notes
This constructor works the fastest when `edge_list` is sorted
by the lexical ordering and does not contain any duplicates.

### See also
[`SimpleGraphFromIterator`](@ref)

## Examples
```jldoctest
julia> using Graphs

julia> el = Edge.([ (1, 2), (1, 5) ])
2-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 5

julia> SimpleGraph(el)
{5, 2} undirected simple Int64 graph
```
"""
function SimpleGraph(edge_list::Vector{SimpleGraphEdge{T}}) where {T<:Integer}
    nvg = zero(T)
    @inbounds(
        for e in edge_list
            nvg = max(nvg, src(e), dst(e))
        end
    )

    list_sizes = ones(Int, nvg)
    degs = zeros(Int, nvg)
    @inbounds(
        for e in edge_list
            s, d = src(e), dst(e)
            (s >= 1 && d >= 1) || continue
            degs[s] += 1
            if s != d
                degs[d] += 1
            end
        end
    )

    fadjlist = Vector{Vector{T}}(undef, nvg)
    @inbounds(
        for v in 1:nvg
            fadjlist[v] = Vector{T}(undef, degs[v])
        end
    )

    @inbounds(
        for e in edge_list
            s, d = src(e), dst(e)
            (s >= 1 && d >= 1) || continue
            fadjlist[s][list_sizes[s]] = d
            list_sizes[s] += 1
            if s != d
                fadjlist[d][list_sizes[d]] = s
                list_sizes[d] += 1
            end
        end
    )

    neg = cleanupedges!(fadjlist)
    g = SimpleGraph{T}()
    g.fadjlist = fadjlist
    g.ne = neg

    return g
end

"""
    SimpleGraph{T}(g::AbstractGraph)
    SimpleGraph(g::AbstractGraph)

Construct a `SimpleGraph` from any `AbstractGraph` by enumerating edges.

If `g` is directed, a directed edge `{u, v}` is added if either directed edge `(u, v)` or `(v, u)` exists.
"""
function SimpleGraph{T}(g::AbstractGraph) where {T}
    eds = edges(g)
    srcs = src.(eds)
    dsts = dst.(eds)
    newg = SimpleGraph(Edge{T}.(srcs, dsts))
    add_vertices!(newg, nv(g) - nv(newg))
    return newg
end

SimpleGraph(g::AbstractGraph{T}) where {T} = SimpleGraph{T}(g)

@inbounds function add_to_fadjlist!(
    fadjlist::Vector{Vector{T}}, s::T, d::T
) where {T<:Integer}
    nvg = length(fadjlist)
    nvg_new = max(nvg, s, d)
    for v in (nvg + 1):nvg_new
        push!(fadjlist, Vector{T}())
    end

    push!(fadjlist[s], d)
    if s != d
        push!(fadjlist[d], s)
    end
end

# Try to get the eltype from the first element
function _SimpleGraphFromIterator(iter)::SimpleGraph
    next = iterate(iter)
    if (next === nothing)
        return SimpleGraph(0)
    end

    e = first(next)
    E = typeof(e)
    if !(E <: SimpleGraphEdge{<:Integer})
        throw(DomainError(iter, "Edges must be of type SimpleEdge{T <: Integer}"))
    end

    T = eltype(e)
    g = SimpleGraph{T}()
    fadjlist = Vector{Vector{T}}()

    while !isnothing(next)
        (e, state) = next

        if !(e isa E)
            throw(DomainError(iter, "Edges must all have the same type."))
        end
        s, d = src(e), dst(e)
        if ((s >= 1) & (d >= 1))
            add_to_fadjlist!(fadjlist, s, d)
        end

        next = iterate(iter, state)
    end

    neg = cleanupedges!(fadjlist)
    g.fadjlist = fadjlist
    g.ne = neg

    return g
end

function _SimpleGraphFromIterator(iter, ::Type{T}) where {T<:Integer}
    g = SimpleGraph{T}()
    fadjlist = Vector{Vector{T}}()

    @inbounds(
        for e in iter
            s, d = src(e), dst(e)
            (s >= 1 && d >= 1) || continue
            add_to_fadjlist!(fadjlist, s, d)
        end
    )

    neg = cleanupedges!(fadjlist)
    g.fadjlist = fadjlist
    g.ne = neg

    return g
end

"""
    SimpleGraphFromIterator(iter)

Create a [`SimpleGraph`](@ref) from an iterator `iter`. The elements in iter must
be of `type <: SimpleEdge`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(3);

julia> add_edge!(g, 1, 2);

julia> add_edge!(g, 2, 3);

julia> h = SimpleGraphFromIterator(edges(g));

julia> collect(edges(h))
2-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 2 => 3
```
"""
function SimpleGraphFromIterator(iter)::SimpleGraph
    if Base.IteratorEltype(iter) == Base.HasEltype()
        E = eltype(iter)
        if (E <: SimpleGraphEdge{<:Integer} && isconcretetype(E))
            T = eltype(E)
            if isconcretetype(T)
                return _SimpleGraphFromIterator(iter, T)
            end
        end
    end

    return _SimpleGraphFromIterator(iter)
end

edgetype(::SimpleGraph{T}) where {T<:Integer} = SimpleGraphEdge{T}

"""
    badj(g::SimpleGraph[, v::Integer])

Return the backwards adjacency list of a graph. If `v` is specified,
return only the adjacency list for that vertex.

### Implementation Notes
Returns a reference to the current graph's internal structures, not a copy.
Do not modify result. If the graph is modified, the behavior is undefined:
the array behind this reference may be modified too, but this is not guaranteed.
"""
badj(g::SimpleGraph) = fadj(g)
badj(g::SimpleGraph, v::Integer) = fadj(g, v)

"""
    adj(g[, v])

Return the adjacency list of a graph. If `v` is specified, return only the
adjacency list for that vertex.

### Implementation Notes
Returns a reference to the current graph's internal structures, not a copy.
Do not modify result. If the graph is modified, the behavior is undefined:
the array behind this reference may be modified too, but this is not guaranteed.
"""
adj(g::SimpleGraph) = fadj(g)
adj(g::SimpleGraph, v::Integer) = fadj(g, v)

copy(g::SimpleGraph) = SimpleGraph(g.ne, deepcopy_adjlist(g.fadjlist))

function ==(g::SimpleGraph, h::SimpleGraph)
    return vertices(g) == vertices(h) && ne(g) == ne(h) && fadj(g) == fadj(h)
end

function Base.hash(g::SimpleGraph, h::UInt)
    r = hash(typeof(g), h)
    r = hash(nv(g), r)
    r = hash(ne(g), r)
    r = hash(fadj(g), r)
    return r
end

"""
    is_directed(g)

Return `true` if `g` is a directed graph.
"""
is_directed(::Type{<:SimpleGraph}) = false

function has_edge(g::SimpleGraph{T}, s, d) where {T}
    verts = vertices(g)
    (s in verts && d in verts) || return false  # edge out of bounds
    @inbounds list_s = g.fadjlist[s]
    @inbounds list_d = g.fadjlist[d]
    if length(list_s) > length(list_d)
        d = s
        list_s = list_d
    end
    return insorted(d, list_s)
end

function has_edge(g::SimpleGraph{T}, e::SimpleGraphEdge{T}) where {T}
    s, d = T.(Tuple(e))
    return has_edge(g, s, d)
end

"""
    add_edge!(g, e)

Add an edge `e` to graph `g`. Return `true` if edge was added successfully,
otherwise return `false`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(2);

julia> add_edge!(g, 1, 2)
true

julia> add_edge!(g, 2, 3)
false
```
"""
function add_edge!(g::SimpleGraph{T}, e::SimpleGraphEdge{T}) where {T}
    s, d = T.(Tuple(e))
    verts = vertices(g)
    (s in verts && d in verts) || return false  # edge out of bounds
    @inbounds list = g.fadjlist[s]
    index = searchsortedfirst(list, d)
    @inbounds (index <= length(list) && list[index] == d) && return false  # edge already in graph
    insert!(list, index, d)

    g.ne += 1
    s == d && return true  # selfloop

    @inbounds list = g.fadjlist[d]
    index = searchsortedfirst(list, s)
    insert!(list, index, s)
    return true  # edge successfully added
end

"""
    rem_edge!(g, e)

Remove an edge `e` from graph `g`. Return `true` if edge was removed successfully,
otherwise return `false`.

### Implementation Notes
If `rem_edge!` returns `false`, the graph may be in an indeterminate state, as
there are multiple points where the function can exit with `false`.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(2);

julia> add_edge!(g, 1, 2);

julia> rem_edge!(g, 1, 2)
true

julia> rem_edge!(g, 1, 2)
false
```
"""
function rem_edge!(g::SimpleGraph{T}, e::SimpleGraphEdge{T}) where {T}
    s, d = T.(Tuple(e))
    verts = vertices(g)
    (s in verts && d in verts) || return false  # edge out of bounds
    @inbounds list = g.fadjlist[s]
    index = searchsortedfirst(list, d)
    @inbounds (index <= length(list) && list[index] == d) || return false  # edge not in graph
    deleteat!(list, index)

    g.ne -= 1
    s == d && return true  # selfloop

    @inbounds list = g.fadjlist[d]
    index = searchsortedfirst(list, s)
    deleteat!(list, index)
    return true  # edge successfully removed
end

fd
"""
    add_vertex!(g)

Add a new vertex to the graph `g`. Return `true` if addition was successful.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(Int8(typemax(Int8) - 1))
{126, 0} undirected simple Int8 graph

julia> add_vertex!(g)
true

julia> add_vertex!(g)
false
```
"""
function add_vertex!(g::SimpleGraph{T}) where {T}
    (nv(g) + one(T) <= nv(g)) && return false       # test for overflow
    push!(g.fadjlist, Vector{T}())
    return true
end

"""
    rem_vertices!(g, vs, keep_order=false) -> vmap

Remove all vertices in `vs` from `g`.
Return a vector `vmap` that maps the vertices in the modified graph to the ones in
the unmodified graph.
If `keep_order` is `true`, the vertices in the modified graph appear in the same
order as they did in the unmodified graph. This might be slower.

### Implementation Notes
This function is not part of the official Graphs API and is subject to change/removal between major versions.

# Examples
```jldoctest
julia> using Graphs

julia> g = complete_graph(5)
{5, 10} undirected simple Int64 graph

julia> vmap = rem_vertices!(g, [2, 4], keep_order=true);

julia> vmap
3-element Vector{Int64}:
 1
 3
 5

julia> g
{3, 3} undirected simple Int64 graph
```
"""
function rem_vertices!(
    g::SimpleGraph{T}, vs::AbstractVector{<:Integer}; keep_order::Bool=false
) where {T<:Integer}
    # TODO There might be some room for performance improvements.
    # At the moment, we check for all edges if they stay in the graph.
    # If some vertices keep their position, this might be unnecessary.

    n = nv(g)
    isempty(vs) && return collect(Base.OneTo(n))

    # Sort and filter the vertices that we want to remove
    remove = sort(vs)
    unique!(remove)
    (1 <= remove[1] && remove[end] <= n) ||
        throw(ArgumentError("Vertices to be removed must be in the range 1:nv(g)."))

    # Create a vmap that maps vertices to their new position
    # vertices that get removed are mapped to 0
    vmap = Vector{T}(undef, n)

    if keep_order
        # traverse the vertex list and shift if a vertex gets removed
        i = 1
        @inbounds for u in vertices(g)
            if i <= length(remove) && u == remove[i]
                vmap[u] = 0
                i += 1
            else
                vmap[u] = u - (i - 1)
            end
        end
    else
        # traverse the vertex list and replace vertices that get removed
        # with the furthest one to the back that does not get removed
        i = 1
        j = length(remove)
        v = n
        @inbounds for u in vertices(g)
            u > v && break
            if i <= length(remove) && u == remove[i]
                while v == remove[j] && v > u
                    vmap[v] = 0
                    v -= one(T)
                    j -= 1
                end
                # v > remove[j] || u == v
                vmap[v] = u
                vmap[u] = 0
                v -= one(T)
                i += 1
            else
                vmap[u] = u
            end
        end
    end

    fadjlist = g.fadjlist

    # count the number of edges that will be removed
    # for an edge that gets removed we have to ensure that
    # such an edge does not get counted twice when both endpoints
    # get removed. That's why we relay on the ordering >= on the vertices.
    num_removed_edges = 0
    @inbounds for u in remove
        for v in fadjlist[u]
            if v >= u || vmap[v] != 0
                num_removed_edges += 1
            end
        end
    end
    g.ne -= num_removed_edges

    # move the lists in the adjacency list to their new position
    # The order of traversal is very important here, as otherwise we
    # could overwrite lists, that we want to keep!
    @inbounds for u in (keep_order ? (one(T):1:n) : (n:-1:one(T)))
        if vmap[u] != 0
            fadjlist[vmap[u]] = fadjlist[u]
        end
    end
    resize!(fadjlist, n - length(remove))

    # remove vertices from the lists in fadjlist
    @inbounds for list in fadjlist
        Δ = 0
        for (i, v) in enumerate(list)
            if vmap[v] == 0
                Δ += 1
            else
                list[i - Δ] = vmap[v]
            end
        end
        resize!(list, length(list) - Δ)
        if !keep_order
            sort!(list)
        end
    end

    # we create a reverse vmap, that maps vertices in the result graph
    # to the ones in the original graph. This resembles the output of
    # induced_subgraph
    reverse_vmap = Vector{T}(undef, nv(g))
    @inbounds for (i, u) in enumerate(vmap)
        if u != 0
            reverse_vmap[u] = i
        end
    end

    return reverse_vmap
end

@testset "Parallel.Pagerank" begin
    function dense_pagerank_solver(g::AbstractGraph, α=0.85::Real)
        p = fill(1 / nv(g), nv(g))
        danglingnodes = outdegree(g) .== 0
        M = Matrix{Float64}(adjacency_matrix(g))
        M = M'
        M[:, danglingnodes] .= sum(danglingnodes) ./ nv(g)
        M = M * Diagonal(1 ./ sum(M; dims=1)[:])
        @assert all(1.01 .>= sum(M; dims=1) .>= 0.999)
        # v = inv(I-β*M) * ((1-β)/nv(g) * ones(nv(g), 1))
        v = inv(I - α * M) * ((1 - α) / nv(g) * ones(nv(g), 1))
        return v
    end

    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)
    g6 = SimpleGraph(4)
    add_edge!(g6, 1, 2)
    add_edge!(g6, 2, 3)
    add_edge!(g6, 1, 3)
    add_edge!(g6, 3, 4)
    for α in [0.75, 0.85]
        for g in testdigraphs(g5)
            @test Parallel.pagerank(g)[3] ≈ 0.318 atol = 0.001
            @test length(@inferred(Parallel.pagerank(g))) == nv(g)
            @test_throws ErrorException Parallel.pagerank(g, 2)
            @test_throws ErrorException Parallel.pagerank(g, α, 2)
            @test isapprox(Parallel.pagerank(g, α), dense_pagerank_solver(g, α), atol=0.001)
        end

        for g in testgraphs(g6)
            @test length(@inferred(Parallel.pagerank(g))) == nv(g)
            @test_throws ErrorException Parallel.pagerank(g, 2)
            @test_throws ErrorException Parallel.pagerank(g, α, 2)
            @test isapprox(Parallel.pagerank(g, α), dense_pagerank_solver(g, α), atol=0.001)
        end
    end
end

@testset "Katz" begin
    g5 = SimpleDiGraph(4)
    add_edge!(g5, 1, 2)
    add_edge!(g5, 2, 3)
    add_edge!(g5, 1, 3)
    add_edge!(g5, 3, 4)
    for g in test_generic_graphs(g5)
        z = @inferred(katz_centrality(g, 0.4))
        @test round.(z, digits=2) == [0.32, 0.44, 0.62, 0.56]
    end
end

function random_greedy_color(
    g::AbstractGraph{T}, reps::Integer; parallel::Symbol=:threads
) where {T<:Integer}
    return if parallel === :threads
        threaded_random_greedy_color(g, reps)
    elseif parallel === :distributed
        distr_random_greedy_color(g, reps)
    else
        throw(
            ArgumentError(
                "Unsupported parallel argument '$(repr(parallel))' (supported: ':threads' or ':distributed')",
            ),
        )
    end
end

function threaded_random_greedy_color(g::AbstractGraph{T}, reps::Integer) where {T<:Integer}
    local_best = Vector{Graphs.Coloring{T}}(undef, reps)
    Base.Threads.@threads for i in 1:reps
        seq = shuffle(vertices(g))
        local_best[i] = Graphs.perm_greedy_color(g, seq)
    end
    best = reduce(Graphs.best_color, local_best)

    return convert(Graphs.Coloring{T}, best)
end

function distr_random_greedy_color(args...; kwargs...)
    return error(
        "`parallel = :distributed` requested, but SharedArrays or Distributed is not loaded"
    )
end

function greedy_color(
    g::AbstractGraph{U}; sort_degree::Bool=false, reps::Integer=1, parallel::Symbol=:threads
) where {U<:Integer}
    return if sort_degree
        Graphs.degree_greedy_color(g)
    else
        Parallel.random_greedy_color(g, reps; parallel)
    end
end

"""
    closeness_centrality(g, distmx=weights(g); normalize=true)

Calculate the [closeness centrality](https://en.wikipedia.org/wiki/Centrality#Closeness_centrality)
of the graph `g`. Return a vector representing the centrality calculated for each node in `g`.

### Optional Arguments
- `normalize=true`: If true, normalize the centrality value of each
node `n` by ``\\frac{|δ_n|}{|V|-1}``, where ``δ_n`` is the set of vertices reachable
from node `n`.

# Examples
```jldoctest
julia> using Graphs

julia> closeness_centrality(star_graph(5))
5-element Vector{Float64}:
 1.0
 0.5714285714285714
 0.5714285714285714
 0.5714285714285714
 0.5714285714285714

julia> closeness_centrality(path_graph(4))
4-element Vector{Float64}:
 0.5
 0.75
 0.75
 0.5
```
"""
function closeness_centrality(
    g::AbstractGraph, distmx::AbstractMatrix=weights(g); normalize=true
)
    n_v = nv(g)
    closeness = zeros(n_v)

    for u in vertices(g)
        if degree(g, u) == 0     # no need to do Dijkstra here
            closeness[u] = 0.0
        else
            d = dijkstra_shortest_paths(g, u, distmx).dists
            δ = filter(x -> x != typemax(x), d)
            σ = sum(δ)
            l = length(δ) - 1
            if σ > 0
                closeness[u] = l / σ
                if normalize
                    n = l / (n_v - 1)
                    closeness[u] *= n
                end
            end
        end
    end
    return closeness
end

using Random: randperm, shuffle!
using Statistics: mean
using Graphs: sample!

"""
    SimpleGraph{T}(nv, ne; rng=nothing, seed=nothing)

Construct a random `SimpleGraph{T}` with `nv` vertices and `ne` edges.
The graph is sampled uniformly from all such graphs.
If `seed >= 0`, a random generator is seeded with this value.
If not specified, the element type `T` is the type of `nv`.

### See also
[`erdos_renyi`](@ref)

## Examples
```jldoctest
julia> using Graphs

julia> SimpleGraph(5, 7)
{5, 7} undirected simple Int64 graph
```
"""
function SimpleGraph{T}(
    nv::Integer,
    ne::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    tnv = T(nv)
    maxe = div(Int(nv) * (nv - 1), 2)
    @assert(ne <= maxe, "Maximum number of edges for this graph is $maxe")
    rng = rng_from_rng_or_seed(rng, seed)
    ne > div((2 * maxe), 3) && return complement(SimpleGraph(tnv, maxe - ne; rng=rng))

    g = SimpleGraph(tnv)

    while g.ne < ne
        source = rand(rng, one(T):tnv)
        dest = rand(rng, one(T):tnv)
        source != dest && add_edge!(g, source, dest)
    end
    return g
end

function SimpleGraph(
    nv::T,
    ne::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    return SimpleGraph{T}(nv, ne; rng=rng, seed=seed)
end

"""
    SimpleDiGraph{T}(nv, ne; rng=nothing, seed=nothing)

Construct a random `SimpleDiGraph{T}` with `nv` vertices and `ne` edges.
The graph is sampled uniformly from all such graphs.
If `seed >= 0`, a random generator is seeded with this value.
If not specified, the element type `T` is the type of `nv`.

### See also
[`erdos_renyi`](@ref)

## Examples
```jldoctest
julia> using Graphs

julia> SimpleDiGraph(5, 7)
{5, 7} directed simple Int64 graph
```
"""
function SimpleDiGraph{T}(
    nv::Integer,
    ne::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    tnv = T(nv)
    maxe = Int(nv) * (nv - 1)
    @assert(ne <= maxe, "Maximum number of edges for this graph is $maxe")
    rng = rng_from_rng_or_seed(rng, seed)
    ne > div((2 * maxe), 3) && return complement(SimpleDiGraph{T}(tnv, maxe - ne; rng=rng))
    g = SimpleDiGraph(tnv)
    while g.ne < ne
        source = rand(rng, one(T):tnv)
        dest = rand(rng, one(T):tnv)
        source != dest && add_edge!(g, source, dest)
    end
    return g
end

function SimpleDiGraph(
    nv::T,
    ne::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    return SimpleDiGraph{Int}(nv, ne; rng=rng, seed=seed)
end
"""
    randbn(n, p; rng=nothing, seed=nothing)

Return a binomially-distributed random number with parameters `n` and `p` and optional `seed`.

### References
- "Non-Uniform Random Variate Generation," Luc Devroye, p. 522. Retrieved via http://www.eirene.de/Devroye.pdf.
- http://stackoverflow.com/questions/23561551/a-efficient-binomial-random-number-generator-code-in-java
"""
function randbn(
    n::Integer,
    p::Real;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    rng = rng_from_rng_or_seed(rng, seed)
    log_q = log(1.0 - p)
    x = 0
    sum = 0.0
    for _ in 1:n
        sum += log(rand(rng)) / (n - x)
        sum < log_q && break
        x += 1
    end
    return x
end

"""
    erdos_renyi(n, p::Real)

Create an [Erdős–Rényi](http://en.wikipedia.org/wiki/Erdős–Rényi_model)
random graph with `n` vertices. Edges are added between pairs of vertices with
probability `p`. 

Note that there exists another definition of the Erdös-Rényi model in which the
total number of edges is kept constant, rather than the probability `p`.
To access this definition, use `erdos_renyi(n, ne::Integer)`
(specifically: `erdos_renyi(n, 1) != erdos_renyi(n, 1.0)`).

### Optional Arguments
- `is_directed=false`: if true, return a directed graph.
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

# Examples
```
julia> using Graphs

julia> erdos_renyi(10, 0.5)
{10, 20} undirected simple Int64 graph
```
```
julia> using Graphs

julia> erdos_renyi(10, 0.5, is_directed=true, seed=123)
{10, 49} directed simple Int64 graph
```
"""
function erdos_renyi(
    n::Integer,
    p::Real;
    is_directed=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    p >= 1 && return is_directed ? complete_digraph(n) : complete_graph(n)
    m = is_directed ? n * (n - 1) : div(n * (n - 1), 2)
    ne = randbn(m, p; rng=rng, seed=seed)
    return if is_directed
        SimpleDiGraph(n, ne; rng=rng, seed=seed)
    else
        SimpleGraph(n, ne; rng=rng, seed=seed)
    end
end

"""
    erdos_renyi(n, ne::Integer)

Create an [Erdős–Rényi](http://en.wikipedia.org/wiki/Erdős–Rényi_model) random
graph with `n` vertices and `ne` edges.

### Optional Arguments
- `is_directed=false`: if true, return a directed graph.
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

# Examples
```
julia> using Graphs

julia> erdos_renyi(10, 30)
{10, 30} undirected simple Int64 graph

julia> erdos_renyi(10, 30, is_directed=true, seed=123)
{10, 30} directed simple Int64 graph
```
"""
function erdos_renyi(
    n::Integer,
    ne::Integer;
    is_directed=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    return if is_directed
        SimpleDiGraph(n, ne; rng=rng, seed=seed)
    else
        SimpleGraph(n, ne; rng=rng, seed=seed)
    end
end

"""
    expected_degree_graph(ω)

Given a vector of expected degrees `ω` indexed by vertex, create a random undirected graph in which vertices `i` and `j` are
connected with probability `ω[i]*ω[j]/sum(ω)`.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

### Implementation Notes
The algorithm should work well for `maximum(ω) << sum(ω)`. As `maximum(ω)` approaches `sum(ω)`, some deviations
from the expected values are likely.

### References
- Connected Components in Random Graphs with Given Expected Degree Sequences, Linyuan Lu and Fan Chung. [https://link.springer.com/article/10.1007%2FPL00012580](https://link.springer.com/article/10.1007%2FPL00012580)
- Efficient Generation of Networks with Given Expected Degrees, Joel C. Miller and Aric Hagberg. [https://doi.org/10.1007/978-3-642-21286-4_10](https://doi.org/10.1007/978-3-642-21286-4_10)

# Examples
```
# 1)
julia> using Graphs

julia> g = expected_degree_graph([3, 1//2, 1//2, 1//2, 1//2])
{5, 3} undirected simple Int64 graph

julia> print(degree(g))
[3, 0, 1, 1, 1]

# 2)
julia> g = expected_degree_graph([0.5, 0.5, 0.5], seed=123)
{3, 1} undirected simple Int64 graph

julia> print(degree(g))
[1, 0, 1]
```
"""
function expected_degree_graph(
    ω::Vector{T};
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Real}
    g = SimpleGraph(length(ω))
    return expected_degree_graph!(g, ω; rng=rng, seed=seed)
end

function expected_degree_graph!(
    g::SimpleGraph,
    ω::Vector{T};
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Real}
    n = length(ω)
    @assert all(zero(T) .<= ω .<= n - one(T)) "Elements of ω needs to be at least 0 and at most n-1"

    π = sortperm(ω; rev=true)
    rng = rng_from_rng_or_seed(rng, seed)

    S = sum(ω)

    for u in 1:(n - 1)
        v = u + 1
        p = min(ω[π[u]] * ω[π[v]] / S, one(T))
        while v <= n && p > zero(p)
            if p != one(T)
                v += floor(Int, log(rand(rng)) / log(one(T) - p))
            end
            if v <= n
                q = min(ω[π[u]] * ω[π[v]] / S, one(T))
                if rand(rng) < q / p
                    add_edge!(g, π[u], π[v])
                end
                p = q
                v += 1
            end
        end
    end
    return g
end

"""
    watts_strogatz(n, k, β)

Return a [Watts-Strogatz](https://en.wikipedia.org/wiki/Watts_and_Strogatz_model)
small world random graph with `n` vertices, each with expected degree `k` 
(or `k - 1` if `k` is odd). Edges are randomized per the model based on probability `β`.

The algorithm proceeds as follows. First, a perfect 1-lattice is constructed,
where each vertex has exacly `div(k, 2)` neighbors on each side (i.e., `k` or
`k - 1` in total). Then the following steps are repeated for a hop length `i` of
`1` through `div(k, 2)`.

1. Consider each vertex `s` in turn, along with the edge to its `i`th nearest
   neighbor `t`, in a clockwise sense.

2. Generate a uniformly random number `r`. If `r ≥ β`, then the edge `(s, t)` is
   left unaltered. Otherwise, the edge is deleted and *rewired* so that `s` is
   connected to some vertex `d`, chosen uniformly at random from the entire
   graph, excluding `s` and its neighbors. (Note that `t` is a valid candidate.)

For `β = 0`, the graph will remain a 1-lattice, and for `β = 1`, all edges will
be rewired randomly.

### Optional Arguments
- `remove_edges=true`: if false, do not remove the original edges.
- `is_directed=false`: if true, return a directed graph.
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

## Examples
```jldoctest
julia> using Graphs

julia> watts_strogatz(10, 4, 0.3)
{10, 20} undirected simple Int64 graph

julia> watts_strogatz(Int8(10), 4, 0.8, is_directed=true, seed=123)
{10, 20} directed simple Int8 graph
```

### References
- Collective dynamics of ‘small-world’ networks, Duncan J. Watts, Steven H. Strogatz. [https://doi.org/10.1038/30918](https://doi.org/10.1038/30918)
- Small Worlds, Duncan J. watts. [https://en.wikipedia.org/wiki/Special:BookSources?isbn=978-0691005416](https://en.wikipedia.org/wiki/Special:BookSources?isbn=978-0691005416)
"""
function watts_strogatz(
    n::Integer,
    k::Integer,
    β::Real;
    is_directed::Bool=false,
    remove_edges::Bool=true,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    @assert k < n

    # If we have n - 1 neighbors (exactly k/2 on each side), then the graph is
    # necessarily complete. No need to run the Watts-Strogatz procedure:
    if k == n - 1 && iseven(k)
        return is_directed ? complete_digraph(n) : complete_graph(n)
    end

    g = is_directed ? SimpleDiGraph(n) : SimpleGraph(n)

    # The ith next vertex, in clockwise order.
    # (Reduce to zero-based indexing, so the modulo works, by subtracting 1
    # before and adding 1 after.)
    @inline target(s, i) = ((s + i - 1) % n) + 1

    # Phase 1: For each step size i, add an edge from each vertex s to the ith
    # next vertex, in clockwise order.

    for i in 1:div(k, 2), s in 1:n
        add_edge!(g, s, target(s, i))
    end

    # Phase 2: For each step size i and each vertex s, consider the edge to the
    # ith next vertex, in clockwise order. With probability β, delete the edge
    # and rewire it to any (valid) target, chosen uniformly at random.

    rng = rng_from_rng_or_seed(rng, seed)
    for i in 1:div(k, 2), s in 1:n

        # We only rewire with a probability β, and we only worry about rewiring
        # if there is some vertex not connected to s; otherwise, the only valid
        # rewiring is to reconnect to the ith next vertex, and there is no work
        # to do.
        (rand(rng) < β && degree(g, s) < n - 1) || continue

        t = target(s, i)

        while true
            d = rand(rng, 1:n)          # Tentative new target
            d == s && continue          # Self-loops prohibited
            d == t && break             # Rewired to original target
            if add_edge!(g, s, d)       # Was this valid (i.e., unconnected)?
                remove_edges && rem_edge!(g, s, t)     # True rewiring: Delete original edge
                break                                   # We found a valid target
            end
        end
    end
    return g
end

"""
    newman_watts_strogatz(n, k, β)

Return a Newman-Watts-Strogatz small world random graph with `n` vertices, each
with expected degree `k(1 + β)` (or `(k - 1)(1 + β)` if `k` is odd). Edges are
randomized per the model based on probability `β`.

The algorithm proceeds as follows. First, a perfect 1-lattice is constructed,
where each vertex has exacly `div(k, 2)` neighbors on each side (i.e., `k` or
`k - 1` in total). Then the following steps are repeated for a hop length `i` of
`1` through `div(k, 2)`.

1. Consider each vertex `s` in turn, along with the edge to its `i`th nearest
   neighbor `t`, in a clockwise sense.

2. Generate a uniformly random number `r`. If `r < β`, `s` is connected to some
   vertex `d`, chosen uniformly at random from the entire graph, excluding `s` and
   its neighbors. (Note that `t` is a valid candidate.)

For `β = 0`, the graph will remain a 1-lattice, and for `β = 1`, all edges will
be rewired randomly.

Note: In the original paper by Newman and Watts, self-loops and double edges were
allowed, which is not the case here. However, for large enough networks and small
enough `p` and `k`, this should not deviate much from the original model.

### Optional Arguments
- `is_directed=false`: if true, return a directed graph.
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

## Examples
```
julia> using Graphs

julia> newman_watts_strogatz(10, 4, 0.3)
{10, 26} undirected simple Int64 graph
````
```jldoctest

julia> newman_watts_strogatz(Int8(10), 4, 0.8, is_directed=true, seed=123)
{10, 36} directed simple Int8 graph
```

### References
- Scaling and percolation in the small-world network model, M. E. J. Newman, Duncan J. Watts. [https://doi.org/10.1103/PhysRevE.60.7332](https://doi.org/10.1103/PhysRevE.60.7332)
"""
function newman_watts_strogatz(
    n::Integer,
    k::Integer,
    β::Real;
    is_directed::Bool=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    return watts_strogatz(
        n, k, β; is_directed=is_directed, remove_edges=false, rng=rng, seed=seed
    )
end

function _suitable(edges::Set{SimpleEdge{T}}, potential_edges::Dict{T,T}) where {T<:Integer}
    isempty(potential_edges) && return true
    list = keys(potential_edges)
    for s1 in list, s2 in list
        s1 >= s2 && continue
        (SimpleEdge(s1, s2) ∉ edges) && return true
    end
    return false
end

_try_creation(n::Integer, k::Integer, rng::AbstractRNG) = _try_creation(n, fill(k, n), rng)

function _try_creation(n::T, k::Vector{T}, rng::AbstractRNG) where {T<:Integer}
    edges = Set{SimpleEdge{T}}()
    m = 0
    stubs = zeros(T, sum(k))
    for i in one(T):n
        for j in one(T):k[i]
            m += 1
            stubs[m] = i
        end
    end
    # stubs = vcat([fill(i, k[i]) for i = 1:n]...) # slower

    while !isempty(stubs)
        potential_edges = Dict{T,T}()
        shuffle!(rng, stubs)
        for i in 1:2:length(stubs)
            s1, s2 = stubs[i:(i + 1)]
            if (s1 > s2)
                s1, s2 = s2, s1
            end
            e = SimpleEdge(s1, s2)
            if s1 != s2 && ∉(e, edges)
                push!(edges, e)
            else
                potential_edges[s1] = get(potential_edges, s1, 0) + 1
                potential_edges[s2] = get(potential_edges, s2, 0) + 1
            end
        end

        if !_suitable(edges, potential_edges)
            return Set{SimpleEdge{T}}()
        end

        stubs = Vector{T}()
        for (e, ct) in potential_edges
            append!(stubs, fill(e, ct))
        end
    end
    return edges
end

"""
    barabasi_albert(n, k)

Create a [Barabási–Albert model](https://en.wikipedia.org/wiki/Barab%C3%A1si%E2%80%93Albert_model)
random graph with `n` vertices. It is grown by adding new vertices to an initial
graph with `k` vertices. Each new vertex is attached with `k` edges to `k`
different vertices already present in the system by preferential attachment.
Initial graphs are undirected and consist of isolated vertices by default.

### Optional Arguments
- `is_directed=false`: if true, return a directed graph.
- `complete=false`: if true, use a complete graph for the initial graph.
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.
## Examples
```jldoctest
julia> using Graphs

julia> barabasi_albert(50, 3)
{50, 141} undirected simple Int64 graph

julia> barabasi_albert(100, Int8(10), is_directed=true, complete=true, seed=123)
{100, 990} directed simple Int8 graph
```
"""
barabasi_albert(n::Integer, k::Integer; keyargs...) = barabasi_albert(n, k, k; keyargs...)

"""
    barabasi_albert(n::Integer, n0::Integer, k::Integer)

Create a [Barabási–Albert model](https://en.wikipedia.org/wiki/Barab%C3%A1si%E2%80%93Albert_model)
random graph with `n` vertices. It is grown by adding new vertices to an initial
graph with `n0` vertices. Each new vertex is attached with `k` edges to `k`
different vertices already present in the system by preferential attachment.
Initial graphs are undirected and consist of isolated vertices by default.

### Optional Arguments
- `is_directed=false`: if true, return a directed graph.
- `complete=false`: if true, use a complete graph for the initial graph.
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

## Examples
```jldoctest
julia> using Graphs

julia> barabasi_albert(10, 3, 2)
{10, 14} undirected simple Int64 graph

julia> barabasi_albert(100, Int8(10), 3, is_directed=true, seed=123)
{100, 270} directed simple Int8 graph
```
"""
function barabasi_albert(
    n::Integer,
    n0::Integer,
    k::Integer;
    is_directed::Bool=false,
    complete::Bool=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    if complete
        g = is_directed ? complete_digraph(n0) : complete_graph(n0)
    else
        g = is_directed ? SimpleDiGraph(n0) : SimpleGraph(n0)
    end

    barabasi_albert!(g, n, k; rng=rng, seed=seed)
    return g
end

"""
    barabasi_albert!(g::AbstractGraph, n::Integer, k::Integer)

Create a [Barabási–Albert model](https://en.wikipedia.org/wiki/Barab%C3%A1si%E2%80%93Albert_model)
random graph with `n` vertices. It is grown by adding new vertices to an initial
graph `g`. Each new vertex is attached with `k` edges to `k` different vertices
already present in the system by preferential attachment.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.
## Examples
```jldoctest
julia> using Graphs

julia> g = cycle_graph(4)
{4, 4} undirected simple Int64 graph

julia> barabasi_albert!(g, 16, 3);

julia> g
{16, 40} undirected simple Int64 graph
```
"""
function barabasi_albert!(
    g::AbstractGraph,
    n::Integer,
    k::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    n0 = nv(g)
    1 <= k <= n0 <= n ||
        throw(ArgumentError("Barabási-Albert model requires 1 <= k <= nv(g) <= n"))
    n0 == n && return g

    # seed random number generator
    rng = rng_from_rng_or_seed(rng, seed)

    # add missing vertices
    sizehint!(g.fadjlist, n)
    add_vertices!(g, n - n0)

    # if initial graph doesn't contain any edges
    # expand it by one vertex and add k edges from this additional node
    if ne(g) == 0
        # expand initial graph
        n0 += one(n0)

        # add edges to k existing vertices
        for target in sample!(rng, collect(1:(n0 - 1)), k)
            add_edge!(g, n0, target)
        end
    end

    # vector of weighted vertices (each node is repeated once for each adjacent edge)
    weightedVs = Vector{Int}(undef, 2 * (n - n0) * k + 2 * ne(g))

    # initialize vector of weighted vertices
    offset = 0
    for e in edges(g)
        weightedVs[offset += 1] = src(e)
        weightedVs[offset += 1] = dst(e)
    end

    # array to record if a node is picked
    picked = fill(false, n)

    # vector of targets
    targets = Vector{Int}(undef, k)

    for source in (n0 + 1):n
        # choose k targets from the existing vertices
        # pick uniformly from weightedVs (preferential attachment)
        i = 0
        while i < k
            target = weightedVs[rand(rng, 1:offset)]
            if !picked[target]
                targets[i += 1] = target
                picked[target] = true
            end
        end

        # add edges to k targets
        for target in targets
            add_edge!(g, source, target)

            weightedVs[offset += 1] = source
            weightedVs[offset += 1] = target
            picked[target] = false
        end
    end
    return g
end

"""
    static_fitness_model(m, fitness)

Generate a random graph with ``|fitness|`` vertices and `m` edges,
in which the probability of the existence of ``Edge_{ij}`` is proportional
to ``fitness_i × fitness_j``.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

### Performance
Time complexity is ``\\mathcal{O}(|V| + |E| log |E|)``.

### References
- Goh K-I, Kahng B, Kim D: Universal behaviour of load distribution in scale-free networks. Phys Rev Lett 87(27):278701, 2001.

## Examples
```
julia> g = static_fitness_model(5, [1, 1, 0.5, 0.1])
{4, 5} undirected simple Int64 graph

julia> edges(g) |> collect
5-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3
 Edge 1 => 4
 Edge 2 => 3
 Edge 2 => 4
```
```
julia> using Graphs

julia> g = static_fitness_model(5, [1, 1, 0.5, 0.1], seed=123)
{4, 5} undirected simple Int64 graph

julia> edges(g) |> collect
5-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3
 Edge 2 => 3
 Edge 2 => 4
 Edge 3 => 4
```
"""
function static_fitness_model(
    m::Integer,
    fitness::Vector{T};
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Real}
    m < 0 && throw(ArgumentError("number of edges must be positive"))
    n = length(fitness)
    m == 0 && return SimpleGraph(n)
    nvs = 0
    for f in fitness
        # sanity check for the fitness
        f < zero(T) && throw(ArgumentError("fitness scores must be non-negative"))
        f > zero(T) && (nvs += 1)
    end
    # avoid getting into an infinite loop when too many edges are requested
    max_no_of_edges = div(nvs * (nvs - 1), 2)
    m > max_no_of_edges &&
        throw(ArgumentError("too many edges requested ($m > $max_no_of_edges)"))
    # calculate the cumulative fitness scores
    cum_fitness = cumsum(fitness)
    g = SimpleGraph(n)
    _create_static_fitness_graph!(g, m, cum_fitness, cum_fitness, rng, seed)
    return g
end

"""
    static_fitness_model(m, fitness_out, fitness_in)

Generate a random directed graph with ``|fitness\\_out + fitness\\_in|`` vertices and `m` edges,
in which the probability of the existence of ``Edge_{ij}`` is proportional with
respect to ``i ∝ fitness\\_out`` and ``j ∝ fitness\\_in``.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

### Performance
Time complexity is ``\\mathcal{O}(|V| + |E| log |E|)``.

### References
- Goh K-I, Kahng B, Kim D: Universal behaviour of load distribution in scale-free networks. Phys Rev Lett 87(27):278701, 2001.

## Examples
```
julia> using Graphs

julia> g = static_fitness_model(6, [1, 0.2, 0.2, 0.2], [0.1, 0.1, 0.1, 0.9]; seed=123)
{4, 6} directed simple Int64 graph

julia> edges(g) |> collect
6-element Vector{Graphs.SimpleGraphs.SimpleEdge{Int64}}:
 Edge 1 => 2
 Edge 1 => 3
 Edge 1 => 4
 Edge 2 => 3
 Edge 2 => 4
 Edge 3 => 4
```
"""
function static_fitness_model(
    m::Integer,
    fitness_out::Vector{T},
    fitness_in::Vector{S};
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Real} where {S<:Real}
    m < 0 && throw(ArgumentError("number of edges must be positive"))
    n = length(fitness_out)
    length(fitness_in) != n &&
        throw(ArgumentError("fitness_in must have the same size as fitness_out"))
    m == 0 && return SimpleDiGraph(n)
    # avoid getting into an infinite loop when too many edges are requested
    noutvs = ninvs = nvs = 0
    @inbounds for i in 1:n
        # sanity check for the fitness
        (fitness_out[i] < zero(T) || fitness_in[i] < zero(S)) &&
            error("fitness scores must be non-negative") # TODO 0.7: change to DomainError?
        fitness_out[i] > zero(T) && (noutvs += 1)
        fitness_in[i] > zero(S) && (ninvs += 1)
        (fitness_out[i] > zero(T) && fitness_in[i] > zero(S)) && (nvs += 1)
    end
    max_no_of_edges = noutvs * ninvs - nvs
    m > max_no_of_edges &&
        throw(ArgumentError("too many edges requested ($m > $max_no_of_edges)"))
    # calculate the cumulative fitness scores
    cum_fitness_out = cumsum(fitness_out)
    cum_fitness_in = cumsum(fitness_in)
    g = SimpleDiGraph(n)
    _create_static_fitness_graph!(g, m, cum_fitness_out, cum_fitness_in, rng, seed)
    return g
end

function _create_static_fitness_graph!(
    g::AbstractGraph,
    m::Integer,
    cum_fitness_out::Vector{T},
    cum_fitness_in::Vector{S},
    rng::Union{Nothing,AbstractRNG},
    seed::Union{Nothing,Integer},
) where {T<:Real} where {S<:Real}
    max_out = cum_fitness_out[end]
    max_in = cum_fitness_in[end]
    rng = rng_from_rng_or_seed(rng, seed)
    while m > 0
        source = searchsortedfirst(cum_fitness_out, rand(rng) * max_out)
        target = searchsortedfirst(cum_fitness_in, rand(rng) * max_in)
        # skip if loop edge
        (source == target) && continue
        # is there already an edge? If so, try again
        add_edge!(g, source, target) || continue
        m -= one(m)
    end
end

"""
    static_scale_free(n, m, α)

Generate a random graph with `n` vertices, `m` edges and expected power-law
degree distribution with exponent `α`.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.
- `finite_size_correction=true`: determines whether to use the finite size correction
proposed by Cho et al.

### Performance
Time complexity is ``\\mathcal{O}(|V| + |E| log |E|)``.

### References
- Goh K-I, Kahng B, Kim D: Universal behaviour of load distribution in scale-free networks. Phys Rev Lett 87(27):278701, 2001.
- Chung F and Lu L: Connected components in a random graph with given degree sequences. Annals of Combinatorics 6, 125-145, 2002.
- Cho YS, Kim JS, Park J, Kahng B, Kim D: Percolation transitions in scale-free networks under the Achlioptas process. Phys Rev Lett 103:135702, 2009.
"""
function static_scale_free(
    n::Integer,
    m::Integer,
    α::Real;
    finite_size_correction::Bool=true,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    n < 0 && throw(ArgumentError("number of vertices must be positive"))
    α < 2 && throw(ArgumentError("out-degree exponent must be >= 2"))
    fitness = _construct_fitness(n, α, finite_size_correction)
    return static_fitness_model(m, fitness; rng=rng, seed=seed)
end

"""
    static_scale_free(n, m, α_out, α_in)

Generate a random graph with `n` vertices, `m` edges and expected power-law
degree distribution with exponent `α_out` for outbound edges and `α_in` for
inbound edges.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.
- `finite_size_correction=true`: determines whether to use the finite size correction
proposed by Cho et al.

### Performance
Time complexity is ``\\mathcal{O}(|V| + |E| log |E|)``.

### References
- Goh K-I, Kahng B, Kim D: Universal behaviour of load distribution in scale-free networks. Phys Rev Lett 87(27):278701, 2001.
- Chung F and Lu L: Connected components in a random graph with given degree sequences. Annals of Combinatorics 6, 125-145, 2002.
- Cho YS, Kim JS, Park J, Kahng B, Kim D: Percolation transitions in scale-free networks under the Achlioptas process. Phys Rev Lett 103:135702, 2009.
"""
function static_scale_free(
    n::Integer,
    m::Integer,
    α_out::Real,
    α_in::Float64;
    finite_size_correction::Bool=true,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    n < 0 && throw(ArgumentError("number of vertices must be positive"))
    α_out < 2 && throw(ArgumentError("out-degree exponent must be >= 2"))
    α_in < 2 && throw(ArgumentError("out-degree exponent must be >= 2"))
    # construct the fitness
    fitness_out = _construct_fitness(n, α_out, finite_size_correction)
    fitness_in = _construct_fitness(n, α_in, finite_size_correction)
    # eliminate correlation
    shuffle!(fitness_in)
    return static_fitness_model(m, fitness_out, fitness_in; rng=rng, seed=seed)
end

function _construct_fitness(n::Integer, α::Real, finite_size_correction::Bool)
    α = -1 / (α - 1)
    fitness = zeros(n)
    j = float(n)
    if finite_size_correction && α < -0.5
        # See the Cho et al paper, first page first column + footnote 7
        j += n^(1 + 1 / 2 * α) * (10 * sqrt(2) * (1 + α))^(-1 / α) - 1
    end
    j = max(j, n)
    @inbounds for i in 1:n
        fitness[i] = j^α
        j -= 1
    end
    return fitness
end

"""
    random_regular_graph(n, k)

Create a random undirected
[regular graph](https://en.wikipedia.org/wiki/Regular_graph) with `n` vertices,
each with degree `k`.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

### Performance
Time complexity is approximately ``\\mathcal{O}(nk^2)``.

### Implementation Notes
Allocates an array of `nk` `Int`s, and . For ``k > \\frac{n}{2}``, generates a graph of degree
``n-k-1`` and returns its complement.
"""
function random_regular_graph(
    n::Integer,
    k::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    !iseven(n * k) && throw(ArgumentError("n * k must be even"))
    !(0 <= k < n) && throw(ArgumentError("the 0 <= k < n inequality must be satisfied"))
    if k == 0
        return SimpleGraph(n)
    end
    rng = rng_from_rng_or_seed(rng, seed)
    if (k > n / 2) && iseven(n * (n - k - 1))
        return complement(random_regular_graph(n, n - k - 1; rng=rng))
    end

    edges = _try_creation(n, k, rng)
    while isempty(edges)
        edges = _try_creation(n, k, rng)
    end

    g = SimpleGraph(n)
    for edge in edges
        add_edge!(g, edge)
    end

    return g
end

"""
    random_configuration_model(n, k)

Create a random undirected graph according to the [configuration model]
(https://sites.santafe.edu/~aaronc/courses/5352/fall2013/csci5352_2013_L11.pdf)
containing `n` vertices, with each node `i` having degree `k[i]`.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.
- `check_graphical=false`: if true, ensure that `k` is a graphical sequence
(see [`isgraphical`](@ref)).

### Performance
Time complexity is approximately ``\\mathcal{O}(n \\bar{k}^2)``.
### Implementation Notes
Allocates an array of ``n \\bar{k}`` `Int`s.
"""
function random_configuration_model(
    n::Integer,
    k::Array{T};
    check_graphical::Bool=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    n != length(k) && throw(ArgumentError("a degree sequence of length n must be provided"))
    m = sum(k)
    !iseven(m) && throw(ArgumentError("sum(k) must be even"))
    !all(0 .<= k .< n) &&
        throw(ArgumentError("the 0 <= k[i] < n inequality must be satisfied"))
    if check_graphical
        isgraphical(k) || throw(ArgumentError("degree sequence must be graphical"))
    end
    rng = rng_from_rng_or_seed(rng, seed)

    edges = _try_creation(n, k, rng)
    while m > 0 && isempty(edges)
        edges = _try_creation(n, k, rng)
    end

    g = SimpleGraphFromIterator(edges)
    if nv(g) < n
        add_vertices!(g, n - nv(g))
    end
    return g
end
"""
    uniform_tree(n)

Generates a random labelled tree, drawn uniformly at random over the ``n^{n-2}`` such trees. A uniform word of length `n-2` over the alphabet `1:n` is generated (Prüfer sequence) then decoded. See also the `prufer_decode` function and [this page on Prüfer codes](https://en.wikipedia.org/wiki/Pr%C3%BCfer_sequence). 

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.

# Examples
```jldoctest
julia> using Graphs

julia> uniform_tree(10)
{10, 9} undirected simple Int64 graph
```
"""
function uniform_tree(n::Integer; rng::Union{Nothing,AbstractRNG}=nothing)
    n <= 1 && return Graph(n)
    n == 2 && return path_graph(n)
    rng = rng_from_rng_or_seed(rng, nothing)
    random_code = rand(rng, Base.OneTo(n), n - 2)
    return prufer_decode(random_code)
end

"""
    random_regular_digraph(n, k)

Create a random directed [regular graph](https://en.wikipedia.org/wiki/Regular_graph)
with `n` vertices, each with degree `k`.

### Optional Arguments
- `dir=:out`: the direction of the edges for the degree parameter.
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

### Implementation Notes
Allocates an ``n × n`` sparse matrix of boolean as an adjacency matrix and
uses that to generate the directed graph.
"""
function random_regular_digraph(
    n::Integer,
    k::Integer;
    dir::Symbol=:out,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    # TODO remove the function sample from StatsBase for one allowing the use
    # of a local rng
    !(0 <= k < n) && throw(ArgumentError("the 0 <= k < n inequality must be satisfied"))

    if k == 0
        return SimpleDiGraph(n)
    end
    rng = rng_from_rng_or_seed(rng, seed)
    if (k > n / 2) && iseven(n * (n - k - 1))
        return complement(random_regular_digraph(n, n - k - 1; dir=dir, rng=rng))
    end
    cs = collect(2:n)
    i = 1
    I = Vector{Int}(undef, n * k)
    J = Vector{Int}(undef, n * k)
    V = fill(true, n * k)
    for r in 1:n
        l = ((r - 1) * k + 1):(r * k)
        I[l] .= r
        J[l] = sample!(rng, cs, k; exclude=r)
    end

    m = dir == :out ? sparse(I, J, V, n, n) : sparse(I, J, V, n, n)'
    return SimpleDiGraph(m)
end

"""
    random_tournament_digraph(n)

Create a random directed [tournament graph]
(https://en.wikipedia.org/wiki/Tournament_%28graph_theory%29)
with `n` vertices.

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

# Examples
```jldoctest
julia> using Graphs

julia> random_tournament_digraph(5)
{5, 10} directed simple Int64 graph

julia> random_tournament_digraph(Int8(10), seed=123)
{10, 45} directed simple Int8 graph
```
"""
function random_tournament_digraph(
    n::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    rng = rng_from_rng_or_seed(rng, seed)
    g = SimpleDiGraph(n)

    for i in 1:n, j in (i + 1):n
        rand(rng, Bool) ? add_edge!(g, SimpleEdge(i, j)) : add_edge!(g, SimpleEdge(j, i))
    end

    return g
end

"""
    stochastic_block_model(c, n)

Return a Graph generated according to the Stochastic Block Model (SBM).

`c[a,b]` : Mean number of neighbors of a vertex in block `a` belonging to block `b`.
           Only the upper triangular part is considered, since the lower triangular is
           determined by ``c[b,a] = c[a,b] * \\frac{n[a]}{n[b]}``.
`n[a]` : Number of vertices in block `a`

### Optional Arguments
- `rng=nothing`: set the Random Number Generator.
- `seed=nothing`: set the RNG seed.

For a dynamic version of the SBM see the [`StochasticBlockModel`](@ref) type and
related functions.
"""
function stochastic_block_model(
    c::Matrix{T},
    n::Vector{U};
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Real} where {U<:Integer}
    size(c, 1) == size(c, 2) == length(n) ||
        throw(ArgumentError("matrix-vector size mismatch"))

    # init dsfmt generator with a fixed seed
    rng = rng_from_rng_or_seed(rng, seed)
    N = sum(n)
    K = length(n)
    nedg = zeros(Int, K, K)
    g = SimpleGraph(N)
    cum = [sum(n[1:a]) for a in 0:K]
    for a in 1:K
        ra = (cum[a] + 1):cum[a + 1]
        for b in a:K
            ((a == b) && !(c[a, b] <= n[b] - 1)) ||
                ((a != b) && !(c[a, b] <= n[b])) && error(
                    "Mean degree cannot be greater than available neighbors in the block.",
                ) # TODO 0.7: turn into some other error?

            m = a == b ? div(n[a] * (n[a] - 1), 2) : n[a] * n[b]
            p = a == b ? n[a] * c[a, b] / (2m) : n[a] * c[a, b] / m
            nedg = randbn(m, p; rng=rng)
            rb = (cum[b] + 1):cum[b + 1]
            i = 0
            while i < nedg
                source = rand(rng, ra)
                dest = rand(rng, rb)
                if source != dest
                    if add_edge!(g, source, dest)
                        i += 1
                    end
                end
            end
        end
    end
    return g
end

"""
    stochastic_block_model(cint, cext, n)

Return a Graph generated according to the Stochastic Block Model (SBM), sampling
from an SBM with ``c_{a,a}=cint``, and ``c_{a,b}=cext``.
"""
function stochastic_block_model(
    cint::T,
    cext::T,
    n::Vector{U};
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Real} where {U<:Integer}
    K = length(n)
    c = [ifelse(a == b, cint, cext) for a in 1:K, b in 1:K]
    return stochastic_block_model(c, n; rng=rng, seed=seed)
end

"""
    StochasticBlockModel{T,P}

A type capturing the parameters of the SBM.
Each vertex is assigned to a block and the probability of edge `(i,j)`
depends only on the block labels of vertex `i` and vertex `j`.

The assignment is stored in nodemap and the block affinities a `k` by `k`
matrix is stored in affinities.

`affinities[k,l]` is the probability of an edge between any vertex in
block `k` and any vertex in block `l`.

### Implementation Notes
Graphs are generated by taking random ``i,j ∈ V`` and
flipping a coin with probability `affinities[nodemap[i],nodemap[j]]`.
"""
mutable struct StochasticBlockModel{T<:Integer,P<:Real}
    n::T
    nodemap::Array{T}
    affinities::Matrix{P}
end

function ==(sbm::StochasticBlockModel, other::StochasticBlockModel)
    return (sbm.n == other.n) &&
           (sbm.nodemap == other.nodemap) &&
           (sbm.affinities == other.affinities)
end

# A constructor for StochasticBlockModel that uses the sizes of the blocks
# and the affinity matrix. This construction implies that consecutive
# vertices will be in the same blocks, except for the block boundaries.
function StochasticBlockModel(sizes::AbstractVector, affinities::AbstractMatrix)
    csum = cumsum(sizes)
    j = 1
    nodemap = zeros(Int, csum[end])
    for i in 1:csum[end]
        if i > csum[j]
            j += 1
        end
        nodemap[i] = j
    end
    return StochasticBlockModel(csum[end], nodemap, affinities)
end

### TODO: This documentation needs work. sbromberger 20170326
"""
    sbmaffinity(internalp, externalp, sizes)

Produce the sbm affinity matrix with internal probabilities `internalp`
and external probabilities `externalp`.
"""
function sbmaffinity(
    internalp::Vector{T}, externalp::Real, sizes::Vector{U}
) where {T<:Real} where {U<:Integer}
    numblocks = length(sizes)
    numblocks == length(internalp) ||
        throw(ArgumentError("Inconsistent input dimensions: internalp, sizes"))
    B = diagm(0 => internalp) + externalp * (ones(numblocks, numblocks) - I)
    return B
end

function StochasticBlockModel(
    internalp::Real, externalp::Real, size::Integer, numblocks::Integer
)
    sizes = fill(size, numblocks)
    B = sbmaffinity(fill(internalp, numblocks), externalp, sizes)
    return StochasticBlockModel(sizes, B)
end

function StochasticBlockModel(
    internalp::Vector{T}, externalp::Real, sizes::Vector{U}
) where {T<:Real,U<:Integer}
    B = sbmaffinity(internalp, externalp, sizes)
    return StochasticBlockModel(sizes, B)
end

const biclique = ones(2, 2) - Matrix{Float64}(I, 2, 2)

# TODO: this documentation needs work. sbromberger 20170326
"""
    nearbipartiteaffinity(sizes, between, intra)

Construct the affinity matrix for a near bipartite SBM.
`between` is the affinity between the two parts of each bipartite community.
`intra` is the probability of an edge within the parts of the partitions.

This is a specific type of SBM with ``\\frac{k}{2} blocks each with two halves.
Each half is connected as a random bipartite graph with probability `intra`
The blocks are connected with probability `between`.
"""
function nearbipartiteaffinity(
    sizes::AbstractVector{T}, between::Real, intra::Real
) where {T<:Integer}
    numblocks = div(length(sizes), 2)
    return kron(between * Matrix{Float64}(I, numblocks, numblocks), biclique) +
           Matrix{Float64}(I, 2 * numblocks, 2 * numblocks) * intra
end

# Return a generator for edges from a stochastic block model near-bipartite graph.
function nearbipartiteaffinity(
    sizes::Vector{T}, between::Real, inter::Real, noise::Real
) where {T<:Integer}
    return nearbipartiteaffinity(sizes, between, inter) .+ noise
end

function nearbipartiteSBM(sizes, between, inter, noise)
    return StochasticBlockModel(sizes, nearbipartiteaffinity(sizes, between, inter, noise))
end

"""
    random_pair(rng, n)

Generate a stream of random pairs in `1:n` using random number generator `RNG`.
"""
function random_pair(rng::AbstractRNG, n::Integer)
    f(ch) = begin
        while true
            put!(ch, SimpleEdge(rand(rng, 1:n), rand(rng, 1:n)))
        end
    end
    return f
end

"""
    make_edgestream(sbm; rng=nothing, seed=nothing)

Take an infinite sample from the Stochastic Block Model `sbm`.
Pass to `Graph(nvg, neg, edgestream)` to get a Graph object based on `sbm`.
"""
function make_edgestream(
    sbm::StochasticBlockModel;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    rng = rng_from_rng_or_seed(rng, seed)
    pairs = Channel(random_pair(rng, sbm.n); ctype=SimpleEdge, csize=32)
    edges(ch) = begin
        for e in pairs
            i, j = Tuple(e)
            i == j && continue
            p = sbm.affinities[sbm.nodemap[i], sbm.nodemap[j]]
            if rand(rng) < p
                put!(ch, e)
            end
        end
    end
    return Channel(edges; ctype=SimpleEdge, csize=32)
end

"""
    SimpleGraph{T}(nv, ne, edgestream::Channel)

Construct a `SimpleGraph{T}` with `nv` vertices and `ne` edges from `edgestream`.
Can result in less than `ne` edges if the channel `edgestream` is closed prematurely.
Duplicate edges are only counted once.
The element type is the type of `nv`.
"""
function SimpleGraph(nvg::Integer, neg::Integer, edgestream::Channel)
    g = SimpleGraph(nvg)
    # println(g)
    for e in edgestream
        add_edge!(g, e)
        ne(g) >= neg && break
    end
    return g
end

"""
    SimpleGraph{T}(nv, ne, smb::StochasticBlockModel)

Construct a random `SimpleGraph{T}` with `nv` vertices and `ne` edges.
The graph is sampled according to the stochastic block model `smb`.
The element type is the type of `nv`.
"""
function SimpleGraph(
    nvg::Integer,
    neg::Integer,
    sbm::StochasticBlockModel;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    return SimpleGraph(nvg, neg, make_edgestream(sbm; rng=rng, seed=seed))
end

# TODO: this documentation needs work. sbromberger 20170326
"""
    blockcounts(sbm, A)

Count the number of edges that go between each block.
"""
function blockcounts(sbm::StochasticBlockModel, A::AbstractMatrix)
    I = collect(1:(sbm.n))
    J = [sbm.nodemap[i] for i in 1:(sbm.n)]
    V = ones(sbm.n)
    Q = sparse(I, J, V)
    return (Q'A) * Q
end

function blockcounts(sbm::StochasticBlockModel, g::AbstractGraph)
    return blockcounts(sbm, adjacency_matrix(g))
end

function blockfractions(sbm::StochasticBlockModel, g::Union{AbstractGraph,AbstractMatrix})
    bc = blockcounts(sbm, g)
    bp = bc ./ sum(bc)
    return bp
end

"""
    kronecker(SCALE, edgefactor, A=0.57, B=0.19, C=0.19; rng=nothing, seed=nothing)

Generate a directed [Kronecker graph](https://en.wikipedia.org/wiki/Kronecker_graph)
with the default Graph500 parameters.

###
References
- http://www.graph500.org/specifications#alg:generator
"""
function kronecker(
    SCALE,
    edgefactor,
    A=0.57,
    B=0.19,
    C=0.19;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    N = 2^SCALE
    M = edgefactor * N
    ij = ones(Int, M, 2)
    ab = A + B
    c_norm = C / (1 - (A + B))
    a_norm = A / (A + B)
    rng = rng_from_rng_or_seed(rng, seed)

    for ib in 1:SCALE
        ii_bit = rand(rng, M) .> (ab)  # bitarray
        jj_bit = rand(rng, M) .> (c_norm .* (ii_bit) + a_norm .* .!(ii_bit))
        ij .+= 2^(ib - 1) .* (hcat(ii_bit, jj_bit))
    end

    p = randperm(rng, N)
    ij = p[ij]

    p = randperm(rng, M)
    ij = ij[p, :]

    g = SimpleDiGraph(N)
    for (s, d) in zip(@view(ij[:, 1]), @view(ij[:, 2]))
        add_edge!(g, s, d)
    end
    return g
end

"""
    dorogovtsev_mendes(n)

Generate a random `n` vertex graph by the Dorogovtsev-Mendes method (with `n \\ge 3`).

The Dorogovtsev-Mendes process begins with a triangle graph and inserts `n-3` additional vertices.
Each time a vertex is added, a random edge is selected and the new vertex is connected to the two
endpoints of the chosen edge. This creates graphs with many triangles and a high local clustering coefficient.

It is often useful to track the evolution of the graph as vertices are added, you can access the graph from
the `t`th stage of this algorithm by accessing the first `t` vertices with `g[1:t]`.

### References
- http://graphstream-project.org/doc/Generators/Dorogovtsev-Mendes-generator/
- https://arxiv.org/pdf/cond-mat/0106144.pdf#page=24

# Examples
```jldoctest
julia> using Graphs

julia> dorogovtsev_mendes(10)
{10, 17} undirected simple Int64 graph

julia> dorogovtsev_mendes(11, seed=123)
{11, 19} undirected simple Int64 graph
```
"""
function dorogovtsev_mendes(
    n::Integer;
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    n < 3 && throw(DomainError("n=$n must be at least 3"))
    rng = rng_from_rng_or_seed(rng, seed)
    g = cycle_graph(3)
    bag_of_edges = Vector{SimpleEdge{Int}}(undef, 2 * n - 3) # Caching edges as they are added to avoid costly lookups

    bag_of_edges[1] = SimpleEdge(1, 2)
    bag_of_edges[2] = SimpleEdge(1, 3)
    bag_of_edges[3] = SimpleEdge(2, 3)
    index = 3

    for _ in 1:(n - 3)
        # Choose random edge from bag
        edge = bag_of_edges[rand(rng, 1:index)]
        u, v = src(edge), dst(edge)

        # Add new vertex
        add_vertex!(g)
        # Add new edges
        add_edge!(g, nv(g), u)
        add_edge!(g, nv(g), v)

        # Add new edges to bag
        bag_of_edges[index + 1] = SimpleEdge(nv(g), edge.src)
        bag_of_edges[index + 2] = SimpleEdge(nv(g), edge.dst)
        index += 2
    end
    return g
end

"""
    random_orientation_dag(g)

Generate a random oriented acyclical digraph. The function takes in a simple
graph and a random number generator as an argument. The probability of each
directional acyclic graph randomly being generated depends on the architecture
of the original directed graph.

DAG's have a finite topological order; this order is randomly generated via "order = randperm()".

# Examples
```jldoctest
julia> using Graphs

julia> random_orientation_dag(complete_graph(10))
{10, 45} directed simple Int64 graph

julia> random_orientation_dag(star_graph(Int8(10)), seed=123)
{10, 9} directed simple Int8 graph
```
"""
function random_orientation_dag(
    g::SimpleGraph{T};
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
) where {T<:Integer}
    nvg = length(g.fadjlist)
    rng = rng_from_rng_or_seed(rng, seed)
    order = randperm(rng, nvg)
    g2 = SimpleDiGraph(nv(g))
    @inbounds for i in vertices(g)
        for j in outneighbors(g, i)
            if order[i] < order[j]
                add_edge!(g2, i, j)
            end
        end
    end
    return g2
end

# The Shortest Path Faster Algorithm for single-source shortest path

###################################################################
#
# The type that encapsulates the state of Shortest Path Faster Algorithm
#
###################################################################

using Graphs: nv, weights, outneighbors

"""
    struct SPFA <: ShortestPathAlgorithm

The structure used to configure and specify that [`shortest_paths`](@ref)
should use the [Shortest Path Faster Algorithm](https://en.wikipedia.org/wiki/Shortest_Path_Faster_Algorithm).
No additional configuration parameters are specified or required.

### Implementation Notes
`SPFA` supports the following shortest-path functionality:
- non-negative distance matrices / weights
- all destinations
"""
struct SPFA <: ShortestPathAlgorithm end
struct SPFAResult{T,U<:Integer} <: ShortestPathResult
    parents::Vector{U}
    dists::Vector{T}
end

function shortest_paths(
    g::AbstractGraph{U}, source::Integer, distmx::AbstractMatrix{T}, alg::SPFA
) where {T,U<:Integer}
    nvg = nv(g)

    (source in 1:nvg) ||
        throw(DomainError(source, "source should be in between 1 and $nvg"))
    dists = fill(typemax(T), nvg)
    parents = zeros(U, nvg)
    dists[source] = 0

    count = zeros(U, nvg)           # Vector to store the count of number of times a vertex goes in the queue.

    queue = Vector{U}()             # Vector used to implement queue
    inqueue = falses(nvg, 1)         # BitArray to mark which vertices are in queue
    push!(queue, source)
    inqueue[source] = true

    @inbounds while !isempty(queue)
        v = popfirst!(queue)
        inqueue[v] = false

        @inbounds for v_neighbor in outneighbors(g, v)
            d = distmx[v, v_neighbor]
            if dists[v] + d < dists[v_neighbor]      # Relaxing edges
                dists[v_neighbor] = dists[v] + d
                parents[v_neighbor] = v

                if !inqueue[v_neighbor]
                    push!(queue, v_neighbor)
                    inqueue[v_neighbor] = true                   # Mark the vertex as inside queue.
                    count[v_neighbor] = count[v_neighbor] + 1      # Increment the number of times a vertex enters a queue.

                    if count[v_neighbor] > nvg          # This step is just to check negative edge cycle. If this step is not there,
                        throw(NegativeCycleError())     # the algorithm will run infinitely in case of a negative weight cycle.
                        # If count[i]>nvg for any i belonging to [1,nvg], it means a negative edge
                        # cycle is present.
                    end
                end
            end
        end
    end

    return SPFAResult(parents, dists)
end

function shortest_paths(g::AbstractGraph, s::Integer, alg::SPFA)
    return shortest_paths(g, s, weights(g), alg)
end

"""
Function which returns true if there is any negative weight cycle in the graph.
# Examples

```
julia> using Graphs

julia> g = complete_graph(3);

julia> d = [1 -3 1; -3 1 1; 1 1 1];

julia> has_negative_weight_cycle(g, d, SPFA())
true

julia> g = complete_graph(4);

julia> d = [1 1 -1 1; 1 1 -1 1; 1 1 1 1; 1 1 1 1];

julia> has_negative_weight_cycle(g, d, SPFA());
false
```
"""
function has_negative_weight_cycle(g::AbstractGraph, distmx::AbstractMatrix, alg::SPFA)
    try
        shortest_paths(g, 1, distmx, alg)
    catch e
        isa(e, ShortestPaths.NegativeCycleError) && return true
    end

    return false
end
has_negative_weight_cycle(g::AbstractGraph, ::SPFA) = false

"""
    diffusion(g, p, n)

Run diffusion simulation on `g` for `n` steps with spread
probabilities based on `p`. Return a vector with the set of new
vertices reached at each step of the simulation.

### Optional Arguments
- `initial_infections=sample(vertices(g), 1)`: A list of vertices that
are infected at the start of the simulation.
- `watch=Vector()`: While simulation is always run on the full graph,
specifying `watch` limits reporting to a specific set of vertices reached
during the simulation. If left empty, all vertices will be watched.
- `normalize=false`: if `false`, set the probability of spread from a vertex ``i`` to
each of the outneighbors of ``i`` to ``p``. If `true`, set the probability of spread
from a vertex ``i`` to each of the `outneighbors` of ``i`` to
``\\frac{p}{outdegreee(g, i)}``.
- `rng=nothing`: A random generator to sample from.
"""
function diffusion(
    g::AbstractGraph{T},
    p::Real,
    n::Integer;
    watch::AbstractVector=Vector{Int}(),
    normalize::Bool=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
    initial_infections::AbstractVector=Graphs.sample(vertices(g), 1; rng=rng, seed=seed),
) where {T}

    # Initialize
    rng = rng_from_rng_or_seed(rng, seed)
    watch_set = Set{T}(watch)
    infected_vertices = BitSet(initial_infections)
    vertices_per_step::Vector{Vector{T}} = [Vector{T}() for i in 1:n]

    # Record initial infection
    if !isempty(watch_set)
        watched_initial_infections = intersect(watch_set, initial_infections)
        vertices_per_step[1] = T.(collect(watched_initial_infections))
    else
        vertices_per_step[1] = T.(initial_infections)
    end

    # Run simulation
    randsubseq_buf = zeros(T, Δout(g))

    for step in 2:n
        new_infections = Set{T}()

        for i in infected_vertices
            outn = outneighbors(g, i)
            outd = length(outn)

            if outd > 0
                if normalize
                    local_p = p / outdegree(g, i)
                else
                    local_p = p
                end

                randsubseq!(rng, randsubseq_buf, outn, local_p)
                union!(new_infections, randsubseq_buf)
            end
        end

        # Record only new infections
        setdiff!(new_infections, infected_vertices)
        if !isempty(watch_set)
            vertices_per_step[step] = T.(collect(intersect(new_infections, watch_set)))
        else
            vertices_per_step[step] = collect(new_infections)
        end

        # Add new to master set of infected
        union!(infected_vertices, new_infections)
    end

    return vertices_per_step
end

"""
    diffusion_rate(results)
    diffusion_rate(g, p, n; ...)

Given the results of a `diffusion` output or the parameters
to the `diffusion` simulation itself, (run and) return the rate of
diffusion as a vector representing the cumulative number of vertices
infected at each simulation step, restricted to vertices included
in `watch`, if specified.
"""
diffusion_rate(x::Vector{Vector{T}}) where {T<:Integer} = cumsum(length.(x))
function diffusion_rate(
    g::AbstractGraph,
    p::Real,
    n::Integer;
    watch::AbstractVector=Vector{Int}(),
    normalize::Bool=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
    initial_infections::AbstractVector=Graphs.sample(vertices(g), 1; rng=rng, seed=seed),
)
    return diffusion_rate(
        diffusion(
            g,
            p,
            n;
            initial_infections=initial_infections,
            watch=watch,
            normalize=normalize,
            rng=rng,
            seed=seed,
        ),
    )
end

SUITE["core"] = BenchmarkGroup(
    [],
    "nv" => BenchmarkGroup([]),
    "edges" => BenchmarkGroup([]),
    "has_edge" => BenchmarkGroup([]),
)

# nv
SUITE["core"]["nv"]["graphs"] = @benchmarkable [nv(g) for (_, g) in $GRAPHS]
SUITE["core"]["nv"]["digraphs"] = @benchmarkable [nv(g) for (_, g) in $DIGRAPHS]

# iterate edges
function iter_edges(g::AbstractGraph)
    i = 0
    for e in edges(g)
        i += 1
    end
    return i
end

SUITE["core"]["edges"]["graphs"] = @benchmarkable [iter_edges(g) for (_, g) in $GRAPHS]
SUITE["core"]["edges"]["digraphs"] = @benchmarkable [iter_edges(g) for (_, g) in $DIGRAPHS]

# has edge
function all_has_edge(g::AbstractGraph)
    nvg = nv(g)
    srcs = rand([1:nvg;], cld(nvg, 4))
    dsts = rand([1:nvg;], cld(nvg, 4))
    i = 0
    for (s, d) in zip(srcs, dsts)
        if has_edge(g, s, d)
            i += 1
        end
    end
    return i
end

SUITE["core"]["has_edge"]["graphs"] = @benchmarkable [all_has_edge(g) for (_, g) in $GRAPHS]
SUITE["core"]["has_edge"]["digraphs"] = @benchmarkable [
    all_has_edge(g) for (_, g) in $DIGRAPHS
]

const exptestdir = dirname(@__FILE__)
tests = ["isomorphism", "parallel/runtests", "shortestpaths", "traversals"]

@testset "Experimental" begin
    @test length(description()) > 1

    for t in tests
        tp = joinpath(exptestdir, "$(t).jl")
        include(tp)
    end
end

@testset "Degree Independent Set" begin
    g0 = SimpleGraph(0)
    for g in testgraphs(g0)
        c = @inferred(independent_set(g, DegreeIndependentSet()))
        @test isempty(c)
    end

    g1 = SimpleGraph(1)
    for g in testgraphs(g1)
        c = @inferred(independent_set(g, DegreeIndependentSet()))
        @test (c == [1])
    end

    add_edge!(g1, 1, 1)
    for g in testgraphs(g1)
        c = @inferred(independent_set(g, DegreeIndependentSet()))
        @test isempty(c)
    end

    g3 = star_graph(5)
    for g in testgraphs(g3)
        c = @inferred(independent_set(g, DegreeIndependentSet()))
        @test sort(c) == [2, 3, 4, 5]
    end

    g4 = complete_graph(5)
    for g in testgraphs(g4)
        c = @inferred(independent_set(g, DegreeIndependentSet()))
        @test length(c) == 1 # Exactly one vertex
    end

    # path_graph(5) with additional edge 2-5
    g5 = path_graph(5)
    add_edge!(g5, 2, 5)
    for g in testgraphs(g5)
        c = @inferred(independent_set(g, DegreeIndependentSet()))
        @test sort(c) == [1, 3, 5]
    end

    add_edge!(g5, 2, 2)
    add_edge!(g5, 3, 3)
    for g in testgraphs(g5)
        c = @inferred(independent_set(g, DegreeIndependentSet()))
        @test sort(c) == [1, 5]
    end
end

@testset "Label propagation" begin
    rng = StableRNG(1)
    n = 10
    g10 = complete_graph(n)
    for g in testgraphs(g10)
        z = copy(g)
        for k in 2:5
            z = blockdiag(z, g)
            add_edge!(z, (k - 1) * n, k * n)
            c, ch = @inferred(label_propagation(GenericGraph(z); rng=rng))
            a = collect(n:n:(k * n))
            a = Int[div(i - 1, n) + 1 for i in 1:(k * n)]
            # check the number of communities
            @test length(unique(a)) == length(unique(c))
            # check the partition
            @test a == c
        end
    end
end

"""
    local_clustering_coefficient(g, v)
    local_clustering_coefficient(g, vs)

Return the [local clustering coefficient](https://en.wikipedia.org/wiki/Clustering_coefficient)
for node `v` in graph `g`. If a list of vertices `vs` is specified, return a vector
of coefficients for each node in the list.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(4);

julia> add_edge!(g, 1, 2);

julia> add_edge!(g, 2, 4);

julia> add_edge!(g, 4, 1);

julia> local_clustering_coefficient(g, [1, 2, 3])
3-element Vector{Float64}:
 1.0
 1.0
 0.0
```
"""
function local_clustering_coefficient(g::AbstractGraph, v::Integer)
    ntriang, nalltriang = local_clustering(g, v)
    return nalltriang == 0 ? 0.0 : ntriang * 1.0 / nalltriang
end

function local_clustering_coefficient(g::AbstractGraph, vs=vertices(g))
    ntriang, nalltriang = local_clustering(g, vs)
    return map(p -> p[2] == 0 ? 0.0 : p[1] * 1.0 / p[2], zip(ntriang, nalltriang))
end

function local_clustering!(storage::AbstractVector{Bool}, g::AbstractGraph, v::Integer)
    k = degree(g, v)
    k <= 1 && return (0, 0)
    neighs = collect_if_not_vector(neighbors(g, v))
    tcount = 0
    storage[neighs] .= true

    @inbounds for i in neighs
        i == v && continue
        @inbounds for j in neighbors(g, i)
            if (j != v) && (i != j) && storage[j]
                tcount += 1
            end
        end
    end
    return is_directed(g) ? (tcount, k * (k - 1)) : (div(tcount, 2), div(k * (k - 1), 2))
end

function local_clustering!(
    storage::AbstractVector{Bool},
    ntriang::AbstractVector{Int},
    nalltriang::AbstractVector{Int},
    g::AbstractGraph,
    vs,
)
    i = 0
    for (i, v) in enumerate(vs)
        ntriang[i], nalltriang[i] = local_clustering!(storage, g, v)
        storage[collect_if_not_vector(neighbors(g, v))] .= false
    end
    return ntriang, nalltriang
end

"""
    local_clustering(g, v)
    local_clustering(g, vs)

Return a tuple `(a, b)`, where `a` is the number of triangles in the neighborhood
of `v` and `b` is the maximum number of possible triangles. If a list of vertices
`vs` is specified, return two vectors representing the number of triangles and
the maximum number of possible triangles, respectively, for each node in the list.

This function is related to the local clustering coefficient `r` by ``r=\\frac{a}{b}``.
"""
function local_clustering(g::AbstractGraph, v::Integer)
    storage = zeros(Bool, nv(g))
    return local_clustering!(storage, g, v)
end

function local_clustering(g::AbstractGraph, vs=vertices(g))
    storage = zeros(Bool, nv(g))
    ntriang = zeros(Int, length(vs))
    nalltriang = zeros(Int, length(vs))
    return local_clustering!(storage, ntriang, nalltriang, g, vs)
end

"""
    triangles(g[, v])
    triangles(g, vs)

Return the number of triangles in the neighborhood of node `v` in graph `g`.
If a list of vertices `vs` is specified, return a vector of number of triangles
for each node in the list. If no vertices are specified, return the number
of triangles for each node in the graph.

# Examples
```jldoctest
julia> using Graphs

julia> g = SimpleGraph(4);

julia> add_edge!(g, 1, 2);

julia> add_edge!(g, 2, 4);

julia> add_edge!(g, 4, 1);

julia> triangles(g)
4-element Vector{Int64}:
 1
 1
 0
 1
```
"""
triangles(g::AbstractGraph, v::Integer) = local_clustering(g, v)[1]
triangles(g::AbstractGraph, vs=vertices(g)) = local_clustering(g, vs)[1]

"""
    global_clustering_coefficient(g)

Return the [global clustering coefficient](https://en.wikipedia.org/wiki/Clustering_coefficient)
of graph `g`.

# Examples
```jldoctest
julia> using Graphs

julia> global_clustering_coefficient(star_graph(4))
0.0

julia> global_clustering_coefficient(smallgraph(:housex))
0.7894736842105263
```
"""
function global_clustering_coefficient(g::AbstractGraph)
    c = 0
    ntriangles = 0
    for v in vertices(g)
        neighs = neighbors(g, v)
        for i in neighs, j in neighs
            i == j && continue
            if has_edge(g, i, j)
                c += 1
            end
        end
        k = degree(g, v)
        ntriangles += k * (k - 1)
    end
    ntriangles == 0 && return 1.0
    return c / ntriangles
end

# Helper function used due to performance bug in @threads.
function _loopbody!(
    pivot::U, nvg::U, dists::Matrix{T}, parents::Matrix{U}
) where {T<:Number} where {U<:Integer}
    # Relax dists[u, v] = min(dists[u, v], dists[u, pivot]+dists[pivot, v]) for all u, v
    @inbounds @threads for v in one(U):nvg
        d = dists[pivot, v]
        if d != typemax(T) && v != pivot
            p = parents[pivot, v]
            @inbounds for u in one(U):nvg
                ans = (
                    if dists[u, pivot] == typemax(T) || u == pivot
                        typemax(T)
                    else
                        dists[u, pivot] + d
                    end
                )
                if dists[u, v] > ans
                    dists[u, v] = ans
                    parents[u, v] = p
                end
            end
        end
    end
end

function floyd_warshall_shortest_paths(
    g::AbstractGraph{U}, distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number} where {U<:Integer}
    nvg = nv(g)
    dists = fill(typemax(T), (Int(nvg), Int(nvg)))
    parents = zeros(U, (Int(nvg), Int(nvg)))

    for v in 1:nvg
        dists[v, v] = zero(T)
    end
    undirected = !is_directed(g)
    for e in edges(g)
        u = src(e)
        v = dst(e)

        d = distmx[u, v]

        dists[u, v] = min(d, dists[u, v])
        parents[u, v] = u
        if undirected
            dists[v, u] = min(d, dists[v, u])
            parents[v, u] = v
        end
    end

    for pivot in vertices(g)
        _loopbody!(pivot, nvg, dists, parents) #Due to bug in @threads
    end
    fws = FloydWarshallState(dists, parents)
    return fws
end

module Parallel

using Graphs
using Graphs: sample, AbstractPathState, JohnsonState, BellmanFordState, FloydWarshallState
using Base.Threads: @threads, nthreads, Atomic, atomic_add!, atomic_cas!
using ArnoldiMethod: LM, SR, LR, partialschur, partialeigen
using Random: AbstractRNG, shuffle
import SparseArrays: sparse
import Base: push!, popfirst!, isempty, getindex

include("shortestpaths/bellman-ford.jl")
include("shortestpaths/dijkstra.jl")
include("shortestpaths/floyd-warshall.jl")
include("shortestpaths/johnson.jl")
include("centrality/betweenness.jl")
include("centrality/closeness.jl")
include("centrality/pagerank.jl")
include("centrality/radiality.jl")
include("centrality/stress.jl")
include("distance.jl")
include("traversals/bfs.jl")
include("traversals/greedy_color.jl")
include("utils.jl")
include("dominatingset/minimal_dom_set.jl")
include("independentset/maximal_ind_set.jl")
include("vertexcover/random_vertex_cover.jl")

end

"""
    struct Parallel.MultipleDijkstraState{T, U}

An [`AbstractPathState`](@ref) designed for Parallel.dijkstra_shortest_paths calculation.
"""
struct MultipleDijkstraState{T<:Number,U<:Integer} <: AbstractPathState
    dists::Matrix{T}
    parents::Matrix{U}
end

"""
    Parallel.dijkstra_shortest_paths(g, sources=vertices(g), distmx=weights(g))

Compute the shortest paths between all pairs of vertices in graph `g` by running
[`dijkstra_shortest_paths`] for every vertex and using an optional list of source vertex `sources` and
an optional distance matrix `distmx`. Return a [`Parallel.MultipleDijkstraState`](@ref) with relevant
traversal information.
"""
function dijkstra_shortest_paths(
    g::AbstractGraph{U}, sources=vertices(g), distmx::AbstractMatrix{T}=weights(g)
) where {T<:Number} where {U}
    n_v = nv(g)
    r_v = length(sources)

    # TODO: remove `Int` once julialang/#23029 / #23032 are resolved
    dists = SharedMatrix{T}(Int(r_v), Int(n_v))
    parents = SharedMatrix{U}(Int(r_v), Int(n_v))

    @sync @distributed for i in 1:r_v
        state = Graphs.dijkstra_shortest_paths(g, sources[i], distmx)
        dists[i, :] = state.dists
        parents[i, :] = state.parents
    end

    result = MultipleDijkstraState(sdata(dists), sdata(parents))
    return result
end

"""
    clique_percolation(g, k=3)

Community detection using the clique percolation algorithm. Communities are potentially overlapping.
Return a vector of vectors `c` such that `c[i]` is the set of vertices in community `i`.
The parameter `k` defines the size of the clique to use in percolation.

### References
- [Palla G, Derenyi I, Farkas I J, et al.] (https://www.nature.com/articles/nature03607)

# Examples
```jldoctest; filter = r"^\\s+BitSet\\(\\[[\\d, ]+\\]\\)\$"m
julia> using Graphs

julia> clique_percolation(clique_graph(3, 2))
2-element Vector{BitSet}:
 BitSet([4, 5, 6])
 BitSet([1, 2, 3])

julia> clique_percolation(clique_graph(3, 2), k=2)
1-element Vector{BitSet}:
 BitSet([1, 2, 3, 4, 5, 6])

julia> clique_percolation(clique_graph(3, 2), k=4)
BitSet[]
```
"""
function clique_percolation end

@traitfn function clique_percolation(g::::(!IsDirected); k=3)
    kcliques = filter(x -> length(x) >= k, maximal_cliques(g))
    nc = length(kcliques)
    # graph with nodes represent k-cliques
    h = Graph(nc)
    # vector for counting common nodes between two cliques efficiently
    x = falses(nv(g))
    for i in 1:nc
        x[kcliques[i]] .= true
        for j in (i + 1):nc
            sum(x[kcliques[j]]) >= k - 1 && add_edge!(h, i, j)
        end
        # reset status
        x[kcliques[i]] .= false
    end
    components = connected_components(h)
    communities = [BitSet() for i in 1:length(components)]
    for (i, component) in enumerate(components)
        push!(communities[i], vcat(kcliques[component]...)...)
    end
    return communities
end

"""
    Graphs.Test

A module that provides utilities for testing functions that should work with any `Graphs.AbstractGraph`.
"""
module Test

using Graphs

export GenericEdge, GenericGraph, GenericDiGraph, generic_graph

"""
    GenericEdge <: Graphs.AbstractEdge

An edge type that can  be used to tests functions that relay on the Graphs.jl interface.

"""
struct GenericEdge{T} <: Graphs.AbstractEdge{T}
    e::Graphs.SimpleEdge{T}
end

Graphs.src(e::GenericEdge) = Graphs.src(e.e)

Graphs.dst(e::GenericEdge) = Graphs.dst(e.e)

Base.reverse(e::GenericEdge) = GenericEdge(reverse(e.e))

"""
    GenericGraph{T} <: Graphs.AbstractGraph{T}

An undirected graph type that can  be used to tests functions that relay on the Graphs.jl interface.

"""
struct GenericGraph{T} <: Graphs.AbstractGraph{T}
    g::SimpleGraph{T}
end

"""
    GenericDiGraph{T} <: Graphs.AbstractGraph{T}

A directed graph type that can  be used to tests functions that relay on the Graphs.jl interface.

"""
struct GenericDiGraph{T} <: Graphs.AbstractGraph{T}
    g::SimpleDiGraph{T}
end

"""
    generic_graph(g::Union{SimpleGraph, SimpleDiGraph})

Return either a GenericGraph or GenericDiGraph that wraps a copy of g.
"""
function generic_graph(g::Union{SimpleGraph,SimpleDiGraph})
    g = copy(g)
    return is_directed(g) ? GenericDiGraph(g) : GenericGraph(g)
end

function GenericDiGraph(elist::Vector{Graphs.SimpleDiGraphEdge{T}}) where {T<:Integer}
    return GenericDiGraph{T}(SimpleDiGraph(elist))
end

Graphs.is_directed(::Type{<:GenericGraph}) = false
Graphs.is_directed(::Type{<:GenericDiGraph}) = true

Graphs.edges(g::GenericGraph) = (GenericEdge(e) for e in Graphs.edges(g.g))
Graphs.edges(g::GenericDiGraph) = (GenericEdge(e) for e in Graphs.edges(g.g))

Graphs.edgetype(g::GenericGraph) = GenericEdge{eltype(g)}
Graphs.edgetype(g::GenericDiGraph) = GenericEdge{eltype(g)}

Graphs.has_edge(g::GenericGraph, s, d) = Graphs.has_edge(g.g, s, d)
Graphs.has_edge(g::GenericDiGraph, s, d) = Graphs.has_edge(g.g, s, d)

Graphs.has_vertex(g::GenericGraph, v) = Graphs.has_vertex(g.g, v)
Graphs.has_vertex(g::GenericDiGraph, v) = Graphs.has_vertex(g.g, v)

Graphs.inneighbors(g::GenericGraph, v) = (u for u in Graphs.inneighbors(g.g, v))
Graphs.inneighbors(g::GenericDiGraph, v) = (u for u in Graphs.inneighbors(g.g, v))

Graphs.outneighbors(g::GenericGraph, v) = (u for u in Graphs.outneighbors(g.g, v))
Graphs.outneighbors(g::GenericDiGraph, v) = (u for u in Graphs.outneighbors(g.g, v))

Graphs.ne(g::GenericGraph) = Graphs.ne(g.g)
Graphs.ne(g::GenericDiGraph) = Graphs.ne(g.g)

Graphs.nv(g::GenericGraph) = Graphs.nv(g.g)
Graphs.nv(g::GenericDiGraph) = Graphs.nv(g.g)

Graphs.vertices(g::GenericGraph) = (v for v in Graphs.vertices(g.g))
Graphs.vertices(g::GenericDiGraph) = (v for v in Graphs.vertices(g.g))

end # module

@testset "Generator deprecations" begin
    types_0 = [
        BullGraph,
        ChvatalGraph,
        CubicalGraph,
        DesarguesGraph,
        DiamondGraph,
        DodecahedralGraph,
        FruchtGraph,
        HeawoodGraph,
        HouseGraph,
        HouseXGraph,
        IcosahedralGraph,
        KarateGraph,
        KrackhardtKiteGraph,
        MoebiusKantorGraph,
        OctahedralGraph,
        PappusGraph,
        PetersenGraph,
        SedgewickMazeGraph,
        TetrahedralGraph,
        TruncatedCubeGraph,
        TruncatedTetrahedronGraph,
        TruncatedTetrahedronDiGraph,
        TutteGraph,
    ]
    types_1param = [
        CompleteGraph,
        CompleteDiGraph,
        StarGraph,
        StarDigraph,
        PathGraph,
        PathDiGraph,
        CycleGraph,
        CycleDiGraph,
        WheelGraph,
        WheelDiGraph,
        BinaryTree,
        Doublebinary_tree,
        RoachGraph,
        LadderGraph,
        Circularladder_graph,
    ]
    types_2params = [
        CompleteBipartiteGraph, LollipopGraph, BarbellGraph, TuranGraph, CliqueGraph
    ]
    for G in types_0
        @test_deprecated G()
    end
    for G in types_1param
        @test_deprecated G(5)
    end
    for G in types_2params
        @test_deprecated G(5, 2)
    end
    @test_deprecated CompleteMultipartiteGraph([3, 5])
    @test_deprecated Grid([3, 5])
end

"""
    euclidean_graph(N, d; rng=nothing, seed=nothing, L=1., p=2., cutoff=-1., bc=:open)

Generate `N` uniformly distributed points in the box ``[0,L]^{d}``
and return a Euclidean graph, a map containing the distance on each edge and
a matrix with the points' positions.

## Examples
```
julia> using Graphs

julia> g, dists = euclidean_graph(5, 2, cutoff=0.3);

julia> g
{5, 4} undirected simple Int64 graph

julia> dists
Dict{Graphs.SimpleGraphs.SimpleEdge{Int64},Float64} with 4 entries:
  Edge 1 => 5 => 0.205756
  Edge 2 => 5 => 0.271359
  Edge 2 => 4 => 0.247703
  Edge 4 => 5 => 0.168372
```
"""
function euclidean_graph(
    N::Int,
    d::Int;
    L=1.0,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
    kws...,
)
    rng = rng_from_rng_or_seed(rng, seed)
    points = rmul!(rand(rng, d, N), L)
    return (euclidean_graph(points; L=L, kws...)..., points)
end

"""
    euclidean_graph(points)

Given the `d×N` matrix `points` build an Euclidean graph of `N` vertices and
return a graph and Dict containing the distance on each edge.

### Optional Arguments
- `L=1`: used to bound the `d` dimensional box from which points are selected.
- `p=2`
- `bc=:open`

### Implementation Notes
Defining the `d`-dimensional vectors `x[i] = points[:,i]`, an edge between
vertices `i` and `j` is inserted if `norm(x[i]-x[j], p) < cutoff`.
In case of negative `cutoff` instead every edge is inserted.
For `p=2` we have the standard Euclidean distance.
Set `bc=:periodic` to impose periodic boundary conditions in the box ``[0,L]^d``.

## Examples
```
julia> using Graphs

julia> pts = rand(3, 10); # 10 vertices in R^3

julia> g, dists = euclidean_graph(pts, p=1, bc=:periodic) # Taxicab-distance (L^1);

julia> g
{10, 45} undirected simple Int64 graph
```
"""
function euclidean_graph(points::Matrix; L=1.0, p=2.0, cutoff=-1.0, bc=:open)
    d, N = size(points)
    weights = Dict{SimpleEdge{Int},Float64}()
    cutoff < 0.0 && (cutoff = typemax(Float64))
    if bc == :periodic
        maximum(points) > L && throw(
            DomainError(maximum(points), "Some points are outside the box of size $L")
        )
    end
    for i in 1:N
        for j in (i + 1):N
            if bc == :open
                Δ = points[:, i] - points[:, j]
            elseif bc == :periodic
                Δ = abs.(points[:, i] - points[:, j])
                Δ = min.(L .- Δ, Δ)
            else
                throw(ArgumentError("$bc is not a valid boundary condition"))
            end
            dist = norm(Δ, p)
            if dist < cutoff
                e = SimpleEdge(i, j)
                weights[e] = dist
            end
        end
    end
    g = Graphs.SimpleGraphs._SimpleGraphFromIterator(keys(weights), Int)
    if nv(g) < N
        add_vertices!(g, N - nv(g))
    end
    return g, weights
end

# Betweenness centrality measures
# TODO - weighted, separate unweighted, edge betweenness

"""
    betweenness_centrality(g[, vs])
    betweenness_centrality(g, k)

Calculate the [betweenness centrality](https://en.wikipedia.org/wiki/Centrality#Betweenness_centrality)
of a graph `g` across all vertices, a specified subset of vertices `vs`, or a random subset of `k`
vertices. Return a vector representing the centrality calculated for each node in `g`.

### Optional Arguments
- `normalize=true`: If true, normalize the betweenness values by the
total number of possible distinct paths between all pairs in the graphs.
For an undirected graph, this number is ``\\frac{(|V|-1)(|V|-2)}{2}``
and for a directed graph, ``{(|V|-1)(|V|-2)}``.
- `endpoints=false`: If true, include endpoints in the shortest path count.
Betweenness centrality is defined as:
``
bc(v) = \\frac{1}{\\mathcal{N}} \\sum_{s \\neq t \\neq v}
\\frac{\\sigma_{st}(v)}{\\sigma_{st}}
``.

### References
- Brandes 2001 & Brandes 2008

# Examples
```jldoctest
julia> using Graphs

julia> betweenness_centrality(star_graph(3))
3-element Vector{Float64}:
 1.0
 0.0
 0.0

julia> betweenness_centrality(path_graph(4))
4-element Vector{Float64}:
 0.0
 0.6666666666666666
 0.6666666666666666
 0.0
```
"""
function betweenness_centrality(
    g::AbstractGraph,
    vs=vertices(g),
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    endpoints=false,
)
    n_v = nv(g)
    k = length(vs)
    isdir = is_directed(g)

    betweenness = zeros(n_v)
    for s in vs
        if degree(g, s) > 0  # this might be 1?
            state = dijkstra_shortest_paths(g, s, distmx; allpaths=true, trackvertices=true)
            if endpoints
                _accumulate_endpoints!(betweenness, state, g, s)
            else
                _accumulate_basic!(betweenness, state, g, s)
            end
        end
    end

    _rescale!(betweenness, n_v, normalize, isdir, k)

    return betweenness
end

function betweenness_centrality(
    g::AbstractGraph,
    k::Integer,
    distmx::AbstractMatrix=weights(g);
    normalize=true,
    endpoints=false,
    rng::Union{Nothing,AbstractRNG}=nothing,
    seed::Union{Nothing,Integer}=nothing,
)
    return betweenness_centrality(
        g,
        sample(collect_if_not_vector(vertices(g)), k; rng=rng, seed=seed),
        distmx;
        normalize=normalize,
        endpoints=endpoints,
    )
end

function _accumulate_basic!(
    betweenness::Vector{Float64}, state::DijkstraState, g::AbstractGraph, si::Integer
)
    n_v = length(state.parents) # this is the ttl number of vertices
    δ = zeros(n_v)
    σ = state.pathcounts
    P = state.predecessors

    # make sure the source index has no parents.
    P[si] = []
    # we need to order the source vertices by decreasing distance for this to work.
    S = reverse(state.closest_vertices) # Replaced sortperm with this
    for w in S
        coeff = (1.0 + δ[w]) / σ[w]
        for v in P[w]
            if v > 0
                δ[v] += (σ[v] * coeff)
            end
        end
        if w != si
            betweenness[w] += δ[w]
        end
    end
    return nothing
end

function _accumulate_endpoints!(
    betweenness::Vector{Float64}, state::DijkstraState, g::AbstractGraph, si::Integer
)
    n_v = nv(g) # this is the ttl number of vertices
    δ = zeros(n_v)
    σ = state.pathcounts
    P = state.predecessors
    v1 = collect(Base.OneTo(n_v))
    v2 = state.dists
    S = reverse(state.closest_vertices)
    betweenness[si] += length(S) - 1    # 289

    for w in S
        coeff = (1.0 + δ[w]) / σ[w]
        for v in P[w]
            δ[v] += σ[v] * coeff
        end
        if w != si
            betweenness[w] += (δ[w] + 1)
        end
    end
    return nothing
end

function _rescale!(
    betweenness::Vector{Float64}, n::Integer, normalize::Bool, directed::Bool, k::Integer
)
    scale = nothing
    if normalize
        if 2 < n
            scale = 1.0 / ((n - 1) * (n - 2))
        end
    elseif !directed
        scale = 1.0 / 2.0
    end
    if !isnothing(scale)
        if k > 0
            scale = scale * n / k
        end
        betweenness .*= scale
    end
    return nothing
end

@testset "Modularity" begin

    # 1. undirected test cases 
    n = 10
    m = n * (n - 1) / 2
    c = ones(Int, n)
    gint = complete_graph(n)
    for g in test_generic_graphs(gint)
        @test @inferred(modularity(g, c)) == 0
    end

    gint = SimpleGraph(n)
    for g in test_generic_graphs(gint)
        @test @inferred(modularity(g, c)) == 0
    end

    barbell = barbell_graph(3, 3)
    c = [1, 1, 1, 2, 2, 2]

    for g in test_generic_graphs(barbell)
        Q1 = @inferred(modularity(g, c))
        @test isapprox(Q1, 0.35714285714285715, atol=1e-3)
        Q2 = @inferred(modularity(g, c, γ=0.5))
        @test isapprox(Q2, 0.6071428571428571, atol=1e-3)
    end

    # Test with self loop
    add_edge!(barbell, 1, 1)
    for g in test_generic_graphs(barbell)
        Q = @inferred(modularity(g, c))
        @test isapprox(Q, 0.3671875, atol=1e-3)
    end

    # 2. directed test cases 
    triangle = SimpleDiGraph(3)
    add_edge!(triangle, 1, 2)
    add_edge!(triangle, 2, 3)
    add_edge!(triangle, 3, 1)

    barbell = blockdiag(triangle, triangle)
    add_edge!(barbell, 1, 4)
    c = [1, 1, 1, 2, 2, 2]

    for g in test_generic_graphs(barbell)
        Q1 = @inferred(modularity(g, c))
        @test isapprox(Q1, 0.3673469387755103, atol=1e-3)

        Q2 = @inferred(modularity(barbell, c, γ=0.5))
        @test isapprox(Q2, 0.6122448979591837, atol=1e-3)
    end

    add_edge!(barbell, 4, 1)
    for g in test_generic_graphs(barbell)
        @test @inferred(modularity(g, c)) == 0.25
    end

    # 3. weighted test cases 
    # 3.1. undirected and weighted test cases

    # the "handle" of the barbell 3--4 gets a weight of 5
    barbell = barbell_graph(3, 3)
    c = [1, 1, 1, 2, 2, 2]
    d = [
        [0 1 1 0 0 0]
        [1 0 1 0 0 0]
        [1 1 0 5 0 0]
        [0 0 5 0 1 1]
        [0 0 0 1 0 1]
        [0 0 0 1 1 0]
    ]
    for g in test_generic_graphs(barbell)
        Q = @inferred(modularity(g, c, distmx=d))
        @test isapprox(Q, 0.045454545454545456, atol=1e-3)
    end
    # Add self loop with weight 5
    add_edge!(barbell, 1, 1)
    d = [
        [5 1 1 0 0 0]
        [1 0 1 0 0 0]
        [1 1 0 1 0 0]
        [0 0 1 0 1 1]
        [0 0 0 1 0 1]
        [0 0 0 1 1 0]
    ]
    for g in test_generic_graphs(barbell)
        Q = @inferred(modularity(g, c, distmx=d))
        @test isapprox(Q, 0.329861, atol=1e-3)
    end

    # 3.2. directed and weighted test cases
    triangle = SimpleDiGraph(3)
    add_edge!(triangle, 1, 2)
    add_edge!(triangle, 2, 3)
    add_edge!(triangle, 3, 1)

    barbell = blockdiag(triangle, triangle)
    add_edge!(barbell, 3, 4) # this edge has a weight of 5
    c = [1, 1, 1, 2, 2, 2]
    d = [
        [0 1 0 0 0 0]
        [0 0 1 0 0 0]
        [1 0 0 5 0 0]
        [0 0 0 0 1 0]
        [0 0 0 0 0 1]
        [0 0 0 1 0 0]
    ]
    for g in test_generic_graphs(barbell)
        Q = @inferred(modularity(g, c, distmx=d))
        @test isapprox(Q, 0.1487603305785124, atol=1e-3)
    end
    # Add self loop with weight 5
    add_edge!(barbell, 1, 1)
    d = [
        [5 1 0 0 0 0]
        [0 0 1 0 0 0]
        [1 0 0 1 0 0]
        [0 0 0 0 1 0]
        [0 0 0 0 0 1]
        [0 0 0 1 0 0]
    ]
    for g in test_generic_graphs(barbell)
        Q = @inferred(modularity(g, c, distmx=d))
        @test isapprox(Q, 0.333333333, atol=1e-3)
    end
end

# Adapted from SimpleGraphs.jl [Copyright (c) 2014, Ed Scheinerman]:
#    https://github.com/scheinerman/SimpleGraphs.jl/blob/master/src/simple_euler.jl
# Reproduced under the MIT Expat License.

"""
    eulerian(g::AbstractSimpleGraph{T}[, u::T]) --> T[]

Returns a [Eulerian trail or cycle](https://en.wikipedia.org/wiki/Eulerian_path) through an
undirected graph `g`, starting at vertex `u`, returning a vector listing the vertices of `g`
in the order that they are traversed. If no such trail or cycle exists, throws an error.

A Eulerian trail or cycle is a path that visits every edge of `g` exactly once; for a
cycle, the path starts _and_ ends at vertex `u`.

## Optional arguments
- If `u` is omitted, a Eulerian trail or cycle is computed with `u = first(vertices(g))`.
"""
function eulerian(g::AbstractGraph{T}, u::T=first(vertices(g))) where {T}
    is_directed(g) && error("`eulerian` is not yet implemented for directed graphs")

    _check_eulerian_input(g, u) # perform basic sanity checks

    g′ = SimpleGraph{T}(nv(g)) # copy `g` (mutated in `_eulerian!`)
    for e in edges(g)
        add_edge!(g′, src(e), dst(e))
    end

    return _eulerian!(g′, u)
end

@traitfn function _eulerian!(g::AG::(!IsDirected), u::T) where {T,AG<:AbstractGraph{T}}
    # TODO: This uses Fleury's algorithm which is O(|E|²) in the number of edges |E|.
    #       Hierholzer's algorithm [https://en.wikipedia.org/wiki/Eulerian_path#Hierholzer's_algorithm]
    #       is presumably faster, running in O(|E|) time, but requires needing to keep track
    #       of visited/nonvisited sites in a doubly-linked list/deque.
    trail = T[]

    nverts = nv(g)
    while true
        # if last vertex
        if nverts == 1
            push!(trail, u)
            return trail
        end

        Nu = neighbors(g, u)
        if length(Nu) == 1
            # if only one neighbor, delete and move on
            w = first(Nu)
            rem_edge!(g, u, w)
            nverts -= 1
            push!(trail, u)
            u = w
        elseif length(Nu) == 0
            error("graph is not connected: a eulerian cycle/trail does not exist")
        else
            # otherwise, pick whichever neighbor is not a bridge/cut-edge
            bs = bridges(g)
            for w in Nu
                if all(e -> _excludes_edge(u, w, e), bs)
                    # not a bridge/cut-edge; add to trail
                    rem_edge!(g, u, w)
                    push!(trail, u)
                    u = w
                    break
                end
            end
        end
    end
    return error("unreachable reached")
end

@inline function _excludes_edge(u, w, e::AbstractEdge)
    # `true` if `e` is not `Edge(u,w)` or `Edge(w,u)`, otherwise `false`
    s, d = src(e), dst(e)
    return !((u == s && w == d) || (u == d && w == s))
end

function _check_eulerian_input(g, u)
    if !has_vertex(g, u)
        error("starting vertex is not in the graph")
    end

    # special case: if any vertex has degree zero
    if any(x -> degree(g, x) == 0, vertices(g))
        error("some vertices have degree zero (are isolated) and cannot be reached")
    end

    # vertex degree checks
    du = degree(g, u)
    if iseven(du)     # cycle: start (u) == stop (v) - all nodes must have even degree
        if any(x -> isodd(degree(g, x)), vertices(g))
            error(
                "starting vertex has even degree but there are other vertices with odd degree: a eulerian cycle does not exist",
            )
        end
    else # isodd(du)  # trail: start (u) != stop (v) - all nodes, except u and v, must have even degree
        if count(x -> isodd(degree(g, x)), vertices(g)) != 2
            error(
                "starting vertex has odd degree but the total number of vertices of odd degree is not equal to 2: a eulerian trail does not exist",
            )
        end
    end

    # to reduce cost, the graph connectivity check is performed in `_eulerian!` rather
    # than through `is_connected(g)`
end

@testset "Parallel.Dijkstra" for parallel in [:threads, :distributed]
    g4 = path_digraph(5)
    d1 = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])
    d2 = sparse(float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0]))
    # Testing multisource On undirected Graph
    g3 = path_graph(5)
    d = [0 1 2 3 4; 1 0 1 0 1; 2 1 0 11 12; 3 0 11 0 5; 4 1 19 5 0]

    for g in testgraphs(g3)
        z = floyd_warshall_shortest_paths(g, d)
        zp = @inferred(Parallel.dijkstra_shortest_paths(g, collect(1:5), d; parallel))
        @test all(isapprox(z.dists, zp.dists))

        for i in 1:5
            state = Graphs.dijkstra_shortest_paths(g, i; allpaths=true)
            for j in 1:5
                if zp.parents[i, j] != 0
                    @test zp.parents[i, j] in state.predecessors[j]
                end
            end
        end

        z = floyd_warshall_shortest_paths(g)
        zp = @inferred(Parallel.dijkstra_shortest_paths(g; parallel))
        @test all(isapprox(z.dists, zp.dists))

        for i in 1:5
            state = Graphs.dijkstra_shortest_paths(g, i; allpaths=true)
            for j in 1:5
                if zp.parents[i, j] != 0
                    @test zp.parents[i, j] in state.predecessors[j]
                end
            end
        end

        z = floyd_warshall_shortest_paths(g)
        zp = @inferred(Parallel.dijkstra_shortest_paths(g, [1, 2]; parallel))
        @test all(isapprox(z.dists[1:2, :], zp.dists))

        for i in 1:2
            state = Graphs.dijkstra_shortest_paths(g, i; allpaths=true)
            for j in 1:5
                if zp.parents[i, j] != 0
                    @test zp.parents[i, j] in state.predecessors[j]
                end
            end
        end
    end

    # Testing multisource On directed Graph
    g3 = path_digraph(5)
    d = float([0 1 2 3 4; 5 0 6 7 8; 9 10 0 11 12; 13 14 15 0 16; 17 18 19 20 0])

    # An error should be reported if the parallel mode could not be understood
    @test_throws ArgumentError Parallel.dijkstra_shortest_paths(
        testdigraphs(g3)[1], collect(1:5), d; parallel=:thread
    )
    @test_throws ArgumentError Parallel.dijkstra_shortest_paths(
        testdigraphs(g3)[1], collect(1:5), d; parallel=:distriibuted
    )

    for g in testdigraphs(g3)
        z = floyd_warshall_shortest_paths(g, d)
        zp = @inferred(Parallel.dijkstra_shortest_paths(g, collect(1:5), d; parallel))
        @test all(isapprox(z.dists, zp.dists))

        for i in 1:5
            state = Graphs.dijkstra_shortest_paths(g, i; allpaths=true)
            for j in 1:5
                if z.parents[i, j] != 0
                    @test zp.parents[i, j] in state.predecessors[j]
                end
            end
        end

        z = floyd_warshall_shortest_paths(g)
        zp = @inferred(Parallel.dijkstra_shortest_paths(g; parallel))
        @test all(isapprox(z.dists, zp.dists))

        for i in 1:5
            state = Graphs.dijkstra_shortest_paths(g, i; allpaths=true)
            for j in 1:5
                if zp.parents[i, j] != 0
                    @test zp.parents[i, j] in state.predecessors[j]
                end
            end
        end

        z = floyd_warshall_shortest_paths(g)
        zp = @inferred(Parallel.dijkstra_shortest_paths(g, [1, 2]; parallel))
        @test all(isapprox(z.dists[1:2, :], zp.dists))

        for i in 1:2
            state = Graphs.dijkstra_shortest_paths(g, i; allpaths=true)
            for j in 1:5
                if zp.parents[i, j] != 0
                    @test zp.parents[i, j] in state.predecessors[j]
                end
            end
        end
    end
end

@testset "Parallel.Stress" begin
    rng = StableRNG(1)
    gint = loadgraph(joinpath(testdir, "testdata", "graph-50-500.jgz"), "graph-50-500")
    c = vec(readdlm(joinpath(testdir, "testdata", "graph-50-500-sc.txt"), ','))
    for g in testdigraphs(gint)
        z = Graphs.stress_centrality(g)
        zd = @inferred(Parallel.stress_centrality(g; parallel=:distributed))
        @test z == zd == c
        zt = @inferred(Parallel.stress_centrality(g; parallel=:threads))
        @test z == zt == c

        xd = Parallel.stress_centrality(g, 3; parallel=:distributed, rng=rng)
        @test length(xd) == 50
        xt = Parallel.stress_centrality(g, 3; parallel=:threads, rng=rng)
        @test length(xt) == 50

        xd2 = Parallel.stress_centrality(g, collect(1:20); parallel=:distributed)
        @test length(xd2) == 50
        xt2 = Parallel.stress_centrality(g, collect(1:20); parallel=:threads)
        @test length(xt2) == 50
    end

    g1 = cycle_graph(4)
    add_vertex!(g1)
    add_edge!(g1, 4, 5)

    for g in testgraphs(g1)
        zd = Parallel.stress_centrality(g; parallel=:distributed)
        @test zd == [4, 2, 4, 10, 0]
        zt = Parallel.stress_centrality(g; parallel=:threads)
        @test zt == [4, 2, 4, 10, 0]
    end
end

# Biconnected graphs

_Graphs.jl_ contains several algorithms to study [biconnectivity](https://en.wikipedia.org/wiki/Biconnected_graph).

## Index

```@index
Pages = ["biconnectivity.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "biconnectivity/articulation.jl",
    "biconnectivity/biconnect.jl",
    "biconnectivity/bridge.jl",
]

```

# Directed graphs

*Graphs.jl* includes some algorithms that are specific to directed graphs.

## Index

```@index
Pages = ["digraph.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "digraph/transitivity.jl",
]

```

# Shortest paths

*Graphs.jl* includes standard algorithms for [shortest paths](https://en.wikipedia.org/wiki/Shortest_path_problem) and longest paths.

## Index

```@index
Pages = ["shortestpaths.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "shortestpaths/astar.jl",
    "shortestpaths/bellman-ford.jl",
    "shortestpaths/desopo-pape.jl",
    "shortestpaths/dijkstra.jl",
    "shortestpaths/floyd-warshall.jl",
    "shortestpaths/johnson.jl",
    "shortestpaths/longest_path.jl",
    "shortestpaths/spfa.jl",
    "shortestpaths/yen.jl",
]

```

# Iterators

_Graphs.jl_ includes various routines for iterating through graphs.

## Index

```@index
Pages = ["iterators.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages   = [
    "iterators/iterators.jl",
    "iterators/bfs.jl",
    "iterators/dfs.jl",
]
Private = false
```

The following names are internals, not part of the public API:

```@autodocs
Modules = [Graphs]
Pages   = [
    "iterators/iterators.jl",
    "iterators/bfs.jl",
    "iterators/dfs.jl",
]
Public = false
```

# Traversals and coloring

_Graphs.jl_ includes various routines for exploring graphs.

## Index

```@index
Pages = ["traversals.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages   = [
    "traversals/bfs.jl",
    "traversals/bipartition.jl",
    "traversals/dfs.jl",
    "traversals/diffusion.jl",
    "traversals/greedy_color.jl",
    "traversals/maxadjvisit.jl",
    "traversals/randomwalks.jl",
    "traversals/eulerian.jl",
    "traversals/all_simple_paths.jl",
]
```

# Connected components

*Graphs.jl* includes several functions dealing with [connected components](https://en.wikipedia.org/wiki/Component_(graph_theory)).

## Index

```@index
Pages = ["connectivity.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "connectivity.jl",
]

```

# Graph plotting

_Graphs.jl_ integrates with several other Julia packages for plotting. Here are a few examples.

## [TikzGraphs.jl](https://github.com/sisl/TikzGraphs.jl)

Another nice graph visualization package. ([TikzPictures.jl](https://github.com/sisl/TikzPictures.jl) required to render/save):

```julia
julia> g = wheel_graph(10); t = plot(g)

julia> save(SVG("wheel10.svg"), t)
```

producing a graph like this:

![Wheel Graph](https://cloud.githubusercontent.com/assets/941359/8960499/17f703c0-35c5-11e5-935e-044be51bc531.png)

## [GraphPlot.jl](https://github.com/afternone/GraphPlot.jl)

Another graph visualization package that is very simple to use. [Compose.jl](https://github.com/dcjones/Compose.jl) is required for most rendering functionality:

```julia
julia> using GraphPlot, Compose

julia> g = wheel_graph(10)

julia> draw(PNG("/tmp/wheel10.png", 16cm, 16cm), gplot(g))
```

## [SGtSNEpi.jl](https://github.com/fcdimitr/SGtSNEpi.jl)

SGtSNEpi.jl is a high-performance software for swift embedding of a large, sparse graph into a d-dimensional space (d = 1,2,3). The [Makie](http://makie.juliaplots.org) plotting ecosystem is used for interactive plots.

```julia
using GLMakie, SGtSNEpi, SNAPDatasets

GLMakie.activate!()

g = loadsnap(:as_caida)
y = sgtsnepi(g);
show_embedding(y;
  A = adjacency_matrix(g),        # show edges on embedding
  mrk_size = 1,                   # control node sizes
  lwd_in = 0.01, lwd_out = 0.001, # control edge widths
  edge_alpha = 0.03 )             # control edge transparency
```

The above code produces the following output:

![alt tag](https://github.com/fcdimitr/SGtSNEpi.jl/raw/master/docs/src/assets/as_caida.png)

SGtSNEpi.jl enables 3D graph embedding as well. The 3D embedding of the weighted undirected graph [ML_Graph/optdigits_10NN](https://sparse.tamu.edu/ML_Graph/optdigits_10NN) is shown below. It consists of 26,475 nodes and 53,381 edges. Nodes are colored according to labels provided with the dataset.

![alt tag](https://fcdimitr.github.io/SGtSNEpi.jl/v0.1.0/sgtsnepi-animation.gif)

## [GraphRecipes.jl](https://github.com/JuliaPlots/GraphRecipes.jl)

GraphRecipes.jl contains several recipes for plotting networks using the Plots.jl ecosystem. There are a lot of different recipes and styles to choose from, check out the [examples page](https://docs.juliaplots.org/stable/GraphRecipes/examples/) to see more of them.

```julia
using Plots, GraphRecipes
g = wheel_graph(10)
graphplot(g, curves=false)
```

![wheel graph with GraphRecipes.jl](https://user-images.githubusercontent.com/8610352/74631053-de196b80-51c0-11ea-8cba-ddbdc2c6312f.png)

## [GraphMakie.jl](https://github.com/JuliaPlots/GraphMakie.jl)

GraphMakie.jl is a graph plotting recipe for the Makie.jl ecosystem. It uses [NetworkLayout.jl](https://github.com/JuliaGraphs/NetworkLayout.jl) for the node placement and supports 2D and 3D plots. Check out the [docs](http://juliaplots.org/GraphMakie.jl/stable/) for more examples and tutorials.

```julia
using GLMakie, GraphMakie
using GraphMakie.NetworkLayout

g = smallgraph(:dodecahedral)
graphplot(g; layout=Stress(; dim=3))
```

![GraphMakie example plot](https://user-images.githubusercontent.com/35867212/133593687-b92b8af9-7bf1-4c43-999b-e2847edb869d.png)

## [Karnak.jl](https://github.com/cormullion/Karnak.jl)

The Karnak.jl package integrates the
[Luxor.jl](https://github.com/JuliaGraphics/Luxor.jl) 2D graphics package, and uses
[NetworkLayout.jl](https://github.com/JuliaGraphs/NetworkLayout.jl) for
calculating layouts. Check out the [docs](https://cormullion.github.io/Karnak.jl/stable/) for examples.

```julia
using Graphs
using Karnak
using NetworkLayout
using Colors
g = barabasi_albert(60, 1)
@drawsvg begin
    background("black")
    sethue("grey40")
    fontsize(8)
    drawgraph(g, 
        layout=stress, 
        vertexlabels = 1:nv(g),
        vertexfillcolors = 
            [RGB(rand(3)/2...) 
               for i in 1:nv(g)]
    )
end 600 400
```

![Karnak.jl example plot](../assets/karnak-example.svg)

# Graph views formats

*Graphs.jl* provides views around directed graphs. 
`ReverseGraph` is a graph view that wraps a directed graph and reverse the direction of every edge.
`UndirectedGraph` is a graph view that wraps a directed graph and consider every edge as undirected.

## Index

```@index
Pages = ["wrappedgraphs.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "wrappedGraphs/graphviews.jl",
]

```

# Reading and writing files

*Graphs.jl* includes functions for working with graphs stored in various file formats/

## Index

```@index
Pages = ["persistence.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = ["persistence/common.jl", "persistence/lg.jl"]

```

# Generators for common graphs

*Graphs.jl* defines generators for various families of deterministic and random graphs.

## Index

```@index
Pages = ["simplegraphs_generators.md"]
```

## Full docs

```@autodocs
Modules = [Graphs.SimpleGraphs]
Pages = [
    "SimpleGraphs/generators/euclideangraphs.jl",
    "SimpleGraphs/generators/randgraphs.jl",
    "SimpleGraphs/generators/smallgraphs.jl",
    "SimpleGraphs/generators/staticgraphs.jl",
]

```

# Creating your own graph format

This section is designed to guide developers who wish to write their own graph structures.

All Graphs.jl functions rely on a standard API to function. As long as your graph structure is a subtype of [`AbstractGraph`](@ref) and implements the following API functions with the given return values, all functions within the Graphs.jl package should just work:

- [`edges`](@ref)
- [`edgetype`](@ref) (example: `edgetype(g::CustomGraph) = Graphs.SimpleEdge{eltype(g)})`)
- [`has_edge`](@ref)
- [`has_vertex`](@ref)
- [`inneighbors`](@ref)
- [`ne`](@ref)
- [`nv`](@ref)
- [`outneighbors`](@ref)
- [`vertices`](@ref)
- [`is_directed`](@ref): Note that since Graphs uses traits to determine directedness, `is_directed` for a `CustomGraph` type should be implemented with **both** of the following signatures:
  - `is_directed(::Type{CustomGraph})::Bool` (example: `is_directed(::Type{<:CustomGraph}) = false`)
  - `is_directed(g::CustomGraph)::Bool`

If the graph structure is designed to represent weights on edges, the [`weights`](@ref) function should also be defined. Note that the output does not necessarily have to be a dense matrix, but it must be a subtype of `AbstractMatrix{<:Real}` and indexable via `[u, v]`.

**Note on inheriting from AbstractSimpleGraph**

Every subtype of `AbstractSimpleGraph` must have vertices forming a `UnitRange` starting from 1 and return `neighbors` in ascending order. The extend to which code for graph types other than subtypes of `AbstractSimpleGraph` does not rely on `AbstractSimpleGraph` assumptions needs to be carefully checked, though in principle the requirement is only part of the `AbstractSimpleGraph` API.

# Test graphs

`Graphs.Test` is a module containing generic graph structures which make as few hypotheses as possible beyond the basic interface.
It is not part of the public API and may break unexpectedly.

## Index

```@index
Pages = ["test.md"]
```

## Full docs

```@autodocs
Modules = [Graphs.Test]
```

# Cycles

_Graphs.jl_ contains numerous algorithms related to [cycles](https://en.wikipedia.org/wiki/Cycle_(graph_theory)).

## Index

```@index
Pages = ["cycles.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "cycles/basis.jl",
    "cycles/hawick-james.jl",
    "cycles/incremental.jl",
    "cycles/johnson.jl",
    "cycles/karp.jl",
    "cycles/limited_length.jl",
]

```

# Graph construction

_Graphs.jl_ provides a number of methods for creating a graph. These include tools for building and modifying graph objects, a wide array of graph generator functions, and the ability to read and write graphs from files (using [GraphIO.jl](https://github.com/JuliaGraphs/GraphIO.jl)).

## Creating graphs

### Standard generators

_Graphs.jl_ implements numerous graph generators, including random graph generators, constructors for classic graphs, numerous small graphs with familiar topologies, and random and static graphs embedded in Euclidean space. An empty simple Graph can be constructed using `g = SimpleGraph()` and similary `g = SimpleDiGraph()` for directed graphs.
See [Generators for common graphs](@ref) for a complete list of available templates.

### Datasets

Other notorious graphs and integration with the `MatrixDepot.jl` package are available in the `Datasets` submodule of the companion package [LightGraphsExtras.jl](https://github.com/JuliaGraphs/LightGraphsExtras.jl).
Selected graphs from the [Stanford Large Network Dataset Collection](https://snap.stanford.edu/data/index.html) may be found in the [SNAPDatasets.jl](https://github.com/JuliaGraphs/SNAPDatasets.jl) package.


## Modifying graphs

Starting from a (possibly empty) graph `g`, one can modify it using the following functions:

- `add_vertex!(g)` adds one vertex to `g`
- `add_vertices!(g, n)` adds `n` vertices to `g`
- `add_edge!(g, s, d)` adds the edge `(s, d)` to `g`
- `rem_vertex!(g, v)` removes vertex `v` from `g`
- `rem_edge!(g, s, d)` removes edge `(s, d)` from `g`

If an iterator of edges `edgelist` is available, then one can directly use `SimpleGraphFromIterator(edgelist)` or `SimpleDiGraphFromIterator(edgelist)`.

In addition to these core functions, more advanced operators can be found in [Operators](@ref).

# Steiner tree

_Graphs.jl_ provides some functionalities related to [Steiner Trees](https://en.wikipedia.org/wiki/Steiner_tree_problem#Approximating_the_Steiner_tree).

## Index

```@index
Pages = ["steinertree.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "steinertree/steiner_tree.jl",
]

```

# Reading and writing graphs

## Saving using custom `LG` format.

Graphs may be written to I/O streams and files using the [`savegraph`](@ref) function, and they can be read with the [`loadgraph`](@ref) function. The default graph format is a bespoke compressed format called `LG`, defined by *Graphs.jl*.

### Example

```julia

g = erdos_renyi(5, 0.2)

savegraph("mygraph.lgz", g)
reloaded_g = loadgraph("mygraph.lgz")
```

In addition, graphs can also be saved in an uncompressed format using the `compress=false` option.

```julia

savegraph("mygraph.lg", g, compress=false)

reloaded_g = loadgraph("mygraph.lg")
```

Finally, dictionaries of graphs can also be saved and subsequently re-loaded one by one.

```julia
graph_dict = Dict("g1" => erdos_renyi(5, 0.1),
              "g2" => erdos_renyi(10, 0.2),
              "g3" => erdos_renyi(2, 0.9))

savegraph("mygraph_dict.lg", graph_dict)

# Re-load only graph g1
reloaded_g1 = loadgraph("mygraph_dict.lg", "g1")
```

## GraphIO for other formats

The [GraphIO.jl](https://github.com/JuliaGraphs/GraphIO.jl) library provides tools for importing and exporting graph objects using common file types like edgelists, GraphML, Pajek NET, and more.

# Graph algorithms

## Defined by Graphs.jl

_Graphs.jl_ provides a number of graph algorithms, including [Cuts](@ref), [Cycles](@ref), and [Trees](@ref), among many others. The algorithms work on any graph type that conforms to the _Graphs.jl_ API.

## External algorithm packages

Several other packages implement additional graph algorithms:

- [GraphsColoring.jl](https://github.com/JuliaGraphs/GraphsColoring.jl) provides algorithms for graph coloring, _i.e._, assigning colors to vertices such that no two neighboring vertices have the same color.
- [GraphsFlows.jl](https://github.com/JuliaGraphs/GraphsFlows.jl) provides algorithms for graph flows.
- [GraphsMatching.jl](https://github.com/JuliaGraphs/GraphsMatching.jl) provides algorithms for matchings on weighted graphs.
- [GraphsOptim.jl](https://github.com/JuliaGraphs/GraphsOptim.jl) provides algorithms for graph optimization that rely on mathematical programming.

## Interfaces to other graph libraries

Several packages make established graph libraries written in other languages accessible from within Julia and the _Graphs.jl_ ecosystem:

- [IGraphs.jl](https://github.com/JuliaGraphs/IGraphs.jl) is a thin Julia wrapper around the C graphs library [igraph](https://igraph.org).
- [NautyGraphs.jl](https://github.com/JuliaGraphs/NautyGraphs.jl) provides graph structures compatible with the graph isomorphism library [_nauty_](https://pallini.di.uniroma1.it), allowing for efficient isomorphism checking and canonization, as well as computing the properties of graph automorphism groups.

## Dispatching to algorithm implementations in external packages

Apart from providing additional graph types and algorithms, many packages extend existing functions in _Graphs.jl_ with new backends. This can make it easier to use the algorithms from within _Graphs.jl_.

For example, _NautyGraphs.jl_ provides a new backend for graph isomorphism calculations:

```jldoctest
julia> using Graphs, NautyGraphs

julia> g = star_graph(5)
{5, 4} undirected simple Int64 graph

julia> Graphs.Experimental.has_isomorph(g, g, NautyAlg())
true
```

Here, dispatching via `NautyAlg()` implicitly converts `g` to a _nauty_-compatible format and uses _nauty_ for the isomorphism computation.

### Functions extended by IGraphs.jl

A list of functions extended by _IGraphs.jl_ can be obtained with

```@example
import IGraphs
IGraphs.igraphalg_methods()
```

### Functions extended by NautyGraphs.jl

A list of functions extended by _NautyGraphs.jl_ can be obtained with

```@example
import NautyGraphs
NautyGraphs.nautyalg_methods()
```

# Centrality measures

*Graphs.jl* implements various [centrality measures](https://en.wikipedia.org/wiki/Centrality), which describe the importance of a vertex to the rest of the graph.

## Index

```@index
Pages   = ["centrality.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages   = [
    "centrality/betweenness.jl",
    "centrality/closeness.jl",
    "centrality/degree.jl",
    "centrality/eigenvector.jl",
    "centrality/katz.jl",
    "centrality/pagerank.jl",
    "centrality/radiality.jl",
    "centrality/stress.jl",
]

```

# Dominating sets

_Graphs.jl_ implements functions for [dominating sets](https://en.wikipedia.org/wiki/Dominating_set).

## Index

```@index
Pages = ["dominatingset.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "dominatingset/degree_dom_set.jl",
    "dominatingset/minimal_dom_set.jl",
]

```

# Spanning trees

_Graphs.jl_ contains a few algorithms to compute [minimum spanning trees](https://en.wikipedia.org/wiki/Minimum_spanning_tree).

## Index

```@index
Pages = ["spanningtrees.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "spanningtrees/boruvka.jl",
    "spanningtrees/kruskal.jl",
    "spanningtrees/prim.jl",
    "planarity.jl",
    "spanningtrees/planar_maximally_filtered_graph.jl",
]

```

# Graph types

## Defined by Graphs.jl

_Graphs.jl_ provides two concrete graph types: [`SimpleGraph`](@ref) is an undirected graph, and [`SimpleDiGraph`](@ref) is its directed counterpart. Both of these types can be parameterized to specify how vertices are identified (by default, `SimpleGraph` and `SimpleDiGraph` use the system default integer type, usually `Int64`).

A graph _G_ is described by a set of vertices _V_ and edges _E_: _G = {V, E}_. _V_ is an integer range `1:n`; _E_ is represented using forward (and, for directed graphs, backward) adjacency lists indexed by vertices. Edges may also be accessed via an iterator that yields `Edge` types containing `(src<:Integer, dst<:Integer)` values. Both vertices and edges may be integers of any type, and the smallest type that fits the data is recommended in order to save memory.

Graphs are created using `SimpleGraph()` or `SimpleDiGraph()`, see [Graph construction](@ref) for details.

Multiple edges between two given vertices are not allowed: an attempt to add an edge that already exists in a graph will not raise an error. This event can be detected using the return value of [`add_edge!`](@ref).

Note that graphs in which the number of vertices equals or approaches the `typemax` of the underlying graph element (_e.g._, a `SimpleGraph{UInt8}` with 127 vertices) may encounter arithmetic overflow errors in some functions, which should be reported as bugs. To be safe, please ensure that your graph is sized with some capacity to spare.

## Available in the wider ecosystem

In addition to providing `SimpleGraph` and `SimpleDiGraph` implementations, _Graphs.jl_ also serves as an interface for custom graph types (see [AbstractGraph interface](@ref)).

Currently, several other packages implement alternative graph types:

- [SimpleWeightedGraphs.jl](https://github.com/JuliaGraphs/SimpleWeightedGraphs.jl) provides a structure for (un)directed graphs with the ability to specify weights on edges.
- [MetaGraphs.jl](https://github.com/JuliaGraphs/MetaGraphs.jl) provides a structure for (un)directed graphs that supports user-defined properties on the graph, vertices, and edges.
- [MetaGraphsNext.jl](https://github.com/JuliaGraphs/MetaGraphsNext.jl) does the same but in a type-stable manner, and with a slightly different interface.
- [StaticGraphs.jl](https://github.com/JuliaGraphs/StaticGraphs.jl) supports very large graph structures in a space- and time-efficient manner, but as the name implies, does not allow modification of the graph once created.

## Which graph type should I use?

These are general guidelines to help you select the proper graph type.

- In general, prefer the native `SimpleGraphs`/`SimpleDiGraphs` structures in _Graphs.jl_.
- If you need edge weights and don't require large numbers of graph modifications, use _SimpleWeightedGraphs.jl_.
- If you need labeling of vertices or edges, use _MetaGraphs.jl_ or _MetaGraphsNext.jl_.
- If you work with very large graphs (billions to tens of billions of edges) and don't need mutability, use _StaticGraphs.jl_.

# Cuts

*Graphs.jl* implements several algorithms for [graph cuts](https://en.wikipedia.org/wiki/Cut_(graph_theory)).

## Index

```@index
Pages = ["cut.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "graphcut/karger_min_cut.jl",
    "graphcut/normalized_cut.jl",
]

```

# Contributor Guide

We welcome all possible contributors and ask that you read these guidelines before starting to work on this project.
Following these guidelines will reduce friction and improve the speed at which your code gets merged.

A general set of rules that we try to follow can be found at [SciML/ColPrac](https://github.com/SciML/ColPrac).
Here are a few more specific recommendations.

## Bug reports

If you notice code that crashes, is incorrect, or is too slow, please file a bug report. The report should be raised as a GitHub issue with a minimal working example that reproduces the condition.
The example should include any data needed. If the problem is incorrectness, then please post the correct result along with an incorrect result.

Please include version numbers of all relevant libraries and Julia itself.

## Development guidelines

Here are a few principles to keep in mind when writing a Pull Request (PR).

### Correctness

- Correctness is a necessary requirement. Add tests to make sure that any new function displays the right behavior.
- Since Graphs.jl supports multiple implementations of the graph data structure using the `AbstractGraph` [type](https://juliagraphs.github.io/Graphs.jl/latest/types.html#AbstractGraph-Type-1), you should refrain from using the internal fields of structs such as `fadjlist`. Instead, you should use the functions provided in the API. Code that is instrumental to defining a concrete graph type can use the internal structure of that type.
- Put type assertions on all function arguments where conflict may arise (use abstract types, `Union`, or `Any` if necessary).
- Take steps to ensure that code works correctly and efficiently on edge cases (disconnected graphs, empty graphs, ...).
- We can accept code that does not work for directed graphs as long as it comes with an explanation of what it would take to make it work for directed graphs.

### Style

- Write your code using Invenia's [BlueStyle](https://github.com/invenia/BlueStyle)
- Format it with [JuliaFormatter](https://github.com/domluna/JuliaFormatter.jl) before pushing

### Efficiency

- Once you have a correct implementation, make a PR so we can help improve performance.
- Minimize dependencies on external packages, and avoid introducing new dependencies that would increase the compilation time by a lot.
- Write code to reuse memory wherever possible. For example:

```julia
function f(g, v)
    storage = Vector{Int}(undef, nv(g))
    # some code operating on storage, g, and v.
    for i in 1:nv(g)
        storage[i] = v-i
    end
    return sum(storage)
end
```

should be rewritten as two functions

```julia
function f(g::AbstractGraph, v::Integer)
    storage = Vector{Int}(undef, nv(g))
    return f!(g, v, storage)
end

function f!(g::AbstractGraph, v::Integer, storage::AbstractVector{Int})
    # some code operating on storage, g, and v.
    for i in 1:nv(g)
        storage[i] = v-i
    end
    return sum(storage)
end
```

This gives users the option of reusing memory and improving performance.

### Misc

- If the algorithm was presented in a paper, include a reference to the paper (_e.g._, a proper academic citation along with an eprint link).

## Git(Hub) usage

### Getting started on a package contribution

In order to make it easier for you to contribute and review PRs, it would be better to be familiar with Git fundamentals.
Most importantly:

- clone the repository from JuliaGraphs/Graphs.jl
- fork the repository on your own GitHub account
- make the modification to the repository, test and document all your changes
- push to the fork you created
- open a PR.

See the [JuMP documentation](https://jump.dev/JuMP.jl/dev/developers/contributing/) for a more detailed guide.

### PR hygiene

- PRs should contain one logical enhancement to the codebase.
- Squash commits in a PR.
- If you want to introduce a new feature, open an issue to discuss a feature before you start coding (this maximizes the likelihood of patch acceptance).

### Advanced: visualize opened PRs locally

In order to make it easier for you to review PRs, you can add this to your git config file, which should be located at `PACKAGE_LOCATION/.git/config`, where `PACKAGE_LOCATION` is where the Graphs.jl was cloned.
If you added the package with the `] dev` command, it is likely at `$HOME/.julia/dev/Graphs`.

These instructions were taken from [this gist](https://gist.github.com/piscisaureus/3342247).

Locate the section for your GitHub remote in the `.git/config` file. It looks like this:

```
[remote "origin"]
    fetch = +refs/heads/*:refs/remotes/origin/*
    url = git@github.com:JuliaGraphs/Graphs.jl.git
```

Now add the line `fetch = +refs/pull/*/head:refs/remotes/origin/pr/*` to this section. Obviously, change the GitHub URL to match your project's URL. It ends up looking like this:

```
[remote "origin"]
    fetch = +refs/heads/*:refs/remotes/origin/*
    url = git@github.com:JuliaGraphs/Graphs.jl.git
    fetch = +refs/pull/*/head:refs/remotes/origin/pr/*
```

Now fetch all the PRs:

```
$ git fetch origin
From github.com:JuliaGraphs/Graphs.jl
 * [new ref]         refs/pull/1000/head -> origin/pr/1000
 * [new ref]         refs/pull/1002/head -> origin/pr/1002
 * [new ref]         refs/pull/1004/head -> origin/pr/1004
 * [new ref]         refs/pull/1009/head -> origin/pr/1009
...
```

To check out a particular PR:

```
$ git checkout pr/999
Branch pr/999 set up to track remote branch pr/999 from origin.
Switched to a new branch 'pr/999'
```

Now you can test a PR by running `git fetch && git checkout pr/PRNUMBER && julia -e 'using Pkg; Pkg.test("Graphs")'`

# Edit distance

_Graphs.jl_ allows computation of the [graph edit distance](https://en.wikipedia.org/wiki/Graph_edit_distance).

## Index

```@index
Pages = ["editdist.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = ["editdist.jl"]
```

# Graph access

The following is an overview of functions for accessing graph properties.

## Global graph properties

- `nv(g)` returns the number of vertices in `g`.
- `ne(g)` returns the number of edges in `g`.
- `vertices(g)` returns an iterable object containing all the vertices in `g`.
- `edges(g)` returns an iterable object containing all the edges in `g`.
- `has_vertex(g, v)` checks whether graph `g` includes a vertex numbered `v`.
- `has_edge(g, s, d)` checks whether graph `g` includes an edge from the source vertex `s` to the destination vertex `d`.
- `has_edge(g, e)` returns true if there is an edge in g that satisfies `e == f` for any `f ∈ edges(g)`. This is a strict equality test that may require all properties of `e` are the same. This definition of equality depends on the implementation. For testing whether an edge exists between two vertices `s,d` use `has_edge(g, s, d)`. Note: to use the `has_edge(g, e)` method safely, it is important to understand the conditions under which edges are equal to each other. These conditions are defined by the `has_edge(g::G,e)` method **as defined** by the graph type `G`. The default behavior is to check `has_edge(g,src(e),dst(e))`. This distinction exists to allow new graph types such as MetaGraphs or MultiGraphs to distinguish between edges with the same source and destination but potentially different properties.
- `has_self_loops(g)` checks for self-loops in `g`.
- `is_directed(g)` checks if `g` is a directed graph.
- `eltype(g)` returns the type of the vertices of `g`.

## Vertex properties

- `neighbors(g, v)` returns the neighbors of vertex `v` in an iterable (if `g` is directed, only outneighbors are returned).
- `all_neighbors(` returns all the neighbors of vertex `v` (if `g` is directed, both inneighbors and outneighbors are returned).
- `inneighbors` return the inneighbors of vertex `v` (equivalent to `neighbors` for undirected graphs).
- `outneighbors` returns the outneighbors of vertex `v` (equivalent to `neighbors` for undirected graphs).

## Edge properties

- `src(e)` gives the source vertex `s` of an edge `(s, d)`.
- `dst(e)` gives the destination vertex `d` of an edge `(s, d)`.
- `reverse(e)` creates a new edge `(d, s)` from edge `(s, d)`.

## Persistence of vertex indices
Adding a vertex to the graph with `add_vertex!(g)` adds it (if successful) to the end of the "vertex-list". Therefore, it is possible to access the index of the recently added vertex by using `nv(g)`:
```julia-repl
julia> g = SimpleGraph(10)
{10, 0} undirected simple Int64 graph

julia> add_vertex!(g)
true

julia> last_added_vertex = nv(g)
11
```
Note that this index is NOT persistent if vertices added earlier are removed. When `rem_vertex!(g, v)` is called, `v` is "switched" with the last vertex before being deleted. As edges are identified by vertex indices, one has to be careful with edges as well. An edge added as `add_edge!(g, 3, 11)` can not be expected to always pass the `has_edge(g, 3, 11)` check:
```julia-repl
julia> g = SimpleGraph(10)
{10, 0} undirected simple Int64 graph

julia> add_vertex!(g)
true

julia> add_edge!(g, 3, 11)
true

julia> g
{11, 1} undirected simple Int64 graph

julia> has_edge(g, 3, 11)
true

julia> rem_vertex!(g, 7)
true

julia> has_edge(g, 3, 11)
false

julia> has_edge(g, 3, 7)  # vertex number 11 "renamed" to vertex number 7
true
```

# Linear algebra

_Graphs.jl_ provides numerous matrix operations on both directed and undirected graphs, as part of the `LinAlg` submodule.

## Index

```@index
Pages   = ["linalg.md"]
```

## Full docs

```@autodocs
Modules = [Graphs.LinAlg]
Pages   = [
    "linalg/graphmatrices.jl",
    "linalg/LinAlg.jl",
    "linalg/nonbacktracking.jl",
    "linalg/spectral.jl"
]

```

# Degeneracy

*Graphs.jl* provides a few functions for [graph degeneracy](https://en.wikipedia.org/wiki/Degeneracy_(graph_theory)).

## Index

```@index
Pages = ["degeneracy.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages   = ["degeneracy.jl"]

```

# SimpleGraphs formats

*Graphs.jl* provides two basic graph formats based on adjacency lists, along with many other functions defined in the `Graphs.SimpleGraphs` submodule.

## Index

```@index
Pages = ["simplegraphs.md"]
```

## Full docs

```@autodocs
Modules = [Graphs.SimpleGraphs]
Pages = [
    "SimpleGraphs/simpledigraph.jl",
    "SimpleGraphs/simpleedge.jl",
    "SimpleGraphs/simpleedgeiter.jl",
    "SimpleGraphs/simplegraph.jl",
    "SimpleGraphs/SimpleGraphs.jl",
    "SimpleGraphs/specializations.jl",
]

```

# Vertex cover

*Graphs.jl* provides some algorithms to find [vertex covers](https://en.wikipedia.org/wiki/Vertex_cover).

## Index

```@index
Pages = ["vertexcover.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "vertexcover/degree_vertex_cover.jl",
    "vertexcover/random_vertex_cover.jl",
]

```

# Error handling

In an ideal world, all software would work perfectly all the time. However, in the real world software encounters errors due to the outside world, bad input, bugs, or programmer error.

## Types of errors

### Sentinel values

It is the position of this project that error conditions that happen often, typically due to bad data, should be handled with sentinel values returned to indicate the failure condition. These are used for functions such as `add_edge!(g, u, v)`. If you try to add an edge with negative vertex numbers, or vertices that exceed the number of vertices in the graph, then you will get a return value of `false`.

### Errors / exceptions

For more severe failures such as bad arguments or failure to converge, we use exceptions. The primary distinction between Sentinel Values and Argument Errors has to do with the run time of the function being called. In a function that is expected to be a called in a tight loop such as `add_edge!`, we will use a sentinel value rather than an exception. This is because it is faster to do a simple `if` statement to handle the error than a full `try/catch` block. For functions that take longer to run, we use Exceptions. If you find an exception with an error message that isn't helpful for debugging, please file a bug report so that we can improve these messages.

- `ArgumentError`: the inputs to this function are not valid
- `InexactError`: some types are used that cannot express a computed quantity with the necessary precision

# Trees

_Graphs.jl_ algorithms related to [trees](https://en.wikipedia.org/wiki/Tree_(graph_theory)).

## Index

```@index
Pages = ["trees.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "trees/prufer.jl",
]

```

# AbstractGraph interface

*Graphs.jl* defines the `AbstractGraph` interface for compatibility with external graph formats.

## Index

```@index
Pages   = ["interface.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages   = ["interface.jl"]

```

```@docs
zero(::Type{<:AbstractGraph})
```

# Paths and traversal

_Graphs.jl_ provides several traversal and shortest-path algorithms, along with various utility functions. Where appropriate, edge distances may be passed in as a matrix of real number values.

Edge distances for most traversals may be passed in as a sparse or dense matrix of values, indexed by `[src,dst]` vertices. That is, `distmx[2,4] = 2.5` assigns the distance `2.5` to the (directed) edge connecting vertex 2 and vertex 4. Note that for undirected graphs `distmx[4,2]` also has to be set.

Default edge distances may be passed in via the `Graphs.DefaultDistance` structure.

Any graph traversal will traverse an edge only if it is present in the graph. When a distance matrix is given:

1. distance values for undefined edges will be ignored;
2. any unassigned values (in sparse distance matrices) for edges that are present in the graph will be assumed to take the default value of 1.0;

## Graph traversal

Graph traversal refers to a process that traverses vertices of a graph following certain order (starting from user-input sources). This package implements three traversal schemes:

- `BreadthFirst`
- `DepthFirst`
- `MaximumAdjacency`

The package also includes uniform random walks and self avoiding walks with the following functions:

- `randomwalk`
- `non_backtracking_randomwalk`
- `self_avoiding_walk`

## Shortest paths

The following properties always hold for shortest path algorithms implemented here:

- The distance from a vertex to itself is always `0`.
- The distance between two vertices with no connecting edge is always `Inf` or `typemax(eltype(distmx))`.

The [`dijkstra_shortest_paths`](@ref), [`desopo_pape_shortest_paths`](@ref), [`floyd_warshall_shortest_paths`](@ref), [`bellman_ford_shortest_paths`](@ref), and [`yen_k_shortest_paths`](@ref) functions return _path states_ (subtypes of `Graphs.AbstractPathState`) that contain various information about the graph learned during traversal.

The corresponding state types (with the exception of `YenState`) have the following common fields:

- `state.dists` holds a vector with the distances computed, indexed by source vertex.
- `state.parents` holds a vector of parents of each vertex on the shortest paths (the parent of a source vertex is always `0`). `YenState` substitutes `.paths` for `.parents`.

In addition, with the appropriate optional arguments, [`dijkstra_shortest_paths`](@ref) will return information on all possible shortest paths available from the source.

## Utility functions

- Once a path state is found using a shortest path algorithm, some or all of the paths can be obtained using [`enumerate_paths`](@ref).
- A longest path within a directed acyclic graph can be found with [`dag_longest_path`](@ref).
- In the case of a graph with some edges having negative weights, the existence of a cycle whose edges sum to a negative value can be detected with [`has_negative_edge_cycle_spfa`](@ref).

# Community structures

_Graphs.jl_ contains several algorithms to detect and analyze [community structures](https://en.wikipedia.org/wiki/Community_structure).

## Index

```@index
Pages = ["community.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "community/assortativity.jl",
    "community/clique_percolation.jl",
    "community/cliques.jl",
    "community/clustering.jl",
    "community/core-periphery.jl",
    "community/label_propagation.jl",
    "community/modularity.jl",
    "community/rich_club.jl",
]

```

# Operators

_Graphs.jl_ implements the following graph operators. In general, functions with two graph arguments will require them to be of the same type (either both `SimpleGraph` or both `SimpleDiGraph`).

## Index

```@index
Pages = ["operators.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = ["operators.jl"]

```

# Parallel algorithms

`Graphs.Parallel` is a module for graph algorithms that are parallelized. Their names should be consistent with the serial versions in the main module. In order to use parallel versions of the algorithms you can write:

```julia
using Graphs
import Graphs.Parallel

g = path_graph(10)
bc = Parallel.betweenness_centrality(g)
```

## How to use them?

The arguments to parallel versions of functions match as closely as possible their serial versions with potential addition default or keyword arguments to control parallel execution. One exception is that for algorithms that cannot be meaningfully parallelized for certain types of arguments a MethodError will be raised. For example, `dijkstra_shortest_paths` works for either a single or multiple source argument, but since the parallel version is slower when given only a single source, it will raise a `MethodError`.

```julia
g = Graph(10)
# these work
Graphs.dijkstra_shortest_paths(g,1)
Graphs.dijkstra_shortest_paths(g, [1,2])
Parallel.dijkstra_shortest_paths(g, [1,2])
# this doesn't
Parallel.dijkstra_shortest_paths(g,1)
```

Note that after `import`ing or `using` `Graphs.Parallel`, you must fully qualify the version of the function you wish to use (using, _e.g._, `Graphs.betweenness_centrality(g)` for the sequential version and `Parallel.betweenness_centrality(g)` for the parallel version).

## Available parallel algorithms

The following is a current list of parallel algorithms:

- Centrality measures:

  - `Parallel.betweenness_centrality`
  - `Parallel.closeness_centrality`
  - `Parallel.pagerank`
  - `Parallel.radiality_centrality`
  - `Parallel.stress_centrality`

- Distance measures:

  - `Parallel.center`
  - `Parallel.diameter`
  - `Parallel.eccentricity`
  - `Parallel.radius`

- Shortest paths algorithms:

  - `Parallel.bellman_ford_shortest_paths`
  - `Parallel.dijkstra_shortest_paths`
  - `Parallel.floyd_warshall_shortest_paths`
  - `Paralell.johnson_shortest_paths`

- Traversal algorithms:
  - `Parallel.bfs`
  - `Parallel.greedy_color`

Also note that in some cases, the arguments for the parallel versions may differ from the serial (standard) versions. As an example, parallel Dijkstra shortest paths takes advantage of multiple processors to execute centrality from multiple source vertices. It is an error to pass a single source vertex into the parallel version of dijkstra_shortest_paths.

## Index

```@index
Pages = ["parallel.md"]
```

## Full docs

```@autodocs
Modules = [Graphs, Graphs.Parallel]
Pages = [
    "Parallel/Parallel.jl",
    "Parallel/utils.jl",
    "Parallel/distance.jl",
    "Parallel/centrality/betweenness.jl",
    "Parallel/centrality/closeness.jl",
    "Parallel/centrality/pagerank.jl",
    "Parallel/centrality/radiality.jl",
    "Parallel/centrality/stress.jl",
    "Parallel/dominatingset/minimal_dom_set.jl",
    "Parallel/independentset/maximal_ind_set.jl",
    "Parallel/shortestpaths/bellman-ford.jl",
    "Parallel/shortestpaths/dijkstra.jl",
    "Parallel/shortestpaths/floyd-warshall.jl",
    "Parallel/shortestpaths/johnson.jl",
    "Parallel/traversals/bfs.jl",
    "Parallel/traversals/greedy_color.jl",
    "Parallel/vertexcover/random_vertex_cover.jl",
]
```

# Experimental algorithms

`Graphs.Experimental` is a module for graph algorithms that are newer or less stable. We can adopt algorithms before we finalize an interface for using them or if we feel that full support cannot be provided to the current implementation. You can expect new developments to land here before they make it into the main module. This enables the development to keep advancing without being risk-averse because of stability guarantees. You can think of this module as a 0.X semantic version space ; it is a place where you can play around with new algorithms, perspectives, and interfaces without fear of breaking critical code.

**A Note To Users**

Code in this module is unstable and subject to change. Do not use any code in this module in production environments without understanding the (large) risks involved. However, we welcome bug reports and issues via the normal channels..

## Index

```@index
Pages = ["experimental.md"]
```

## Full docs

```@autodocs
Modules = [Graphs.Experimental, Graphs.Experimental.Traversals, Graphs.Experimental.ShortestPaths, Graphs.Experimental.Parallel]
Pages = [
    "Experimental/Experimental.jl",
    "Experimental/isomorphism.jl",
    "Experimental/vf2.jl",
    "Experimental/Parallel/traversals/gdistances.jl",
    "Experimental/Parallel/Parallel.jl",
    "Experimental/ShortestPaths/astar.jl",
    "Experimental/ShortestPaths/bellman-ford.jl",
    "Experimental/ShortestPaths/bfs.jl",
    "Experimental/ShortestPaths/desopo-pape.jl",
    "Experimental/ShortestPaths/dijkstra.jl",
    "Experimental/ShortestPaths/floyd-warshall.jl",
    "Experimental/ShortestPaths/johnson.jl",
    "Experimental/ShortestPaths/ShortestPaths.jl",
    "Experimental/ShortestPaths/spfa.jl",
    "Experimental/Traversals/bfs.jl",
    "Experimental/Traversals/dfs.jl",
    "Experimental/Traversals/Traversals.jl",
]

```

# Utilities

Here are a few useful functions that didn't fit in the other categories.

## Index

```@index
Pages = ["utils.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = ["utils.jl"]

```

# Independent sets

_Graphs.jl_ contains functions related to [independent sets](https://en.wikipedia.org/wiki/Independent_set_(graph_theory)).

## Index

```@index
Pages = ["independentset.md"]
```

## Full docs

```@autodocs
Modules = [Graphs]
Pages = [
    "independentset/degree_ind_set.jl",
    "independentset/maximal_ind_set.jl",
]

```
